package Updater_Combo;
require CMONOS::SetupAssistant::Tools::JavaScriptUpdater;
@ISA = qw(JavaScriptUpdater);
use strict;
use utf8;
use Fcntl qw(:DEFAULT :flock);
eval 'use ' . $env::dbm_file . ';';
######################################################################
# Ver2.0.20230227 累積アップデータモジュール
# Updater_Combo.pm
# Copyright (C) 1999-2023 CMONOS Co. Ltd.
#
# support@cmonos.jp
# http://cmonos.jp/
#
######################################################################
# 実行
sub run ($) {
    my $this = shift;
    $this->get_setup_env;
    my $update_enabled = 0;
    $this->{'is_old_charset'} = 0;
    my $is_old_library = 0;
    my %log            = ();
    my $ver = 20230227;    ###########<<<<<<<<<<<<<最新版にあわす

    if (   !defined $main::ver
        || $main::ver eq ''
        || $this->is_nan($main::ver) )
    {
        $main::ver
            = ( %setting::general && $setting::general{'ver'} )
            ? $setting::general{'ver'}
            : 0;
    }

    #文字コード未変換
    $main::updating = $this->{'is_old_charset'} = 1
        if $this->read_file( $default::cgi_data_root . '/lib/env.pl' )
        !~ /use utf8;/;

    if ( !$main::updating ) {
        $this->jump_menu('tools');
        $this->print_page_header('tools');
        my $checked = 0;
        print '<h1>CMONOS.JP アップデータ</h1>';
        print $this->form_start(
            'key'      => 'tools',
            'name'     => 'input',
            'method'   => 'post',
            'required' => \@setting::form
        );
        print '<input type="hidden" name="updating" value="1" />';
        print
            '<fieldset><legend>アップデート (アップデート完了後このアップデータを削除してください)</legend>';
        print
            '<p>全てのサイトテンプレートおよび全てのサブディレクトリの各種設定をアップデートします。</p>';
        print
            '<fieldset><legend>アップデート前のバージョン</legend>';
        print '<ol class="checkbox">';
        print '<li><label><input type="radio" name="ver" value="20110905"'
            . ( ( $main::ver < 20111105 && !$checked++ )
            ? ' checked="checked"'
            : '' )
            . ' /> ver.1.5.20110905</label></li>';
        print '<li><label><input type="radio" name="ver" value="20111105"'
            . ( ( $main::ver < 20111111 && !$checked++ )
            ? ' checked="checked"'
            : '' )
            . ' /> ver.1.5.20111105</label></li>';
        print '<li><label><input type="radio" name="ver" value="20111111"'
            . ( ( $main::ver < 20111205 && !$checked++ )
            ? ' checked="checked"'
            : '' )
            . ' /> ver.1.5.20111111</label></li>';
        print '<li><label><input type="radio" name="ver" value="20111205"'
            . ( ( $main::ver < 20111222 && !$checked++ )
            ? ' checked="checked"'
            : '' )
            . ' /> ver.1.5.20111205</label></li>';
        print '<li><label><input type="radio" name="ver" value="20111222"'
            . ( ( $main::ver < 20111226 && !$checked++ )
            ? ' checked="checked"'
            : '' )
            . ' /> ver.2.0.20111220〜ver.2.0.20111222</label></li>';
        print '<li><label><input type="radio" name="ver" value="20111226"'
            . ( ( $main::ver < 20111229 && !$checked++ )
            ? ' checked="checked"'
            : '' )
            . ' /> ver.2.0.20111226</label></li>';
        print '<li><label><input type="radio" name="ver" value="20111229"'
            . ( ( $main::ver < 20130130 && !$checked++ )
            ? ' checked="checked"'
            : '' )
            . ' /> ver.2.0.20111229〜ver.2.0.20120818</label></li>';
        print '<li><label><input type="radio" name="ver" value="20130130"'
            . ( ( $main::ver < 20130422 && !$checked++ )
            ? ' checked="checked"'
            : '' )
            . ' /> ver.2.0.20130130〜ver.2.0.20130410</label></li>';
        print '<li><label><input type="radio" name="ver" value="20130422"'
            . ( ( $main::ver < 20130424 && !$checked++ )
            ? ' checked="checked"'
            : '' )
            . ' /> ver.2.0.20130422</label></li>';
        print '<li><label><input type="radio" name="ver" value="20130424"'
            . ( ( $main::ver < 20130912 && !$checked++ )
            ? ' checked="checked"'
            : '' )
            . ' /> ver.2.0.20130424〜ver.2.0.20130714</label></li>';
        print '<li><label><input type="radio" name="ver" value="20130912"'
            . ( ( $main::ver < 20130924 && !$checked++ )
            ? ' checked="checked"'
            : '' )
            . ' /> ver.2.0.20130912</label></li>';
        print '<li><label><input type="radio" name="ver" value="20130924"'
            . ( ( $main::ver < 20131225 && !$checked++ )
            ? ' checked="checked"'
            : '' )
            . ' /> ver.2.0.20130924〜ver.2.0.20131221</label></li>';
        print '<li><label><input type="radio" name="ver" value="20131225"'
            . ( ( $main::ver < 20140103 && !$checked++ )
            ? ' checked="checked"'
            : '' )
            . ' /> ver.2.0.20131225</label></li>';
        print '<li><label><input type="radio" name="ver" value="20140103"'
            . ( ( $main::ver < 20140502 && !$checked++ )
            ? ' checked="checked"'
            : '' )
            . ' /> ver.2.0.20140103〜ver.2.0.20140331</label></li>';
        print '<li><label><input type="radio" name="ver" value="20140509"'
            . ( ( $main::ver < 20140528 && !$checked++ )
            ? ' checked="checked"'
            : '' )
            . ' /> ver.2.0.20140502〜ver.2.0.20140509</label></li>';
        print '<li><label><input type="radio" name="ver" value="20140528"'
            . ( ( $main::ver < 20140702 && !$checked++ )
            ? ' checked="checked"'
            : '' )
            . ' /> ver.2.0.20140528〜ver.2.0.20140623</label></li>';
        print '<li><label><input type="radio" name="ver" value="20140702"'
            . ( ( $main::ver < 20140704 && !$checked++ )
            ? ' checked="checked"'
            : '' )
            . ' /> ver.2.0.20140702〜ver.2.0.20140703</label></li>';
        print '<li><label><input type="radio" name="ver" value="20140704"'
            . ( ( $main::ver < 20140711 && !$checked++ )
            ? ' checked="checked"'
            : '' )
            . ' /> ver.2.0.20140704</label></li>';
        print '<li><label><input type="radio" name="ver" value="20140711"'
            . ( ( $main::ver < 20140723 && !$checked++ )
            ? ' checked="checked"'
            : '' )
            . ' /> ver.2.0.20140711〜ver.2.0.20140719</label></li>';
        print '<li><label><input type="radio" name="ver" value="20140723"'
            . ( ( $main::ver < 20141125 && !$checked++ )
            ? ' checked="checked"'
            : '' )
            . ' /> ver.2.0.20140723〜ver.2.0.20141115</label></li>';
        print '<li><label><input type="radio" name="ver" value="20141125"'
            . ( ( $main::ver < 20150312 && !$checked++ )
            ? ' checked="checked"'
            : '' )
            . ' /> ver.2.0.20141125〜ver.2.0.20150308</label></li>';
        print '<li><label><input type="radio" name="ver" value="20150312"'
            . ( ( $main::ver < 20150412 && !$checked++ )
            ? ' checked="checked"'
            : '' )
            . ' /> ver.2.0.20150312〜ver.2.0.20151117</label></li>';
        print '<li><label><input type="radio" name="ver" value="20150412"'
            . ( ( $main::ver < 20160531 && !$checked++ )
            ? ' checked="checked"'
            : '' )
            . ' /> ver.2.0.20160531〜ver.2.0.20171004</label></li>';
        print '<li><label><input type="radio" name="ver" value="20160531"'
            . ( ( $main::ver < 20181031 && !$checked++ )
            ? ' checked="checked"'
            : '' )
            . ' /> ver.2.0.20171124〜ver.2.0.20180827</label></li>';
        print '<li><label><input type="radio" name="ver" value="20181031"'
            . ( ( $main::ver >= 20181031 && !$checked++ )
            ? ' checked="checked"'
            : '' )
            . ' /> ver.2.0.20181031〜</label></li>';
        print '</ol>';
        print '</fieldset>';
        print '</fieldset>';
        print
            '<fieldset class="submit"><input type="submit" value="各種設定を最新版にアップデートする" /></fieldset>';
        print '</form>';
        $this->print_page_footer('tools');
        return;
    }

    my $target_file = $default::preference_dir . '/updater_target.txt';
    my $key_file    = $default::preference_dir . '/updater_key.txt';
    my $ver_file    = $default::preference_dir . '/updater_ver.txt';
    my $number_file = $default::preference_dir . '/updater_number.txt';
    my $total_file  = $default::preference_dir . '/updater_total.txt';

    my $update_key = $this->rand_char(24);
    if ( !-f $key_file ) {
        $this->write_file( $key_file, $update_key . "\x09" . time, 1 );
        $this->write_file( $ver_file, $main::ver, 1 );
        $this->refresh_updater( 0, $update_key, '' );
        return;
    }

    $main::ver = $this->read_file( $ver_file, 1 ) || $main::ver;
    my ( $prev_key, $last_time )
        = split( /\x09/, $this->read_file( $key_file, 1 ) );
    if (   !$main::update_key
        || !$prev_key
        || ( $main::update_key ne $prev_key && time - $last_time < 100 ) )
    {
        $this->refresh_updater(
            0, $update_key,
            'しばらくお待ち下さい',
            ( 100 - time + $last_time )
        );
        return;
    }

    if ( !-f $target_file ) {
        my %target;
        $this->optimize_htaccess('../../') if $main::ver < 20140103;
        if ( $this->{'is_old_charset'} || $main::ver < 20150312 ) {
            $this->import_materials if $main::ver < 20130424;
            foreach my $dir ( '',
                $this->sub_directory_scan($default::shared_cgi_data_root) )
            {
                $this->find_target_from_htdocs( '../..' . $dir . '/',
                    \%target )
                    if $main::ver < 20120116 || $this->{'is_old_charset'};
                $this->find_target(
                    $default::cgi_data_root . $dir . '/preferences',
                    \%target, 1 )
                    if $main::ver < 20110905 || $this->{'is_old_charset'};
                $this->find_target( $default::cgi_data_root . $dir . '/data',
                    \%target, 1 )
                    if $main::ver < 20110905 || $this->{'is_old_charset'};
                $target{ $default::cgi_data_root . $dir . '/lib/env.pl' }
                    .= ' euc'
                    if $this->{'is_old_charset'};
                $target{ $default::cgi_data_root . $dir . '/lib/env.pl' }
                    .= ' samewindowregi'
                    if $main::ver < 20111111;
                $target{ $default::cgi_data_root . $dir . '/lib/env.pl' }
                    .= ' og'
                    if $main::ver < 20111220;
                $target{ $default::cgi_data_root . $dir . '/lib/env.pl' }
                    .= ' servername'
                    if $main::ver < 20121121;
                $target{ $default::cgi_data_root . $dir . '/lib/env.pl' }
                    .= ' cse'
                    if $main::ver < 20131225;
                $target{ $default::cgi_data_root . $dir . '/lib/env.pl' }
                    .= ' nogenerator'
                    if $main::ver < 20140610;
                $target{ $default::cgi_data_root . $dir . '/lib/env.pl' }
                    .= ' htmlheader'
                    if $main::ver < 20140702;
                $target{ $default::cgi_data_root . $dir . '/lib/env.pl' }
                    .= ' navfix'
                    if $main::ver < 20140704;

                if ( $main::ver < 20111111 ) {
                    $target{ $default::cgi_data_root . $dir
                            . '/preferences/common/deco' } .= ' dbm newicon';
                    $target{ $default::cgi_data_root . $dir
                            . '/preferences/common/deco.bak' } .= ' newicon';
                }
                $target{ '../..' . $dir } .= ' image_css_update'
                    if $main::ver < 20111111;
                $target{ '../..' . $dir } .= ' mobile_css_update'
                    if $main::ver < 20111226
                    && !-f ( ($dir)
                    ? '../..' . $dir . '/lib/css/mobile.css'
                    : '../../lib/css/mobile.css' );
                $target{ '../..' . $dir } .= ' estimate_css_update'
                    if $main::ver < 20120116
                    && !-f ( ($dir)
                    ? '../..' . $dir . '/lib/css/estimate.css'
                    : '../../lib/css/estimate.css' );
                $target{ '../..' . $dir } .= ' receipt_css_update'
                    if $main::ver < 20130424
                    && !-f ( ($dir)
                    ? '../..' . $dir . '/lib/css/receipt.css'
                    : '../../lib/css/receipt.css' );
                $target{ ($dir)
                    ? '../..' . $dir . '/cgi/navimaker/default.pl'
                    : '../navimaker/default.pl' } .= ' pswdinnavi'
                    if $main::ver < 20111226;
                $target{ '../..' . $dir . '/lib/css/default.css' }
                    .= ' sccartcss'
                    if $main::ver < 20130912;
                $target{ '../..' . $dir . '/lib/css/default.css' }
                    .= ' ariticle'
                    if $main::ver < 20150312;
                $this->find_order(
                    $default::cgi_data_root . $dir . '/data/order', \%target )
                    if $main::ver < 20111229
                    && -d $default::cgi_data_root . $dir . '/data/order';
                $this->find_css( '../..' . $dir . '/lib/css', \%target )
                    if $main::ver < 20120116;
                $this->write_file(
                    '../..' . $dir . '/lib/xfiles/blank-page.ssi',
                    '', 1 )
                    if -$main::ver < 20140103;
            }
            if ( $main::ver < 20130912
                && opendir( TEMP, $env::template_dir . '/site' ) )
            {
                my @templates
                    = grep( $_ !~ /\./
                        && -d $env::template_dir . '/site/' . $_,
                    readdir(TEMP) );
                closedir(TEMP);
                foreach my $dir (@templates) {
                    $this->find_target_from_htdocs(
                        $env::template_dir . '/site/' . $dir . '/htdocs/',
                        \%target )
                        if $main::ver < 20120116 || $this->{'is_old_charset'};
                    $this->find_target(
                        $env::template_dir . '/site/' . $dir . '/preferences',
                        \%target,
                        1
                        )
                        if $main::ver < 20110905 || $this->{'is_old_charset'};
                    $this->find_target(
                        $env::template_dir . '/site/' . $dir . '/data',
                        \%target, 1 )
                        if $main::ver < 20110905 || $this->{'is_old_charset'};
                    $target{  $env::template_dir
                            . '/site/'
                            . $dir
                            . '/env.bak' } .= ' euc'
                        if $this->{'is_old_charset'};
                    $target{  $env::template_dir
                            . '/site/'
                            . $dir
                            . '/env.bak' } .= ' samewindowregi'
                        if $main::ver < 20111111;
                    if ( $main::ver < 20111111 ) {
                        $target{  $env::template_dir
                                . '/site/'
                                . $dir
                                . '/preferences/common/deco' }
                            .= ' dbm newicon';
                        $target{  $env::template_dir
                                . '/site/'
                                . $dir
                                . '/preferences/common/deco.bak' }
                            .= ' newicon';
                    }
                    $target{  $env::template_dir
                            . '/site/'
                            . $dir
                            . '/htdocs' } .= ' image_css_update'
                        if $main::ver < 20111111;
                    $target{  $env::template_dir
                            . '/site/'
                            . $dir
                            . '/htdocs' } .= ' mobile_css_update'
                        if $main::ver < 20111226
                        && !-f $env::template_dir
                        . '/site/'
                        . $dir
                        . '/htdocs/lib/css/mobile.css';
                    $target{  $env::template_dir
                            . '/site/'
                            . $dir
                            . '/htdocs' } .= ' estimate_css_update'
                        if $main::ver < 20120116
                        && !-f $env::template_dir
                        . '/site/'
                        . $dir
                        . '/htdocs/lib/css/estimate.css';
                    $target{  $env::template_dir
                            . '/site/'
                            . $dir
                            . '/htdocs' } .= ' receipt_css_update'
                        if $main::ver < 20130424
                        && !-f $env::template_dir
                        . '/site/'
                        . $dir
                        . '/htdocs/lib/css/receipt.css';
                    $target{  $env::template_dir
                            . '/site/'
                            . $dir
                            . '/htdocs/cgi/navimaker/default.pl' }
                        .= ' pswdinnavi'
                        if $main::ver < 20111226;
                    $target{  $env::template_dir
                            . '/site/'
                            . $dir
                            . '/htdocs/lib/css/default.css' } .= ' sccartcss'
                        if $main::ver < 20130912;
                    $target{  $env::template_dir
                            . '/site/'
                            . $dir
                            . '/htdocs/lib/css/default.css' } .= ' ariticle'
                        if $main::ver < 20150312;
                    $this->find_order(
                        $env::template_dir . '/site/' . $dir . '/data/order',
                        \%target
                        )
                        if $main::ver < 20111229
                        && -d $env::template_dir
                        . '/site/'
                        . $dir
                        . '/data/order';
                    $this->find_css(
                        $env::template_dir
                            . '/site/'
                            . $dir
                            . '/htdocs/lib/css',
                        \%target
                    ) if $main::ver < 20120116;
                }
            }
            $this->find_target( $env::default_dir, \%target, 1 )
                if $main::ver < 20110905 || $this->{'is_old_charset'};
            $this->find_target( $env::template_dir . '/cgi', \%target, 1 )
                if $main::ver < 20110905 || $this->{'is_old_charset'};
        }
        local (*FH);
        my $count = 0;
        if ( open( FH, ">>$target_file" ) ) {
            binmode FH, ":utf8";
            flock( FH, LOCK_EX );
            truncate( FH, 0 );
            seek( FH, 0, 0 );
            foreach my $path ( sort keys %target ) {
                $count++;
                print FH $path, "\x09", $target{$path}, "\x0A";
            }
            if ( $this->{'is_old_charset'} ) {
                $count++;
                print FH "$env::zipcode/zipcode\x09euc,dbm\x0A";
            }
            print FH "" if !$count;
            close(FH);
        }
        $this->write_file( $key_file,    $update_key . "\x09" . time, 1 );
        $this->write_file( $number_file, '0',                         1 );
        $this->write_file( $total_file,  $count,                      1 );
        $this->refresh_updater( 0, $update_key, '' );
        return;
    }

    my $start = $this->read_file( $number_file, 1 );
    my $total = $this->read_file( $total_file,  1 );
    if ( $total && $start < $total ) {
        local (*FH);
        if ( open( FH, $target_file ) ) {
            binmode FH;
            flock( FH, LOCK_SH );
            my $count = 0;
            my $done  = 0;
            while ( my $data = <FH> ) {
                if ( $count >= $start ) {
                    chomp $data;
                    my ( $path, $mode ) = split( /\x09/, $data );
                    if ( $done >= 50
                        || ( $done && $path eq "$env::zipcode/zipcode" ) )
                    {
                        last;
                    }
                    if ( $mode =~ /[a-z]+_css_update/ ) {
                        $this->image_css_update($path)
                            if $mode =~ /image_css_update/;
                        $this->mobile_css_update($path)
                            if $mode =~ /mobile_css_update/;
                        $this->estimate_css_update($path)
                            if $mode =~ /estimate_css_update/;
                        $this->receipt_css_update($path)
                            if $mode =~ /receipt_css_update/;
                    }
                    elsif ( $mode =~ /dbm/ ) {
                        $this->db_update( $path, $mode );
                    }
                    elsif ( -f $path ) {
                        my $data = $this->read_file($path);
                        if ( $path =~ /\/site-navi-utf8\.ssi$/ ) {
                            my $old_path = $path;
                            $path
                                =~ s/\/site-navi-utf8\.ssi$/\/site-navi-euc.ssi/;
                            unlink $old_path;
                            $data = $this->jcode_convert( \$data, 'euc',
                                'utf8' );
                        }
                        elsif ( $path =~ /\/site-navi-sjis\.ssi$/ ) {
                            $data = $this->jcode_convert( \$data, 'sjis',
                                'utf8' );
                        }
                        else {
                            $data = $this->text_update( $data, $path, $mode );
                        }
                        $this->write_file( $path, \$data, 1 );
                    }
                    if ( !$done && $path eq "$env::zipcode/zipcode" ) {
                        $count++;
                        last;
                    }
                    $done++;
                }
                $count++;
            }
            close(FH);
            if ( $count > $start ) {
                $this->write_file( $key_file, $update_key . "\x09" . time,
                    1 );
                $this->write_file( $number_file, $count, 1 );
                $this->refresh_updater( int( $count / $total * 100 ) / 100,
                    $update_key, $count . '/' . $total );
                return;
            }
        }
    }

    #サイトテンプレートチェック
    if ( -f $env::template_dir
        . '/site/default/htdocs/lib/javascript/cmonos.js' )
    {
        my @stat = stat( $env::template_dir
                . '/site/default/htdocs/lib/javascript/cmonos.js' );
        use Time::Local;
        my $t = timelocal( 0, 0, 0, 1, 9, 2017 );
        if ( !$stat[9] || $stat[9] < $t ) {
            $is_old_library = 1;
            push(
                @{ $this->{'dialog'} },
                '「デフォルトのサイトテンプレート」が古いため JavaScript および CSS がアップデートされなかった可能性があります。最新の「デフォルトのサイトテンプレート」をアップロードしてください。'
            );
        }
    }
    else {
        $is_old_library = 1;
        push(
            @{ $this->{'dialog'} },
            'アップデートに必要な「デフォルトのサイトテンプレート」がみつからなかったため JavaScript および CSS がアップデートされなかった可能性があります。最新の「デフォルトのサイトテンプレート」をアップロードしてください。'
        );
    }

    my $log = '';
    if ( !$is_old_library ) {
        if ( $main::ver < 20220107 ) {    #CSSアップデート
            local @main::target = ( $main::ver < 20140711 )
              ? (
                'common.css',            'calendar-common.css',
                'tablemaker-common.css', 'tools.css',
                'images'
              )
              : ( $main::ver < 20160527 )
              ? ( 'common.css', 'calendar-common.css', 'tools.css' )
              : ( $main::ver < 20220107 ) ? ('calendar-common.css')
              :                             ( 'common.css', 'tools.css' );
            $log .= Common->new('s304')->update->update_log;
        }
        if ( $main::ver < 20181031 ) {    #JavaScriptアップデート
            $log .= Common->new('s303')->update->update_log;
        }
    }
    $log .= $this->updater_clipboard_sweeper();
    my %general;
    tie( %general, $env::dbm_file, $default::preference_dir . '/general',
        O_RDWR, $env::dbm_mode );
    if ( ref tied %general ) {
        $general{'ver'} = $this->encode_utf8($ver);
    }
    else {
        push(
            @{ $this->{'dialog'} },
            'バージョンの保存に失敗しました。'
        );
    }
    untie %general;
    if ( $main::k ne '....' ) {
        push(
            @{ $this->{'dialog'} },
            'アップデートが終了したのでこのアップデータは削除されました。'
        );
        $cgi::action->clean_up;
    }
    elsif ( $this->unlink_by_myself ) {
        push(
            @{ $this->{'dialog'} },
            'アップデートが終了したのでこのアップデータは削除されました。'
        );
        $main::k = '0000';
    }
    else {
        push(
            @{ $this->{'dialog'} },
            'アップデートが終了したのでこのアップデータ(Updater_Combo.pm)を削除してください。'
        );
    }

    $this->jump_menu( 'tools', 'backup' );
    $this->print_page_header('tools');
    print '<h1>CMONOS.JP アップデートログ</h1>';
    print '<fieldset><ol>';
    local (*FH);
    if ( open( FH, $target_file ) ) {
        binmode FH;
        flock( FH, LOCK_SH );
        while ( my $data = <FH> ) {
            my ( $path, $mode ) = split( /\x09/, $data );
            $path =~ s/^(?:\.\.\/)+/~\//;
            print '<li>' . $path . ' (' . $mode . ')</li>';
        }
        close(FH);
    }
    print $log;
    print '</ol></fieldset>';
    unlink $target_file;
    unlink $ver_file;
    unlink $key_file;
    unlink $number_file;
    unlink $total_file;
    $this->print_page_footer('tools');

    exit;
}

######################################################################
# 再読み込み
sub refresh_updater ($$$;$$) {
    my ( $this, $ratio, $key, $info, $waiting_time ) = @_;
    $ratio = 0 if !$ratio;
    binmode STDOUT, ":utf8";
    $info = ($info) ? '(' . $info . ')' : '';
    require CMONOS::CGI_Lib::ProgressBar;
    my $progress_bar = ProgressBar->new;
    my $submit = ($waiting_time) ? 'false' : 'true';
    $waiting_time = 100 if !$waiting_time;
    print 'Content-Type: text/html' . "\x0A";
    print $this->{'Set_Cookie'}
        if defined $this->{'Set_Cookie'} && $this->{'Set_Cookie'};
    print "\x0A";
    print <<HTML;
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="ja" lang="ja">
<head>
<meta http-equiv="Content-Type" content="text/html;charset=UTF-8" />
<meta http-equiv="Content-Style-Type" content="text/css" />
<title lang="ja">CMONOS.JP をアップデートしています...$info</title>
<style type="text/css">
<!--
body, table {
  font: 14px 'Lucida Grande','Hiragino Kaku Gothic Pro','ヒラギノ角ゴ Pro W3','HiraKakuProN-W3',Verdana,'メイリオ','Meiryo','ＭＳ Ｐゴシック','MS PGothic',Osaka,arial,helvetica,sans-serif;
}
HTML
    print $progress_bar->css( int( 480 * $ratio ), 1 );
    print <<HTML;
form#updater {
  display: none;
}
-->
</style>
<noscript>
<style type="text/css">
<!--
form#updater {
  display: block;
}
-->
</style>
</noscript>
<script type="text/javascript" language="JavaScript">
<!-- <![CDATA[
var progressbar = {
	update : function (ratio) {
		if (typeof document.body.style.maxHeight == "undefined") {
			document.getElementById('progress-bar-box-bg').style.height = (document.body.scrollTop + document.body.clientHeight) + 'px';
			document.getElementById('progress-bar-box-bg').style.width = (document.body.scrollLeft + document.body.clientWidth) + 'px';
		}
		if (ratio >= 1) {
			document.getElementById('progress-bar').style.width = '480px';
			document.getElementById('progress-bar-dialog').innerHTML += '[完了]';
			document.getElementById('progress-bar-box-bg').style.display = 'none';
			document.getElementById('progress-bar-box').style.display = 'none';
			if (this.bar_timer != null) clearInterval(this.bar_timer);
		} else {
			this.ratio = ratio;
			var self = this;
			if (this.bar_timer == null) this.bar_timer = setInterval(function () {
				self.ratio += 0.005;
				if (self.ratio > 0.99) self.ratio = 0.99;
				var w = Math.floor(self.ratio * 480);
				document.getElementById('progress-bar').style.width = ((w > 0) ? w : 1) + 'px';
			},500);
		}
	},
	refresh : function () {
		var submit_enabled = $submit;
		var update_form = document.getElementById('updater');
		if (update_form != null) {
			update_form.style.display = "none";
			if (submit_enabled) update_form.submit();
		}
		if (submit_enabled) progressbar.update($ratio);
		setTimeout(function () { update_form.style.display = "block" },${waiting_time}000);
	}
};
// ]]> -->
</script>
</head>
<body onload="progressbar.refresh()">
HTML
    print '<div id="progress-bar-dialog">';
    print 'CMONOS.JP をアップデートしています...' . $info;
    print
        '</div><div id="progress-bar-bg"><div id="progress-bar"></div></div>';
    print $this->form_start(
        'key'      => 'tools',
        'name'     => 'updater',
        'id'       => 'updater',
        'method'   => 'post',
        'required' => [ @setting::form, 'updating' ]
    );
    print '<input type="hidden" name="update_key" value="'
        . $this->escape($key)
        . '" /><input type="submit" value="アップデートを続行する" /></form></div>';
    print '</body></html>';
    exit;
}

######################################################################
# 素材を読み込む
sub import_materials ($) {
    my $this = shift;
    require CMONOS::CGI_Lib::HTTP_Client;
    if ( $main::ver < 20110603 ) {
        if (!-d $env::template_dir
            . '/site/default/htdocs/image/baobab/listreset/1'
            && $this->set_dir(
                $env::template_dir
                    . '/site/default/htdocs/image/baobab/listreset/1'
            )
            )
        {
            foreach my $file ( 'link.gif', 'hover.gif', 'active.gif' ) {
                HTTP_Client->new->request(
                    'GET' =>
                        'http://cmonos.jp/download/updater_materials/20110603/'
                        . $file,
                    {}, '', '', '',
                    $env::template_dir
                        . '/site/default/htdocs/image/baobab/listreset/1/'
                        . $file
                );
            }
            $this->directory_copy(
                $env::template_dir
                    . '/site/default/htdocs/image/baobab/listreset/1',
                $env::template_dir
                    . '/site/default/htdocs/image/tablemaker/tmreset/1'
            );
        }
    }
    if ( $main::ver < 20111011 ) {
        if ( !-f $env::image_lib . '/toggler/circle/c.png' ) {
            $this->set_dir( $env::image_lib . '/toggler' );
            foreach my $dir ( 'circle', 'circlemini', 'square', 'squaremini' )
            {
                $this->set_dir( $env::image_lib . '/toggler/' . $dir );
            }
            foreach my $file (
                'image.css',             'circle/a.png',
                'circle/b.png',          'circle/c.png',
                'circle/active.gif',     'circlemini/a.png',
                'circlemini/b.png',      'circlemini/c.png',
                'circlemini/active.gif', 'square/a.gif',
                'square/b.gif',          'square/c.gif',
                'square/active.gif',     'squaremini/a.gif',
                'squaremini/b.gif',      'squaremini/c.gif',
                'squaremini/active.gif'
                )
            {
                HTTP_Client->new->request(
                    'GET' =>
                        'http://cmonos.jp/download/updater_materials/20111011/'
                        . $file,
                    {}, '', '', '',
                    $env::image_lib . '/toggler/' . $file
                );
            }
            $this->directory_copy( $env::image_lib . '/toggler/circle',
                $env::template_dir . '/site/default/htdocs/image/toggler/1' );
        }
    }
    if ( $main::ver < 20111111 ) {
        if ( !-f $env::image_lib . '/new/new.gif' ) {
            $this->set_dir( $env::image_lib . '/new' );
            $this->set_dir(
                $env::template_dir . '/site/default/htdocs/image/new' );
            foreach my $file ( '1.gif', '2.gif' ) {
                HTTP_Client->new->request(
                    'GET' =>
                        'http://cmonos.jp/download/updater_materials/20111111/'
                        . $file,
                    {}, '', '', '',
                    $env::template_dir
                        . '/site/default/htdocs/image/new/'
                        . $file
                );
            }
            foreach my $file (
                'hot_b.gif', 'hot.gif', 'new_b.gif', 'new.gif',
                'up_b.gif',  'up.gif'
                )
            {
                HTTP_Client->new->request(
                    'GET' =>
                        'http://cmonos.jp/download/updater_materials/20111111/'
                        . $file,
                    {}, '', '', '',
                    $env::image_lib . '/new/' . $file
                );
            }
        }
    }
    if ( $main::ver < 20120116 ) {
        if ( !-d $env::image_lib . '/order/estimate' ) {
            $this->set_dir( $env::image_lib . '/order/estimate' );
            foreach my $dir (
                'blackcircle18bar', 'blackcircle24bar',
                'blackcircle30bar', 'blacksquare18bar',
                'blacksquare24bar', 'blacksquare30bar',
                'whitecircle18bar', 'whitecircle24bar',
                'whitecircle30bar', 'whitesquare18bar',
                'whitesquare24bar', 'whitesquare30bar'
                )
            {
                $this->set_dir( $env::image_lib . '/order/estimate/' . $dir );
                foreach my $file ( 'link.gif', 'hover.gif' ) {
                    HTTP_Client->new->request(
                        'GET' =>
                            'http://cmonos.jp/download/updater_materials/20120116/estimate/'
                            . $dir . '/'
                            . $file,
                        {}, '', '', '',
                        $env::image_lib
                            . '/order/estimate/'
                            . $dir . '/'
                            . $file
                    );
                }
            }
            HTTP_Client->new->request(
                'GET' =>
                    'http://cmonos.jp/download/updater_materials/20120116/estimate/image.css',
                {}, '', '', '',
                $env::image_lib . '/order/estimate/image.css'
            );
        }
    }
    if ( $main::ver < 20130424 ) {
        if ( -d $env::default_dir . '/order'
            && !-f $env::default_dir . '/order/page._receipt.default' )
        {
            HTTP_Client->new->request(
                'GET' =>
                    'http://cmonos.jp/download/updater_materials/20130424/page._receipt.default',
                {}, '', '', '',
                $env::default_dir . '/order/page._receipt.default'
            );
        }
    }
}

######################################################################
# ターゲットファイル取得
sub find_target_from_htdocs ($$$) {
    my ( $this, $dir, $target_ref ) = @_;
    my @target = ();
    if ( $dir eq '../../' ) {
        push( @target, $env::javascript )    if $this->{'is_old_charset'};
        push( @target, $env::css )           if $this->{'is_old_charset'};
        push( @target, $env::externalfiles ) if $this->{'is_old_charset'};
        push( @target, $env::image_dir . '/imagemenu' )
            if $this->{'is_old_charset'};
        push( @target, $env::image_lib . '/imagemenu' )
            if $this->{'is_old_charset'};
    }
    else {
        push( @target, $dir . '/lib/javascript' )
            if $this->{'is_old_charset'};
        push( @target, $dir . '/lib/css' )    if $this->{'is_old_charset'};
        push( @target, $dir . '/lib/xfiles' ) if $this->{'is_old_charset'};
        push( @target, $dir . '/image/imagemenu' )
            if $this->{'is_old_charset'};
    }
    local (*DIR);
    my $cgi_path = $dir . 'cgi';
    if ( $this->{'is_old_charset'} ) {
        $target_ref->{ $cgi_path . '/dummy.html' } .= ' euc'
            if -f $cgi_path . '/dummy.html';
        $target_ref->{ $cgi_path . '/dummy4href.html' } .= ' euc'
            if -f $cgi_path . '/dummy4href.html';
        $target_ref->{ $cgi_path . '/index.html' } .= ' euc'
            if -f $cgi_path . '/index.html';
    }
    if ( opendir( DIR, $cgi_path ) ) {
        my @cgi
            = grep( $_ =~ /^[0-9a-zA-Z_\-]+$/
                && -d $cgi_path . '/' . $_
                && -f $cgi_path . '/' . $_ . '/start.cgi',
            readdir(DIR) );
        closedir(DIR);
        foreach my $c (@cgi) {
            my ($lib);
            my $default_pl = $cgi_path . '/' . $c . '/default.pl';
            my $data = $this->read_file( $default_pl, 1 );
            if ($data) {
                if ( $data
                    =~ /^[\x20\x09]*\$lib[\x20\x09]*=[\x20\x09]*["']?([^"']+?)["']?;/m
                    )
                {
                    $lib = $1;
                }
                else {
                    next;
                }
                if ( $lib eq 'HomePageMaker' ) {
                    push( @target,
                        $this->un_base_change( eval($1), $default_pl, 'rel' )
                    ) if $data =~ /^[\x20\x09]*\$home[\x20\x09]*=(.*?);/m;
                }
                elsif ( $lib eq 'HomePageMakerLite' ) {
                    $target_ref->{ $this->un_base_change( eval($1),
                            $default_pl, 'rel' ) } .= ' euc'
                        if $this->{'is_old_charset'}
                        && $data =~ /^[\x20\x09]*\$home[\x20\x09]*=(.*?);/m;
                }
                if ( $data =~ /^[\x20\x09]*\$file[\x20\x09]*=(.*?);/m ) {
                    my $file = $this->un_base_change( eval($1), $default_pl,
                        'rel' );
                    push( @target, $file ) if $file !~ /^$cgi_path\/$c/;
                }
            }
            if ( $this->{'is_old_charset'} ) {
                push( @target, $cgi_path . '/' . $c );
            }
        }
    }
    foreach my $d (@target) {
        $this->find_target( $d, $target_ref );
    }
}

sub find_target ($$$;$) {
    my ( $this, $dir, $target_ref, $has_dbm ) = @_;
    local (*DIR);
    my @directories = ();
    if ( opendir( DIR, $dir ) ) {
        while ( my $file = readdir(DIR) ) {
            next if $file =~ /^\.\.?$/;
            if ( -d $dir . '/' . $file ) {
                push( @directories, $dir . '/' . $file );
            }
            elsif ( -f $dir . '/' . $file ) {
                if ($file =~ /\.(?:s?html?|ssi|js|css|cgi|pl|htcomment)$/i
                    || (   $file =~ /\.dat$/i
                        && $file
                        !~ /[0-9a-zA-Z_]+\.[0-9a-zA-Z_]+\.[0-9a-zA-Z_]+\.dat$/
                    )
                    || $file eq 'name.txt'
                    || ( $has_dbm && $file =~ /\.(?:bak|default|csv|tsv)$/i )
                    || ( $has_dbm && $dir =~ /\/data\/session_store$/i )
                    )
                {
                    if ( $this->{'is_old_charset'} ) {
                        $target_ref->{ $dir . '/' . $file } .= ' euc';
                        $target_ref->{ $dir . '/' . $file }
                            .= ' changecharset'
                            if $file =~ /^site-navi-(?:sjis|utf8)\.ssi$/;
                    }
                    if (   $main::ver < 20120116
                        && $dir =~ m!/archives\.pending/! )
                    {
                        $target_ref->{ $dir . '/' . $file } .= ' typo201201';
                    }
                }
                elsif ( $has_dbm && $file =~ /^(.*?)(?:\.[a-zA-Z0-9_]+)?$/is )
                {
                    $target_ref->{ $dir . '/' . $1 } .= ' euc dbm'
                        if $this->{'is_old_charset'};
                }
            }
        }
        closedir(DIR);
    }
    foreach my $d (@directories) {
        $this->find_target( $d, $target_ref, $has_dbm );
    }
}

sub find_order ($$$) {
    my ( $this, $dir, $target_ref ) = @_;
    local (*DIR);
    if ( opendir( DIR, $dir ) ) {
        while ( my $file = readdir(DIR) ) {
            next if $file =~ /^\.\.?$/;
            if ( -d $dir . '/' . $file ) {
                $target_ref->{ $dir . '/' . $file . '/order.bak' }
                    .= ' eucorder';
                $target_ref->{ $dir . '/' . $file . '/order' }
                    .= ' eucorder dbm';
            }
        }
        closedir(DIR);
    }
}

sub find_css ($$$) {
    my ( $this, $dir, $target_ref ) = @_;
    local (*DIR);
    if ( opendir( DIR, $dir ) ) {
        while ( my $file = readdir(DIR) ) {
            if ( $file =~ /^\w+\.css$/i
                && !
                grep( $_ eq $file, 'common.css', 'tools.css', 'image.css' )
                && -f $dir . '/' . $file )
            {
                $target_ref->{ $dir . '/' . $file } .= ' scestimatecss'
                    if $main::ver < 20120116;
            }
        }
        closedir(DIR);
    }
}

######################################################################
# 画像ライブラリCSSをアップデート
sub image_css_update ($$) {
    my ( $this, $dir ) = @_;
    if ( $main::ver < 20110603
        && -f $env::template_dir
        . '/site/default/htdocs/image/tablemaker/tmreset/1/link.gif' )
    {
        $this->directory_copy(
            $env::template_dir
                . '/site/default/htdocs/image/baobab/listreset/1',
            $dir . '/image/baobab/listreset/1'
            )
            if -d $dir . '/image/baobab'
            && !-d $dir . '/image/baobab/listreset/1';
        $this->directory_copy(
            $env::template_dir
                . '/site/default/htdocs/image/baobab/listreset/1',
            $dir . '/image/tablemaker/tmreset/1'
            )
            if -d $dir . '/image/tablemaker'
            && !-d $dir . '/image/tablemaker/tmreset/1';
        if ( -d $dir . '/cgi/imageLib' ) {
            $this->directory_copy(
                $env::template_dir
                    . '/site/default/htdocs/image/baobab/listreset/1',
                $dir . '/cgi/imageLib/baobab/listreset/1'
            ) if !-d $dir . '/cgi/imageLib/baobab/listreset/1';
            $this->directory_copy(
                $env::template_dir
                    . '/site/default/htdocs/image/baobab/listreset/1',
                $dir . '/cgi/imageLib/tablemaker/tmreset/1'
            ) if !-d $dir . '/cgi/imageLib/tablemaker/tmreset/1';
        }
    }
    if ( $main::ver < 20111011
        && -f $env::template_dir
        . '/site/default/htdocs/image/toggler/1/c.png' )
    {
        $this->directory_copy(
            $env::template_dir . '/site/default/htdocs/image/toggler/1',
            $dir . '/image/toggler/1' )
            if !-f $dir . '/image/toggler/1/c.png';
    }
    if ( $main::ver < 20111111
        && -f $env::template_dir . '/site/default/htdocs/image/new/1.gif' )
    {
        $this->directory_copy(
            $env::template_dir . '/site/default/htdocs/image/new',
            $dir . '/image/new' )
            if !-d $dir . '/image/new';
    }
    Common->new('s302')->update( 'imagedir', $dir );
    Common->new('s302')->update( 'imagelib', $dir )
        if -d $dir . '/cgi/imageLib';
}

######################################################################
sub mobile_css_update ($$) {
    my ( $this, $dir ) = @_;
    if (   $main::ver < 20111226
        && -f $env::template_dir . '/site/default/htdocs/lib/css/mobile.css'
        && -d $dir . '/lib/css'
        && -d $dir . '/lib/javascript' )
    {
        $this->file_copy(
            $env::template_dir . '/site/default/htdocs/lib/css/mobile.css',
            $dir . '/lib/css/mobile.css' );
    }
}

######################################################################
sub estimate_css_update ($$) {
    my ( $this, $dir ) = @_;
    if (   $main::ver < 20120116
        && -f $env::template_dir . '/site/default/htdocs/lib/css/mobile.css'
        && -d $dir . '/lib/css'
        && -d $dir . '/lib/javascript'
        && !-f $dir . '/lib/css/estimate.css' )
    {
        $this->file_copy(
            $env::template_dir . '/site/default/htdocs/lib/css/estimate.css',
            $dir . '/lib/css/estimate.css'
        );
    }
}

######################################################################
sub receipt_css_update ($$) {
    my ( $this, $dir ) = @_;
    if (   $main::ver < 20130424
        && -f $env::template_dir . '/site/default/htdocs/lib/css/mobile.css'
        && -d $dir . '/lib/css'
        && -d $dir . '/lib/javascript'
        && !-f $dir . '/lib/css/receipt.css' )
    {
        $this->file_copy(
            $env::template_dir . '/site/default/htdocs/lib/css/receipt.css',
            $dir . '/lib/css/receipt.css' );
    }
}

######################################################################
# テキストアップデート
sub text_update ($$$$) {
    my ( $this, $data, $path, $mode ) = @_;
    if ( $mode =~ /eucorder/ && $this->use_session ) {
        my $temp = '';
        while ( $data =~ /^(.*?)\x09(.*)$/mg ) {
            next if !$1 || !$2;
            my ( $k, $v ) = ( $1, $2 );
            chomp $v;
            $v =~ s/&#09;/\x09/gs;
            $v =~ s/\x0B/\x0A/gs;
            $v = $this->order_update($v);
            $v =~ s/\x09/&#09;/gs;
            $v =~ s/(\x0D\x0A|\x0D|\x0A)/\x0B/gs;
            $temp .= $k . "\x09" . $v . "\x0A";
        }
        return $temp;
    }
    if ( $mode =~ /euc/ ) {
        if ( $path =~ /\.(?:cgi|pl|pm)$/i ) {
            $data
                =~ s/(use strict;|package env;|package default;)/$1\x0Ause utf8;/s
                if $data !~ /use utf8;/;
            $data =~ s/\->decode\(1,\s*'euc'/->decode\(1,'utf8'/sg;
        }
        else {
            $data = $this->euc_text_to_utf8($data);
        }
    }
    if ( $mode =~ /newicon/ && $data !~ /^new_1_width	/m ) {
        $data
            .= "new_1_width	36\x0Anew_1_height	13\x0Anew_1_name	1.gif\x0Anew_1_alt	NEW!\x0Anew_2_width	36\x0Anew_2_height	13\x0Anew_2_name	2.gif\x0Anew_2_alt	UP!\x0A";
    }
    if ( $path =~ /\/env\.pl$/i ) {
        if ( $data !~ /\$register_in_same_window / ) {
            $data
                =~ s!(\$register_db =.*?;)!$1\x0A\x0A# 会員登録CGIを同じウィンドウで開く\x0A\$register_in_same_window = 0;!;
        }
        if ( $data !~ /\$locale / ) {
            $data
                =~ s!(\$ENV{'TZ'} =.*?;)!$1\x0A\x0A# locale\x0A\$locale = 'ja_JP';!;
        }
        if ( $data !~ /\$og_type / ) {
            $data
                =~ s!(\$description =.*?';)!$1\x0A\x0A# og:type\x0A\$og_type = 'website';!;
        }
        if ( $data !~ /\$html_header / ) {
            $data
                =~ s!(\$doctype =.*?';)!$1\x0A\x0A# 共通 HTML ヘッダ\x0A\$html_header = '';!;
        }
        if ( $data !~ /\$inline_navi / ) {
            $data
                =~ s!(\$html_header =.*?[^\\]';)!$1\x0A\x0A\x0A# 埋め込み型ナビゲーション（フレーム型=0/埋め込み型=1）\x0A\$inline_navi = 1;!s;
        }
        if ( $data !~ /\$window_title_format / ) {
            $data
                =~ s!(\$inline_navi =.*?;)!$1\x0A\x0A\x0A# ウィンドウタイトルフォーマット\x0A# [サイトタイトルの区切り文字],[中間層の区切り文字],[上層→下層=0/下層→上層=1]\x0A\$window_title_format = ':,:';!;
        }
        if ( $data !~ /\$fb_appid / ) {
            $data
                =~ s!(\$amazon_associates_id =.*?;)!$1\x0A\x0A\x0A# Facebook Platform アプリケーションID\x0A\$fb_appid = '';!;
        }
        if ( $data !~ /\$server_name / ) {
            $data
                =~ s!(\$file_server =.*?;)!$1\x0A\x0A# サーバネーム（空欄で自動取得）\x0A\$server_name = '';!;
            $data =~ s/\$ssl = 0/\$ssl = ''/;
        }
        if ( $data !~ /\$no_generator / ) {
            $data
                =~ s!(\$dummy_window =.*?;)!$1\x0A\x0A# ジェネレータをメタ情報に含めない\x0A\$no_generator = 0;!;
        }
        if ( $data
            =~ /^[\x20\x09]*\$multi_domain[\x20\x09]*=[\x09\x0A\x0C\x0D\x20]*["']([^'"]+\.[a-zA-Z0-9]+)["'];/m
            )
        {
            my $server_name = $1;
            $data
                =~ s!^[\x20\x09]*\$multi_domain[\x20\x09]*=[^\x0A\x0D]*;!\$multi_domain =1;!gm;
            $data
                =~ s!^[\x20\x09]*\$server_name[\x20\x09]*=[^\x0A\x0D]*;!\$server_name = '$server_name';!gm;
        }
        if ( $data !~ /\$google_custom_search_cx / ) {
            $data
                =~ s!(\$pending_db =.*?;)!$1\x0A\x0A\x0A\x0A# Google API キー\x0A\$google_api_key = '';\x0A\x0A# Google カスタム検索 cx\x0A\$google_custom_search_cx = '';!;
        }
    }
    if ( $mode =~ /pswdinnavi/ && $path =~ /\/navimaker\/default\.pl$/i ) {
        $data =~ s![\x09\x20]*'Register',\x0A!!s;
    }
    if (   $mode =~ /scestimatecss/
        && $data =~ /div#sc-proceed-to-order/
        && $data !~ /div#sc-print-estimate-sheet/ )
    {
        my $new
            = "div#sc-proceed-to-order div#sc-print-estimate-sheet {\x0A  margin-top: 10px;\x0A}\x0A";
        $data .= $new
            unless $data
            =~ s/(div#sc-update-sub-total input, div#sc-proceed-to-checkout input, div#sc-proceed-to-order input \{.*?\}\s*)/$1$new/s;
    }
    if ( $mode =~ /sccartcss/ && $path =~ /\/default\.css$/ ) {
        my $cartcss
            = '/\\* カートを見る iframe \\*/\\s*iframe#shoppingcart \\{\\s*opacity: 0.9;\\s*-moz-opacity: 0.9;\\s*-webkit-opacity: 0.9;\\s*-o-opacity: 0.9;\\s*-ms-filter: "alpha\\(opacity=90\\)";\\s*filter: alpha\\(opacity=90\\);\\s*border: 1px solid #000;\\s*background: #fff none;\\s*\\}\\s*';
        $data =~ s/$cartcss//s;
    }
    if ( $mode =~ /ariticle/ && $path =~ /\/default\.css$/ ) {
        $data =~ s/ariticle-selector/article-selector/sg;
    }
    if ( $mode =~ /typo201201/ ) {
        $data
            =~ s/<div id="cms-rollback-infomation">/<div id="cms-rollback-information">/sg;
    }
    return $data;
}

sub order_update ($$) {
    my ( $this, $data ) = @_;
    if ( $this->use_session ) {
        my $temp = '';
        my $n;
        while ( $data =~ /^(.*)$/mg ) {
            next if !$1;
            my $item = $1;
            chomp $item;
            if ( !$n++ ) {
                $temp .= $item . "\x0A";
            }
            else {
                my %item_data = ();
                $cgi::Session->read_data( \%item_data, $item );
                foreach my $k ( keys %item_data ) {
                    $item_data{$k}
                        = $this->jcode_convert( \$item_data{$k}, 'utf8' );
                }
                $temp
                    .= $cgi::Session->data( '', '', \%item_data, 1 ) . "\x0A";
            }
        }
        return $temp;
    }
    return $data;
}

sub euc_text_to_utf8 ($$) {
    my ( $this, $data ) = @_;
    $data
        =~ s!<meta\s*http-equiv="Content-Type"\s*content="text/html;\s*charset=EUC-JP"\s*/?>!<meta http-equiv="Content-Type" content="text/html;charset=UTF-8" />!sig;
    $data =~ s!<meta\s*charset="EUC-JP"\s*/?>!<meta charset="UTF-8" />!sig;
    $data =~ s! charset="EUC-JP"! charset="UTF-8"!sig;
    $data =~ s/\@charset "EUC-JP";/\@charset "UTF-8";/sig;
    $data
        =~ s/(<form(?=[\x09\x0A\x0D\x20])[^>]*?[\x09\x0A\x0D\x20]action="(?!http:\/\/)[^"]+"[^>]*?>)(?![\x09\x0A\x0D\x20]*<input type="hidden" name="_" value="＿"[^>]*?>)/$1<input type="hidden" name="_" value="＿" \/>/sig;
    $data =~ s/<span class="gyo"([^>]*?)>/<span class="tktr-gyo"$1>/sig;
    $data =~ s/\.gyo[\x20\x09]*\{/td.gyo span.tktr-gyo \{/mig;
    return $data;
}

######################################################################
# DBアップデート
sub db_update ($$$) {
    my ( $this, $path, $mode ) = @_;
    my %db_hash;
    tie( %db_hash, $env::dbm_file, $path, O_RDWR, $env::dbm_mode );
    if ( ref tied %db_hash ) {
        if ( $mode =~ /euc/ ) {
            if ( $path =~ m!/url_to_title$! ) {
                %db_hash = ();
            }
            else {
                foreach my $k ( keys %db_hash ) {
                    my $v = $db_hash{$k};
                    if ( $mode =~ /eucorder/ ) {
                        $v = $this->order_update($v);
                        utf8::encode($k) if utf8::is_utf8($k);
                        utf8::encode($v) if utf8::is_utf8($v);
                    }
                    else {
                        my $escape_null = ( $v =~ s/\x00/&#0;/sg ) ? 1 : 0;
                        $v = $this->jcode_convert( \$v, 'utf8' );
                        $v = $this->euc_text_to_utf8($v);
                        utf8::encode($k)      if utf8::is_utf8($k);
                        utf8::encode($v)      if utf8::is_utf8($v);
                        $v =~ s/\&#0;/\x00/sg if $escape_null;
                    }
                    $db_hash{$k} = $v;
                }
            }
        }
        if ( $mode =~ /newicon/ && !$db_hash{'new_1_width'} ) {
            $db_hash{'new_1_width'}  = '36';
            $db_hash{'new_1_height'} = '13';
            $db_hash{'new_1_name'}   = '1.gif';
            $db_hash{'new_1_alt'}    = 'NEW!';
            $db_hash{'new_2_width'}  = '36';
            $db_hash{'new_2_height'} = '13';
            $db_hash{'new_2_name'}   = '2.gif';
            $db_hash{'new_2_alt'}    = 'UP!';
        }
    }
    untie %db_hash;
}

######################################################################
# クリップボードを掃除
sub updater_clipboard_sweeper ($) {
    my $this = shift;
    $this->clipboard_sweeper;
    return '<li>クリップボードを掃除</li>';
}

######################################################################
sub unlink_by_myself ($) {
    my $this = shift;
    foreach my $lib (@INC) {
        if ( $lib && -f "$lib/CMONOS/SetUpAssistant/Tools/Updater_Combo.pm" )
        {
            return 1
                if unlink "$lib/CMONOS/SetUpAssistant/Tools/Updater_Combo.pm";
            return 0;
        }
    }
    return 0;
}

######################################################################
# クラス登録
#sub import {
BEGIN {
    if (   $env::ownerpower
        && ( !defined $env::home_dir_id || $env::home_dir_id eq '' )
        && !$env::multi_domain )
    {

        #クラス登録
        Common::class_register( '....', 'Updater_Combo' );

        #メニュー登録
        if ( !ref $cgi::action ) {
            $setting::jump_menu{'....'}
                = 'ver2.0.20190916 累積アップデータ';
            $main::k = '....';
        }
    }
}

1;
