package RankingPage;
require CMONOS::CGI_Lib::Tools::Page;
@ISA = qw(Page);
use strict;
use utf8;
######################################################################
# アクセスランキングページ設定モジュール
# RankingPage.pm ver1.0
# Copyright (C) 1999-2018 CMONOS Co. Ltd.
#
# support@cmonos.jp
# http://cmonos.jp/
#
######################################################################
# 設定項目取得
sub get_sub_setting_items ($) {
    no warnings qw(once);
    my $this = shift;

    #数字チェック
    $check::num{'rankingTitleFrameWidth'}
        = 'アクセスランキングタイトル幅';

    #棒グラフ情報
    $cgi::BarGraph->get_bargraph_setting_items();
    return;
}

######################################################################
# 設定環境
sub set_sub_preferences ($) {
    no warnings qw(once);
    my $this = shift;
    $preference::id = 'ranking';    # データキー
    $preference::name = 'アクセスランキングページレイアウト'
        ;                           # 設定パネル名
    $preference::title
        = 'アクセスランキングページのレイアウトについて設定します。';
    unless ( ref $cgi::BarGraph ) {
        require CMONOS::CGI_Lib::BarGraph;
        $cgi::BarGraph = BarGraph->new;
    }
}

######################################################################
# 設定パネル
sub print_sub_preference_panel ($) {
    my $this = shift;

    print '<fieldset><legend>テーブル設定</legend>';
    print '<table class="field-table"><tbody>';
    print '<tr>';
    print
        '<td class="field-name"><label for="data:ranking_infoTable">ランキング条件表テーブルタイプ</label></td>';
    print '<td class="field">';
    print $this->table_menu( 'data:ranking_infoTable',
        $main::data{'ranking_infoTable'} );
    print '</td>';
    print '</tr>';
    print '<tr>';
    print
        '<td class="field-name"><label for="data:ranking_table">ランキング結果表テーブルタイプ</label></td>';
    print '<td class="field">';
    print $this->table_menu( 'data:ranking_table',
        $main::data{'ranking_table'} );
    print '</td>';
    print '</tr>';
    print '</tbody></table>';
    print '</fieldset>';

    #棒グラフ設定
    $cgi::BarGraph->print_bargraph_setting_form('ranking');

    print '<fieldset><legend>ボタン設定</legend>';

    print '<fieldset><legend>「前」ボタン</legend>';
    print $cgi::Deco->button_menu( 'data:ranking_prevButton', 'prev', 120,
        $main::data{'ranking_prevButton'} );
    print '</fieldset>';

    print '<fieldset><legend>「次」ボタン</legend>';
    print $cgi::Deco->button_menu( 'data:ranking_nextButton', 'next', 120,
        $main::data{'ranking_nextButton'} );
    print '</fieldset>';

    print '</fieldset>';
    $this->print_sc_button_setting;
}

######################################################################
#sub import {
BEGIN {
    no warnings qw(once);

    #クラス登録
    Common::class_register( 'c000', 'RankingPage' );

    #ツール登録
    $setting::jump_menu{'c000'}
        = 'アクセスランキングページレイアウト';

    #画像
    $setting::deco_dir{'next'}  = '「次」ボタン';
    $setting::deco_type{'next'} = 'button';
    $setting::deco_dir{'prev'}  = '「前」ボタン';
    $setting::deco_type{'prev'} = 'button';

    $setting::deco_dir{'bargraph'}    = '棒グラフ画像';
    $setting::deco_type{'bargraph'}   = 'image';
    $setting::deco_dir{'bargraphbg'}  = '棒グラフ枠画像';
    $setting::deco_type{'bargraphbg'} = 'image';

    $setting::deco_dir{'number'}  = '数字画像';
    $setting::deco_type{'number'} = 'number';

    if ( defined $env::checkout && $env::checkout ) {
        $setting::deco_dir{'check'}  = 'カートを見る ボタン';
        $setting::deco_type{'check'} = 'button';
    }
}

1;
