package Uncountable;
require CMONOS::CGI_Lib::SetUp;
@ISA = qw(SetUp);
use strict;
use utf8;
######################################################################
# カウント対象除外設定モジュール
# Uncountable.pm ver1.0
# Copyright (C) 1999-2018 CMONOS Co. Ltd.
#
# support@cmonos.jp
# http://cmonos.jp/
#
######################################################################
# 実行
sub run ($) {
    my $this = shift;
    my ($nocheck);
    $nocheck = 1
        if $this->read_cookie_direct( 'NOCHECK' . $default::id ) eq
        $default::nocheck_pswd;
    push( @default::target, $this->home_location ) if !@default::target;

    # 指定/解除
    if ( defined $main::cookie && $main::cookie ) {
        my ( $expires, $cookie );
        if ( $main::cookie eq 'set' ) {
            $expires = ' expires=Monday, 01-Jan-2035 00:00:00 GMT;';
            $cookie
                = 'Set-Cookie: NOCHECK'
                . $default::id . '='
                . $default::nocheck_pswd . ';';
            push(
                @{ $this->{'dialog'} },
                'アクセス非カウント対象指定を行いました。'
            );
            $nocheck = 1;
        }
        else {
            $expires = ' expires=Thursday, 01-Jan-1970 00:00:00 GMT;';
            $cookie  = 'Set-Cookie: NOCHECK' . $default::id . '=0;';
            push(
                @{ $this->{'dialog'} },
                'アクセス非カウント対象指定を解除しました。'
            );
            $nocheck = 0;
        }
        foreach (@default::target) {
            my $domain = $_;
            my $path   = '/';
            $domain =~ s/^http[s]?:\/\///;
            ( $domain, $path ) = ( $1, $2 ) if $domain =~ /^([^\/]+)(\/.*)$/;
            $domain = ' domain=' . $domain . ';'
                if defined $domain && $domain ne '';
            $path = ' path=' . $path . ';';
            $this->{'Set_Cookie'}
                .= $cookie . $expires . $path . $domain . "\x0A";
        }
    }

    #ページヘッダ
    $this->jump_menu('tools');
    $this->print_page_header('tools');

    print
        '<h1 title="Cookie により、管理人のアクセスをカウントしないよう設定します。">管理人クッキー設定</h1>';

    print $this->form_start(
        'key'      => 'tools',
        'name'     => 'input',
        'method'   => 'post',
        'required' => \@setting::form
    );

    print '<fieldset class="submit">';
    if ( defined $nocheck && $nocheck ) {
        print
            '<input type="submit" name="cookie=clear" value="このブラウザのアクセス非カウント対象指定を解除する" />';
    }
    else {
        print
            '<input type="submit" name="cookie=set" value="このブラウザからのアクセスを非カウント対象に指定する" />';
    }
    print '</fieldset>';

    print '</form>';

    #ページフッタ
    $this->print_page_footer('tools');
}

######################################################################
# クラス登録
#sub import {
BEGIN {
    no warnings qw(once);

    #クラス登録
    Common::class_register( '00c0', 'Uncountable' );

    #メニュー登録
    $setting::jump_menu{'00c0'} = '管理人クッキー設定';

}

1;
