package StatPage;
require CMONOS::CGI_Lib::Tools::Page;
@ISA = qw(Page);
use strict;
use utf8;
######################################################################
# アクセス解析ページ設定モジュール
# StatPage.pm ver1.0
# Copyright (C) 1999-2018 CMONOS Co. Ltd.
#
# support@cmonos.jp
# http://cmonos.jp/
#
######################################################################
# 設定項目取得
sub get_sub_setting_items ($) {
    my $this = shift;

    #数字チェック
    $check::num{'statTitleFrameWidth'} = 'アクセス解析タイトル幅';
    $check::num{'datelimit'}           = '相対日時';

    #棒グラフ情報
    $cgi::BarGraph->get_bargraph_setting_items();
    $cgi::BarGraph->get_bargraph_setting_items( '2', 'サブ', 1 );

    return;
}

######################################################################
# 設定環境
sub set_sub_preferences ($) {
    my $this = shift;
    $preference::id = 'stat';    # データキー
    $preference::name
        = 'アクセス解析ページレイアウト';   # 設定パネル名
    $preference::title
        = 'アクセス解析ページのレイアウトについて設定します。';

    unless ( ref $cgi::BarGraph ) {
        require CMONOS::CGI_Lib::BarGraph;
        $cgi::BarGraph = BarGraph->new;
    }
}

######################################################################
# 設定パネル
sub print_sub_preference_panel ($) {
    my $this = shift;
    print '<fieldset><legend>表示設定</legend>';
    print '<table class="field-table"><tbody>';
    print '<tr>';
    print
        '<td class="field-name"><label for="data:stat_infoTable">解析条件表テーブルタイプ</label></td>';
    print '<td class="field">';
    print $this->table_menu( 'data:stat_infoTable',
        $main::data{'stat_infoTable'} );
    print '</td>';
    print '</tr>';
    print '<tr class="tbody-end">';
    print
        '<td class="field-name"><label for="data:stat_table">解析結果表テーブルタイプ</label></td>';
    print '<td class="field">';
    print $this->table_menu( 'data:stat_table', $main::data{'stat_table'} );
    print '</td>';
    print '</tr>';
    print '</tbody><tbody>';
    print '<tr>';
    print
        '<td class="field-name"><label for="data:stat_datetype">日時の書式</label></td>';
    print '<td class="field">';
    $this->print_date_type_menu( 'data:stat_', $main::data{'stat_datetype'} );
    print '</td>';
    print '</tr>';
    print '<tr>';
    print
        '<td class="field-name"><span class="datatitle">相対日時</span></td>';
    print '<td class="field">';
    print
        '<label><input type="number" size="3" name="data:stat_datelimit" id="data:stat_datelimit" value="'
        . $this->escape( $main::data{'stat_datelimit'} )
        . '" title="きのう、きょう、何日前、といった相対日時で表現する範囲を指定します。" /> 日以内なら相対日時で表示する</label>';
    print '</td>';
    print '</tr>';
    print '</tbody></table>';
    print '</fieldset>';

    #棒グラフ設定
    $cgi::BarGraph->print_bargraph_setting_form('stat');

    #サブ棒グラフ設定
    $cgi::BarGraph->print_bargraph_setting_form( 'stat', '2', 'サブ', 1 );

    print '<fieldset><legend>ボタン設定</legend>';

    print '<fieldset><legend>インデックスボタン</legend>';
    print $cgi::Deco->button_menu( 'data:stat_indexButton', 'index', 120,
        $main::data{'stat_indexButton'} );
    print '</fieldset>';

    print '<fieldset><legend>「前」ボタン</legend>';
    print $cgi::Deco->button_menu( 'data:stat_prevButton', 'prev', 120,
        $main::data{'stat_prevButton'} );
    print '</fieldset>';

    print '<fieldset><legend>「次」ボタン</legend>';
    print $cgi::Deco->button_menu( 'data:stat_nextButton', 'next', 120,
        $main::data{'stat_nextButton'} );
    print '</fieldset>';

    print '</fieldset>';

}

######################################################################
#sub import {
BEGIN {
    no warnings qw(once);

    #クラス登録
    Common::class_register( 'a000', 'StatPage' );

    #ツール登録
    $setting::jump_menu{'a000'}
        = 'アクセス解析ページレイアウト';

    #画像
    $setting::deco_dir{'index'}  = 'インデックス ボタン';
    $setting::deco_type{'index'} = 'button';
    $setting::deco_dir{'next'}   = '「次」ボタン';
    $setting::deco_type{'next'}  = 'button';
    $setting::deco_dir{'prev'}   = '「前」ボタン';
    $setting::deco_type{'prev'}  = 'button';

    $setting::deco_dir{'bargraph'}    = '棒グラフ画像';
    $setting::deco_type{'bargraph'}   = 'image';
    $setting::deco_dir{'bargraphbg'}  = '棒グラフ枠画像';
    $setting::deco_type{'bargraphbg'} = 'image';

    if ( defined $env::checkout && $env::checkout ) {
        $setting::deco_dir{'check'}  = 'カートを見る ボタン';
        $setting::deco_type{'check'} = 'button';
    }
}

1;
