package BbCommon;
require CMONOS::CGI_Lib::SetUp;
@ISA = qw(SetUp);
use strict;
use utf8;
use Fcntl qw(:DEFAULT);
eval 'use ' . $env::dbm_file . ';';
######################################################################
# バオバブセットアップモジュール
# BbCommon.pm ver1.0.2
# Copyright (C) 1999-2017 CMONOS Co. Ltd.
#
# support@cmonos.jp
# http://cmonos.jp/
# 最終更新日：2017-03-20
######################################################################
sub amp_escape ($$) {
my($this,$url) = @_;
return '' if !defined $url;
$url =~ s/\&/\&amp;/g;
return $url;
}

sub add_field_footer ($$) {
my($this,$data,$addition) = @_;
my $escaped_addition = $this->escape($addition);
my $added = 0;
$added = 1 if $data =~ s/foot="(.*?)"/foot="$escaped_addition$1"/s;
$added = 1 if $data =~ s/(<!--foot(?!\w)[^>]*-->)(.*?)(<!--\/foot(?!\w)[^>]*-->)/$1$addition$2$3/is;
if (!$added) {
	$data =~ s/(<!--\/field(?!\w)[^>]*-->)/<!--foot-->$addition<!--\/foot-->$1/is;
}
return $data;
}

######################################################################
# データベースに接続する
sub tie_db_by_field_setting ($$$) {
my($this,$database,$key) = @_;
my($id,$field);
while (($id,$field) = each %field::obj) {
	next unless ref $field;
	my $db = $field->db;
	if ($db && $field->{$key} && !ref tied %{$database->{$db}}) {
		tie(%{$database->{$db}}, $env::dbm_file, "$default::db/$db", O_RDONLY, $env::dbm_mode);
	}
}
}

sub tie_db ($$@) {
my($this,$database,@field) = @_;
return if !@field;
my($id);
foreach $id (@field) {
	my $db = $field::obj{$id}->db;
	next if !defined $db || $db eq '';
	unless (ref tied %{$database->{$db}}) {
		tie(%{$database->{$db}}, $env::dbm_file, "$default::db/$db", O_RDONLY, $env::dbm_mode);
	}
}
}

sub untie_db ($$) {
my($this,$database) = @_;
my($k,$db);
while (($k,$db) = each %$database) {
	untie(%$db);
	undef %$db;
}
undef %$database;
}

######################################################################
# レスがつけられるかどうか
sub tree_enabled ($) {
my $this = shift;
return $this->{'tree_enabled'} if defined $this->{'tree_enabled'} && $this->{'tree_enabled'} ne '';
my($field);
foreach $field (values %field::obj) {
	if ($field->{'class'} eq 'xbb_viewselector' && (
			$field->{'treeres'} || $field->{'listres'} || $field->{'articlelistres'} || $field->{'articleres'}
			 || $field->{'treeres'} eq '' || $field->{'listres'} eq '' || $field->{'articlelistres'} eq '' || $field->{'articleres'} eq ''
		)) {
		$this->{'tree_enabled'} = 1;
		return 1;
	}
}
$this->{'tree_enabled'} = 0;
return 0;
}

######################################################################
# ルート記事番号
sub get_top ($$) {
my($this,$n,$info) = @_;
return (defined $info && $info =~ /^[^,]+,([0-9]+)/) ? $1 : $n;
}

######################################################################
# 表示切り替えボタン
sub view_switch_button ($$;$$$$$$$) {
my($this,$view,$title,$url,$query,$li_class,$onclick,$target,$is_selected) = @_;
my $button;
$button = '<li' . ((defined $li_class && $li_class ne '') ? ' class="' . $li_class . '"' : '') . '>';
if (defined $url && $url ne '') {
	if (ref $query) {
		my $queries = $this->add_query('url',$query);
		if ($url !~ /\?/) {
			$queries =~ s/^&/\?/;
		} elsif ($url =~ /(?:&amp;|&|\?)$/) {
			$queries =~ s/^&//;
		}
		$url .= $this->amp_escape($queries);
	}
	$button .= $cgi::icon->button(
		$view,
		$setting::page{$view} . (($is_selected) ? '-selected' : ''),
		$url,
		$title,
		$target,
		(($onclick) ? {'onclick' => $onclick} : '')
	);
} else {
	if ($target) {
		if ($onclick =~ /^return/) {
			$onclick =~ s/;$/ \&\& /;
			$onclick .= '(this.form.target=\'' . $target . '\');';
		} else {
			$onclick .= ';' if $onclick;
			$onclick .= 'this.form.target=\'' . $target . '\';';
		}
	}
	$button .= $cgi::icon->submit_button(
		$view,
		$setting::page{$view} . (($is_selected) ? '-selected' : ''),
		$title,
		(($onclick) ? {'onclick' => $onclick} : ''),
		$query
	);
}
$button .= '</li>';
return $button;
}

######################################################################
# セットアップ
#sub import {
BEGIN {
if ( !$main::m || $main::m ne 'Tools' ) {
if (!$default::subdivided || ($default::subdivided && defined $main::c && $main::c ne '')) {

	#設定DB読み込み設定
	$setting::general = 1;				#一般設定読み込み
	$setting::deco = 1;					#テキスト装飾設定読み込み
	$setting::security = 1;				#アクセス権設定読み込み
	$setting::table = 1;				#テーブル設定読み込み
	$setting::page = 1;					#ページ設定読み込み

	#クッキー
	$cookie::id_enabled = 1;					#ID情報クッキー読み込み

	#フィールド読み込み設定
	$setting::field_db_name = 'inputfield';		#フィールド設定DB
	$setting::field = 2;					#フィールド設定読み込み（2=オリジナルも読み込む）
	$setting::field_style_disabled = 0;			#2=フォント設定スタイル設定を無視/1=フォント設定のみ無視
	$setting::field_tag_enabled = 'no';			#tag=タグのみ/all=全ての設定/no=タグをつけない

	#必須フォーム
	@setting::form = ('m','k','s','w','tc','st','and','search','q') if !@setting::form;
	@setting::form0 = ('m','k');
	@setting::form1 = ('s','w','tc','st','and','search','q');

	#デフォルト画面の調整
	if ($default::subdivided && defined $main::c && $main::c ne '') {
		unshift(@setting::form,'c') if !grep($_ eq 'c',@setting::form);
		unshift(@setting::form0,'c');
		unshift(@setting::form1,'c');
	}

	#イメージCSS
	$setting::image_css = 'baobab-image.css';

} else {
	$main::m = $default::m = 'Index';
	$main::k = $default::k = 'index';
	require CMONOS::Baobab::Index;
}
}
}

1;
