package BbLeaf;
require CMONOS::Baobab::BbTrunk;
@ISA = qw(BbTrunk);
use strict;
use utf8;
######################################################################
# バオバブ単記事表示基本モジュール
# BbLeaf.pm ver1.1.1
# Copyright (C) 1999-2018 CMONOS Co. Ltd.
#
# support@cmonos.jp
# http://cmonos.jp/
# 最終更新日：2015-01-21
######################################################################
# 必要なフィールドのIDを返す
sub required_fields ($) {
    my $this = shift;
    $setting::page{$setting::key}{'articleLimit'} = 10
        if !$setting::page{$setting::key}{'articleLimit'}
        || $setting::page{$setting::key}{'articleLimit'} <= 0;

    #テンプレートスキャン
    if ( defined $setting::page{$setting::key}{'template'}
        && $setting::page{$setting::key}{'template'} )
    {
        require CMONOS::CGI_Lib::Template;
        $this->{'Template'} = Template->new();
        $this->{'Template'}->set(
            'field_style_disabled' => 0,
            'field_tag_enabled'    => 'no'
        );
        $setting::page{$setting::key}{'template'}
            =~ s/(<!--field(?=\s)[^>]*\s+id="$field::for{'title'}"[^>]*-->.*?<!--\/field(?!\w)[^>]*-->)/$this->add_field_footer($1,'<newicon>')/seig
            if $field::for{'title'};
        my @fields = $this->{'Template'}
            ->template_parser( \$setting::page{$setting::key}{'template'} );
        if (@fields) {
            foreach my $id (@fields) {
                if ( ref $field::obj{$id} ) {
                    if (  !$field::obj{$id}->{'Hidden'}
                        && $field::obj{$id}->format_for_detail_enabled
                        && (   $field::obj{$id}->{'Open'}
                            || $this->is_secure('secret') )
                        )
                    {
                        push( @{ $this->{'required_fields'} }, $id );
                    }
                    else {
                        $field::obj{$id}->disabled;
                    }
                }
            }
            $setting::page{$setting::key}{'template'} = $this->{'Template'}
                ->deco( $setting::page{$setting::key}{'template'} );
            return @{ $this->{'required_fields'} };
        }
        else {
            delete $setting::page{$setting::key}{'template'};
            delete $this->{'Template'};
        }
    }

    #読み込みフィールド
    $this->{'statusFieldID'}   = '';
    $this->{'categoryFieldID'} = '';
    foreach my $i ( sort { $a <=> $b } keys %field::ORDER ) {
        my $id = $field::ORDER{$i};
        if (   ref $field::obj{$id}
            && !$field::obj{$id}->{'Hidden'}
            && $field::obj{$id}->format_for_detail_enabled
            && ( $field::obj{$id}->{'Open'} || $this->is_secure('secret') )
            || !grep( $_ eq $id, @{ $this->{'required_fields'} } ) )
        {
            push( @{ $this->{'required_fields'} }, $id );
            if ( $field::obj{$id}->{'class'} eq 'xbb_category' ) {
                $this->{'categoryFieldID'} = $id;
            }
            elsif ( $field::obj{$id}->{'class'} eq 'xbb_status' ) {
                $this->{'statusFieldID'} = $id;
            }
            $field::obj{$id}->{'field_style_disabled'} = 0;
            $field::obj{$id}->{'field_tag_enabled'}    = 'no';
        }
    }

    return @{ $this->{'required_fields'} };
}

######################################################################
# 記事ヘッダ
sub print_list_header ($$$$) {
    my ( $this, $handle, $output, $p ) = @_;

    #前後ページへのリンク
    $this->print_page_jump_form( $handle, $output, $p,
        $setting::page{$setting::key}{'articleLimit'},
        $this->{'count'} );
}

######################################################################
# 単記事表示
sub set_article_frame ($$) {
    my ( $this, $output ) = @_;
    return
        if $setting::page{$setting::key}{'template'}
        =~ /[^\x09\x0A\x0C\x0D\x20]/;

    #フレーム調整
    $setting::page{$setting::key}{'articleFrameWidth'} = 450
        if !$setting::page{$setting::key}{'articleFrameWidth'}
        || $setting::page{$setting::key}{'articleFrameWidth'} <= 0;
    if ( $setting::page{$setting::key}{'articleFrame'}
        && ref $frame::obj{'frame'}
        { $setting::page{$setting::key}{'articleFrame'} } )
    {
        my ( $temp, $contents, $title, @frame_setting );
        @frame_setting = (
            'frameclass' => 'baobab-article-frame',
            'framewidth' => $setting::page{$setting::key}{'articleFrameWidth'}
        );
        push( @frame_setting,
            'contentsalign', $setting::page{$setting::key}{'articleAlign'} )
            if defined $setting::page{$setting::key}{'articleAlign'}
            && $setting::page{$setting::key}{'articleAlign'};
        push( @frame_setting,
            'contentsvalign', $setting::page{$setting::key}{'articleValign'} )
            if defined $setting::page{$setting::key}{'articleValign'}
            && $setting::page{$setting::key}{'articleValign'};
        $contents = '_C_';
        $title    = '<!--article title-->';
        $temp
            = $cgi::Deco->frame( 'frame',
            $setting::page{$setting::key}{'articleFrame'},
            \$contents, \$title, 'no', '', 0, @frame_setting );
        ( $this->{'articleFrame'}, $this->{'articleFrameEnd'} )
            = split( /_C_/, $temp );

    }
    elsif ($setting::page{$setting::key}{'articleFrameWidth'} ne ''
        || $setting::page{$setting::key}{'articleHeight'} ne '' )
    {
        $this->{'articleFrame'} = '<div class="baobab-article-frame section"';
        if (   $setting::page{$setting::key}{'articleFrameWidth'}
            || $setting::page{$setting::key}{'articleAlign'} )
        {
            $this->{'articleFrame'} .= ' style="';
            $this->{'articleFrame'}
                .= ' width:'
                . $setting::page{$setting::key}{'articleFrameWidth'} . 'px;'
                if defined $setting::page{$setting::key}{'articleFrameWidth'}
                && $setting::page{$setting::key}{'articleFrameWidth'};
            $this->{'articleFrame'}
                .= ' text-align:'
                . $setting::page{$setting::key}{'articleAlign'} . ';'
                if defined $setting::page{$setting::key}{'articleAlign'}
                && $setting::page{$setting::key}{'articleAlign'};
            $this->{'articleFrame'} .= '"';
        }
        $this->{'articleFrame'} .= '>';
        $this->{'articleFrameEnd'} = '</div>';
        $setting::page{$setting::key}{'articleFrameTitle'} = 0;
    }

}

######################################################################
# 単記事表示
sub print_article_box ($$$$) {
    my ( $this, $handle, $database, $n ) = @_;

    #タイトル
    my ( $is_deleted, $del_title );
    if ( !defined $database->{'tree'}->{ $this->encode_utf8($n) } ) {
        return;
    }
    elsif (
        $this->decode_utf8( $database->{'tree'}->{ $this->encode_utf8($n) } )
        =~ /^d/ )
    {
        $is_deleted = 1;
        $del_title
            = ( $setting::page{'deletedMsg'} )
            ? $setting::page{'deletedMsg'}
            : '<em>'
            . (
            (   $this->decode_utf8(
                    $database->{'tree'}->{ $this->encode_utf8($n) }
                ) =~ /^dm/
            ) ? '管理人' : '投稿者'
            ) . 'により、この記事は削除されました</em>';
    }
    print $handle '<a name="n' . $n . '" id="n' . $n . '"></a>';

    #テンプレートに従って出力
    if ( defined $setting::page{$setting::key}{'template'}
        && $setting::page{$setting::key}{'template'} )
    {
        my ( %temp, $temp_nostyle );
        foreach my $id ( @{ $this->{'required_fields'} } ) {
            if ( ref $field::obj{$id} ) {
                if (  !$field::obj{$id}->{'Hidden'}
                    && $field::obj{$id}->format_for_detail_enabled
                    && (   $field::obj{$id}->{'Open'}
                        || $this->is_secure('secret') )
                    )
                {
                    my $db = $field::obj{$id}->db;
                    $temp{$id}
                        = ($db)
                        ? $this->decode_utf8(
                        $database->{$db}->{ $this->encode_utf8($n) } )
                        : '';
                }
                else {
                    $field::obj{$id}->disabled;
                }
            }
        }
        if (   $is_deleted
            && $field::for{'title'}
            && ref $field::obj{ $field::for{'title'} } )
        {
            $temp{ $field::for{'title'} } = $del_title;
            $temp_nostyle = $field::obj{ $field::for{'title'} }->{'nostyle'};
            $field::obj{ $field::for{'title'} }->{'nostyle'} = 0;
        }
        my $temp = $setting::page{$setting::key}{'template'};
        my $newicon
            = ($is_deleted) ? '' : $this->new_item_icon( $database, $n );
        $temp =~ s/<newicon>/$newicon/sig;
        $newicon = $this->escape($newicon);
        $temp =~ s/&lt;newicon&gt;/$newicon/sig;
        print $handle $this->{'Template'}
            ->replace( $temp, \%temp, 'detail', $default::file . '/' . $n,
            $main::c, $n, $database );
        undef %temp;

        if (   $is_deleted
            && $field::for{'title'}
            && ref $field::obj{ $field::for{'title'} } )
        {
            $field::obj{ $field::for{'title'} }->{'nostyle'} = $temp_nostyle;
        }

        #デフォルト
    }
    else {
        my ( %done, $title, $my_category, $my_status );
        if (   $setting::page{$setting::key}{'articleFrameClass'}
            && $this->{'categoryFieldID'} )
        {
            my $db = $field::obj{ $this->{'categoryFieldID'} }->db;
            if ( defined $db && $db ) {
                $my_category
                    .= $field::obj{ $this->{'categoryFieldID'} }->name . ':'
                    if defined $field::obj{ $this->{'categoryFieldID'} }
                    ->{'nametag'}
                    && $field::obj{ $this->{'categoryFieldID'} }->{'nametag'};
                $my_category
                    .= $field::obj{ $this->{'categoryFieldID'} }
                    ->format_for_detail(
                    $this->decode_utf8(
                        $database->{$db}->{ $this->encode_utf8($n) }
                    ),
                    $default::file . '/' . $n,
                    $main::c, $n,
                    $database
                    ) . ' ';
                $done{ $this->{'categoryFieldID'} } = 1;
            }
        }
        if ( $field::for{'title'} && ref $field::obj{ $field::for{'title'} } )
        {
            my $db = $field::obj{ $field::for{'title'} }->db;
            if ( defined $db && $db ) {
                $title .= $field::obj{ $field::for{'title'} }->name . ':'
                    if
                    defined $field::obj{ $field::for{'title'} }->{'nametag'}
                    && $field::obj{ $field::for{'title'} }->{'nametag'};
                $title
                    .= ($is_deleted) ? $del_title
                    : $field::obj{ $field::for{'title'} }->format_for_detail(
                    $this->decode_utf8(
                        $database->{$db}->{ $this->encode_utf8($n) }
                    ),
                    $default::file . '/' . $n,
                    $main::c, $n,
                    $database
                    )
                    . ( ($is_deleted) ? ''
                    : $this->new_item_icon( $database, $n ) );
                $done{ $field::for{'title'} } = 1;
            }
        }
        if (   $setting::page{$setting::key}{'articleFrameStatus'}
            && $this->{'statusFieldID'} )
        {
            my $db = $field::obj{ $this->{'statusFieldID'} }->db;
            if ( defined $db && $db ) {
                $my_status .= ' ';
                $my_status
                    .= $field::obj{ $this->{'statusFieldID'} }->name . ':'
                    if defined $field::obj{ $this->{'statusFieldID'} }
                    ->{'nametag'}
                    && $field::obj{ $this->{'statusFieldID'} }->{'nametag'};
                $my_status
                    .= $field::obj{ $this->{'statusFieldID'} }
                    ->format_for_detail(
                    $this->decode_utf8(
                        $database->{$db}->{ $this->encode_utf8($n) }
                    ),
                    $default::file . '/' . $n,
                    $main::c, $n,
                    $database
                    );
                $done{ $this->{'statusFieldID'} } = 1;
            }
        }
        $title
            = '<h2 class="baobab-article-title">'
            . ( ( defined $my_category ) ? $my_category : '' )
            . ( ( defined $title )       ? $title       : '' )
            . ( ( defined $my_status )   ? $my_status   : '' ) . '</h2>'
            if $title || $my_category || $my_status;

        if ( defined $setting::page{$setting::key}{'articleFrameTitle'}
            && $setting::page{$setting::key}{'articleFrameTitle'} )
        {
            my ($frame_start);
            $frame_start = $this->{'articleFrame'};
            $frame_start .= $title
                unless $frame_start
                =~ s/<!--titlebar-->.*?<!--\/titlebar-->/$title/;
            print $handle $frame_start;
        }
        else {
            print $handle $this->{'articleFrame'};
            print $handle $title;
        }
        print $handle '<div class="body">';

        #記事情報
        print $handle '<dl class="baobab-article-info info">';
        my $id;
        foreach $id ( @{ $this->{'required_fields'} } ) {
            next if $done{$id} || !$field::obj{$id}->{'info'};
            my $db  = $field::obj{$id}->db;
            my $str = $field::obj{$id}->format_for_detail(
                (   ($db)
                    ? $this->decode_utf8(
                        $database->{$db}->{ $this->encode_utf8($n) }
                        )
                    : ''
                ),
                $default::file . '/' . $n,
                $main::c, $n,
                $database
            );
            $done{$id} = 1;
            next if !defined $str || $str eq '';
            print $handle '<dt>' . $field::obj{$id}->name . '</dt>'
                if defined $field::obj{$id}->{'nametag'}
                && $field::obj{$id}->{'nametag'};
            print $handle '<dd>' . $str . '</dd>';
        }
        print $handle '</dl>';

        #記事本文
        foreach $id ( @{ $this->{'required_fields'} } ) {
            next if defined $done{$id} && $done{$id};
            my $db  = $field::obj{$id}->db;
            my $str = $field::obj{$id}->format_for_detail(
                (   ($db)
                    ? $this->decode_utf8(
                        $database->{$db}->{ $this->encode_utf8($n) }
                        )
                    : ''
                ),
                $default::file . '/' . $n,
                $main::c, $n,
                $database
            );
            $done{$id} = 1;
            next if !defined $str || $str eq '';
            print $handle '<div class="baobab-article-item">';
            print $handle $field::obj{$id}->name . ':'
                if defined $field::obj{$id}->{'nametag'}
                && $field::obj{$id}->{'nametag'};
            print $handle $str;
            print $handle '</div>';
        }

        print $handle '</div>';
        print $handle $this->{'articleFrameEnd'};
    }
}

######################################################################
#記事フッタ
sub print_list_footer ($$$$) {
    my ( $this, $handle, $output, $p ) = @_;

    #前後ページへのリンク
    $this->print_page_jump_form( $handle, $output, $p,
        $setting::page{$setting::key}{'articleLimit'},
        $this->{'count'}, '2' );
}

1;
