package Index;
require CMONOS::Baobab::BbCommon;
@ISA = qw(BbCommon);
use strict;
use utf8;
use Fcntl qw(:DEFAULT);
eval 'use ' . $env::dbm_file . ';';
######################################################################
# 総合インデックスモジュール
# Index.pm ver1.0.3
# Copyright (C) 1999-2018 CMONOS Co. Ltd.
#
# support@cmonos.jp
# http://cmonos.jp/
# 最終更新日：2010-02-15
######################################################################
# 実行
sub run ($) {
    my $this = shift;
    my ($u,              $template,  %category_mtime, @pattern,
        $prev_flag,      $next_flag, $count,          $tile_frame,
        $tile_frame_end, @category,  $c
    );

    #---------------------------------------------------------------------
    #承認待ち項目警告
    $this->set_pending_item_alert
        if !defined $main::sort && $this->is_secure('tools');

    #---------------------------------------------------------------------

    #一ページ記事数
    $setting::page{$setting::key}{'tableRows'} = 10
        if !defined $setting::page{$setting::key}{'tableRows'}
        || !$setting::page{$setting::key}{'tableRows'};
    $setting::page{$setting::key}{'tableCols'} = 1
        if !defined $setting::page{$setting::key}{'tableCols'}
        || !$setting::page{$setting::key}{'tableCols'};
    $u = $setting::page{$setting::key}{'tableRows'}
        * $setting::page{$setting::key}{'tableCols'};
    $main::sort = $setting::page{$setting::key}{'defaultSort'}
        if !defined $main::sort || $main::sort eq '';
    $main::p = $main::pnum - 1 if $main::pnum && !$this->is_nan($main::pnum);
    $main::p
        = ( $main::p && !$this->is_nan($main::p) && $main::p > 0 )
        ? $main::p
        : 0;
    $template
        = $this->template_deco( $setting::page{$setting::key}{'template'} )
        if defined $setting::page{$setting::key}{'template'}
        && $setting::page{$setting::key}{'template'};

    if ( defined $main::search && $main::search ne '' ) {
        @pattern = split( /\s+/, $main::search );
        @pattern = grep( $_ ne '', @pattern );
        $this->push_window_title(
            ($default::english) ? 'Search Results' : '検索結果' )
            if @pattern;
    }
    $tile_frame = $tile_frame_end = '';

    tie( %category_mtime, $env::dbm_file,
        $default::master_db_dir . '/category_mtime',
        O_RDONLY, $env::dbm_mode );
    if ( ref tied %category_mtime ) {
        no warnings qw(numeric);
        @category = grep( $_ ne 'Last-Modified', keys %category_mtime );
        if ( $main::sort eq 'newer' ) {
            @category = sort {
                $category_mtime{$b} <=> $category_mtime{$a}
                    || $a <=> $b
                    || $a cmp $b
            } @category;
        }
        elsif ( $main::sort eq 'older' ) {
            @category = sort {
                $category_mtime{$a} <=> $category_mtime{$b}
                    || $a <=> $b
                    || $a cmp $b
            } @category;
        }
        else {
            @category = sort { $a <=> $b || $a cmp $b } @category;
        }
    }
    untie %category_mtime;
    $this->set_og_url( $this->my_url );
    $this->set_last_modified( $setting::general{'mtime'} )
        if $setting::general{'lastModifiedHeaderEnabled'};
    $this->print_page_header($setting::key);

    #検索ボックス
    $this->print_search_box
        if defined $setting::page{$setting::key}{'headBox'}
        && $setting::page{$setting::key}{'headBox'};

    #テーブルフレーム
    print $this->frame_start( $setting::page{$setting::key}{'tableFrame'},
        '', 'index', 'baobab-index-table-frame' );

    #タイルフレーム調整
    if ( $setting::page{$setting::key}{'tileFrame'}
        && ref $frame::obj{'frame'}
        { $setting::page{$setting::key}{'tileFrame'} } )
    {
        my (@align);
        push( @align,
            'contentsalign', $setting::page{$setting::key}{'tileAlign'} )
            if defined $setting::page{$setting::key}{'tileAlign'}
            && $setting::page{$setting::key}{'tileAlign'};
        push( @align,
            'contentsvalign', $setting::page{$setting::key}{'tileValign'} )
            if defined $setting::page{$setting::key}{'tileValign'}
            && $setting::page{$setting::key}{'tileValign'};
        $frame::obj{'frame'}{ $setting::page{$setting::key}{'tileFrame'} }
            ->set_direct(
            'framewidth'  => $setting::page{$setting::key}{'tileWidth'},
            'frameheight' => $setting::page{$setting::key}{'tileHeight'},
            @align
            );

    }
    elsif ($setting::page{$setting::key}{'tileWidth'}
        || $setting::page{$setting::key}{'tileHeight'} )
    {
        $tile_frame = '<table';
        $tile_frame
            .= ' width="' . $setting::page{$setting::key}{'tileWidth'} . '"'
            if defined $setting::page{$setting::key}{'tileWidth'}
            && $setting::page{$setting::key}{'tileWidth'};
        $tile_frame
            .= ' height="'
            . $setting::page{$setting::key}{'tileHeight'} . '"'
            if defined $setting::page{$setting::key}{'tileHeight'}
            && $setting::page{$setting::key}{'tileHeight'};
        $tile_frame .= '><tr class="tbody-end"><td';
        $tile_frame
            .= ' align="' . $setting::page{$setting::key}{'tileAlign'} . '"'
            if defined $setting::page{$setting::key}{'tileAlign'}
            && $setting::page{$setting::key}{'tileAlign'};
        $tile_frame
            .= ' valign="'
            . $setting::page{$setting::key}{'tileValign'} . '"'
            if defined $setting::page{$setting::key}{'tileValign'}
            && $setting::page{$setting::key}{'tileValign'};
        $tile_frame .= '>';
        $tile_frame_end = '</td></tr></tbody></table>';
    }

    if (@category) {
        no warnings qw(untie);
        my ($this_table);
        if (   $setting::page{$setting::key}{'tableCols'}
            && $setting::page{$setting::key}{'tableCols'} > 1 )
        {
            $this_table = Table->new;
            if ( ref $table::obj{ $setting::page{$setting::key}{'table'} } ) {
                %{$this_table}
                    = %{ $table::obj{ $setting::page{$setting::key}{'table'} }
                    };
            }
            else {
                $this_table->set(
                    'tableclass' => 'tile-table',
                    'class0'     => 'tile-cell'
                );
            }

            #テーブル開始
            print $this_table->table;

            #列制限
            $this_table->limit( $setting::page{$setting::key}{'tableCols'} );
        }
        foreach $c (@category) {
            my (%general,     $master,    $title, $description,
                $p,           $a_count,   $icon,  $icon_width,
                $icon_height, $html_flag, $mtime, $is_matched
            );
            tie( %general, $env::dbm_file,
                $default::master_preference_dir . '/' . $c . '/general',
                O_RDONLY, $env::dbm_mode );
            if ( ref tied %general ) {
                $master      = $this->decode_utf8( $general{'mastername'} );
                $title       = $this->decode_utf8( $general{'cginame'} );
                $description = $this->decode_utf8( $general{'description'} );
                $p           = $this->decode_utf8( $general{'p'} );
                $a_count     = $this->decode_utf8( $general{'count'} );
                $icon        = $this->decode_utf8( $general{'icon'} );
                $icon_width  = $this->decode_utf8( $general{'iconwidth'} );
                $icon_height = $this->decode_utf8( $general{'iconheight'} );
                $html_flag   = $this->decode_utf8( $general{'html'} );
                $mtime       = $1
                    if $this->decode_utf8( $general{'latest'} )
                    =~ /^([0-9]+):/;
                untie %general;

                if (@pattern) {
                    $is_matched = 1
                        if !$is_matched
                        && ( $main::target eq '' || $main::target eq 'title' )
                        && $this->is_matched( \$title, \@pattern );
                    $is_matched = 1
                        if !$is_matched
                        && ( $main::target eq ''
                        || $main::target eq 'master' )
                        && $this->is_matched( \$master, \@pattern );
                    $is_matched = 1
                        if !$is_matched
                        && ( $main::target eq ''
                        || $main::target eq 'description' )
                        && $this->is_matched( \$description, \@pattern );
                }
                else {
                    $is_matched = 1;
                }

                if ( defined $is_matched && $is_matched ) {
                    $count++;
                    if ( $main::p * $u < $count
                        && ( $main::p + 1 ) * $u >= $count )
                    {
                        $a_count = '0' if !defined $a_count || !$a_count;
                        if ( defined $html_flag && $html_flag ) {
                            my (%security);
                            tie(%security,
                                $env::dbm_file,
                                $default::master_preference_dir . '/'
                                    . $c
                                    . '/security',
                                O_RDONLY,
                                $env::dbm_mode
                            );
                            if ( ref tied %security ) {
                                $html_flag = 0
                                    if $this->decode_utf8(
                                    $security{'browse_passwordCheck'} ) ne
                                    'nocheck'
                                    || $this->decode_utf8(
                                    $security{'secret_passwordCheck'} ) ne
                                    'nocheck'
                                    || $this->decode_utf8(
                                    $security{'closed_passwordCheck'} ) ne
                                    'nocheck';
                            }
                            untie %security;
                        }
                        $title = $c if !defined $title || $title eq '';
                        if ( ref $this_table ) {
                            print $this_table->trtd(
                                $tile_frame
                                    . $this->category_box(
                                    $template,    $html_flag,
                                    $c,           $mtime,
                                    $title,       $master,
                                    $description, $p,
                                    $a_count,     $icon,
                                    $icon_width,  $icon_height
                                    )
                                    . $tile_frame_end
                            );
                        }
                        else {
                            print( $tile_frame
                                    . $this->category_box(
                                    $template,    $html_flag,
                                    $c,           $mtime,
                                    $title,       $master,
                                    $description, $p,
                                    $a_count,     $icon,
                                    $icon_width,  $icon_height
                                    )
                                    . $tile_frame_end
                            );
                        }
                    }
                }
            }
            else {
                untie %general;
            }
        }

        #テーブル終了
        if ( ref $this_table ) {
            print $this_table->trtd( '', 1 );
            print $this_table->_table;
        }
    }

    #テーブルフレーム終了
    print $this->frame_end( $setting::page{$setting::key}{'tableFrame'},
        '', 'index', 'baobab-index-table-frame' );

    #前後ページへのジャンプ
    $this->print_page_jump_button( $u, $main::p, $count );

    $this->print_search_box('_foot')
        if defined $setting::page{$setting::key}{'footBox'}
        && $setting::page{$setting::key}{'footBox'};
    $this->print_return_button;
    $this->print_tool_icon
        if defined $setting::page{'index'}{'toolIcon'}
        && $setting::page{'index'}{'toolIcon'};
    $this->print_page_footer($setting::key);
}

######################################################################
# 検索ボックス
sub is_matched ($$$) {
    my ( $this, $str, $pat ) = @_;
    my ($matched);
    foreach my $p (@$pat) {
        if ( $$str =~ /$p/i ) {
            $matched = 1;
        }
        else {
            return 0;
        }
    }
    return $matched;
}

######################################################################
# 検索ボックス
sub print_search_box ($;$) {
    my ( $this, $name ) = @_;
    my ($search_frame_title);
    $search_frame_title = '<h2>検索</h2>'
        if defined $setting::page{$setting::key}{'searchFrameTitle'}
        && $setting::page{$setting::key}{'searchFrameTitle'};

    #検索フレーム
    print $this->frame_start(
        $setting::page{$setting::key}{'searchFrame'},
        $setting::page{$setting::key}{'searchWidth'},
        'baobab-index-search-box panel',
        '',
        $search_frame_title
    );

    print $this->form_start(
        'key'  => 'index',
        'name' => 'search_box' . ( ( defined $name ) ? $name : '' ),
        'required' => [ 'm', 'k' ]
    );
    print '<select name="target">';
    print '<option value="">すべての項目</option>';
    print '<option value="title"'
        . ( ( defined $main::target && $main::target eq 'title' )
        ? ' selected="selected"'
        : '' )
        . '>タイトル</option>';
    print '<option value="master"'
        . ( ( defined $main::target && $main::target eq 'master' )
        ? ' selected="selected"'
        : '' )
        . '>管理人名</option>';
    print '<option value="description"'
        . ( ( defined $main::target && $main::target eq 'description' )
        ? ' selected="selected"'
        : '' )
        . '>説明</option>';
    print '</select> ';
    print '<input type="search" placeholder="検索" results="5" autosave="'
        . ( ($default::id) ? $default::id : 'tablemaker' )
        . '" size="20" name="search" value="'
        . $this->escape($main::search) . '" /> ';
    print '<select name="sort">';
    print '<option value="">デフォルトの順</option>';
    print '<option value="newer"'
        . ( ( defined $main::sort && $main::sort eq 'newer' )
        ? ' selected="selected"'
        : '' )
        . '>更新時の新しい順</option>';
    print '<option value="older"'
        . ( ( defined $main::sort && $main::sort eq 'older' )
        ? ' selected="selected"'
        : '' )
        . '>更新時の古い順</option>';
    print '</select> ';
    print '<input type="submit" value="検索" /> ';
    print
        '<input type="button" value="リセット" onclick="cmonos.form.item(this.form).resetAll()" />';
    print '</form>';

    #検索フレーム終了
    print $this->frame_end(
        $setting::page{$setting::key}{'searchFrame'},
        $setting::page{$setting::key}{'searchWidth'},
        'baobab-index-search-box panel'
    );
}

######################################################################
# グループボックス
sub category_box ($$$$$$$$$$$) {
    my ($this,  $template, $html_flag, $c,
        $mtime, $title,    $master,    $description,
        $p,     $a_count,  $icon,      $icon_width,
        $icon_height
    ) = @_;
    my ($date);
    my $newicon = $this->new_item_icon($mtime);
    $mtime = $this->date(
        $mtime,
        $setting::general{'dateLimit'},
        'gmt' . $setting::general{'datetype'}
    ) if defined $mtime && $mtime;
    $icon
        = ( $setting::general{'subicon'} && defined $icon && $icon )
        ? $this->mk_link(
        '<img src="'
            . (
            ( $default::master_file_dir ne '' )
            ? $default::master_file_dir
            : '.'
            )
            . '/'
            . $c . '/'
            . $icon
            . '" width="'
            . $icon_width
            . '" height="'
            . $icon_height
            . '" alt="'
            . $this->escape($title)
            . '" border="0" />',
        $c,
        $html_flag
        )
        : '';
    $title = $this->mk_link( $title, $c, $html_flag );
    $this->tag_fix( \$description, 2, 0, 0, $p );

    #テンプレートがある場合
    if ($template) {
        $template
            =~ s/<\!--title(?![0-9a-zA-Z_])([^>]*)-->(.*?)<\!--\/title(?![0-9a-zA-Z_])[^>]*-->/$this->bb_index_tag_replace($title,$1,$2,$newicon)/ges;
        $template
            =~ s/<\!--description(?![0-9a-zA-Z_])([^>]*)-->(.*?)<\!--\/description(?![0-9a-zA-Z_])[^>]*-->/$this->bb_index_tag_replace($description,$1,$2)/ges;
        $template
            =~ s/<\!--master(?![0-9a-zA-Z_])([^>]*)-->(.*?)<\!--\/master(?![0-9a-zA-Z_])[^>]*-->/$this->bb_index_tag_replace($master,$1,$2)/ges;
        $template
            =~ s/<\!--count(?![0-9a-zA-Z_])([^>]*)-->(.*?)<\!--\/count(?![0-9a-zA-Z_])[^>]*-->/$this->bb_index_tag_replace($a_count,$1,$2)/ges;
        $template
            =~ s/<\!--mtime(?![0-9a-zA-Z_])([^>]*)-->(.*?)<\!--\/mtime(?![0-9a-zA-Z_])[^>]*-->/$this->bb_index_tag_replace($mtime,$1,$2)/ges;
        $template
            =~ s/<\!--icon(?![0-9a-zA-Z_])([^>]*)-->(.*?)<\!--\/icon(?![0-9a-zA-Z_])[^>]*-->/$this->bb_index_tag_replace($icon,$1,$2)/ges;
        return $template;

        #テンプレートがない場合
    }
    else {
        $template
            = '<h2 class="baobab-category-title">'
            . $title . ' ('
            . $a_count . ')'
            . $newicon . '</h2>'
            if !$setting::page{$setting::key}{'tileFrameTitle'};
        $template .= '<div class="body">';
        $template .= '<p class="baobab-category-icon icon">' . $icon . '</p>'
            if defined $icon && $icon;
        if ( $master ne '' || $mtime ) {
            $template .= '<dl class="baobab-category-info info">';
            $template .= '<dt>最終更新日時</dt><dd>' . $mtime . '</dd>'
                if defined $mtime && $mtime;
            $template .= '<dt>管理人</dt><dd>' . $master . '</dd>'
                if defined $master && $master ne '';
            $template .= '</dl>';
        }
        $template .= $description
            if defined $description && $description ne '';
        $template .= '</div>';
        return $this->get_frame(
            $setting::page{$setting::key}{'tileFrame'},
            $template,
            (   ( $setting::page{$setting::key}{'tileFrameTitle'} )
                ? '<h2 class="baobab-article-title">'
                    . $this->mk_link( $title, $c, $html_flag ) . ' ('
                    . $a_count
                    . ')</h2>'
                : ''
            ),
            'no',
            'baobab-category-frame section'
        );
    }
}

sub mk_link ($$$$) {
    my ( $this, $str, $c, $html_flag ) = @_;
    return '<a href="'
        . ( ($html_flag)
        ? $default::file . '/' . $c . '/index.html'
        : $cgi::path . '?c=' . $c )
        . '">'
        . $str . '</a>';
}

sub bb_index_tag_replace ($$$$;$) {
    my ( $this, $str, $setting, $dat, $icon ) = @_;
    my ( $head, $foot );
    if ( $dat
        =~ /<\!--head(?![0-9a-zA-Z_])[^>]*-->(.*?)<\!--\/head(?![0-9a-zA-Z_])[^>]*-->/s
        )
    {
        $head = $1;
    }
    elsif ( $dat =~ /^(.*?)<\!--data(?![0-9a-zA-Z_])[^>]*-->/s ) {
        $head = $1;
    }
    elsif ( $setting
        =~ /[\x09\x0A\x0C\x0D\x20]+head[\x09\x0A\x0C\x0D\x20]*=[\x09\x0A\x0C\x0D\x20]*"([^"]+)/s
        )
    {
        $head = $this->unescape( $this->entity_to_lf($1) );
    }
    if ( $dat
        =~ /<\!--foot(?![0-9a-zA-Z_])[^>]*-->(.*?)<\!--\/foot(?![0-9a-zA-Z_])[^>]*-->/s
        )
    {
        $foot = $1;
    }
    elsif ( $dat =~ /<\!--\/data(?![0-9a-zA-Z_])[^>]*-->(.*?)$/s ) {
        $foot = $1;
    }
    elsif ( $setting
        =~ /[\x09\x0A\x0C\x0D\x20]+foot[\x09\x0A\x0C\x0D\x20]*=[\x09\x0A\x0C\x0D\x20]*"([^"]+)/s
        )
    {
        $foot = $this->unescape( $this->entity_to_lf($1) );
    }
    return $head . $str . ( $icon || '' ) . $foot;
}

######################################################################
# 新着アイコン取得
sub new_item_icon ($$) {
    my ( $this, $mtime ) = @_;
    if ( $setting::page{'index'}{'upIconLimit'} ) {
        if ( $mtime
            && time - $mtime
            < 86400 * $setting::page{'index'}{'upIconLimit'} )
        {
            my $title
                = ( $setting::page{'index'}{'upIconAlt'} )
                ? $setting::page{'index'}{'upIconAlt'}
                : ( $setting::deco{'new'}{ $setting::page{'index'}{'upIcon'} }
                    {'alt'} )
                ? $setting::deco{'new'}{ $setting::page{'index'}{'upIcon'} }
                {'alt'}
                : 'UP!';
            if (   $setting::page{'index'}{'upIcon'}
                && $setting::deco{'new'}{ $setting::page{'index'}{'upIcon'} }
                {'width'} )
            {
                unless ( ref $cgi::Image ) {
                    require CMONOS::CGI_Lib::Image;
                    $cgi::Image = Image->new;
                }
                return ' '
                    . $cgi::Image->image_tag(
                    $env::image_dir . '/new/'
                        . $setting::deco{'new'}
                        { $setting::page{'index'}{'upIcon'} }{'name'},
                    $setting::deco{'new'}
                        { $setting::page{'index'}{'upIcon'} }{'width'},
                    $setting::deco{'new'}
                        { $setting::page{'index'}{'upIcon'} }{'height'},
                    0,
                    $title,
                    'class="up-item-icon"',
                    );
            }
            else {
                return ' <span class="up-item-icon">' . $title . '</span>';
            }
        }
    }
    return '';
}

######################################################################
# 前後ページへのリンク
sub print_page_jump_button ($$$$) {
    my ( $this, $u, $p, $count ) = @_;
    my ( $prev, $next, $to, $url, $from, $form_flag );
    $p    = 0 if !$p;
    $prev = $p - 1;
    $next = $p + 1;
    $count += 0;
    $u     += 0;
    $to = $u * $next;
    return if !$p && $to > $count;
    $to = $count if $to > $count;

    if ( $setting::general{'postMethod'} ) {
        print $this->form_start(
            'key'      => $setting::security_key,
            'name'     => 'jump',
            'method'   => 'post',
            'required' => \@setting::form
        );
        $form_flag = 1;
    }
    else {
        $this->use_deco;
        $url = $cgi::path . $this->set_query( 'url', \@setting::form );
    }
    print '<ul class="pager">';
    if ( $prev >= 0 ) {
        print '<li class="prev">';
        if ($form_flag) {
            print $cgi::Deco->submit_button(
                'prev',
                $setting::page{'prevButton'},
                ( ($default::english) ? 'Prev' : '前のページ' ),
                '',
                ( ($prev) ? { 'p' => $prev } : {} )
            );
        }
        else {
            print $cgi::Deco->button(
                'prev',
                $setting::page{'prevButton'},
                $url
                    . (
                    ($prev)
                    ? $this->add_query( 'url', { 'p' => $prev } )
                    : ''
                    ),
                ( ($default::english) ? 'Prev' : '前のページ' )
            );
        }
        print '</li>';
    }
    if ( $form_flag || $setting::page{'index'}{'pageinfo'} || $count < $u ) {
        my $from = $u * $p;
        $from += 1 if defined $count && $count;
        print '<li class="info">' . $from . ' - ' . $to . ' / ' . $count
            . '</li>';
    }
    else {
        my ( $pnum, $max, $margin, $total, $start_page, $end_page,
            $omission );
        $pnum = $p + 1;
        $max
            = ( $setting::page{'index'}{'pagelistmax'} )
            ? $setting::page{'index'}{'pagelistmax'}
            : 12;
        $margin
            = ( $setting::page{'index'}{'pagelistmargin'} )
            ? $setting::page{'index'}{'pagelistmargin'}
            : 2;
        $total  = int( $count / $u + 0.9999 );
        $max    = 7 if $max && $max < 7;
        $margin = int( ( $max - 5 ) / 2 ) if $max - $margin * 2 - 5 < 0;
        $margin = 1 if $margin < 1;
        $start_page
            = ( $pnum - $margin <= $total - $max + 3 )
            ? ( $pnum - $margin > 3 )
                ? $pnum - $margin
                : 3
            : $total - $max + 3;
        $end_page = $start_page + $max - 5;
        $omission = 0;

        foreach my $page ( 1 .. $total ) {
            if (( $max && $max < $total && $page > 1 && $page < $total )
                && (   ( $pnum > $margin + 3 && $page < $start_page )
                    || ( $end_page < $page && $end_page < $total - 2 ) )
                )
            {
                $omission = 1;
                next;
            }
            if ($omission) {
                print '<li class="omission">...</li>';
                $omission = 0;
            }
            if ( $page == $pnum ) {
                print '<li class="here">' . $page . '</li>';
            }
            else {
                print '<li><a href="'
                    . $url
                    . (
                    ( $page && $page > 1 )
                    ? $this->amp_escape(
                        $this->add_query( 'url', { 'p' => ( $page - 1 ) } )
                        )
                    : ''
                    )
                    . '">'
                    . $page
                    . '</a></li>';
            }
        }
    }
    if ( $count >= 1 && $count > $to ) {
        print '<li class="next">';
        if ($form_flag) {
            print $cgi::Deco->submit_button(
                'next',
                $setting::page{'nextButton'},
                ( ($default::english) ? 'Next' : '次のページ' ),
                '', { 'p' => $next }
            );
        }
        else {
            print $cgi::Deco->button(
                'next',
                $setting::page{'nextButton'},
                $url . $this->add_query( 'url', { 'p' => $next } ),
                ( ($default::english) ? 'Next' : '次のページ' )
            );
        }
        print '</li>';
    }

    print '</ul>';
    print '</form>' if $form_flag;
}

######################################################################
# 戻るリンク
sub print_return_button ($) {
    my $this = shift;
    if ( defined $setting::page{'returnUrl'}
        && $setting::page{'returnUrl'} ne '' )
    {
        print '<div class="baobab-index-return">';
        print $cgi::Deco->button(
            'return',
            $setting::page{'returnButton'},
            $setting::page{'returnUrl'},
            ( ($default::english) ? 'Return' : '戻る' )
        );
        print '</div>';
    }
}

######################################################################
#	テンプレート変換
sub template_deco ($$) {
    my ( $this, $template ) = @_;

    # フレーム変換
    if ( $template =~ /<!--frame(?![0-9a-zA-Z_])([^>]*)-->/ ) {
        require CMONOS::CGI_Lib::Frame;
        my $frame = Frame->new;
        $template
            = $frame->text_to_frame( $template, 'no', $frame::obj{'frame'} );
    }
    return $template;
}

######################################################################
# クラス登録
#sub import {
BEGIN {
    no warnings qw(once);
    if (   defined $default::subdivided
        && $default::subdivided
        && ( !defined $main::c || $main::c eq '' ) )
    {

        #設定DB読み込み設定
        $setting::general  = 1;    #一般設定読み込み
        $setting::deco     = 1;    #テキスト装飾設定読み込み
        $setting::security = 1;    #アクセス権設定読み込み
        $setting::table    = 1;    #テーブル設定読み込み
        $setting::page     = 1;    #ページ設定読み込み

        #クッキー
        $cookie::id_enabled = 1;    #ID情報クッキー読み込み

        #設定種キー設定
        $setting::security_key
            = 'index';              #デフォルトセキュリティキー
        $setting::key = 'index';    #ページ設定キー

        #デフォルトキー
        $main::k = 'index' if !defined $main::k || !$main::k;

        #クラス登録
        Common::class_register( 'index', 'Index' );
        @setting::form = ( 'm', 'k', 'target', 'search', 'sort' );

        #イメージCSS
        $setting::image_css = 'baobab-image.css';

    }
    else {
        $main::m = $default::m = 'Viewer';
        $main::k = $default::k = 'viewer';
        require CMONOS::Baobab::Viewer;
    }
}

1;
