package Viewer;
require CMONOS::Baobab::BbCommon;
@ISA = qw(BbCommon);
use strict;
use utf8;
######################################################################
# バオバブ記事表示モジュール
# Viewer.pm ver1.1.7
# Copyright (C) 1999-2018 CMONOS Co. Ltd.
#
# support@cmonos.jp
# http://cmonos.jp/
# 最終更新日：2016-06-27
######################################################################
# 実行
sub run ($;$) {
    my ( $this, $output ) = @_;
    my ( $v, %db, %match, %sort, $sort_db );

    #デフォルト表示形式
    $this->import_db( $default::preference_dir . '/page',
        \%setting::page, 1, 'article' )
        if !ref $setting::page{'article'};
    if ( !defined $main::v || $main::v eq '' ) {
        $main::v = $setting::page{'article'}{'defaultView'};
        eval 'ViewSelector::set_my_type($main::v,$main::n)';
        eval 'ThreadCategory::set_my_type($main::v,$main::k)';
        eval 'ThreadStatus::set_my_type($main::v,$main::k)';
        eval 'BbGrader::set_my_type($main::v,$main::k)';
    }
    if ($output) {
        $this->set_canonical(
            $this->my_url
                . (
                ( defined $main::c && $main::c ne '' )
                ? '?c=' . $main::c
                : ''
                )
        );
        $this->set_og_cgi_summary;
        $v = $setting::page{'article'}{'defaultView'};
    }
    else {
        $v = $main::v;
        if (   defined $main::n
            && $main::n ne ''
            && ( !$default::subdivided
                || ( defined $main::c && $main::c ne '' ) )
            && $v eq 'listarticle'
            )
        {
            my $url;
            if ( $default::subdivided && defined $main::c && $main::c ne '' )
            {
                $url
                    = $this->my_url . '?c='
                    . $main::c . '&n='
                    . $main::n
                    . '&v=listarticle';
            }
            else {
                $url = $this->my_url . '?n=' . $main::n . '&v=listarticle';
            }
            $this->set_canonical($url);
        }
        elsif (
               defined $main::t
            && $main::t ne ''
            && ( !$default::subdivided
                || ( defined $main::c && $main::c ne '' ) )
            && $v eq 'listthread'
            )
        {
            my $url;
            if ( $default::subdivided && defined $main::c && $main::c ne '' )
            {
                $url
                    = $this->my_url . '?c='
                    . $main::c
                    . (
                    (          defined $main::n
                            && $main::n ne ''
                            && $main::n ne $main::t
                    ) ? '&n=' . $main::n : ''
                    )
                    . '&t='
                    . $main::t
                    . '&v=listthread';
            }
            elsif (defined $main::n
                && $main::n ne ''
                && $main::n ne $main::t )
            {
                $url
                    = $this->my_url . '?n='
                    . $main::n . '&t='
                    . $main::t
                    . '&v=listthread';
            }
            else {
                $url = $this->my_url . '?t=' . $main::t . '&v=listthread';
            }
            $this->set_canonical($url);
        }
        else {
            $this->set_og_url(
                $this->my_url
                    . (
                    ( defined $main::c && $main::c ne '' )
                    ? '?c=' . $main::c
                    : ''
                    )
            );
            $this->set_og_cgi_summary;
        }
    }

    #検索ページ
    if ( $v eq 'listsearch' ) {
        $this->print_article_list( $output, \%db, $this->view_object($v) );
        return;
    }

    use Fcntl qw(:DEFAULT :flock);
    eval 'use ' . $env::dbm_file . ';';
    tie(%{ $db{'thread_category'} },
        $env::dbm_file, "$default::db/thread_category",
        O_RDONLY, $env::dbm_mode
    ) if $field::for{'category'};
    tie( %{ $db{'thread_status'} },
        $env::dbm_file, "$default::db/thread_status", O_RDONLY,
        $env::dbm_mode )
        if $field::for{'status'};
    tie(%{ $db{'tree'} }, $env::dbm_file, "$default::db/tree",
        O_RDONLY,         $env::dbm_mode
    );

    if ($output) {
        eval 'ViewSelector::set_my_type($v)';
        eval 'ThreadCategory::set_my_type($v)';
        eval 'ThreadStatus::set_my_type($v)';
        eval 'BbGrader::set_my_type($v)';
        $this->{'original_k'}   = $main::k;
        $this->{'original_m'}   = $main::m;
        $this->{'original_v'}   = $main::v;
        $this->{'original_s'}   = $main::s;
        $this->{'original_w'}   = $main::w;
        $this->{'original_p'}   = $main::p;
        $this->{'original_key'} = $setting::key;
        $main::k                = 'viewer';
        $main::m                = 'Viewer';
        $main::v                = $v;
        undef $main::s;
        undef $main::w;
        undef $main::p;
        $setting::key = 'article';
    }
    else {
        if ( !defined $main::q || $main::q eq '' ) {
            @setting::form  = grep( $_ ne 'q', @setting::form );
            @setting::form1 = grep( $_ ne 'q', @setting::form1 );
        }
        if (   !defined $main::s
            || $main::s eq ''
            || $main::s eq ( $field::for{'sort'} || 'thread_mtime' ) )
        {
            @setting::form  = grep( $_ ne 's', @setting::form );
            @setting::form1 = grep( $_ ne 's', @setting::form1 );
        }
        if (   !defined $main::w
            || $main::w eq ''
            || $main::w eq ( $field::SORTORDER || 'descend' ) )
        {
            @setting::form  = grep( $_ ne 'w', @setting::form );
            @setting::form1 = grep( $_ ne 'w', @setting::form1 );
        }
        if (%main::search) {
            my %delete;
            my @delete_ids;
            while ( my ( $id, $hash ) = each %main::search ) {
                my $count = 0;
                while ( my ( $k, $v ) = each %$hash ) {
                    if ( defined $v
                        && ( ( ref $v && @$v ) || ( !ref $v && $v ne '' ) ) )
                    {
                        $count++;
                    }
                    else {
                        $delete{$id} = $k;
                    }
                }
                if ( $count && $count == 1 && $main::search{$id}{'mode'} ) {
                    $delete{$id} = 'mode';
                    $count = 0;
                }
                push( @delete_ids, $id ) if !$count;
            }
            while ( my ( $id, $name ) = each %delete ) {
                delete $main::search{$id}{$name};
            }
            foreach my $id (@delete_ids) {
                delete $main::search{$id};
            }
            undef %main::search if !%main::search;
        }
        if ( !%main::search ) {
            @setting::form
                = grep( $_ ne 'search' && $_ ne 'and', @setting::form );
            @setting::form1
                = grep( $_ ne 'search' && $_ ne 'and', @setting::form1 );
        }
    }

    #ソート
    $main::s = ( $field::for{'sort'} ) ? $field::for{'sort'} : 'thread_mtime'
        if !defined $main::s || $main::s eq '';
    if ( $main::s eq 'thread_mtime' || $main::s eq 'thread_ctime' ) {
        $sort_db = $main::s;
    }
    elsif (ref $field::obj{$main::s}
        && $field::obj{$main::s}->sort_enabled
        && $field::obj{$main::s}->{'sortEnabled'}
        && ( $field::obj{$main::s}->{'Open'} || $this->is_secure('secret') ) )
    {
        $sort_db = $field::obj{$main::s}->db;
        $sort_db = 'thread_mtime' if !defined $sort_db || !$sort_db;
    }
    else {
        $main::s = $sort_db = 'thread_mtime';
    }
    unless ( ref tied %{ $db{$sort_db} } ) {
        tie( %{ $db{$sort_db} },
            $env::dbm_file, "$default::db/$sort_db", O_RDONLY,
            $env::dbm_mode );
    }

    $this->set_last_modified( $setting::general{'mtime'} )
        if $setting::general{'lastModifiedHeaderEnabled'};
    if ( !$output ) {

        #---------------------------------------------------------------------
        #承認待ち項目警告
        $this->set_pending_item_alert
            if !defined $main::s && $this->is_secure('tools');

        #---------------------------------------------------------------------
        #特殊フィールド処理
        $field::obj{$main::id}->update
            if defined $main::id
            && $main::id ne ''
            && defined $main::n
            && $main::n ne ''
            && ref $field::obj{$main::id}
            && $field::obj{$main::id}->update_enabled
            && $field::obj{$main::id}->is_secure_user_for_update;

        #---------------------------------------------------------------------
        #ターゲットが確定している場合
        if ( $main::n || $main::t ) {
            my ( $top, $is_secure );
            if ( defined $main::n && $main::n ne '' ) {
                $top = $this->get_top(
                    $main::n,
                    $this->decode_utf8(
                        $db{'tree'}->{ $this->encode_utf8($main::n) }
                    )
                );
            }
            else {
                $top = $main::t;
            }

            #スレッドカテゴリーチェック
            if ( $field::for{'category'} && %{ $thread::category{'ORDER'} } )
            {
                my $category = $this->decode_utf8(
                    $db{'thread_category'}->{ $this->encode_utf8($top) } );
                $is_secure = 1
                    if !defined $category
                    || !ref $thread::category{$category}
                    || !$thread::category{$category}{'closed'}
                    || $this->is_secure('closed');
            }
            else {
                $is_secure = 1;
            }

            if ($is_secure) {
                my (@list);
                if ( $main::n && $v eq 'listarticle' ) {
                    if ( $setting::general{'lastModifiedHeaderEnabled'} ) {
                        if ( !ref tied %{ $db{'mtime'} } ) {
                            tie(%{ $db{'mtime'} },    $env::dbm_file,
                                "$default::db/mtime", O_RDONLY,
                                $env::dbm_mode
                            );
                        }
                        $this->set_last_modified(
                            $this->decode_utf8(
                                $db{'mtime'}->{ $this->encode_utf8($main::n) }
                            )
                        );
                    }
                    @list = ($main::n) ? ($main::n) : ();
                    $this->set_page_title( \%db, $main::n );
                    $this->set_ogp( \%db, $main::n );
                    $this->print_article_list( '', \%db,
                        $this->view_object($v),
                        \@list, $main::t, $main::n, $v );
                    return;
                }
                elsif ( defined $main::t && $main::t ) {
                    $v = 'listthread' if $v eq 'listarticle';
                    $main::t = $top;
                    if ( $setting::general{'lastModifiedHeaderEnabled'} ) {
                        if ( !ref tied %{ $db{'thread_mtime'} } ) {
                            tie(%{ $db{'thread_mtime'} },    $env::dbm_file,
                                "$default::db/thread_mtime", O_RDONLY,
                                $env::dbm_mode
                            );
                        }
                        $this->set_last_modified(
                            $this->decode_utf8(
                                $db{'thread_mtime'}
                                    ->{ $this->encode_utf8($top) }
                            )
                        );
                    }
                    @list = ($main::t) ? ($main::t) : ();
                    $this->set_page_title( \%db, $top );
                    $this->print_article_list( '', \%db,
                        $this->view_object($v),
                        \@list, $main::t, $main::n, $v );
                    return;
                }
                elsif ( $v eq 'list' ) {
                    $main::t = $top;
                }
            }
        }

        #---------------------------------------------------------------------
        #検索
        my @q = $this->make_patterns( \$main::q, 1 );
        my @fields = keys %field::obj;
        foreach my $id (@fields) {
            if (ref $field::obj{$id}
                && ($field::obj{$id}->match_enabled
                    || (   @q
                        && $field::obj{$id}->{'class'}
                        =~ /^(?:text|num|addr_|select_(?!image)|ysc_)/ )
                )
                && (   $field::obj{$id}->{'Open'}
                    || $this->is_secure('secret') )
                )
            {
                $this->{'is_searched'} = 1;
                last;
            }
        }
        if ( $this->{'is_searched'} ) {
        THREAD:
            while ( my ( $no, $info ) = each %{ $db{'tree'} } ) {
                utf8::decode($no)   if !utf8::is_utf8($no);
                utf8::decode($info) if !utf8::is_utf8($info);
                my $top = $this->get_top( $no, $info );

                #スレッドカテゴリーチェック
                if ( $field::for{'category'}
                    && %{ $thread::category{'ORDER'} } )
                {
                    my $category
                        = $this->decode_utf8(
                        $db{'thread_category'}->{ $this->encode_utf8($top) }
                        );
                    next THREAD
                        if defined $category
                        && ref $thread::category{$category}
                        && $thread::category{$category}{'closed'}
                        && !$this->is_secure('closed');
                    next THREAD
                        if $main::tc
                        && defined $category
                        && ref $thread::category{$category}
                        && $thread::category{$category}{'ORDER'}
                        && $main::tc ne $category;
                }

                #スレッド状態チェック
                next THREAD
                    if $field::for{'status'}
                    && $main::st
                    && $this->decode_utf8(
                    $db{'thread_status'}->{ $this->encode_utf8($top) } ) ne
                    $main::st;

                my $matched   = 0;
                my $q_matched = 0;
                my $text      = '';

            SEARCH:
                foreach my $id (@fields) {
                    next SEARCH
                        if !$field::obj{$id}->{'searchEnabled'}
                        || ( !$field::obj{$id}->match_enabled
                        && (   !@q
                            || !$field::obj{$id}->format_for_text_enabled ) );
                    my ( $db, $thread_flag );
                    $db = $field::obj{$id}->db;
                    next SEARCH if !defined $db || !$db;

             #検索実行フラグ/スレッド関連フィールドフラグ
                    $thread_flag = 1 if $db =~ /^thread/;

                    unless ( ref tied %{ $db{$db} } ) {
                        tie( %{ $db{$db} },
                            $env::dbm_file, "$default::db/$db", O_RDONLY,
                            $env::dbm_mode );
                    }
                    my $dat
                        = ($thread_flag)
                        ? $this->decode_utf8(
                        $db{$db}->{ $this->encode_utf8($top) } )
                        : $this->decode_utf8(
                        $db{$db}->{ $this->encode_utf8($no) } );
                    $dat = '' if !defined $dat;
                    if ( $field::obj{$id}->match_enabled ) {
                        $this->{'is_searched_full'} = 1;
                        if ( $field::obj{$id}->match( \$dat ) ) {
                            $matched++;
                        }
                        elsif ($main::and) {
                            $matched = $q_matched = 0;
                            last SEARCH;
                        }
                    }
                    if ( @q && $field::obj{$id}->format_for_text_enabled ) {
                        $text .= ( ($text) ? "\x0A" : '' )
                            . $field::obj{$id}->format_for_text($dat);
                    }
                }
                if ( $text && @q ) {
                    $q_matched
                        = $this->pattern_matched( \$text, \@q, 1, 'and', 1 );
                }
                if (   ( !$this->{'is_searched_full'} || $matched )
                    && ( !@q || $q_matched ) )
                {
                    if ( $v eq 'listarticle' ) {
                        $match{$no} += $matched + $q_matched;
                        $sort{$no}
                            = ( ref $field::obj{$main::s} )
                            ? $field::obj{$main::s}->sample(
                            $this->decode_utf8(
                                $db{$sort_db}->{ $this->encode_utf8($no) }
                            )
                            )
                            : $this->decode_utf8(
                            $db{$sort_db}->{ $this->encode_utf8($no) } );
                    }
                    elsif ($top) {
                        if ( $no ne $top ) {
                            $match{$top} += $matched + $q_matched;
                            delete $match{$no};
                        }
                        $sort{$top}
                            = ( ref $field::obj{$main::s} )
                            ? $field::obj{$main::s}->sample(
                            $this->decode_utf8(
                                $db{$sort_db}->{ $this->encode_utf8($top) }
                            )
                            )
                            : $this->decode_utf8(
                            $db{$sort_db}->{ $this->encode_utf8($top) } );
                    }
                }
            }
        }
    }

    #---------------------------------------------------------------------
    #検索あり
    if ( $this->{'is_searched'} ) {
        $this->push_window_title(
            ($default::english) ? 'Search Results' : '検索結果' );

        #検索無し
    }
    else {
        my $thread_flag = 1 if $sort_db =~ /^thread/;
        while ( my ( $no, $info ) = each %{ $db{'tree'} } ) {
            my $top = $this->get_top( $no, $info );
            next if $v ne 'listarticle' && $top ne $no;

            #スレッドカテゴリーチェック
            if ( $field::for{'category'} && %{ $thread::category{'ORDER'} } )
            {
                my $category = $this->decode_utf8(
                    $db{'thread_category'}->{ $this->encode_utf8($top) } );
                next
                    if defined $category
                    && ref $thread::category{$category}
                    && $thread::category{$category}{'closed'}
                    && !$this->is_secure('closed');
                next
                    if $main::tc
                    && defined $category
                    && ref $thread::category{$category}
                    && $thread::category{$category}{'ORDER'}
                    && $main::tc ne $category;
            }

            #スレッド状態チェック
            next
                if $field::for{'status'}
                && $main::st
                && $this->decode_utf8(
                $db{'thread_status'}->{ $this->encode_utf8($top) } ) ne
                $main::st;

            $sort{$no}
                = ($thread_flag)
                ? ( ref $field::obj{$main::s} )
                    ? $field::obj{$main::s}->sample(
                        $this->decode_utf8(
                            $db{$sort_db}->{ $this->encode_utf8($top) }
                        )
                    )
                    : $this->decode_utf8(
                        $db{$sort_db}->{ $this->encode_utf8($top) } )
                : ( ref $field::obj{$main::s} )
                ? $field::obj{$main::s}->sample(
                $this->decode_utf8(
                    $db{$sort_db}->{ $this->encode_utf8($no) }
                )
                )
                : $this->decode_utf8(
                $db{$sort_db}->{ $this->encode_utf8($no) } );
        }
    }

    #表示件数＆ソート調整
    if ( !defined $main::w || $main::w eq '' ) {
        $main::w = ($field::SORTORDER) ? $field::SORTORDER : 'descend';
    }

    #表示記事リスト
    my @list = sort {
               $this->sort_by( \$match{$b}, \$match{$a} )
            || $this->sort_by( \$sort{$a}, \$sort{$b}, $main::w )
            || $this->sort_by( \$a,        \$b,        $main::w )
    } keys %sort;

    #---------------------------------------------------------------------
    #書き出し
    $this->print_article_list( $output, \%db, $this->view_object($v),
        \@list, $main::t, $main::n, $v );

    if ( defined $output && $output ) {
        undef $cgi::output;
        undef $cgi::output_option;
        $this->use_icon( 'baobab', 'bb_icon' );
        $this->use_deco();
        $setting::key = $this->{'original_key'};
        $main::k      = $this->{'original_k'};
        $main::m      = $this->{'original_m'};
        $main::v      = $this->{'original_v'};
        $main::s      = $this->{'original_s'};
        $main::w      = $this->{'original_w'};
        $main::p      = $this->{'original_p'};
        eval 'ViewSelector::set_my_type($main::v,$main::n)';
        eval 'ThreadCategory::set_my_type($main::v,$main::k)';
        eval 'ThreadStatus::set_my_type($main::v,$main::k)';
        eval 'BbGrader::set_my_type($main::v,$main::k)';
        delete $this->{'is_searched'};
        delete $this->{'original_k'};
        delete $this->{'original_m'};
        delete $this->{'original_v'};
        delete $this->{'original_s'};
        delete $this->{'original_w'};
        delete $this->{'original_key'};
    }
}

sub set_page_title ($$$) {
    my ( $this, $database, $n ) = @_;
    my ($title);
    if ( $field::for{'title'} eq ''
        || !ref $field::obj{ $field::for{'title'} } )
    {
        $title = ($default::english) ? 'Article' : '記事';
    }
    else {
        my $db = $field::obj{ $field::for{'title'} }->db;
        unless ( ref tied %{ $database->{$db} } ) {
            tie(%{ $database->{$db} }, $env::dbm_file,
                "$default::db/$db",    O_RDONLY,
                $env::dbm_mode
            );
        }
        $title = $field::obj{ $field::for{'title'} }->usual_format(
            $this->decode_utf8(
                $database->{$db}->{ $this->encode_utf8($n) }
            )
        );
    }
    $this->push_window_title($title);
}

sub set_ogp ($$$) {
    my ( $this, $database, $n ) = @_;
    my ( $db, $image_url );
    if ( $field::for{'content'} && ref $field::obj{ $field::for{'content'} } )
    {
        my $db = $field::obj{ $field::for{'content'} }->db;
        unless ( ref tied %{ $database->{$db} } ) {
            tie(%{ $database->{$db} }, $env::dbm_file,
                "$default::db/$db",    O_RDONLY,
                $env::dbm_mode
            );
        }
        $this->set_description(
            $field::obj{ $field::for{'content'} }->format_for_text(
                $this->decode_utf8(
                    $database->{$db}->{ $this->encode_utf8($n) }
                )
            )
        );
    }
    if ( $field::for{'media'} && ref $field::obj{ $field::for{'media'} } ) {
        my $db = $field::obj{ $field::for{'media'} }->db;
        unless ( ref tied %{ $database->{$db} } ) {
            tie(%{ $database->{$db} }, $env::dbm_file,
                "$default::db/$db",    O_RDONLY,
                $env::dbm_mode
            );
        }
        $image_url = $field::obj{ $field::for{'media'} }->image_file_url(
            $this->decode_utf8(
                $database->{$db}->{ $this->encode_utf8($n) }
            ),
            $default::file . '/' . $n,
            $main::c, $n,
            $database
        );
    }
    if (  !$image_url
        && $field::for{'media2'}
        && ref $field::obj{ $field::for{'media2'} } )
    {
        my $db = $field::obj{ $field::for{'media2'} }->db;
        unless ( ref tied %{ $database->{$db} } ) {
            tie(%{ $database->{$db} }, $env::dbm_file,
                "$default::db/$db",    O_RDONLY,
                $env::dbm_mode
            );
        }
        $image_url = $field::obj{ $field::for{'media2'} }->image_file_url(
            $this->decode_utf8(
                $database->{$db}->{ $this->encode_utf8($n) }
            ),
            $default::file . '/' . $n,
            $main::c, $n,
            $database
        );
    }
    if (  !$image_url
        && $field::for{'media3'}
        && ref $field::obj{ $field::for{'media3'} } )
    {
        my $db = $field::obj{ $field::for{'media3'} }->db;
        unless ( ref tied %{ $database->{$db} } ) {
            tie(%{ $database->{$db} }, $env::dbm_file,
                "$default::db/$db",    O_RDONLY,
                $env::dbm_mode
            );
        }
        $image_url = $field::obj{ $field::for{'media3'} }->image_file_url(
            $this->decode_utf8(
                $database->{$db}->{ $this->encode_utf8($n) }
            ),
            $default::file . '/' . $n,
            $main::c, $n,
            $database
        );
    }
    $this->set_og_image($image_url);
    if ( $field::for{'coordinates'}
        && ref $field::obj{ $field::for{'coordinates'} } )
    {
        my $db = $field::obj{ $field::for{'coordinates'} }->db;
        unless ( ref tied %{ $database->{$db} } ) {
            tie(%{ $database->{$db} }, $env::dbm_file,
                "$default::db/$db",    O_RDONLY,
                $env::dbm_mode
            );
        }
        $this->set_og_latlng(
            $field::obj{ $field::for{'coordinates'} }->get_latlng(
                $this->decode_utf8(
                    $database->{$db}->{ $this->encode_utf8($n) }
                ),
                $default::file . '/' . $n,
                $main::c, $n,
                $database
            )
        );
    }
}

sub view_object ($$) {
    my ( $this, $v ) = @_;
    my ($this_view);
    $v = $setting::page{'article'}{'defaultView'} if !defined $v || !$v;
    if ( defined $v && $v eq 'listtree' ) {
        require CMONOS::Baobab::BbTree;
        $this_view = BbTree->new;
    }
    elsif ( defined $v && $v eq 'listarticle' ) {
        require CMONOS::Baobab::BbArticle;
        $this_view = BbArticle->new;
    }
    elsif ( defined $v && $v eq 'listthread' ) {
        require CMONOS::Baobab::BbThread;
        $this_view = BbThread->new;
    }
    elsif ( defined $v && $v eq 'listsearch' ) {
        require CMONOS::Baobab::BbSearch;
        $this_view = BbSearch->new;
    }
    else {
        require CMONOS::Baobab::BbList;
        $this_view = BbList->new;
    }
    return $this_view;
}

######################################################################
# 出力ひな型
sub print_article_list ($;$$$$$) {
    my ( $this, $output, $database, $this_view, $list, $t, $n, $v ) = @_;
    my ( $opened, $p );
    local (*OUT);
    if ( defined $output && $output ) {
        undef $n;
        undef $t;
        if ( open( OUT, ">>$output" ) ) {
            binmode OUT, ":utf8";
            flock( OUT, LOCK_EX );
            truncate( OUT, 0 );
            seek( OUT, 0, 0 );
            $opened      = 1;
            $cgi::output = $output;

        }
        else {
            push(
                @{ $cgi::action->{'dialog'} },
                'ファイルの書き込みに失敗しました。'
            ) if ref $cgi::action;
            return 0;
        }
    }
    else {
        *OUT     = *STDOUT;
        $main::p = $main::pnum - 1
            if $main::pnum && !$this->is_nan($main::pnum);
        $p
            = ( $main::p && !$this->is_nan($main::p) && $main::p > 0 )
            ? $main::p
            : 0;
    }
    $this->use_icon( 'baobab', 'bb_icon', $output );
    $this->use_deco($output);

    #ページセッティング
    $this->set_css( $this_view->css($list) );

    #必要なDBを読み込む
    $this->tie_db( $database, $this_view->required_fields );

    #ページ数判定
    $p = $this_view->list_count( $output, $database, $list, $p, $t, $n );

    #前後ページ登録
    $this->set_related_links( $output, $p,
        $setting::page{$setting::key}{'articleLimit'},
        $this_view->{'count'}, $this_view->is_list );

    #ヘッダ
    $this->print_page_header( $setting::key, \*OUT, $output );

    #アイコン
    $this->print_tool_button( \*OUT, $output, 'top', $n )
        if $setting::page{$setting::key}{'headIcon'};

    #記事ヘッダ
    $this_view->print_list_header( \*OUT, $output, $p );

    #記事リスト
    $this_view->print_articles( \*OUT, $output, $database, $list, $p );

    #記事フッタ
    $this_view->print_list_footer( \*OUT, $output, $p );

    #投稿フォーム
    $this_view->print_input_form( \*OUT, $output, $database, $t, $n, $v )
        if $setting::page{$setting::key}{'formEnabled'} && !$output;

    #DBの接続を解除する
    $this->untie_db($database);

    #アイコン
    $this->print_tool_button( \*OUT, $output, 'bottom', $n )
        if $setting::page{$setting::key}{'footIcon'};

    #戻る
    $this->print_return_button( \*OUT, $output, $list, $t, $n, $v );

    #フッタ
    $this->print_page_footer( $setting::key, \*OUT, $output );

    close(OUT) if $opened;
}

######################################################################
# 前後ページへのリンク
sub set_related_links ($$$$$) {
    my ( $this, $output, $p, $u, $count, $is_list ) = @_;
    $this->set_link_rel( { 'index' => { 'href' => $cgi::path } } );
    return if !$count || $u > $count;
    $p = 0 if !$p;
    my @form = ();
    if ( defined $output && $output ) {
        push( @form, @setting::form0, 'v' );
    }
    elsif ($is_list) {
        push( @form, @setting::form, 'v' );
    }
    else {
        push( @form, @setting::form, 'v', 't' );
    }
    my $url
        = $cgi::path . $this->amp_escape( $this->set_query( 'url', \@form ) );
    if ($p) {
        $this->set_link_rel( { 'start' => { 'href' => $url } } );
        $this->set_link_rel(
            {   'prev' => {
                    'href' => $url
                        . $this->amp_escape(
                        $this->add_query( 'url', { 'p' => ( $p - 1 ) } )
                        )
                }
            }
        );
    }
    if ( $count && $count > $u * ( $p + 1 ) ) {
        $this->set_link_rel(
            {   'next' => {
                    'href' => $url
                        . $this->amp_escape(
                        $this->add_query( 'url', { 'p' => ( $p + 1 ) } )
                        )
                }
            }
        );
    }
}

######################################################################
# アイコンの表示
sub print_tool_button ($$;$$$) {
    my ( $this, $handle, $output, $name, $n ) = @_;
    my ( $url, $viewform_flag, $query );
    if ( defined $setting::page{$setting::key}{'viewSwitch'}
        && $setting::page{$setting::key}{'viewSwitch'} )
    {
        my @form
            = grep( $_ ne 'q' && $_ ne 'n' && $_ ne 't', @setting::form1 );
        if (   $setting::page{$setting::key}{'sortMenu'}
            || $setting::page{$setting::key}{'searchbox'}
            || ( !$output && $setting::general{'postMethod'} ) )
        {
            @form = grep( $_ ne 's' && $_ ne 'w', @form )
                if $setting::page{$setting::key}{'sortMenu'};
            if ( defined $output && $output ) {
                print $handle $this->form_start(
                    'key'           => 'browse',
                    'authorization' => 'disabled',
                    'name'          => 'view_' . $name
                );
                print $handle '<input type="hidden" name="c" value="'
                    . $this->escape($main::c) . '" />'
                    if defined $main::c && $main::c ne '';
            }
            else {
                print $handle $this->form_start(
                    'key'      => 'browse',
                    'name'     => 'view_' . $name,
                    'required' => \@form
                );
            }
            print $handle $this->add_query( 'post',
                { 'm' => 'Viewer', 'k' => 'viewer' } );
            $viewform_flag = 1;
        }
        else {
            $url = $cgi::path;
            $url .= $this->amp_escape( $this->set_query( 'url', \@form ) )
                if !$output;
        }
        undef @form;
        print $handle '<ul class="tools panel" id="view-selector-' . $name
            . '">';
        if ( $setting::page{$setting::key}{'searchbox'} ) {
            print $handle '<li><input type="search" placeholder="'
                . ( ( $this->{'is_searched_full'} ) ? '絞り込み検索'
                : '検索' )
                . '" results="5" autosave="'
                . ( ($default::id) ? $default::id : 'baobab' )
                . '" name="q" size="16" value="'
                . $this->escape($main::q)
                . '" title="'
                . ( ( $this->{'is_searched_full'} )
                ? '検索キーワードでさらに絞り込みます。'
                : '検索キーワード' )
                . '" onkeypress="if((event.keyCode || event.charCode)==13){this.name=\'v='
                . $main::v
                . '&amp;q=%03\';submit();return false}" /></li>';
        }

        # 再ソートメニュー
        if ( defined $setting::page{$setting::key}{'sortMenu'}
            && $setting::page{$setting::key}{'sortMenu'} )
        {
            $this->print_sort_menu($handle);
        }

        # 表示切り替えボタン

        # テーブル表示
        print $handle $this->view_switch_button( 'list',
            'テーブル表示', $url, { 'v' => 'list' },
            '', '', '', ( ( $main::v && $main::v eq 'list' ) ? 1 : 0 ) );

        if ( $this->tree_enabled ) {

            # ツリー表示
            print $handle $this->view_switch_button(
                'listtree',
                'ツリー表示',
                $url,
                { 'v' => 'listtree' },
                '',
                '',
                '',
                ( ( $main::v && $main::v eq 'listtree' ) ? 1 : 0 )
            );

            # 記事スレッド表示
            print $handle $this->view_switch_button(
                'listthread',
                '記事スレッド表示',
                $url,
                { 'v' => 'listthread' },
                '',
                '',
                '',
                ( ( $main::v && $main::v eq 'listthread' ) ? 1 : 0 )
            );
        }

        # 記事表示
        print $handle $this->view_switch_button( 'listarticle',
            '記事表示', $url, { 'v' => 'listarticle' },
            '', '', '',
            ( ( $main::v && $main::v eq 'listarticle' ) ? 1 : 0 ) );

        # 検索条件をリセット
        if ( $this->{'is_searched'} ) {
            print $handle $this->view_switch_button(
                'listreset',
                '検索条件をリセット',
                $cgi::path
                    . $this->set_query(
                    'url',
                    [   grep( $_ ne 'q' && $_ ne 'search' && $_ ne 'and',
                            @setting::form ),
                        'v'
                    ]
                    ),
                '',
                'group-start',
            );
        }

        # 検索
        print $handle $this->view_switch_button(
            'listsearch',
            '記事検索',
            $url,
            { 'v' => 'listsearch' },
            'group-start',
            '',
            '',
            ( ( $main::v && $main::v eq 'listsearch' ) ? 1 : 0 )
        );

    }
    else {
        print $handle '<ul class="tools" id="view-selector-' . $name . '">';
    }

    # 新規投稿
    if ((     !$output
            || $setting::security{'inputthread'}{'passwordCheck'} eq 'nocheck'
        )
        && $this->is_secure('inputthread')
        )
    {
        my ( %query, $url );
        $url = $cgi::path . '?k=editor&amp;m=Editor';
        if ( defined $output && $output ) {
            $url .= '&amp;c=' . $main::c
                if defined $main::c && $main::c ne '';
            %query = ();
        }
        else {
            $url .= $this->amp_escape(
                $this->set_query( 'url+', \@setting::form1 ) );
            %query = ( 'v' => $main::v );
        }
        print $handle $this->view_switch_button( 'input', '新規投稿',
            $url, \%query, 'group-start',
            "cmonos.window.open('articleEditor',640,480)",
            'articleEditor', );
    }

    # ツール
    if ( !$output && $this->is_secure('tools') ) {
        print $handle $this->view_switch_button(
            'tool',
            '環境設定を開く',
            $cgi::path
                . '?m=Tools'
                . ( ( defined $main::c ) ? '&amp;c=' . $main::c : '' ),
            '',
            'group-start'
        );
    }

    # パスワード操作
    if ( defined $setting::page{$setting::key}{'pswdIcon'}
        && $setting::page{$setting::key}{'pswdIcon'} )
    {
        print $handle $this->view_switch_button(
            'toolpassword',
            'ログイン',
            $env::register_cgi . '?k=pswd&amp;m=Password',
            '',
            'group-start',
            (     ($env::register_in_same_window)
                ? ()
                : ( "cmonos.window.open('LoginWindow',450,300)",
                    'LoginWindow',
                )
            ),
        );
    }

    print $handle '</ul>';
    print $handle '</form>' if defined $viewform_flag && $viewform_flag;
}

sub print_sort_menu ($$$) {
    my ( $this, $handle ) = @_;
    my $s
        = ( defined $main::s && $main::s ne '' ) ? $main::s
        : ( $field::for{'sort'} ) ? $field::for{'sort'}
        :                           'thread_mtime';
    my $w
        = ( defined $main::w && $main::w ne '' ) ? $main::w
        : ($field::SORTORDER) ? $field::SORTORDER
        :                       'descend';
    print $handle
        '<li class="group-end"><select name="s" title="ソート(並べ替え)項目">';
    print $handle '<option value="thread_mtime"'
        . (
        (   $s eq 'thread_mtime'
                || ( ref $field::obj{$s}
                && $field::obj{$s}->{'timetype'}
                && $field::obj{$s}->{'timetype'} eq 'thread_mtime' )
        ) ? ' selected="selected"' : ''
        )
        . '>'
        . ( ( $this->tree_enabled ) ? 'スレッド' : '' )
        . '更新時</option>';
    print $handle '<option value="thread_ctime"'
        . (
        (   $s eq 'thread_ctime'
                || ( ref $field::obj{$s}
                && $field::obj{$s}->{'timetype'}
                && $field::obj{$s}->{'timetype'} eq 'thread_ctime' )
        ) ? ' selected="selected"' : ''
        )
        . '>'
        . ( ( $this->tree_enabled ) ? 'スレッド' : '' )
        . '作成時</option>';
    foreach ( sort { $a <=> $b } keys %field::ORDER ) {
        next
            unless ref $field::obj{ $field::ORDER{$_} }
            && $field::obj{ $field::ORDER{$_} }->sort_enabled
            && $field::obj{ $field::ORDER{$_} }->{'sortEnabled'}
            && $field::obj{ $field::ORDER{$_} }->{'class'} ne
            'xbb_threadxtime';
        print $handle '<option value="'
            . $field::ORDER{$_} . '"'
            . ( ( $s eq $field::ORDER{$_} ) ? ' selected="selected"' : '' )
            . '>'
            . $field::obj{ $field::ORDER{$_} }->name
            . '</option>';
    }
    print $handle '</select>';
    print $handle '<select name="w" title="ソート(並べ替え)方法">';
    print $handle '<option value="descend"'
        . ( ( $w eq 'descend' ) ? ' selected="selected"' : '' )
        . '>降順</option>';
    print $handle '<option value="ascend"'
        . ( ( $w eq 'ascend' ) ? ' selected="selected"' : '' )
        . '>昇順</option>';
    print $handle '</select></li>';
}

######################################################################
# 戻るボタン
sub print_return_button ($$$$$$$) {
    my ( $this, $handle, $output, $list, $t, $n, $v ) = @_;
    my ($url);
    $n = $list->[0] if !$n && ref $list && @$list == 1;
    if (  !$output
        && $n
        && $v
        && $setting::page{'article'}{'defaultView'}
        && ( ( ref $list && @$list == 1 && $v eq 'listarticle' )
            || $v ne $setting::page{'article'}{'defaultView'} )
        )
    {
        $url
            = $cgi::path
            . ( ( $default::subdivided && $main::c ) ? '?c=' . $main::c . '&'
            : '?' )
            . ( ( $setting::page{'article'}{'defaultView'} ne 'listarticle' )
            ? 'n=' . $n
            : '' )
            . '&v='
            . $setting::page{'article'}{'defaultView'};
    }
    elsif ( defined $default::subdivided && $default::subdivided ) {
        $url = $cgi::path
            . (
            (          $default::subdivided
                    && $main::c
                    && $v ne $setting::page{'article'}{'defaultView'}
            ) ? '?c=' . $main::c : ''
            );
    }
    elsif ( defined $setting::page{'returnUrl'}
        && $setting::page{'returnUrl'} )
    {
        $url = $setting::page{'returnUrl'};
    }
    else {
        return;
    }
    print $handle '<div id="return-to" class="panel">';
    print $handle $cgi::Deco->set_output($output)
        ->button( 'return', $setting::page{'returnButton'},
        $url, ( ($default::english) ? 'Return' : '戻る' ) );
    print $handle '</div>';
}

######################################################################
# クラス登録
#sub import {
BEGIN {
    no warnings qw(once);
    if ( !$default::subdivided
        || ( $default::subdivided && defined $main::c && $main::c ne '' ) )
    {

        #各種キー設定
        $setting::security_key = 'browse'
            if !defined $setting::security_key
            || $setting::security_key eq
            '';    #デフォルトセキュリティキー

        #ページ設定キー
        $setting::key = 'article'
            if !defined $setting::key || $setting::key eq '';

        #デフォルトキー
        $main::k = 'viewer' if !defined $main::k || !$main::k;

        #クラス登録
        Common::class_register( 'viewer', 'Viewer' );

    }
}

1;
