package Banner;
require CMONOS::CGI_Lib::Field;
@ISA = qw(Field);
use strict;
use utf8;
######################################################################
# フィールド定義モジュール（バナー/リンク）
# Banner.pm 1.1.7
# Copyright (C) 1999-2018 CMONOS Co. Ltd.
#
# support@cmonos.jp
# http://cmonos.jp/
# 最終更新日：2013-06-08
######################################################################
sub _set ($$) {
    my ( $this, $setting ) = @_;

    unless ( ref $cgi::Image ) {
        require CMONOS::CGI_Lib::Image;
        $cgi::Image = Image->new;
    }
    unless ( ref $cgi::Deco ) {
        require CMONOS::CGI_Lib::Deco;
        $cgi::Deco = Deco->new;
    }
    $this->{'border'} = 0
        if !defined $this->{'border'} || $this->{'border'} eq '';
    $this->{'maxsize'} = 128000 if !$this->{'maxsize'};

    #複数の要素を登録
    $this->{'elements'} = 1;

    #ファイルアップロード
    $cgi::enctype_multipart = 1;
    return;
}

######################################################################
#	(1) obj->match(str);
sub match ($;$) {
    my ( $this, $str ) = @_;
    my ( $match, $i, %data, $modifier );
    return 1
        if !defined $main::search{ $this->{'id'} }{'str'}
        || $main::search{ $this->{'id'} }{'str'} eq '';
    %data = $this->elements($$str);
    @{ $this->{'pattern'} }
        = split( /[\x09\x0A\x0C\x0D\x20]+/,
        $this->z_to_h( $main::search{ $this->{'id'} }{'str'} ) )
        if !ref $this->{'pattern'};
    $modifier = ( defined $main::search{ $this->{'id'} }{'i'}
            && $main::search{ $this->{'id'} }{'i'} ) ? '(?i)' : '';
    foreach ( @{ $this->{'pattern'} } ) {
        next if $_ eq '';
        my $p = quotemeta($_);
        if ( $data{'location'} =~ /$modifier$p/ ) {
            return 1
                if !defined $main::search{ $this->{'id'} }{'mode'}
                || $main::search{ $this->{'id'} }{'mode'} ne 'and';
        }
        elsif ( defined $main::search{ $this->{'id'} }{'mode'}
            && $main::search{ $this->{'id'} }{'mode'} eq 'and' )
        {
            return 0;
        }
    }
    if ( defined $main::search{ $this->{'id'} }{'mode'}
        && $main::search{ $this->{'id'} }{'mode'} eq 'and' )
    {
        return 1;
    }
    else {
        return 0;
    }
}

######################################################################
#	(2) obj->form;
sub form {
    my ( $this, $status, $original, $path ) = @_;
    my ( $name, $form, @menu, $v, %selected );

    #名前にデータIDを埋め込む
    $name = 'data:' . $this->{'id'};

    #フィールドネーム+ヘッダ
    $form = $this->field_header;

    #デフォルト
    $main::data{ $this->{'id'} }{'location'} = $this->{'default'}
        if ( !defined $status || $status eq '' )
        && ( !defined $main::data{ $this->{'id'} }{'location'}
        || $main::data{ $this->{'id'} }{'location'} eq '' );

    #ファイルの存在をチェック
    (   $main::data{ $this->{'id'} }{'type'},
        $main::data{ $this->{'id'} }{'width'},
        $main::data{ $this->{'id'} }{'height'}
        )
        = ()
        unless defined $main::data{ $this->{'id'} }{'type'}
        && -f ( ( !$cgi::input->{'clipboard_expired'}
                && $this->{'is_posted_file'} )
        ? $cgi::input->get_public_clipboard
        : $path )
        . '/'
        . $this->{'id'} . '.'
        . $main::data{ $this->{'id'} }{'type'};

    $form
        .= '<table class="sub-field-table"><tbody><tr><td class="sub-field-name"><label for="'
        . $name
        . ':location">URL</label></td><td class="sub-field"><input type="'
        . ( ( $this->{'pathEnabled'} ) ? 'text' : 'url' )
        . '" name="'
        . $name
        . ':location" id="'
        . $name
        . ':location" size="36"';
    $form
        .= ' value="'
        . $this->escape( $main::data{ $this->{'id'} }{'location'} ) . '"'
        if defined $main::data{ $this->{'id'} }{'location'}
        && $main::data{ $this->{'id'} }{'location'};
    $form .= ' class="invalid-field"'
        if $this->{'is_invalid_field'}{'location'};
    $form .= ' />';
    $form .= '</td></tr>';
    if (   !$this->{'titlefrom'}
        || !$this->{'usertitledisabled'}
        || !ref $this->{'field_obj'}->{ $this->{'titlefrom'} }
        || $this->{'field_obj'}->{ $this->{'titlefrom'} }->{'class'}
        !~ /^text/
        || (   $this->{'field_obj'}->{ $this->{'titlefrom'} }->{'rows'}
            && $this->{'field_obj'}->{ $this->{'titlefrom'} }->{'rows'} > 1 )
        )
    {
        $form
            .= '<tr><td class="sub-field-name"><label for="'
            . $name
            . ':title">タイトル</label></td><td class="sub-field"><input type="text" name="'
            . $name
            . ':title" id="'
            . $name
            . ':title" size="36"';
        $form
            .= ' value="'
            . $this->escape( $main::data{ $this->{'id'} }{'title'} ) . '"'
            if defined $main::data{ $this->{'id'} }{'title'}
            && $main::data{ $this->{'id'} }{'title'};
        $form .= ' /></td></tr>';
    }

    #画像URL
    if ( defined $this->{'imageurl'} && $this->{'imageurl'} ) {
        $form
            .= '<tr><td class="sub-field-name"><label for="'
            . $name
            . ':image">画像URL</label></td><td class="sub-field"><input type="url" name="'
            . $name
            . ':image" id="'
            . $name
            . ':image" size="36"';
        $form
            .= ' value="'
            . $this->escape( $main::data{ $this->{'id'} }{'image'} ) . '"'
            if defined $main::data{ $this->{'id'} }{'image'}
            && $main::data{ $this->{'id'} }{'image'};
        $form .= $this->set_invalid_class
            if $this->{'is_invalid_field'}{'image'};
        $form .= ' /></td></tr>';
    }

    #アップロードフォーム
    $form
        .= '<tr><td class="sub-field-name"><label for="'
        . $name
        . ':file">バナー画像</label></td>';
    $form
        .= '<td class="sub-field"><span id="'
        . $name
        . ':file-wrapper"><input type="file" name="'
        . $name
        . ':file" id="'
        . $name
        . ':file" value="'
        . $this->escape( $main::data{ $this->{'id'} }{'file'} ) . '"';
    $form .= $this->set_invalid_class if $this->{'is_invalid_field'}{'file'};
    $form
        .= ' /></span><input type="button" value="&#139; リセット" onclick="cmonos.form.item(this.form).fieldname(\''
        . $name
        . ':file\').reset()">';
    $form .= '<div class="note">(&lt; ' . $this->{'maxsize'} . ' byte) </div>'
        if $this->{'maxsize'} > 0;
    $form
        .= '<div class="note">(&lt; '
        . ( ( $this->{'widthlimit'} ) ? $this->{'widthlimit'} : '&infin;' )
        . ' × '
        . ( ( $this->{'heightlimit'} ) ? $this->{'heightlimit'} : '&infin;' )
        . ' ピクセル) </div>'
        if $this->{'widthlimit'} || $this->{'heightlimit'};
    $form .= '</td></tr></tbody></table>';
    $form
        .= '<input type="hidden" name="'
        . $name
        . ':width" value="'
        . $this->escape( $main::data{ $this->{'id'} }{'width'} ) . '" />';
    $form
        .= '<input type="hidden" name="'
        . $name
        . ':height" value="'
        . $this->escape( $main::data{ $this->{'id'} }{'height'} ) . '" />';

    #既存ファイルの表示
    if ( ( ( defined $status && $status ne '' ) || $this->{'is_posted_file'} )
        && defined $main::data{ $this->{'id'} }{'type'}
        && $main::data{ $this->{'id'} }{'type'} ne '' )
    {
        $path = $cgi::input->get_public_clipboard
            if !$cgi::input->{'clipboard_expired'}
            && $this->{'is_posted_file'};
        $form .= '<div class="sample-image">';
        $form .= $cgi::Image->image_tag(
            "$path/$this->{'id'}.$main::data{$this->{'id'}}{'type'}",
            $main::data{ $this->{'id'} }{'width'},
            $main::data{ $this->{'id'} }{'height'},
            $this->{'border'},
            $main::data{ $this->{'id'} }{'title'},
            '',
            300,
            300
        );
        if (  !$cgi::input->{'clipboard_expired'}
            && $this->{'is_posted_file'} )
        {
            $form
                .= '<div class="extra-field"><label><input type="checkbox" name="option:'
                . $this->{'id'}
                . ':cancel" value="1" /> この<strong>未確定</strong>バナー画像を削除する</label></div>';
        }
        else {
            $form
                .= '<div class="extra-field"><label><input type="checkbox" name="'
                . $name
                . ':delete" value="1"'
                . (
                (         !$cgi::input->{'clipboard_expired'}
                        && $main::data{ $this->{'id'} }{'delete'}
                ) ? ' checked="checked"' : ''
                ) . ' /> このバナー画像を削除する</label></div>';
        }
        $form
            .= '<input type="hidden" name="'
            . $name
            . ':type" value="'
            . $main::data{ $this->{'id'} }{'type'}
            . '" /></div>';
    }

    $form .= $this->field_footer;
    return $form;
}

######################################################################
#	(3) obj->is_valid_data(path);
sub is_valid_data ($;$) {
    my ( $this, $path ) = @_;
    my ( $is_valid, @stat, $name,, $width, $height, $type );
    delete $this->{'is_invalid_field'} if ref $this->{'is_invalid_field'};
    $is_valid = 1;

    #半角変換
    $this->escape_data_tag('location');
    $main::data{ $this->{'id'} }{'location'}
        = $this->z_to_h( $main::data{ $this->{'id'} }{'location'} );
    $main::data{ $this->{'id'} }{'location'} =~ s/\x0A//gs;

    #必須項目/文字数チェック
    $is_valid = $this->is_not_empty('location');

    #書式チェック
    my $url = $main::data{ $this->{'id'} }{'location'};
    if (   defined $main::data{ $this->{'id'} }{'location'}
        && $main::data{ $this->{'id'} }{'location'} ne ''
        && $main::data{ $this->{'id'} }{'location'} ne '/'
        && $this->is_invalid_url( $main::data{ $this->{'id'} }{'location'} ) )
    {
        my $query = '';
        ( $url, $query ) = ( $1, $2 ) if $url =~ /^(.*?)([\?\#].*)$/s;
        $url =~ s!([^\.])/$!$1!;
        if ( $this->{'pathEnabled'} && $url !~ m![^\.]/\.+/! ) {
            my $is_invalid_path = 0;
            if ( $url =~ m!^/! ) {
                $url = $this->path_change( $url, $ENV{'SCRIPT_NAME'}, 'rel' );
            }
            else {
                $this->home_location
                    if !defined $cgi::document_root
                    || !defined $cgi::user_directory;
                if ($default::static) {
                    my $here
                        = ( $default::lib eq 'HomePageMakerLite' )
                        ? $default::home
                        : (   !$master::home
                            || $master::home eq $default::home )
                        ? $default::home
                        . ( ( defined $main::c && $main::c ne '' )
                        ? '/' . $main::c
                        : '' )
                        . '/'
                        . $main::n
                        . '/index.html'
                        : $default::home . '/' . $main::n . '/index.html';
                    $url = $this->un_base_change( $url, $here, 'rel', 1 );
                }
                my $path = $this->path_change( $url, $this->get_cwd . '/here',
                    'abs' );
                if (   $path !~ /^$cgi::document_root/
                    && $cgi::document_root ne $path )
                {
                    push(
                        @{ $cgi::action->{'dialog'} },
                        ( ( $this->{'name'} ) ? $this->{'name'} : '入力' )
                            . 'を確認してください。ブラウザからアクセスできないパスです。'
                    ) if ref $cgi::action;
                    $is_valid                               = 0;
                    $this->{'is_invalid_field'}{'location'} = 1;
                    $is_invalid_path                        = 1;
                }
            }
            if ( !$is_invalid_path ) {
                if ( !-e $url ) {
                    push(
                        @{ $cgi::action->{'dialog'} },
                        ( ( $this->{'name'} ) ? $this->{'name'} : '入力' )
                            . 'を確認してください。入力されたパスにファイルが存在しません。'
                    ) if ref $cgi::action;
                    $is_valid = 0;
                    $this->{'is_invalid_field'}{'location'} = 1;
                }
                else {
                    $url = $this->full_path($url) . $query;
                }
            }
        }
        else {
            push(
                @{ $cgi::action->{'dialog'} },
                ( ( $this->{'name'} ) ? $this->{'name'} : '入力' )
                    . 'を確認してください。URLではありません。'
            ) if ref $cgi::action;
            $is_valid = 0;
            $this->{'is_invalid_field'}{'location'} = 1;
        }
    }

    #フィルターのチェック
    if (   $this->{'extfilter'}
        && defined $main::data{ $this->{'id'} }{'location'}
        && $main::data{ $this->{'id'} }{'location'} ne '' )
    {
        my @ext_filter = split( /,/, $this->{'extfilter'} );
        @ext_filter = grep( $_ ne '', @ext_filter );
        my $ext;
        my $matched = 0;
        foreach $ext (@ext_filter) {
            if ( $main::data{ $this->{'id'} }{'location'} =~ /\.$ext$/i ) {
                $matched = 1;
                if ( !$this->{'extmatched'} ) {
                    push(
                        @{ $cgi::action->{'dialog'} },
                        (   ( defined $this->{'name'} && $this->{'name'} )
                            ? $this->{'name'}
                            : '入力'
                            )
                            . 'を確認してください。禁止されたファイルです。'
                    ) if ref $cgi::action;
                    $is_valid = 0;
                    $this->{'is_invalid_field'}{'location'} = 1;
                    last;
                }
            }
        }
        if ( !$matched && $this->{'extmatched'} ) {
            push(
                @{ $cgi::action->{'dialog'} },
                (   ( defined $this->{'name'} && $this->{'name'} )
                    ? $this->{'name'}
                    : '入力'
                    )
                    . 'を確認してください。禁止されたファイルです。'
            ) if ref $cgi::action;
            $this->{'is_invalid_field'}{'location'} = 1;
            $is_valid = 0;
        }
    }

    #タイトル
    if (   $this->{'titlefrom'}
        && ref $this->{'field_obj'}->{ $this->{'titlefrom'} }
        && $this->{'field_obj'}->{ $this->{'titlefrom'} }->{'class'}
        =~ /^text/
        && (  !$this->{'field_obj'}->{ $this->{'titlefrom'} }->{'rows'}
            || $this->{'field_obj'}->{ $this->{'titlefrom'} }->{'rows'} == 1 )
        && (   !defined $main::data{ $this->{'id'} }{'title'}
            || $main::data{ $this->{'id'} }{'title'} eq ''
            || $this->{'usertitledisabled'} )
        )
    {
        $main::data{ $this->{'id'} }{'title'}
            = ( defined $main::data{ $this->{'titlefrom'} }{'str'} )
            ? $main::data{ $this->{'titlefrom'} }{'str'}
            : '';
    }
    if ($this->{'getTitle'}
        && ( !defined $main::data{ $this->{'id'} }{'title'}
            || $main::data{ $this->{'id'} }{'title'} eq '' )
        && $url
        && (   !ref $this->{'is_invalid_field'}
            || !$this->{'is_invalid_field'}{'location'} )
        )
    {
        $url = $this->full_path($url) if $url !~ /^https?:\/\//i;
        require CMONOS::CGI_Lib::HTTP_Client;
        my $res
            = HTTP_Client->new->request( 'GET' => $url, {}, '', '', 4096 );
        if ( $res->is_success ) {
            my $content = $res->content('utf8');
            if ($content
                && ( $content
                    =~ m/<title(?![0-9a-zA-Z_])[^>]*>(.*?)<\/title(?![0-9a-zA-Z_])[^>]*>/si
                    || $content
                    =~ m/<h[1-6](?![0-9a-zA-Z_])[^>]*>(.*?)<\/h[1-6]>/si )
                )
            {
                $main::data{ $this->{'id'} }{'title'} = $this->unescape($1);
            }
        }
    }
    if ( $main::data{ $this->{'id'} }{'title'} ) {
        $this->detag( \$main::data{ $this->{'id'} }{'title'} );
        $main::data{ $this->{'id'} }{'title'} =~ s/[\x0A\x0D]//gs;
    }

    #シンボリックネーム
    $name = 'data:' . $this->{'id'} . ':file';

    #既存ファイル情報
    if ( !$path || !-d $path ) {
        $main::data{ $this->{'id'} }{'width'}
            = $main::data{ $this->{'id'} }{'height'}
            = $main::data{ $this->{'id'} }{'type'} = '';
        undef $path;
    }
    else {
        (   $main::data{ $this->{'id'} }{'width'},
            $main::data{ $this->{'id'} }{'height'},
            $main::data{ $this->{'id'} }{'type'},
            $main::data{ $this->{'id'} }{'name'}
            )
            = $this->get_field_file_info(
            $path,
            $main::data{ $this->{'id'} }{'width'},
            $main::data{ $this->{'id'} }{'height'},
            $main::data{ $this->{'id'} }{'type'}
            );
    }

    if (   $main::clipboard_id
        && !$main::data{ $this->{'id'} }{'file'}
        && !$main::option{ $this->{'id'} }{'cancel'} )
    {
        $cgi::input->inherit_posted_file_properties($name);
    }
    my %properties
        = $cgi::input->get_posted_file_properties_from_param($name);
    if ( $properties{'delete'} ) {
        delete $properties{'delete'};
        $cgi::input->set_posted_file_properties_from_param( $name, 0,
            \%properties );
    }
    if ( $properties{'filename'} ) {

        #添付ファイルが画像ファイルかどうかチェック
        @stat
            = $cgi::Image->input_info( $cgi::input, $name, 0,
            $this->{'widthlimit'}, $this->{'heightlimit'},
            1, \%properties, 1 );
        ( $width, $height, $type ) = @stat if @stat > 2;

        #MIME-TYPEチェック
        if ( !defined $type || $type eq '' ) {
            push(
                @{ $cgi::action->{'dialog'} },
                ( ( $this->{'name'} ) ? $this->{'name'} : 'バナー画像' )
                    . 'のファイルタイプを確認してください。'
            ) if ref $cgi::action;
            $this->{'is_invalid_field'}{'file'} = 1;
            $is_valid = 0;
        }

        #ファイルサイズチェック
        if (   $this->{'maxsize'}
            && $cgi::input->get_posted_file_size_from_param($name)
            > $this->{'maxsize'} )
        {
            push(
                @{ $cgi::action->{'dialog'} },
                ( ( $this->{'name'} ) ? $this->{'name'} : 'バナー画像' )
                    . 'のファイルサイズを確認してください。'
                    . $this->{'maxsize'}
                    . 'バイト以内にしてください。'
            ) if ref $cgi::action;
            $this->{'is_invalid_field'}{'file'} = 1;
            $is_valid = 0;
        }

        if ( !$is_valid ) {
            $cgi::input->remove_posted_file($name);
            undef %properties;
        }

        #ファイル削除予約
    }
    elsif ( $main::data{ $this->{'id'} }{'delete'} ) {
        $properties{'delete'} = $this->{'id'};
        $cgi::input->set_posted_file_properties_from_param( $name, 0,
            \%properties );
        $cgi::input->parameters_trash(
            \$main::data{ $this->{'id'} }{'width'},
            \$main::data{ $this->{'id'} }{'height'},
            \$main::data{ $this->{'id'} }{'type'}
        );
        delete $main::data{ $this->{'id'} }{'file'};
        $this->data( 'file', 'delete', 'width', 'height', 'type' );
        return 1;

    }
    else {
        ( $width, $height, $type ) = (
            $main::data{ $this->{'id'} }{'width'},
            $main::data{ $this->{'id'} }{'height'},
            $main::data{ $this->{'id'} }{'type'}
        );
    }
    delete $main::data{ $this->{'id'} }{'file'};

    #画像サイズチェック
    if ( $this->{'widthlimit'} && $width && $width > $this->{'widthlimit'} ) {
        push(
            @{ $cgi::action->{'dialog'} },
            ( ( $this->{'name'} ) ? $this->{'name'} : 'バナー画像' )
                . 'の横幅を確認してください。'
                . $this->{'widthlimit'}
                . 'ピクセル以内にしてください。'
        ) if ref $cgi::action;
        $is_valid = 0;
        $this->{'is_invalid_field'}{'file'} = 1;
    }
    if (   $this->{'heightlimit'}
        && $height
        && $height > $this->{'heightlimit'} )
    {
        push(
            @{ $cgi::action->{'dialog'} },
            ( ( $this->{'name'} ) ? $this->{'name'} : 'バナー画像' )
                . 'の高さを確認してください。'
                . $this->{'heightlimit'}
                . 'ピクセル以内にしてください。'
        ) if ref $cgi::action;
        $is_valid = 0;
        $this->{'is_invalid_field'}{'file'} = 1;
    }

    #画像URL
    delete $main::data{ $this->{'id'} }{'imagewidth'};
    delete $main::data{ $this->{'id'} }{'imageheight'};
    if ( defined $this->{'imageurl'} && $this->{'imageurl'} ) {
        if ( defined $main::data{ $this->{'id'} }{'image'}
            && $main::data{ $this->{'id'} }{'image'} ne '' )
        {
            if ( $main::data{ $this->{'id'} }{'image'}
                =~ /[0-9a-zA-Z_]+\.(gif|jpg|jpeg|png)$/i )
            {
                require CMONOS::CGI_Lib::HTTP_Client;
                my $res = HTTP_Client->new->request(
                    'GET' => $main::data{ $this->{'id'} }{'image'} );
                if ( $res->is_success ) {
                    my $content = $res->content;
                    (   $main::data{ $this->{'id'} }{'imagewidth'},
                        $main::data{ $this->{'id'} }{'imageheight'}
                    ) = $cgi::Image->info( \$content );
                }
            }
            if ( !$main::data{ $this->{'id'} }{'imagewidth'} ) {
                push(
                    @{ $cgi::action->{'dialog'} },
                    (   ( $this->{'name'} )
                        ? $this->{'name'}
                        : 'バナー画像'
                        )
                        . 'の画像 URL を確認してください。Web に適した画像ではありません。'
                ) if ref $cgi::action;
                $is_valid = 0;
                $this->{'is_invalid_field'}{'image'} = 1;
            }
        }
    }
    else {
        delete $main::data{ $this->{'id'} }{'image'};
    }
    return 0 if !$is_valid;

    #データ整形
    (   $main::data{ $this->{'id'} }{'width'},
        $main::data{ $this->{'id'} }{'height'},
        $main::data{ $this->{'id'} }{'type'}
    ) = ( $width, $height, $type );
    $this->data;

    #画像の保存を予約
    if ( $properties{'filename'} ) {
        $mail::file .= '<' . $name . '>,'
            if !$default::static
            && ( $this->{'mail'} || $setting::field_for_mail )
            ;    #メール添付予約
        $cgi::input->save_file( $name, '!' . $this->{'id'} );
        $this->{'is_posted_file'} = 1;
    }

    return 1;
}

######################################################################
#	(4) obj->usual_format(str);
sub usual_format {
    my ( $this, $str, $path ) = @_;
    return $this->field_tag($str) if !defined $str || $str eq '';
    $path = $cgi::input->get_public_clipboard
        if $this->{'is_temporary_data'} && $this->{'is_posted_file'};

    my ( %data, $thumnail_url, $rel_path, $url );
    %data
        = ( ref $str eq 'HASH' )
        ? ( defined $$str{'str'} )
            ? $this->elements( $$str{'str'} )
            : %$str
        : $this->elements($str);
    return $this->field_tag( $this->data_tag_from_ref( \%data ), 1 )
        if !defined $data{'location'} || $data{'location'} eq '';
    $data{'title'} =~ s/[\x0A\x0D]//gs if $data{'title'};
    $data{'title'} = $data{'location'}
        if !defined $data{'title'} && $data{'title'} eq '';

    $rel_path = $url = $data{'location'};
    if ( $url !~ /^https?:\/\//i ) {
        if ( $url =~ m!^/! ) {
            $url = $this->full_path($url);
        }
        else {
            $rel_path
                = $this->un_base_change( $rel_path, $cgi::output,
                ( $cgi::output_option || 'rel' ), 1 )
                if $cgi::output || $cgi::output_option;
            $url = $this->full_path($rel_path);
        }
    }
    $thumnail_url = $this->get_website_thumnail_url( $this->{'apiurl'}, $url )
        if !$data{'type'} && !$data{'image'} && $this->{'apiurl'};

    #画像タグ
    if ( defined $data{'type'} && $data{'type'} ne '' ) {
        $str = '<a href="' . $data{'location'} . '"';
        $str .= ' target="_blank"' if !$this->{'sameWindow'};
        $str .= ' rel="nofollow"'  if $this->{'nofollow'};
        $str
            .= ' title="'
            . $this->escape_except_html_entity( $data{'title'} ) . '">'
            . $cgi::Image->image_tag(
            "$path/$this->{'id'}.$data{'type'}", $data{'width'},
            $data{'height'},                     $this->{'border'},
            $data{'title'},                      '',
            $this->{'widthlimit'},               $this->{'heightlimit'},
            $cgi::output,                        $cgi::output_option,
            1
            ) . '</a>';
        if (   $this->{'is_temporary_data'}
            && $main::data{ $this->{'id'} }{'delete'}
            && !$this->{'required'}
            && !$this->{'is_posted_file'} )
        {
            $str
                .= '<div class="note">このファイルを削除する</div>';
        }

    }
    elsif ( defined $data{'image'} && $data{'image'} ne '' ) {
        $str = '<a href="' . $data{'location'} . '"';
        $str .= ' target="_blank"' if !$this->{'sameWindow'};
        $str .= ' rel="nofollow"'  if $this->{'nofollow'};
        $str
            .= ' title="'
            . $this->escape_except_html_entity( $data{'title'} ) . '">'
            . $cgi::Image->image_tag(
            $data{'image'},        $data{'imagewidth'},
            $data{'imageheight'},  $this->{'border'},
            $data{'title'},        '',
            $this->{'widthlimit'}, $this->{'heightlimit'},
            $cgi::output,          $cgi::output_option,
            1
            ) . '</a>';

    }
    elsif ( defined $thumnail_url && $thumnail_url ne '' ) {
        $str = '<a href="' . $data{'location'} . '"';
        $str .= ' target="_blank"' if !$this->{'sameWindow'};
        $str .= ' rel="nofollow"'  if $this->{'nofollow'};
        $str
            .= ' title="'
            . $this->escape_except_html_entity( $data{'title'} ) . '">'
            . $cgi::Image->image_tag(
            $thumnail_url,            $this->{'previewwidth'},
            $this->{'previewheight'}, $this->{'border'},
            $data{'title'},           '',
            $this->{'widthlimit'},    $this->{'heightlimit'},
            $cgi::output,             $cgi::output_option,
            1
            ) . '</a>';

    }
    elsif ( $this->{'button'} ) {
        $this->use_deco($cgi::output);
        $str = $cgi::Deco->button(
            'jump',
            $this->{'button'},
            $rel_path,
            $data{'title'},
            ( ( !$this->{'sameWindow'} ) ? '_blank' : '' ),
            ( ( $this->{'nofollow'} ) ? { 'rel' => 'nofollow' } : '' )
        );

    }
    else {
        $str = '<a href="' . $data{'location'} . '" class="banner-title"';
        $str .= ' target="_blank"' if !$this->{'sameWindow'};
        $str .= ' rel="nofollow"'  if $this->{'nofollow'};
        $str
            .= ' title="'
            . $this->escape_except_html_entity( $data{'title'} ) . '">'
            . $this->escape_except_html_entity( $data{'title'} ) . '</a>';
    }

    return $this->field_tag( $this->data_tag_from_ref( \%data ) . $str );
}

sub has_content {
    my ( $this, $str ) = @_;
    return 0 if !defined $str || $str eq '';
    my %data
        = ( ref $str eq 'HASH' )
        ? ( defined $$str{'str'} )
            ? $this->elements( $$str{'str'} )
            : %$str
        : $this->elements($str);
    return ( %data && defined $data{'location'} && $data{'location'} ne '' )
        ? 1
        : 0;
}

#---------------------------------------------------------------------
#	(4) obj->format_for_mail(str);
sub format_for_mail {
    my ( $this, $str ) = @_;
    return '' if !defined $str || $str eq '';

    my (%data);
    %data
        = ( ref $str eq 'HASH' )
        ? ( defined $$str{'str'} )
            ? $this->elements( $$str{'str'} )
            : %$str
        : $this->elements($str);
    return '' if !$data{'location'};

    $str = '[' . $this->name . "]\x0A";
    $str .= "\x0A" if length( $this->{'name'} . $data{'location'} ) > 67;
    $str
        .= $data{'location'}
        . ( ( $data{'title'} ) ? ' (' . $data{'title'} . ')' : '' )
        . "\x0A\x0A";
    return $str;
}

#	(4)-4 obj->format_for_text(str);
sub format_for_text {
    my ( $this, $str ) = @_;
    return '' if !defined $str || $str eq '';
    my %data
        = ( ref $str eq 'HASH' )
        ? ( defined $$str{'str'} )
            ? $this->elements( $$str{'str'} )
            : %$str
        : $this->elements($str);
    return ( $data{'location'} ) ? $data{'location'} : '';
}

######################################################################
#	(5) obj->print_setting_form;
sub print_setting_form ($;$$) {
    my $this = shift;
    my ($name);

    #名前
    $name = 'data:' . $this->{'id'};

    $this->print_field_info_form($name);

    print '<fieldset>';
    print '<legend>入力欄設定</legend>';
    print
        '<div class="hints">画像が制限幅を超える場合、画像添付を拒絶します。</div>';
    print '<table class="field-table">';
    print '<tbody>';
    print '<tr><td class="field-name"><label for="' . $name
        . '_maxsize">ファイルサイズ制限</label></td>';
    print '<td class="field" colspan="3"><input type="text" name="'
        . $name
        . '_maxsize" id="'
        . $name
        . '_maxsize" value="'
        . $this->escape( $this->{'maxsize'} )
        . '" size="16" /> <span class="unit">byte</span>';
    print
        '<div class="hints">設定が無い場合、128,000byte（128KB）に設定されます。</div></td>';
    print '</tr>';
    print '<tr>';
    print '<td class="field-name"><label for="' . $name
        . '_widthlimit">横幅制限</label></td>';
    print '<td class="q-field"><input type="number" name="'
        . $name
        . '_widthlimit" id="'
        . $name
        . '_widthlimit" value="'
        . $this->escape( $this->{'widthlimit'} )
        . '" size="4" /> <span class="unit">ピクセル</span></td>';
    print '<td class="field-name"><label for="' . $name
        . '_heightlimit">高さ制限</label></td>';
    print '<td class="q-field"><input type="number" name="'
        . $name
        . '_heightlimit" id="'
        . $name
        . '_heightlimit" value="'
        . $this->escape( $this->{'heightlimit'} )
        . '" size="4" /> <span class="unit">ピクセル</span></td>';
    print '</tr>';
    print '</tbody></table>';
    print '<fieldset>';
    print '<legend><label for="' . $name
        . '_default">デフォルト URL</label></legend>';
    print '<input type="text" name="'
        . $name
        . '_default" id="'
        . $name
        . '_default" value="'
        . $this->escape( $this->{'default'} )
        . '" size="72" />';
    print '</fieldset>';
    print '<fieldset>';
    print '<legend><label for="' . $name
        . '_extfilter">リンク先拡張子フィルタ</label></legend>';
    print '<input type="text" name="'
        . $name
        . '_extfilter" id="'
        . $name
        . '_extfilter" value="'
        . ( ( defined $this->{'extfilter'} )
        ? $this->escape( $this->{'extfilter'} )
        : 'exe,app,scr,pif,bat,com,cmd' )
        . '" size="50" title="拡張子でフィルタリングします。" />';
    print
        ' <span class="note">(拡張子ごとにカンマで区切ります)</note>';
    print '<fieldset>';
    print '<legend>処理</legend>';
    print '<ol class="checkbox">';
    print '<li><label><input type="radio" name="'
        . $name
        . '_extmatched" value="1"'
        . ( ( $this->{'extmatched'} ) ? ' checked="checked"' : '' )
        . ' /> 拡張子が一致するとき、登録を許可する。</label></li>';
    print '<li><label><input type="radio" name="'
        . $name
        . '_extmatched" value="0"'
        . ( ( !$this->{'extmatched'} ) ? ' checked="checked"' : '' )
        . ' /> 拡張子が一致しないとき、登録を許可する。</label></li>';
    print '</ol>';
    print '</fieldset>';
    print '</fieldset>';
    print '<fieldset>';
    print '<legend><label for="' . $name
        . '_titlefrom">タイトルがないとき、この文字列フィールドからタイトルを作成する</label></legend>';
    print '<select name="'
        . $name
        . '_titlefrom" id="'
        . $name
        . '_titlefrom">';
    print '<option value=""></option>';

    foreach my $id (
        sort {
            $this->{'field_obj'}->{$a}->{'ORDER'}
                <=> $this->{'field_obj'}->{$b}->{'ORDER'}
                || $a <=> $b
        } keys %{ $this->{'field_obj'} }
        )
    {
        next
            unless ref $this->{'field_obj'}->{$id}
            && $this->{'field_obj'}->{$id}->{'class'} =~ /^text/
            && ( !$this->{'field_obj'}->{$id}->{'rows'}
            || $this->{'field_obj'}->{$id}->{'rows'} == 1 );
        print '<option value="'
            . $id . '"'
            . (
            ( defined $this->{'titlefrom'} && $this->{'titlefrom'} eq $id )
            ? ' selected="selected"'
            : '' )
            . '>'
            . $this->jfold( $this->{'field_obj'}->{$id}->name, 32, 'I', 1 )
            . '</option>';
    }
    print '</select>';
    print '<ol class="checkbox">';
    print '<li><label><input type="checkbox" name="'
        . $name
        . '_usertitledisabled" value="1"'
        . ( ( $this->{'usertitledisabled'} ) ? ' checked="checked"' : '' )
        . ' /> 常にこのフィールドの値をタイトルにする。</label>';
    print '<li><label><input type="checkbox" name="'
        . $name
        . '_getTitle" value="1"'
        . ( ( defined $this->{'getTitle'} && $this->{'getTitle'} )
        ? ' checked="checked"'
        : '' )
        . ' /> タイトルがみつからない場合ページタイトルを取得する</label></li>';
    print '</ol>';
    print '</fieldset>';
    print '</fieldset>';

    print '<fieldset>';
    print '<legend>リンク設定</legend>';
    print '<ol class="checkbox">';
    print '<li><label><input type="checkbox" name="'
        . $name
        . '_nofollow" id="'
        . $name
        . '_nofollow" value="1"'
        . ( ( defined $this->{'nofollow'} && $this->{'nofollow'} )
        ? ' checked="checked"'
        : '' )
        . ' /> リンク先を検索エンジンに無視させる</label></li>';
    print '<li><label><input type="checkbox" name="'
        . $name
        . '_sameWindow" value="1"'
        . ( ( defined $this->{'sameWindow'} && $this->{'sameWindow'} )
        ? ' checked="checked"'
        : '' )
        . ' /> 同じウィンドウで開く</label></li>';
    print '<li><label><input type="checkbox" name="'
        . $name
        . '_pathEnabled" value="1"'
        . ( ( defined $this->{'pathEnabled'} && $this->{'pathEnabled'} )
        ? ' checked="checked"'
        : '' )
        . ' /> 相対パスによる指定を許可する</label></li>';
    print '</ol>';
    print '</fieldset>';

    print '<fieldset>';
    print '<legend>バナー設定</legend>';
    print '<ol class="checkbox">';
    print '<li><label><input type="checkbox" name="'
        . $name
        . '_mail" id="'
        . $name
        . '_mail" value="1"'
        . ( ( defined $this->{'mail'} && $this->{'mail'} )
        ? ' checked="checked"'
        : '' )
        . ' /> 通知メールにファイルを添付する</label></li>'
        if !$default::static && !$setting::field_for_mail;
    print '<li><label><input type="checkbox" name="'
        . $name
        . '_imageurl" id="'
        . $name
        . '_imageurl" value="1"'
        . ( ( defined $this->{'imageurl'} && $this->{'imageurl'} )
        ? ' checked="checked"'
        : '' )
        . ' /> 外部バナー画像 URL の設定を許可する</label></li>';
    print '</ol>';
    print '<fieldset>';
    print '<legend>デフォルトボタン</legend>';

    #ボタンメニュー
    print $cgi::Deco->button_menu( $name . '_button',
        'jump', 120, $this->{'button'} );

    print '</fieldset>';
    print '<fieldset>';
    print
        '<legend>ウェブページ・サムネイル化サービス API</legend>';
    print '<fieldset>';
    print '<legend><label for="' . $name
        . '_apiurl">API URL</label></legend>';
    print '<input type="text" name="'
        . $name
        . '_apiurl" id="'
        . $name
        . '_apiurl" value="'
        . $this->escape( $this->{'apiurl'} )
        . '" size="72" />';
    print
        '<select class="tool" onchange="cmonos.form.item(this.form).fieldname(\'',
        $name, '_apiurl\').textByMenu(this)">';
    print '<option value="">↓主なサービス</option>';
    print
        '<option value="http://img.simpleapi.net/small/%u">SimpleAPI</option>';
    print '<option value="https://blinky.nemui.org/shot?%u">Mozshot</option>';
    print
        '<option value="http://capture.heartrails.com/medium?%u">HeartRails Capture</option>';
    print
        '<option value="http://images.websnapr.com/?url=%u&amp;size=s">WebSnapr</option>';
    print
        '</select><div class="note">URL が入る場所を %u とします。</div>';
    print '</fieldset>';
    print '<fieldset>';
    print '<legend>サムネイルサイズ</legend>';
    print '<label>幅 <input type="number" name="'
        . $name
        . '_previewwidth" id="'
        . $name
        . '_previewwidth" value="'
        . $this->escape( $this->{'previewwidth'} )
        . '" size="4" /> <span class="unit">ピクセル</span></label> &times <label>高さ <input type="number" name="'
        . $name
        . '_previewheight" id="'
        . $name
        . '_previewheight" value="'
        . $this->escape( $this->{'previewheight'} )
        . '" size="4" /> <span class="unit">ピクセル</span></label>';
    print '</fieldset>';
    print '</fieldset>';
    print '</fieldset>';

    $this->print_setting_save_button;
}

######################################################################
#	(6) obj->is_valid_setting;
sub is_valid_setting ($) {
    my $this     = shift;
    my $is_valid = 1;
    $main::data{ $this->{'id'} . '_default' } =~ s/[\x0A\x0D]//sg;
    $this->tag_fix( \$main::data{ $this->{'id'} . '_description' } )
        if defined $main::data{ $this->{'id'} . '_description' }
        && $main::data{ $this->{'id'} . '_description' };
    $this->tag_fix( \$main::data{ $this->{'id'} . '_note' } )
        if defined $main::data{ $this->{'id'} . '_note' }
        && $main::data{ $this->{'id'} . '_note' };
    $main::data{ $this->{'id'} . '_nofollow' } = ''
        if !defined $main::data{ $this->{'id'} . '_nofollow' }
        || !$main::data{ $this->{'id'} . '_nofollow' };
    $main::data{ $this->{'id'} . '_mail' } = ''
        if !defined $main::data{ $this->{'id'} . '_mail' }
        || !$main::data{ $this->{'id'} . '_mail' };
    $main::data{ $this->{'id'} . '_imageurl' } = ''
        if !defined $main::data{ $this->{'id'} . '_imageurl' }
        || !$main::data{ $this->{'id'} . '_imageurl' };

    if ( $main::data{ $this->{'id'} . '_extfilter' } ) {
        $main::data{ $this->{'id'} . '_extfilter' }
            = $this->z_to_h( $main::data{ $this->{'id'} . '_extfilter' } );
        $main::data{ $this->{'id'} . '_extfilter' } =~ s/[^a-zA-Z0-9,]/,/g;
        $main::data{ $this->{'id'} . '_extfilter' } =~ s/,+/,/g;
        $main::data{ $this->{'id'} . '_extfilter' } =~ s/^,//;
        $main::data{ $this->{'id'} . '_extfilter' } =~ s/,$//;
    }
    $main::data{ $this->{'id'} . '_usertitledisabled' } = ''
        if !defined $main::data{ $this->{'id'} . '_usertitledisabled' }
        || !$main::data{ $this->{'id'} . '_usertitledisabled' };
    $main::data{ $this->{'id'} . '_getTitle' } = ''
        if !defined $main::data{ $this->{'id'} . '_getTitle' }
        || $main::data{ $this->{'id'} . '_getTitle' } eq '';
    $main::data{ $this->{'id'} . '_pathEnabled' } = ''
        if !defined $main::data{ $this->{'id'} . '_pathEnabled' }
        || $main::data{ $this->{'id'} . '_pathEnabled' } eq '';
    $main::data{ $this->{'id'} . '_sameWindow' } = ''
        if !defined $main::data{ $this->{'id'} . '_sameWindow' }
        || $main::data{ $this->{'id'} . '_sameWindow' } eq '';
    $is_valid = 0 if !$this->is_valid_file_setting;
    if (   defined $main::data{ $this->{'id'} . '_apiurl' }
        && $main::data{ $this->{'id'} . '_apiurl' } ne ''
        && $this->is_invalid_url( $main::data{ $this->{'id'} . '_apiurl' } ) )
    {
        push(
            @{ $cgi::action->{'dialog'} },
            'サムネイル化 API URLを確認してください。URLではありません。'
        ) if ref $cgi::action;
        $is_valid = 0;
        delete $main::data{ $this->{'id'} . '_apiurl' };
    }
    if (   defined $main::data{ $this->{'id'} . '_previewwidth' }
        && $main::data{ $this->{'id'} . '_previewwidth' } ne ''
        && $this->is_nan( $main::data{ $this->{'id'} . '_previewwidth' } ) )
    {
        push(
            @{ $cgi::action->{'dialog'} },
            'サムネイル横幅設定を更新できませんでした。半角数字にしてください。'
        ) if ref $cgi::action;
        delete $main::data{ $this->{'id'} . '_previewwidth' };
        $is_valid = 0;
    }
    if (   defined $main::data{ $this->{'id'} . '_previewheight' }
        && $main::data{ $this->{'id'} . '_previewheight' } ne ''
        && $this->is_nan( $main::data{ $this->{'id'} . '_previewheight' } ) )
    {
        push(
            @{ $cgi::action->{'dialog'} },
            'サムネイル高さ設定を更新できませんでした。半角数字にしてください。'
        ) if ref $cgi::action;
        delete $main::data{ $this->{'id'} . '_previewheight' };
        $is_valid = 0;
    }
    if ( $main::data{ $this->{'id'} . '_apiurl' }
        && !$main::data{ $this->{'id'} . '_previewwidth' } )
    {
        my $thumnail
            = $this->get_website_thumnail_url(
            $main::data{ $this->{'id'} . '_apiurl' },
            'http://www.google.com/' );
        if ($thumnail) {
            require CMONOS::CGI_Lib::HTTP_Client;
            my $res = HTTP_Client->new->request( 'GET' => $thumnail );
            if ( $res->is_success ) {
                my $content = $res->content;
                (   $main::data{ $this->{'id'} . '_previewwidth' },
                    $main::data{ $this->{'id'} . '_previewheight' }
                ) = $cgi::Image->info( \$content );
            }
        }
    }
    return $is_valid;
}

sub get_website_thumnail_url ($$$) {
    my ( $this, $api, $url ) = @_;
    $url = $this->url_encode($url) if $url && $api =~ /\?/ && $api =~ /=/;
    return ( $url && $api =~ s/\%u/$url/g ) ? $api : '';
}

######################################################################
#	(8) obj->sort_enabled;
sub sort_enabled ($) {
    my $this = shift;
    return 0;
}

######################################################################
#	(9) obj->cookie_enabled;
sub cookie_enabled ($) {
    my $this = shift;
    return 0;
}

######################################################################
sub get_enclosure_attributes ($$$$$) {
    my ( $this, $str, $path, $c, $n ) = @_;
    my ( %data, $size );
    %data
        = ( ref $str eq 'HASH' )
        ? ( defined $$str{'str'} )
            ? $this->elements( $$str{'str'} )
            : %$str
        : $this->elements($str);
    return () if !$data{'type'};
    $path = $path . '/' . $this->{'id'} . '.' . $data{'type'};
    $size = -s $path;
    return (
        'url'    => $this->full_path($path),
        'length' => ( ($size) ? $size : '' ),
        'type'   => (
            ( $data{'type'} && $Common::mime_type{ $data{'type'} } )
            ? $Common::mime_type{ $data{'type'} }
            : 'application/octet-stream'
        )
    );
}

######################################################################
#sub import {
BEGIN {
    Field::class_register( 'file_banner', 'Banner', 'バナー' );
    $setting::deco_dir{'jump'}  = 'ジャンプボタン';
    $setting::deco_type{'jump'} = 'button';
}

1;
