package CheckBox;
require CMONOS::CGI_Lib::Field::Select;
@ISA = qw(Select);
use strict;
use utf8;
######################################################################
# フィールドモジュール（選択ボタン）
# CheckBox.pm 1.1.1
# Copyright (C) 1999-2018 CMONOS Co. Ltd.
#
# support@cmonos.jp
# http://cmonos.jp/
# 最終更新日：2014-08-11
######################################################################
sub select_menu ($$;$$$) {
    my ( $this, $name, $boxtype, $value, $is_invalid ) = @_;
    my ( $form, @menu );
    $boxtype = ($boxtype) ? 'checkbox' : 'radio';

    #名前にデータIDを埋め込む
    $name = 'data' if !defined $name || !$name;
    $name .= ':' . $this->{'id'} . ':str';

    #メニュー
    @menu = ( $this->{'default'} ) ? split( /\x0A/, $this->{'default'} ) : ();
    $form .= '<ol class="checkbox">' . "\x0A";
    foreach my $v (@menu) {
        $form
            .= '<li><label'
            . ( ($is_invalid) ? ' class="invalid-field"' : '' )
            . (
            ( $boxtype eq 'radio' && !$this->{'required'} )
            ? ' title="'
                . (
                ($default::english)
                ? 'Click the radio button to reset.'
                : '選択済みラジオボタンをクリックすると選択を解除できます。'
                )
                . '"'
            : ''
            )
            . '><input type="'
            . $boxtype
            . '" name="'
            . $name
            . '" value="'
            . $this->escape($v) . '"'
            . ( ( ref $value && @$value && grep( $_ eq $v, @$value ) )
            ? ' checked="checked"'
            : '' )
            . ( ($is_invalid)
            ? ( ( $boxtype eq 'checkbox' ) ? ' onchange' : ' onclick' )
                . '="cmonos.validate.field(this).bailOut()"'
            : '' )
            . ( ( $boxtype eq 'radio' && !$this->{'required'} )
            ? ' onmousedown="var t=this;if(t.checked)setTimeout(function(){t.checked=false},200)"'
            : '' )
            . ' /> '
            . $this->fix_value($v);
        $form .= ' <span class="unit">' . $this->{'unit'} . '</span>'
            if defined $this->{'unit'} && $this->{'unit'};
        $form .= '</label></li>' . "\x0A";
    }
    $form .= '</ol>' . "\x0A";
    return $form;
}

sub fix_value ($$) {
    my ( $this, $str ) = @_;
    return $this->tag_fix($str);
}

######################################################################
#	(5) obj->print_setting_form;
sub print_setting_form ($;$$) {
    my ( $this, $html_disabled ) = @_;
    my ($name);

    #名前
    $name = 'data:' . $this->{'id'};

    $this->print_field_info_form($name);

    print '<fieldset>';
    print '<legend>入力欄設定</legend>';
    print '<table class="field-table">';
    print '<tbody>';
    print '<tr class="tbody-end">';
    print
        '<td class="field-name"><span class="datatitle">タイプ</span></td>';
    print
        '<td class="q-field"><ol class="checkbox"><li><label><input type="radio" name="'
        . $name
        . '_multiple" value="0"'
        . ( ( !$this->{'multiple'} ) ? ' checked="checked"' : '' )
        . ' /> ラジオボタン</label></li><li><label><input type="radio" name="'
        . $name
        . '_multiple" value="1"'
        . ( ( $this->{'multiple'} ) ? ' checked="checked"' : '' )
        . ' /> チェックボックス</label></li></ol></td>';
    print '<td class="field-name"><label for="' . $name
        . '_unit">単位</label></td>';
    print '<td class="q-field"><input type="text" name="'
        . $name
        . '_unit" id="'
        . $name
        . '_unit" value="'
        . $this->escape( $this->{'unit'} )
        . '" size="8" /></td>';
    print '</tr>';
    print '<tr>';
    print '<td class="field-name"><label for="' . $name
        . '_default">選択肢設定</label></td>';
    print '<td class="field" colspan="3"><textarea name="'
        . $name
        . '_default" cols="56" rows="8" wrap="off">'
        . $this->escape( $this->{'default'} )
        . '</textarea><div class="note">選択項目ごとに改行します。</div></td>';
    print '</tr>';
    print '</tbody></table>';
    print '</fieldset>';
    $this->_print_setting_form($name);

    #文字設定
    $this->print_font_setting_form($name)
        if !defined $html_disabled || !$html_disabled;
    $this->print_setting_save_button;
    return;
}

######################################################################
#sub import {
BEGIN {
    Field::class_register( 'select_box', 'CheckBox', '選択ボタン' );
}

1;
