package Email;
require CMONOS::CGI_Lib::Field;
@ISA = qw(Field);
use strict;
use utf8;
######################################################################
# フィールド定義モジュール（メールアドレス）
# Email.pm 1.1.6
# Copyright (C) 1999-2018 CMONOS Co. Ltd.
#
# support@cmonos.jp
# http://cmonos.jp/
# 最終更新日：2012-10-30
######################################################################
sub _set ($$) {
    my ( $this, $setting ) = @_;
    unless ( ref $cgi::Deco ) {
        require CMONOS::CGI_Lib::Deco;
        $cgi::Deco = Deco->new;
    }
    $this->{'e-mail'} = 1;
    $this->{'field_for'}{'mail_address'} = []
        if !ref $this->{'field_for'}{'mail_address'};
    push( @{ $this->{'field_for'}{'mail_address'} }, $this->{'id'} );
    $this->__set($setting);
    return;
}

sub __set ($$) {
    my ( $this, $setting ) = @_;
    $this->{'single'} = 1
        if $this->{'field_for'}{'mail'}
        && $this->{'field_for'}{'mail'} eq $this->{'id'};
    return;
}

######################################################################
#	(1) obj->match(str);
sub match ($;$) {
    my ( $this, $str ) = @_;
    my ( $modifier, $p );
    return 1
        if !defined $main::search{ $this->{'id'} }{'str'}
        || $main::search{ $this->{'id'} }{'str'} eq '';
    if ( !ref $this->{'pattern'} ) {
        $main::search{ $this->{'id'} }{'str'}
            = $this->z_to_h( $main::search{ $this->{'id'} }{'str'} );
        @{ $this->{'pattern'} } = $this->make_patterns(
            \$main::search{ $this->{'id'} }{'str'},
            (   (          $this->{'ignoreCase'}
                        || $main::search{ $this->{'id'} }{'i'}
                ) ? 1 : 0
            ),
            $main::search{ $this->{'id'} }{'mode'}
        );
    }
    return $this->pattern_matched(
        $str,
        $this->{'pattern'},
        (   ( $this->{'ignoreCase'} || $main::search{ $this->{'id'} }{'i'} )
            ? 1
            : 0
        ),
        $main::search{ $this->{'id'} }{'mode'}
    );
}

######################################################################
#	(2) obj->form;
sub form {
    my ( $this, $status ) = @_;
    my ( $name, $form, $event );

    #名前にデータIDを埋め込む
    $name = 'data:' . $this->{'id'} . ':str';

    #ログインアドレスに固定
    if ( $this->{'fixed'} && !$this->is_staff && $this->is_registered_email )
    {
        return $this->field_header( '40', $name )
            . (
            ( $this->{'required'} )
            ? '<input type="hidden" name="'
                . $name
                . '" value="'
                . $this->escape($main::email) . '" />'
                . $this->escape($main::email)
            : '<label><input type="checkbox" name="'
                . $name
                . '" value="'
                . $this->escape($main::email) . '"'
                . (
                ( $main::data{ $this->{'id'} }{'str'} )
                ? ' checked="checked"'
                : ''
                )
                . ' /> '
                . $this->escape($main::email)
                . '</label>'
            ) . $this->field_footer;
    }

    #フィールドネーム+ヘッダ
    $form = $this->field_header( $this->{'cols'}, $name );

    #チェック項目
    $event .= ' onchange="cmonos.validate.field(this).asEMailAddress()"';
    $event .= ' class="invalid-field"' if $this->{'is_invalid_field'}{'str'};

    #デフォルト作成
    if (( !defined $status || $status eq '' )
        && ( !defined $main::data{ $this->{'id'} }{'str'}
            || $main::data{ $this->{'id'} }{'str'} eq '' )
        )
    {
        $main::data{ $this->{'id'} }{'str'} = $this->{'default'};

        #設定補足
        $main::data{ $this->{'id'} }{'str'} = $main::email
            if defined $main::email
            && $main::email ne ''
            && $this->is_invalid_email_address_header(
            $main::data{ $this->{'id'} }{'str'} );
    }
    $this->{'cols'} = 40 if !defined $this->{'cols'} || !$this->{'cols'};

    #高さが1以下の場合
    if (   !defined $this->{'rows'}
        || $this->{'rows'} eq ''
        || $this->{'rows'} <= 1 )
    {
        $main::data{ $this->{'id'} }{'str'} =~ s/\x0A//gs
            if defined $main::data{ $this->{'id'} }{'str'}
            && $main::data{ $this->{'id'} }{'str'} ne '';
        $form
            .= '<input type="'
            . ( ( $this->{'single'} ) ? 'email' : 'text' )
            . '" name="'
            . $name
            . '" id="'
            . $name
            . '" size="'
            . $this->{'cols'} . '"';
        $form
            .= ' placeholder="'
            . $this->escape( $this->{'placeholder'} ) . '"'
            if defined $this->{'placeholder'} && $this->{'placeholder'} ne '';
        $form .= ' value="' . $main::data{ $this->{'id'} }{'str'} . '"'
            if defined $main::data{ $this->{'id'} }{'str'}
            && $main::data{ $this->{'id'} }{'str'} ne '';
        $form .= ' required="required"' if $this->{'required'};
        $form .= $event . ' />';

        #高さが2以上の場合
    }
    else {
        $form
            .= '<textarea name="'
            . $name
            . '" id="'
            . $name
            . '" cols="'
            . $this->{'cols'}
            . '" rows="'
            . $this->{'rows'} . '"'
            . $event
            . ' wrap="off"';
        $form
            .= ' placeholder="'
            . $this->escape( $this->{'placeholder'} ) . '"'
            if defined $this->{'placeholder'} && $this->{'placeholder'} ne '';
        $form .= ' required="required"' if $this->{'required'};
        $form .= '>';
        $form .= $main::data{ $this->{'id'} }{'str'}
            if defined $main::data{ $this->{'id'} }{'str'}
            && $main::data{ $this->{'id'} }{'str'} ne '';
        $form .= '</textarea>';
    }

    $form .= $this->field_footer;
    return $form;
}

######################################################################
#	(3) obj->is_valid_data(path);
sub is_valid_data ($;$) {
    my $this = shift;
    delete $this->{'is_invalid_field'} if ref $this->{'is_invalid_field'};
    my ($is_valid);

    #ログインアドレスに固定
    if ( $this->{'fixed'} && !$this->is_staff && $this->is_registered_email )
    {
        $main::data{ $this->{'id'} }{'str'}
            = ( $this->{'required'} || $main::data{ $this->{'id'} }{'str'} )
            ? $main::email
            : '';
        $is_valid = 1;

    }
    else {

        $this->escape_data_tag('str');

        #半角変換
        $main::data{ $this->{'id'} }{'str'}
            = $this->z_to_h( $main::data{ $this->{'id'} }{'str'} );

        #必須項目/文字数チェック
        $is_valid
            = $this->is_not_empty('str') && $this->is_not_too_long('str');

        #書式チェック
        if ($main::data{ $this->{'id'} }{'str'} ne ''
            && ((   $this->{'single'} && $this->is_invalid_email_address(
                        $main::data{ $this->{'id'} }{'str'}
                    )
                )
                || (!$this->{'single'}
                    && $this->is_invalid_email_address_header(
                        $main::data{ $this->{'id'} }{'str'}
                    )
                )
            )
            )
        {
            if ($default::english) {
                push(
                    @{ $cgi::action->{'dialog'} },
                    '"'
                        . (
                        ( defined $this->{'name'} && $this->{'name'} )
                        ? $this->{'name'}
                        : ''
                        )
                        . '" field is not e-mail address.'
                ) if ref $cgi::action;
            }
            else {
                push(
                    @{ $cgi::action->{'dialog'} },
                    ( ( $this->{'name'} ) ? $this->{'name'} : '入力' )
                        . 'を確認してください。'
                ) if ref $cgi::action;
            }
            $is_valid = 0;
        }
    }

    if ($is_valid) {
        $cookie::data{ 'data:' . $this->{'id'} . ':str' }
            = $main::data{ $this->{'id'} }{'str'}
            if $this->{'cookie'} && $main::set_cookie;
    }
    else {
        $this->{'is_invalid_field'}{'str'} = 1;
    }
    return $is_valid;
}

######################################################################
#	(4) obj->usual_format(str);
sub usual_format {
    my ( $this, $str ) = @_;
    $str = $$str{'str'} if ref $str eq 'HASH';
    return $this->field_tag('') if !defined $str || $str eq '';

    if ( $this->{'button'} ) {
        $this->use_deco($cgi::output);
        my ( @email, $email, $email_title );
        @email = $this->get_address($str);
        $email = join( ',', @email );
        $email_title
            = ( $this->{'addressProtector'} )
            ? ( ($default::english)
            ? 'E-Mail'
            : 'メールソフトを開きます。' )
            : $this->address_camouflage($str);
        $email
            = $this->address_protector( $email, $this->{'addressProtector'} );
        return $this->field_tag(
            $this->data_tag_from_hash(
                'str',
                $this->address_camouflage(
                    $str, $this->{'addressProtector'}
                )
                )
                . $cgi::Deco->button(
                'email', $this->{'button'}, $email,
                $email_title, '', '', '', 0, 1
                )
        );

    }
    else {
        $str =~ s/\x20+/ /g;
        $this->escape( \$str );
        $str =~ s/[\x0A\x0D]+/<br \/>/g;
        $this->autolink( \$str, 0, $this->{'addressProtector'} );
        return $this->field_tag(
            $this->style(
                $this->data_tag( 'str', $str ), $this->{'style'},
                $this->{'fontsize'}, $this->{'fontcolor'},
                $this->{'fontface'}
            )
        );
    }
}

sub format_for_mail {
    my ( $this, $str ) = @_;
    $str = $$str{'str'} if ref $str eq 'HASH';
    return '' if !defined $str || $str eq '';
    $str =~ s/,[\x09\x0A\x0C\x0D\x20]*/,\x0A/g
        if $this->str_length($str) > 70;
    $str = '[' . $this->name . "]\x0A" . $str;
    $str =~ s/[\x0A]*\Z/\x0A\x0A/s;
    return $str;
}

#---------------------------------------------------------------------
#	(4)-5 obj->confirmation(str);
sub confirmation_enabled ($) {
    my $this = shift;
    return 1;
}

sub confirmation ($$) {
    my ( $this, $str ) = @_;
    $str = $$str{'str'} if ref $str eq 'HASH';
    return '' if !defined $str || $str eq '';
    $str =~ s/\x0A//g;
    return $this->escape($str);
}

######################################################################
#	(5) obj->print_setting_form;
sub print_setting_form ($;$$) {
    my ( $this, $html_disabled ) = @_;

    #名前
    my $name = 'data:' . $this->{'id'};

    $this->print_field_info_form($name);

    print '<fieldset>';
    print '<legend>入力欄設定</legend>';
    print '<table class="field-table">';
    print '<tbody>';
    print '<tr class="tbody-end">';
    print '<td class="field-name"><label for="' . $name
        . '_cols">入力欄横幅</label></td>';
    print '<td class="q-field"><input type="number" name="'
        . $name
        . '_cols" id="'
        . $name
        . '_cols" value="'
        . $this->escape( $this->{'cols'} )
        . '" size="3" title="入力欄の横幅を設定します。" /> <span class="unit">文字（半角）</span></td>';
    print '<td class="field-name"><label for="' . $name
        . '_rows">入力欄高さ</label></td>';
    print '<td class="q-field"><input type="number" name="'
        . $name
        . '_rows" id="'
        . $name
        . '_rows" value="'
        . $this->escape( $this->{'rows'} )
        . '" size="3" title="入力欄の高さを設定します。" /> <span class="unit">文字</span></td>';
    print '</tr>';
    print '</tbody>';
    print '<tbody>';

    if (  !$this->{'field_for'}{'mail'}
        || $this->{'field_for'}{'mail'} ne $this->{'id'} )
    {
        print '<tr>';
        print
            '<td class="field-name"><span class="datatitle">入力形式</span></td>';
        print
            '<td class="field" colspan="3"><label><input type="checkbox" name="'
            . $name
            . '_single" value="1"'
            . ( ( $this->{'single'} ) ? ' checked="checked"' : '' )
            . ' /> 一つのメールアドレスのみを入力する<span class="note">(チェックなしで複数入力可能)</span>。</label></td>';
        print '</tr>';
    }
    print '<tr class="tbody-end">';
    print
        '<td class="field-name"><span class="datatitle">入力を固定</span></td>';
    print '<td class="field" colspan="3"><label><input type="checkbox" name="'
        . $name
        . '_fixed" value="1"'
        . ( ( $this->{'fixed'} ) ? ' checked="checked"' : '' )
        . ' /> ログインメールアドレスを使用する。</label></td>';
    print '</tr>';
    print '</tbody>';
    print '<tbody>';
    print '<tr>';
    print '<td class="field-name"><label for="' . $name
        . '_default">デフォルト</label></td>';
    print '<td class="field" colspan="3"><textarea name="'
        . $name
        . '_default" id="'
        . $name
        . '_default" cols="56" rows="6" wrap="off" title="入力欄のデフォルトの値を設定します。">'
        . $this->escape( $this->{'default'} )
        . '</textarea></td>';
    print '</tr>';
    print '<tr>';
    print '<td class="field-name"><label for="' . $name
        . '_placeholder">プレースホルダ</label></td>';
    print '<td class="field" colspan="3"><input type="text" name="'
        . $name
        . '_placeholder" id="'
        . $name
        . '_placeholder" size="'
        . ( ( $this->{'cols'} ) ? $this->{'cols'} : '72' )
        . '" title="入力欄の placeholder 属性の値を設定します。" value="'
        . $this->escape( $this->{'placeholder'} )
        . '" /></td>';
    print '</tr>';
    print '</tbody></table>';
    print '</fieldset>';

    if (   $this->{'field_for'}{'mail'}
        && $this->{'field_for'}{'mail'} eq $this->{'id'} )
    {
        print '<input type="hidden" name="' . $name . '_single" value="1" />';
    }

    if ( !defined $html_disabled || !$html_disabled ) {
        print '<fieldset><legend>メールアドレス表示設定</legend>';
        print '<fieldset><legend>ボタン</legend>';

        #ボタンメニュー
        print $cgi::Deco->button_menu( $name . '_button',
            'email', 120, $this->{'button'} );
        print
            '<div class="note">設定がない場合、E-Mailアドレスが表示されます。</div></fieldset>';
        print
            '<fieldset><legend>メールアドレスの保護</legend><label><input type="checkbox" name="'
            . $name
            . '_addressProtector" value="1"'
            . (
            (   defined $this->{'addressProtector'}
                    && $this->{'addressProtector'}
            ) ? ' checked="checked"' : ''
            )
            . ' /> メールアドレスを JavaScript + CSS + HTML エンティティで保護する。</label></fieldset>';
        print '</fieldset>';

        $this->print_ignorecase_setting_form($name);

        $this->print_font_setting_form($name);
    }

    $this->print_setting_save_button;
    return;
}

######################################################################
#	(6) obj->is_valid_setting;
sub is_valid_setting ($) {
    my $this = shift;

    #文字色チェック
    my $is_valid = $this->is_valid_font_setting;

    if (   $main::data{ $this->{'id'} . '_cols' } ne ''
        && $this->is_nan( $main::data{ $this->{'id'} . '_cols' } ) )
    {
        push(
            @{ $cgi::action->{'dialog'} },
            '横幅を更新できませんでした。半角数字にしてください。'
        ) if ref $cgi::action;
        delete $main::data{ $this->{'id'} . '_cols' };
        $is_valid = 0;
    }
    if (   $main::data{ $this->{'id'} . '_rows' } ne ''
        && $this->is_nan( $main::data{ $this->{'id'} . '_rows' } ) )
    {
        push(
            @{ $cgi::action->{'dialog'} },
            '高さを更新できませんでした。半角数字にしてください。'
        ) if ref $cgi::action;
        delete $main::data{ $this->{'id'} . '_rows' };
        $is_valid = 0;
    }
    if (   $this->{'field_for'}{'mail'}
        && $this->{'field_for'}{'mail'} eq $this->{'id'}
        && !$main::data{ $this->{'id'} . '_single' } )
    {
        push(
            @{ $cgi::action->{'dialog'} },
            '「代表メールフィールド」に指定されているのでメールアドレスは一つに限られます。'
        ) if ref $cgi::action;
        $main::data{ $this->{'id'} . '_single' } = 1;
    }
    elsif ( !$main::data{ $this->{'id'} . '_single' } ) {
        $main::data{ $this->{'id'} . '_single' } = '';
    }

    $this->tag_fix( \$main::data{ $this->{'id'} . '_description' } )
        if defined $main::data{ $this->{'id'} . '_description' }
        && $main::data{ $this->{'id'} . '_description' };
    $this->tag_fix( \$main::data{ $this->{'id'} . '_note' } )
        if defined $main::data{ $this->{'id'} . '_note' }
        && $main::data{ $this->{'id'} . '_note' };
    $main::data{ $this->{'id'} . '_addressProtector' } = ''
        if !defined $main::data{ $this->{'id'} . '_addressProtector' }
        || !$main::data{ $this->{'id'} . '_addressProtector' };
    $main::data{ $this->{'id'} . '_placeholder' } =~ s/[\x0A\x0D]+//sg
        if defined $main::data{ $this->{'id'} . '_placeholder' };
    $main::data{ $this->{'id'} . '_ignoreCase' } = ''
        if !$main::data{ $this->{'id'} . '_ignoreCase' };
    $main::data{ $this->{'id'} . '_fixed' } = ''
        if !$main::data{ $this->{'id'} . '_fixed' };
    return $is_valid;
}

######################################################################
#	sample
sub sample ($$) {
    my ( $this, $str ) = @_;
    return ( defined $str ) ? $str : '';
}

######################################################################
#sub import {
BEGIN {
    Field::class_register( 'text_email', 'Email', 'メールアドレス' );
    $setting::deco_dir{'email'}  = 'Eメールボタン';
    $setting::deco_type{'email'} = 'button';
}

1;
