package IP;
require CMONOS::CGI_Lib::Field;
@ISA = qw(Field);
use strict;
use utf8;
######################################################################
# フィールドモジュール（記入者IP）
# IP.pm 1.0.1
# Copyright (C) 1999-2018 CMONOS Co. Ltd.
#
# support@cmonos.jp
# http://cmonos.jp/
# 最終更新日：2010-06-14
######################################################################
#	(0)-3 フィールドDB
sub db ($) {
    my $this = shift;
    return 'ip';
}

######################################################################
#	(2) obj->input_enabled;
sub input_enabled ($) {
    my $this = shift;
    return 0;
}

sub form {
    my ( $this, $status, $original ) = @_;
    $main::data{ $this->{'id'} }{'str'}
        = $ENV{'REMOTE_HOST'} || $this->to_host( $ENV{'REMOTE_ADDR'} );
    my $form = $this->field_header;
    $form .= $main::data{ $this->{'id'} }{'str'};
    $form .= $this->field_footer;
    return $form;
}

######################################################################
#	(3) obj->is_valid_data(path);
sub is_valid_data ($;$) {
    my $this = shift;
    $main::data{ $this->{'id'} }{'str'}
        = $ENV{'REMOTE_HOST'} || $this->to_host( $ENV{'REMOTE_ADDR'} );
    return 1;
}

######################################################################
#	(4) obj->usual_format(str);
sub usual_format {
    my ( $this, $str ) = @_;
    $str = $$str{'str'} if ref $str eq 'HASH';
    return $this->field_tag(
        $this->style(
            $this->data_tag( 'str', $str ), $this->{'style'},
            $this->{'fontsize'}, $this->{'fontcolor'},
            $this->{'fontface'}
        )
    );
}

sub has_content {
    my $this = shift;
    return 1;
}

#---------------------------------------------------------------------
#	(4) obj->format_for_mail(str);
sub format_for_mail {
    my ( $this, $str ) = @_;
    $str = $$str{'str'} if ref $str eq 'HASH';
    return '' if !defined $str || $str eq '';
    return '[' . $this->name . "]\x0A" . $str . "\x0A\x0A";
}

#	(4)-3 obj->format_for_text(str);
sub format_for_text {
    my ( $this, $str ) = @_;
    $str = $$str{'str'} if ref $str eq 'HASH';
    return $str;
}

######################################################################
#	(5) obj->print_setting_form;
sub print_setting_form ($;$$) {
    my ( $this, $html_disabled ) = @_;

    #名前
    my $name = 'data:' . $this->{'id'};

    $this->print_field_info_form($name);

    #文字設定
    $this->print_font_setting_form($name)
        if !defined $html_disabled || !$html_disabled;

    $this->print_setting_save_button;
    return;
}

######################################################################
#	(6) obj->is_valid_setting;
sub is_valid_setting ($) {
    my $this = shift;
    $this->tag_fix( \$main::data{ $this->{'id'} . '_description' } )
        if defined $main::data{ $this->{'id'} . '_description' }
        && $main::data{ $this->{'id'} . '_description' };
    $this->tag_fix( \$main::data{ $this->{'id'} . '_note' } )
        if defined $main::data{ $this->{'id'} . '_note' }
        && $main::data{ $this->{'id'} . '_note' };
    return $this->is_valid_font_setting;
}

######################################################################
#	sample
sub sample ($$) {
    my ( $this, $str ) = @_;
    return ( defined $str ) ? $str : '';
}

######################################################################
#	(9) obj->cookie_enabled;
sub cookie_enabled ($) {
    my $this = shift;
    return 0;
}

######################################################################
#	(10) obj->required_enabled;
sub required_enabled ($) {
    my $this = shift;
    return 0;
}

######################################################################
#sub import {
BEGIN {
    Field::class_register( 'user_ip', 'IP', '記入者IP' );
}

1;
