package ImageSelector;
require CMONOS::CGI_Lib::Field;
@ISA = qw(Field);
use strict;
use utf8;
######################################################################
# フィールド定義モジュール（画像選択）
# ImageSelector.pm 1.1.2
# Copyright (C) 1999-2018 CMONOS Co. Ltd.
#
#　support@cmonos.jp
#　http://cmonos.jp/
#
######################################################################
sub _set ($$) {
    my ( $this, $setting ) = @_;
    unless ( ref $cgi::Image ) {
        require CMONOS::CGI_Lib::Image;
        $cgi::Image = Image->new;
    }
    $this->{'border'} = '0' if !$this->{'border'};
    $this->scalar_to_array( \$this->{'images'} );
    return;
}

#	(0)-8 obj->align;
sub align ($) {
    my $this = shift;
    return 'center';
}

######################################################################
#	(1)-0 obj->match_enabled;
sub match_enabled ($) {
    my $this = shift;
    return 1
        if ( ref $main::search{ $this->{'id'} }{'images'}
        && @{ $main::search{ $this->{'id'} }{'images'} } )
        || ( defined $main::search{ $this->{'id'} }{'images'}
        && $main::search{ $this->{'id'} }{'images'} ne '' );
    return 0;
}

#	(1) obj->match(str);
sub match ($;$) {
    my ( $this, $str ) = @_;
    return 1
        unless ( ref $main::search{ $this->{'id'} }{'images'}
        && @{ $main::search{ $this->{'id'} }{'images'} } )
        || ( defined $main::search{ $this->{'id'} }{'images'}
        && $main::search{ $this->{'id'} }{'images'} ne '' );
    $this->scalar_to_array( \$main::search{ $this->{'id'} }{'images'} );

    my ( @image, $img );
    @image = ( defined $$str ) ? split( /,/, $$str ) : ();

    foreach $img ( @{ $main::search{ $this->{'id'} }{'images'} } ) {
        if ( grep( $_ eq $img, @image ) ) {
            return 1
                if !defined $main::search{ $this->{'id'} }{'mode'}
                || $main::search{ $this->{'id'} }{'mode'} ne 'and';
        }
        elsif ( defined $main::search{ $this->{'id'} }{'mode'}
            && $main::search{ $this->{'id'} }{'mode'} eq 'and' )
        {
            return 0;
        }
    }
    if ( defined $main::search{ $this->{'id'} }{'mode'}
        && $main::search{ $this->{'id'} }{'mode'} eq 'and' )
    {
        return 1;
    }
    else {
        return 0;
    }
}

######################################################################
#	(2) obj->form;
sub form {
    my ( $this, $status, $original, $path ) = @_;
    my ($form);

    #フィールドネーム+ヘッダ
    $form = $this->field_header;

    #画像選択フォーム
    $this->scalar_to_array( \$main::data{ $this->{'id'} }{'images'} );
    @{ $main::data{ $this->{'id'} }{'images'} }
        = split( /,/, $main::data{ $this->{'id'} }{'str'} )
        if !@{ $main::data{ $this->{'id'} }{'images'} }
        && defined $main::data{ $this->{'id'} }{'str'}
        && $main::data{ $this->{'id'} }{'str'} ne '';
    $form .= $this->image_selector_form(
        'data:' . $this->{'id'} . ':images',
        $this->{'multiple'},
        $this->{'required'},
        $this->{'allImages'},
        $main::data{ $this->{'id'} }{'images'},
        $this->{'is_invalid_field'}{'images'}
    );

    $form .= $this->field_footer;
    return $form;
}

#画像選択フォーム
sub image_selector_form ($$;$$$$$) {
    no warnings qw(numeric);
    my ( $this, $name, $multiple, $required, $all, $default,
        $is_invalid_field )
        = @_;
    return '画像が用意されていません。'
        if !ref $setting::deco{'misc'} || !%{ $setting::deco{'misc'} };
    my ( $form, $type, $script, @images );
    $type = ($multiple) ? 'checkbox' : 'radio';
    $script
        = ($is_invalid_field)
        ? ' onclick="cmonos.validate.field(this.parentNode.parentNode.parentNode.parentNode.parentNode).bailOut()"'
        : '';

    $form .= '<ul class="materials'
        . ( ($is_invalid_field) ? ' invalid-field' : '' ) . '">';

    #空選択肢
    $form
        .= '<li><input name="'
        . $name
        . '" type="'
        . $type
        . '" value=""'
        . ( ( !ref $default || !@$default ) ? ' checked="checked"' : '' )
        . $script
        . ' /></li>'
        if !$multiple && !$required;

    if ( defined $all && $all ) {
        @images = sort { $a <=> $b } keys %{ $setting::deco{'misc'} };
    }
    else {
        @images = sort { $a <=> $b } @{ $this->{'images'} };
    }
    @images = grep( defined $_ && $_ ne '', @images );
    return '画像が用意されていません。' if !@images;
    foreach my $img (@images) {
        next
            if !defined $setting::deco{'misc'}{$img}{'width'}
            || !$setting::deco{'misc'}{$img}{'width'};
        $form
            .= '<li><label class="img"><input name="'
            . $name
            . '" type="'
            . $type
            . '" value="'
            . $img . '"'
            . ( ( ref $default && grep( $_ eq $img, @$default ) )
            ? ' checked="checked"'
            : '' )
            . $script . ' />'
            . $cgi::Image->image_tag(
            $env::image_dir . '/misc/' . $setting::deco{'misc'}{$img}{'name'},
            $setting::deco{'misc'}{$img}{'width'},
            $setting::deco{'misc'}{$img}{'height'},
            $this->{'border'},
            (   ( $setting::deco{'misc'}{$img}{'alt'} )
                ? $setting::deco{'misc'}{$img}{'alt'}
                : $img
            ),
            '',
            $this->{'widthlimit'},
            $this->{'heightlimit'}
            ) . '</label></li>';
    }

    $form .= '</ul>';
    return $form;
}

######################################################################
#	(3) obj->is_valid_data(path);
sub is_valid_data ($;$) {
    my $this = shift;
    delete $this->{'is_invalid_field'} if ref $this->{'is_invalid_field'};
    if (   !defined $main::data{ $this->{'id'} }{'str'}
        || !$main::data{ $this->{'id'} }{'str'} )
    {
        $this->scalar_to_array( \$main::data{ $this->{'id'} }{'images'} );
        @{ $main::data{ $this->{'id'} }{'images'} }
            = grep( $_ ne '' && $_ !~ /[^0-9]/,
            @{ $main::data{ $this->{'id'} }{'images'} } );
        $main::data{ $this->{'id'} }{'str'}
            = join( ',', @{ $main::data{ $this->{'id'} }{'images'} } );
    }
    elsif ( $main::data{ $this->{'id'} }{'str'} =~ /[^0-9a-zA-Z_:,]/ ) {
        $main::data{ $this->{'id'} }{'str'} = '';
    }

    #入力のチェック
    if ( $this->is_not_empty('str') ) {
        $cookie::data{ 'data:' . $this->{'id'} . ':str' }
            = $main::data{ $this->{'id'} }{'str'}
            if $this->{'cookie'} && $main::set_cookie;
        return 1;
    }
    else {
        $this->{'is_invalid_field'}{'images'} = 1;
        return 0;
    }
}

######################################################################
#	(4) obj->usual_format(str,path,category,no);
#	str=表示するデータ/path=ファイル保存ディレクトリ
sub usual_format {
    my ( $this, $str, $path ) = @_;
    $str = $$str{'str'} if ref $str eq 'HASH';
    my $image_dir = $env::image_dir . '/misc';
    $image_dir
        = $this->base_change( $image_dir, $cgi::output, $cgi::output_option )
        if $cgi::output || $cgi::output_option;
    my ( @images, $img, $id );
    $img = '';
    @images = ( defined $str ) ? split( /,/, $str ) : ();
    foreach $id ( sort { $a <=> $b } @images ) {

        if ( $setting::deco{'misc'}{$id}{'width'} ) {
            $img .= $cgi::Image->image_tag(
                $image_dir . '/' . $setting::deco{'misc'}{$id}{'name'},
                $setting::deco{'misc'}{$id}{'width'},
                $setting::deco{'misc'}{$id}{'height'},
                $this->{'border'},
                (   ( defined $setting::deco{'misc'}{$id}{'alt'} )
                    ? $setting::deco{'misc'}{$id}{'alt'}
                    : $id
                )
            );
        }
    }
    return $this->field_tag(
        $this->data_tag_from_hash( 'str', $str ) . $img );
}

sub image_file_url ($$$$) {
    my ( $this, $str, $path, $c, $n ) = @_;
    return '' if !$str;
    my @images = ( defined $str ) ? split( /,/, $str ) : ();
    return (   @images
            && $images[0]
            && ref $setting::deco{'misc'}{ $images[0] }
            && ref $setting::deco{'misc'}{ $images[0] }{'name'} )
        ? $this->full_path( $env::image_dir
            . '/misc/'
            . $setting::deco{'misc'}{ $images[0] }{'name'} )
        : '';
}

#---------------------------------------------------------------------
#	(4)-2 obj->format_for_mail(str);
sub format_for_mail {
    my ( $this, $str ) = @_;
    $str = $$str{'str'} if ref $str eq 'HASH';
    return '' if !defined $str || $str eq '';
    my ( @images, $id );
    @images = ( defined $str ) ? split( /,/, $str ) : ();
    $str = '';
    foreach $id ( sort { $a <=> $b } @images ) {
        $str
            .= ( ( $str ne '' ) ? ',' : '' )
            . ( ( defined $setting::deco{'misc'}{$id}{'alt'} )
            ? $setting::deco{'misc'}{$id}{'alt'}
            : $id );
    }
    $str = '[' . $this->name . "]\x0A" . $str;
    $str =~ s/[\x0A]*\Z/\x0A\x0A/s;
    return $str;
}

#---------------------------------------------------------------------
#	(4)-4 obj->format_for_text(str);
sub format_for_text {
    my ( $this, $str ) = @_;
    $str = $$str{'str'} if ref $str eq 'HASH';
    return '' if !defined $str || $str eq '';
    my ( @images, $id );
    @images = ( defined $str ) ? split( /,/, $str ) : ();
    $str = '';
    foreach $id ( sort { $a <=> $b } @images ) {
        $str
            .= ( ( $str ne '' ) ? ',' : '' )
            . ( ( defined $setting::deco{'misc'}{$id}{'alt'} )
            ? $setting::deco{'misc'}{$id}{'alt'}
            : $id );
    }
    return $str;
}

######################################################################
#	(5) obj->print_setting_form;
sub print_setting_form ($;$$) {
    my $this = shift;

    #名前
    my $name = 'data:' . $this->{'id'};

    $this->print_field_info_form($name);

    print '<fieldset>';
    print '<legend>選択肢表示設定</legend>';
    print '<table class="field-table">';
    print '<tbody>';
    print '<tr>';
    print '<td class="field-name"><label for="' . $name
        . '_widthlimit">最大横幅</label></td>';
    print '<td class="field"><input type="number" name="'
        . $name
        . '_widthlimit" id="'
        . $name
        . '_widthlimit" value="'
        . $this->escape( $this->{'widthlimit'} )
        . '" size="3" /> <span class="unit">ピクセル</span></td>';
    print '</tr>';
    print '<tr>';
    print '<td class="field-name"><label for="' . $name
        . '_heightlimit">最大高さ</label></td>';
    print '<td class="field"><input type="number" name="'
        . $name
        . '_heightlimit" id="'
        . $name
        . '_heightlimit" value="'
        . $this->escape( $this->{'heightlimit'} )
        . '" size="3" /> <span class="unit">ピクセル</span></td>';
    print '</tr>';
    print '<tr>';
    print '<td class="field-name"><label for="' . $name
        . '_border">枠線幅</label></td>';
    print '<td class="field"><input type="text" name="'
        . $name
        . '_border" id="'
        . $name
        . '_border" value="'
        . $this->escape( $this->{'border'} )
        . '" size="3" /> <span class="unit">ピクセル</span></td>';
    print '</tr>';
    print '</tbody></table>';
    print '</fieldset>';
    print '<fieldset>';
    print '<legend>選択肢画像設定</legend>';

    print '<fieldset>';
    print '<legend>選択肢画像</legend>';
    print $this->image_selector_form( $name . '_images',
        1, 0, 1, $this->{'images'} );
    print '</fieldset>';

    print '<ol class="checkbox">';
    print '<li><label><input type="checkbox" name="'
        . $name
        . '_allImages" value="1"'
        . ( ( defined $this->{'allImages'} && $this->{'allImages'} )
        ? ' checked="checked"'
        : '' )
        . ' /> 全ての素材を選択肢とする</label></li>';
    print '<li><label><input type="checkbox" name="'
        . $name
        . '_multiple" value="1"'
        . ( ( defined $this->{'multiple'} && $this->{'multiple'} )
        ? ' checked="checked"'
        : '' )
        . ' /> 複数選択可</label></li>';
    print '</ol>';
    print '</fieldset>';

    $this->print_setting_save_button;
}

######################################################################
#	(6) obj->is_valid_setting;
sub is_valid_setting ($) {
    my $this     = shift;
    my $is_valid = 1;

    #チェックボックス
    $main::data{ $this->{'id'} . '_allImages' } = ''
        if !defined $main::data{ $this->{'id'} . '_allImages' }
        || $main::data{ $this->{'id'} . '_allImages' } eq '';
    $main::data{ $this->{'id'} . '_multiple' } = ''
        if !defined $main::data{ $this->{'id'} . '_multiple' }
        || $main::data{ $this->{'id'} . '_multiple' } eq '';
    $main::data{ $this->{'id'} . '_images' } = ''
        if !defined $main::data{ $this->{'id'} . '_images' };

    #数字チェック
    if (   defined $main::data{ $this->{'id'} . '_widthlimit' }
        && $main::data{ $this->{'id'} . '_widthlimit' } ne ''
        && $this->is_nan( $main::data{ $this->{'id'} . '_widthlimit' } ) )
    {
        push(
            @{ $cgi::action->{'dialog'} },
            '最大横幅を更新できませんでした。半角数字にしてください。'
        ) if ref $cgi::action;
        delete $main::data{ $this->{'id'} . '_widthlimit' };
        $is_valid = 0;
    }
    if (   defined $main::data{ $this->{'id'} . '_heightlimit' }
        && $main::data{ $this->{'id'} . '_heightlimit' } ne ''
        && $this->is_nan( $main::data{ $this->{'id'} . '_heightlimit' } ) )
    {
        push(
            @{ $cgi::action->{'dialog'} },
            '最大高さを更新できませんでした。半角数字にしてください。'
        ) if ref $cgi::action;
        delete $main::data{ $this->{'id'} . '_heightlimit' };
        $is_valid = 0;
    }

    $this->tag_fix( \$main::data{ $this->{'id'} . '_description' } )
        if defined $main::data{ $this->{'id'} . '_description' }
        && $main::data{ $this->{'id'} . '_description' };
    $this->tag_fix( \$main::data{ $this->{'id'} . '_note' } )
        if defined $main::data{ $this->{'id'} . '_note' }
        && $main::data{ $this->{'id'} . '_note' };
    return $is_valid;
}

######################################################################
#	(6) obj->search_form;
sub search_form ($) {
    my $this = shift;
    my ($form);
    $this->scalar_to_array( \$main::search{ $this->{'id'} }{'images'} );
    $form
        = '<tr><td class="field-name"><span class="datatitle">'
        . $this->{'name'}
        . '</span></td><td class="field">';
    $form
        .= $this->image_selector_form( 'search:' . $this->{'id'} . ':images',
        1, 0, $this->{'allImages'},
        $main::search{ $this->{'id'} }{'images'} );

    if ( defined $this->{'multiple'} && $this->{'multiple'} ) {

        #英語表記
        if ( defined $default::english && $default::english ) {
            $form .= $this->mk_select_menu(
                'search:' . $this->{'id'} . ':mode', '', '',
                $main::search{ $this->{'id'} }{'mode'},
                'and' => 'Matches on all selection',
                'or'  => 'Matches on any selection'
            );

            #日本語
        }
        else {
            $form .= $this->mk_select_menu(
                'search:' . $this->{'id'} . ':mode', '', '',
                $main::search{ $this->{'id'} }{'mode'},
                'and' => '全ての選択肢に一致',
                'or'  => 'いずれかの選択肢に一致'
            );
        }
    }

    $form .= '</td></tr>';

    return $form;
}

######################################################################
#	sample
sub sample ($$) {
    my ( $this, $str ) = @_;
    return ( defined $str ) ? $str : '';
}

######################################################################
#sub import {
BEGIN {
    if ( !$setting::field_for_mail ) {
        Field::class_register( 'select_image', 'ImageSelector',
            '画像選択' );
        $setting::deco_dir{'misc'}  = '画像選択用素材';
        $setting::deco_type{'misc'} = 'image';
    }
}

1;
