package IncludeBase;
require CMONOS::CGI_Lib::Field;
@ISA = qw(Field);
use strict;
use utf8;
######################################################################
# フィールドモジュール（外部記事埋め込み）
# IncludeBase.pm 1.0.1
# Copyright (C) 1999-2018 CMONOS Co. Ltd.
#
# support@cmonos.jp
# http://cmonos.jp/
# 最終更新日：2014-09-27
######################################################################
sub _set ($$) {
    my ( $this, $setting ) = @_;
    $this->{'elements'} = 1;
    $this->{'source'}   = 'hpml' if !$this->{'source'};
    $this->{'dir'}      = 'top' if !$this->{'dir'};
    $this->{'target'}   = 'section' if !$this->{'target'};
    $this->{'interval'} = 1
        if !$this->{'interval'} || $this->{'interval'} =~ /[^0-9]/s;
    return;
}

######################################################################
#	(2) obj->input_enabled;
sub form {
    my ( $this, $status, $original ) = @_;
    my $form = '';
    my ( $html, $here, $titleid )
        = $this->read_external_html( $main::data{ $this->{'id'} }{'url'} );
    if ($html
        || (   $this->{'source'}
            && $this->{'source'} eq 'url'
            && $this->{'userurl'} )
        )
    {
        $form = $this->field_header;
        $form .= '<dl>';
        if ( $this->{'source'} && $this->{'source'} eq 'url' ) {
            if ( $this->{'userurl'} ) {
                $form
                    .= '<dt><label for="data:'
                    . $this->{'id'}
                    . ':url">読み込み元URL</label></dt>';
                $form
                    .= '<dd><input type="url" id="data:'
                    . $this->{'id'}
                    . ':url" name="data:'
                    . $this->{'id'}
                    . ':url" size="40" value="'
                    . $this->escape(
                    (   ( !defined $status || $status eq '' )
                            && !$main::data{ $this->{'id'} }{'url'}
                    ) ? $this->{'url'} : $main::data{ $this->{'id'} }{'url'}
                    ) . '" /></dd>';
            }
            else {
                $form .= '<dt>読み込み元URL</dt>';
                $form
                    .= '<dd><a href="'
                    . $this->escape( $this->{'url'} )
                    . '" target="_blank">'
                    . $this->escape( $this->{'url'} )
                    . '</a></dd>';
            }
        }
        else {
            $form .= '<dt>読み込み元URL</dt>';
            $form
                .= '<dd><a href="'
                . $this->escape($here)
                . '" target="_blank">'
                . $this->escape($here)
                . '</a></dd>';
        }
        if ($html) {
            if ( $this->{'target'} eq 'range' ) {
                undef $html;
                $form .= '<dt>開始文字列(HTMLソース)</dt>';
                $form
                    .= '<dd><textarea name="data:'
                    . $this->{'id'}
                    . ':start" id="data:'
                    . $this->{'id'}
                    . ':start" cols="50" rows="3" wrap="soft">'
                    . $this->escape( $main::data{ $this->{'id'} }{'start'} )
                    . '</textarea></dd>';
                $form .= '<dt>終了文字列(HTMLソース)</dt>';
                $form
                    .= '<dd><textarea name="data:'
                    . $this->{'id'}
                    . ':end" id="data:'
                    . $this->{'id'}
                    . ':end" cols="50" rows="3" wrap="soft">'
                    . $this->escape( $main::data{ $this->{'id'} }{'end'} )
                    . '</textarea></dd>';
                $form
                    .= '<dd><label><input type="checkbox" name="data:'
                    . $this->{'id'}
                    . ':outer" id="data:'
                    . $this->{'id'}
                    . ':outer" value="1"'
                    . ( ( $main::data{ $this->{'id'} }{'outer'} )
                    ? ' checked="checked"'
                    : '' )
                    . ' /> 開始文字列・終了文字列を読み込み範囲に含む</label></dd>';
                $form .= '</dl>';
            }
            else {
                $form .= '<dt>読み込む chapter/section</dt>';
                $form
                    .= '<dd><select name="data:'
                    . $this->{'id'}
                    . ':target" id="data:'
                    . $this->{'id'}
                    . ':target"><option value=""></option>';
                my $chap_count = 1;
                while ( $html
                    =~ /<!--chapter(?!\w)[^<>]*\sid="(.*?)"[^<>]*-->(.*?)<!--\/chapter(?!\w)[^<>]*-->/sig
                    )
                {
                    $form =~ s/>├([^<>]+<\/option>)$/>└$1/s;
                    my $chap       = $1;
                    my $chap_html  = $2;
                    my $chap_title = 'chapter ' . $chap_count++;
                    if ( $html
                        =~ /<!--chaptertitle(?!\w)[^<>]*-->(.*?)<!--\/chaptertitle(?!\w)[^<>]*-->/si
                        )
                    {
                        $chap_title = $this->detag_text($1);
                    }
                    $form
                        .= '<option value="'
                        . $this->escape($chap) . '"'
                        . (
                        (          $main::data{ $this->{'id'} }{'target'}
                                && $main::data{ $this->{'id'} }{'target'} eq
                                $chap
                        ) ? ' selected="selected"' : ''
                        )
                        . '>'
                        . $this->cut_string( $chap_title, 32, 'i' )
                        . '</option>';
                    my $sect_count = 1;
                    while ( $chap_html
                        =~ /<!--section(?!\w)[^<>]*\sid="(.*?)"[^<>]*-->(.*?)<!--\/section(?!\w)[^<>]*-->/sig
                        )
                    {
                        my $sect      = $1;
                        my $sect_html = $2;
                        my $sect_title;
                        if (   $titleid
                            && $sect_html
                            =~ /<!--field(?!\w)[^<>]*\sid="$titleid"[^<>]*-->(.*?)<!--\/field(?!\w)[^<>]*-->/si
                            )
                        {
                            $sect_title = $1;
                        }
                        elsif ( $sect_html
                            =~ /<(h[1-6])(?!\w)[^<>]*>(.*?)<\/\1(?!\w)[^<>]*>/si
                            )
                        {
                            $sect_title = $2;
                        }
                        if (   $sect_title
                            && $sect_title
                            =~ /<!--data(?!\w)[^<>]*\sname="str"[^<>]*-->(.*?)<!--\/data-->/si
                            )
                        {
                            $sect_title = $this->detag_text($1);
                        }
                        elsif ( $sect_html
                            =~ /<!--data(?!\w)[^<>]*\sname="str"[^<>]*-->(.*?)<!--\/data-->/si
                            )
                        {
                            $sect_title = $this->detag_text($1);
                        }
                        $sect_title = 'section ' . $sect_count++
                            if !$sect_title;
                        $form
                            .= '<option value="'
                            . $this->escape( $chap . '/' . $sect ) . '"'
                            . (
                            (          $main::data{ $this->{'id'} }{'target'}
                                    && $main::data{ $this->{'id'} }{'target'}
                                    eq $chap . '/' . $sect
                            ) ? ' selected="selected"' : ''
                            )
                            . '>├'
                            . $this->cut_string( $sect_title, 32, 'i' )
                            . '</option>';
                    }
                }
                $form =~ s/>├([^<>]+<\/option>)$/>└$1/s;
                $form .= '</select></dd>';
                $form .= '</dl>';
            }
        }
        $form .= $this->field_footer;
    }
    return $form;
}

######################################################################
#	(3) obj->is_valid_data(path);
sub is_valid_data ($;$) {
    my ( $this, $path ) = @_;
    my $is_valid = 1;
    delete $main::data{ $this->{'id'} }{'url'} if !$this->{'userurl'};
    if (   defined $main::data{ $this->{'id'} }{'url'}
        && $main::data{ $this->{'id'} }{'url'} ne ''
        && $main::data{ $this->{'id'} }{'url'} ne '/'
        && $this->is_invalid_url( $main::data{ $this->{'id'} }{'url'} ) )
    {
        push(
            @{ $cgi::action->{'dialog'} },
            ( ( $this->{'name'} ) ? $this->{'name'} : '入力' )
                . 'の 読み込み元URL を確認してください。URLではありません。'
        ) if ref $cgi::action;
        $is_valid = 0;
    }
    if (   $this->{'target'} ne 'range'
        && $this->{'required'}
        && !$main::data{ $this->{'id'} }{'target'} )
    {
        push(
            @{ $cgi::action->{'dialog'} },
            ( ( $this->{'name'} ) ? $this->{'name'} : '入力' )
                . 'の 読み込む chapter/section を指定してください。'
        ) if ref $cgi::action;
        $is_valid = 0;
    }
    elsif ( $this->{'target'} eq 'range' ) {
        if (   $this->{'required'}
            && $this->{'userurl'}
            && !$main::data{ $this->{'id'} }{'url'} )
        {
            push(
                @{ $cgi::action->{'dialog'} },
                ( ( $this->{'name'} ) ? $this->{'name'} : '入力' )
                    . 'の 読み込み元URL を指定してください。'
            ) if ref $cgi::action;
            $is_valid = 0;
        }
        elsif (
            (   $this->{'required'}
                || (   $this->{'userurl'}
                    && $main::data{ $this->{'id'} }{'url'} )
            )
            && (   !defined $main::data{ $this->{'id'} }{'start'}
                || $main::data{ $this->{'id'} }{'start'} eq ''
                || !defined $main::data{ $this->{'id'} }{'end'}
                || $main::data{ $this->{'id'} }{'end'} eq '' )
            )
        {
            push(
                @{ $cgi::action->{'dialog'} },
                ( ( $this->{'name'} ) ? $this->{'name'} : '入力' )
                    . 'の 開始文字列(HTMLソース)・終了文字列(HTMLソース) を指定してください。'
            ) if ref $cgi::action;
            $is_valid = 0;
        }
    }
    $this->data;
    if ( $is_valid && $this->{'cookie'} && $main::set_cookie ) {
        if ( $this->{'target'} eq 'range' ) {
            $cookie::data{ 'data:' . $this->{'id'} . ':start' }
                = $main::data{ $this->{'id'} }{'start'} || '';
            $cookie::data{ 'data:' . $this->{'id'} . ':end' }
                = $main::data{ $this->{'id'} }{'end'} || '';
            $cookie::data{ 'data:' . $this->{'id'} . ':outer' }
                = $main::data{ $this->{'id'} }{'outer'} || '';
            $cookie::data{ 'data:' . $this->{'id'} . ':url' }
                = $main::data{ $this->{'id'} }{'url'} || '';
        }
        else {
            $cookie::data{ 'data:' . $this->{'id'} . ':target' }
                = $main::data{ $this->{'id'} }{'target'} || '';
        }
    }
    return $is_valid;
}

sub settle_up ($;$) {
    my ( $this, $path ) = @_;
    $this->embed( $path, $main::c, $main::n, $main::data{ $this->{'id'} },
        1 );
    return 1;
}

sub embed ($$$$$;$$) {
    my ( $this, $path, $c, $n, $data, $refresh, $noread ) = @_;
    my $cache = '';
    if (ref $data && ( $this->{'target'} ne 'range' && $data->{'target'} )
        || (   $this->{'target'} eq 'range'
            && ( $this->{'url'} || ( $this->{'userurl'} && $data->{'url'} ) )
            && (   ( defined $data->{'start'} && $data->{'start'} ne '' )
                || ( defined $data->{'end'} && $data->{'end'} ne '' ) )
        )
        && $path
        && $this->set_dir($path)
        )
    {
        $path .= '/' . $this->{'id'} . '.ssi';
        if (   !$refresh
            && -f $path
            && ( 365 < $this->{'interval'} || -M $path < $this->{'interval'} )
            )
        {
            return ($noread) ? '' : $this->read_file( $path, 1 );
        }
        my ( $html, $here, $titleid, $url )
            = $this->read_external_html( $data->{'url'} );
        if ($html) {
            my $title
                = ( $html =~ /<title(?!\w)[^>]*>(.*?)<\/title>/is ) ? $1 : '';
            $html =~ s/^.*?<body(?!\w)[^<>]*>//s;
            $html =~ s/<\/body(?!\w)[^<>]*>.*?$//s;
            if ( $this->{'target'} eq 'range' ) {
                my $s
                    = ( $data->{'start'} ) ? quotemeta $data->{'start'} : '^';
                my $e
                    = ( $data->{'end'} ) ? quotemeta( $data->{'end'} ) : '$';
                if ( $data->{'outer'} ) {
                    $html = ( $html =~ /($s.*?$e)/s ) ? $1 : '';
                }
                else {
                    $html = ( $html =~ /$s(.*?)$e/s ) ? $1 : '';
                }
            }
            else {
                my ( $chap, $sect ) = split( /\//, $data->{'target'} );
                if (   $chap
                    && $chap =~ /^[0-9]+$/s
                    && $html
                    =~ /<!--chapter(?!\w)[^<>]*\sid="$chap"[^<>]*-->(.*?)<!--\/chapter(?!\w)[^<>]*-->/s
                    )
                {
                    $html = $1;
                    if ( $sect && $sect =~ /^[0-9]+$/s ) {
                        if ( $html
                            =~ /<!--section(?!\w)[^<>]*\sid="$sect"[^<>]*-->(.*?)<!--\/section(?!\w)[^<>]*-->/s
                            )
                        {
                            $html = $1;
                        }
                        else {
                            $html = '';
                        }
                    }
                }
            }
            $cache
                = ( $this->{'textOnly'} ) ? $this->detag_text($html)
                : $this->tag_fix(
                $this->rel_to_abs(
                    $html, $here, 0, 1, 1,
                    (   ( $this->{'source'} && $this->{'source'} eq 'url' )
                        ? $url
                        : ''
                    )
                )
                ) if $html;
            if ( $this->{'linkToOriginal'} ) {
                my $linktext = $title || $url;
                my $text = $this->{'linkText'} || '&raquo; %t から';
                $text =~ s/%t/$linktext/sgi;
                $cache
                    .= '<p class="link-to-original"><a href="'
                    . $this->escape_except_html_entity($url)
                    . '" target="_blank">'
                    . $this->escape_except_html_entity($text)
                    . '</a></p>';
            }
            if ( $default::static && 365 >= $this->{'interval'} ) {
                $cache
                    .= '<script type="text/javascript" src="'
                    . $cgi::path
                    . $this->get_query_for_user_generated_field_editor( 0,
                    $c, $n )
                    . '"></script>';
            }
        }
        $this->write_file( $path, $cache, 1 );
        $this->mk_external_javascript( $path, '', $cache );
    }
    return $cache;
}

sub read_external_html ($;$) {
    my ( $this, $url ) = @_;
    my ( $html, $here, $titleid );
    if ( $this->{'source'} && $this->{'source'} eq 'url' ) {
        $url = $this->{'url'} if !$this->{'userurl'};
        if ($url) {
            require CMONOS::CGI_Lib::HTTP_Client;
            my $res = HTTP_Client->new->request(
                'GET' => $url,
                { 'Accept' => 'text/html, application/xhtml+xml' }
            );
            if ( $res->is_success ) {
                $here = $url;
                $here =~ s!^http://[^/]+/!/!i;
                $html = $res->content('utf8');
            }
        }
    }
    else {
        my $default = $this->hpml_settings( $this->{'dir'} );
        if ( ref $default && %$default ) {
            $html = $this->read_file( $default->{'path'}, 1 );
            $here = $this->path_change( $default->{'path'},
                $ENV{'SCRIPT_NAME'}, 'abs' );
            $titleid = $default->{'titleid'} || '';
        }
    }
    return (wantarray) ? ( $html, $here, $titleid, $url ) : $html;
}

######################################################################
#	(4) obj->usual_format(str);
sub usual_format {
    my ( $this, $str, $path, $c, $n ) = @_;
    my %data
        = ( ref $str eq 'HASH' )
        ? ( defined $$str{'str'} )
            ? $this->elements( $$str{'str'} )
            : %$str
        : $this->elements($str);
    return $this->field_tag(
        $this->data_tag_from_ref( \%data )
            . (
            ( !$default::static )
            ? $this->embed( $path, $c, $n, \%data )
            : $this->include_external_file(
                $path . '/' . $this->{'id'} . '.ssi', 1,
                $this->get_output_path
            )
            )
    );
}

sub has_content {
    my ( $this, $str ) = @_;
    return 1 if !defined $str || $str eq '';
    my %data
        = ( ref $str eq 'HASH' )
        ? ( defined $$str{'str'} )
            ? $this->elements( $$str{'str'} )
            : %$str
        : $this->elements($str);
    return (
        ( $this->{'target'} ne 'range' && $data{'target'} )
            || (
            $this->{'target'} eq 'range'
            && (   ( defined $data{'start'} ne '' && $data{'start'} ne '' )
                || ( defined $data{'end'} ne '' && $data{'end'} ne '' ) )
            )
    ) ? 1 : 0;
}

#---------------------------------------------------------------------
#	(4) obj->format_for_mail(str);
sub format_for_mail_enabled ($) {
    my $this = shift;
    return 0;
}

sub format_for_mail {
    my ( $this, $str ) = @_;
    return '';
}

#	(4)-3 obj->format_for_text(str);
sub format_for_text_enabled ($) {
    my $this = shift;
    return 0;
}

sub format_for_text {
    my ( $this, $str ) = @_;
    return '';
}

######################################################################
#	(5) obj->print_setting_form;
sub hpml_settings ($$) {
    my ( $this, $dir ) = @_;
    my %default = ();
    my $path    = "../$dir/default.pl";
    my $data    = $this->read_file($path);
    if ( $data =~ /\$lib\s*=\s*['"]HomePageMakerLite['"]/s ) {
        my $home
            = ( $data =~ /\$home\s*=\s*(.*?);/s )
            ? $this->un_base_change( eval $1, $path )
            : '';
        if ($home) {
            $default{'dir'} = $default{'name'} = $dir;
            $default{'path'} = $home;
            my $preference_dir
                = ( $data =~ /\$preference_dir\s*=\s*(.*?);/s )
                ? $this->un_base_change( eval $1, $path, 'rel', 1 )
                : '';
            my $field_pref_dir
                = ( $data =~ /\$field_pref_dir\s*=\s*(.*?);/s )
                ? $this->un_base_change( eval $1, $path, 'rel', 1 )
                : '';
            my (%db);
            use Fcntl qw(:DEFAULT);
            eval 'use ' . $env::dbm_file . ';';
            tie( %db, $env::dbm_file, $preference_dir . '/general',
                O_RDONLY, $env::dbm_mode );

            if ( ref tied %db && defined $db{'cginame'} ) {
                $default{'name'} = $this->decode_utf8( $db{'cginame'} );
            }
            untie %db;
            tie( %db, $env::dbm_file, $field_pref_dir . '/inputfield',
                O_RDONLY, $env::dbm_mode );
            if ( ref tied %db && defined $db{'for_title'} ) {
                $default{'titleid'} = $this->decode_utf8( $db{'for_title'} );
            }
            untie %db;
        }
    }
    return \%default;
}

sub print_setting_form ($;$$) {
    my ( $this, $html_disabled ) = @_;
    my ( $name, @hpml );
    local (*DIR);
    if ( opendir( DIR, "../" ) ) {
        my @dir = grep( $_ !~ /^\./ && -d "../$_" && -f "../$_/default.pl",
            readdir(DIR) );
        closedir(DIR);
        if (@dir) {
            use Fcntl qw(:DEFAULT);
            eval 'use ' . $env::dbm_file . ';';
            foreach my $d (@dir) {
                my $default = $this->hpml_settings($d);
                push( @hpml, $default ) if ref $default && %$default;
            }
        }
    }

    #名前
    $name = 'data:' . $this->{'id'};

    $this->print_field_info_form($name);
    print '<fieldset>';
    print '<legend>読み込み元設定</legend>';

    if (@hpml) {
        print '<fieldset>';
        print
            '<legend><label title="「ホームページメーカーLite」で書き出された記事を読み込みます。"><input type="radio" name="'
            . $name
            . '_source" id="'
            . $name
            . '_source" value="hpml"'
            . ( ( $this->{'source'} && $this->{'source'} eq 'hpml' )
            ? ' checked="checked"'
            : '' )
            . ' /> このディレクトリの単ページ記事を読み込む</label></legend>';
        print '<select name="'
            . $name
            . '_dir" id="'
            . $name
            . '_dir"><option value=""></option>';
        foreach my $i (@hpml) {
            print '<option value="'
                . $i->{'dir'} . '"'
                . ( ( $i->{'dir'} eq $this->{'dir'} )
                ? ' selected="selected"'
                : '' )
                . '>'
                . $i->{'name'}
                . '</option>';
        }
        print '</select>';
        print '</fieldset>';
        print '<fieldset>';
        print '<legend><label><input type="radio" name="'
            . $name
            . '_source" id="'
            . $name
            . '_source" value="url"'
            . ( ( $this->{'source'} && $this->{'source'} eq 'url' )
            ? ' checked="checked"'
            : '' )
            . ' /> URL を指定する</label></legend>';
    }
    else {
        print '<input type="hidden" name="'
            . $name
            . '_source" id="'
            . $name
            . '_source" value="url" />';
        print '<fieldset>';
        print '<legend>URL を指定する</legend>';
    }
    print '<input type="url" name="'
        . $name
        . '_url" id="'
        . $name
        . '_url" value="'
        . $this->escape( $this->{'url'} )
        . '" size="72" />';
    print ' <label><input type="checkbox" name="'
        . $name
        . '_userurl" id="'
        . $name
        . '_userurl" value="range"'
        . ( ( $this->{'userurl'} ) ? ' checked="checked"' : '' )
        . ' /> ユーザーによる URL 指定を許可する</label>';
    print '</fieldset>';
    print '</fieldset>';

    print '<fieldset>';
    print '<legend>読み込み範囲</legend><ol class="checkbox">';
    print '<li><label><input type="radio" name="'
        . $name
        . '_target" id="'
        . $name
        . '_target" value="section"'
        . ( ( $this->{'target'} && $this->{'target'} eq 'section' )
        ? ' checked="checked"'
        : '' )
        . ' /> chapter/section を指定する</label></li>';
    print '<li><label><input type="radio" name="'
        . $name
        . '_target" id="'
        . $name
        . '_target" value="range"'
        . ( ( $this->{'target'} && $this->{'target'} eq 'range' )
        ? ' checked="checked"'
        : '' )
        . ' /> 開始文字列と終了文字列を HTML ソースで指定する</label></li>';
    print '</ol>';
    print '<ol class="checkbox">';
    print '<li><label><input type="checkbox" name="'
        . $name
        . '_textOnly" id="'
        . $name
        . '_textOnly" value="range"'
        . ( ( $this->{'textOnly'} ) ? ' checked="checked"' : '' )
        . ' /> テキストのみ読み込む</label></li>';
    print '</ol></fieldset>';
    print '<fieldset>';

    print '<legend><label><input type="checkbox" name="'
        . $name
        . '_linkToOriginal" id="'
        . $name
        . '_linkToOriginal" value="1"'
        . ( ( $this->{'linkToOriginal'} ) ? ' checked="checked"' : '' )
        . ' /> 読み込み元へのリンクを付記する</label></legend>';
    print '<input type="text" name="'
        . $name
        . '_linkText" id="'
        . $name
        . '_linkText" value="'
        . $this->escape( $this->{'linkText'} )
        . '" size="72" placeholder="リンクテキスト（%t=リンク先ページタイトルに変換）" />';
    print '</fieldset>';

    print '<fieldset>';
    print '<legend><label for="' . $name
        . '_interval">再読み込み間隔</label></legend>';
    print $this->mk_select_menu(
        $name . '_interval', '', '', $this->{'interval'},
        '1'   => '1日おき',
        '2'   => '2日おき',
        '3'   => '3日おき',
        '4'   => '4日おき',
        '5'   => '5日おき',
        '6'   => '6日おき',
        '7'   => '7日おき',
        '8'   => '8日おき',
        '9'   => '9日おき',
        '10'  => '10日おき',
        '30'  => '30日おき',
        '999' => '更新時のみ',
    );
    print '</fieldset>';

    $this->print_setting_save_button;
    return;
}

######################################################################
#	(6) obj->is_valid_setting;
sub is_valid_setting ($) {
    my $this     = shift;
    my $is_valid = 1;
    if ( !$main::data{ $this->{'id'} . '_source' } ) {
        push(
            @{ $cgi::action->{'dialog'} },
            '読み込み元を選択してください。'
        ) if ref $cgi::action;
        delete $main::data{ $this->{'id'} . '_source' };
        $is_valid = 0;
    }
    if ( $main::data{ $this->{'id'} . '_dir' } ) {
        my $default
            = $this->hpml_settings( $main::data{ $this->{'id'} . '_dir' } );
        delete $main::data{ $this->{'id'} . '_dir' }
            if !ref $default || !%$default;
    }
    if (   $main::data{ $this->{'id'} . '_source' }
        && $main::data{ $this->{'id'} . '_source' } eq 'hpml'
        && ( !defined $main::data{ $this->{'id'} . '_dir' }
            || $main::data{ $this->{'id'} . '_dir' } eq '' )
        )
    {
        push(
            @{ $cgi::action->{'dialog'} },
            '単ページ記事を選択してください。'
        ) if ref $cgi::action;
        delete $main::data{ $this->{'id'} . '_dir' };
        $is_valid = 0;
    }
    if (   $main::data{ $this->{'id'} . '_url' }
        && $this->is_invalid_url( $main::data{ $this->{'id'} . '_url' } ) )
    {
        push(
            @{ $cgi::action->{'dialog'} },
            '読み込み元 URL を確認してください。'
        ) if ref $cgi::action;
        delete $main::data{ $this->{'id'} . '_url' };
        $is_valid = 0;
    }
    if ( !$main::data{ $this->{'id'} . '_target' } ) {
        push(
            @{ $cgi::action->{'dialog'} },
            '読み込み範囲指定方法を選択してください。'
        ) if ref $cgi::action;
        delete $main::data{ $this->{'id'} . '_target' };
        $is_valid = 0;
    }
    if ( $main::data{ $this->{'id'} . '_url' } ) {
        require CMONOS::CGI_Lib::HTTP_Client;
        my $res = HTTP_Client->new->request(
            'GET' => $main::data{ $this->{'id'} . '_url' },
            { 'Accept' => 'text/html, application/xhtml+xml' }
        );
        my $content_type = $res->header('Content-Type');
        if ( $res->is_success ) {
            if (  !$content_type
                || $content_type eq 'text/html'
                || $content_type eq 'text/plain'
                || $content_type eq 'application/xhtml+xml' )
            {
                my $html = $res->content('utf8');
                if (   $main::data{ $this->{'id'} . '_target' }
                    && $main::data{ $this->{'id'} . '_target' } eq 'section' )
                {
                    unless ( $html
                        =~ /<!--chapter(?!\w)[^<>]*-->(.*?)<!--\/chapter(?!\w)[^<>]*-->/s
                        && $1
                        =~ /<!--section(?!\w)[^<>]*-->.*?<!--\/section(?!\w)[^<>]*-->/s
                        )
                    {
                        push(
                            @{ $cgi::action->{'dialog'} },
                            '読み込み範囲指定方法を変更しました。選択読み込み元 URL に chapter/section がみつかりませんでした。'
                        ) if ref $cgi::action;
                        $main::data{ $this->{'id'} . '_target' } = 'range';
                    }
                }
            }
            else {
                push(
                    @{ $cgi::action->{'dialog'} },
                    '<a href="'
                        . $main::data{ $this->{'id'} . '_url' }
                        . '" target="_blank">読み込み元 URL</a> を確認してください。'
                        . (
                        ($content_type)
                        ? '読み込めないファイル('
                            . $content_type
                            . ')です。'
                        : ''
                        )
                ) if ref $cgi::action;
            }
        }
        else {
            my $not_found = ( $res->code eq '404' ) ? 1 : 0;
            if ($not_found) {
                push(
                    @{ $cgi::action->{'dialog'} },
                    '読み込み元 URL を確認してください。ファイルがみつかりませんでした。'
                ) if ref $cgi::action;
            }
            else {
                push(
                    @{ $cgi::action->{'dialog'} },
                    '<a href="'
                        . $main::data{ $this->{'id'} . '_url' }
                        . '" target="_blank">読み込み元 URL</a> を確認してください。'
                        . (
                        ($content_type)
                        ? '読み込めないファイル('
                            . $content_type
                            . ')です。'
                        : ''
                        )
                ) if ref $cgi::action;
            }
            delete $main::data{ $this->{'id'} . '_url' };
            $is_valid = 0;
        }
    }
    $this->tag_fix( \$main::data{ $this->{'id'} . '_description' } )
        if defined $main::data{ $this->{'id'} . '_description' }
        && $main::data{ $this->{'id'} . '_description' };
    $this->tag_fix( \$main::data{ $this->{'id'} . '_note' } )
        if defined $main::data{ $this->{'id'} . '_note' }
        && $main::data{ $this->{'id'} . '_note' };

    #チェックボックス対策
    $main::data{ $this->{'id'} . '_textOnly' } = ''
        if !$main::data{ $this->{'id'} . '_textOnly' };
    $main::data{ $this->{'id'} . '_userurl' } = ''
        if !$main::data{ $this->{'id'} . '_userurl' };
    $main::data{ $this->{'id'} . '_linkToOriginal' } = ''
        if !$main::data{ $this->{'id'} . '_linkToOriginal' };
    return $is_valid;
}

######################################################################
#	(7) obj->search_form;
sub search_form_enabled ($) {
    my $this = shift;
    return 0;
}

######################################################################
#	(8) obj->sort_enabled;
sub sort_enabled ($) {
    my $this = shift;
    return 0;
}

######################################################################
sub editor_enabled ($) {
    my $this = shift;
    return 1;
}

sub is_secure_user_for_edit ($) {
    my $this = shift;
    return 1;
}

sub set_user_generated_field_editor_page_settings ($) {
    my $this = shift;
    return 1;
}

sub print_user_generated_field_editor ($) {
    my $this = shift;
    $this->embed( $this->get_file_directory, $main::c, $main::n,
        $this->get_field_data, 0, 1 )
        if 365 >= $this->{'interval'};
    $this->print_http_header('text/javascript');
    return 1;
}

sub user_generated_field_edit ($) {
    my $this = shift;
    return 1;
}

1;
