package LinkToOrder;
require CMONOS::CGI_Lib::Field;
@ISA = qw(Field);
use strict;
use utf8;
use Fcntl qw(:DEFAULT);
eval 'use ' . $env::dbm_file . ';';
######################################################################
# フィールドモジュール（カレンダーリンク）
# LinkToOrder.pm 1.0.0
# Copyright (C) 1999-2018 CMONOS Co. Ltd.
#
# support@cmonos.jp
# http://cmonos.jp/
# 最終更新日：2013-04-14
######################################################################
sub _set ($$) {
    my ( $this, $setting ) = @_;
    $this->{'label'} = '発注者リンク' if !$this->{'label'};
    return;
}

sub showcase_object_enabled ($) {
    my $this = shift;
    if ( ref $this->{'showcase'} ) {
        return 1;
    }
    elsif ( $this->{'field_for'}->{'showcase'}
        && ref $this->{'field_obj'}->{ $this->{'field_for'}->{'showcase'} } )
    {
        $this->{'showcase'}
            = $this->{'field_obj'}->{ $this->{'field_for'}->{'showcase'} };
        return 1;
    }
    else {
        return 0;
    }
}

######################################################################
#	(2) obj->input_enabled;
sub form {
    my ( $this, $status, $original ) = @_;
    return '' if !$this->showcase_object_enabled;
    $main::data{ $this->{'id'} }{'str'} = 1
        if $this->{'default'} && ( !defined $status || $status eq '' );
    return
          $this->field_header
        . '<label><input type="checkbox" name="data:'
        . $this->{'id'}
        . ':str" id="data:'
        . $this->{'id'}
        . ':str" value="1"'
        . (
        ( $main::data{ $this->{'id'} }{'str'} ) ? ' checked="checked"' : '' )
        . ' /> 使用する</label>'
        . $this->field_footer;
}

######################################################################
#	(3) obj->is_valid_data(path);
sub is_valid_data ($;$) {
    my ( $this, $path ) = @_;
    $main::data{ $this->{'id'} }{'str'} = ( $this->showcase_object_enabled
            && $main::data{ $this->{'id'} }{'str'} ) ? 1 : '';
    if ( $this->{'cookie'} && $main::set_cookie ) {
        $cookie::data{ 'data:' . $this->{'id'} . ':str' }
            = $main::data{ $this->{'id'} }{'str'};
    }
    return 1;
}

######################################################################
#	(4) obj->usual_format(str);
sub usual_format {
    my ( $this, $str, $path, $c, $n ) = @_;
    return ''
        if !$this->showcase_object_enabled
        || !$this->is_administrator( $c, $n );
    $str = $$str{'str'} if ref $str eq 'HASH';
    my $url = $this->order_link( $c, $n );
    if ( $this->{'button'} ) {
        $this->use_deco($cgi::output);
        return $this->field_tag(
            $this->data_tag_from_hash( 'str', $str )
                . $cgi::Deco->button(
                'jump',
                $this->{'button'},
                $url,
                $this->{'label'},
                ( ( $this->{'newWindow'} ) ? '_blank' : '' ),
                '',
                $cgi::output_option
                )
        );

    }
    else {
        $url = $this->base_change( $url, $cgi::output, $cgi::output_option )
            if $cgi::output || $cgi::output_option;
        return $this->field_tag(
            $this->data_tag_from_hash( 'str', $str )
                . $this->style(
                '<a href="'
                    . $this->escape_except_html_entity($url)
                    . '" title="'
                    . $this->detag_text( $this->{'label'} ) . '"'
                    . ( ( $this->{'newWindow'} ) ? ' target="_blank"' : '' )
                    . '>'
                    . $this->{'label'} . '</a>',
                $this->{'style'},     $this->{'fontsize'},
                $this->{'fontcolor'}, $this->{'fontface'}
                )
        );
    }
}

sub is_administrator ($$$$) {
    my ( $this, $c, $n ) = @_;
    if (  !$default::static
        && $this->{'adminOnly'}
        && $this->{'field_for'}->{'mail'}
        && ref $this->{'field_obj'}->{ $this->{'field_for'}->{'mail'} }
        && $this->{'field_obj'}->{ $this->{'field_for'}->{'mail'} }
        ->{'e-mail'} )
    {
        my $db = $this->{'field_obj'}->{ $this->{'field_for'}->{'mail'} }->db;
        if ($db) {
            my $email = '';
            my $db_dir
                = ( $default::lib eq 'TableMaker' && $c )
                ? $default::db . '/' . $c
                : $default::db;
            if ( ref $cgi::action && ref $cgi::action->{'DB'} ) {
                if ( !ref tied %{ $cgi::action->{'DB'}{$c}{$db} } ) {
                    tie(%{ $cgi::action->{'DB'}{$c}{$db} },
                        $env::dbm_file, "$db_dir/$db",
                        O_RDONLY,       $env::dbm_mode
                    );
                }
                $email = $this->decode_utf8(
                    $cgi::action->{'DB'}{$c}{$db}{ $this->encode_utf8($n) } );
            }
            else {
                my %db;
                tie( %db, $env::dbm_file, $db_dir . '/' . $db,
                    O_RDONLY, $env::dbm_mode );
                if ( ref tied %db ) {
                    $email
                        = $this->decode_utf8( $db{ $this->encode_utf8($n) } );
                }
                untie %db;
            }
            return $this->is_authorized($email);
        }
    }
    return 1;
}

sub order_link ($;$$) {
    my ( $this, $c, $n ) = @_;
    return '' if !$this->showcase_object_enabled;
    my ( $url, $anchor ) = $this->article_path( $c, $n );
    return ( !$url )
        ? ''
        : '../order/start.cgi?m='
        . ( $this->{'mode'} || 'TableViewer' )
        . '&order_item='
        . $this->url_encode( 'path=' . $url )
        . ( ($anchor) ? '+' . $this->url_encode( 'anchor=' . $anchor ) : '' );
}

#---------------------------------------------------------------------
#	(4)-2 obj->format_for_mail(str);
sub format_for_mail {
    my ( $this, $str, $path, $c, $n ) = @_;
    return '' if !$this->showcase_object_enabled || !$this->{'adminOnly'};
    $str = $$str{'str'} if ref $str eq 'HASH';
    return ( !defined $str || $str eq '' )
        ? ''
        : '['
        . $this->name . "]\x0A"
        . $this->full_path( $this->order_link )
        . "\x0A\x0A";
}

#---------------------------------------------------------------------
#	(4)-4 obj->format_for_text(str);
sub format_for_text {
    my ( $this, $str, $path, $c, $n ) = @_;
    return ''
        if !$this->showcase_object_enabled
        || !$this->is_administrator( $c, $n );
    $str = $$str{'str'} if ref $str eq 'HASH';
    return ( !defined $str || $str eq '' )
        ? ''
        : $this->full_path( $this->order_link );
}

######################################################################
#	(5) obj->print_setting_form;
sub print_setting_form ($;$$) {
    my ( $this, $html_disabled ) = @_;
    my ($name);

    if ( !$this->showcase_object_enabled ) {
        $this->print_field_info_form( $name, 1,
            'このフィールドタイプを使用するには「ショッピングカート」フィールドタイプが必要です。'
        );
        return;
    }

    #名前
    $name = 'data:' . $this->{'id'};

    $this->print_field_info_form($name);

    if ( !$default::static ) {
        print '<fieldset>';
        print '<legend>表示の限定</legend>';
        print '<label><input type="checkbox" name="'
            . $name
            . '_adminOnly" value="1"'
            . ( ( defined $this->{'adminOnly'} && $this->{'adminOnly'} )
            ? ' checked="checked"'
            : '' )
            . ' /> 「代表メールフィールド」に登録されたメールアドレスでログインしているユーザーと「スタッフ」以上の権限を持つユーザーにのみ表示する。</label>';
        print '</fieldset>';
    }
    print '<fieldset>';
    print '<legend>受注データの表示画面</legend>';
    print $this->mk_select_menu(
        $name . '_mode', '', '', $this->{'mode'},
        'TableViewer' => 'テーブル表示',
        'TileViewer'  => 'タイル表示',
        'GMapViewer'  => 'Googleマップ表示',
        'Gate'        => '修正レコード選択ページ',
        'DetailGate'  => '詳細表示選択ページ',
    );
    print '</fieldset>';

    print '<fieldset>';
    print '<legend>デフォルト</legend>';
    print '<label><input type="checkbox" name="'
        . $name
        . '_default" value="1"'
        . ( ( defined $this->{'default'} && $this->{'default'} )
        ? ' checked="checked"'
        : '' )
        . ' /> 使用する</label>';
    print '</fieldset>';

    if ( !defined $html_disabled || !$html_disabled ) {

        print '<fieldset>';
        print '<legend>リンク設定</legend>';

        print '<fieldset>';
        print '<legend><label for="' . $name
            . '_label">リンクラベル</label></legend>';
        print '<input type="text" name="'
            . $name
            . '_label" id="'
            . $name
            . '_label" value="'
            . $this->escape( $this->{'label'} )
            . '" size="50" />';
        print '</fieldset>';

        print '<fieldset>';
        print '<legend>ウィンドウ</legend>';
        print '<label><input type="checkbox" name="'
            . $name
            . '_newWindow" value="1"'
            . ( ( defined $this->{'newWindow'} && $this->{'newWindow'} )
            ? ' checked="checked"'
            : '' )
            . ' /> 新しいウィンドウで開く</label>';
        print '</fieldset>';

        #ボタンメニュー
        print
            '<fieldset><legend title="設定がない場合、URLが表示されます。">ボタン</legend>';
        print $cgi::Deco->button_menu( $name . '_button',
            'jump', 120, $this->{'button'} );
        print '</fieldset>';
        print '</fieldset>';

        #文字設定
        $this->print_font_setting_form($name);
    }
    $this->print_setting_save_button;
    return;
}

######################################################################
#	(6) obj->is_valid_setting;
sub is_valid_setting ($) {
    my $this     = shift;
    my $is_valid = 1;
    $this->tag_fix( \$main::data{ $this->{'id'} . '_label' } )
        if defined $main::data{ $this->{'id'} . '_label' }
        && $main::data{ $this->{'id'} . '_label' };
    $this->tag_fix( \$main::data{ $this->{'id'} . '_description' } )
        if defined $main::data{ $this->{'id'} . '_description' }
        && $main::data{ $this->{'id'} . '_description' };
    $this->tag_fix( \$main::data{ $this->{'id'} . '_note' } )
        if defined $main::data{ $this->{'id'} . '_note' }
        && $main::data{ $this->{'id'} . '_note' };
    $main::data{ $this->{'id'} . '_default' } = ''
        if !$main::data{ $this->{'id'} . '_default' };
    $main::data{ $this->{'id'} . '_newWindow' } = ''
        if !$main::data{ $this->{'id'} . '_newWindow' };
    $is_valid = 0 if !$this->is_valid_font_setting;
    return $is_valid;
}

######################################################################
#	(7) obj->search_form;
sub search_form_enabled ($) {
    my $this = shift;
    return 0;
}

######################################################################
#	(8) obj->sort_enabled;
sub sort_enabled ($) {
    my $this = shift;
    return 0;
}

######################################################################
#sub import {
BEGIN {
    if (   $env::checkout
        && -e $env::checkout
        && !$setting::field_for_mail
        && ( !defined $default::type || $default::type eq '' ) )
    {
        Field::class_register( 'z_orderlink', 'LinkToOrder',
            '発注者リンク' );
        $setting::deco_dir{'jump'}  = 'ジャンプボタン';
        $setting::deco_type{'jump'} = 'button';
    }
}

1;
