package Menu;
require CMONOS::CGI_Lib::Field::Select;
@ISA = qw(Select);
use strict;
use utf8;
######################################################################
# フィールドモジュール（メニュー）
# Menu.pm 1.1.1
# Copyright (C) 1999-2018 CMONOS Co. Ltd.
#
# support@cmonos.jp
# http://cmonos.jp/
# 最終更新日：2015-04-11
######################################################################
sub select_menu ($$;$$$) {
    my ( $this, $name, $multiple, $value, $is_invalid ) = @_;
    my ( $form, @menu, @values, $is_search );

    #名前にデータIDを埋め込む
    $is_search = 1 if $name && $name eq 'search';
    $name = 'data' if !defined $name || !$name;
    $name .= ':' . $this->{'id'} . ':str';

    #エスケープ+デフォルト
    @values = (@$value) ? $this->escape(@$value) : ();

    #メニュー
    @menu
        = ( $this->{'default'} )
        ? $this->escape( split( /\x0A/, $this->{'default'} ) )
        : ();
    $this->{'rows'} = @menu if !$this->{'rows'} || $this->{'rows'} > @menu;

    if ( $multiple && $this->{'rows'} && $this->{'rows'} < 4 ) {
        $this->{'rows'} = ( @menu > 4 ) ? 4 : @menu;
    }
    elsif ( !$multiple || !$this->{'rows'} ) {
        $this->{'rows'} = 1;
    }
    $form
        .= '<select size="'
        . $this->{'rows'}
        . '" name="'
        . $name
        . '" id="'
        . $name . '"';
    $form .= ' multiple="multiple"'   if $multiple;
    $form .= $this->set_invalid_class if $is_invalid;
    $form .= ' required="required"'   if !$is_search && $this->{'required'};
    $form .= '>';
    $form
        .= '<option value="">'
        . ( ( $this->{'required'} ) ? '▼選択してください' : '' )
        . '</option>'
        if !$multiple;
    foreach my $k (@menu) {
        $form
            .= '<option value="'
            . $k . '"'
            . ( ( @values && grep( $_ eq $k, @values ) )
            ? ' selected="selected"'
            : '' )
            . '>'
            . $k
            . '</option>';
    }

    $form .= ' ' . $this->{'unit'} if $this->{'unit'};
    $form .= '</select>';
    return $form;
}

sub is_one_to_one ($) {
    my $this = shift;
    return 1;
}

######################################################################
#	(5) obj->print_setting_form;
sub print_setting_form ($;$$) {
    my ( $this, $html_disabled ) = @_;

    #名前
    my $name = 'data:' . $this->{'id'};

    $this->print_field_info_form($name);

    print '<fieldset>';
    print '<legend>入力欄設定</legend>';
    print '<table class="field-table">';
    print '<tbody>';
    print '<tr>';
    print '<td class="field-name"><label for="' . $name
        . '_rows">表示行数</label></td>';
    print '<td class="field"><input type="number" name="'
        . $name
        . '_rows" id="'
        . $name
        . '_rows" value="'
        . $this->escape( $this->{'rows'} )
        . '" size="3" /> <span class="unit">行</span>';
    print ' <label><input type="checkbox" name="'
        . $name
        . '_multiple" value="1"'
        . ( ( $this->{'multiple'} ) ? ' checked="checked"' : '' )
        . ' /> 複数選択</label></td>';
    print '</tr>';
    print '<tr>';
    print '<td class="field-name"><label for="' . $name
        . '_unit">単位</label></td>';
    print '<td class="field"><input type="text" name="'
        . $name
        . '_unit" id="'
        . $name
        . '_unit" value="'
        . $this->escape( $this->{'unit'} )
        . '" size="8" title="入力する内容に適した単位を設定します。" /></td>';
    print '</tr>';
    print '<tr>';
    print '<td class="field-name"><label for="' . $name
        . '_default">選択肢設定</label></td>';
    print '<td class="field"><textarea name="'
        . $name
        . '_default" id="'
        . $name
        . '_default" cols="56" rows="8" wrap="off">'
        . $this->escape( $this->{'default'} )
        . '</textarea><div class="hints">選択項目ごとに改行します</div></td>';
    print '</tr>';
    print '</tbody></table>';
    print '</fieldset>';
    $this->_print_setting_form($name);

    #文字設定
    $this->print_font_setting_form($name)
        if !defined $html_disabled || !$html_disabled;

    $this->print_setting_save_button;
    return;
}

######################################################################
#sub import {
BEGIN {
    Field::class_register( 'select_menu', 'Menu', 'メニュー' );
}

1;
