package Pref;
require CMONOS::CGI_Lib::Field;
@ISA = qw(Field);
use strict;
use utf8;
######################################################################
# フィールド定義モジュール（都道府県）
# Pref.pm 1.0.1
# Copyright (C) 1999-2018 CMONOS Co. Ltd.
#
# support@cmonos.jp
# http://cmonos.jp/
# 最終更新日：2016-07-08
######################################################################
sub _set ($$) {
    my ( $this, $setting ) = @_;
    return;
}

######################################################################
#	(1)-0 obj->match_enabled;
sub match_enabled ($) {
    my $this = shift;
    return 1
        if ( defined $main::search{ $this->{'id'} }{'str'}
        && $main::search{ $this->{'id'} }{'str'} ne '' )
        || ( ref $main::search{ $this->{'id'} }{'str'}
        && @{ $main::search{ $this->{'id'} }{'str'} } > 0 );
    return 0;
}

#	(1) obj->match(str);
sub match ($;$) {
    my ( $this, $str ) = @_;
    my ( $pat, @str );
    return 1
        unless ( defined $main::search{ $this->{'id'} }{'str'}
        && $main::search{ $this->{'id'} }{'str'} ne '' )
        || ( ref $main::search{ $this->{'id'} }{'str'}
        && @{ $main::search{ $this->{'id'} }{'str'} } > 0 );
    $this->scalar_to_array( \$main::search{ $this->{'id'} }{'str'} )
        if !ref $main::search{ $this->{'id'} }{'str'};
    @str = split( /,/, $$str );
    foreach $pat ( @{ $main::search{ $this->{'id'} }{'str'} } ) {
        next if $pat eq '';
        if ( grep( $_ eq $pat, @str ) > 0 ) {
            return 1
                if !defined $main::search{ $this->{'id'} }{'mode'}
                || $main::search{ $this->{'id'} }{'mode'} ne 'and';
        }
        elsif ( defined $main::search{ $this->{'id'} }{'mode'}
            && $main::search{ $this->{'id'} }{'mode'} eq 'and' )
        {
            return 0;
        }
    }
    if ( defined $main::search{ $this->{'id'} }{'mode'}
        && $main::search{ $this->{'id'} }{'mode'} eq 'and' )
    {
        return 1;
    }
    else {
        return 0;
    }
}

######################################################################
sub select_menu ($$;$$$) {
    my ( $this, $name, $multiple, $value, $is_invalid ) = @_;
    my ( $form, @menu, @values, $is_search );

    #名前にデータIDを埋め込む
    $is_search = 1 if $name && $name =~ /^search:/;

    require CMONOS::CGI_Lib::JPrefecture;
    my %pref = JPrefecture->new->get_prefecture_name_hash;

    #メニュー
    if ( !$this->{'selectortype'} || $this->{'selectortype'} eq 'menu' ) {
        $this->{'rows'} = 47 if !$this->{'rows'} || $this->{'rows'} > 47;
        if ( $multiple && $this->{'rows'} && $this->{'rows'} < 4 ) {
            $this->{'rows'} = ( @menu > 4 ) ? 4 : @menu;
        }
        elsif ( !$multiple || !$this->{'rows'} ) {
            $this->{'rows'} = 1;
        }
        $form
            .= '<select size="'
            . $this->{'rows'}
            . '" name="'
            . $name
            . '" id="'
            . $name . '"';
        $form .= ' multiple="multiple"'   if $multiple;
        $form .= $this->set_invalid_class if $is_invalid;
        $form .= ' required="required"' if !$is_search && $this->{'required'};
        $form .= '>';
        $form
            .= '<option value="">'
            . ( ( $this->{'required'} ) ? '▼選択してください' : '' )
            . '</option>'
            if !$multiple;
        foreach my $i ( 1 .. 47 ) {
            $form
                .= '<option value="'
                . $i . '"'
                . ( ( ref $value && @$value && grep( $_ eq $i, @$value ) )
                ? ' selected="selected"'
                : '' )
                . '>'
                . $pref{$i}
                . '</option>';
        }
        $form .= '</select>';
    }
    else {
        $form .= '<ol class="checkbox">' . "\x0A";
        foreach my $i ( 1 .. 47 ) {
            $form
                .= '<li><label'
                . ( ($is_invalid) ? ' class="invalid-field"' : '' )
                . (
                ( !$multiple && !$this->{'required'} )
                ? ' title="'
                    . (
                    ($default::english)
                    ? 'Click the radio button to reset.'
                    : '選択済みラジオボタンをクリックすると選択を解除できます。'
                    )
                    . '"'
                : ''
                )
                . '><input type="'
                . ( ($multiple) ? 'checkbox' : 'radio' )
                . '" name="'
                . $name
                . '" value="'
                . $i . '"'
                . ( ( ref $value && @$value && grep( $_ eq $i, @$value ) )
                ? ' checked="checked"'
                : '' )
                . ( ($is_invalid)
                ? ( ($multiple) ? ' onchange' : ' onclick' )
                    . '="cmonos.validate.field(this).bailOut()"'
                : '' )
                . ( ( !$multiple && !$this->{'required'} )
                ? ' onmousedown="var t=this;if(t.checked)setTimeout(function(){t.checked=false},200)"'
                : '' )
                . ' /> '
                . $pref{$i}
                . '</label></li>' . "\x0A";
        }
        $form .= '</ol>' . "\x0A";
    }
    return $form;
}

######################################################################
#	(2) obj->form;
sub form {
    my ( $this, $status ) = @_;
    my @temp = ();
    $main::data{ $this->{'id'} }{'str'} = $this->{'default'}
        if ( !defined $status || $status eq '' )
        && ( !defined $main::data{ $this->{'id'} }{'str'}
        || $main::data{ $this->{'id'} }{'str'} eq '' );
    if (   defined $main::data{ $this->{'id'} }{'str'}
        && !ref $main::data{ $this->{'id'} }{'str'}
        && $main::data{ $this->{'id'} }{'str'} =~ /,/ )
    {
        @temp = split( /,/, $main::data{ $this->{'id'} }{'str'} );
    }
    elsif ( ref $main::data{ $this->{'id'} }{'str'}
        && @{ $main::data{ $this->{'id'} }{'str'} } > 0 )
    {
        push( @temp, @{ $main::data{ $this->{'id'} }{'str'} } );
    }
    elsif ( defined $main::data{ $this->{'id'} }{'str'}
        && $main::data{ $this->{'id'} }{'str'} ne '' )
    {
        push( @temp, $main::data{ $this->{'id'} }{'str'} );
    }
    my $form = $this->field_header(
        50,
        (   ( !$this->{'selectortype'} || $this->{'selectortype'} eq 'menu' )
            ? 'data:' . $this->{'id'} . ':str'
            : ''
        )
    );
    $form .= $this->select_menu( 'data:' . $this->{'id'} . ':str',
        $this->{'multiple'}, \@temp, $this->{'is_invalid_field'}{'str'} );
    $form .= $this->field_footer;
    return $form;
}

######################################################################
#	(3) obj->is_valid_data(path);
sub is_valid_data ($;$) {
    my $this = shift;
    delete $this->{'is_invalid_field'} if ref $this->{'is_invalid_field'};
    if ( defined $main::data{ $this->{'id'} }{'str'}
        && !ref $main::data{ $this->{'id'} }{'str'} )
    {
        if ( $main::data{ $this->{'id'} }{'str'} =~ /,/s ) {
            $main::data{ $this->{'id'} }{'str'}
                = [ split( /,/s, $main::data{ $this->{'id'} }{'str'} ) ];
        }
        else {
            $this->scalar_to_array( \$main::data{ $this->{'id'} }{'str'} );
        }
    }
    elsif ( !$main::data{ $this->{'id'} }{'str'} ) {
        $main::data{ $this->{'id'} }{'str'} = [];
    }
    @{ $main::data{ $this->{'id'} }{'str'} }
        = sort { $a <=> $b } grep( $_ =~ /^[0-9]+$/ && $_ >= 1 && $_ <= 47,
        @{ $main::data{ $this->{'id'} }{'str'} } );
    $main::data{ $this->{'id'} }{'str'}
        = ( @{ $main::data{ $this->{'id'} }{'str'} } )
        ? ( $this->{'multiple'} )
            ? join( ",", @{ $main::data{ $this->{'id'} }{'str'} } )
            : shift( @{ $main::data{ $this->{'id'} }{'str'} } )
        : '';
    if ( $this->is_not_empty('str') ) {
        $cookie::data{ 'data:' . $this->{'id'} . ':str' }
            = $main::data{ $this->{'id'} }{'str'}
            if defined $this->{'cookie'}
            && $this->{'cookie'}
            && defined $main::set_cookie
            && $main::set_cookie;
        return 1;
    }
    else {
        $this->{'is_invalid_field'}{'str'} = 1;
        return 0;
    }
}

sub is_not_empty ($$) {
    my ( $this, $name ) = @_;
    if (   defined $this->{'required'}
        && $this->{'required'}
        && ( !defined $main::data{ $this->{'id'} }{$name}
            || $main::data{ $this->{'id'} }{$name} eq '' )
        )
    {
        if ($default::english) {
            push(
                @{ $cgi::action->{'dialog'} },
                '"'
                    . (
                    ( defined $this->{'name'} && $this->{'name'} )
                    ? $this->{'name'}
                    : ''
                    )
                    . '" field is required.'
            ) if ref $cgi::action;
        }
        else {
            push(
                @{ $cgi::action->{'dialog'} },
                (   ( defined $this->{'name'} && $this->{'name'} )
                    ? $this->{'name'} . 'が'
                    : ''
                    )
                    . '選択されていません。'
            ) if ref $cgi::action;
        }
        $this->{'is_invalid_field'}{$name} = 1;
        return 0;
    }
    return 1;
}

######################################################################
#	(4)-1 obj->usual_format(str);
sub usual_format {
    my ( $this, $str ) = @_;
    $str = $$str{'str'} if ref $str eq 'HASH';
    return $this->field_tag($str) if !defined $str || $str eq '';
    my @str  = $this->pref_ids_to_names($str);
    my $data = '';
    if ( @str && @str > 1 ) {
        if ( !$this->{'listtype'} || $this->{'listtype'} eq 'csv' ) {
            $data = join( ', ', @str );
        }
        elsif ( $this->{'listtype'} eq 'ul' ) {
            $data = '<ul><li>' . join( '</li><li>', @str ) . '</li></ul>';
        }
        elsif ( $this->{'listtype'} eq 'ol' ) {
            $data = '<ol><li>' . join( '</li><li>', @str ) . '</li></ol>';
        }
    }
    else {
        $data = $str[0];
    }
    return $this->field_tag(
        $this->data_tag_from_hash( 'str', $str )
            . $this->style(
            $data,                $this->{'style'}, $this->{'fontsize'},
            $this->{'fontcolor'}, $this->{'fontface'}
            )
    );
}

sub pref_ids_to_names ($$) {
    my ( $this, $str ) = @_;
    require CMONOS::CGI_Lib::JPrefecture;
    my %pref  = JPrefecture->new->get_prefecture_name_hash;
    my @prefs = ();
    foreach my $id (
        grep( $pref{$_},
            ( sort { $a <=> $b || $a cmp $b } split( /,\s*/, $str ) ) )
        )
    {
        push( @prefs, $pref{$id} );
    }
    return @prefs;
}

#	(4)-2 obj->format_for_mail(str);
sub format_for_mail {
    my ( $this, $str ) = @_;
    $str = $$str{'str'} if ref $str eq 'HASH';
    return '' if !defined $str || $str eq '';
    my @str = $this->pref_ids_to_names($str);
    if ( @str && @str > 1 ) {
        if ( !$this->{'listtype'} || $this->{'listtype'} eq 'csv' ) {
            $str = join( ', ', @str );
        }
        elsif ( $this->{'listtype'} eq 'ul' ) {
            $str = "\x0A・" . join( "\x0A・", @str ) . "\x0A";
        }
        elsif ( $this->{'listtype'} eq 'ol' ) {
            my $n = 1;
            my $s;
            $str = '';
            foreach $s (@str) { $str .= "\x0A" . ( $n++ ) . ') ' . $s; }
        }
    }
    else {
        $str = $str[0];
    }
    $str = '[' . $this->name . "]\x0A" . $str;
    $str =~ s/[\x0A]*\Z/\x0A\x0A/s;
    return $str;
}

#	(4)-4 obj->format_for_text(str);
sub format_for_text {
    my ( $this, $str ) = @_;
    $str = $$str{'str'} if ref $str eq 'HASH';
    return '' if !defined $str || $str eq '';
    my @str = $this->pref_ids_to_names($str);
    if ( @str && @str > 1 ) {
        if ( !$this->{'listtype'} || $this->{'listtype'} eq 'csv' ) {
            $str = join( ', ', @str );
        }
        elsif ( $this->{'listtype'} eq 'ul' ) {
            $str = "\x0A・" . join( "\x0A・", @str ) . "\x0A";
        }
        elsif ( $this->{'listtype'} eq 'ol' ) {
            my $n = 1;
            my $s;
            $str = '';
            foreach $s (@str) { $str .= "\x0A" . ( $n++ ) . ') ' . $s; }
        }
    }
    else {
        $str = $str[0];
    }
    return $str;
}

######################################################################
#	(5) obj->print_setting_form;
sub print_setting_form ($;$$) {
    my ( $this, $html_disabled ) = @_;
    my ($name);

    #名前
    $name = 'data:' . $this->{'id'};

    $this->print_field_info_form($name);

    print '<fieldset>';
    print '<legend>セレクター設定</legend>';
    print '<fieldset>';
    print '<legend>セレクタータイプ</legend>';
    print '<ol class="checkbox">';
    print '<li><label><input type="radio" name="'
        . $name
        . '_selectortype" value="menu"'
        . (
        (   !$this->{'selectortype'}
                || ( $this->{'selectortype'}
                && $this->{'selectortype'} eq 'menu' )
        ) ? ' checked="checked"' : ''
        ) . ' /> メニュー</label></li>';
    print '<li><label><input type="radio" name="'
        . $name
        . '_selectortype" value="checkbox"'
        . (
        ( $this->{'selectortype'} && $this->{'selectortype'} eq 'checkbox' )
        ? ' checked="checked"'
        : '' )
        . ' /> チェックボックス または ラジオボタン</label></li>';
    print '<label><input type="checkbox" name="'
        . $name
        . '_multiple" value="1"'
        . ( ( $this->{'multiple'} ) ? ' checked="checked"' : '' )
        . ' /> 複数選択</label>';
    print '</ol>';
    print '</fieldset>';
    print '<fieldset>';
    print '<legend><label for="' . $name
        . '_rows">メニュー表示行数</label></legend>';
    print '<input type="number" name="'
        . $name
        . '_rows" id="'
        . $name
        . '_rows" value="'
        . $this->escape( $this->{'rows'} )
        . '" size="3" /> <span class="unit">行</span>';
    print '</fieldset>';
    print '</fieldset>';

    print '<fieldset>';
    print '<legend>複数選択可能な場合の表示</legend>';
    print '<ol class="checkbox">';
    print '<li><label><input type="radio" name="'
        . $name
        . '_listtype" value="csv"'
        . (
        (   !$this->{'listtype'}
                || ( $this->{'listtype'} && $this->{'listtype'} eq 'csv' )
        ) ? ' checked="checked"' : ''
        ) . ' /> カンマ区切りテキスト</label></li>';
    print '<li><label><input type="radio" name="'
        . $name
        . '_listtype" value="ul"'
        . ( ( $this->{'listtype'} && $this->{'listtype'} eq 'ul' )
        ? ' checked="checked"'
        : '' )
        . ' /> リスト(&lt;ul&gt;)</label></li>';
    print '<li><label><input type="radio" name="'
        . $name
        . '_listtype" value="ol"'
        . ( ( $this->{'listtype'} && $this->{'listtype'} eq 'ol' )
        ? ' checked="checked"'
        : '' )
        . ' /> 番号付リスト(&lt;ol&gt;)</label></li>';
    print '</ol>';
    print '</fieldset>';

    print '<fieldset>';
    print '<legend>デフォルト</legend>';
    print $this->select_menu(
        $name . '_default',
        $this->{'multiple'},
        (   ( $this->{'default'} ) ? [ split( /,/, $this->{'default'} ) ] : []
        ),
        $this->{'is_invalid_field'}{'str'}
    );
    print '</fieldset>';

    if ( !$setting::field_for_mail ) {
        print '<fieldset>';
        print '<legend><label for="' . $name
            . '_defaultSearchOparator">検索オプションのデフォルト</label></legend>';
        print $this->mk_select_menu(
            $name . '_defaultSearchOparator',
            '', '',
            $this->{'defaultSearchOparator'},
            'and' => (
                ($default::english) ? 'Matches on all selection'
                : '全ての選択肢に一致'
            ),
            'or' => (
                ($default::english) ? 'Matches on any selection'
                : 'いずれかの選択肢に一致'
            )
        );
        print ' <label><input type="checkbox" name="'
            . $name
            . '_defaultSearchOparatorFixed" id="'
            . $name
            . '_defaultSearchOparatorFixed" value="1"'
            . ( ( $this->{'defaultSearchOparatorFixed'} )
            ? ' checked="checked"'
            : '' )
            . ' /> 固定する</label>';
        print '</fieldset>';
    }

    #文字設定
    $this->print_font_setting_form($name)
        if !defined $html_disabled || !$html_disabled;

    $this->print_setting_save_button;
    return;
}

######################################################################
#	(6) obj->is_valid_setting;
sub is_valid_setting ($) {
    my $this     = shift;
    my $is_valid = 1;

    #チェックボックス
    $main::data{ $this->{'id'} . '_multiple' } = ''
        if !defined $main::data{ $this->{'id'} . '_multiple' }
        || $main::data{ $this->{'id'} . '_multiple' } eq '';
    $main::data{ $this->{'id'} . '_listtype' } = 'csv'
        if !defined $main::data{ $this->{'id'} . '_listtype' }
        || $main::data{ $this->{'id'} . '_listtype' } eq '';
    $main::data{ $this->{'id'} . '_defaultSearchOparatorFixed' } = ''
        if !$setting::field_for_mail
        && (
        !defined $main::data{ $this->{'id'} . '_defaultSearchOparatorFixed' }
        || $main::data{ $this->{'id'} . '_defaultSearchOparatorFixed' } eq
        '' );

    if ( defined $main::data{ $this->{'id'} . '_default' }
        && !ref $main::data{ $this->{'id'} . '_default' } )
    {
        if ( $main::data{ $this->{'id'} . '_default' } =~ /,/s ) {
            $main::data{ $this->{'id'} . '_default' } = [
                split( /,/s, $main::data{ $this->{'id'} . '_default' } ) ];
        }
        else {
            $this->scalar_to_array(
                \$main::data{ $this->{'id'} . '_default' } );
        }
    }
    elsif ( !$main::data{ $this->{'id'} . '_default' } ) {
        $main::data{ $this->{'id'} . '_default' } = [];
    }
    @{ $main::data{ $this->{'id'} . '_default' } }
        = sort { $a <=> $b } grep( $_ =~ /^[0-9]+$/ && $_ >= 1 && $_ <= 47,
        @{ $main::data{ $this->{'id'} . '_default' } } );
    $main::data{ $this->{'id'} . '_default' }
        = ( @{ $main::data{ $this->{'id'} . '_default' } } )
        ? ( $main::data{ $this->{'id'} . '_multiple' } )
            ? join( ",", @{ $main::data{ $this->{'id'} . '_default' } } )
            : shift( @{ $main::data{ $this->{'id'} . '_default' } } )
        : '';

    #フォントチェック
    $is_valid = 0 if !$this->is_valid_font_setting;

    $this->tag_fix( \$main::data{ $this->{'id'} . '_description' } )
        if defined $main::data{ $this->{'id'} . '_description' }
        && $main::data{ $this->{'id'} . '_description' };
    $this->tag_fix( \$main::data{ $this->{'id'} . '_note' } )
        if defined $main::data{ $this->{'id'} . '_note' }
        && $main::data{ $this->{'id'} . '_note' };
    return $is_valid;
}

######################################################################
#	(7) obj->search_form;
sub search_form ($) {
    my $this = shift;
    my ($form);
    $this->scalar_to_array( \$main::search{ $this->{'id'} }{'str'} );
    $form
        = '<tr><td class="field-name">'
        . ( ( !$this->{'selectortype'} || $this->{'selectortype'} eq 'menu' )
        ? '<label for="search:'
            . $this->{'id'}
            . ':str">'
            . $this->{'name'}
            . '</label>'
        : '<span class="datatitle">' . $this->{'name'} . '</span>' )
        . '</td><td class="field">';
    $form .= $this->select_menu( 'search:' . $this->{'id'} . ':str',
        1, $main::search{ $this->{'id'} }{'str'} );
    if ( defined $this->{'multiple'} && $this->{'multiple'} ) {
        if (   $this->{'defaultSearchOparator'}
            && $this->{'defaultSearchOparatorFixed'} )
        {
            $form
                .= '<input type="hidden" name="search:'
                . $this->{'id'}
                . ':mode" value="'
                . (
                ( $this->{'defaultSearchOparator'} eq 'or' ) ? 'or' : 'and' )
                . '" />';
        }
        else {
            $main::search{ $this->{'id'} }{'mode'}
                = $this->{'defaultSearchOparator'}
                if !$main::search{ $this->{'id'} }{'mode'}
                && $this->{'defaultSearchOparator'};
            $form .= $this->mk_select_menu(
                'search:' . $this->{'id'} . ':mode',
                '', '',
                $main::search{ $this->{'id'} }{'mode'},
                'and' => (
                    ($default::english) ? 'Matches on all selection'
                    : '全ての選択肢に一致'
                ),
                'or' => (
                    ($default::english) ? 'Matches on any selection'
                    : 'いずれかの選択肢に一致'
                )
            );
        }
    }
    $form .= '</td></tr>';
    return $form;
}

######################################################################
#sub import {
BEGIN {
    Field::class_register( 'addr_pref', 'Pref', '都道府県' );
}

1;
