package ShiPainter;
require CMONOS::CGI_Lib::Field;
@ISA = qw(Field);
use strict;
use utf8;
use Fcntl qw(:flock);
######################################################################
# フィールド定義モジュール（しぃペインター）
# ShiPainter.pm 1.0.5
# Copyright (C) 2009-2018 CMONOS Co. Ltd.
#
# support@cmonos.jp
# http://cmonos.jp/
# 最終更新日：2010-12-18
######################################################################
# しぃペインター描画オプション
sub shipainter_param ($) {
    my $this = shift;
    return <<PARAM;

<param name="color_text" value="#000000" />
<param name="color_icon" value="#dddddd" />
<param name="color_frame" value="#eeeeee" />

<param name="color_iconselect" value="#dd3300" />
<param name="color_bar" value="#999999" />
<param name="color_bar_hl" value="#cccccc" />
<param name="color_bar_shadow" value="#666666" /> 

<param name="tool_color_bk" value="#dddddd" />
<param name="tool_color_button" value="#ccccdd" />
<param name="tool_color_button_hl" value="#ffffff" />
<param name="tool_color_button_dk" value="#999999" />

<param name="tool_color_button2" value="#dddddd" />
<param name="tool_color_text" value="#000000" />
<param name="tool_color_bar" value="#999999" />
<param name="tool_color_frame" value="#cccccc" />

<param name="pro_menu_color_text" value="#000000" />
<param name="pro_menu_color_off" value="#666666" />
<param name="pro_menu_color_off_hl" value="#999999" />
<param name="pro_menu_color_off_dk" value="#333333" />
<param name="pro_menu_color_on" value="#cccccc" />
<param name="pro_menu_color_on_hl" value="#ffffff" />
<param name="pro_menu_color_on_dk" value="#999999" />

<param name="bar_color_bk" value="#ffffff" />
<param name="bar_color_frame" value="#ffffff" />
<param name="bar_color_off" value="#ffffff" />
<param name="bar_color_off_hl" value="#ffffff" />
<param name="bar_color_off_dk" value="#eeeeee" />
<param name="bar_color_on" value="#dddddd" />
<param name="bar_color_on_hl" value="#dddddd" />
<param name="bar_color_on_dk" value="#dddddd" />
<param name="bar_color_text" value="#666666" />

<param name="window_color_text" value="#000000" />
<param name="window_color_frame" value="#333333" />
<param name="window_color_bk" value="#dddddd" />
<param name="window_color_bar" value="#666666" />
<param name="window_color_bar_hl" value="#aaaaaa" />
<param name="window_color_bar_text" value="#ffffff" />

<param name="dlg_color_bk" value="#cccccc" />
<param name="dlg_color_text" value="#000000" />

<param name="color_bk" value="#aaaaaa" />
<param name="color_bk2" value="#bbbbbb" />

<param name="l_m_color" value="#999999" />
<param name="l_m_color_text" value="#000000" />

PARAM
}

sub shipainter_viewer_param ($) {
    my $this = shift;
    return <<PARAM;

<param name="color_back" value="#ffffff" />
<param name="color_text" value="#999999" />
<param name="color_icon" value="#ffffff" />
<param name="color_bar" value="#dddddd" />
<param name="color_frame" value="#dddddd" />
<param name="color_bar_select" value="#cccccc" />

PARAM
}

######################################################################
sub _set ($$) {
    my ( $this, $setting ) = @_;
    unless ( ref $cgi::Image ) {
        require CMONOS::CGI_Lib::Image;
        $cgi::Image = Image->new;
    }

    #複数の要素を登録
    $this->{'elements'}      = 1;
    $this->{'preview'}       = 1 if !defined $this->{'preview'};
    $this->{'refererCheck'}  = 1 if !defined $this->{'refererCheck'};
    $this->{'width'}         = 480 if !$this->{'width'};
    $this->{'height'}        = 360 if !$this->{'height'};
    $this->{'previewwidth'}  = 160 if !$this->{'previewwidth'};
    $this->{'previewheight'} = 120 if !$this->{'previewheight'};
    return;
}

######################################################################
#	(1)-0 obj->match_enabled;
sub match_enabled ($) {
    my $this = shift;
    return (
               defined $main::search{ $this->{'id'} }{'e'}
            && $main::search{ $this->{'id'} }{'e'} ne ''
            && ( !$this->{'animationDisabled'}
            || $main::search{ $this->{'id'} }{'e'} != 2 )
    ) ? 1 : 0;
}

#	(1) obj->match(str);
sub match ($;$) {
    my ( $this, $str ) = @_;
    return 1 if !$this->match_enabled;
    my %data = $this->elements($$str);
    return (
        ( !$main::search{ $this->{'id'} }{'e'} && !$data{'type'} )
            || ( $main::search{ $this->{'id'} }{'e'}
            && $main::search{ $this->{'id'} }{'e'} == 1
            && $data{'type'} )
            || ( $main::search{ $this->{'id'} }{'e'}
            && $main::search{ $this->{'id'} }{'e'} == 2
            && $data{'type'}
            && !$data{'animationDisabled'} )
    ) ? 1 : 0;
}

######################################################################
#	(2) obj->form;
sub form {
    my ( $this, $status, $original, $path, $parent_path ) = @_;
    my $temp_exist
        = (    $main::data{ $this->{'id'} }{'key'}
            && $main::data{ $this->{'id'} }{'key'} !~ /[^0-9a-zA-Z_\@\-]/s
            && -f $env::clipboard . '/'
            . $main::data{ $this->{'id'} }{'key'} ) ? 1 : 0;
    my $clipboard_key
        = ($temp_exist)
        ? $main::data{ $this->{'id'} }{'key'}
        : $cgi::Image->temp_file_name;
    my $exist = ( $path && -f $path . '/' . $this->{'id'} . '.spch' ) ? 1 : 0;
    my $query = $this->escape( $this->get_query_for_editor );
    my $form  = $this->field_header;
    $form
        .= '<input type="hidden" name="data:'
        . $this->{'id'}
        . ':step" id="data:'
        . $this->{'id'}
        . ':step" value="'
        . $this->escape( $main::data{ $this->{'id'} }{'step'} ) . '" />';
    $form
        .= '<input type="hidden" name="data:'
        . $this->{'id'}
        . ':time" id="data:'
        . $this->{'id'}
        . ':time" value="'
        . $this->escape( $main::data{ $this->{'id'} }{'time'} ) . '" />';
    $form
        .= '<input type="hidden" name="data:'
        . $this->{'id'}
        . ':key" id="data:'
        . $this->{'id'}
        . ':key" value="'
        . $clipboard_key . '" />';
    $form
        .= '<a href="./start.cgi'
        . $query
        . '&amp;key='
        . $clipboard_key
        . ( ($exist)
        ? '&amp;pch=' . $this->escape( $path . '/' . $this->{'id'} . '.spch' )
        : '' )
        . '" id="shi-preview-'
        . $this->{'id'}
        . '" target="shiPainter" title="しぃペインターを開く" class="note" onclick="cmonos.window.open(\'shiPainter\','
        . ( ( $this->{'windowwidth'} ) ? $this->{'windowwidth'} : '640' )
        . ','
        . ( ( $this->{'windowheight'} ) ? $this->{'windowheight'} : '480' )
        . ')">';

    if ( ( $exist && $main::data{ $this->{'id'} }{'previewwidth'} )
        || $temp_exist )
    {
        $form .= $cgi::Image->image_tag(
            (   ( $exist && $main::data{ $this->{'id'} }{'previewwidth'} )
                ? $path . '/' . $this->{'id'} . '.preview.png'
                : './start.cgi'
                    . $this->get_query_for_editor . '&key='
                    . $main::data{ $this->{'id'} }{'key'}
                    . '&preview=preview'
            ),
            $main::data{ $this->{'id'} }{'previewwidth'},
            $main::data{ $this->{'id'} }{'previewheight'},
            0,
            'しぃペインターを開く',
            '',
            $this->{'previewwidth'},
            $this->{'previewheight'},
            '', '', 1
        );
    }
    else {
        $form .= 'しぃペインターを開く';
    }
    $form .= '</a>';
    $form
        .= ' <a href="./start.cgi'
        . $query
        . '&amp;mode=pro&amp;key='
        . $clipboard_key
        . ( ($exist)
        ? '&amp;pch=' . $this->escape( $path . '/' . $this->{'id'} . '.spch' )
        : '' )
        . '" target="shiPainter" class="note" onclick="cmonos.window.open(\'shiPainter\','
        . ( ( $this->{'windowwidth'} ) ? $this->{'windowwidth'} : '640' )
        . ','
        . ( ( $this->{'windowheight'} ) ? $this->{'windowheight'} : '480' )
        . ')" title="しぃペインター Pro を開く">[Pro]</a>';
    if (   $parent_path
        && ref $original
        && -f $parent_path . '/' . $this->{'id'} . '.spch' )
    {
        $form
            .= '<br /><a href="./start.cgi'
            . $query
            . '&amp;key='
            . $clipboard_key
            . ( ($exist)
            ? '&amp;pch='
                . $this->escape( $path . '/' . $this->{'id'} . '.spch' )
            : '' )
            . '&amp;import='
            . $this->escape( $parent_path . '/' . $this->{'id'} . '.spch' )
            . '" id="shi-preview-'
            . $this->{'id'}
            . '" target="shiPainter" title="しぃペインターを開く" class="note" onclick="cmonos.window.open(\'shiPainter\','
            . ( ( $this->{'windowwidth'} ) ? $this->{'windowwidth'} : '640' )
            . ','
            . (
            ( $this->{'windowheight'} ) ? $this->{'windowheight'} : '480' )
            . ')">';
        $form .= $cgi::Image->image_tag(
            $parent_path . '/' . $this->{'id'} . '.preview.png',
            $original->{'previewwidth'},
            $original->{'previewheight'},
            0,
            'オリジナルを引用して、しぃペインターを開く',
            '',
            $this->{'previewwidth'},
            $this->{'previewheight'},
            '',
            '',
            1
        );
        $form .= '</a>';
        $form
            .= ' <a href="./start.cgi'
            . $query
            . '&amp;mode=pro&amp;key='
            . $clipboard_key
            . ( ($exist)
            ? '&amp;pch='
                . $this->escape( $path . '/' . $this->{'id'} . '.spch' )
            : '' )
            . '&amp;import='
            . $this->escape( $parent_path . '/' . $this->{'id'} . '.spch' )
            . '" target="shiPainter" class="note" onclick="cmonos.window.open(\'shiPainter\','
            . ( ( $this->{'windowwidth'} ) ? $this->{'windowwidth'} : '640' )
            . ','
            . (
            ( $this->{'windowheight'} ) ? $this->{'windowheight'} : '480' )
            . ')" title="オリジナルを引用して、しぃペインター Pro を開く">[Pro]</a>';
    }
    if (   !$this->{'titlefrom'}
        || !$this->{'usertitledisabled'}
        || !ref $this->{'field_obj'}->{ $this->{'titlefrom'} }
        || $this->{'field_obj'}->{ $this->{'titlefrom'} }->{'class'}
        !~ /^text/
        || (   $this->{'field_obj'}->{ $this->{'titlefrom'} }->{'rows'}
            && $this->{'field_obj'}->{ $this->{'titlefrom'} }->{'rows'} > 1 )
        )
    {
        $form
            .= '<div class="extra-field"><label for="data:'
            . $this->{'id'}
            . ':title">タイトル</label><input type="text" name="data:'
            . $this->{'id'}
            . ':title" id="data:'
            . $this->{'id'}
            . ':title" size="36" value="'
            . $this->escape( $main::data{ $this->{'id'} }{'title'} )
            . '" /></div>';
    }
    $form
        .= '<div class="extra-field"><label><input type="checkbox" name="data:'
        . $this->{'id'}
        . ':delete" value="1" /> この'
        . $this->name(1)
        . 'を削除する</label></div>'
        if !$this->{'required'} && $exist;
    $form
        .= '<div class="extra-field"><label><input type="checkbox" name="data:'
        . $this->{'id'}
        . ':animationDisabled" value="1"'
        . ( ( $main::data{ $this->{'id'} }{'animationDisabled'} )
        ? 'checked="checked"'
        : '' )
        . ' /> アニメーション表示画面を開くリンクを表示しない</label></div>'
        if !$setting::field_for_mail && !$this->{'animationDisabled'};
    $form .= $this->field_footer;
    return $form;
}

######################################################################
#	(3) obj->is_valid_data(path);
sub is_valid_data ($;$) {
    my ( $this, $path ) = @_;
    my $changed = 0;
    my $exist = ( $path && -f $path . '/' . $this->{'id'} . '.spch' ) ? 1 : 0;
    if ($main::clipboard_id) {
        $cgi::input->inherit_posted_file_properties(
            'data:' . $this->{'id'} . ':file' );
        $cgi::input->inherit_posted_file_properties(
            'data:' . $this->{'id'} . ':preview' );
        $cgi::input->inherit_posted_file_properties(
            'data:' . $this->{'id'} . ':pch' );
    }

    #タイトル
    if (   $this->{'titlefrom'}
        && ref $this->{'field_obj'}->{ $this->{'titlefrom'} }
        && $this->{'field_obj'}->{ $this->{'titlefrom'} }->{'class'}
        =~ /^text/
        && (  !$this->{'field_obj'}->{ $this->{'titlefrom'} }->{'rows'}
            || $this->{'field_obj'}->{ $this->{'titlefrom'} }->{'rows'} == 1 )
        && (   !defined $main::data{ $this->{'id'} }{'title'}
            || $main::data{ $this->{'id'} }{'title'} eq ''
            || $this->{'usertitledisabled'} )
        )
    {
        $main::data{ $this->{'id'} }{'title'}
            = ( defined $main::data{ $this->{'titlefrom'} }{'str'} )
            ? $main::data{ $this->{'titlefrom'} }{'str'}
            : '';
        $main::data{ $this->{'id'} }{'title'} =~ s/<>[#0-9a-zA-z]{3,10}\Z//s;
        $this->detag( \$main::data{ $this->{'id'} }{'title'} );
    }

    $main::data{ $this->{'id'} }{'title'} =~ s/[\x0A\x0D]//gs;
    if (   $main::data{ $this->{'id'} }{'key'}
        && $main::data{ $this->{'id'} }{'key'} !~ /[^0-9a-zA-Z_\@\-]/s )
    {
        my $is_valid_header = 1;
        local (*SPD);
        if (open( SPD,
                $env::clipboard . '/' . $main::data{ $this->{'id'} }{'key'}
            )
            )
        {
            binmode SPD;
            flock( SPD, LOCK_EX );
            my $pos = 9;
            my $buf = int( $this->read_image( \*SPD, 1, 8 ) );
            my %header;
            if ($buf) {
                %header = $this->url_decode(
                    $this->read_image( \*SPD, 9, $buf ) );
                $pos += $buf;
                if ( $header{'pch'} ) {
                    my $temp_path = $path;
                    my $pch_path  = $header{'pch'};
                    $temp_path =~ s!/draft\.pending/files!!;
                    $pch_path =~ s!/draft\.pending/files!!;
                    $temp_path =~ s!\.pending/!/!;
                    $pch_path =~ s!\.pending/!/!;
                    if (  !$temp_path
                        || $pch_path ne $temp_path . '/'
                        . $this->{'id'}
                        . '.spch' )
                    {
                        push(
                            @{ $cgi::action->{'dialog'} },
                            (   ( $this->{'name'} )
                                ? $this->{'name'}
                                : 'しぃペインター画像'
                                )
                                . 'の読み込みファイルを確認してください。画像の保存に失敗しました。'
                        ) if ref $cgi::action;
                        $is_valid_header = 0;
                    }
                }
            }
            if ($is_valid_header) {
                $main::data{ $this->{'id'} }{'time'}
                    = ( ( $main::data{ $this->{'id'} }{'time'} )
                    ? $main::data{ $this->{'id'} }{'time'}
                    : 0 )
                    + int( $header{'timer'} / 1000 );
                $main::data{ $this->{'id'} }{'step'} = $header{'count'};
                $buf = int( $this->read_image( \*SPD, $pos, 8 ) );
                $pos += 10;    #8バイト+CRLF
                if ($buf) {
                    my $image = $this->read_image( \*SPD, $pos, $buf );
                    my ( $width, $height, $ext, $type )
                        = $cgi::Image->info( \$image, $this->{'width'},
                        $this->{'height'}, 1 );
                    my $name = 'data:' . $this->{'id'} . ':file';
                    $pos += $buf;
                    $main::data{ $this->{'id'} }{'width'}  = $width;
                    $main::data{ $this->{'id'} }{'height'} = $height;
                    $main::data{ $this->{'id'} }{'type'}   = $ext;
                    $main::data{ $this->{'id'} }{'name'}   = 'image';
                    $main::data{ $this->{'id'} }{'file'}
                        = 'shipainter.' . $ext;
                    $cgi::input->post_clipboard(
                        $name, 0, $image,
                        {   'filename' => 'image.' . $ext,
                            'name'     => $name,
                            'type'     => $type,
                        }
                    );
                    $cgi::input->save_file( $name,
                        '!' . $this->{'id'} . '.image.' . $ext );
                    $mail::file .= '<' . $name . '>,'
                        if !$default::static
                        && ( $this->{'mail'} || $setting::field_for_mail )
                        ;    #メール添付予約
                    $changed = 1;
                }
                $buf = int( $this->read_image( \*SPD, $pos, 8 ) );
                $pos += 8;
                if ($buf) {
                    my $preview = $this->read_image( \*SPD, $pos, $buf );
                    my ( $width, $height, $ext, $type ) = $cgi::Image->info(
                        \$preview,
                        $this->{'previewwidth'},
                        $this->{'previewheight'}, 1
                    );
                    $pos += $buf;
                    $main::data{ $this->{'id'} }{'previewwidth'}  = $width;
                    $main::data{ $this->{'id'} }{'previewheight'} = $height;
                    $main::data{ $this->{'id'} }{'previewtype'}   = $ext;
                    my $name = 'data:' . $this->{'id'} . ':preview';
                    $cgi::input->post_clipboard(
                        $name, 0, $preview,
                        {   'filename' => 'preview.' . $ext,
                            'name'     => $name,
                            'type'     => $type,
                        }
                    );
                    $cgi::input->save_file( $name,
                        '!' . $this->{'id'} . '.preview.' . $ext );
                }
                $buf = int( $this->read_image( \*SPD, $pos, 8 ) );
                $pos += 8;
                if ($buf) {
                    my $pch = $this->read_image( \*SPD, $pos, $buf );
                    my $name = 'data:' . $this->{'id'} . ':pch';
                    $cgi::input->post_clipboard(
                        $name, 0, $pch,
                        {   'filename' => 'shipainter.spch',
                            'name'     => $name,
                            'step'     => $header{'count'},
                            'time' => $main::data{ $this->{'id'} }{'time'},
                            'type' => 'image/x-pch',
                        }
                    );
                    $cgi::input->save_file( $name,
                        '!' . $this->{'id'} . '.spch' );
                }
            }
            else {
                unlink $env::clipboard . '/'
                    . $main::data{ $this->{'id'} }{'key'};
                delete $main::data{ $this->{'id'} }{'key'};
            }
            close(SPD);
        }
    }
    else {
        delete $main::data{ $this->{'id'} }{'key'};
    }
    if ( !$changed
        && ( $this->{'required'} || !$main::data{ $this->{'id'} }{'delete'} )
        )
    {
        my %properties = $cgi::input->get_posted_file_properties_from_param(
            'data:' . $this->{'id'} . ':pch' );
        if ( $exist || $properties{'savedir'} ) {
            my $dir
                = ( $properties{'savedir'} ) ? $properties{'savedir'} : $path;
            $main::data{ $this->{'id'} }{'time'} = $properties{'time'}
                if $properties{'time'};
            $main::data{ $this->{'id'} }{'step'} = $properties{'step'}
                if $properties{'step'};
            $main::data{ $this->{'id'} }{'name'} = 'image';
            (   $main::data{ $this->{'id'} }{'width'},
                $main::data{ $this->{'id'} }{'height'},
                $main::data{ $this->{'id'} }{'type'}
                )
                = $cgi::Image->info(
                (   ( -f $path . '/' . $this->{'id'} . '.image.png' )
                    ? $path . '/' . $this->{'id'} . '.image.png'
                    : $path . '/' . $this->{'id'} . '.image.jpg'
                ),
                $this->{'width'},
                $this->{'height'},
                1
                );
            (   $main::data{ $this->{'id'} }{'previewwidth'},
                $main::data{ $this->{'id'} }{'previewheight'},
                $main::data{ $this->{'id'} }{'previewtype'}
                )
                = $cgi::Image->info(
                (   ( -f $path . '/' . $this->{'id'} . '.preview.png' )
                    ? $path . '/' . $this->{'id'} . '.preview.png'
                    : $path . '/' . $this->{'id'} . '.preview.jpg'
                ),
                $this->{'previewwidth'},
                $this->{'previewheight'},
                1
                );
            $mail::file .= '<data:' . $this->{'id'} . ':file>,'
                if $properties{'savedir'}
                && !$default::static
                && ( $this->{'mail'} || $setting::field_for_mail )
                ;    #メール添付予約
        }
    }

    $this->clipboard_sweeper;

    #必須項目
    if ( $this->{'required'} && !$exist && !$changed ) {
        push(
            @{ $cgi::action->{'dialog'} },
            (   ( $this->{'name'} ) ? $this->{'name'}
                : 'しぃペインター画像'
                )
                . 'がみつかりません。'
                . (
                ( $this->{'name'} ) ? $this->{'name'}
                : 'しぃペインター画像'
                )
                . 'を「しぃペインター」ウィンドウ左上のメニューから「投稿」して保存してください。'
        ) if ref $cgi::action;
        return 0;
    }

    #ファイル削除予約
    if (   !$this->{'required'}
        && !$changed
        && $main::data{ $this->{'id'} }{'delete'} )
    {
        $cgi::input->set_posted_file_properties_from_param(
            'data:' . $this->{'id'} . ':file',
            0, { 'delete' => $this->{'id'} . '(\\.[0-9a-zA-Z_]+)?' } );
    }

    #データ整形
    delete $main::data{ $this->{'id'} }{'time'}
        if defined $main::data{ $this->{'id'} }{'time'}
        && $main::data{ $this->{'id'} }{'time'} ne ''
        && $this->is_nan( $main::data{ $this->{'id'} }{'time'} );
    delete $main::data{ $this->{'id'} }{'step'}
        if defined $main::data{ $this->{'id'} }{'step'}
        && $main::data{ $this->{'id'} }{'step'} ne ''
        && $this->is_nan( $main::data{ $this->{'id'} }{'step'} );
    $this->data( 'file', 'key', 'delete' );
    return 1;
}

sub read_image {
    my ( $this, $image, $pos, $buf ) = @_;
    my $out;
    seek( $image, $pos, 0 );
    read( $image, $out, $buf );
    return $out;
}

sub clipboard_sweeper ($) {
    my $this = shift;
    local (*DIR);
    return 0 unless opendir( DIR, $env::clipboard );
    my @tempfiles = map( $env::clipboard . '/' . $_,
        grep( $_ !~ /^\./
                && $_ !~ /\.html$/
                && -f $env::clipboard . '/' . $_
                && -M $env::clipboard . '/' . $_ > 1,
            readdir(DIR) ) );
    closedir(DIR);
    unlink @tempfiles;
    return 1;
}

#---------------------------------------------------------------------
# 後処理
sub settle_up ($;$) {
    my ( $this, $path ) = @_;
    unlink $env::clipboard . '/' . $main::data{ $this->{'id'} }{'key'}
        if $main::data{ $this->{'id'} }{'key'}
        && $main::data{ $this->{'id'} }{'key'} !~ /[^0-9a-zA-Z_\@\-]/s
        && -f $env::clipboard . '/' . $main::data{ $this->{'id'} }{'key'};
    delete $main::data{ $this->{'id'} }{'key'};
    $this->write_pchviewer(
        $path,
        $main::data{ $this->{'id'} },
        $main::data{ $this->{'id'} }{'animationDisabled'}
    );
    return 1;
}

######################################################################
#	(4) obj->usual_format(str);
sub usual_format {
    my ( $this, $str, $path, $c, $n ) = @_;
    return $this->field_tag('') if !defined $str || $str eq '';
    my (%data);
    %data
        = ( ref $str eq 'HASH' )
        ? ( defined $$str{'str'} )
            ? $this->elements( $$str{'str'} )
            : %$str
        : $this->elements($str);
    undef $str;
    return ( $this->{'icon_type'} )
        ? ''
        : $this->field_tag( $this->data_tag_from_ref( \%data ), 1 )
        if !$data{'type'};
    $str = '';
    my $url
        = ( defined $data{'title'}
            && !$this->is_invalid_url( $data{'title'} ) )
        ? $this->escape_except_html_entity( $data{'title'} )
        : '';
    my $info    = '';
    my $is_file = 0;

    if ( !$this->{'animationDisabled'} && !$data{'animationDisabled'} ) {
        $info = -s $path . '/' . $this->{'id'} . '.image.' . $data{'type'};
        if ( !$info ) {
            $info = '';
        }
        elsif ( $info >= 1000000 ) {
            $info = $this->digit( int( ( $info + 50000 ) / 100000 ) / 10 )
                . 'MB';
        }
        elsif ( $info >= 1000 ) {
            $info = int( ( $info + 500 ) / 1000 ) . 'KB';
        }
        else {
            $info .= 'B';
        }
        if ( $data{'time'} ) {
            $info .= '/' if $info;
            if ( $data{'time'} > 3600 ) {
                my $min = $data{'time'} % 3600;
                $info
                    .= int( $data{'time'} / 3600 )
                    . '時間'
                    . int( $min / 60 ) . '分'
                    . ( $min % 60 ) . '秒';
            }
            elsif ( $data{'time'} > 60 ) {
                $info .= int( $data{'time'} / 60 ) . '分'
                    . ( $data{'time'} % 60 ) . '秒';
            }
            else {
                $info .= $data{'time'} . '秒';
            }
        }
        if ( $data{'step'} ) {
            $info .= '/' if $info;
            $info .= $data{'step'} . 'ステップ';
        }
        if ( !-f $path . '/' . $this->{'id'} . '.html' ) {
            if ( -f $path . '/' . $this->{'id'} . '.spch' ) {
                $this->write_pchviewer( $path, \%data );
            }
            else {
                $data{'animationDisabled'} = 1;
                $is_file = 1;
            }
        }
    }
    $path = $this->base_change( $path, $cgi::output, $cgi::output_option )
        if $cgi::output || $cgi::output_option;
    my $image_path
        = $path . '/'
        . $this->{'id'}
        . (
        ($is_file)
        ? ( ( defined $data{'name'} && $data{'name'} )
            ? '.' . $data{'name'} . '.'
            : '.' )
        : '.image.'
        ) . $data{'type'};
    my $preview_path = $path . '/' . $this->{'id'} . '.preview.png';
    my $title
        = ( defined $data{'title'} )
        ? $this->escape_except_html_entity( $data{'title'} )
        . ( ($info) ? '(' . $info . ')' : '' )
        : $info;
    if ( $this->{'icon_type'} ) {
        my $width = (
                   defined $this->{'icon_type'}
                && $this->{'icon_type'} eq 'preview'
                && $this->{'previewwidth'}
                && ( !$this->{'width'}
                || $this->{'previewwidth'} < $this->{'width'} )
        ) ? $this->{'previewwidth'} : $this->{'width'};
        my $height = (
                   defined $this->{'icon_type'}
                && $this->{'icon_type'} eq 'preview'
                && $this->{'previewheight'}
                && ( !$this->{'height'}
                || $this->{'previewheight'} < $this->{'height'} )
        ) ? $this->{'previewheight'} : $this->{'height'};
        my $icon_path
            = (    defined $this->{'icon_type'}
                && $this->{'icon_type'} eq 'preview'
                && $data{'previewwidth'} ) ? $preview_path : $image_path;
        return ( ($url) ? '<a href="' . $url . '" target="_blank">' : '' )
            . $cgi::Image->image_tag( $icon_path, $data{'width'},
            $data{'height'}, 0, ( ($url) ? $url : $title ),
            '', $width, $height, '', '', ( ($url) ? 1 : 0 ) )
            . ( ($url) ? '</a>' : '' );
    }
    my $thumbnail_disabled
        = ( !$this->{'preview'}
            || ( $this->{'thumbnail'} && $this->{'thumbnail'} eq 'no' ) )
        ? 1
        : 0;
    my $animation_link
        = ( !$this->{'animationDisabled'} && !$data{'animationDisabled'} )
        ? '<a href="'
        . $path . '/'
        . $this->{'id'}
        . '.html" target="PCHViewer" title="アニメーションを開く" class="note" onclick="if(typeof cmonos == \'object\'){cmonos.window.open(\'PCHViewer\','
        . ( ( $data{'width'} )  ? $data{'width'}       : '640' ) . ','
        . ( ( $data{'height'} ) ? $data{'height'} + 26 : '480' )
        . ')}else{window.open(\'\',\'PCHViewer\',\'width='
        . ( ( $data{'width'} ) ? $data{'width'} : '640' )
        . ',height='
        . ( ( $data{'height'} ) ? $data{'height'} + 26 : '480' )
        . ',scrollbars=yes,resizable=yes\')} return true">'
        : '';
    if ( !$thumbnail_disabled && $data{'previewwidth'} ) {
        $title =~ s/[\x0A\x0D]//sg;
        my ( $win_width, $win_height ) = ( $data{'width'}, $data{'height'} );
        $win_width  = 800 if !$win_width  || $win_width > 800;
        $win_height = 600 if !$win_height || $win_height > 600;
        $str .= '<a href="' . $image_path . '"';
        if ( $this->{'rel'} ) {
            $str .= ' rel="' . $this->{'rel'} . '"';
        }
        else {
            $str
                .= " target=\"fileViewer\" onclick=\"if(typeof cmonos == 'object'){cmonos.window.open('fileViewer',$data{'width'},$data{'height'})}else{window.open('','fileViewer','width=$win_width,height=$win_height,scrollbars=yes,resizable=yes')} return true\"";
        }
        $str .= ' title="' . $title . '">';
        $str .= $cgi::Image->image_tag(
            $preview_path,           $data{'previewwidth'},
            $data{'previewheight'},  0,
            $title,                  '',
            $this->{'previewwidth'}, $this->{'previewheight'},
            '',                      '',
            1
        );
        $str .= '</a>';
        $str
            .= '<div class="paint-animation">'
            . $animation_link
            . '[アニメーション]</a></div>'
            if $animation_link;
    }
    else {
        my $linked = 0;
        if ($animation_link) {
            $linked = 1;
            $str    = $animation_link;
        }
        elsif ($url) {
            $linked = 1;
            $str    = '<a href="' . $url . '" target="_blank">';
        }
        $str .= $cgi::Image->image_tag(
            $image_path,
            $data{'width'},
            $data{'height'},
            0,
            ( ( $url && !$animation_link ) ? $url : $title ),
            '',
            $this->{'width'},
            $this->{'height'},
            '',
            '',
            ( ($linked) ? 1 : 0 )
        );
        $str .= '</a>' if $linked;
    }
    return $this->field_tag( $this->data_tag_from_ref( \%data ) . $str );
}

sub image_file_url ($$$$) {
    my ( $this, $str, $path, $c, $n ) = @_;
    return '' if !$str;
    my %data
        = ( ref $str eq 'HASH' )
        ? ( defined $$str{'str'} )
            ? $this->elements( $$str{'str'} )
            : %$str
        : $this->elements($str);
    return ( $data{'type'} )
        ? $this->full_path( $path . '/' . $this->{'id'} . '.preview.png' )
        : '';
}

sub has_content {
    my ( $this, $str ) = @_;
    return 0 if !defined $str || $str eq '';
    my %data
        = ( ref $str eq 'HASH' )
        ? ( defined $$str{'str'} )
            ? $this->elements( $$str{'str'} )
            : %$str
        : $this->elements($str);
    return ( %data && defined $data{'type'} && $data{'type'} ne '' ) ? 1 : 0;
}

#---------------------------------------------------------------------
#	(4)-3 obj->format_for_detail(str);
sub format_for_detail {
    my ( $this, $str, @data ) = @_;
    local $this->{'thumbnail'} = 'no' if $this->{'nopreviewdetail'};
    return $this->usual_format( $str, @data );
}

#---------------------------------------------------------------------
#	(4) obj->format_for_mail(str);
sub format_for_mail {
    my ( $this, $str ) = @_;
    return '' if !defined $str || $str eq '';
    my (%data);
    %data
        = ( ref $str eq 'HASH' )
        ? ( defined $$str{'str'} )
            ? $this->elements( $$str{'str'} )
            : %$str
        : $this->elements($str);
    return ( $data{'type'} )
        ? '[' . $this->name . "]\x0A" . '(添付ファイル)' . "\x0A\x0A"
        : '';
}

#---------------------------------------------------------------------
#	(4)-4 obj->format_for_text(str);
sub format_for_text {
    my ( $this, $str ) = @_;
    return '' if !defined $str || $str eq '';
    my (%data);
    %data
        = ( ref $str eq 'HASH' )
        ? ( defined $$str{'str'} )
            ? $this->elements( $$str{'str'} )
            : %$str
        : $this->elements($str);
    return ( $data{'type'} ) ? '[画像あり]' : '';
}

#---------------------------------------------------------------------
#	(4)-5 obj->confirmation(str);
sub confirmation_enabled ($) {
    my $this = shift;
    return (   $main::data{ $this->{'id'} }{'key'}
            && $main::data{ $this->{'id'} }{'key'} !~ /[^0-9a-zA-Z_\@\-]/s
            && -f $env::clipboard . '/'
            . $main::data{ $this->{'id'} }{'key'} ) ? 1 : 0;
}

sub confirmation ($$) {
    my ( $this, $str ) = @_;
    return
          '<img src="./start.cgi'
        . $this->escape( $this->get_query_for_editor )
        . '&amp;key='
        . $main::data{ $this->{'id'} }{'key'}
        . '&amp;preview=preview" title="一時保存画像" alt="一時保存画像" />';
}

######################################################################
#	(5) obj->print_setting_form;
sub print_setting_form ($;$$) {
    my ( $this, $html_disabled ) = @_;

    #名前
    my $name = 'data:' . $this->{'id'};

    $this->print_field_info_form($name);

    print '<fieldset>';
    print '<legend>しぃペインター設定</legend>';
    print '<table class="field-table">';
    print '<tbody>';
    print '<tr>';
    print '<td class="field-name"><label for="' . $name
        . '_windowwidth">編集ウィンドウ横幅</label></td>';
    print '<td class="q-field"><input type="number" name="'
        . $name
        . '_windowwidth" id="'
        . $name
        . '_windowwidth" value="'
        . $this->escape( $this->{'windowwidth'} )
        . '" size="4" /> <span class="unit">ピクセル</span></td>';
    print '<td class="field-name"><label for="' . $name
        . '_windowheight">編集ウィンドウ高さ</label></td>';
    print '<td class="q-field"><input type="number" name="'
        . $name
        . '_windowheight" id="'
        . $name
        . '_windowheight" value="'
        . $this->escape( $this->{'windowheight'} )
        . '" size="4" /> <span class="unit">ピクセル</span></td>';
    print '</tr>';
    print '<tr class="tbody-end">';
    print '<td class="field-name"><label for="' . $name
        . '_width">画像横幅</label></td>';
    print '<td class="q-field"><input type="number" name="'
        . $name
        . '_width" id="'
        . $name
        . '_width" value="'
        . $this->escape( $this->{'width'} )
        . '" size="4" /> <span class="unit">ピクセル</span></td>';
    print '<td class="field-name"><label for="' . $name
        . '_height">画像高さ</label></td>';
    print '<td class="q-field"><input type="number" name="'
        . $name
        . '_height" id="'
        . $name
        . '_height" value="'
        . $this->escape( $this->{'height'} )
        . '" size="4" /> <span class="unit">ピクセル</span></td>';
    print '</tr>';
    print '</tbody>';

    if ( !$html_disabled ) {
        print '<tbody>';
        print '<tr>';
        print '<td class="field-name"><label><input type="checkbox" name="'
            . $name
            . '_preview" id="'
            . $name
            . '_preview" value="1"'
            . ( ( defined $this->{'preview'} && $this->{'preview'} )
            ? ' checked="checked"'
            : '' )
            . ' /> サムネイル画像</label></td>';
        print
            '<td class="field" colspan="3"><label><input type="checkbox" name="'
            . $name
            . '_nopreviewdetail" id="'
            . $name
            . '_nopreviewdetail" value="1"'
            . (
            (   defined $this->{'nopreviewdetail'}
                    && $this->{'nopreviewdetail'}
            ) ? ' checked="checked"' : ''
            )
            . ' /> 一覧でのみサムネイル画像を使用する。</label></td>';
        print '</tr>';
        print '<tr>';
        print '<td class="field-name"><label for="' . $name
            . '_previewwidth">サムネイル横幅</label></td>';
        print '<td class="q-field"><input type="number" name="'
            . $name
            . '_previewwidth" id="'
            . $name
            . '_previewwidth" value="'
            . $this->escape( $this->{'previewwidth'} )
            . '" size="4" /> <span class="unit">ピクセル</span></td>';
        print '<td class="field-name"><label for="' . $name
            . '_previewheight">サムネイル高さ</label></td>';
        print '<td class="q-field"><input type="number" name="'
            . $name
            . '_previewheight" id="'
            . $name
            . '_previewheight" value="'
            . $this->escape( $this->{'previewheight'} )
            . '" size="4" /> <span class="unit">ピクセル</span></td>';
        print '</tr>';
        print '<tr class="tbody-end">';
        print '<td class="field-name"><label for="' . $name
            . '_rel">画像リンクの rel 属性</label></td>';
        print '<td class="field" colspan="3"><input type="text" name="'
            . $name
            . '_rel" id="'
            . $name
            . '_rel" value="'
            . $this->escape( $this->{'rel'} )
            . '" size="16" title="lightbox 等を使う場合設定します。例）&quot;lightbox[picture]&quot;" /></td>';
        print '</tr>';
        print '</tbody>';
    }
    print '<tbody>';
    print '<tr>';
    print '<td class="field-name"><label for="' . $name
        . '_securityClick">クリック数チェック</label></td>';
    print '<td class="field" colspan="3"><input type="number" name="'
        . $name
        . '_securityClick" id="'
        . $name
        . '_securityClick" value="'
        . $this->escape( $this->{'securityClick'} )
        . '" size="4" /> 回以下の時送信を拒否する</td>';
    print '</tr>';
    print '<tr class="tbody-end">';
    print '<td class="field-name"><label for="' . $name
        . '_securityTime">作業時間チェック</label></td>';
    print '<td class="field" colspan="3"><input type="number" name="'
        . $name
        . '_securityTimer" id="'
        . $name
        . '_securityTimer" value="'
        . $this->escape( $this->{'securityTimer'} )
        . '" size="4" /> 秒以下の時送信を拒否する</td>';
    print '</tr>';
    print '</tbody>';

    if ( ( !$default::static && !$setting::field_for_mail )
        || !$html_disabled )
    {
        print '<tbody>';
        if ( !$default::static && !$setting::field_for_mail ) {
            print '<tr>';
            print '<td class="field-name"><input type="checkbox" name="'
                . $name
                . '_mail" id="'
                . $name
                . '_mail" value="1"'
                . ( ( defined $this->{'mail'} && $this->{'mail'} )
                ? ' checked="checked"'
                : '' )
                . ' /></td>';
            print '<td class="field" colspan="3"><label for="' . $name
                . '_mail">通知メールにファイルを添付する</label></td>';
            print '</tr>';
        }
        if ( !$html_disabled ) {
            print '<tr class="tbody-end">';
            print '<td class="field-name"><input type="checkbox" name="'
                . $name
                . '_animationDisabled" id="'
                . $name
                . '_animationDisabled" value="1"'
                . (
                (   defined $this->{'animationDisabled'}
                        && $this->{'animationDisabled'}
                ) ? ' checked="checked"' : ''
                ) . ' /></td>';
            print '<td class="field" colspan="3"><label for="' . $name
                . '_animationDisabled">アニメーション表示画面を開くリンクを表示しない</label></td>';
            print '</tr>';
        }
        print '</tbody>';
    }
    print '<tbody>';
    print '<tr class="tbody-end">';
    print '<td class="field-name"><label for="' . $name
        . '_titlefrom">タイトル</label></td>';
    print '<td class="field" colspan="3">タイトルがないとき、';
    print '<select name="'
        . $name
        . '_titlefrom" id="'
        . $name
        . '_titlefrom">';
    print '<option value=""></option>';
    foreach my $id (
        sort {
            $this->{'field_obj'}->{$a}->{'ORDER'}
                <=> $this->{'field_obj'}->{$b}->{'ORDER'}
                || $a <=> $b
        } keys %{ $this->{'field_obj'} }
        )
    {
        next
            unless ref $this->{'field_obj'}->{$id}
            && $this->{'field_obj'}->{$id}->{'class'} =~ /^text/
            && ( !$this->{'field_obj'}->{$id}->{'rows'}
            || $this->{'field_obj'}->{$id}->{'rows'} == 1 );
        print '<option value="'
            . $id . '"'
            . (
            ( defined $this->{'titlefrom'} && $this->{'titlefrom'} eq $id )
            ? ' selected="selected"'
            : '' )
            . '>'
            . $this->jfold( $this->{'field_obj'}->{$id}->name, 32, 'I', 1 )
            . '</option>';
    }
    print '</select>からタイトルを作成する';
    print '<div class="extra-field"><label><input type="checkbox" name="'
        . $name
        . '_usertitledisabled" value="1"'
        . ( ( $this->{'usertitledisabled'} ) ? ' checked="checked"' : '' )
        . ' /> 常にこのフィールドの値をタイトルにする。</label></div>';
    print '</td>';
    print '</tr>';
    print '</tbody>';
    print '</table>';
    print '</fieldset>';

    print '<fieldset>';
    print '<legend>しぃペインター画面</legend>';
    print '<ol class="checkbox">';
    print '<li><label><input type="checkbox" name="'
        . $name
        . '_refererCheck" value="1"'
        . ( ( $this->{'refererCheck'} ) ? ' checked="checked"' : '' )
        . ' /> この CGI から開いたかどうかリンク元をチェックする</label></li>';
    print '</ol>';
    print '</fieldset>';

    $this->print_setting_save_button;
    return;
}

######################################################################
#	obj->is_valid_setting;
sub is_valid_setting ($) {
    my $this     = shift;
    my $is_valid = 1;
    if (   defined $main::data{ $this->{'id'} . '_windowwidth' }
        && $main::data{ $this->{'id'} . '_windowwidth' } ne ''
        && $this->is_nan( $main::data{ $this->{'id'} . '_windowwidth' } ) )
    {
        push(
            @{ $cgi::action->{'dialog'} },
            'ウィンドウ横幅を更新できませんでした。半角数字にしてください。'
        ) if ref $cgi::action;
        delete $main::data{ $this->{'id'} . '_windowwidth' };
        $is_valid = 0;
    }
    if (   defined $main::data{ $this->{'id'} . '_windowheight' }
        && $main::data{ $this->{'id'} . '_windowheight' } ne ''
        && $this->is_nan( $main::data{ $this->{'id'} . '_windowheight' } ) )
    {
        push(
            @{ $cgi::action->{'dialog'} },
            'ウィンドウ高さを更新できませんでした。半角数字にしてください。'
        ) if ref $cgi::action;
        delete $main::data{ $this->{'id'} . '_windowheight' };
        $is_valid = 0;
    }
    if ( $main::data{ $this->{'id'} . '_windowwidth' }
        && !$main::data{ $this->{'id'} . '_windowheight' } )
    {
        $main::data{ $this->{'id'} . '_windowheight' }
            = int( $main::data{ $this->{'id'} . '_windowwidth' } * 3 / 4 );
    }
    elsif ( !$main::data{ $this->{'id'} . '_windowwidth' }
        && $main::data{ $this->{'id'} . '_windowheight' } )
    {
        $main::data{ $this->{'id'} . '_windowwidth' }
            = int( $main::data{ $this->{'id'} . '_windowheight' } * 4 / 3 );
    }
    elsif (!$main::data{ $this->{'id'} . '_windowwidth' }
        && !$main::data{ $this->{'id'} . '_windowheight' } )
    {
        $main::data{ $this->{'id'} . '_windowwidth' }  = 640;
        $main::data{ $this->{'id'} . '_windowheight' } = 480;
    }
    if (   defined $main::data{ $this->{'id'} . '_width' }
        && $main::data{ $this->{'id'} . '_width' } ne ''
        && $this->is_nan( $main::data{ $this->{'id'} . '_width' } ) )
    {
        push(
            @{ $cgi::action->{'dialog'} },
            '画像横幅を更新できませんでした。半角数字にしてください。'
        ) if ref $cgi::action;
        delete $main::data{ $this->{'id'} . '_width' };
        $is_valid = 0;
    }
    if (   defined $main::data{ $this->{'id'} . '_height' }
        && $main::data{ $this->{'id'} . '_height' } ne ''
        && $this->is_nan( $main::data{ $this->{'id'} . '_height' } ) )
    {
        push(
            @{ $cgi::action->{'dialog'} },
            '画像高さを更新できませんでした。半角数字にしてください。'
        ) if ref $cgi::action;
        delete $main::data{ $this->{'id'} . '_height' };
        $is_valid = 0;
    }
    if ( $main::data{ $this->{'id'} . '_width' }
        && !$main::data{ $this->{'id'} . '_height' } )
    {
        $main::data{ $this->{'id'} . '_height' }
            = $main::data{ $this->{'id'} . '_width' };
    }
    elsif ( !$main::data{ $this->{'id'} . '_width' }
        && $main::data{ $this->{'id'} . '_height' } )
    {
        $main::data{ $this->{'id'} . '_width' }
            = $main::data{ $this->{'id'} . '_height' };
    }
    elsif (!$main::data{ $this->{'id'} . '_width' }
        && !$main::data{ $this->{'id'} . '_height' } )
    {
        $main::data{ $this->{'id'} . '_width' }  = 480;
        $main::data{ $this->{'id'} . '_height' } = 360;
    }

    if (   defined $main::data{ $this->{'id'} . '_previewwidth' }
        && $main::data{ $this->{'id'} . '_previewwidth' } ne ''
        && $this->is_nan( $main::data{ $this->{'id'} . '_previewwidth' } ) )
    {
        push(
            @{ $cgi::action->{'dialog'} },
            'サムネイル画像横幅を更新できませんでした。半角数字にしてください。'
        ) if ref $cgi::action;
        delete $main::data{ $this->{'id'} . '_previewwidth' };
        $is_valid = 0;
    }
    elsif ($main::data{ $this->{'id'} . '_previewwidth' }
        && $main::data{ $this->{'id'} . '_maxwidth' }
        && $main::data{ $this->{'id'} . '_previewwidth' }
        > $main::data{ $this->{'id'} . '_maxwidth' } )
    {
        push(
            @{ $cgi::action->{'dialog'} },
            'サムネイル画像横幅は画像横幅より小さな値にしてください。'
        ) if ref $cgi::action;
        $main::data{ $this->{'id'} . '_previewwidth' }
            = int( $main::data{ $this->{'id'} . '_width' } / 2 );
    }
    if (   defined $main::data{ $this->{'id'} . '_previewheight' }
        && $main::data{ $this->{'id'} . '_previewheight' } ne ''
        && $this->is_nan( $main::data{ $this->{'id'} . '_previewheight' } ) )
    {
        push(
            @{ $cgi::action->{'dialog'} },
            'サムネイル画像高さを更新できませんでした。半角数字にしてください。'
        ) if ref $cgi::action;
        delete $main::data{ $this->{'id'} . '_previewheight' };
        $is_valid = 0;
    }
    elsif ($main::data{ $this->{'id'} . '_previewheight' }
        && $main::data{ $this->{'id'} . '_maxheight' }
        && $main::data{ $this->{'id'} . '_previewheight' }
        > $main::data{ $this->{'id'} . '_maxheight' } )
    {
        push(
            @{ $cgi::action->{'dialog'} },
            'サムネイル画像高さは画像高さより小さな値にしてください。'
        ) if ref $cgi::action;
        $main::data{ $this->{'id'} . '_previewheight' }
            = int( $main::data{ $this->{'id'} . '_height' } / 2 );
    }
    if ((   $main::data{ $this->{'id'} . '_previewwidth' }
            && !$main::data{ $this->{'id'} . '_previewheight' }
        )
        || (   $main::data{ $this->{'id'} . '_previewwidth' }
            && $main::data{ $this->{'id'} . '_previewheight' }
            && $main::data{ $this->{'id'} . '_previewwidth' }
            / $main::data{ $this->{'id'} . '_width' }
            < $main::data{ $this->{'id'} . '_previewheight' }
            / $main::data{ $this->{'id'} . '_height' } )
        )
    {
        $main::data{ $this->{'id'} . '_previewheight' }
            = int($main::data{ $this->{'id'} . '_height' }
                * $main::data{ $this->{'id'} . '_previewwidth' }
                / $main::data{ $this->{'id'} . '_width' } );
    }
    elsif (
        (     !$main::data{ $this->{'id'} . '_previewwidth' }
            && $main::data{ $this->{'id'} . '_previewheight' }
        )
        || (   $main::data{ $this->{'id'} . '_previewwidth' }
            && $main::data{ $this->{'id'} . '_previewheight' }
            && $main::data{ $this->{'id'} . '_previewwidth' }
            / $main::data{ $this->{'id'} . '_width' }
            > $main::data{ $this->{'id'} . '_previewheight' }
            / $main::data{ $this->{'id'} . '_height' } )
        )
    {
        $main::data{ $this->{'id'} . '_previewwidth' }
            = int($main::data{ $this->{'id'} . '_width' }
                * $main::data{ $this->{'id'} . '_previewheight' }
                / $main::data{ $this->{'id'} . '_height' } );
    }
    elsif (!$main::data{ $this->{'id'} . '_previewwidth' }
        && !$main::data{ $this->{'id'} . '_previewheight' } )
    {
        $main::data{ $this->{'id'} . '_previewwidth' }
            = int( $main::data{ $this->{'id'} . '_width' } * 1 / 3 );
        $main::data{ $this->{'id'} . '_previewheight' }
            = int( $main::data{ $this->{'id'} . '_height' } * 1 / 3 );
    }
    if (   defined $main::data{ $this->{'id'} . '_securityClick' }
        && $main::data{ $this->{'id'} . '_securityClick' } ne ''
        && $this->is_nan( $main::data{ $this->{'id'} . '_securityClick' } ) )
    {
        push(
            @{ $cgi::action->{'dialog'} },
            'クリック回数チェックを更新できませんでした。半角数字にしてください。'
        ) if ref $cgi::action;
        delete $main::data{ $this->{'id'} . '_securityClick' };
        $is_valid = 0;
    }
    if (   defined $main::data{ $this->{'id'} . '_securityTimer' }
        && $main::data{ $this->{'id'} . '_securityTimer' } ne ''
        && $this->is_nan( $main::data{ $this->{'id'} . '_securityTimer' } ) )
    {
        push(
            @{ $cgi::action->{'dialog'} },
            '作業時間チェックを更新できませんでした。半角数字にしてください。'
        ) if ref $cgi::action;
        delete $main::data{ $this->{'id'} . '_securityTimer' };
        $is_valid = 0;
    }
    $main::data{ $this->{'id'} . '_refererCheck' } = ''
        if !$main::data{ $this->{'id'} . '_refererCheck' };
    $main::data{ $this->{'id'} . '_preview' } = ''
        if !defined $main::data{ $this->{'id'} . '_preview' }
        || $main::data{ $this->{'id'} . '_preview' } eq '';
    $main::data{ $this->{'id'} . '_usertitledisabled' } = ''
        if !defined $main::data{ $this->{'id'} . '_usertitledisabled' }
        || !$main::data{ $this->{'id'} . '_usertitledisabled' };
    $main::data{ $this->{'id'} . '_mail' } = ''
        if !$main::data{ $this->{'id'} . '_mail' };
    $main::data{ $this->{'id'} . '_animationDisabled' } = ''
        if !$main::data{ $this->{'id'} . '_animationDisabled' };
    $this->escape( \$main::data{ $this->{'id'} . '_rel' } )
        if defined $main::data{ $this->{'id'} . '_rel' }
        && $main::data{ $this->{'id'} . '_rel' };
    $this->tag_fix( \$main::data{ $this->{'id'} . '_description' } )
        if defined $main::data{ $this->{'id'} . '_description' }
        && $main::data{ $this->{'id'} . '_description' };
    $this->tag_fix( \$main::data{ $this->{'id'} . '_note' } )
        if defined $main::data{ $this->{'id'} . '_note' }
        && $main::data{ $this->{'id'} . '_note' };
    return $is_valid;
}

######################################################################
#	(7) obj->search_form;
sub search_form ($) {
    my $this = shift;
    my $form
        = '<tr><td class="field-name"><label for="search:'
        . $this->{'id'} . ':e">'
        . $this->{'name'}
        . '</label></td><td class="field">';
    $form .= '<select name="search:' . $this->{'id'} . ':e">';
    $form .= '<option value=""></option>';
    $form .= '<option value="0"'
        . (
        (   defined $main::search{ $this->{'id'} }{'e'}
                && $main::search{ $this->{'id'} }{'e'} eq '0'
        ) ? ' selected="selected"' : ''
        )
        . '>'
        . ( ($default::english) ? 'no image' : '無' )
        . '</option>';
    $form .= '<option value="1"'
        . (
        (          $main::search{ $this->{'id'} }{'e'}
                && $main::search{ $this->{'id'} }{'e'} == 1
        ) ? ' selected="selected"' : ''
        )
        . '>'
        . ( ($default::english) ? 'has a image' : '有' )
        . '</option>';
    $form .= '<option value="2"'
        . (
        (          $main::search{ $this->{'id'} }{'e'}
                && $main::search{ $this->{'id'} }{'e'} == 2
        ) ? ' selected="selected"' : ''
        )
        . '>'
        . ( ($default::english) ? 'has a image' : 'アニメーション有' )
        . '</option>'
        if !$this->{'animationDisabled'};
    return $form;
}

######################################################################
#	(8) obj->sort_enabled;
sub sort_enabled ($) {
    my $this = shift;
    return 0;
}

######################################################################
#	(9) obj->cookie_enabled;
sub cookie_enabled ($) {
    my $this = shift;
    return 0;
}

######################################################################
sub editor_enabled ($) {
    my $this = shift;
    return 1;
}

sub is_secure_user_for_edit ($) {
    my $this = shift;
    undef $main::key if !$main::key || $main::key =~ /[^0-9a-zA-Z_\@\-]/s;
    if ( $main::key && $main::preview ) {
        my $preview = '';
        local (*SPD);
        if ( open( SPD, $env::clipboard . '/' . $main::key ) ) {
            binmode SPD;
            flock( SPD, LOCK_EX );
            my $buf = int( $this->read_image( \*SPD, 1, 8 ) );
            my $pos = 9 + $buf;
            $buf = int( $this->read_image( \*SPD, $pos, 8 ) );
            $pos += 10;    #8バイト+CRLF
            if ( $main::preview eq 'image' && $buf ) {
                $preview = $this->read_image( \*SPD, $pos, $buf );
            }
            else {
                $pos += $buf;
                $buf = int( $this->read_image( \*SPD, $pos, 8 ) );
                $pos += 8;
                $preview = $this->read_image( \*SPD, $pos, $buf ) if $buf;
            }
            close(SPD);
        }
        binmode STDOUT;
        utf8::encode($preview) if utf8::is_utf8($preview);
        print 'Content-type: image/',
            ( ( $preview =~ /^\x89\x50\x4e\x47\x0d\x0a\x1a\x0a/ )
            ? 'png'
            : 'jpeg' ), "\x0A";
        print 'Content-length: ', bytes::length($preview), "\x0A";
        print 'Cache-Control: no-cache', "\x0A";
        print 'Pragma: no-cache',        "\x0A";
        print "\x0A";
        print $preview;
        exit;

    }
    elsif ( $this->{'refererCheck'} && $main::key ) {
        my $my_url = $this->my_url;
        return (   $ENV{'HTTP_REFERER'}
                && $ENV{'HTTP_REFERER'} =~ /^\Q$my_url\E/ ) ? 1 : 0;
    }
    elsif ( $main::key || $main::error || $main::success ) {
        return 1;
    }
    else {
        return 0;
    }
}

sub set_user_generated_field_editor_page_settings ($) {
    my $this = shift;
    $setting::page{'ugfieldeditor'}{'title'} = 'しぃペインター';

    #	$setting::page{'ugfieldeditor'}{'text'} = '#000000';
    #	$setting::page{'ugfieldeditor'}{'link'} = '#0000ff';
    #	$setting::page{'ugfieldeditor'}{'alink'} = '#99ffff';
    #	$setting::page{'ugfieldeditor'}{'vlink'} = '#000099';
    #	$setting::page{'ugfieldeditor'}{'hover'} = '#00ffff';
    #	$setting::page{'ugfieldeditor'}{'nodeco'} = 'no';
    $setting::page{'ugfieldeditor'}{'bgcolor'} = '#ffffff';

    #	$setting::page{'ugfieldeditor'}{'bodyId'} = '';
    #	$setting::page{'ugfieldeditor'}{'cssFileName'} = '';
    $setting::page{'ugfieldeditor'}{'CSS'}
        .= 'p { margin: 1em; text-align: center; }';

# 	$setting::page{'ugfieldeditor'}{'CSS'} = 'h1 { font-size: large; font-weight: bold; text-indent: 1em; font-family: "ヒラギノ角ゴ Pro W3",Osaka,"ＭＳ Ｐゴシック",sans-serif;}' . "\x0A";
# 	$setting::page{'ugfieldeditor'}{'CSS'} .= 'h2 { font-size: medium; font-weight: bold; font-family: "ヒラギノ角ゴ Pro W3",Osaka,"ＭＳ Ｐゴシック",sans-serif;}' . "\x0A";
# 	$setting::page{'ugfieldeditor'}{'CSS'} .= 'hr { border-width: 1 0 0 0; }';
# 	$setting::page{'ugfieldeditor'}{'background'} = '';
# 	$setting::page{'ugfieldeditor'}{'bgproperties'} = '';
    $setting::page{'ugfieldeditor'}{'CSS'}
        .= 'applet { margin: 0; padding: 0; display: block; }';
    $setting::page{'ugfieldeditor'}{'topmargin'}    = '0';
    $setting::page{'ugfieldeditor'}{'bottommargin'} = '0';
    $setting::page{'ugfieldeditor'}{'rightmargin'}  = '0';
    $setting::page{'ugfieldeditor'}{'leftmargin'}   = '0';

    # 	$setting::page{'ugfieldeditor'}{'javascript'} = '';
    # 	$setting::page{'ugfieldeditor'}{'header'} = '';
    # 	$setting::page{'ugfieldeditor'}{'headerFileName'} = '';
    # 	$setting::page{'ugfieldeditor'}{'titleImageAlign'} = '';
    # 	$setting::page{'ugfieldeditor'}{'titleImage'} = '';
    # 	$setting::page{'ugfieldeditor'}{'align'} = '';
    # 	$setting::page{'ugfieldeditor'}{'width'} = '';
    # 	$setting::page{'ugfieldeditor'}{'deco'} = '';
    # 	$setting::page{'ugfieldeditor'}{'titleText'} = '';
    return 1;
}

sub print_user_generated_field_editor ($) {
    my $this = shift;
    my $url  = $this->full_path($cgi::path) . $this->get_query_for_editor;
    if ( !$main::success && !$main::error && $cgi::HTTP_RAW_POST_DATA ) {
        binmode STDOUT, ":utf8";
        $this->print_http_header('text/plain');
        if ($main::key) {
            $this->clipboard_sweeper;
            $this->write_file( $env::clipboard . '/' . $main::key,
                \$cgi::HTTP_RAW_POST_DATA, 1 );
            print 'URL:' . $url . '&key=' . $main::key . '&success=1';
        }
        else {
            print "error\x0Aエラー";
        }
        exit;
    }
    $url = $this->escape($url);
    $cgi::action->print_page_header('ugfieldeditor');
    $main::pch
        = ( $main::pch && $main::pch =~ /\.spch$/ && -f $main::pch )
        ? $main::pch
        : '';
    $main::import
        = ( $main::import && $main::import =~ /\.spch$/ && -f $main::import )
        ? $main::import
        : '';
    if ($main::error) {
        print
            '<p>エラー<a href="javascript:void(0)" onclick="history.back()">[&laquo;戻る]</a></p>';
    }
    elsif ($main::success) {
        print
            '<p>画像を一時的に保存しました。24時間以内に記事を保存してください。<a href="javascript:void(0)" onclick="window.close()" title="閉じる">[x]</a></p>';
        print '<p><img src="'
            . $url
            . '&amp;key='
            . $main::key
            . '&amp;preview=image" title="一時保存画像" alt="一時保存画像" /></p>';
    }
    elsif ($main::key) {
        $main::mode
            = ( ( $main::mode && $main::mode eq 'pro' ) ? 'pro' : 'normal' );
        print '<applet code="c.ShiPainter.class" name="paintbbs" archive="'
            . $env::javascript
            . '/sptr/spainter.jar,'
            . $env::javascript
            . '/sptr/res/'
            . $main::mode
            . '.zip" width="'
            . ( ( $this->{'windowwidth'} ) ? $this->{'windowwidth'} : '640' )
            . '" height="'
            . (
            ( $this->{'windowheight'} ) ? $this->{'windowheight'} : '480' )
            . '">' . "\x0A";
        if ($main::import) {
            print '<param name="image_canvas" value="'
                . $main::import . '" />' . "\x0A";
        }
        elsif ($main::pch) {
            print '<param name="image_canvas" value="'
                . $main::pch . '" />' . "\x0A";
        }
        print '<param name="image_width" value="'
            . $this->{'width'} . '" />' . "\x0A";
        print '<param name="image_height" value="'
            . $this->{'height'} . '" />' . "\x0A";

        print '<param name="dir_resource" value="'
            . $env::javascript
            . '/sptr/res/" />' . "\x0A";
        print '<param name="tt.zip" value="'
            . $env::javascript
            . '/sptr/res/tt.zip" />' . "\x0A";
        print '<param name="res.zip" value="'
            . $env::javascript
            . '/sptr/res/res_'
            . $main::mode
            . '.zip" />' . "\x0A";
        print '<param name="tools" value="' . $main::mode . '" />' . "\x0A";

        print '<param name="url_save" value="'
            . $url
            . '&amp;key='
            . $main::key
            . '&amp;HTTP_RAW_POST_DATA=1" />' . "\x0A";
        print '<param name="security_url" value="'
            . $url
            . '&amp;error=1" />' . "\x0A";
        print '<param name="security_post" value="false" />' . "\x0A";

        print '<param name="thumbnail_type" value="png" />' . "\x0A";
        print '<param name="thumbnail_type2" value="animation" />' . "\x0A";
        print '<param name="thumbnail_width" value="'
            . $this->{'previewwidth'} . '" />' . "\x0A";
        print '<param name="thumbnail_height" value="'
            . $this->{'previewheight'} . '" />' . "\x0A";

        print '<param name="send_header" value="pch='
            . $main::pch . '" />' . "\x0A"
            if $main::pch;
        print '<param name="send_header_timer" value="true" />' . "\x0A";
        print '<param name="send_header_count" value="true" />' . "\x0A";

        print '<param name="security_timer" value="'
            . $this->{'securityTimer'} . '" />' . "\x0A"
            if $this->{'securityTimer'};
        print '<param name="security_click" value="'
            . $this->{'securityClick'} . '" />' . "\x0A"
            if $this->{'securityClick'};

        print $this->shipainter_param;
        print "</applet>\x0A";

    }
    else {
        print '<p>ファイルがみつかりません。</p>';
    }
    $cgi::action->print_page_footer('ugfieldeditor');
    return 1;
}

sub user_generated_field_edit ($) {
    my $this = shift;
    return 1;
}

sub get_query_for_editor ($;$$$) {
    my ( $this, $c ) = @_;
    return
          '?m=UserGeneratedFieldEditor&k=ugfieldeditor&id='
        . $this->{'id'}
        . (
        ( $default::subdivided && defined $main::c ) ? '&c=' . $main::c : '' )
        . (
        (          $main::m
                && $main::m !~ /[^0-9a-zA-Z_]/
                && $main::m ne 'UserGeneratedFieldEditor'
        ) ? '&mod=' . $main::m
        : (        $main::mod
                && $main::mod !~ /[^0-9a-zA-Z_]/
                && $main::mod ne 'UserGeneratedFieldEditor' )
        ? '&mod=' . $main::mod
        : ''
        )
        . (
        ( $main::p && $main::p !~ /[^0-9a-zA-Z_]/ ) ? '&p=' . $main::p : '' )
        . ( ($main::i) ? '&i=1' : '' );
}

######################################################################
# アニメーションページ作成
sub write_pchviewer ($$;$$) {
    my ( $this, $path, $data, $animation_disabled ) = @_;
    return 0 if !$path || !-d $path;
    if ( !-f $path . '/' . $this->{'id'} . '.spch' ) {
        unlink $path . '/' . $this->{'id'} . '.html';
        return 0;
    }
    $path .= '/' . $this->{'id'} . '.html';
    my $js_dir = $this->base_change( $env::javascript, $path );
    local (*VIEWER);
    if ( open( VIEWER, ">>$path" ) ) {
        binmode VIEWER, ":utf8";
        flock( VIEWER, LOCK_EX );
        truncate( VIEWER, 0 );
        seek( VIEWER, 0, 0 );
        if ( $this->{'animationDisabled'} || $animation_disabled ) {
            print VIEWER "NO DATA";
        }
        else {
            local $setting::page{'pchviewer'}{'title'}
                = ( $data->{'title'} ) ? $data->{'title'} : '作成過程';
            local $setting::page{'pchviewer'}{'bgcolor'} = '#ffffff';
            local $setting::page{'pchviewer'}{'CSS'}
                = 'applet { margin: 0; padding: 0; display: block; }';
            local $setting::page{'pchviewer'}{'topmargin'}    = '0';
            local $setting::page{'pchviewer'}{'bottommargin'} = '0';
            local $setting::page{'pchviewer'}{'rightmargin'}  = '0';
            local $setting::page{'pchviewer'}{'leftmargin'}   = '0';

            $cgi::action->print_page_header( 'pchviewer', \*VIEWER, $path );

            print VIEWER
                '<applet name="pch" code="pch2.PCHViewer.class" codebase="./" archive="'
                . $js_dir
                . '/sptr/PCHViewer.jar" width="'
                . ( ( $data->{'width'} ) ? $data->{'width'} : '640' )
                . '" height="'
                . ( ( $data->{'height'} ) ? $data->{'height'} + 26 : '480' )
                . '">' . "\x0A";
            print VIEWER '<param name="speed" value="-1" />' . "\x0A";
            print VIEWER '<param name="pch_file" value="./'
                . $this->{'id'}
                . '.spch" />' . "\x0A";

            print VIEWER '<param name="buffer_progress" value="false" />'
                . "\x0A";
            print VIEWER '<param name="buffer_canvas" value="false" />'
                . "\x0A";

            print VIEWER '<param name="res.zip" value="'
                . $js_dir
                . '/sptr/res/res_normal.zip" />' . "\x0A";
            print VIEWER '<param name="tt.zip" value="'
                . $js_dir
                . '/sptr/res/tt.zip" />' . "\x0A";

            print VIEWER $this->shipainter_viewer_param;
            print VIEWER "</applet>\x0A";

            $cgi::action->print_page_footer( 'pchviewer', \*VIEWER, $path );
        }
        close(VIEWER);
        return 1;
    }
    else {
        return 0;
    }
}

######################################################################
sub get_enclosure_attributes ($$$$$) {
    my ( $this, $str, $path, $c, $n ) = @_;
    my ( %data, $size );
    %data
        = ( ref $str eq 'HASH' )
        ? ( defined $$str{'str'} )
            ? $this->elements( $$str{'str'} )
            : %$str
        : $this->elements($str);
    return () if !$data{'type'};
    $path = $path . '/' . $this->{'id'} . '.image.' . $data{'type'};
    $size = -s $path;
    return ($size)
        ? (
        'url'    => $this->full_path($path),
        'length' => ( ($size) ? $size : '' ),
        'type'   => $Common::mime_type{ $data{'type'} }
        )
        : ();
}

######################################################################
#sub import {
BEGIN {
    no warnings qw(once);
    Field::class_register( 'file_shipainter', 'ShiPainter',
        'しぃペインター' )
        if -f $env::javascript . '/sptr/spainter.jar';
}

1;
