package ShoppingCartBase;
require CMONOS::CGI_Lib::Field;
@ISA = qw(Field);
use strict;
use utf8;
######################################################################
# フィールド定義モジュール（ショッピングカート基本モジュール）
# ShoppingCartBase.pm 1.0.10
# Copyright (C) 1999-2018 CMONOS Co. Ltd.
#
# support@cmonos.jp
# http://cmonos.jp/
# 最終更新日：2018-03-01
######################################################################
#	(0)-3 フィールドDB
sub db ($) {
    my $this = shift;
    return 'showcase';
}

# --------------------------------------------------------------------
sub _set ($$) {
    my ( $this, $setting ) = @_;
    unless ( ref $cgi::Image ) {
        require CMONOS::CGI_Lib::Image;
        $cgi::Image = Image->new;
    }
    unless ( ref $cgi::Deco ) {
        require CMONOS::CGI_Lib::Deco;
        $cgi::Deco = Deco->new;
    }
    $this->{'namefield'}
        = $this->{'field_for'}->{'title'} || $this->{'field_for'}->{'name'}
        if !$this->{'namefield'};
    $this->{'keyfield'}
        = $this->{'field_for'}->{'key'} || $this->{'field_for'}->{'title'}
        if !$this->{'keyfield'};
    $this->{'monetaryunit'} = '円' if !$this->{'monetaryunit'};
    $this->{'stockunit'}    = ''    if !defined $this->{'stockunit'};

    #$this->{'pointunit'} = 'point' if !$this->{'pointunit'};
    if ( defined $this->{'stockmenu'} && $this->{'stockmenu'} ne '' ) {
        my $id = 0;
        while ( $this->{'stockmenu'} =~ /^(.*)$/mg ) {
            my $name = $1;
            next if $name !~ /[^\x09\x0A\x0C\x0D\x20]/;
            $this->{'sellout'}[$id] = 1 if $name =~ s/^\*//;
            $this->{'stockAvailability'}[$id] = $name;
            $id++;
        }
        $this->{'stockview'} = 'menu' if $default::static && $id;
        $this->{'stockview'} = 'menu' if !$this->{'stockview'};
    }
    elsif ( !defined $this->{'stockview'} || $this->{'stockview'} eq '' ) {
        $this->{'stockview'} = '' if !$this->{'stockview'};
        $this->{'stockhidden'} = 1;
    }
    $this->{'outOfStockBounds'} = 0 if !$this->{'outOfStockBounds'};
    $this->{'field_for'}->{'showcase'} = $this->{'id'}
        if !$this->{'field_for'}->{'showcase'};

#子フィールドで $this->{'field_obj'}->{$this->{'field_for'}->{'showcase'}}->{'***'}

    #ファイルアップロード
    if (   $this->{'digitalContentUploadEnabled'}
        || $this->{'digitalContentMenuEnabled'} )
    {
        undef %{ $this->{'ext_type'} };
        undef %{ $this->{'type_ext'} };
        undef %{ $this->{'mimename'} };
        delete $this->{'ext_type'};
        delete $this->{'type_ext'};
        delete $this->{'mimename'};
        if (   ref $setting
            && defined $setting->{'mimetype'}
            && $setting->{'mimetype'} ne '' )
        {
            my @mime = split( /\x0A|,[\x09\x0A\x0C\x0D\x20]*/,
                $setting->{'mimetype'} );
            foreach my $type (@mime) {
                next if !defined $type || $type eq '';
                if ( $type =~ /^([^:]+):([^:]+)[:]{0,1}([^:]*)$/ ) {
                    $this->{'ext_type'}{$2} = $1;
                    $this->{'type_ext'}{$1} = $2;
                    $this->{'mimename'}{$2} = ( $3 ne '' ) ? $3 : $2;
                }
            }
        }
        $cgi::enctype_multipart = 1 if $this->{'digitalContentUploadEnabled'};
    }
    $this->{'elements'} = 1;
    return;
}

sub showcase_object_enabled ($) {
    my $this = shift;
    if ( ref $this->{'showcase'} ) {
        return 1;
    }
    elsif ( $this->{'field_for'}->{'showcase'}
        && ref $this->{'field_obj'}->{ $this->{'field_for'}->{'showcase'} } )
    {
        $this->{'showcase'}
            = $this->{'field_obj'}->{ $this->{'field_for'}->{'showcase'} };
        return 1;
    }
    else {
        return 0;
    }
}

# --------------------------------------------------------------------
#	(0)-5 データ要素の取得
sub elements ($$) {
    my ( $this, $str ) = @_;
    my (%data);
    $data{'price'} = $data{'condition'} = $data{'availability'}
        = $data{'stock'}        = $data{'multiple'} = $data{'option'}
        = $data{'discountable'} = $data{'limited'}  = '';
    if ($str) {
        $data{'price'} = $1 if $str =~ s/^([0-9]*)\x0A//;
        while ( $str =~ /^([0-9a-zA-Z_]+)\:(.*)$/gm ) {
            $data{$1} = $2;
            $data{$1} =~ s/&#10;/\x0A/sg;
        }
    }
    return %data;
}

# --------------------------------------------------------------------
#デジタルコンテンツディレクトリ
sub get_digital_content_directory_ftp_url ($) {
    my $this = shift;
    return
          ( ( $this->{'ftpurl'} =~ m!://! ) ? '' : 'ftp://' )
        . $this->{'ftpurl'}
        . $this->ftp_url_fix
        if $this->{'ftpurl'};
    my $digital_content_directory
        = $this->path_conv( $this->get_digital_content_directory_path,
        'path' );
    my $uid = ( stat( $this->path_conv( $ENV{'SCRIPT_NAME'}, 'path' ) ) )[4];
    my $ftp_path = '';
    while ( $digital_content_directory =~ s!(/[^/]+)$!! ) {
        if ($digital_content_directory) {
            my $duid = ( stat($digital_content_directory) )[4];
            if ( !$duid || $duid ne $uid ) {
                $ftp_path = $1 . $ftp_path if !$ftp_path;
                last;
            }
        }
        $ftp_path = $1 . $ftp_path;
    }
    return 'ftp://' . $env::server_name . $ftp_path;
}

sub ftp_url_fix ($) {
    my $this = shift;
    return '';
}

sub get_digital_content_directory_path ($) {
    my $this = shift;
    return ( ($default::home)
        ? ($default::file)
                ? $default::file
                : $default::home
        : ( defined $main::c && $main::c ne '' && !$default::subdivided )
        ? $default::db . '/' . $main::c
        : $default::db )
        . '/digital-content';
}

######################################################################
#	(1)-0 obj->match_enabled;
sub match_enabled ($) {
    my $this = shift;

#return 0 if $this->{'pricehidden'} && $this->{'pointhidden'} && $this->{'stockhidden'};
    return 0 if $this->{'pricehidden'} && $this->{'stockhidden'};
    return 1
        if !$this->is_not_digit( $main::search{ $this->{'id'} }{'f'} )
        || !$this->is_not_digit( $main::search{ $this->{'id'} }{'t'} )
        || !$this->is_not_digit( $main::search{ $this->{'id'} }{'pf'} )
        || !$this->is_not_digit( $main::search{ $this->{'id'} }{'pt'} )
        || (
        defined $main::search{ $this->{'id'} }{'stock'}
        && ( $main::search{ $this->{'id'} }{'stock'} ne ''
            || @{ $main::search{ $this->{'id'} }{'stock'} } )
        );
    return 0;
}

#	(1) obj->match(str);
sub match ($;$) {
    my ( $this, $str ) = @_;
    return (
        ( $this->{'pricehidden'} || $this->price_is_matched( $this, $str ) )

        #&& ($this->{'pointhidden'} || $this->point_is_matched($this,$str))
            && ( $this->{'stockhidden'}
            || $this->stock_is_matched( $this, $str ) )
    ) ? 1 : 0;
}

sub price_is_matched ($$;$) {
    my ( $this, $obj, $str ) = @_;
    return 1
        if $this->is_not_digit( $main::search{ $obj->{'id'} }{'f'} )
        && $this->is_not_digit( $main::search{ $obj->{'id'} }{'t'} );
    $obj->{'price_search_from'}
        = ( !defined $main::search{ $obj->{'id'} }{'f'}
            || $main::search{ $obj->{'id'} }{'f'} eq '' )
        ? ''
        : $this->add_tax( $main::search{ $obj->{'id'} }{'f'} )
        if !defined $obj->{'price_search_from'};
    $obj->{'price_search_to'}
        = ( !defined $main::search{ $obj->{'id'} }{'t'}
            || $main::search{ $obj->{'id'} }{'t'} eq '' )
        ? ''
        : $this->add_tax( $main::search{ $obj->{'id'} }{'t'} )
        if !defined $obj->{'price_search_to'};
    my %data = $this->elements($$str);
    if ((      $obj->{'price_search_from'} eq ''
            || $obj->{'price_search_from'} <= $data{'price'}
        )
        && (   $obj->{'price_search_to'} eq ''
            || $obj->{'price_search_to'} >= $data{'price'} )
        )
    {
#if (($obj->{'price_search_from'} eq '' || $obj->{'price_search_from'} <= $$str) &&
#	($obj->{'price_search_to'} eq '' || $obj->{'price_search_to'} >= $$str)) {
        return 1;
    }
    else {
        return 0;
    }
}

#sub point_is_matched ($$;$) {
#my($this,$obj,$str) = @_;
#return 1 if $this->is_not_digit($main::search{$obj->{'id'}}{'pf'}) && $this->is_not_digit($main::search{$obj->{'id'}}{'pt'});
#my %data = $this->elements($$str);
#if ((!defined $main::search{$obj->{'id'}}{'pf'} || $main::search{$obj->{'id'}}{'pf'} eq '' || $main::search{$obj->{'id'}}{'pf'} <= $data{'point'}) &&
#	(!defined $main::search{$obj->{'id'}}{'pt'} || $main::search{$obj->{'id'}}{'pt'} eq '' || $main::search{$obj->{'id'}}{'pt'} >= $data{'point'})) {
#	return 1;
#} else {
#	return 0;
#}
#}

sub stock_is_matched ($$;$) {
    my ( $this, $obj, $str ) = @_;
    return 1
        if !defined $main::search{ $obj->{'id'} }{'stock'}
        || $main::search{ $obj->{'id'} }{'stock'} eq '';
    $this->scalar_to_array( \$main::search{ $obj->{'id'} }{'stock'} );
    my %data = $this->elements($$str);
    if ($this->{'stockDisabled'}
        || (   $this->{'digitalContentMenuEnabled'}
            && $data{'foldertype'}
            && $data{'foldertype'} eq '1'
            && $data{'digitalcontent'} )
        || (   $this->{'digitalContentUploadEnabled'}
            && $data{'foldertype'}
            && $data{'foldertype'} eq '2'
            && $data{'digitalcontent'} )
        )
    {
        if (
#				($data{'withdrawn'} && (grep($_ eq 'withdrawn',@{$main::search{$obj->{'id'}}{'stock'}}) || ($this->{'stockview'} eq 'sync' && grep($_ eq 'out_of_stock',@{$main::search{$obj->{'id'}}{'stock'}})) || ($this->{'stockview'} eq 'menu' && ref $this->{'sellout'} eq 'ARRAY' && grep(defined $_ && $_ =~ /^[0-9]+$/ && $this->{'sellout'}[$_],@{$main::search{$obj->{'id'}}{'stock'}}))))
#			||	(!$data{'withdrawn'} && (grep($_ eq 'file',@{$main::search{$obj->{'id'}}{'stock'}}) || ($this->{'stockview'} eq 'sync' && grep($_ eq 'abundant' || $_ eq 'in_stock' || $_ eq 'limited',@{$main::search{$obj->{'id'}}{'stock'}})) || ($this->{'stockview'} eq 'menu' && (!ref $this->{'sellout'} || grep(defined $_ && $_ =~ /^[0-9]+$/ && $this->{'stockAvailability'}[$_] && !$this->{'sellout'}[$_],@{$main::search{$obj->{'id'}}{'stock'}})))))
            (   $data{'withdrawn'} && grep( $_ eq 'withdrawn',
                    @{ $main::search{ $obj->{'id'} }{'stock'} } )
            )
            || (!$data{'withdrawn'}
                && grep( $_ eq 'file',
                    @{ $main::search{ $obj->{'id'} }{'stock'} } )
            )
            )
        {
            return 1;
        }
        else {
            return 0;
        }
    }
    if ( !$this->{'digitalContentRequired'} ) {
        if ( $this->{'stockview'} eq 'sync' ) {
            return 1 if defined $default::static && $default::static;
            return 0 if !defined $data{'stock'} || $data{'stock'} eq '';
            foreach my $availability (
                @{ $main::search{ $obj->{'id'} }{'stock'} } )
            {
                if ( $data{'stock'} <= $this->{'outOfStockBounds'} ) {
                    return 1 if $availability eq 'out_of_stock';
                }
                elsif ($this->{'limitedAvailabilityBounds'}
                    && $data{'stock'}
                    <= $this->{'limitedAvailabilityBounds'} )
                {
                    return 1 if $availability eq 'limited';
                }
                elsif ($this->{'inStockBounds'}
                    && $data{'stock'} <= $this->{'inStockBounds'} )
                {
                    return 1 if $availability eq 'in_stock';
                }
                elsif ( $data{'stock'} ) {
                    return 1 if $availability eq 'abundant';
                }
            }
            return 0;
        }
        elsif ( $this->{'stockview'} eq 'menu' ) {
            return (
                grep( $_ eq $data{'availability'},
                    @{ $main::search{ $obj->{'id'} }{'stock'} } )
            ) ? 1 : 0;
        }
    }
    return 0;
}

######################################################################
#	(2) obj->form;
sub form {
    my ( $this, $status, $original, $path ) = @_;
    my ($form);

    #フィールドネーム+ヘッダ
    $form = $this->field_header;

    #デフォルトの作成
    if (( !defined $status || $status eq '' )
        && ( !defined $main::data{ $this->{'id'} }{'price'}
            || $main::data{ $this->{'id'} }{'price'} eq '' )
        )
    {
        $main::data{ $this->{'id'} }{'price'}  = $this->{'defaultprice'};
        $main::data{ $this->{'id'} }{'stock'}  = $this->{'defaultstock'};
        $main::data{ $this->{'id'} }{'weight'} = $this->{'defaultweight'};
        $main::data{ $this->{'id'} }{'condition'}
            = $this->{'defaultcondition'};
        $main::data{ $this->{'id'} }{'discountable'}
            = $this->{'defaultdiscountable'};
        $main::data{ $this->{'id'} }{'limited'} = $this->{'defaultlimited'};
        $main::data{ $this->{'id'} }{'noshipping'}
            = $this->{'defaultnoshipping'};
        $main::data{ $this->{'id'} }{'canceldeadline'}
            = $this->{'defaultcanceldeadline'};
        $main::data{ $this->{'id'} }{'availability'}
            = $this->{'defaultavailability'};
        $main::data{ $this->{'id'} }{'option'} = $this->{'defaultoption'};
        $this->set_default_value( $main::data{ $this->{'id'} } );
    }

    #入力フォーム表示
    $form .= $this->input_form(
        'data:' . $this->{'id'} . ':',
        '', $main::data{ $this->{'id'} },
        1, 1, $this->{'id'}, $path
    );
    $form .= $this->field_footer;
    return $form;
}

sub set_default_value ($$) {
    my ( $this, $data ) = @_;
}

sub input_form ($$$$;$$$) {
    my ( $this, $name, $type, $data, $option, $invalid_check, $id, $path )
        = @_;
    my ( $form, $form_id, $pricelimit );
    $type = '' if !defined $type;
    $pricelimit
        = ( defined $this->{'pricelimit'} && $this->{'pricelimit'} )
        ? ',' . $this->{'pricelimit'}
        : '';

#$pricelimit .= (($pricelimit) ? '' : ",''") . ',' . $this->{'pointlimit'} if defined $this->{'pointlimit'} && $this->{'pointlimit'};
    $form_id = ($id) ? $id : $this->{'id'};
    $form .= '<table class="sub-field-table">';
    if ( $invalid_check && $this->{'digitalContentMenuEnabled'} ) {
        my $digital_content_directory
            = $this->get_digital_content_directory_path;
        my $ftp_url = $this->get_digital_content_directory_ftp_url;
        $form .= '<tbody>';
        $form
            .= '<tr><td class="sub-field-name"><span class="datatitle" title="デジタルコンテンツのアップロード先フォルダ">FTP</span></td><td class="sub-field"><a href="'
            . $ftp_url . '">'
            . $ftp_url
            . '</a></td></tr>'
            if $this->is_secure('tools');
        $form
            .= ( !$this->{'digitalContentUploadEnabled'} )
            ? '<tr>'
            : '<tr class="tbody-end">';
        $form
            .= '<td class="sub-field-name"><label for="'
            . $name
            . 'selectedDigitalContent" title="デジタルコンテンツメニュー">ダウンロード商品</label></td><td class="sub-field">';
        local (*DIR);
        if ( $this->set_dir($digital_content_directory)
            && opendir( DIR, $digital_content_directory ) )
        {
            $this->write_file(
                $digital_content_directory . '/.htaccess',
                'Satisfy all' . "\x0A"
                    . 'order deny,allow' . "\x0A"
                    . 'deny from all' . "\x0A",
                1
            );
            my %digital_content = ();
            my $digital_content
                = $data->{ $type . 'selectedDigitalContent' } || '';
            my $is_menu = 0;
            if (   $data->{ $type . 'foldertype' }
                && $data->{ $type . 'foldertype' } eq '1'
                && -f $digital_content_directory . '/'
                . $data->{ $type . 'digitalcontent' } )
            {
                $digital_content = $data->{ $type . 'digitalcontent' };
                $is_menu         = 1;
            }
            my $count = 0;
            my $done  = 0;
            my @files
                = grep( $_ !~ /^\./
                    && $_ =~ /\.[0-9a-zA-Z_]+$/
                    && -f "$digital_content_directory/$_",
                readdir(DIR) );
            closedir(DIR);
            foreach my $f (@files) {
                $digital_content{$f}
                    = ( stat("$digital_content_directory/$f") )[9]
                    if !ref $this->{'ext_type'}
                    || ( $f =~ /\.([0-9a-zA-Z_]+)$/
                    && $this->{'ext_type'}{$1} );
            }
            if (%digital_content) {
                $form
                    .= '<select name="'
                    . $name
                    . 'selectedDigitalContent" id="'
                    . $name
                    . 'selectedDigitalContent"'
                    . (
                    ( $this->{'is_invalid_field'}{'selectedDigitalContent'} )
                    ? $this->set_invalid_class
                    : '' )
                    . '>';
                $form .= '<option value=""></option>';
                foreach my $f (
                    sort { $digital_content{$b} <=> $digital_content{$a} }
                    keys %digital_content )
                {
                    $form
                        .= '<option value="'
                        . $this->escape($f) . '"'
                        . ( ( $f eq $digital_content && !$done++ )
                        ? ' selected="selected"'
                        : '' )
                        . '>'
                        . $this->escape($f)
                        . '</option>';
                    last
                        if $this->{'maxitem'}
                        && ++$count >= $this->{'maxitem'};
                }
                $form
                    .= '<option value="'
                    . $this->escape($digital_content)
                    . '" selected="selected">'
                    . $this->escape($digital_content)
                    . '</option>'
                    if $digital_content && !$done;
                $form .= '</select>';
                if ($is_menu) {
                    $form
                        .= '<input type="hidden" name="'
                        . $name
                        . 'foldertype" value="'
                        . $this->escape( $data->{ $type . 'foldertype' } )
                        . '" />';
                    $form
                        .= '<input type="hidden" name="'
                        . $name
                        . 'digitalcontent" value="'
                        . $this->escape( $data->{ $type . 'digitalcontent' } )
                        . '" />';
                }
                elsif ($data->{ $type . 'foldertype' }
                    && $data->{ $type . 'foldertype' } eq '1' )
                {
                    delete $data->{ $type . 'foldertype' };
                    delete $data->{ $type . 'digitalcontent' };
                }
            }
            else {
                $form
                    .= 'デジタルコンテンツがみつかりません。';
            }
        }
        else {
            $form
                .= 'デジタルコンテンツフォルダを開けませんでした。';
        }
        $form .= '</td></tr>';
        $form .= '</tbody>' if !$this->{'digitalContentUploadEnabled'};
    }
    if ( $invalid_check && $this->{'digitalContentUploadEnabled'} ) {
        $form .= '<tbody>' if !$this->{'digitalContentMenuEnabled'};
        $form .= '<tr class="tbody-end">';
        $form
            .= '<td class="sub-field-name"><label for="'
            . $name
            . 'file" title="デジタルコンテンツファイルを指定してアップロードします">ダウンロード商品</label></td><td class="sub-field">';
        $form
            .= '<span id="'
            . $name
            . 'file-wrapper"><input type="file" name="'
            . $name
            . 'file" id="'
            . $name . 'file"'
            . ( ( $this->{'is_invalid_field'}{'file'} )
            ? $this->set_invalid_class
            : '' )
            . ' /></span><input type="button" value="&#139; リセット" onclick="cmonos.form.item(this.form).fieldname(\''
            . $name
            . 'file\').reset()">';
        if (   $data->{ $type . 'foldertype' }
            && $data->{ $type . 'foldertype' } eq '2'
            && $data->{ $type . 'digitalcontent' }
            && -f ( (
                          !$cgi::input->{'clipboard_expired'}
                        && $this->{'is_posted_file'}
                )         ? $cgi::input->get_public_clipboard
                : ($path) ? $path
                :           $this->get_file_directory
            )
            . '/'
            . $id . '.'
            . $data->{ $type . 'digitalcontent' } . '.dat'
            )
        {
            $form .= $this->digital_content_icon(
                $main::data{ $this->{'id'} } );
            if (  !$cgi::input->{'clipboard_expired'}
                && $this->{'is_posted_file'} )
            {
                $form
                    .= '<div class="extra-field"><label><input type="checkbox" name="option:'
                    . $this->{'id'}
                    . ':cancel" value="1" /> この<strong>未確定</strong>ファイルを削除する</label></div>';
            }
            elsif ($this->{'digitalContentMenuEnabled'}
                || !$this->{'required'}
                || !$this->{'digitalContentRequired'} )
            {
                $form
                    .= '<div class="extra-field"><label><input type="checkbox" name="'
                    . $name
                    . 'delete" value="1"'
                    . (
                    (         !$cgi::input->{'clipboard_expired'}
                            && $main::data{ $this->{'id'} }{'delete'}
                    ) ? ' checked="checked"' : ''
                    ) . ' /> このファイルを削除する</label></div>';
            }
            $form
                .= '<input type="hidden" name="'
                . $name
                . 'foldertype" value="'
                . $this->escape( $data->{ $type . 'foldertype' } ) . '" />';
            $form
                .= '<input type="hidden" name="'
                . $name
                . 'digitalcontent" value="'
                . $this->escape( $data->{ $type . 'digitalcontent' } )
                . '" />';
        }
        elsif ($data->{ $type . 'foldertype' }
            && $data->{ $type . 'foldertype' } eq '2' )
        {
            delete $data->{ $type . 'foldertype' };
            delete $data->{ $type . 'digitalcontent' };
        }
        $form .= '</td></tr>';
        $form .= '</tbody>';
    }
    $form .= '<tbody>';
    if (!$invalid_check
        && (   $this->{'digitalContentMenuEnabled'}
            || $this->{'digitalContentUploadEnabled'} )
        && $data->{ $type . 'digitalcontent' }
        )
    {
        $form .= '<tr>';
        $form
            .= '<td class="sub-field-name"><span class="datatitle">ファイル</span></td>';
        $form .= '<td class="sub-field">';
        $form .= $this->digital_content_icon($data);
        $form
            .= '<input type="hidden" name="'
            . $name
            . 'foldertype" value="'
            . $this->escape( $data->{ $type . 'foldertype' } ) . '" />';
        $form
            .= '<input type="hidden" name="'
            . $name
            . 'digitalcontent" value="'
            . $this->escape( $data->{ $type . 'digitalcontent' } ) . '" />';
        $form .= '</td></tr>';
    }
    $form .= '<tr>';
    $form
        .= '<td class="sub-field-name"><label for="price-form-'
        . $form_id
        . '">価格</label></td>';
    $form .= '<td class="sub-field">';
    $form .= '<span class="unit">' . $this->{'monetaryunit'} . '</span> '
        if $this->{'monetaryunit'} !~ /[^\x20-\x7F]/;
    $form
        .= '<input type="number" size="8" name="'
        . $name
        . 'price" value="'
        . $this->escape( $data->{ $type . 'price' } )
        . '" onchange="cmonos.tool.showPrice(\''
        . $env::tax_frac . '\','
        . $env::tax_rate . ',\''
        . $form_id . '\''
        . $pricelimit . ');"'
        . ( ( $invalid_check && $this->{'is_invalid_field'}{'price'} )
        ? ' class="invalid-field"'
        : '' )
        . ' id="price-form-'
        . $form_id . '" />';
    $form .= ' <span class="unit">' . $this->{'monetaryunit'} . '</span>'
        if $this->{'monetaryunit'} =~ /[^\x20-\x7F]/;
    $form .= ' <span class="note">(税込み価格 : ';
    $form .= $this->{'monetaryunit'}
        if $this->{'monetaryunit'} !~ /[^\x20-\x7F]/;
    $form .= '<span id="price-' . $form_id . '">';
    $form .= $this->digit( $this->add_tax( $data->{ $type . 'price' } ) );
    $form .= '</span>';
    $form .= $this->{'monetaryunit'}
        if $this->{'monetaryunit'} =~ /[^\x20-\x7F]/;
    $form .= ')</span>';
    $form .= '</td></tr>';

#$form .= '<tr>';
#$form .= '<td class="sub-field-name"><label for="point-form-' . $form_id . '">ポイント率</label></td>';
#$form .= '<td class="sub-field">';
#$form .= '<input type="text" size="10" name="' . $name . 'point" value="' . $this->escape($data->{$type . 'point'}) . '" onchange="cmonos.tool.showPrice(\'' . $env::tax_frac . '\',' . $env::tax_rate . ',\'' . $form_id . '\'' . $pricelimit . ');"' . (($invalid_check && $this->{'is_invalid_field'}{'point'}) ? ' class="invalid-field"' : '') . ' id="point-form-' . $form_id . '" />';
#$form .= ' % <span class="note">(';
#$form .= '<span id="point-' . $form_id . '">';
#$form .= $this->digit($this->get_point($data->{$type . 'point'},$data->{$type . 'price'}));
#$form .= '</span>';
#$form .= $this->{'pointunit'};
#$form .= ')</span></td></tr>';
    if ($option) {
        if (   $this->{'weightenabled'}
            && !$this->{'digitalContentRequired'}
            && !$data->{ $type . 'digitalcontent' } )
        {
            $form .= '<tr>';
            $form
                .= '<td class="sub-field-name"><label for="'
                . $name
                . 'weight">重量</label></td>';
            $form
                .= '<td class="sub-field"><input type="number" size="4" name="'
                . $name
                . 'weight" id="'
                . $name
                . 'weight" value="'
                . $this->escape( $data->{ $type . 'weight' } ) . '"'
                . (
                (          $invalid_check
                        && $this->{'is_invalid_field'}{ $type . 'weight' }
                ) ? $this->set_invalid_class : ''
                ) . ' step="0.1" /> <span class="unit">g</span></td>';
            $form .= '</tr>';
        }
        if (   $this->{'sizeAndThicknessEnabled'}
            && !$this->{'digitalContentRequired'}
            && !$data->{ $type . 'digitalcontent' } )
        {
            $form .= '<tr>';
            $form
                .= '<td class="sub-field-name"><label for="'
                . $name
                . 'papersize">サイズ</label></td><td class="sub-field">';
            $form .= $this->mk_select_menu(
                $name . 'papersize', '', '', $data->{ $type . 'papersize' },
                ''          => '',
                'A6'        => 'A6',
                'B6'        => 'B6',
                'A5'        => 'A5',
                'B5'        => 'B5',
                'A4'        => 'A4',
                'OUT'       => 'A4より大きい',
                'ACCESSORY' => '小物類',
            );
            $form .= '</td></tr>';
            $form .= '<tr>';
            $form
                .= '<td class="sub-field-name"><label for="'
                . $name
                . 'thickness">厚さ</label></td>';
            $form
                .= '<td class="sub-field"><input type="number" size="4" name="'
                . $name
                . 'thickness" id="'
                . $name
                . 'thickness" value="'
                . $this->escape( $data->{ $type . 'thickness' } ) . '"'
                . (
                (          $invalid_check
                        && $this->{'is_invalid_field'}{ $type . 'thickness' }
                ) ? $this->set_invalid_class : ''
                ) . ' step="0.1" /> <span class="unit">mm</span></td>';
            $form .= '</tr>';
        }
    }
    if ( $data->{ $type . 'digitalcontent' } || $this->{'stockDisabled'} ) {
        $data->{ $type . 'withdrawn' } = time
            if $data->{ $type . 'withdrawn' }
            && $this->is_not_digit( $data->{ $type . 'withdrawn' } );
        $form .= '<tr>';
        $form
            .= '<td class="sub-field-name"><label for="'
            . $name
            . 'withdrawn">販売中止</label></td>';
        $form
            .= '<td class="sub-field"><input type="checkbox" name="'
            . $name
            . 'withdrawn" id="'
            . $name
            . 'withdrawn" value="'
            . ( $data->{ $type . 'withdrawn' } || time ) . '"'
            . (
            ( $data->{ $type . 'withdrawn' } ) ? ' checked="checked"' : '' )
            . ' />'
            . $this->escape( $this->{'withdrawnLabel'} || '販売中止' )
            . ( ( $data->{ $type . 'withdrawn' } )
            ? '('
                . int( ( time - $data->{ $type . 'withdrawn' } ) / 86400 )
                . '日)'
            : '' )
            . '</td>';
        $form .= '</tr>';
    }
    elsif ( !$default::static && !$this->{'digitalContentRequired'} ) {
        $form .= '<tr>';
        $form
            .= '<td class="sub-field-name"><label for="'
            . $name
            . 'stock">在庫数</label></td>';
        $form
            .= '<td class="sub-field"><input type="number" size="4" name="'
            . $name
            . 'stock" id="'
            . $name
            . 'stock" value="'
            . $this->escape( $data->{ $type . 'stock' } ) . '"'
            . (
            (          $invalid_check
                    && $this->{'is_invalid_field'}{ $type . 'stock' }
            ) ? $this->set_invalid_class : ''
            )
            . ' />'
            . ( ( $this->{'stockunit'} ne '' )
            ? ' <span class="unit">' . $this->{'stockunit'} . '</span>'
            : '' )
            . '</td>';
        $form .= '</tr>';
    }
    if (!$this->{'stockDisabled'}
        && ($this->{'stockview'} eq 'menu'
            || ( $default::static
                && ref $this->{'stockAvailability'} eq 'ARRAY' )
        )
        && !$this->{'digitalContentRequired'}
        && !$data->{ $type . 'digitalcontent' }
        )
    {
        my $option = '';
        my $id     = 0;
        foreach my $availability_name ( @{ $this->{'stockAvailability'} } ) {
            $option
                .= '<option value="'
                . $id . '"'
                . (
                (          defined $data->{ $type . 'availability' }
                        && $data->{ $type . 'availability' } ne ''
                        && $data->{ $type . 'availability' } eq $id
                ) ? ' selected="selected"' : ''
                )
                . '>'
                . $this->get_option_name($availability_name)
                . ( ( ref $this->{'sellout'} && $this->{'sellout'}[$id] )
                ? '(受注停止)'
                : '' )
                . '</option>';
            $id++;
        }
        if ($option) {
            $form .= '<tr>';
            $form
                .= '<td class="sub-field-name"><label for="'
                . $name
                . 'availability">在庫状況</label></td>';
            $form .= '<td class="sub-field">';
            $form
                .= '<select name="'
                . $name
                . 'availability" id="'
                . $name
                . 'availability">';
            $form .= '<option value=""></option>';
            $form .= $option;
            $form .= '</select>';
            $form .= '</td>';
            $form .= '</tr>';
        }
    }
    if ( $type || ( $invalid_check && !$this->{'defaultconditionfixed'} ) ) {
        $form .= '<tr>';
        $form
            .= '<td class="sub-field-name"><label for="'
            . $name
            . 'condition">状態</label></td>';
        $form .= '<td class="sub-field">';
        $form .= $this->mk_select_menu(
            $name . 'condition', '', '', $data->{ $type . 'condition' },
            'new'         => '新品',
            'used'        => '中古品',
            'refurbished' => '再生品'
        );
        $form
            .= ' <label><input type="checkbox" name="'
            . $name
            . 'conditionfixed" value="1"'
            . ( ( $data->{ $type . 'conditionfixed' } )
            ? ' checked="checked"'
            : '' )
            . ' />固定(非表示)</label>'
            if $type;
        $form .= '</td>';
        $form .= '</tr>';
    }
    if ( $this->{'discountenabled'} || $this->{'limitenabled'} ) {
        $form .= '<tr>';
        $form
            .= '<td class="sub-field-name"><span class="datatitle">販売条件</span></td>';
        $form .= '<td class="sub-field">';
        $form
            .= '<label><input type="checkbox" name="'
            . $name
            . 'discountable" id="'
            . $name
            . 'discountable" value="1"'
            . ( ( $data->{ $type . 'discountable' } )
            ? ' checked="checked"'
            : '' )
            . ' />'
            . ( $this->{'discountableLabel'}
                || 'まとめ買い割引対象' )
            . '</label>'
            if $this->{'discountenabled'};
        $form
            .= ( ( $this->{'discountenabled'} ) ? '<br />' : '' )
            . '<label><input type="checkbox" name="'
            . $name
            . 'limited" id="'
            . $name
            . 'limited" value="1"'
            . ( ( $data->{ $type . 'limited' } ) ? ' checked="checked"' : '' )
            . ' />'
            . ( $this->{'limitedLabel'} || '購入総額制限対象' )
            . '</label>'
            if $this->{'limitenabled'};
        $form .= '</td>';
        $form .= '</tr>';
    }
    if ( $type || $invalid_check ) {
        $form .= '<tr>';
        $form
            .= '<td class="sub-field-name"><span class="datatitle">配送</span></td>';
        $form .= '<td class="sub-field">';
        $form
            .= '<label><input type="checkbox" name="'
            . $name
            . 'noshipping" id="'
            . $name
            . 'noshipping" value="1"'
            . (
            ( $data->{ $type . 'noshipping' } ) ? ' checked="checked"' : '' )
            . ' /> 配送不要</label>';
        $form .= '</td>';
        $form .= '</tr>';
        $form .= '<tr>';
        $form
            .= '<td class="sub-field-name"><span class="datatitle">キャンセル期限</span></td>';
        $form .= '<td class="sub-field">';
        $form
            .= '<label><input type="checkbox" name="'
            . $name
            . 'canceldeadline" id="'
            . $name
            . 'canceldeadline" value="shipping"'
            . (
            (          $data->{ $type . 'canceldeadline' }
                    && $data->{ $type . 'canceldeadline' } eq 'shipping'
            ) ? ' checked="checked"' : ''
            ) . ' /> 配送前まで</label>';
        $form .= $this->cancel_deadline_field( $name, $type, $data,
            $invalid_check );
        $form .= '</td>';
        $form .= '</tr>';
    }
    if ($option) {
        if ( $this->{'optionenabled'} ) {
            $form .= '<tr>';
            $form
                .= '<td class="sub-field-name"><label for="'
                . $name
                . 'option">オプション</label></td>';
            $form .= '<td class="sub-field">';
            $form
                .= '<textarea name="'
                . $name
                . 'option" id="'
                . $name
                . 'option" rows="5" cols="40"'
                . (
                (          $invalid_check
                        && $this->{'is_invalid_field'}{ $type . 'option' }
                ) ? $this->set_invalid_class : ''
                ) . '>';
            $form .= $this->escape( $data->{ $type . 'option' } );
            $form .= '</textarea>';
            $form
                .= '<div class="note">書式=項目名:上乗せ価格[改行]</div><div class="note">上乗せ価格は正負の整数にしてください</div>';
            $form
                .= '<div class="extra-field"><label><input type="checkbox" name="'
                . $name
                . 'multiple" value="1"'
                . ( ( $data->{ $type . 'multiple' } )
                ? ' checked="checked"'
                : '' )
                . ' /> 複数選択可</label></div>';
            $form .= '</td>';
            $form .= '</tr>';
        }
    }
    else {
        $form .= '<tr>';
        $form .= '<td class="submit-box" colspan="2">';
        $form .= $cgi::Deco->submit_button(
            'submit',
            $this->{'submitButton'},
            ( ($default::english) ? 'Submit' : '更新' ),
            { 'id' => $id . '-submit' }
        );
        $form .= '</td>';
        $form .= '</tr>';
    }
    $form .= '</tbody></table>';
    return $form;
}

sub cancel_deadline_field ($$;$$) {
    my ( $this, $name, $type, $data_ref ) = @_;
    return '';
}

sub digital_content_icon ($$;$) {
    my ( $this, $data, $no_box ) = @_;
    my $icon = '';
    $icon .= '<div class="digital-content">' if !$no_box;
    my $ext = ( $data->{'digitalcontent'} =~ /\.([0-9a-zA-Z_]+)$/ ) ? $1 : '';
    if ( !@env::icon_images && $env::icon_dir && -d $env::icon_dir ) {
        opendir( DIR, $env::icon_dir );
        @env::icon_images = readdir(DIR);
        closedir(DIR);
    }
    if (@env::icon_images) {
        my ($icon_image) = grep( $_ =~ /^$ext\./, @env::icon_images );
        if ( !$icon_image ) {
            if ( @Common::video_plug
                && grep( $_ eq $ext, @Common::video_plug ) )
            {
                $icon_image = 'mov.png'
                    if grep( $_ eq 'mov.png', @env::icon_images );
            }
            elsif (
                @Common::image_plug
                && grep( $_ eq $ext,
                    @Common::image_plug, 'png', 'jpg', 'jpeg', 'gif' )
                )
            {
                $icon_image = 'image.png'
                    if grep( $_ eq 'image.png', @env::icon_images );
            }
            elsif ( @Common::sound_plug
                && grep( $_ eq $ext, @Common::sound_plug ) )
            {
                $icon_image = 'sound.png'
                    if grep( $_ eq 'sound.png', @env::icon_images );
            }
            else {
                $icon_image = 'unknown.png';
            }
        }
        $icon .= '<img src="'
            . (
            ($cgi::output)
            ? $this->base_change(
                $env::icon_dir . '/' . $icon_image, $cgi::output,
                $cgi::output_option
                )
            : $env::icon_dir . '/' . $icon_image
            )
            . '" border="0" width="32" height="32" alt="'
            . $this->escape( $data->{'digitalcontent'} )
            . '" /><span class="sc-download-file-name">'
            . $this->escape( $data->{'digitalcontent'} )
            . '</span>';
    }
    else {
        $icon .= $this->escape( $data->{'digitalcontent'} );
    }
    if (   $this->{'is_temporary_data'}
        && $main::data{ $this->{'id'} }{'delete'}
        && !$this->{'is_posted_file'} )
    {
        $icon .= '<div class="note">このファイルを削除する</div>';
    }
    $icon .= '</div>' if !$no_box;
    return $icon;
}

sub stock_label ($$$) {
    my ( $this, $name, $stock ) = @_;
    return '' if !defined $name;
    $name =~ s/%s/$stock/gis;
    return $name;
}

sub get_option_name ($$) {
    my ( $this, $option ) = @_;
    my ($name);
    $name = $1
        if $option
        =~ /[\x09\x0A\x0C\x0D\x20]+alt[\x09\x0A\x0C\x0D\x20]*=[\x09\x0A\x0C\x0D\x20]*"([^"]+)"/s;
    $option =~ s/<[^>]+>//sg if $option;
    $name
        .= ( defined $option && $option ne '' )
        ? ( defined $name && $name ne '' )
            ? '(' . $option . ')'
            : $option
        : '';
    return $name;
}

######################################################################
#	(3) obj->is_valid_data;
sub is_valid_data ($;$) {
    my ( $this, $path ) = @_;
    delete $this->{'is_invalid_field'} if ref $this->{'is_invalid_field'};
    $path = $this->get_file_directory if !$path;
    my $is_valid    = 1;
    my $upload_name = 'data:' . $this->{'id'} . ':file';
    if (   $main::clipboard_id
        && !$main::data{ $this->{'id'} }{'file'}
        && !$main::option{ $this->{'id'} }{'cancel'} )
    {
        $cgi::input->inherit_posted_file_properties($upload_name);
    }
    my %properties
        = $cgi::input->get_posted_file_properties_from_param($upload_name);
    if ( $properties{'delete'} ) {
        delete $properties{'delete'};
        $cgi::input->set_posted_file_properties_from_param( $upload_name, 0,
            \%properties );
    }
    my $dc_directory = $this->get_digital_content_directory_path;
    if ( $this->{'digitalContentUploadEnabled'} ) {
        if (   $main::data{ $this->{'id'} }{'foldertype'}
            && $main::data{ $this->{'id'} }{'foldertype'} eq '2'
            && $main::data{ $this->{'id'} }{'digitalcontent'}
            && $main::data{ $this->{'id'} }{'digitalcontent'} !~ /^\./
            && -f $path . '/'
            . $this->{'id'} . '.'
            . $main::data{ $this->{'id'} }{'digitalcontent'}
            . '.dat' )
        {
            $main::data{ $this->{'id'} }{'foldertype'} = 2;
        }
        else {
            my $file_path = $this->fileglob( $path,
                      '^'
                    . $this->{'id'}
                    . '\\.[0-9a-zA-Z_]+\\.[0-9a-zA-Z_]+\\.dat$' );
            if (   $file_path
                && $file_path
                =~ /\/$this->{'id'}\.([0-9a-zA-Z_]+\.[0-9a-zA-Z_]+)\.dat$/ )
            {
                $main::data{ $this->{'id'} }{'digitalcontent'} = $1;
                $main::data{ $this->{'id'} }{'foldertype'}     = 2;
            }
            elsif ($main::data{ $this->{'id'} }{'foldertype'}
                && $main::data{ $this->{'id'} }{'foldertype'} eq '2'
                && $main::data{ $this->{'id'} }{'digitalcontent'} )
            {
                push(
                    @{ $cgi::action->{'dialog'} },
                    '以前'
                        . (
                        ( $this->{'name'} )
                        ? $this->{'name'}
                            . 'からアップロードされた'
                        : ''
                        )
                        . 'デジタルコンテンツファイルがみつかりません。'
                ) if ref $cgi::action;
                $this->{'is_invalid_field'}{'file'} = 1;
                delete $main::data{ $this->{'id'} }{'foldertype'};
                delete $main::data{ $this->{'id'} }{'digitalcontent'};
                delete $main::data{ $this->{'id'} }{'delete'};
                $is_valid = 0;
            }
        }
    }
    if (   $this->{'digitalContentMenuEnabled'}
        && $main::data{ $this->{'id'} }{'foldertype'}
        && $main::data{ $this->{'id'} }{'foldertype'} eq '1' )
    {
        if ((   defined $main::data{ $this->{'id'} }{'digitalcontent'}
                && $main::data{ $this->{'id'} }{'digitalcontent'} =~ /^\./
            )
            || !-f $dc_directory . '/'
            . $main::data{ $this->{'id'} }{'digitalcontent'}
            )
        {
            push(
                @{ $cgi::action->{'dialog'} },
                (   ( defined $this->{'name'} && $this->{'name'} ne '' )
                    ? $this->{'name'} . 'で選択された'
                    : ''
                    )
                    . 'デジタルコンテンツがみつかりません。'
            ) if ref $cgi::action;
            $this->{'is_invalid_field'}{'selectedDigitalContent'} = 1;
            delete $main::data{ $this->{'id'} }{'foldertype'};
            delete $main::data{ $this->{'id'} }{'digitalcontent'};
            $is_valid = 0;
        }
    }
    delete $main::data{ $this->{'id'} }{'foldertype'}
        if defined $main::data{ $this->{'id'} }{'foldertype'}
        && $main::data{ $this->{'id'} }{'foldertype'} ne '1'
        && $main::data{ $this->{'id'} }{'foldertype'} ne '2';
    if ( $this->{'digitalContentUploadEnabled'} && $properties{'filename'} ) {
        if ( ref $this->{'type_ext'} eq 'HASH' && %{ $this->{'type_ext'} } ) {

            #MIME-TYPEチェック
            if ( !defined $this->{'type_ext'}{ $properties{'type'} } ) {
                my $mimename = '';
                foreach my $ext ( sort keys %{ $this->{'mimename'} } ) {
                    $mimename
                        .= ( ($mimename) ? ',' : '' )
                        . $this->{'mimename'}{$ext}
                        . ( ( $this->{'mimename'}{$ext} ne $ext )
                        ? '(' . $ext . ')'
                        : '' );
                }
                push(
                    @{ $cgi::action->{'dialog'} },
                    (   ( $this->{'name'} )
                        ? $this->{'name'}
                            . 'からアップロードされた'
                        : ''
                        )
                        . 'デジタルコンテンツファイルのファイル形式を確認してください。下記形式のみ許可されています。'
                        . $mimename
                ) if ref $cgi::action;
                $this->{'is_invalid_field'}{'file'} = 1;
                $is_valid = 0;
            }
            else {
                $properties{'filename'}
                    =~ s/\.[0-9a-zA-Z_]+$/\.$this->{'type_ext'}{$properties{'type'}}/;
            }
        }

        #ファイル名
        if ($is_valid) {
            my $file_name = $this->z_to_h( $properties{'filename'}, 'utf8' );
            my $ext
                = ( $file_name =~ s/\.([0-9a-zA-Z_]+)$//s ) ? lc $1 : 'txt';
            $file_name =~ s/[\x09\x0A\x0C\x0D\x20\.\-\+]+/_/gs;
            $file_name = 'download' if $file_name =~ /[^0-9a-zA-Z_]/;
            $main::data{ $this->{'id'} }{'foldertype'} = 2;
            $main::data{ $this->{'id'} }{'digitalcontent'}
                = $file_name . '.' . $ext;
            delete $main::data{ $this->{'id'} }{'selectedDigitalContent'};
        }

    }
    elsif ( !$main::data{ $this->{'id'} }{'delete'}
        && $this->{'digitalContentUploadEnabled'}
        && $main::data{ $this->{'id'} }{'foldertype'}
        && $main::data{ $this->{'id'} }{'foldertype'} eq '2'
        && $main::data{ $this->{'id'} }{'digitalcontent'} )
    {
        if (   $this->{'digitalContentMenuEnabled'}
            && defined $main::data{ $this->{'id'} }{'selectedDigitalContent'}
            && $main::data{ $this->{'id'} }{'selectedDigitalContent'} ne '' )
        {
            push(
                @{ $cgi::action->{'dialog'} },
                (   ( defined $this->{'name'} && $this->{'name'} ne '' )
                    ? $this->{'name'} . 'で選択された'
                    : ''
                    )
                    . 'デジタルコンテンツを指定するには、現在アップロードされている「'
                    . $main::data{ $this->{'id'} }{'digitalcontent'}
                    . '」を削除します。'
            ) if ref $cgi::action;
        }

    }
    elsif ($this->{'digitalContentMenuEnabled'}
        && defined $main::data{ $this->{'id'} }{'selectedDigitalContent'}
        && $main::data{ $this->{'id'} }{'selectedDigitalContent'} ne '' )
    {
        $dc_directory = $this->get_digital_content_directory_path;
        if ( $main::data{ $this->{'id'} }{'selectedDigitalContent'} =~ /^\./
            || !-f $dc_directory . '/'
            . $main::data{ $this->{'id'} }{'selectedDigitalContent'} )
        {
            push(
                @{ $cgi::action->{'dialog'} },
                (   ( defined $this->{'name'} && $this->{'name'} ne '' )
                    ? $this->{'name'} . 'で選択された'
                    : ''
                    )
                    . 'デジタルコンテンツがみつかりません。'
            ) if ref $cgi::action;
            $this->{'is_invalid_field'}{'selectedDigitalContent'} = 1;
            delete $main::data{ $this->{'id'} }{'selectedDigitalContent'};
            $is_valid = 0;
        }
        else {
            $main::data{ $this->{'id'} }{'foldertype'} = 1;
            $main::data{ $this->{'id'} }{'digitalcontent'}
                = $main::data{ $this->{'id'} }{'selectedDigitalContent'};
        }
        $this->write_file(
            $dc_directory . '/.htaccess',
            'Satisfy all' . "\x0A"
                . 'order deny,allow' . "\x0A"
                . 'deny from all' . "\x0A",
            1
        );
    }
    if ( $default::static && $main::data{ $this->{'id'} }{'foldertype'} ) {
        my $dir
            = ( $main::data{ $this->{'id'} }{'foldertype'} eq '2' )
            ? $this->get_file_directory
            : $this->get_digital_content_directory_path;
        $main::data{ $this->{'id'} }{'folder'}
            = ($cgi::output)
            ? $this->base_change( $dir, $cgi::output, $cgi::output_option )
            : $dir;
    }
    else {
        delete $main::data{ $this->{'id'} }{'folder'};
    }
    if ($this->is_digital_content( $main::data{ $this->{'id'} } )
        && (  !$main::data{ $this->{'id'} }{'delete'}
            || $main::data{ $this->{'id'} }{'selectedDigitalContent'} )
        )
    {
        delete $main::data{ $this->{'id'} }{'availability'};
        delete $main::data{ $this->{'id'} }{'stock'};
    }
    elsif ( $this->{'digitalContentRequired'} && $this->{'required'} ) {
        push(
            @{ $cgi::action->{'dialog'} },
            (   ( defined $this->{'name'} && $this->{'name'} ne '' )
                ? $this->{'name'} . 'の'
                : ''
                )
                . 'デジタルコンテンツを確認してください。デジタルコンテンツは必須項目です。'
        ) if ref $cgi::action;
        $this->{'is_invalid_field'}{'file'} = 1;
        $is_valid = 0;
    }
    if (   defined $main::data{ $this->{'id'} }{'price'}
        && $main::data{ $this->{'id'} }{'price'} ne ''
        && (   $this->is_not_digit( $main::data{ $this->{'id'} }{'price'} )
            || $main::data{ $this->{'id'} }{'price'} < 0 )
        )
    {
        push(
            @{ $cgi::action->{'dialog'} },
            (   ( defined $this->{'name'} && $this->{'name'} ne '' )
                ? $this->{'name'} . 'の'
                : ''
                )
                . '価格が数ではありません。半角数字にしてください。'
        ) if ref $cgi::action;
        $this->{'is_invalid_field'}{'price'} = 1;
        $is_valid = 0;
    }
    elsif ($main::data{ $this->{'id'} }{'price'}
        && $main::data{ $this->{'id'} }{'price'} =~ /\./ )
    {
        push(
            @{ $cgi::action->{'dialog'} },
            (   ( defined $this->{'name'} && $this->{'name'} ne '' )
                ? $this->{'name'} . 'の'
                : ''
                )
                . '価格を確認してください。小数点以下を四捨五入しました。'
        ) if ref $cgi::action;
        $main::data{ $this->{'id'} }{'price'}
            = int( $main::data{ $this->{'id'} }{'price'} + 0.5 );
    }

#if (defined $main::data{$this->{'id'}}{'point'} && $main::data{$this->{'id'}}{'point'} ne '' && ($this->is_not_digit($main::data{$this->{'id'}}{'point'}) || $main::data{$this->{'id'}}{'point'} < 0 || $main::data{$this->{'id'}}{'point'} >= 100)) {
#	push(@{$cgi::action->{'dialog'}},((defined $this->{'name'} && $this->{'name'} ne '') ? $this->{'name'} . 'の' : '') . 'ポイントを確認してください。0 以上 100 未満の半角数字にしてください。') if ref $cgi::action;
#	$this->{'is_invalid_field'}{'point'} = 1;
#	$is_valid = 0;
#}
    if (   defined $main::data{ $this->{'id'} }{'weight'}
        && $main::data{ $this->{'id'} }{'weight'} ne ''
        && (   $this->is_nan( $main::data{ $this->{'id'} }{'weight'} )
            || $main::data{ $this->{'id'} }{'weight'} < 0 )
        )
    {
        push(
            @{ $cgi::action->{'dialog'} },
            (   ( defined $this->{'name'} && $this->{'name'} ne '' )
                ? $this->{'name'} . 'の'
                : ''
                )
                . '重量が正の数ではありません。半角数字にしてください。'
        ) if ref $cgi::action;
        $this->{'is_invalid_field'}{'weight'} = 1;
        $is_valid = 0;
    }
    if (   defined $main::data{ $this->{'id'} }{'thickness'}
        && $main::data{ $this->{'id'} }{'thickness'} ne ''
        && (   $this->is_nan( $main::data{ $this->{'id'} }{'thickness'} )
            || $main::data{ $this->{'id'} }{'thickness'} <= 0 )
        )
    {
        push(
            @{ $cgi::action->{'dialog'} },
            (   ( defined $this->{'name'} && $this->{'name'} ne '' )
                ? $this->{'name'} . 'の'
                : ''
                )
                . '厚さが正の数ではありません。半角数字にしてください。'
        ) if ref $cgi::action;
        $this->{'is_invalid_field'}{'thickness'} = 1;
        $is_valid = 0;
    }
    if ( $this->{'stockDisabled'} || $default::static ) {
        delete $main::data{ $this->{'id'} }{'stock'};
    }
    else {
        if (   defined $main::data{ $this->{'id'} }{'stock'}
            && $main::data{ $this->{'id'} }{'stock'} ne ''
            && $this->is_not_digit( $main::data{ $this->{'id'} }{'stock'} ) )
        {
            push(
                @{ $cgi::action->{'dialog'} },
                (   ( defined $this->{'name'} && $this->{'name'} ne '' )
                    ? $this->{'name'} . 'の'
                    : ''
                    )
                    . '在庫数が数ではありません。半角数字にしてください。'
            ) if ref $cgi::action;
            $this->{'is_invalid_field'}{'stock'} = 1;
            $is_valid = 0;
        }
        elsif ($main::data{ $this->{'id'} }{'stock'}
            && $main::data{ $this->{'id'} }{'stock'} =~ /\./ )
        {
            push(
                @{ $cgi::action->{'dialog'} },
                (   ( defined $this->{'name'} && $this->{'name'} ne '' )
                    ? $this->{'name'} . 'の'
                    : ''
                    )
                    . '在庫数を確認してください。小数点以下を切り捨てました。'
            ) if ref $cgi::action;
            $main::data{ $this->{'id'} }{'stock'}
                = int( $main::data{ $this->{'id'} }{'stock'} + 0.5 );
        }
    }
    if ($this->{'required'}
        && ( !defined $main::data{ $this->{'id'} }{'price'}
            || $main::data{ $this->{'id'} }{'price'} eq '' )
        )
    {
        push(
            @{ $cgi::action->{'dialog'} },
            (   ( defined $this->{'name'} && $this->{'name'} ne '' )
                ? $this->{'name'} . 'の'
                : ''
                )
                . '価格が入力されていません。'
        ) if ref $cgi::action;
        $this->{'is_invalid_field'}{'price'} = 1;
        $is_valid = 0;
    }
    delete $main::data{ $this->{'id'} }{'canceldeadline'}
        if !$main::data{ $this->{'id'} }{'canceldeadline'}
        || $main::data{ $this->{'id'} }{'canceldeadline'} ne 'shipping';
    delete $main::data{ $this->{'id'} }{'noshipping'}
        if !$main::data{ $this->{'id'} }{'noshipping'};
    $is_valid = 0 if !$this->_is_valid_data();
    unless (
        $this->{'stockDisabled'}
        || (   $this->{'digitalContentMenuEnabled'}
            && $main::data{ $this->{'id'} }{'foldertype'}
            && $main::data{ $this->{'id'} }{'foldertype'} eq '1'
            && $main::data{ $this->{'id'} }{'digitalcontent'} )
        || (   $this->{'digitalContentUploadEnabled'}
            && !$main::data{ $this->{'id'} }{'delete'}
            && $main::data{ $this->{'id'} }{'foldertype'}
            && $main::data{ $this->{'id'} }{'foldertype'} eq '2'
            && $main::data{ $this->{'id'} }{'digitalcontent'} )
        )
    {
        delete $main::data{ $this->{'id'} }{'withdrawn'};
    }
    if ( defined $main::data{ $this->{'id'} }{'option'}
        && $main::data{ $this->{'id'} }{'option'} ne '' )
    {
        my $id   = 1;
        my $temp = '';
        while ( $main::data{ $this->{'id'} }{'option'} =~ /^(.*)$/mg ) {
            my ( $name, $formula );
            $name = $1;
            chomp $name;
            $formula = $1 if $name =~ s/:([^:]*?)$//;
            if ( $name !~ /[^\x09\x0A\x0C\x0D\x20]/ ) {
                push(
                    @{ $cgi::action->{'dialog'} },
                    (   ( defined $this->{'name'} && $this->{'name'} ne '' )
                        ? $this->{'name'} . 'の'
                        : ''
                        )
                        . 'オプション '
                        . $id
                        . '行目が空白です。'
                ) if ref $cgi::action;
                $this->{'is_invalid_field'}{'option'} = 1;
                $is_valid = 0;
            }
            if ( defined $formula && $formula ne '' ) {
                if (   $main::data{ $this->{'id'} }{'price'}
                    && $formula =~ s/^=//
                    && !$this->is_nan($formula) )
                {
                    $formula -= $main::data{ $this->{'id'} }{'price'};
                }
                if ( $this->is_nan($formula) ) {
                    push(
                        @{ $cgi::action->{'dialog'} },
                        (   (   defined $this->{'name'}
                                    && $this->{'name'} ne ''
                            ) ? $this->{'name'} . 'の' : ''
                            )
                            . 'オプション '
                            . $id
                            . '行目の上乗せ価格が計算不能です。'
                    ) if ref $cgi::action;
                    $this->{'is_invalid_field'}{'option'} = 1;
                    $is_valid = 0;
                }
            }
            $temp .= $name . ( ($formula) ? ':' . $formula : '' ) . "\x0A";
            $id++;
        }
        $main::data{ $this->{'id'} }{'option'} = $temp;
        if ( $this->{'optionRequired'} ) {
            $main::data{ $this->{'id'} }{'optionRequired'} = 1;
        }
        else {
            delete $main::data{ $this->{'id'} }{'optionRequired'};
        }
    }
    if ($is_valid) {
        $main::data{ $this->{'id'} }{'digitalContentRequired'} = 1
            if $this->{'digitalContentRequired'};
        if ( !$this->sc_stock_is_ok( $main::data{ $this->{'id'} } ) ) {
            $main::data{ $this->{'id'} }{'unavailable'} = 1;
        }
        else {
            delete $main::data{ $this->{'id'} }{'unavailable'};
        }
        $main::data{ $this->{'id'} }{'str'}
            = ( ( defined $main::data{ $this->{'id'} }{'price'} )
            ? $main::data{ $this->{'id'} }{'price'}
            : '' )
            . "\x0A";
        my ( $k, $v );
        while ( ( $k, $v ) = each %{ $main::data{ $this->{'id'} } } ) {
            next
                if !defined $k
                || !defined $v
                || $k eq 'str'
                || $k eq 'price'
                || $k eq 'file'
                || $k eq 'selectedDigitalContent'
                || $k eq 'delete'
                || ( !$properties{'filename'}
                && $this->{'digitalContentUploadEnabled'}
                && $main::data{ $this->{'id'} }{'delete'}
                && !$main::data{ $this->{'id'} }{'selectedDigitalContent'}
                && ( $k eq 'digitalcontent' || $k eq 'foldertype' ) );
            $v =~ s/\x0A/\&#10;/sg;
            $main::data{ $this->{'id'} }{'str'} .= $k . ':' . $v . "\x0A";
        }
        $cookie::data{ 'data:' . $this->{'id'} . ':str' }
            = $main::data{ $this->{'id'} }{'str'}
            if $this->{'cookie'} && $main::set_cookie;

        #ファイル保存/削除予約
        if ( $properties{'filename'} ) {
            $cgi::input->save_file(
                $upload_name,
                '!'
                    . $this->{'id'} . '.'
                    . $main::data{ $this->{'id'} }{'digitalcontent'} . '.dat',
                '',
                '',
                '',
                $this->{'id'} . '(\\..*|)'
            );
            $this->{'is_posted_file'} = 1;
        }
        elsif ( $main::data{ $this->{'id'} }{'delete'} ) {
            $properties{'delete'} = $this->{'id'} . '(\\..*|)';
            $cgi::input->set_posted_file_properties_from_param( $upload_name,
                0, \%properties );
            $cgi::input->parameters_trash(
                \$main::data{ $this->{'id'} }{'foldertype'},
                \$main::data{ $this->{'id'} }{'digitalcontent'}
            ) if $this->{'digitalContentUploadEnabled'};
        }
    }
    delete $main::data{ $this->{'id'} }{'file'};
    return $is_valid;
}

sub _is_valid_data ($) {
    my $this = shift;
    return 1;
}

######################################################################
#	(4) obj->usual_format(str,path,category,no);
#	str=表示するデータ/path=ファイル保存ディレクトリ
sub usual_format {
    my ( $this, $str, $path, $c, $n ) = @_;
    my ( %data, $out, $id );
    $id = $this->mk_user_generated_field_id( $c, $n );
    %data
        = ( ref $str eq 'HASH' )
        ? ( defined $$str{'str'} )
            ? $this->elements( $$str{'str'} )
            : %$str
        : $this->elements($str);
    if ( $this->{'optionRequired'} ) {
        $data{'optionRequired'} = 1;
    }
    else {
        delete $data{'optionRequired'};
    }
    my $is_dc = $this->is_digital_content( \%data );
    return $this->field_tag( $this->data_tag_from_ref( \%data ), 1 )
        if ( $this->{'digitalContentRequired'}
        || $data{'digitalContentRequired'} )
        && !$is_dc;
    if (   !$default::static
        && !$cgi::output
        && $this->{'formauthority'}
        && $this->is_secure( $this->{'formauthority'} ) )
    {
        $out .= $this->form_start(
            'key'      => $this->{'formauthority'},
            'id'       => ( ($id) ? $id . '-form' : '' ),
            'name'     => ( ($id) ? $id . '-form' : '' ),
            'method'   => 'post',
            'onsubmit' => 'return cmonos.form.item(this).submit(\''
                . $id . '\');',
            'required' => $this->get_query_keys
        );
        $out .= $this->add_query_for_form( $c, $n );
        $out .= $this->add_query( 'post', { 'id' => $this->{'id'} } );
        $out .= $this->input_form( 'data:' . $this->{'id'} . ':',
            '', \%data, 0, 0, $id, $path );
        $out .= '</form>';
    }
    else {
        return $this->field_tag( $this->data_tag_from_ref( \%data ), 1 )
            if !defined $data{'price'} || $data{'price'} eq '';
        my $is_available          = 0;
        my $is_not_available_time = 0;
        if ( $this->sc_stock_is_ok( \%data ) ) {
            delete $data{'unavailable'};
            $is_available = 1;
        }
        else {
            $data{'unavailable'} = 1;
            $is_available = 0;
        }
        if ( $default::static || $this->sc_period_is_ok( \%data, $c, $n ) ) {
            $is_available = 1 if $is_available;
        }
        else {
            $is_available          = 0;
            $is_not_available_time = 1;
        }
        $out
            .= '<div itemprop="offerDetails" itemscope itemtype="http://data-vocabulary.org/Offer">';
        if ($is_available) {
            $out .= '<form action="'
                . (
                ( $cgi::output || $cgi::output_option )
                ? $this->base_change( $env::checkout, $cgi::output,
                    $cgi::output_option )
                : $env::checkout
                ) . '" method="post"';
            $out .= ' name="' . $id . '-form"';
            $out
                .= ' onsubmit="return cmonos.tool.shoppingcart.window.open(this)"';
            $out .= ' class="showcase-form">';
            $out .= '<input type="hidden" name="m" value="CartViewer" />';
            $out
                .= '<input type="hidden" name="cart:caller" value="'
                . ( ( $ENV{'SCRIPT_NAME'} =~ m!([^/]+)/[^/]+$! ) ? $1 : '' )
                . '" />';
            $out .= '<input type="hidden" name="cart:c" value="' . $c . '" />'
                if defined $c;
            $out .= '<input type="hidden" name="cart:n" value="' . $n . '" />'
                if defined $n;
            $out .= '<input type="hidden" name="cart:cartfield" value="'
                . $this->{'id'} . '" />';

            if ($default::static) {
                $out
                    .= '<input type="hidden" name="cart:namefield" value="'
                    . $this->{'namefield'} . '" />'
                    if defined $this->{'namefield'} && $this->{'namefield'};
                $out
                    .= '<input type="hidden" name="cart:keyfield" value="'
                    . $this->{'keyfield'} . '" />'
                    if defined $this->{'keyfield'} && $this->{'keyfield'};
                $out
                    .= '<input type="hidden" name="cart:periodfield" value="'
                    . $this->{'periodfield'} . '" />'
                    if defined $this->{'periodfield'}
                    && $this->{'periodfield'};
                $out
                    .= '<input type="hidden" name="cart:p" value="'
                    . $main::p . '" />'
                    if defined $main::p;
                $out
                    .= '<input type="hidden" name="cart:chapterid" value="'
                    . $main::chap . '" />'
                    if defined $main::chap && $main::chap ne '';
                $out
                    .= '<input type="hidden" name="cart:sectionid" value="'
                    . $main::sect . '" />'
                    if defined $main::sect && $main::sect ne '';

#			$out .= '<input type="hidden" name="cart:itemname" value="' . $main::data{$this->{'namefield'}}{'str'} . '" />' if defined $this->{'namefield'} && $this->{'namefield'};
#			$out .= '<input type="hidden" name="cart:itemid" value="' . $main::data{$this->{'keyfield'}}{'str'} . '" />' if defined $this->{'keyfield'} && $this->{'keyfield'};
#			$out .= '<input type="hidden" name="cart:price" value="' . $data{'price'} . '" />';
#			$out .= '<input type="hidden" name="cart:availability" value="' . $data{'availability'} . '" />';
            }
            else {
#			$out .= '<input type="hidden" name="cart:lib" value="' . $default::lib . '" />';
                $out
                    .= '<input type="hidden" name="cart:m" value="'
                    . $this->escape( $this->current_module($main::m) )
                    . '" />';
            }
            $out
                .= '<input type="hidden" name="cart:digitalcontent" value="'
                . $this->escape( $data{'foldertype'} ) . '" />'
                if $is_dc;
        }
        if ( $this->{'template'} ) {
            my $template = $this->{'template'};
            my $icon
                = ($is_dc) ? $this->digital_content_icon( \%data, 1 ) : '';
            my $price
                = ( !$this->{'pricehidden'} )
                ? $this->sc_price_tag( $data{'price'},
                $this->{'monetaryunit'}, 1 )
                : '';

#		my $point = (!$this->{'pointhidden'}) ? $this->sc_point_tag($data{'point'},$data{'price'},$this->{'pointunit'},1) : '';
            my $stock
                = ( !$this->{'stockhidden'} )
                ? $this->sc_stock_tag( $data{'availability'}, $data{'stock'},
                $is_dc, $data{'withdrawn'}, 1, $is_not_available_time )
                : '';
            my $condition
                = ( !$this->{'defaultconditionfixed'} && !$is_dc )
                ? $this->sc_condition_tag( $data{'condition'}, 1 )
                : '';
            my $weight
                = ( !$this->{'weightenabled'} && !$is_dc )
                ? $this->sc_weight_tag( $data{'weight'}, 1 )
                : '';
            my $papersize
                = ( !$this->{'sizeAndThicknessEnabled'} && !$is_dc )
                ? $this->sc_papersize_tag( $data{'papersize'}, 1 )
                : '';
            my $thickness
                = ( !$this->{'sizeAndThicknessEnabled'} && !$is_dc )
                ? $this->sc_thickness_tag( $data{'thickness'}, 1 )
                : '';
            $template
                =~ s/<\!--icon(?![0-9a-zA-Z_])([^>]*)-->(.*?)<\!--\/icon(?![0-9a-zA-Z_])[^>]*-->/$this->item_tag_replace('icon',$1,$2,$icon)/gies;
            $template
                =~ s/<\!--price(?![0-9a-zA-Z_])([^>]*)-->(.*?)<\!--\/price(?![0-9a-zA-Z_])[^>]*-->/$this->item_tag_replace('price',$1,$2,$price)/gies;

#		$template =~ s/<\!--point(?![0-9a-zA-Z_])([^>]*)-->(.*?)<\!--\/point(?![0-9a-zA-Z_])[^>]*-->/$this->item_tag_replace('point',$1,$2,$point)/gies;
            $template
                =~ s/<\!--stock(?![0-9a-zA-Z_])([^>]*)-->(.*?)<\!--\/stock(?![0-9a-zA-Z_])[^>]*-->/$this->item_tag_replace('stock',$1,$2,$stock)/gies;
            $template
                =~ s/<\!--condition(?![0-9a-zA-Z_])([^>]*)-->(.*?)<\!--\/condition(?![0-9a-zA-Z_])[^>]*-->/$this->item_tag_replace('condition',$1,$2,$condition)/gies;
            if ($is_available) {
                my $quantity = $this->sc_quantity_tag( \%data, $is_dc, 1 );
                my $option = $this->sc_option_menu( \%data, 1 );
                my $button = $this->sc_submit_button(1);
                my $discountable
                    = ( $this->{'discountenabled'} )
                    ? $this->sc_discountable_tag(1)
                    : '';
                my $limited
                    = ( $this->{'limitenabled'} )
                    ? $this->sc_limited_tag(1)
                    : '';
                $template
                    =~ s/<\!--quantity(?![0-9a-zA-Z_])([^>]*)-->(.*?)<\!--\/quantity(?![0-9a-zA-Z_])[^>]*-->/(($is_dc) ? $quantity : $this->item_tag_replace('quantity',$1,$2,$quantity))/gies;
                $template
                    =~ s/<\!--option(?![0-9a-zA-Z_])([^>]*)-->(.*?)<\!--\/option(?![0-9a-zA-Z_])[^>]*-->/$this->item_tag_replace('option',$1,$2,$option)/gies;
                $template
                    =~ s/<\!--button(?![0-9a-zA-Z_])([^>]*)-->(.*?)<\!--\/button(?![0-9a-zA-Z_])[^>]*-->/$this->item_tag_replace('button',$1,$2,$button)/gies;
                $template
                    =~ s/<\!--discountable(?![0-9a-zA-Z_])([^>]*)-->(.*?)<\!--\/discountable(?![0-9a-zA-Z_])[^>]*-->/$this->item_tag_replace('discountable',$1,$2,$discountable)/gies;
                $template
                    =~ s/<\!--limited(?![0-9a-zA-Z_])([^>]*)-->(.*?)<\!--\/limited(?![0-9a-zA-Z_])[^>]*-->/$this->item_tag_replace('limited',$1,$2,$limited)/gies;
                $out .= $template . '</form>';
            }
            else {
                $template
                    =~ s/<\!--quantity(?![0-9a-zA-Z_])[^>]*-->.*?<\!--\/quantity(?![0-9a-zA-Z_])[^>]*-->//gis;
                $template
                    =~ s/<\!--option(?![0-9a-zA-Z_])[^>]*-->.*?<\!--\/option(?![0-9a-zA-Z_])[^>]*-->//gis;
                $template
                    =~ s/<\!--button(?![0-9a-zA-Z_])[^>]*-->.*?<\!--\/button(?![0-9a-zA-Z_])[^>]*-->//gis;
                $template
                    =~ s/<\!--discountable(?![0-9a-zA-Z_])[^>]*-->.*?<\!--\/discountable(?![0-9a-zA-Z_])[^>]*-->//gis;
                $template
                    =~ s/<\!--limited(?![0-9a-zA-Z_])[^>]*-->.*?<\!--\/limited(?![0-9a-zA-Z_])[^>]*-->//gis;
                $out .= $template;
            }
        }
        else {
            $out .= $this->digital_content_icon( \%data ) if $is_dc;
            $out
                .= $this->sc_price_tag( $data{'price'},
                $this->{'monetaryunit'} )
                if !$this->{'pricehidden'};

#		$out .= $this->sc_point_tag($data{'point'},$data{'price'},$this->{'pointunit'}) if !$this->{'pointhidden'};
            $out
                .= $this->sc_stock_tag( $data{'availability'},
                $data{'stock'}, $is_dc, $data{'withdrawn'}, 0,
                $is_not_available_time )
                if !$this->{'stockhidden'};
            $out .= $this->sc_condition_tag( $data{'condition'} )
                if !$this->{'defaultconditionfixed'} && !$is_dc;
            $out .= $this->sc_discountable_tag if $this->{'discountenabled'};
            $out .= $this->sc_limited_tag      if $this->{'limitenabled'};
            $out .= $this->sc_weight_tag( $data{'weight'} )
                if $this->{'weightenabled'};
            if ( $this->{'sizeAndThicknessEnabled'} ) {
                $out .= $this->sc_papersize_tag( $data{'papersize'} );
                $out .= $this->sc_thickness_tag( $data{'thickness'} );
            }
            if ($is_available) {
                $out .= $this->sc_quantity_tag( \%data, $is_dc );
                $out .= $this->sc_option_menu( \%data );
                $out .= $this->sc_submit_button;
                $out .= '</form>';
            }
        }
        $out .= '</div>';
    }
    return $this->field_tag(
        $this->data_tag_from_ref( \%data )
            . $this->style(
            $out,                 $this->{'style'}, $this->{'fontsize'},
            $this->{'fontcolor'}, $this->{'fontface'}
            )
    );
}

sub current_module {
    my ( $this, $m ) = @_;
    return $m;
}

sub has_content {
    my ( $this, $str ) = @_;
    my %data
        = ( ref $str eq 'HASH' )
        ? ( defined $$str{'str'} )
            ? $this->elements( $$str{'str'} )
            : %$str
        : $this->elements($str);
    return (
        (          !$default::static
                && !$cgi::output
                && !$this->{'digitalContentMenuEnabled'}
                && !$this->{'digitalContentUploadEnabled'}
                && $this->{'formauthority'}
                && $this->is_secure( $this->{'formauthority'} )
        )
            || ( defined $data{'price'} && $data{'price'} ne '' )
    ) ? 1 : 0;
}

sub sc_stock_is_ok ($$;$) {
    no warnings qw(numeric);
    my ( $this, $data, $ignore_dc ) = @_;
    if ((      $this->{'digitalContentMenuEnabled'}
            && $data->{'foldertype'}
            && $data->{'foldertype'} eq '1'
            && $data->{'digitalcontent'}
        )
        || (   $this->{'digitalContentUploadEnabled'}
            && $data->{'foldertype'}
            && $data->{'foldertype'} eq '2'
            && $data->{'digitalcontent'} )
        )
    {
        return ( !$ignore_dc && ref $data && $data->{'withdrawn'} ) ? 0 : 1;
    }
    elsif ( $this->{'stockDisabled'} ) {
        return ( !$ignore_dc && ref $data && $data->{'withdrawn'} ) ? 0 : 1;
    }
    elsif ( $default::static || $this->{'stockview'} eq 'menu' ) {
        return (   ref $data
                && defined $data->{'availability'}
                && ref $this->{'sellout'} eq 'ARRAY'
                && $this->{'sellout'}[ $data->{'availability'} ] ) ? 0 : 1;
    }
    elsif ( $this->{'stockview'} eq 'sync' ) {
        return (   ref $data
                && defined $data->{'stock'}
                && $data->{'stock'} ne ''
                && $data->{'stock'} <= $this->{'outOfStockBounds'} ) ? 0 : 1;
    }
    return 1;
}

sub sc_period_is_ok ($$$$) {
    my ( $this, $data, $c, $n ) = @_;
    my $period = $this->validity_period( $data, $c, $n );
    return 0 if $period && !$this->is_available_time($period);
    return $this->_sc_period_is_ok( $data, $c, $n );
}

sub validity_period ($$$$) {
    my ( $this, $data, $c, $n ) = @_;
    if (   $this->{'periodfield'}
        && ref $this->{'field_obj'}->{ $this->{'periodfield'} }
        && $this->{'field_obj'}->{ $this->{'periodfield'} }->{'class'}
        && $this->{'field_obj'}->{ $this->{'periodfield'} }->{'class'} eq
        'time_span'
        && %main::data
        && ref $main::data{ $this->{'periodfield'} }
        && $main::data{ $this->{'periodfield'} }{'str'} )
    {
        return $main::data{ $this->{'periodfield'} }{'str'};
    }
    return '';
}

sub is_available_time ($$$$) {
    my ( $this, $period ) = @_;
    use Time::Local;
    if (   $period
        && $period
        =~ m!^([0-9]{0,4})([0-9]{0,2})([0-9]{0,2})([0-9]{0,2})([0-9]{0,2})([0-9]{0,2}) \- ([0-9]{0,4})([0-9]{0,2})([0-9]{0,2})([0-9]{0,2})([0-9]{0,2})([0-9]{0,2})!
        )
    {
        my $start = ($1)
            ? timelocal(
            ( $6 || 0 ),
            ( $5 || 0 ),
            ( $4 || 0 ),
            ( $3 || 1 ),
            ( ($2) ? $2 - 1 : 0 ), $1
            )
            : 0;
        my $end = ($7)
            ? timelocal(
            ( $12 || 0 ),
            ( $11 || 0 ),
            ( $10 || 0 ),
            ( $9  || 1 ),
            ( ($8) ? $8 - 1 : 0 ), $7
            )
            : 0;
        my $now = time;
        if ( $start > $now || ( $end && $end < $now ) ) {
            return 0;
        }
    }
    return 1;
}

sub _sc_period_is_ok ($$$$) {
    my ( $this, $data, $c, $n ) = @_;
    return 1;
}

sub is_digital_content ($$) {
    my ( $this, $data ) = @_;
    if ((      $this->{'digitalContentMenuEnabled'}
            && $data->{'foldertype'}
            && $data->{'foldertype'} eq '1'
            && $data->{'digitalcontent'}
        )
        || (   $this->{'digitalContentUploadEnabled'}
            && $data->{'foldertype'}
            && $data->{'foldertype'} eq '2'
            && $data->{'digitalcontent'} )
        )
    {
        return 1;
    }
    else {
        return 0;
    }
}

sub sc_price_tag ($$$;$) {
    my ( $this, $price, $unit, $no_box ) = @_;
    my $out = '';
    $out
        .= '<div class="showcase-price"'
        . $this->raw_price_info( $price, $unit, 1 ) . '>'
        if !$no_box;
    $out .= '<span class="unit">' . $unit . '</span>'
        if $unit && $unit !~ /[^\x20-\x7F]/;
    $price = $this->add_tax($price);
    $out
        .= '<meta itemprop="currency" content="JPY" /><span itemprop="price" content="' . $price . '">'
        . $this->digit( $price )
        . '</span>';
    $out .= '<span class="unit">' . $unit . '</span>'
        if $unit && $unit =~ /[^\x20-\x7F]/;
    $out .= '</div>' if !$no_box;
    return $out;
}

sub sc_weight_tag ($$;$) {
    my ( $this, $weight, $no_box ) = @_;
    return ( $this->{'weightinvisible'} || !defined $weight || $weight eq '' )
        ? ''
        : ( ( !$no_box ) ? '<div class="showcase-weight">' : '' )
        . $this->digit($weight)
        . '<span class="unit">g</span>'
        . ( ( !$no_box ) ? '</div>' : '' );
}

sub sc_papersize_tag ($$;$) {
    my ( $this, $papersize, $no_box ) = @_;
    return
        (      $this->{'sizeAndThicknessInvisible'}
            || !defined $papersize
            || $papersize eq '' ) ? ''
        : ( ( !$no_box ) ? '<div class="showcase-papersize">' : '' )
        . ( ( !$papersize ) ? ''
        : ( $papersize eq 'ACCESSORY' )           ? '小物'
        : ( $papersize =~ /^(?:A[4-6]|B[5-6])$/ ) ? $papersize
        :                                           'A4よりも大きい' )
        . ( ( !$no_box ) ? '</div>' : '' );
}

sub sc_thickness_tag ($$;$) {
    my ( $this, $thickness, $no_box ) = @_;
    return (   $this->{'sizeAndThicknessInvisible'}
            || !defined $thickness
            || $thickness eq '' )
        ? ''
        : ( ( !$no_box ) ? '<div class="showcase-thickness">' : '' )
        . $this->digit($thickness)
        . '<span class="unit">mm</span>'
        . ( ( !$no_box ) ? '</div>' : '' );
}

#sub sc_point_tag ($$$$;$) {
#my($this,$point_rate,$price,$unit,$no_box) = @_;
#my($out);
#return '' if !$point_rate || $point_rate =~ /[^0-9\.]/;
#$out .= '<div class="showcase-point">' if !$no_box;
#$out .= $this->digit($this->get_point($point_rate,$price)) . (($unit) ? '<span class="unit">' . $unit . '</span>' : '');
#$out .= ' <span class="note">(' . $point_rate . '%)</span>';
#$out .= '</div>' if !$no_box;
#return $out;
#}
#
#sub get_point ($$$) {
#my($this,$point_rate,$price) = @_;
#$price = 0 if !$price || $price =~ /[^0-9\.]/;
#$point_rate = 0 if !$point_rate || $point_rate =~ /[^0-9\.]/;
#if ($env::tax_frac eq 'floor') {
#	return int(($price * ($point_rate / 100)) + 0.999);
#} elsif ($env::tax_frac eq 'round') {
#	return int(($price * ($point_rate / 100)) + 0.5);
#} else {
#	return int($price * ($point_rate / 100));
#}
#}

sub sc_stock_tag ($$$$;$$$) {
    my ( $this, $availability, $stock, $is_dc, $withdrawn, $no_box,
        $is_not_available_time )
        = @_;
    my ( $out, $outofstock );
    if ($is_not_available_time) {
        $out .= $this->escape( $this->{'discontinuedLabel'}
                || '販売終了' );
        $outofstock = 1;
    }
    elsif ( $is_dc || $this->{'stockDisabled'} ) {
        return '' if !$withdrawn;
        $out .= $this->escape( $this->{'withdrawnLabel'} || '販売中止' );
        $outofstock = 1;
    }
    elsif ( $default::static || $this->{'stockview'} eq 'menu' ) {
        return ''
            if !defined $availability
            || $availability eq ''
            || ref $this->{'stockAvailability'} ne 'ARRAY'
            || !defined $this->{'stockAvailability'}[$availability]
            || $this->{'stockAvailability'}[$availability] eq '';
        $out .= $this->{'stockAvailability'}[$availability];
        $outofstock = 1 if $this->{'sellout'}[$availability];
    }
    elsif ( $this->{'stockview'} eq 'sync' ) {
        my $name = '';
        if ( !defined $stock || $stock eq '' ) {
            return '';
        }
        elsif ( $stock <= $this->{'outOfStockBounds'} ) {
            $name = $this->{'outOfStockName'} || '受注停止';
            $outofstock = 1;
        }
        elsif ($this->{'limitedAvailabilityBounds'}
            && $stock <= $this->{'limitedAvailabilityBounds'} )
        {
            $name = $this->{'limitedAvailabilityName'} || '在庫僅少';
        }
        elsif ($this->{'inStockBounds'}
            && $stock <= $this->{'inStockBounds'} )
        {
            $name = $this->{'inStockName'} || '在庫通常';
        }
        else {
            $name = $this->{'abundantName'} || '在庫潤沢';
        }
        $out .= $this->stock_label( $name, $stock . $this->{'stockunit'} );
    }
    else {
        return '';
    }
    $out
        = '<'
        . ( ($no_box) ? 'span' : 'div class="showcase-stock"' )
        . ' itemprop="availability" content="'
        . ( ($outofstock) ? 'out_of_stock' : 'in_stock' ) . '">'
        . $out
        . ( ($no_box) ? '</span>' : '</div>' );
    return $out;
}

sub sc_quantity_tag ($$$;$) {
    my ( $this, $data, $is_dc, $no_box ) = @_;
    my $out = '';
    if ( !$is_dc ) {
        $out
            .= '<div class="showcase-quantity"><label>'
            . ( ( $this->{'stockname'} )
            ? $this->escape_except_html_entity( $this->{'stockname'} )
            : '数量' )
            . ':'
            if !$no_box;
        my $max;
        my $max_quantity = 12;
        if ( $this->{'maxQuantity'} && $this->{'maxQuantity'} >= 1 ) {
            $max = $max_quantity = $this->{'maxQuantity'};
            if (   !$this->{'stockDisabled'}
                && !$default::static
                && $this->{'stockview'}
                && $this->{'stockview'} eq 'sync'
                && ref $data
                && defined $data->{'stock'}
                && $data->{'stock'} ne ''
                && $max > $data->{'stock'} - $this->{'outOfStockBounds'} )
            {
                $max = $data->{'stock'} - $this->{'outOfStockBounds'};
                $max = 1 if $max < 1;
            }
        }
        elsif (ref $data
            && defined $data->{'stock'}
            && $data->{'stock'} ne '' )
        {
            $max = $data->{'stock'};
            $max -= $this->{'outOfStockBounds'}
                if !$this->{'stockDisabled'}
                && !$default::static
                && $this->{'stockview'}
                && $this->{'stockview'} eq 'sync';
            $max = 1 if $max < 1;
        }
        $max_quantity = $max if $max && $max_quantity > $max;
        if ( $max && $max == 1 ) {
            return '<input type="hidden" name="cart:quantity" value="1" />';
        }
        elsif ( $this->{'quantityMenu'} ) {
            $out .= '<select name="cart:quantity">';
            for ( my $i = 1; $i <= $max_quantity; $i++ ) {
                $out .= '<option value="' . $i . '">' . $i . '</option>';
            }
            $out .= '</select>';
        }
        else {
   #$out .= '<input type="number" name="cart:quantity" size="3" value="1" />';
            $out
                .= '<input type="number" name="cart:quantity" size="3" min="1"'
                . ( ($max) ? ' max="' . $max . '"' : '' )
                . ' onfocus="cmonos.form.field(this).proposalNumberMenu('
                . $max_quantity
                . ')" onblur="cmonos.form.field(this).clearProposalTextMenu()"'
                . ' value="1" />';
        }
        $out .= '<span class="unit">' . $this->{'stockunit'} . '</span>'
            if $this->{'stockunit'};
        $out .= '</label></div>' if !$no_box;
    }
    else {
        $out .= '<input type="hidden" name="cart:quantity" value="1" />';
    }
    return $out;
}

sub sc_option_menu ($$;$) {
    my ( $this, $data, $no_box ) = @_;
    if ( ref $data && defined $data->{'option'} && $data->{'option'} ne '' ) {
        my $id   = 0;
        my $menu = '';
        my $selected;
        my @options = grep( $_ ne '' && $_ =~ /[^\x09\x0A\x0C\x0D\x20]/,
            split( /\x0A/, $data->{'option'} ) );
        foreach my $name (@options) {
            my ( $mark, $optionprice )
                = ( $name =~ s/:([\+\-]?)([0-9]+)$// )
                ? ( $1, $2 )
                : ( '', '' );
            if ( !$data->{'multiple'} && $this->{'optionTotalPrice'} ) {
                $optionprice = ( $data->{'price'} || 0 )
                    + ( $mark . ( $optionprice || 0 ) );
                $mark = '=';
            }
            $id++;
            if ( $this->{'optionsByCheckbox'} ) {
                $menu
                    .= '<li><label><input type="'
                    . ( ( $data->{'multiple'} || @options == 1 )
                    ? 'checkbox'
                    : 'radio' )
                    . '" name="cart:option" value="'
                    . $id . '"'
                    . (
                    (         !$data->{'multiple'}
                            && $this->{'optionRequired'}
                            && !$selected++
                    ) ? ' checked="checked"' : ''
                    )
                    . ' /> '
                    . $this->escape($name)
                    . (
                    ($optionprice)
                    ? ' ('
                        . (
                          ( $mark && $mark eq '=' ) ? ''
                        : ($mark) ? $mark
                        :           '+'
                        )
                        . $this->digit( $this->add_tax($optionprice) )
                        . '円)'
                    : ''
                    ) . '</label></li>';
            }
            else {
                $menu
                    .= '<option value="'
                    . $id . '">'
                    . $this->escape($name)
                    . (
                    ($optionprice)
                    ? ' ('
                        . (
                          ( $mark && $mark eq '=' ) ? ''
                        : ($mark) ? $mark
                        :           '+'
                        )
                        . $this->digit( $this->add_tax($optionprice) )
                        . '円)'
                    : ''
                    ) . '</option>';
            }
        }
        if ($menu) {
            if ( $this->{'optionsByCheckbox'} ) {
                $menu = '<ol class="checkbox">'
                    . (
                    (         !$data->{'multiple'}
                            && @options > 1
                            && !$this->{'optionRequired'}
                    )
                    ? '<li><label><input type="radio" name="cart:option" value="" checked="checked" /></label></li>'
                    : ''
                    ) . $menu . '</ol>';
            }
            else {
                $menu
                    = '<select name="cart:option"'
                    . ( ( $data->{'multiple'} )
                    ? ' size="'
                        . ( ( $id > 4 ) ? 5 : ( $id + 1 ) )
                        . '" multiple="multiple"'
                    : '' )
                    . '>'
                    . ( ( !$this->{'optionRequired'} )
                    ? '<option value=""></option>'
                    : '' )
                    . $menu
                    . '</select>';
            }
            $menu = '<div class="showcase-option">' . $menu . '</div>'
                if !$no_box;
            return $menu;
        }
        else {
            return '';
        }
    }
    else {
        return '';
    }
}

sub sc_submit_button ($;$) {
    my ( $this, $no_box ) = @_;
    my $out = '';
    $out .= '<div class="showcase-submit">' if !$no_box;
    $out .= $cgi::Deco->submit_button(
        'cart',
        $this->{'button'},
        (   ( $this->{'buttonName'} )
            ? $this->{'buttonName'}
            : 'カートに入れる'
        ),
        '', '',
        $cgi::output_option
    );
    $out .= '</div>' if !$no_box;
    return $out;
}

sub sc_condition_tag ($$;$) {
    my ( $this, $condition, $no_box ) = @_;
    $condition = $this->get_condition($condition);
    return ( ( !$no_box ) ? '<div class="showcase-condition">' : '' )
        . ( ($default::english) ? $condition
        : ( $condition eq 'used' )        ? '中古品'
        : ( $condition eq 'refurbished' ) ? '再生品'
        :                                   '新品' )
        . ( ( !$no_box ) ? '</div>' : '' );
}

sub sc_discountable_tag ($;$) {
    my ( $this, $no_box ) = @_;
    my $out = '';
    $out .= '<div class="showcase-discountable">' if !$no_box;
    $out .= $this->{'discountableLabel'} || 'まとめ買い割引対象';
    $out .= '</div>' if !$no_box;
    return $out;
}

sub sc_limited_tag ($;$) {
    my ( $this, $no_box ) = @_;
    my $out = '';
    $out .= '<div class="showcase-limited">' if !$no_box;
    $out .= $this->{'limitedLabel'} || '購入総額制限対象';
    $out .= '</div>' if !$no_box;
    return $out;
}

sub get_condition ($$) {
    my ( $this, $condition ) = @_;
    $condition = $this->{'defaultcondition'}
        if $this->{'defaultconditionfixed'};
    $condition = 'new'
        if !$condition
        || !grep( $condition eq $_, 'new', 'used', 'refurbished' );
    return $condition;
}

sub get_gdata ($$$) {
    my ( $this, $guid, $data ) = @_;
    return () if !$guid || !$data || !ref $data;
    $data = { $this->elements( $data->{'str'} ) }
        if !defined $data->{'price'} && $data->{'str'};
    return ( !defined $data->{'price'} )
        ? ()
        : (
        'g:id'        => $guid,
        'g:price'     => $data->{'price'},
        'g:condition' => $this->get_condition( $data->{'condition'} ),
        );
}

sub raw_price_info ($$$;$) {
    my ( $this, $price, $unit, $title_flag ) = @_;
    if ( !$env::tax_rate ) {
        return '';
    }
    elsif ( defined $env::tax_included && $env::tax_included ) {
        my ($out);
        $out = ($title_flag) ? ' title="' : '(';
        $out .= ($default::english) ? '' : '本体価格:';
        $out .= $unit if $unit && $unit !~ /[^\x20-\x7F]/;
        $out .= $this->digit($price);
        $out .= $unit if $unit && $unit =~ /[^\x20-\x7F]/;
        $out .= ($title_flag) ? '"' : ')';
        return $out;
    }
    else {
        return '';
    }
}

sub add_tax ($$) {
    my ( $this, $price ) = @_;
    if ( !$env::tax_rate ) {
        return $price;
    }
    elsif ( defined $env::tax_included && $env::tax_included ) {
        $price = 0 if !$price || $price =~ /[^0-9\.]/;
        if ( $env::tax_frac eq 'floor' ) {
            return int( $price * ( 1 + $env::tax_rate ) );
        }
        elsif ( $env::tax_frac eq 'round' ) {
            return int( ( $price * ( 1 + $env::tax_rate ) ) + 0.5 );
        }
        else {
            return int( ( $price * ( 1 + $env::tax_rate ) ) + 0.999 );
        }
    }
    else {
        return $price;
    }
}

#---------------------------------------------------------------------
#	(4)-2 obj->format_for_mail(str);
sub format_for_mail {
    my ( $this, $str ) = @_;
    return ''
        if !defined $str
        || $str eq ''
        || ( $this->{'pricehidden'} && $this->{'stockhidden'} );
    my (%data);
    %data
        = ( ref $str eq 'HASH' )
        ? ( defined $$str{'str'} )
            ? $this->elements( $$str{'str'} )
            : %$str
        : $this->elements($str);
    $str = $this->get_showcase_info( \%data );
    return '' if !defined $str || $str eq '';
    $str = '[' . $this->name . "]\x0A" . $str;
    $str =~ s/[\x0A]*\Z/\x0A\x0A/s;
    return $str;
}

sub get_showcase_info($$) {
    my ( $this, $data ) = @_;
    my $out;
    if ( !defined $this->{'pricehidden'} || !$this->{'pricehidden'} ) {
        $out .= $this->{'monetaryunit'}
            if $this->{'monetaryunit'} !~ /[^\x20-\x7F]/;
        $out .= $this->digit( $$data{'price'} );
        $out .= $this->{'monetaryunit'}
            if $this->{'monetaryunit'} =~ /[^\x20-\x7F]/;
    }
    if ( !defined $this->{'stockhidden'} || !$this->{'stockhidden'} ) {
        if (   ( $default::static || $this->{'stockview'} eq 'menu' )
            && defined $$data{'availability'}
            && $$data{'availability'} ne ''
            && ref $this->{'stockAvailability'} eq 'ARRAY'
            && defined $this->{'stockAvailability'}[ $$data{'availability'} ]
            && $this->{'stockAvailability'}[ $$data{'availability'} ] ne '' )
        {
            $out .= '／' if defined $out && $out ne '';
            $out .= $this->{'stockAvailability'}[ $$data{'availability'} ];
        }
        if (   !$default::static
            && defined $$data{'stock'}
            && $$data{'stock'} ne '' )
        {
            $out .= '／' if defined $out && $out ne '';
            $out .= '在庫 ';
            $out .= $this->digit( $$data{'stock'} );
            $out .= $this->{'stockunit'} if $this->{'stockunit'};
        }
    }
    return $out;
}

#---------------------------------------------------------------------
#	(4)-4 obj->format_for_text(str);
sub format_for_text {
    my ( $this, $str ) = @_;
    return ''
        if !defined $str
        || $str eq ''
        || ( $this->{'pricehidden'} && $this->{'stockhidden'} );
    my (%data);
    %data
        = ( ref $str eq 'HASH' )
        ? ( defined $$str{'str'} )
            ? $this->elements( $$str{'str'} )
            : %$str
        : $this->elements($str);
    return $this->get_showcase_info( \%data );
}

#---------------------------------------------------------------------
#	(4)-5 obj->confirmation(str);
sub confirmation_enabled ($) {
    my $this = shift;
    return 1;
}

sub confirmation ($$;$$$) {
    my ( $this, $str, $path, $c, $n ) = @_;
    my %data
        = ( ref $str eq 'HASH' )
        ? ( defined $$str{'str'} )
            ? $this->elements( $$str{'str'} )
            : %$str
        : $this->elements($str);
    my $is_dc = $this->is_digital_content( \%data );
    my $out   = '';
    $out .= $this->digital_content_icon( \%data ) if $is_dc;
    $out .= $this->sc_price_tag( $data{'price'}, $this->{'monetaryunit'} )
        if !$this->{'pricehidden'};

#	$out .= $this->sc_point_tag($data{'point'},$data{'price'},$this->{'pointunit'}) if !$this->{'pointhidden'};
    $out .= $this->sc_stock_tag( $data{'availability'}, $data{'stock'} )
        if !$this->{'stockhidden'} && !$is_dc;
    $out .= $this->sc_condition_tag( $data{'condition'} )
        if !$this->{'defaultconditionfixed'} && !$is_dc;
    $out .= $this->sc_discountable_tag( $data{'discountable'} )
        if $this->{'discountenabled'};
    $out .= $this->sc_limited_tag( $data{'limited'} )
        if $this->{'limitenabled'};
    if ( defined $data{'option'} && $data{'option'} ne '' ) {
        my $menu = '';
        while ( $data{'option'} =~ /^(.*)$/mg ) {
            my $name = $1;
            my ( $mark, $optionprice )
                = ( $name =~ s/:([\+\-]?)([0-9]+)$// )
                ? ( $1, $2 )
                : ( '', '' );
            next if $name !~ /[^\x09\x0A\x0C\x0D\x20]/;
            $menu
                .= $this->escape($name)
                . ( ($optionprice)
                ? '('
                    . ( ($mark) ? $mark : '+' )
                    . $this->digit( $this->add_tax($optionprice) ) . '円)'
                : '' );
        }
        $out .= '<ol>' . $menu . '</ol>' if $menu;
    }
    return $out;
}

######################################################################
#	(5) obj->print_setting_form;
sub print_setting_form ($;$$) {
    my $this = shift;

    #名前
    my $name = 'data:' . $this->{'id'};

    #デフォルト
    $this->print_field_info_form($name);

    print '<fieldset>';
    print '<legend>入力欄設定</legend>';
    print '<table class="field-table">';
    if ( !$default::static ) {
        print '<tbody>';
        print '<tr>';
        print
            '<td class="field-name"><span class="datatitle">フォーム表示</span></td>';
        print '<td class="field" colspan="3">';
        print '<label><select name="' . $name . '_formauthority">';
        print '<option value=""></option>';
        foreach (
            sort {
                $setting::security_name{$a} cmp $setting::security_name{$b}
            } keys %setting::security_name
            )
        {
            print '<option value="'
                . $_ . '"'
                . (
                (   defined $this->{'formauthority'}
                        && $this->{'formauthority'} eq $_
                ) ? ' selected="selected"' : ''
                )
                . '>'
                . $setting::security_name{$_}
                . '</option>';
        }
        print
            '</select> 権限がある場合、価格変更フォームを表示する</label>';
        print '</td>';
        print '</tr>';
        print '<tr class="tbody-end">';
        print
            '<td class="field-name"><span class="datatitle">後処理</span></td>';
        print '<td class="field" colspan="3">';
        print '<label><input type="checkbox" name="'
            . $name
            . '_mTime" value="1"'
            . ( ( $this->{'mTime'} ) ? ' checked="checked"' : '' )
            . ' /> 変更時に更新時データベースを更新する</label>';
        print '</td>';
        print '</tr>';
        print '</tbody>';
    }
    print '<tbody>';
    print '<tr>';
    print
        '<td class="field-name"><span class="datatitle">価格表示</span></td>';
    print '<td class="q-field"><label><input type="checkbox" name="'
        . $name
        . '_pricehidden" value="1"'
        . ( ( defined $this->{'pricehidden'} && $this->{'pricehidden'} )
        ? ' checked="checked"'
        : '' )
        . ' /> 非表示</label></td>';
    print '<td class="field-name"><label for="' . $name
        . '_monetaryunit">価格単位</label></td>';
    print '<td class="q-field">';
    print $this->mk_select_menu(
        $name . '_monetaryunit', '', '', $this->{'monetaryunit'},
        '円'   => '円',
        '&yen;' => '&yen;'
    );
    print '</td>';
    print '</tr>';
    print '<tr class="tbody-end">';
    print
        '<td class="field-name"><span class="datatitle">価格警告</span></td>';
    print
        '<td class="field" colspan="3"><label>価格が <input type="number" name="'
        . $name
        . '_pricelimit" value="'
        . $this->escape( $this->{'pricelimit'} )
        . '" size="10" /> 円未満の時警告する</label></td>';
    print '</tr>';
    print '</tbody>';
    print '<tbody class="physical-item">';
    print '<tr>';
    print '<td class="field-name"><label for="' . $name
        . '_stockname">発注数の名称</label></td>';
    print '<td class="q-field"><input type="text" size="8" name="'
        . $name
        . '_stockname" id="'
        . $name
        . '_stockname" value="'
        . $this->escape( $this->{'stockname'} )
        . '" /> (設定なしで「数量」)</td>';
    print '<td class="field-name"><label for="' . $name
        . '_stockunit">発注数の単位</label></td>';
    print '<td class="q-field"><input type="text" size="8" name="'
        . $name
        . '_stockunit" id="'
        . $name
        . '_stockunit" value="'
        . $this->escape( $this->{'stockunit'} )
        . '" /></td>';
    print '</tr>';
    print '<tr class="tbody-end">';
    print '<td class="field-name"><label for="' . $name
        . '_maxQuantity">数量の最大値</label></td>';
    print '<td class="field" colspan="3">';
    print '<input type="number" size="4" id="'
        . $name
        . '_maxQuantity" name="'
        . $name
        . '_maxQuantity" value="'
        . $this->escape( $this->{'maxQuantity'} ) . '" />';
    print ' <label><input type="checkbox" name="'
        . $name
        . '_quantityMenu" id="'
        . $name
        . '_quantityMenu" value="1"'
        . ( ( defined $this->{'quantityMenu'} && $this->{'quantityMenu'} )
        ? ' checked="checked"'
        : '' )
        . ' /> 数量をプルダウンメニューで選択</label>';
    print '</td>';
    print '</tr>';
    print '</tbody>';

#print '<tbody>';
#print '<tr class="tbody-end">';
#print '<td class="field-name"><span class="datatitle">ポイント表示</span></td>';
#print '<td class="q-field"><label><input type="checkbox" name="' . $name . '_pointhidden" value="1"' . ((defined $this->{'pointhidden'} && $this->{'pointhidden'}) ? ' checked="checked"' : '') . ' /> 非表示</label></td>';
#print '<td class="field-name"><label for="' . $name . '_pointunit">ポイント単位</label></td>';
#print '<td class="q-field"><input type="text" size="8" name="' . $name . '_pointunit" id="' . $name . '_pointunit" value="' . $this->escape($this->{'pointunit'}) . '" /></td>';
#print '</tr>';
#print '<tr>';
#print '<td class="field-name"><span class="datatitle">ポイント警告</span></td>';
#print '<td class="field" colspan="3"><label>ポイント率が <input type="number" name="' . $name . '_pointlimit" value="' . $this->escape($this->{'pointlimit'}) . '" size="4" /> % より大きい時警告する</label></td>';
#print '</tr>';
#print '</tbody>';
    print '<tbody class="physical-item">';
    print '<tr>';
    print
        '<td class="field-name"><span class="datatitle">重量欄</span></td>';
    print '<td class="field" colspan="3">';
    print '<label><input type="checkbox" name="'
        . $name
        . '_weightenabled" id="'
        . $name
        . '_weightenabled" value="1"'
        . ( ( defined $this->{'weightenabled'} && $this->{'weightenabled'} )
        ? ' checked="checked"'
        : '' )
        . ' /> 使用する(重量別送料選択時に必須)</label>';
    print '／<label><input type="checkbox" name="'
        . $name
        . '_weightinvisible" id="'
        . $name
        . '_weightinvisible" value="1"'
        . (
        ( defined $this->{'weightinvisible'} && $this->{'weightinvisible'} )
        ? ' checked="checked"'
        : '' )
        . ' /> 非表示</label>';
    print '</td>';
    print '</tr>';
    print '<tr class="tbody-end">';
    print
        '<td class="field-name"><span class="datatitle">サイズと厚さ欄</span></td>';
    print '<td class="field" colspan="3">';
    print '<label><input type="checkbox" name="'
        . $name
        . '_sizeAndThicknessEnabled" id="'
        . $name
        . '_sizeAndThicknessEnabled" value="1"'
        . (
        (   defined $this->{'sizeAndThicknessEnabled'}
                && $this->{'sizeAndThicknessEnabled'}
        ) ? ' checked="checked"' : ''
        ) . ' /> 使用する(「メール便」利用時に必須)</label>';
    print '／<label><input type="checkbox" name="'
        . $name
        . '_sizeAndThicknessInvisible" id="'
        . $name
        . '_sizeAndThicknessInvisible" value="1"'
        . (
        (   defined $this->{'sizeAndThicknessInvisible'}
                && $this->{'sizeAndThicknessInvisible'}
        ) ? ' checked="checked"' : ''
        ) . ' /> 非表示</label>';
    print '</td>';
    print '</tr>';
    print '</tbody>';

#print '<tbody>';
#print '<tr>';
#print '<td class="field-name"><span class="datatitle">個数欄</span></td>';
#print '<td class="field" colspan="3"><label><input type="checkbox" name="' . $name . '_quantityenabled" id="' . $name . '_quantityenabled" value="1"' . ((defined $this->{'quantityenabled'} && $this->{'quantityenabled'}) ? ' checked="checked"' : '') . ' /> 使用する</label></td>';
#print '</tr>';
#print '</tbody>';
    print '<tbody class="physical-item">';
    print '<tr>';
    print
        '<td class="field-name"><span class="datatitle">在庫管理</span></td>';
    print '<td class="field" colspan="3"><label><input type="checkbox" name="'
        . $name
        . '_stockDisabled" id="'
        . $name
        . '_stockDisabled" value="1"'
        . ( ( defined $this->{'stockDisabled'} && $this->{'stockDisabled'} )
        ? ' checked="checked"'
        : '' )
        . ' /> 在庫を管理しない</label></td>';
    print '</tr>';
    print '<tr>';
    print
        '<td class="field-name"><span class="datatitle">在庫表示</span></td>';
    print '<td class="field" colspan="3"><label><input type="checkbox" name="'
        . $name
        . '_stockhidden" id="'
        . $name
        . '_stockhidden" value="1"'
        . ( ( defined $this->{'stockhidden'} && $this->{'stockhidden'} )
        ? ' checked="checked"'
        : '' )
        . ' /> 非表示</label></td>';
    print '</tr>';

    if ( !$default::static ) {
        print '<tr>';
        print
            '<td class="field-name"><span class="datatitle">在庫表示内容</span></td>';
        print '<td class="field" colspan="3">';
        print '<fieldset><legend><label><input type="radio" name="'
            . $name
            . '_stockview" value="sync"'
            . (
            (   defined $this->{'stockview'}
                    && $this->{'stockview'} eq 'sync'
            ) ? ' checked="checked"' : ''
            ) . '> 在庫数連動</label></legend>';
        require CMONOS::CGI_Lib::Table;
        my $table = Table->new;
        $table->set(
            'tableclass' => 'tooltable',
            'thenabled'  => 'true',
            'trclass'    => 'odd,even',
            'class0'     => 'odd,even',
            'classF'     => 'name',
            'style0'     => 'text-align: center'
        );
        print $table->table;
        print $table->tr;
        print $table->td('状況');
        print $table->td('在庫');
        print $table->td('表示');
        print $table->_tr;
        print $table->tr;
        print $table->td('在庫潤沢');
        print $table->td(
            '<span id="abundant_bounds">'
                . (
                (   defined $this->{'inStockBounds'}
                        && $this->{'inStockBounds'} ne ''
                ) ? $this->{'inStockBounds'}
                : ( defined $this->{'limitedAvailabilityBounds'}
                        && $this->{'limitedAvailabilityBounds'} ne '' )
                ? $this->{'limitedAvailabilityBounds'}
                : ( defined $this->{'outOfStockBounds'}
                        && $this->{'outOfStockBounds'} ne '' )
                ? $this->{'outOfStockBounds'}
                : '&lt;未設定&gt;'
                )
                . '</span>'
                . $this->{'stockunit'}
                . 'より多い'
        );
        print $table->td( '<input type="text" size="24" name="'
                . $name
                . '_abundantName" value="'
                . $this->escape( $this->{'abundantName'} )
                . '" /> ' );
        print $table->_tr;
        print $table->tr;
        print $table->td('在庫通常');
        print $table->td( '<input type="number" size="8" name="'
                . $name
                . '_inStockBounds" value="'
                . $this->escape( $this->{'inStockBounds'} ) . '" /> '
                . $this->{'stockunit'}
                . '以下' );
        print $table->td( '<input type="text" size="24" name="'
                . $name
                . '_inStockName" value="'
                . $this->escape( $this->{'inStockName'} )
                . '" /> ' );
        print $table->_tr;
        print $table->tr;
        print $table->td('在庫僅少');
        print $table->td( '<input type="number" size="8" name="'
                . $name
                . '_limitedAvailabilityBounds" value="'
                . $this->escape( $this->{'limitedAvailabilityBounds'} )
                . '" /> '
                . $this->{'stockunit'}
                . '以下' );
        print $table->td( '<input type="text" size="24" name="'
                . $name
                . '_limitedAvailabilityName" value="'
                . $this->escape( $this->{'limitedAvailabilityName'} )
                . '" /> ' );
        print $table->_tr;
        print $table->tr;
        print $table->td('受注停止');
        print $table->td( '<input type="number" size="8" name="'
                . $name
                . '_outOfStockBounds" value="'
                . $this->escape( $this->{'outOfStockBounds'} ) . '" /> '
                . $this->{'stockunit'}
                . '以下' );
        print $table->td( '<input type="text" size="24" name="'
                . $name
                . '_outOfStockName" value="'
                . $this->escape( $this->{'outOfStockName'} )
                . '" /> ' );
        print $table->_tr;
        print $table->_table;
        print
            '<div class="note">%s = 在庫数</div></fieldset><fieldset><legend><label><input type="radio" name="'
            . $name
            . '_stockview" value="menu"'
            . (
            (   defined $this->{'stockview'}
                    && $this->{'stockview'} eq 'menu'
            ) ? ' checked="checked"' : ''
            ) . '> 在庫状況メニュー</label></legend>';
    }
    else {
        print '<tr>';
        print '<td class="field-name"><label for="' . $name
            . '_stockmenu">在庫状況メニュー</label></td>';
        print '<td class="field" colspan="3">';
    }

    print '<textarea name="'
        . $name
        . '_stockmenu" cols="56" rows="10" wrap="soft" title="在庫状況メニューを設定します。">'
        . $this->escape( $this->{'stockmenu'} )
        . '</textarea>';
    print '<div class="note">項目ごとに改行</div>';
    print '<div class="note">行頭に * = 受注停止対象項目</div>';
    print '</fieldset>' if !defined $default::static || !$default::static;
    print '</td>';
    print '</tr>';
    print '</tbody>';
    print '<tbody>';
    print '<tr>';
    print
        '<td class="field-name"><span class="datatitle">オプション</span></td>';
    print '<td class="field" colspan="3"><ol class="checkbox">';
    print '<li><label><input type="checkbox" name="'
        . $name
        . '_optionenabled" value="1"'
        . ( ( defined $this->{'optionenabled'} && $this->{'optionenabled'} )
        ? ' checked="checked"'
        : '' )
        . ' /> オプションメニューを設定可能にする</label></li>';
    print '<li><label><input type="checkbox" name="'
        . $name
        . '_optionsByCheckbox" value="1"'
        . (
        (   defined $this->{'optionsByCheckbox'}
                && $this->{'optionsByCheckbox'}
        ) ? ' checked="checked"' : ''
        )
        . ' /> オプションをメニューではなくチェックボックスで表示する</label></li>';
    print '<li><label><input type="checkbox" name="'
        . $name
        . '_optionRequired" value="1"'
        . ( ( defined $this->{'optionRequired'} && $this->{'optionRequired'} )
        ? ' checked="checked"'
        : '' )
        . ' /> オプションが存在するとき、オプションの選択を必須とする</label></li>';
    print '<li><label><input type="checkbox" name="'
        . $name
        . '_optionTotalPrice" value="1"'
        . (
        (   defined $this->{'optionTotalPrice'} && $this->{'optionTotalPrice'}
        ) ? ' checked="checked"' : ''
        )
        . ' /> オプションが「複数選択可」ではないとき、上乗せ価格ではなく総額を表示する</label></li>';
    print '</ol></td>';
    print '</tr>';
    print '</tbody></table>';
    print '</fieldset>';

    print '<fieldset>';
    print '<legend>デジタルコンテンツ販売</legend>';

    if ( !$env::subdirectory_disabled && !$env::user_site_template_dir ) {
        my $digital_content_directory
            = $this->get_digital_content_directory_path;
        my $ftp_url = $this->get_digital_content_directory_ftp_url;
        print '<fieldset>';
        print '<legend><label><input type="checkbox" name="'
            . $name
            . '_digitalContentMenuEnabled" value="1"'
            . (
            (   defined $this->{'digitalContentMenuEnabled'}
                    && $this->{'digitalContentMenuEnabled'}
            ) ? ' checked="checked"' : ''
            )
            . ' /> デジタルコンテンツメニュー</label></legend>';
        print
            '<p>デジタルコンテンツを指定フォルダから選択します。</p>';

        print '<table class="field-table">';
        print '<tbody>';

        if ( $this->set_dir($digital_content_directory) ) {
            my $dir = $digital_content_directory;
            $dir =~ s!^(?:\.\./)+!~/!;
            print '<tr>';
            print
                '<td class="field-name"><span class="datatitle">デジタルコンテンツディレクトリのパス</span></td>';
            print '<td class="field">' . $dir . $this->ftp_url_fix . '</td>';
            print '</tr>';
            print '<tr>';
            print
                '<td class="field-name"><span class="datatitle">デジタルコンテンツディレクトリのFTPアドレス(自動取得)</span></td>';
            print '<td class="field"><a href="'
                . $ftp_url . '">'
                . $ftp_url . '</a>'
                . $this->ftp_url_fix . '</td>';
            print '</tr>';
            print '<tr>';
            print '<td class="field-name"><label for="' . $name
                . '_ftpurl">デジタルコンテンツディレクトリのFTPアドレス(補正)</label></td>';
            print '<td class="field">ftp://<input type="text" name="'
                . $name
                . '_ftpurl" id="'
                . $name
                . '_ftpurl" value="'
                . $this->escape( $this->{'ftpurl'} )
                . '" size="30" title="自動取得 URL が間違っている場合、メディアファイルを保存しているディレクトリのURLを設定します。" />'
                . $this->ftp_url_fix . '</td>';
            print '</tr>';
        }

        print '<tr>';
        print '<td class="field-name"><label for="' . $name
            . '_maxitem">表示ファイル数</label></td>';
        print '<td class="field">新しい順に <input type="number" name="'
            . $name
            . '_maxitem" id="'
            . $name
            . '_maxitem" value="'
            . $this->escape( $this->{'maxitem'} )
            . '" size="3" title="メディアファイル選択メニューの表示ファイル数の上限を設定します。" /> 個のファイルをメニューに含める。</td>';
        print '</tr>';

        print '</tbody></table>';
        print '</fieldset>';
    }

    print '<fieldset>';
    print '<legend><label><input type="checkbox" name="'
        . $name
        . '_digitalContentUploadEnabled" value="1"'
        . (
        (   defined $this->{'digitalContentUploadEnabled'}
                && $this->{'digitalContentUploadEnabled'}
        ) ? ' checked="checked"' : ''
        )
        . ' /> デジタルコンテンツアップロード</label></legend>';
    print
        '<p>デジタルコンテンツをファイルアップロードフォームからアップロードします。</p>';
    print '</fieldset>';

    print '<fieldset>';
    print '<legend><label><input type="checkbox" name="'
        . $name
        . '_digitalContentRequired" value="1"'
        . (
        (   defined $this->{'digitalContentRequired'}
                && $this->{'digitalContentRequired'}
        ) ? ' checked="checked"' : ''
        )
        . ' onclick="cmonos.element.item(\'tbody.physical-item\').disappear(this.checked);" /> デジタルコンテンツ必須</label></legend>';
    print
        '<p>デジタルコンテンツが存在しない場合カートを表示しません。</p>';
    print '</fieldset>';
    print $this->javascript(
        'cmonos.element.item(\'tbody.physical-item\').disappear(true);')
        if $this->{'digitalContentRequired'};

    print '<fieldset>';
    print '<legend><label for="' . $name
        . '_mimetype">登録可能なデジタルコンテンツの MIME-TYPE</label></legend>';
    print '<textarea name="'
        . $name
        . '_mimetype" id="'
        . $name
        . '_mimetype" cols="50" rows="6">'
        . $this->escape( $this->{'mimetype'} )
        . '</textarea>';
    print
        '<div class="note">MIME-TYPE:拡張子:ファイルの種類[改行]</div>';
    print '<div class="example">例）image/jpeg:jpg:JPEG画像</div>';
    print
        '<div class="hints">設定がない場合全てのファイルを登録します。</div>';
    print '</fieldset>';

    print '</fieldset>';

    print '<fieldset>';
    print '<legend><label for="' . $name
        . '_withdrawnLabel">「販売中止」ラベル</label></legend>';
    print '<input type="text" name="'
        . $name
        . '_withdrawnLabel" id="'
        . $name
        . '_withdrawnLabel" value="'
        . $this->escape( $this->{'withdrawnLabel'} )
        . '" size="50" title="「販売中止」ラベルを設定します。" />';
    print '</fieldset>';

    print '<fieldset>';
    print '<legend>販売期間</legend>';
    print '<table class="field-table">';
    print '<tbody>';
    print '<tr>';
    print '<td class="field-name"><label for="' . $name
        . '_periodfield">期間参照フィールド</label></td>';
    print '<td class="field">';
    my $period_menu = '';

    foreach my $id (
        sort {
            $this->{'field_obj'}->{$a}->{'ORDER'}
                <=> $this->{'field_obj'}->{$b}->{'ORDER'}
                || $a <=> $b
        } keys %{ $this->{'field_obj'} }
        )
    {
        $period_menu
            .= '<option value="'
            . $id . '"'
            . (
            (   defined $this->{'periodfield'}
                    && $this->{'periodfield'} eq $id
            ) ? ' selected="selected"' : ''
            )
            . '>'
            . $this->{'field_obj'}{$id}->{'name'}
            . '</option>'
            if ref $this->{'field_obj'}{$id}
            && $this->{'field_obj'}{$id}->{'class'}
            && $this->{'field_obj'}{$id}->{'class'} eq 'time_span';
    }
    if ($period_menu) {
        print '<select name="'
            . $name
            . '_periodfield" id="'
            . $name
            . '_periodfield">';
        print '<option value=""'
            . (
            (   !defined $this->{'periodfield'}
                    || $this->{'periodfield'} eq ''
            ) ? ' selected="selected"' : ''
            ) . '>&lt;指定しない&gt;</option>';
        print $period_menu;
        print '</select>';
    }
    else {
        print '「期間」フィールドがみつかりません。';
    }
    print '</td>';
    print '</tr>';
    $this->print_period_setting_form($name);
    if ( !$default::static ) {
        print '<tr>';
        print '<td class="field-name"><label for="' . $name
            . '_discontinuedLabel">販売期間外ラベル</label></td>';
        print '<td class="field"><input type="text" name="'
            . $name
            . '_discontinuedLabel" id="'
            . $name
            . '_discontinuedLabel" size="32" title="販売期間外のとき表示するラベルを設定します。" value="'
            . $this->escape( $this->{'discontinuedLabel'} )
            . '" /></td>';
        print '</tr>';
    }
    print '</tbody></table>';
    print '</fieldset>';

    print '<fieldset>';
    print '<legend>販売条件</legend>';
    print '<table class="field-table">';
    print '<tbody>';
    print '<tr>';
    print
        '<td class="field-name"><label title="まとめ買い割引対象を指定するときチェックします。"><input type="checkbox" name="'
        . $name
        . '_discountenabled" value="1"'
        . ( ( $this->{'discountenabled'} ) ? ' checked="checked"' : '' )
        . ' /> まとめ買い割引対象ラベル</label></td>';
    print '<td class="field"><input type="text" name="'
        . $name
        . '_discountableLabel" id="'
        . $name
        . '_discountableLabel" size="50" title="まとめ買い割引対象のラベルを設定します。" value="'
        . $this->escape( $this->{'discountableLabel'} )
        . '" /></td>';
    print '</tr>';
    print '<tr>';
    print
        '<td class="field-name"><label title="購入総額制限対象を指定するときチェックします。"><input type="checkbox" name="'
        . $name
        . '_limitenabled" value="1"'
        . ( ( $this->{'limitenabled'} ) ? ' checked="checked"' : '' )
        . ' /> 購入総額制限対象ラベル</label></td>';
    print '<td class="field"><input type="text" name="'
        . $name
        . '_limitedLabel" id="'
        . $name
        . '_limitedLabel" size="50" title="購入総額制限対象のラベルを設定します。" value="'
        . $this->escape( $this->{'limitedLabel'} )
        . '" /></td>';
    print '</tr>';
    print '</tbody>';
    print '</table>';
    print '</fieldset>';

    $this->print_sub_setting_form($name);

    print '<fieldset>';
    print '<legend>ボタン設定</legend>';
    print '<fieldset>';
    print '<legend>カートアイコン</legend>';
    print $cgi::Deco->button_menu( $name . '_button',
        'cart', 120, $this->{'button'}, );
    print '<div class="additional-field"><label for="'
        . $name
        . '_buttonName">ボタンの名前</label><input type="text" size="50" maxlength="100" name="'
        . $name
        . '_buttonName" id="'
        . $name
        . '_buttonName" value="'
        . $this->escape( $this->{'buttonName'} )
        . '" /></div>';
    print '</fieldset>';

    if ( !$default::static ) {
        print '<fieldset>';
        print '<legend>送信ボタン</legend>';
        print $cgi::Deco->button_menu(
            $name . '_submitButton',
            'submit', 120, $this->{'submitButton'},
        );
        print '</fieldset>';
    }
    print '</fieldset>';

    print '<fieldset>';
    print '<legend><label for="' . $name
        . '_template">テンプレート</label></legend>';
    print '<textarea name="'
        . $name
        . '_template" id="'
        . $name
        . '_template" cols="72" rows="10" wrap="off" class="content-editor-area">'
        . $this->escape( $this->{'template'} )
        . '</textarea>';
    print '<div class="toolbox">';
    print
        '<label class="auto-fit" title="高さを内容に合わせる"><input type="checkbox" onclick="cmonos.form.item(this.form).fieldname(\'',
        $name,
        '_template\').setAutoFit(this.checked);" />フィット</label> ';
    print
        '<select class="tool" onchange="cmonos.form.item(this.form).fieldname(\''
        . $name
        . '_template\').quotationByMenu(this)" title="これらのタグは、書き出し時に対応する投稿データに変換されます。">';
    print
        '<option value="">▼ショッピングカートタグを挿入する</option>';
    print
        '<option value="&lt;!--icon--&gt;&lt;!--head--&gt;&lt;!--/head--&gt;&lt;!--foot--&gt;&lt;!--/foot--&gt;&lt;!--/icon--&gt;">デジタルコンテンツアイコン &lt;!--icon--&gt;&lt;!--/icon--&gt;</option>';
    print
        '<option value="&lt;!--price--&gt;&lt;!--head--&gt;&lt;!--/head--&gt;&lt;!--foot--&gt;&lt;!--/foot--&gt;&lt;!--/price--&gt;">価格 &lt;!--price--&gt;&lt;!--/price--&gt;</option>';

#print '<option value="&lt;!--point--&gt;&lt;!--head--&gt;&lt;!--/head--&gt;&lt;!--foot--&gt;&lt;!--/foot--&gt;&lt;!--/point--&gt;">ポイント &lt;!--point--&gt;&lt;!--/point--&gt;</option>';
    print
        '<option value="&lt;!--stock--&gt;&lt;!--head--&gt;&lt;!--/head--&gt;&lt;!--foot--&gt;&lt;!--/foot--&gt;&lt;!--/stock--&gt;">在庫 &lt;!--stock--&gt;&lt;!--/stock--&gt;</option>';
    print
        '<option value="&lt;!--condition--&gt;&lt;!--head--&gt;&lt;!--/head--&gt;&lt;!--foot--&gt;&lt;!--/foot--&gt;&lt;!--/condition--&gt;">状態 &lt;!--condition--&gt;&lt;!--/condition--&gt;</option>';
    print '<option value=""></option>';
    print
        '<option value="&lt;!--weight--&gt;&lt;!--head--&gt;&lt;!--/head--&gt;&lt;!--foot--&gt;&lt;!--/foot--&gt;&lt;!--/weight--&gt;">在庫 &lt;!--weight--&gt;&lt;!--/weight--&gt;</option>';
    print
        '<option value="&lt;!--papersize--&gt;&lt;!--head--&gt;&lt;!--/head--&gt;&lt;!--foot--&gt;&lt;!--/foot--&gt;&lt;!--/papersize--&gt;">サイズ &lt;!--papersize--&gt;&lt;!--/papersize--&gt;</option>';
    print
        '<option value="&lt;!--thickness--&gt;&lt;!--head--&gt;&lt;!--/head--&gt;&lt;!--foot--&gt;&lt;!--/foot--&gt;&lt;!--/thickness--&gt;">厚さ &lt;!--thickness--&gt;&lt;!--/thickness--&gt;</option>';
    print '<option value=""></option>';
    print
        '<option value="&lt;!--quantity--&gt;&lt;!--head--&gt;&lt;!--/head--&gt;&lt;!--foot--&gt;&lt;!--/foot--&gt;&lt;!--/quantity--&gt;">発注数欄 &lt;!--quantity--&gt;&lt;!--/quantity--&gt;</option>';
    print
        '<option value="&lt;!--option--&gt;&lt;!--head--&gt;&lt;!--/head--&gt;&lt;!--foot--&gt;&lt;!--/foot--&gt;&lt;!--/option--&gt;">オプションメニュー &lt;!--option--&gt;&lt;!--/option--&gt;</option>';
    print
        '<option value="&lt;!--button--&gt;&lt;!--head--&gt;&lt;!--/head--&gt;&lt;!--foot--&gt;&lt;!--/foot--&gt;&lt;!--/button--&gt;">カートに入れる ボタン &lt;!--button--&gt;&lt;!--/button--&gt;</option>';
    print '</select>';

    require CMONOS::CGI_Lib::HTMLHelper;
    print HTMLHelper->new->html_helper_menu( $name . '_template' );

    print '</div>';
    print '</fieldset>';

    print '<fieldset>';
    print '<legend>デフォルト</legend>';

    print $this->input_form( $name . '_default', 'default', $this, 1 );

    print '</fieldset>';

    $this->print_font_setting_form($name);
    $this->print_setting_save_button;
    return;
}

sub print_sub_setting_form ($) {
    my ( $this, $name ) = @_;
}

sub print_period_setting_form ($) {
    my ( $this, $name ) = @_;
}

######################################################################
#	(6) obj->is_valid_setting;
sub is_valid_setting ($) {
    my $this     = shift;
    my $is_valid = $this->is_valid_font_setting;
    if (   defined $main::data{ $this->{'id'} . '_pricelimit' }
        && $main::data{ $this->{'id'} . '_pricelimit' } ne ''
        && $this->is_not_digit( $main::data{ $this->{'id'} . '_pricelimit' } )
        )
    {
        push(
            @{ $cgi::action->{'dialog'} },
            '価格警告対象値が数ではありません。半角数字にしてください。'
        ) if ref $cgi::action;
        delete $main::data{ $this->{'id'} . '_pricelimit' };
        $is_valid = 0;
    }

#if (defined $main::data{$this->{'id'} . '_pointlimit'} && $main::data{$this->{'id'} . '_pointlimit'} ne '' && $this->is_not_digit($main::data{$this->{'id'} . '_pointlimit'})) {
#	push(@{$cgi::action->{'dialog'}},'ポイント警告対象値が数ではありません。半角数字にしてください。') if ref $cgi::action;
#	delete $main::data{$this->{'id'} . '_pointlimit'};
#	$is_valid = 0;
#}
    if (   defined $main::data{ $this->{'id'} . '_maxQuantity' }
        && $main::data{ $this->{'id'} . '_maxQuantity' } ne ''
        && $this->is_not_digit(
            $main::data{ $this->{'id'} . '_maxQuantity' } ) )
    {
        push(
            @{ $cgi::action->{'dialog'} },
            '数量の最大値が数ではありません。半角数字にしてください。'
        ) if ref $cgi::action;
        delete $main::data{ $this->{'id'} . '_maxQuantity' };
        $is_valid = 0;
    }
    elsif ( $main::data{ $this->{'id'} . '_maxQuantity' } ) {
        $main::data{ $this->{'id'} . '_maxQuantity' }
            = abs( int( $main::data{ $this->{'id'} . '_maxQuantity' } ) );
    }
    if ( !$default::static ) {
        if (   defined $main::data{ $this->{'id'} . '_inStockBounds' }
            && $main::data{ $this->{'id'} . '_inStockBounds' } ne ''
            && $this->is_not_digit(
                $main::data{ $this->{'id'} . '_inStockBounds' }
            )
            )
        {
            push(
                @{ $cgi::action->{'dialog'} },
                '在庫通常となる在庫条件を更新できませんでした。半角数字にしてください。'
            ) if ref $cgi::action;
            delete $main::data{ $this->{'id'} . '_inStockBounds' };
            $is_valid = 0;
        }
        if (defined $main::data{ $this->{'id'}
                    . '_limitedAvailabilityBounds' }
            && $main::data{ $this->{'id'} . '_limitedAvailabilityBounds' } ne
            ''
            && $this->is_not_digit(
                $main::data{ $this->{'id'} . '_limitedAvailabilityBounds' }
            )
            )
        {
            push(
                @{ $cgi::action->{'dialog'} },
                '在庫僅少となる在庫条件を更新できませんでした。半角数字にしてください。'
            ) if ref $cgi::action;
            delete $main::data{ $this->{'id'}
                    . '_limitedAvailabilityBounds' };
            $is_valid = 0;
        }
        if (   defined $main::data{ $this->{'id'} . '_outOfStockBounds' }
            && $main::data{ $this->{'id'} . '_outOfStockBounds' } ne ''
            && $this->is_not_digit(
                $main::data{ $this->{'id'} . '_outOfStockBounds' }
            )
            )
        {
            push(
                @{ $cgi::action->{'dialog'} },
                '受注停止となる在庫条件を更新できませんでした。半角数字にしてください。'
            ) if ref $cgi::action;
            delete $main::data{ $this->{'id'} . '_outOfStockBounds' };
            $is_valid = 0;
        }
        if (  !$main::data{ $this->{'id'} . '_stockDisabled' }
            && $main::data{ $this->{'id'} . '_stockview' }
            && $main::data{ $this->{'id'} . '_stockview' } eq 'sync' )
        {
            if ( !defined $main::data{ $this->{'id'} . '_outOfStockBounds' }
                || $main::data{ $this->{'id'} . '_outOfStockBounds' } eq '' )
            {
                push(
                    @{ $cgi::action->{'dialog'} },
                    '在庫条件を更新できませんでした。受注停止となる在庫条件を設定してください。'
                ) if ref $cgi::action;
                $main::data{ $this->{'id'} . '_stockview' } = '';
                $is_valid = 0;
            }
            else {
                my @bounds = grep( defined $_ && $_ =~ /^[0-9]+$/,
                    $main::data{ $this->{'id'} . '_inStockBounds' },
                    $main::data{ $this->{'id'}
                            . '_limitedAvailabilityBounds' },
                    $main::data{ $this->{'id'} . '_outOfStockBounds' } );
                my $prev;
                my $is_valid_bounds = 1;
                foreach my $n (@bounds) {
                    if ( defined $prev && $prev <= $n ) {
                        $is_valid_bounds = 0;
                        last;
                    }
                    $prev = $n;
                }
                if ( !$is_valid_bounds ) {
                    push(
                        @{ $cgi::action->{'dialog'} },
                        '在庫条件を更新できませんでした。在庫条件に矛盾があります。'
                    ) if ref $cgi::action;
                    delete $main::data{ $this->{'id'} . '_inStockBounds' };
                    delete $main::data{ $this->{'id'}
                            . '_limitedAvailabilityBounds' };
                    delete $main::data{ $this->{'id'} . '_outOfStockBounds' };
                    $is_valid = 0;
                }
            }
        }
        $this->tag_fix( \$main::data{ $this->{'id'} . '_abundantName' } )
            if defined $main::data{ $this->{'id'} . '_abundantName' }
            && $main::data{ $this->{'id'} . '_abundantName' };
        $this->tag_fix( \$main::data{ $this->{'id'} . '_inStockName' } )
            if defined $main::data{ $this->{'id'} . '_inStockName' }
            && $main::data{ $this->{'id'} . '_inStockName' };
        $this->tag_fix(
            \$main::data{ $this->{'id'} . '_limitedAvailabilityName' } )
            if
            defined $main::data{ $this->{'id'} . '_limitedAvailabilityName' }
            && $main::data{ $this->{'id'} . '_limitedAvailabilityName' };
        $this->tag_fix( \$main::data{ $this->{'id'} . '_outOfStockName' } )
            if defined $main::data{ $this->{'id'} . '_outOfStockName' }
            && $main::data{ $this->{'id'} . '_outOfStockName' };
    }
    if (!$main::data{ $this->{'id'} . '_stockDisabled' }
        && ($default::static
            || (   $main::data{ $this->{'id'} . '_stockview' }
                && $main::data{ $this->{'id'} . '_stockview' } eq 'menu' )
        )
        )
    {
        if (   !defined $main::data{ $this->{'id'} . '_stockmenu' }
            || $main::data{ $this->{'id'} . '_stockmenu' } eq ''
            || $main::data{ $this->{'id'} . '_stockmenu' } !~ /\x0A/s )
        {
            push(
                @{ $cgi::action->{'dialog'} },
                '在庫状況メニューを更新できませんでした。2つ以上の在庫状況メニューを入力してください。'
            ) if ref $cgi::action;
            $is_valid = 0;
        }
    }
    if (   defined $main::data{ $this->{'id'} . '_defaultprice' }
        && $main::data{ $this->{'id'} . '_defaultprice' } ne ''
        && ($this->is_not_digit(
                $main::data{ $this->{'id'} . '_defaultprice' }
            )
            || $main::data{ $this->{'id'} . '_defaultprice' } < 0
        )
        )
    {
        push(
            @{ $cgi::action->{'dialog'} },
            '価格のデフォルトが正の数ではありません。半角数字にしてください。'
        ) if ref $cgi::action;
        delete $main::data{ $this->{'id'} . '_defaultprice' };
        $is_valid = 0;
    }
    if (   defined $main::data{ $this->{'id'} . '_defaultstock' }
        && $main::data{ $this->{'id'} . '_defaultstock' } ne ''
        && ($this->is_not_digit(
                $main::data{ $this->{'id'} . '_defaultstock' }
            )
            || $main::data{ $this->{'id'} . '_defaultstock' } < 0
        )
        )
    {
        push(
            @{ $cgi::action->{'dialog'} },
            '在庫数のデフォルトが正の数ではありません。半角数字にしてください。'
        ) if ref $cgi::action;
        delete $main::data{ $this->{'id'} . '_defaultstock' };
        $is_valid = 0;
    }
    if (   defined $main::data{ $this->{'id'} . '_defaultweight' }
        && $main::data{ $this->{'id'} . '_defaultweight' } ne ''
        && ( $this->is_nan( $main::data{ $this->{'id'} . '_defaultweight' } )
            || $main::data{ $this->{'id'} . '_defaultweight' } < 0 )
        )
    {
        push(
            @{ $cgi::action->{'dialog'} },
            '重量のデフォルトが正の数ではありません。半角数字にしてください。'
        ) if ref $cgi::action;
        delete $main::data{ $this->{'id'} . '_defaultweight' };
        $is_valid = 0;
    }
    if (   defined $main::data{ $this->{'id'} . '_defaultthickness' }
        && $main::data{ $this->{'id'} . '_defaultthickness' } ne ''
        && ($this->is_nan(
                $main::data{ $this->{'id'} . '_defaultthickness' }
            )
            || $main::data{ $this->{'id'} . '_defaultthickness' } < 0
        )
        )
    {
        push(
            @{ $cgi::action->{'dialog'} },
            '厚さのデフォルトが正の数ではありません。半角数字にしてください。'
        ) if ref $cgi::action;
        delete $main::data{ $this->{'id'} . '_defaultthickness' };
        $is_valid = 0;
    }
    $main::data{ $this->{'id'} . '_mTime' } = ''
        if !defined $main::data{ $this->{'id'} . '_mTime' }
        || !$main::data{ $this->{'id'} . '_mTime' };
    $main::data{ $this->{'id'} . '_pricehidden' } = ''
        if !defined $main::data{ $this->{'id'} . '_pricehidden' }
        || !$main::data{ $this->{'id'} . '_pricehidden' };
    $main::data{ $this->{'id'} . '_stockDisabled' } = ''
        if !defined $main::data{ $this->{'id'} . '_stockDisabled' }
        || !$main::data{ $this->{'id'} . '_stockDisabled' };
    $main::data{ $this->{'id'} . '_stockhidden' } = ''
        if !defined $main::data{ $this->{'id'} . '_stockhidden' }
        || !$main::data{ $this->{'id'} . '_stockhidden' };

#$main::data{$this->{'id'} . '_pointhidden'} = '' if !defined $main::data{$this->{'id'} . '_pointhidden'} || !$main::data{$this->{'id'} . '_pointhidden'};
    $main::data{ $this->{'id'} . '_quantityMenu' } = ''
        if !defined $main::data{ $this->{'id'} . '_quantityMenu' }
        || !$main::data{ $this->{'id'} . '_quantityMenu' };
    $main::data{ $this->{'id'} . '_weightenabled' } = ''
        if !defined $main::data{ $this->{'id'} . '_weightenabled' }
        || !$main::data{ $this->{'id'} . '_weightenabled' };
    $main::data{ $this->{'id'} . '_weightinvisible' } = ''
        if !defined $main::data{ $this->{'id'} . '_weightinvisible' }
        || !$main::data{ $this->{'id'} . '_weightinvisible' };
    $main::data{ $this->{'id'} . '_sizeAndThicknessEnabled' } = ''
        if !defined $main::data{ $this->{'id'} . '_sizeAndThicknessEnabled' }
        || !$main::data{ $this->{'id'} . '_sizeAndThicknessEnabled' };
    $main::data{ $this->{'id'} . '_sizeAndThicknessInvisible' } = ''
        if !
        defined $main::data{ $this->{'id'} . '_sizeAndThicknessInvisible' }
        || !$main::data{ $this->{'id'} . '_sizeAndThicknessInvisible' };
    $main::data{ $this->{'id'} . '_discountenabled' } = ''
        if !defined $main::data{ $this->{'id'} . '_discountenabled' }
        || !$main::data{ $this->{'id'} . '_discountenabled' };
    $main::data{ $this->{'id'} . '_limitenabled' } = ''
        if !defined $main::data{ $this->{'id'} . '_limitenabled' }
        || !$main::data{ $this->{'id'} . '_limitenabled' };

#$main::data{$this->{'id'} . '_quantityenabled'} = '' if !defined $main::data{$this->{'id'} . '_quantityenabled'} || !$main::data{$this->{'id'} . '_quantityenabled'};
    $main::data{ $this->{'id'} . '_optionenabled' } = ''
        if !defined $main::data{ $this->{'id'} . '_optionenabled' }
        || !$main::data{ $this->{'id'} . '_optionenabled' };
    $main::data{ $this->{'id'} . '_optionsByCheckbox' } = ''
        if !defined $main::data{ $this->{'id'} . '_optionsByCheckbox' }
        || !$main::data{ $this->{'id'} . '_optionsByCheckbox' };
    $main::data{ $this->{'id'} . '_optionRequired' } = ''
        if !defined $main::data{ $this->{'id'} . '_optionRequired' }
        || !$main::data{ $this->{'id'} . '_optionRequired' };
    $main::data{ $this->{'id'} . '_optionTotalPrice' } = ''
        if !defined $main::data{ $this->{'id'} . '_optionTotalPrice' }
        || !$main::data{ $this->{'id'} . '_optionTotalPrice' };
    $main::data{ $this->{'id'} . '_defaultconditionfixed' } = ''
        if !defined $main::data{ $this->{'id'} . '_defaultconditionfixed' }
        || !$main::data{ $this->{'id'} . '_defaultconditionfixed' };
    $main::data{ $this->{'id'} . '_defaultdiscountable' } = ''
        if !defined $main::data{ $this->{'id'} . '_defaultdiscountable' }
        || !$main::data{ $this->{'id'} . '_defaultdiscountable' };
    $main::data{ $this->{'id'} . '_defaultlimited' } = ''
        if !defined $main::data{ $this->{'id'} . '_defaultlimited' }
        || !$main::data{ $this->{'id'} . '_defaultlimited' };
    $main::data{ $this->{'id'} . '_defaultnoshipping' } = ''
        if !defined $main::data{ $this->{'id'} . '_defaultnoshipping' }
        || !$main::data{ $this->{'id'} . '_defaultnoshipping' };
    $main::data{ $this->{'id'} . '_defaultcanceldeadline' } = ''
        if !defined $main::data{ $this->{'id'} . '_defaultcanceldeadline' }
        || $main::data{ $this->{'id'} . '_defaultcanceldeadline' } ne
        'shipping';

    $is_valid = 0 if $this->is_valid_sub_setting;

    $main::data{ $this->{'id'} . '_ftpurl' }
        = $this->z_to_h( $main::data{ $this->{'id'} . '_ftpurl' }, 'utf8' )
        if defined $main::data{ $this->{'id'} . '_ftpurl' }
        && $main::data{ $this->{'id'} . '_ftpurl' };
    $main::data{ $this->{'id'} . '_digitalContentMenuEnabled' } = ''
        if !
        defined $main::data{ $this->{'id'} . '_digitalContentMenuEnabled' }
        || !$main::data{ $this->{'id'} . '_digitalContentMenuEnabled' };
    $main::data{ $this->{'id'} . '_digitalContentUploadEnabled' } = ''
        if !
        defined $main::data{ $this->{'id'} . '_digitalContentUploadEnabled' }
        || !$main::data{ $this->{'id'} . '_digitalContentUploadEnabled' };
    $main::data{ $this->{'id'} . '_digitalContentRequired' } = ''
        if !defined $main::data{ $this->{'id'} . '_digitalContentRequired' }
        || !$main::data{ $this->{'id'} . '_digitalContentRequired' };

    if (   defined $main::data{ $this->{'id'} . '_maxitem' }
        && $main::data{ $this->{'id'} . '_maxitem' } ne ''
        && $this->is_not_digit( $main::data{ $this->{'id'} . '_maxitem' } ) )
    {
        push(
            @{ $cgi::action->{'dialog'} },
            '表示ファイル数を更新できませんでした。半角数字にしてください。'
        ) if ref $cgi::action;
        delete $main::data{ $this->{'id'} . '_maxitem' };
        $is_valid = 0;
    }
    if (   !$main::data{ $this->{'id'} . '_digitalContentMenuEnabled' }
        && !$main::data{ $this->{'id'} . '_digitalContentUploadEnabled' }
        && $main::data{ $this->{'id'} . '_digitalContentRequired' } )
    {
        push(
            @{ $cgi::action->{'dialog'} },
            'デジタルコンテンツを必須とするには「デジタルコンテンツメニュー」または「デジタルコンテンツアップロード」が有効である必要があります。'
        ) if ref $cgi::action;
        delete $main::data{ $this->{'id'} . '_digitalContentRequired' };
        $is_valid = 0;
    }
    $this->detag( \$main::data{ $this->{'id'} . '_mimetype' } )
        if defined $main::data{ $this->{'id'} . '_mimetype' }
        && $main::data{ $this->{'id'} . '_mimetype' };

    $main::data{ $this->{'id'} . '_defaultmultiple' } = ''
        if !defined $main::data{ $this->{'id'} . '_defaultmultiple' }
        || !$main::data{ $this->{'id'} . '_defaultmultiple' };
    $this->tag_fix( \$main::data{ $this->{'id'} . '_description' } )
        if defined $main::data{ $this->{'id'} . '_description' }
        && $main::data{ $this->{'id'} . '_description' };
    $this->tag_fix( \$main::data{ $this->{'id'} . '_note' } )
        if defined $main::data{ $this->{'id'} . '_note' }
        && $main::data{ $this->{'id'} . '_note' };
    $this->tag_fix( \$main::data{ $this->{'id'} . '_stockunit' } )
        if defined $main::data{ $this->{'id'} . '_stockunit' }
        && $main::data{ $this->{'id'} . '_stockunit' };
    $this->tag_fix( \$main::data{ $this->{'id'} . '_discountableLabel' } )
        if defined $main::data{ $this->{'id'} . '_discountableLabel' }
        && $main::data{ $this->{'id'} . '_discountableLabel' };
    $this->tag_fix( \$main::data{ $this->{'id'} . '_limitedLabel' } )
        if defined $main::data{ $this->{'id'} . '_limitedLabel' }
        && $main::data{ $this->{'id'} . '_limitedLabel' };

#$this->tag_fix(\$main::data{$this->{'id'} . '_pointunit'}) if defined $main::data{$this->{'id'} . '_pointunit'} && $main::data{$this->{'id'} . '_pointunit'};
    return $is_valid;
}

sub is_valid_sub_setting ($) {
    my $this = shift;
    return 1;
}

######################################################################
sub search_form_enabled ($) {
    my $this = shift;
    return ( $this->{'pricehidden'} && $this->{'stockhidden'} ) ? 0 : 1;
}

#	(6) obj->search_form;
sub search_form ($) {
    my $this = shift;

#return '' if $this->{'pricehidden'} && $this->{'pointhidden'} && $this->{'stockhidden'};
    return '' if $this->{'pricehidden'} && $this->{'stockhidden'};
    my ($form);
    $form
        = '<tr><td class="field-name"><span class="datatitle">'
        . $this->{'name'}
        . '</span></td><td class="field"><table class="sub-field-table">';
    if ( !$this->{'pricehidden'} ) {
        $form .= '<tr><td class="sub-field-name">';
        $form
            .= ( ($default::english)
            ? '<span class="datatitle">Price</span> '
            : '<span class="datatitle">価格</span> ' );
        $form .= '</td><td class="sub-field">';
        $form .= $this->search_form_for_price($this);
        $form .= '</td></tr>';
    }

#if (!defined $this->{'pointhidden'} ||  !$this->{'pointhidden'}) {
#	$form .= '<tr><td class="sub-field-name">';
#	$form .= (($default::english) ? '<span class="datatitle">Point</span> ' : '<span class="datatitle">ポイント</span> ');
#	$form .= '</td><td class="sub-field">';
#	$form .= $this->search_form_for_point($this);
#	$form .= '</td></tr>';
#}
    if ( !$this->{'stockhidden'} ) {
        $form .= '<tr><td class="sub-field-name">';
        $form
            .= ( ($default::english)
            ? '<span class="datatitle">Stock</span> '
            : '<span class="datatitle">在庫状況</span> ' );
        $form .= '</td><td class="sub-field">';
        $form .= $this->search_form_for_stock($this);
        $form .= '</td></tr>';
    }
    $form .= '</tbody></table></td></tr>';
    return $form;
}

sub search_form_for_price ($$) {
    my ( $this, $obj ) = @_;
    my ($form);
    $form .= '<label>';
    $form .= '<span class="unit">From</span> '
        if defined $default::english && $default::english;
    $form .= '<span class="unit">' . $this->{'monetaryunit'} . '</span> '
        if !defined $this->{'monetaryunit'}
        && $this->{'monetaryunit'} !~ /[^\x20-\x7F]/;
    $form
        .= '<input type="number" size="10" name="search:'
        . $obj->{'id'}
        . ':f" value="'
        . $this->escape( $main::search{ $obj->{'id'} }{'f'} ) . '" />';
    $form .= ' <span class="unit">' . $this->{'monetaryunit'} . '</span>'
        if defined $this->{'monetaryunit'}
        && $this->{'monetaryunit'} =~ /[^\x20-\x7F]/;
    $form .= ' <span class="unit">以上</span> '
        if !defined $default::english || !$default::english;
    $form .= '</label>';
    $form .= '<label>';
    $form .= ' <span class="unit">To</span> '
        if defined $default::english && $default::english;
    $form .= '<span class="unit">' . $this->{'monetaryunit'} . '</span> '
        if !defined $this->{'monetaryunit'}
        && $this->{'monetaryunit'} !~ /[^\x20-\x7F]/;
    $form
        .= '<input type="number" size="10" name="search:'
        . $obj->{'id'}
        . ':t" value="'
        . $this->escape( $main::search{ $obj->{'id'} }{'t'} ) . '" />';
    $form .= ' <span class="unit">' . $this->{'monetaryunit'} . '</span>'
        if defined $this->{'monetaryunit'}
        && $this->{'monetaryunit'} =~ /[^\x20-\x7F]/;
    $form .= ' <span class="unit">以下</span>'
        if !defined $default::english || !$default::english;
    $form .= '</label>';
    return $form;
}

#sub search_form_for_point ($$) {
#my($this,$obj) = @_;
#my($form);
#$form .= '<label>';
#$form .= '<span class="unit">From</span> ' if defined $default::english && $default::english;
#$form .= '<input type="number" size="3" name="search:' . $obj->{'id'} . ':pf" value="' . $this->escape($main::search{$obj->{'id'}}{'pf'}) . '" />';
#$form .= ' <span class="unit">%</span>';
#$form .= ' <span class="unit">以上</span> ' if !defined $default::english || !$default::english;
#$form .= '</label>';
#$form .= '<label>';
#$form .= ' <span class="unit">To</span> ' if defined $default::english && $default::english;
#$form .= '<input type="number" size="3" name="search:' . $obj->{'id'} . ':pt" value="' . $this->escape($main::search{$obj->{'id'}}{'pt'}) . '" />';
#$form .= ' <span class="unit">%</span>';
#$form .= ' <span class="unit">以下</span>' if !defined $default::english || !$default::english;
#$form .= '</label>';
#return $form;
#}

sub search_form_for_stock ($$) {
    my ( $this, $obj ) = @_;
    my $name = 'search:' . $obj->{'id'} . ':stock';
    $this->scalar_to_array( \$main::search{ $obj->{'id'} }{'stock'} );
    my $form = '';
    if (   $this->{'digitalContentMenuEnabled'}
        || $this->{'digitalContentUploadEnabled'} )
    {
        $form
            .= '<li><label><input type="checkbox" name="'
            . $name
            . '" id="'
            . $name
            . '" value="file"'
            . (
            (   @{ $main::search{ $obj->{'id'} }{'stock'} }
                    && grep( $_ eq 'file',
                    @{ $main::search{ $obj->{'id'} }{'stock'} } )
            ) ? ' checked="checked"' : ''
            ) . '> ダウンロード</label></li>';
        $form
            .= '<li><label><input type="checkbox" name="'
            . $name
            . '" id="'
            . $name
            . '" value="withdrawn"'
            . (
            (   @{ $main::search{ $obj->{'id'} }{'stock'} }
                    && grep( $_ eq 'withdrawn',
                    @{ $main::search{ $obj->{'id'} }{'stock'} } )
            ) ? ' checked="checked"' : ''
            )
            . '> '
            . $this->get_option_name( $this->{'withdrawnLabel'}
                || '販売中止' )
            . '</label></li>';
    }
    if ( !$this->{'digitalContentRequired'} ) {
        if ( $default::static || $this->{'stockview'} eq 'menu' ) {
            my $id = 0;
            foreach
                my $availability_name ( @{ $this->{'stockAvailability'} } )
            {
                $form
                    .= '<li><label><input type="checkbox" name="'
                    . $name
                    . '" id="'
                    . $name
                    . '" value="'
                    . $id . '"'
                    . (
                    (   @{ $main::search{ $obj->{'id'} }{'stock'} }
                            && grep( $_ eq $id,
                            @{ $main::search{ $obj->{'id'} }{'stock'} } )
                    ) ? ' checked="checked"' : ''
                    )
                    . '> '
                    . $this->get_option_name($availability_name)
                    . ( ( ref $this->{'sellout'} && $this->{'sellout'}[$id] )
                    ? '(受注停止)'
                    : '' )
                    . '</label></li>';
                $id++;
            }
        }
        elsif ( $this->{'stockview'} eq 'sync' ) {
            $form
                .= '<li><label><input type="checkbox" name="'
                . $name
                . '" id="'
                . $name
                . '" value="abundant"'
                . (
                (   @{ $main::search{ $obj->{'id'} }{'stock'} }
                        && grep( $_ eq 'abundant',
                        @{ $main::search{ $obj->{'id'} }{'stock'} } )
                ) ? ' checked="checked"' : ''
                )
                . '> '
                . $this->get_option_name(
                $this->stock_label(
                    $this->{'abundantName'},
                    (          $this->{'inStockBounds'}
                            || $this->{'limitedAvailabilityBounds'}
                            || $this->{'outOfStockBounds'}
                            || 0
                        )
                        . $this->{'stockunit'}
                        . 'より多い'
                    )
                    || '在庫潤沢'
                ) . '</label></li>';
            $form
                .= '<li><label><input type="checkbox" name="'
                . $name
                . '" id="'
                . $name
                . '" value="in_stock"'
                . (
                (   @{ $main::search{ $obj->{'id'} }{'stock'} }
                        && grep( $_ eq 'in_stock',
                        @{ $main::search{ $obj->{'id'} }{'stock'} } )
                ) ? ' checked="checked"' : ''
                )
                . '> '
                . $this->get_option_name(
                $this->stock_label(
                    $this->{'inStockName'},
                    (          $this->{'limitedAvailabilityBounds'}
                            || $this->{'outOfStockBounds'}
                            || 0
                        )
                        . $this->{'stockunit'} . '〜'
                        . $this->{'inStockBounds'}
                        . $this->{'stockunit'}
                    )
                    || '在庫通常'
                )
                . '</label></li>'
                if $this->{'inStockBounds'};
            $form
                .= '<li><label><input type="checkbox" name="'
                . $name
                . '" id="'
                . $name
                . '" value="limited"'
                . (
                (   @{ $main::search{ $obj->{'id'} }{'stock'} }
                        && grep( $_ eq 'limited',
                        @{ $main::search{ $obj->{'id'} }{'stock'} } )
                ) ? ' checked="checked"' : ''
                )
                . '> '
                . $this->get_option_name(
                $this->stock_label(
                    $this->{'limitedAvailabilityName'},
                    $this->{'outOfStockBounds'}
                        . $this->{'stockunit'} . '〜'
                        . $this->{'limitedAvailabilityBounds'}
                        . $this->{'stockunit'}
                    )
                    || '在庫僅少'
                )
                . '</label></li>'
                if $this->{'limitedAvailabilityBounds'};
            $form
                .= '<li><label><input type="checkbox" name="'
                . $name
                . '" id="'
                . $name
                . '" value="out_of_stock"'
                . (
                (   @{ $main::search{ $obj->{'id'} }{'stock'} }
                        && grep( $_ eq 'out_of_stock',
                        @{ $main::search{ $obj->{'id'} }{'stock'} } )
                ) ? ' checked="checked"' : ''
                )
                . '> '
                . $this->get_option_name(
                $this->stock_label(
                    $this->{'outOfStockName'},
                    $this->{'outOfStockBounds'}
                        . $this->{'stockunit'}
                        . '以下'
                    )
                    || '受注停止'
                ) . '</label></li>';
        }
    }
    return ($form) ? '<ol class="checkbox">' . $form . '</ol>' : '';
}

######################################################################
#	sample
sub sample ($$) {
    my ( $this, $str ) = @_;
    return ( defined $str && $str =~ s/^([0-9]*)\x0A// ) ? $1 : '';
}

######################################################################
#sub import {
BEGIN {
    no warnings qw(once);
    if (   $env::checkout
        && -e $env::checkout
        && !$setting::field_for_mail
        && ( !defined $default::type || $default::type eq '' ) )
    {
        $setting::deco_dir{'cart'}  = '900:カートに入れる ボタン';
        $setting::deco_type{'cart'} = 'button';

        #	$setting::deco_dir{'login'} = '901:ログインボタン画像';
        #	$setting::deco_type{'login'} = 'button';
        #	$setting::deco_dir{'logout'} = '902:ログアウトボタン画像';
        #	$setting::deco_type{'logout'} = 'button';
        $setting::deco_dir{'check'}   = '903:カートを見る ボタン';
        $setting::deco_type{'check'}  = 'button';
        $setting::deco_dir{'submit'}  = '送信 ボタン';
        $setting::deco_type{'submit'} = 'button';
        push( @field::redundancy_forbidden, 'ysc_cart' );
    }
}

1;
