package Span;
require CMONOS::CGI_Lib::Field::Date;
@ISA = qw(Date);
use strict;
use utf8;
######################################################################
# フィールド定義モジュール（期間）
# Span.pm 1.1.7
# Copyright (C) 1999-2018 CMONOS Co. Ltd.
#
# support@cmonos.jp
# http://cmonos.jp/
# 最終更新日：2011-06-03
######################################################################
#	(1) obj->match(str);
sub match ($;$) {
    no warnings qw(numeric);
    my ( $this, $str ) = @_;
    return 0 if !ref $str || $$str eq '';
    my ( $p, $from, $to );
    $this->get_search_patterns if !ref $this->{'pattern'};
    return 1 if @{ $this->{'pattern'} } == 0;
    ( $from, $to )
        = ( $$str !~ / - / && !$this->is_nan($$str) )
        ? ( $$str, $$str )
        : split( / \- /, $$str );
    return 0
        if ( !defined $from || $from eq '' ) && ( !defined $to || $to eq '' );

    foreach $p ( @{ $this->{'pattern'} } ) {
        next if !defined $p || $p eq '';
        if ( $p =~ /^(.*?)\-(.*)$/ ) {
            my ( $f, $t ) = ( $1, $2 );
            if ((   (      !defined $f
                        || $f eq ''
                        || ( defined $from && $from ne '' && $f <= $from )
                    )
                    && (   !defined $t
                        || $t eq ''
                        || ( defined $to && $to ne '' && $to <= $t ) )
                )
                || (!$main::search{ $this->{'id'} }{'o'}
                    && ((   (      !defined $f
                                || $f eq ''
                                || (   defined $from
                                    && $from ne ''
                                    && $f <= $from )
                            )
                            && (   !defined $t
                                || $t eq ''
                                || (   defined $from
                                    && $from ne ''
                                    && $from < $t )
                            )
                        )
                        || ((      !defined $f
                                || $f eq ''
                                || ( defined $to && $to ne '' && $f < $to )
                            )
                            && (   !defined $t
                                || $t eq ''
                                || ( defined $to && $to ne '' && $to <= $t ) )
                        )
                        || ((      defined $f
                                && $f ne ''
                                && defined $from
                                && $from ne ''
                                && $from <= $f
                            )
                            && (   defined $t
                                && $t ne ''
                                && defined $to
                                && $to ne ''
                                && $t <= $to )
                        )
                    )
                )
                )
            {
                return 1
                    if !defined $main::search{ $this->{'id'} }{'mode'}
                    || $main::search{ $this->{'id'} }{'mode'} ne 'and';
            }
            elsif ( defined $main::search{ $this->{'id'} }{'mode'}
                && $main::search{ $this->{'id'} }{'mode'} eq 'and' )
            {
                return 0;
            }
        }
        elsif (!$this->is_nan($p)
            && defined $from
            && $from ne ''
            && $from <= $p
            && defined $to
            && $to ne ''
            && $p <= $to )
        {
            return 1
                if !defined $main::search{ $this->{'id'} }{'mode'}
                || $main::search{ $this->{'id'} }{'mode'} ne 'and';
        }
        elsif ( defined $main::search{ $this->{'id'} }{'mode'}
            && $main::search{ $this->{'id'} }{'mode'} eq 'and' )
        {
            return 0;
        }
    }
    if ( defined $main::search{ $this->{'id'} }{'mode'}
        && $main::search{ $this->{'id'} }{'mode'} eq 'and' )
    {
        return 1;
    }
    else {
        return 0;
    }
}

######################################################################
#	(2) obj->form;
sub form {
    my ( $this, $status ) = @_;
    my ($form);

    #フィールドネーム+ヘッダ
    $form = $this->field_header;

    #デフォルト作成
    if (   ( !defined $status || $status eq '' )
        && !defined $main::data{ $this->{'id'} }{'fy'}
        && !defined $main::data{ $this->{'id'} }{'str'}
        && !$main::data{ $this->{'id'} }{'fsec'}
        && !$main::data{ $this->{'id'} }{'fmin'}
        && !$main::data{ $this->{'id'} }{'fh'}
        && !$main::data{ $this->{'id'} }{'fd'}
        && !$main::data{ $this->{'id'} }{'fmon'}
        && !$main::data{ $this->{'id'} }{'fy'}
        && !$main::data{ $this->{'id'} }{'tsec'}
        && !$main::data{ $this->{'id'} }{'tmin'}
        && !$main::data{ $this->{'id'} }{'th'}
        && !$main::data{ $this->{'id'} }{'td'}
        && !$main::data{ $this->{'id'} }{'tmon'}
        && !$main::data{ $this->{'id'} }{'ty'} )
    {
        if ( defined $this->{'presentTime'} && $this->{'presentTime'} ) {
            my ( $f, $t ) = $this->get_present_span;
            (   $main::data{ $this->{'id'} }{'fsec'},
                $main::data{ $this->{'id'} }{'fmin'},
                $main::data{ $this->{'id'} }{'fh'},
                $main::data{ $this->{'id'} }{'fd'},
                $main::data{ $this->{'id'} }{'fmon'},
                $main::data{ $this->{'id'} }{'fy'}
            ) = localtime($f);
            $main::data{ $this->{'id'} }{'fy'} += 1900;
            $main::data{ $this->{'id'} }{'fmon'}++;
            (   $main::data{ $this->{'id'} }{'tsec'},
                $main::data{ $this->{'id'} }{'tmin'},
                $main::data{ $this->{'id'} }{'th'},
                $main::data{ $this->{'id'} }{'td'},
                $main::data{ $this->{'id'} }{'tmon'},
                $main::data{ $this->{'id'} }{'ty'}
            ) = localtime($t);
            $main::data{ $this->{'id'} }{'ty'} += 1900;
            $main::data{ $this->{'id'} }{'tmon'}++;
        }
        else {
            $main::data{ $this->{'id'} }{'fsec'} = $this->{'defaultfsec'};
            $main::data{ $this->{'id'} }{'fmin'} = $this->{'defaultfmin'};
            $main::data{ $this->{'id'} }{'fh'}   = $this->{'defaultfh'};
            $main::data{ $this->{'id'} }{'fd'}   = $this->{'defaultfd'};
            $main::data{ $this->{'id'} }{'fmon'} = $this->{'defaultfmon'};
            $main::data{ $this->{'id'} }{'fy'}   = $this->{'defaultfy'};
            $main::data{ $this->{'id'} }{'tsec'} = $this->{'defaulttsec'};
            $main::data{ $this->{'id'} }{'tmin'} = $this->{'defaulttmin'};
            $main::data{ $this->{'id'} }{'th'}   = $this->{'defaultth'};
            $main::data{ $this->{'id'} }{'td'}   = $this->{'defaulttd'};
            $main::data{ $this->{'id'} }{'tmon'} = $this->{'defaulttmon'};
            $main::data{ $this->{'id'} }{'ty'}   = $this->{'defaultty'};
        }
    }
    elsif ( $main::data{ $this->{'id'} }{'str'} ) {
        $this->resolve_into_values( \$main::data{ $this->{'id'} }{'str'} );
    }

    $form .= '<div class="sub-field">';
    $form .= '<span class="unit">From </span>'
        if defined $default::english && $default::english;
    $form .= $this->input_form( 'data', 'f', '', 1 );
    $form .= '<span class="unit">から</span>'
        if !defined $default::english || !$default::english;
    $form .= '</div><div class="sub-field">';
    $form .= ' <span class="unit">To </span>'
        if defined $default::english && $default::english;
    $form .= $this->input_form( 'data', 't', '', 1 );
    $form .= '<span class="unit">まで</span>'
        if !defined $default::english || !$default::english;
    $form
        .= $this->date_reset_tool( 'data:' . $this->{'id'} . ':', 'f', 't' );
    $form .= '</div>';

    $form .= $this->field_footer;
    return $form;
}

sub get_present_span ($) {
    my $this = shift;
    my ( $start, $end ) = $this->get_datetime_bounds;
    my $gap
        = ( $this->{'minLength'} )
        ? $this->timeunit_to_sec( $this->{'minLength'},
        $this->{'minLengthUnit'} )
        : 3600;
    my $f = time;
    my $t = $f + $gap;
    if ( $end && $end < $t ) {
        if (   $this->{'boundsEndType'}
            && $this->{'boundsEndType'} eq 'rel'
            && $this->{'hourStart'}
            && (   $this->{'boundsEndUnit'} eq 'week'
                || $this->{'boundsEndUnit'} eq 'day' )
            )
        {
            $end = $end - 86400
                + ( ( $this->{'hourEnd'} ) ? $this->{'hourEnd'} * 3600 : 0 );
        }
        $t = $end;
        $f = $end - $gap;
    }
    if ( $start && $start > $f ) {
        if (   $this->{'boundsStartType'}
            && $this->{'boundsStartType'} eq 'rel'
            && $this->{'hourStart'}
            && (   $this->{'boundsStartUnit'} eq 'week'
                || $this->{'boundsStartUnit'} eq 'day' )
            )
        {
            $start += $this->{'hourStart'} * 3600;
        }
        $f = $start;
        $t = $start + $gap;
    }
    return ( $f, $t );
}

sub resolve_into_values ($$) {
    my ( $this, $str ) = @_;
    return if !$$str;
    if ( $$str
        =~ m!^([0-9]{0,4})([0-9]{0,2})([0-9]{0,2})([0-9]{0,2})([0-9]{0,2})([0-9]{0,2}) \- ([0-9]{0,4})([0-9]{0,2})([0-9]{0,2})([0-9]{0,2})([0-9]{0,2})([0-9]{0,2})!
        )
    {
        $main::data{ $this->{'id'} }{'fsec'} = $6;
        $main::data{ $this->{'id'} }{'fmin'} = $5;
        $main::data{ $this->{'id'} }{'fh'}   = $4;
        $main::data{ $this->{'id'} }{'fd'}   = $3;
        $main::data{ $this->{'id'} }{'fmon'} = $2;
        $main::data{ $this->{'id'} }{'fy'}   = $1;
        $main::data{ $this->{'id'} }{'tsec'} = $12;
        $main::data{ $this->{'id'} }{'tmin'} = $11;
        $main::data{ $this->{'id'} }{'th'}   = $10;
        $main::data{ $this->{'id'} }{'td'}   = $9;
        $main::data{ $this->{'id'} }{'tmon'} = $8;
        $main::data{ $this->{'id'} }{'ty'}   = $7;
    }
    elsif ( $$str
        =~ m!^([0-9]{0,4})([0-9]{0,2})([0-9]{0,2})([0-9]{0,2})([0-9]{0,2})([0-9]{0,2})!
        )
    {
        $main::data{ $this->{'id'} }{'fsec'} = $6;
        $main::data{ $this->{'id'} }{'fmin'} = $5;
        $main::data{ $this->{'id'} }{'fh'}   = $4;
        $main::data{ $this->{'id'} }{'fd'}   = $3;
        $main::data{ $this->{'id'} }{'fmon'} = $2;
        $main::data{ $this->{'id'} }{'fy'}   = $1;
        $main::data{ $this->{'id'} }{'tsec'} = $6;
        $main::data{ $this->{'id'} }{'tmin'} = $5;
        $main::data{ $this->{'id'} }{'th'}   = $4;
        $main::data{ $this->{'id'} }{'td'}   = $3;
        $main::data{ $this->{'id'} }{'tmon'} = $2;
        $main::data{ $this->{'id'} }{'ty'}   = $1;
    }
}

######################################################################
#	(3) obj->is_valid_data(path);
sub is_valid_data ($;$) {
    my $this = shift;
    delete $this->{'is_invalid_field'} if ref $this->{'is_invalid_field'};
    my ( $is_valid, $is_valid_f, $inputf, $is_valid_t, $inputt );

    $this->resolve_into_values( \$main::data{ $this->{'id'} }{'str'} )
        if defined $main::data{ $this->{'id'} }{'str'}
        && $main::data{ $this->{'id'} }{'str'};

    ( $is_valid_f, $inputf ) = $this->is_valid_date( 'f', '開始日時' );
    ( $is_valid_t, $inputt ) = $this->is_valid_date( 't', '終了日時' );
    $is_valid = 1 if $is_valid_f && $is_valid_t;

    if (   $is_valid
        && $inputf
        && $inputt
        && ( $this->{'minLength'} || $this->{'maxLength'} ) )
    {
        my $se_gap = $this->data_to_datetime(
            $main::data{ $this->{'id'} }{'tsec'},
            $main::data{ $this->{'id'} }{'tmin'},
            $main::data{ $this->{'id'} }{'th'},
            $main::data{ $this->{'id'} }{'td'},
            $main::data{ $this->{'id'} }{'tmon'},
            $main::data{ $this->{'id'} }{'ty'}
            ) - $this->data_to_datetime(
            $main::data{ $this->{'id'} }{'fsec'},
            $main::data{ $this->{'id'} }{'fmin'},
            $main::data{ $this->{'id'} }{'fh'},
            $main::data{ $this->{'id'} }{'fd'},
            $main::data{ $this->{'id'} }{'fmon'},
            $main::data{ $this->{'id'} }{'fy'}
            );
        if ($this->{'minLength'}
            && $this->timeunit_to_sec( $this->{'minLength'},
                $this->{'minLengthUnit'} ) > $se_gap
            )
        {
            push(
                @{ $cgi::action->{'dialog'} },
                ( ( defined $this->{'name'} ) ? $this->{'name'} : '入力' )
                    . 'を確認してください。開始から終了までを'
                    . $this->{'minLength'}
                    . $this->timeunit_to_japanese( $this->{'minLengthUnit'} )
                    . '以上にしてください。'
            ) if ref $cgi::action;
            $this->{'is_invalid_field'}{$_} = 1 foreach (
                'fsec', 'fmin', 'fh', 'fd', 'fmon', 'fy',
                'tsec', 'tmin', 'th', 'td', 'tmon', 'ty'
            );
            $is_valid = 0;
        }
        elsif (
            $this->{'maxLength'}
            && $this->timeunit_to_sec( $this->{'maxLength'},
                $this->{'maxLengthUnit'} ) < $se_gap
            )
        {
            push(
                @{ $cgi::action->{'dialog'} },
                ( ( defined $this->{'name'} ) ? $this->{'name'} : '入力' )
                    . 'を確認してください。開始から終了までを'
                    . $this->{'maxLength'}
                    . $this->timeunit_to_japanese( $this->{'maxLengthUnit'} )
                    . '以下にしてください。'
            ) if ref $cgi::action;
            $this->{'is_invalid_field'}{$_} = 1 foreach (
                'fsec', 'fmin', 'fh', 'fd', 'fmon', 'fy',
                'tsec', 'tmin', 'th', 'td', 'tmon', 'ty'
            );
            $is_valid = 0;
        }
    }

    #必須項目チェック
    if ( $this->{'required'} && !$inputf && !$inputt ) {
        push(
            @{ $cgi::action->{'dialog'} },
            (   ( defined $this->{'name'} && $this->{'name'} )
                ? $this->{'name'} . 'が'
                : ''
                )
                . '入力されていません。'
        ) if ref $cgi::action;
        if ( !$inputf ) {
            foreach ( 'fsec', 'fmin', 'fh', 'fd', 'fmon', 'fy' ) {
                $this->{'is_invalid_field'}{$_} = 1
                    if !defined $main::data{ $this->{'id'} }{$_}
                    || $main::data{ $this->{'id'} }{$_} eq '';
            }
        }
        if ( !$inputt ) {
            foreach ( 'tsec', 'tmin', 'th', 'td', 'tmon', 'ty' ) {
                $this->{'is_invalid_field'}{$_} = 1
                    if !defined $main::data{ $this->{'id'} }{$_}
                    || $main::data{ $this->{'id'} }{$_} eq '';
            }
        }
        $is_valid = 0;

        #データ整形
    }
    elsif ( $is_valid && $inputf == 0 && $inputt == 0 ) {
        $main::data{ $this->{'id'} }{'str'} = '';
    }
    elsif ($is_valid) {
        my $from = '';
        my $to   = '';
        if ( defined $inputf && $inputf ) {
            $from = $this->date_cat(
                $main::data{ $this->{'id'} }{'fsec'},
                $main::data{ $this->{'id'} }{'fmin'},
                $main::data{ $this->{'id'} }{'fh'},
                $main::data{ $this->{'id'} }{'fd'},
                $main::data{ $this->{'id'} }{'fmon'},
                $main::data{ $this->{'id'} }{'fy'}
            );
        }
        if ( defined $inputt && $inputt ) {
            $to = $this->date_cat(
                $main::data{ $this->{'id'} }{'tsec'},
                $main::data{ $this->{'id'} }{'tmin'},
                $main::data{ $this->{'id'} }{'th'},
                $main::data{ $this->{'id'} }{'td'},
                $main::data{ $this->{'id'} }{'tmon'},
                $main::data{ $this->{'id'} }{'ty'}
            );
        }
        if ( $from && $to && $from > $to ) {
            push(
                @{ $cgi::action->{'dialog'} },
                (   ( defined $this->{'name'} && $this->{'name'} )
                    ? $this->{'name'} . 'を'
                    : ''
                    )
                    . '確認してください。開始日時より終了日時が先になっています。'
            ) if ref $cgi::action;
            $this->{'is_invalid_field'}{$_} = 1 foreach (
                'fsec', 'fmin', 'fh', 'fd', 'fmon', 'fy',
                'tsec', 'tmin', 'th', 'td', 'tmon', 'ty'
            );
            $is_valid = 0;
        }
        else {
            $main::data{ $this->{'id'} }{'str'} = $from . ' - ' . $to;
            $cookie::data{ 'data:' . $this->{'id'} . ':str' }
                = $main::data{ $this->{'id'} }{'str'}
                if $this->{'cookie'} && $main::set_cookie;
        }
    }

    return $is_valid;
}

######################################################################
#	(4) obj->usual_format(str);
sub usual_format {
    my ( $this, $str ) = @_;
    $str = $$str{'str'} if ref $str eq 'HASH';
    return $this->field_tag('') if !defined $str || $str !~ /[0-9]/;
    return $this->field_tag(
        $this->data_tag_from_hash( 'str', $str )
            . $this->style(
            $this->nobr_date( $this->span($str) ), $this->{'style'},
            $this->{'fontsize'},                   $this->{'fontcolor'},
            $this->{'fontface'}
            )
    );
}

sub span ($$;$$) {
    my ( $this, $span, $limit, $for_text ) = @_;
    return '' if !defined $span || $span eq '';
    my ( $from, $to )
        = ( $span !~ / - / && !$this->is_nan($span) )
        ? ( $span, $span )
        : split( / \- /, $span );
    if ( defined $from && defined $to && $from eq $to ) {
        return $this->field_date( $from, $limit );
    }
    else {
        return (
            ( defined $from && $from )
            ? $this->field_date( $from, $limit,
                ( ( !$for_text ) ? 'startDate' : '' ) )
            : ''
            )
            . ( ($default::english) ? ' - ' : '〜' )
            . (
            ( defined $to && $to )
            ? $this->field_date( $to, $limit,
                ( ( !$for_text ) ? 'endDate' : '' ) )
            : ''
            );
    }
}

sub has_content {
    my ( $this, $str ) = @_;
    $str = $$str{'str'} if ref $str eq 'HASH';
    return ( defined $str && $str ne '' && $str =~ /[0-9]/ ) ? 1 : 0;
}

#---------------------------------------------------------------------
#	(4) obj->format_for_mail(str);
sub format_for_mail {
    my ( $this, $str ) = @_;
    $str = $$str{'str'} if ref $str eq 'HASH';
    return '' if !defined $str || $str eq '';
    return
          '['
        . $this->name . "]\x0A"
        . $this->span( $str, 0, 1 )
        . "\x0A\x0A";
}

#	(4)-3 obj->format_for_text(str);
sub format_for_text {
    my ( $this, $str ) = @_;
    $str = $$str{'str'} if ref $str eq 'HASH';
    return '' if !defined $str || $str eq '';
    return $this->span( $str, 0, 1 );
}

######################################################################
#	(5) obj->print_setting_form;
sub print_setting_form ($) {
    my ( $this, $html_disabled ) = @_;

    #名前
    my $name = 'data:' . $this->{'id'};

    #デフォルト
    $this->{'inputLimit'} = '0' if !$this->{'inputLimit'};

    $this->print_field_info_form($name);

    print '<fieldset>';
    print '<legend>入力欄設定</legend>';
    print '<table class="field-table">';
    print '<tbody>';
    print '<tr>';
    print
        '<td class="field-name"><span class="datatitle">入力範囲</span></td>';
    print '<td class="field"><label><span class="unit">年〜</span>';
    print $this->mk_select_menu(
        $name . '_inputLimit', '', '', $this->{'inputLimit'},
        '-2' => '年',
        '-1' => '月',
        '0'  => '日',
        '1'  => '時',
        '2'  => '分',
        '3'  => '秒'
    );
    print '</label>';
    print '</td>';
    print '</tr>';
    print '<tr>';
    print
        '<td class="field-name"><span class="datatitle">「年」選択範囲</span></td>';
    print '<td class="field">';
    print '<label><input type="number" size="4" maxlength="4" name="'
        . $name
        . '_yearStart" value="'
        . $this->escape( $this->{'yearStart'} )
        . '" /><span class="unit">年〜</span></label>';
    print '<label><input type="number" size="4" maxlength="4" name="'
        . $name
        . '_yearEnd" value="'
        . $this->escape( $this->{'yearEnd'} )
        . '" /><span class="unit">年</span></label>';
    print '</td>';
    print '</tr>';
    print '<tr>';
    print
        '<td class="field-name"><span class="datatitle">「時」指定範囲</span></td>';
    print '<td class="field">';
    print '<label><select name="'
        . $name
        . '_hourStart" id="'
        . $name
        . '_hourStart">';
    print '<option value=""></option>';

    foreach my $hour ( 0 .. 23 ) {
        print '<option value="'
            . $hour . '"'
            . (
            (          defined $this->{'hourStart'}
                    && $this->{'hourStart'} ne ''
                    && $hour == $this->{'hourStart'}
            ) ? ' selected="selected"' : ''
            )
            . '>'
            . $hour
            . '</option>';
    }
    print '</select>時</label>〜';
    print '<label><select name="'
        . $name
        . '_hourEnd" id="'
        . $name
        . '_hourEnd">';
    print '<option value=""></option>';
    foreach my $hour ( 0 .. 23 ) {
        print '<option value="'
            . $hour . '"'
            . (
            (          defined $this->{'hourEnd'}
                    && $this->{'hourEnd'} ne ''
                    && $hour == $this->{'hourEnd'}
            ) ? ' selected="selected"' : ''
            )
            . '>'
            . $hour
            . '</option>';
    }
    print '</select>時</label>';
    print '</td>';
    print '</tr>';
    print '<tr>';
    print '<td class="field-name"><label for="' . $name
        . '_minScale">「分/秒」指定</label></td>';
    print '<td class="field">';
    print $this->mk_select_menu(
        $name . '_minScale', '', '', $this->{'minScale'},
        ''   => '1分/秒きざみ',
        '5'  => '5分/秒きざみ',
        '10' => '10分/秒きざみ',
        '15' => '15分/秒きざみ',
        '20' => '20分/秒きざみ',
        '30' => '30分/秒きざみ',
    );
    print '</td>';
    print '</tr>';
    print '<tr>';
    print '<td class="field-name"><label for="' . $name
        . '_datetype">表示形式</label></td>';
    print '<td class="field">';
    $this->print_date_type_menu( $name . '_',
        $this->{'datetype'}, '', '', 1, $this->{'dateformat'} );
    print '</td></tr>';

    if ( !defined $default::static || !$default::static ) {
        print '<tr>';
        print
            '<td class="field-name"><span class="datatitle">日時の表示</span></td>';
        print
            '<td class="field"><label><input type="number" size="3" maxlength="3" name="'
            . $name
            . '_datelimit" value="'
            . $this->escape( $this->{'datelimit'} )
            . '" /> 日以内なら相対日時で表現する（きょう/きのう/○日前）</label></td>';
        print '</tr>';
    }
    print '</tbody></table>';
    print '</fieldset>';
    print '<fieldset>';
    print '<legend>デフォルト</legend>';
    print '<div class="sub-field">';
    print '<span class="unit">From </span>'
        if defined $default::english && $default::english;
    print $this->input_form( 'data', 'defaultf', 1 );
    print '<span class="unit">から</span>'
        if !defined $default::english || !$default::english;
    print '</div><div class="sub-field">';
    print ' <span class="unit">To </span>'
        if defined $default::english && $default::english;
    print $this->input_form( 'data', 'defaultt', 1 );
    print '<span class="unit">まで</span>'
        if !defined $default::english || !$default::english;
    print $this->date_reset_tool( 'data:' . $this->{'id'} . '_',
        'defaultf', 'defaultt' );
    print '</div>';
    print '<div class="extra-field"><label><input type="checkbox" name="'
        . $name
        . '_presentTime" value="1"'
        . ( ( defined $this->{'presentTime'} && $this->{'presentTime'} )
        ? ' checked="checked"'
        : '' )
        . ' /> 書き込み時間を初期値にする</label></div>';
    print '</fieldset>';
    $this->print_validate_settings($name);

    if ( !defined $html_disabled || !$html_disabled ) {

        #検索オプション
        $this->print_search_option_settings($name);

        #文字設定
        $this->print_font_setting_form($name);
    }

    $this->print_setting_save_button;
    return;
}

sub _print_validate_settings ($$) {
    my ( $this, $name ) = @_;
    print '<fieldset><legend>期間の長さ</legend>';
    print '<input type="number" size="3" maxlength="3" name="'
        . $name
        . '_minLength" value="'
        . $this->escape( $this->{'minLength'} ) . '" />';
    print $this->mk_select_menu(
        $name . '_minLengthUnit', '', '',
        ( $this->{'minLengthUnit'} || 'min' ),
        'min'   => '分',
        'hour'  => '時間',
        'day'   => '日',
        'week'  => '週',
        'month' => 'ヶ月',
        'year'  => '年',
    );
    print '以上 <input type="number" size="3" maxlength="3" name="'
        . $name
        . '_maxLength" value="'
        . $this->escape( $this->{'maxLength'} ) . '" />';
    print $this->mk_select_menu(
        $name . '_maxLengthUnit', '', '',
        ( $this->{'maxLengthUnit'} || 'min' ),
        'min'   => '分',
        'hour'  => '時間',
        'day'   => '日',
        'week'  => '週',
        'month' => 'ヶ月',
        'year'  => '年',
    );
    print '以下';
    print '</fieldset>';
    return;
}

######################################################################
#	(6) obj->is_valid_setting;
sub is_valid_setting ($) {
    my $this     = shift;
    my $is_valid = $this->is_valid_date_setting;

    #数字チェック
    if ((      defined $main::data{ $this->{'id'} . '_defaultfy' }
            && $main::data{ $this->{'id'} . '_defaultfy' } ne ''
            && $this->is_nan( $main::data{ $this->{'id'} . '_defaultfy' } )
        )
        || (   defined $main::data{ $this->{'id'} . '_defaultty' }
            && $main::data{ $this->{'id'} . '_defaultty' } ne ''
            && $this->is_nan( $main::data{ $this->{'id'} . '_defaultty' } ) )
        )
    {
        push(
            @{ $cgi::action->{'dialog'} },
            'デフォルトを更新できませんでした。半角数字にしてください。'
        ) if ref $cgi::action;
        delete $main::data{ $this->{'id'} . '_defaultfy' };
        delete $main::data{ $this->{'id'} . '_defaultty' };
        $is_valid = 0;
    }

    #日付チェック
    if ((      $main::data{ $this->{'id'} . '_defaultfy' }
            && $main::data{ $this->{'id'} . '_defaultfmon' }
            && $main::data{ $this->{'id'} . '_defaultfd' }
            && $this->is_impossible_mday(
                $main::data{ $this->{'id'} . '_defaultfy' },
                $main::data{ $this->{'id'} . '_defaultfmon' },
                $main::data{ $this->{'id'} . '_defaultfd' }
            )
        )
        || (   $main::data{ $this->{'id'} . '_defaultty' }
            && $main::data{ $this->{'id'} . '_defaulttmon' }
            && $main::data{ $this->{'id'} . '_defaulttd' }
            && $this->is_impossible_mday(
                $main::data{ $this->{'id'} . '_defaultty' },
                $main::data{ $this->{'id'} . '_defaulttmon' },
                $main::data{ $this->{'id'} . '_defaulttd' }
            )
        )
        )
    {
        push(
            @{ $cgi::action->{'dialog'} },
            'デフォルトを更新できませんでした。存在しない日付です。'
        ) if ref $cgi::action;
        delete $main::data{ $this->{'id'} . '_defaultfy' };
        delete $main::data{ $this->{'id'} . '_defaultfmon' };
        delete $main::data{ $this->{'id'} . '_defaultfd' };
        delete $main::data{ $this->{'id'} . '_defaultty' };
        delete $main::data{ $this->{'id'} . '_defaulttmon' };
        delete $main::data{ $this->{'id'} . '_defaulttd' };
        $is_valid = 0;
    }

    if (   defined $main::data{ $this->{'id'} . '_minLength' }
        && $main::data{ $this->{'id'} . '_minLength' } ne ''
        && $this->is_nan( $main::data{ $this->{'id'} . '_minLength' } ) )
    {
        push(
            @{ $cgi::action->{'dialog'} },
            '設定範囲の最短時間を更新できませんでした。半角数字にしてください。'
        ) if ref $cgi::action;
        delete $main::data{ $this->{'id'} . '_minLength' };
        $is_valid = 0;
    }
    if (   defined $main::data{ $this->{'id'} . '_maxLength' }
        && $main::data{ $this->{'id'} . '_maxLength' } ne ''
        && $this->is_nan( $main::data{ $this->{'id'} . '_maxLength' } ) )
    {
        push(
            @{ $cgi::action->{'dialog'} },
            '設定範囲の最長時間を更新できませんでした。半角数字にしてください。'
        ) if ref $cgi::action;
        delete $main::data{ $this->{'id'} . '_maxLength' };
        $is_valid = 0;
    }
    my $min = $this->timeunit_to_sec(
        $main::data{ $this->{'id'} . '_minLength' },
        $main::data{ $this->{'id'} . '_minLengthUnit' }
    );
    my $max = $this->timeunit_to_sec(
        $main::data{ $this->{'id'} . '_maxLength' },
        $main::data{ $this->{'id'} . '_maxLengthUnit' }
    );
    $main::data{ $this->{'id'} . '_minLengthUnit' } = 'min'
        if !$main::data{ $this->{'id'} . '_minLengthUnit' };
    $main::data{ $this->{'id'} . '_maxLengthUnit' } = 'max'
        if !$main::data{ $this->{'id'} . '_maxLengthUnit' };
    if ( $min && $max && $min > $max ) {
        push(
            @{ $cgi::action->{'dialog'} },
            'イベントの長さの設定範囲を確認してください。最短時間が最長時間より長くなっています。'
        ) if ref $cgi::action;
        delete $main::data{ $this->{'id'} . '_minLength' };
        delete $main::data{ $this->{'id'} . '_minLengthUnit' };
        delete $main::data{ $this->{'id'} . '_maxLength' };
        delete $main::data{ $this->{'id'} . '_maxLengthUnit' };
    }
    return $is_valid;
}

######################################################################
#	(7) obj->search_form;
sub additional_search_form ($) {
    my $this = shift;
    return
        '<div class="extra-field"><label><input type="checkbox" name="search:'
        . $this->{'id'}
        . ':o" value="1"'
        . (
        (   defined $main::search{ $this->{'id'} }{'o'}
                && $main::search{ $this->{'id'} }{'o'}
        ) ? ' checked="checked"' : ''
        )
        . ' /> '
        . ( ($default::english)
        ? 'Strictly.'
        : '条件に重ならない期間を許容しない' )
        . '</label></div>';
}

######################################################################
#sub import {
BEGIN {
    Field::class_register( 'time_span', 'Span', '期間' );
}

1;
