package Tategaki;
require CMONOS::CGI_Lib::Field;
@ISA = qw(Field);
use strict;
use utf8;
######################################################################
# フィールド定義モジュール（縦書き）
# Tategaki.pm 1.0
# Copyright (C) 1999-2018 CMONOS Co. Ltd.
#
# support@cmonos.jp
# http://cmonos.jp/
# 最終更新日：2010-04-27
######################################################################
sub __set ($$) {
    my ( $this, $setting ) = @_;
    return;
}

######################################################################
#	(4) obj->usual_format(str);
sub usual_format {
    my ( $this, $str, $path, $c, $n ) = @_;
    $str = $$str{'str'} if ref $str eq 'HASH';
    return $this->field_tag($str) if !defined $str || $str eq '';

    my ( $tate, $fontcolor, $id );
    $id
        = ( $this->{'toggle'} )
        ? 'tategaki' . $this->_mk_user_generated_field_id( $c, $n )
        : '';
    $fontcolor = $this->text_color( \$str );
    $this->text_conv( \$str );
    $this->text_fix( \$str, $this->{'csv'},
        ( ( !$this->{'rows'} || $this->{'rows'} <= 1 ) ? 1 : 0 ) )
        if defined $str && $str;

    require CMONOS::CGI_Lib::Taketori;
    $tate = Taketori->new(
        {   'css'          => 1,
            'id'           => $id,
            'class'        => 'tategaki',
            'height'       => $this->{'height'},       # 一段高さ
            'fontsize'     => $this->{'basesize'},     # フォントサイズ
            'width'        => $this->{'width'},        # 一段横幅
            'margin'       => $this->{'margin'},       # 行間隔
            'colmargin'    => $this->{'colmargin'},    # 段間隔
            'blockenabled' => $this->{'blockenabled'}, # スクロールする
            'rotatedisabled' => $this->{'rotatedisabled'}
            , # 長音符を横書き長音符の回転で表示せず「｜」で代用する
            'clear' => ( ( $this->{'toggle'} || $this->{'clear'} ) ? 1 : 0 )
            ,    # 文末で回り込み解除
            'ltrnum' => $this->{'ltrnum'},    # 数字は横書きにする
        }
    )->tategaki($str);

    if ( $this->{'toggle'} ) {
        $tate
            .= $this->javascript(
                  'document.write(\'<ul class="panel tools"><li id="'
                . $id
                . '-tate"><a href="javascript:void(0)" onclick="cmonos.element.item(\\\''
                . $id
                . '\\\',\\\''
                . $id
                . '-tate\\\',\\\''
                . $id
                . '-ltr\\\',\\\''
                . $id
                . '-yoko\\\').toggle();">横書きで表示する</a></li><li id="'
                . $id
                . '-yoko"><a href="javascript:void(0)" onclick="cmonos.element.item(\\\''
                . $id
                . '\\\',\\\''
                . $id
                . '-tate\\\',\\\''
                . $id
                . '-ltr\\\',\\\''
                . $id
                . '-yoko\\\').toggle();">縦書きで表示する</a></li></ul>\');'
            );
        $tate
            .= $this->javascript( 'cmonos.element.item(\''
                . $id
                . '-ltr\',\''
                . $id
                . '-yoko\').disappear(true);' );
    }

    return $this->field_tag(
        (   ($fontcolor)
            ? $this->data_tag_from_hash( 'fontcolor', $fontcolor )
            : ''
        )
        . $this->style(
            (   ( $this->{'toggle'} )
                ? '<div id="'
                    . $id
                    . '-ltr" style="display: none">'
                    . $this->data_tag( 'str', $str )
                    . '</div>'
                : $this->data_tag_from_hash( 'str', $str )
            )
            . $tate,
            $this->{'style'},
            $this->{'fontsize'},
            ( ($fontcolor) ? $fontcolor : $this->{'fontcolor'} ),
            $this->{'fontface'},
        )
    );
}

######################################################################
#	(5) obj->print_setting_form;
sub print_sub_setting_form ($$) {
    my ( $this, $name ) = @_;

    print '<fieldset>';
    print '<legend>縦書き設定</legend>';
    print '<table class="field-table">';
    print '<tbody>';
    print '<tr>';
    print '<td class="field-name"><label for="' . $name
        . '_height">一段高さ</label></td>';
    print '<td class="q-field"><input type="number" name="'
        . $name
        . '_height" id="'
        . $name
        . '_height" value="'
        . $this->escape( $this->{'height'} )
        . '" size="3" /> <span class="unit">px</span></td>';
    print '<td class="field-name"><label for="' . $name
        . '_basesize">文字の大きさ</label></td>';
    print '<td class="q-field"><input type="number" name="'
        . $name
        . '_basesize" id="'
        . $name
        . '_basesize" value="'
        . $this->escape( $this->{'basesize'} )
        . '" size="3" /> <span class="unit">px</span></td>';
    print '</tr>';
    print '<tr>';
    print '<td class="field-name"><label for="' . $name
        . '_margin">行間隔</label></td>';
    print '<td class="q-field"><input type="text" name="'
        . $name
        . '_margin" id="'
        . $name
        . '_margin" value="'
        . $this->escape( $this->{'margin'} )
        . '" size="3" /> <span class="unit">px</span></td>';
    print '<td class="field-name"><label for="' . $name
        . '_colmargin">段間隔</label></td>';
    print '<td class="q-field"><input type="text" name="'
        . $name
        . '_colmargin" id="'
        . $name
        . '_colmargin" value="'
        . $this->escape( $this->{'colmargin'} )
        . '" size="3" /> <span class="unit">px</span></td>';
    print '</tr>';
    print '<tr class="tbody-end">';
    print '<td class="field-name"><label for="' . $name
        . '_width">一段横幅</label></td>';
    print '<td class="field" colspan="3"><input type="number" name="'
        . $name
        . '_width" id="'
        . $name
        . '_width" value="'
        . $this->escape( $this->{'width'} )
        . '" size="3" /> <span class="unit">px</span></td>';
    print '</tr>';
    print '</tbody>';
    print '<tbody>';
    print '<tr>';
    print
        '<td class="field-name"><span class="datatitle">縦書きオプション</span></td>';
    print '<td class="field" colspan="3">';
    print '<ol class="checkbox">';
    print '<li><label><input type="checkbox" name="'
        . $name
        . '_rotatedisabled" value="1" '
        . ( ( defined $this->{'rotatedisabled'} && $this->{'rotatedisabled'} )
        ? ' checked="checked"'
        : '' )
        . ' /> 長音符を横書き長音符の回転で表示せず「｜」で代用する</label></li>';
    print '<li><label><input type="checkbox" name="'
        . $name
        . '_ltrnum" value="1" '
        . ( ( defined $this->{'ltrnum'} && $this->{'ltrnum'} )
        ? ' checked="checked"'
        : '' )
        . ' /> 数字は横書きにする</label></li>';
    print '<li><label><input type="checkbox" name="'
        . $name
        . '_clear" value="1" '
        . ( ( defined $this->{'clear'} && $this->{'clear'} )
        ? ' checked="checked"'
        : '' )
        . ' /> 文末で回り込みを解除する</label></li>';
    print '<li><label><input type="checkbox" name="'
        . $name
        . '_toggle" value="1" '
        . ( ( defined $this->{'toggle'} && $this->{'toggle'} )
        ? ' checked="checked"'
        : '' )
        . ' /> 横書き表示と切り替え可能にする</label></li>';
    print '<li><label><input type="checkbox" name="'
        . $name
        . '_blockenabled" value="1" '
        . ( ( defined $this->{'blockenabled'} && $this->{'blockenabled'} )
        ? ' checked="checked"'
        : '' )
        . ' /> すべてのブロック要素を保持する(ブロック要素ごとに改段します)</label></li>';
    print '</ol>';
    print '</td>';
    print '</tr>';
    print '</tbody>';
    print '</table>';
    print '</fieldset>';
}

sub html_editor_panel_type ($) {
    my $this = shift;
    return ( $this->{'nostyle'} ) ? 'nostylemini' : 'mini';
}

######################################################################
#	(6) obj->is_valid_setting;
sub is_valid_sub_setting ($) {
    my $this     = shift;
    my $is_valid = 1;

    #チェックボックス
    $main::data{ $this->{'id'} . '_ltrnum' } = ''
        if !defined $main::data{ $this->{'id'} . '_ltrnum' }
        || !$main::data{ $this->{'id'} . '_ltrnum' };
    $main::data{ $this->{'id'} . '_clear' } = ''
        if !defined $main::data{ $this->{'id'} . '_clear' }
        || !$main::data{ $this->{'id'} . '_clear' };
    $main::data{ $this->{'id'} . '_toggle' } = ''
        if !defined $main::data{ $this->{'id'} . '_toggle' }
        || !$main::data{ $this->{'id'} . '_toggle' };
    $main::data{ $this->{'id'} . '_rotatedisabled' } = ''
        if !defined $main::data{ $this->{'id'} . '_rotatedisabled' }
        || !$main::data{ $this->{'id'} . '_rotatedisabled' };
    $main::data{ $this->{'id'} . '_blockenabled' } = ''
        if !defined $main::data{ $this->{'id'} . '_blockenabled' }
        || !$main::data{ $this->{'id'} . '_blockenabled' };

    #数字
    if (   defined $main::data{ $this->{'id'} . '_basesize' }
        && $main::data{ $this->{'id'} . '_basesize' } ne ''
        && $this->is_nan( $main::data{ $this->{'id'} . '_basesize' } ) )
    {
        push(
            @{ $cgi::action->{'dialog'} },
            '文字の大きさを更新できませんでした。半角数字にしてください。'
        ) if ref $cgi::action;
        delete $main::data{ $this->{'id'} . '_basesize' };
        $is_valid = 0;
    }
    if (   defined $main::data{ $this->{'id'} . '_margin' }
        && $main::data{ $this->{'id'} . '_margin' } ne ''
        && $this->is_nan( $main::data{ $this->{'id'} . '_margin' } ) )
    {
        push(
            @{ $cgi::action->{'dialog'} },
            '行間隔を更新できませんでした。半角数字にしてください。'
        ) if ref $cgi::action;
        delete $main::data{ $this->{'id'} . '_margin' };
        $is_valid = 0;
    }
    if (   defined $main::data{ $this->{'id'} . '_height' }
        && $main::data{ $this->{'id'} . '_height' } ne ''
        && $this->is_nan( $main::data{ $this->{'id'} . '_height' } ) )
    {
        push(
            @{ $cgi::action->{'dialog'} },
            '一段高さを更新できませんでした。半角数字にしてください。'
        ) if ref $cgi::action;
        delete $main::data{ $this->{'id'} . '_height' };
        $is_valid = 0;
    }
    if (   defined $main::data{ $this->{'id'} . '_colmargin' }
        && $main::data{ $this->{'id'} . '_colmargin' } ne ''
        && $this->is_nan( $main::data{ $this->{'id'} . '_colmargin' } ) )
    {
        push(
            @{ $cgi::action->{'dialog'} },
            '段間隔を更新できませんでした。半角数字にしてください。'
        ) if ref $cgi::action;
        delete $main::data{ $this->{'id'} . '_colmargin' };
        $is_valid = 0;
    }
    if (   defined $main::data{ $this->{'id'} . '_width' }
        && $main::data{ $this->{'id'} . '_width' } ne ''
        && $this->is_nan( $main::data{ $this->{'id'} . '_width' } ) )
    {
        push(
            @{ $cgi::action->{'dialog'} },
            '横幅を更新できませんでした。半角数字にしてください。'
        ) if ref $cgi::action;
        delete $main::data{ $this->{'id'} . '_width' };
        $is_valid = 0;
    }

    return $is_valid;
}

######################################################################
#sub import {
BEGIN {
    Field::class_register( 'text_0_tategaki', 'Tategaki', '縦書き' )
        if !$setting::field_for_mail;
}

1;
