package UserGeneratedBarGraph;
require CMONOS::CGI_Lib::Field::UserGeneratedField;
@ISA = qw(UserGeneratedField);
use strict;
use utf8;
use Fcntl qw(:DEFAULT);
eval 'use ' . $env::dbm_file . ';';
######################################################################
# フィールド定義モジュール（ユーザー作成バーグラフ）
# UserGeneratedBarGraph.pm 1.0.6
# Copyright (C) 2007-2018 CMONOS Co. Ltd.
#
# support@cmonos.jp
# http://cmonos.jp/
# 最終更新日：2014-08-17
######################################################################
sub _set ($$) {
    my $this = shift;
    unless ( ref $cgi::Image ) {
        require CMONOS::CGI_Lib::Image;
        $cgi::Image = Image->new;
    }
    unless ( ref $cgi::Deco ) {
        require CMONOS::CGI_Lib::Deco;
        $cgi::Deco = Deco->new;
    }
    unless ( ref $cgi::BarGraph ) {
        require CMONOS::CGI_Lib::BarGraph;
        $cgi::BarGraph = BarGraph->new;
    }

    #初期設定
    $this->{'barColor'} = '#6699ff'
        if !defined $this->{'barColor'} || !$this->{'barColor'};
    $this->{'bgColor'} = '#eeeeee'
        if !defined $this->{'bgColor'} || !$this->{'bgColor'};
    $this->{'barWidth'} = 150
        if !defined $this->{'barWidth'} || !$this->{'barWidth'};
    $this->{'default'} = "+5\x0A+4\x0A+3\x0A+2\x0A+1"
        if !defined $this->{'default'} || !$this->{'default'};
    $this->{'rule'} = 1 if !defined $this->{'rule'} || $this->{'rule'} eq '';
    $this->{'cancelLimit'} = 604800
        if !defined $this->{'rule'} || $this->{'rule'} eq '';
    $this->{'voteButtonName'} = 'OK'
        if !defined $this->{'voteButtonName'}
        || $this->{'voteButtonName'} eq '';
    $this->{'generatableUser'} = 'nocheck' if !$this->{'generatableUser'};
    $this->set_ownerpower if $default::static;
    $this->set_external_file_status;
    $this->__set;
    return;
}

sub __set ($$) {
    my $this = shift;
    return;
}

# --------------------------------------------------------------------
#	(0)-5 データ要素の取得
sub elements ($$) {
    my ( $this, $str ) = @_;
    return ();
}

######################################################################
#	(1)-0 obj->match_enabled;
sub match_enabled ($) {
    my $this = shift;
    delete $main::search{ $this->{'id'} }{'f'}
        if defined $main::search{ $this->{'id'} }{'f'}
        && $this->is_nan( $main::search{ $this->{'id'} }{'f'} );
    delete $main::search{ $this->{'id'} }{'t'}
        if defined $main::search{ $this->{'id'} }{'t'}
        && $this->is_nan( $main::search{ $this->{'id'} }{'t'} );
    return (   !$main::search{ $this->{'id'} }{'f'}
            && !$main::search{ $this->{'id'} }{'t'} ) ? 0 : 1;
}

#	(1) obj->match(str);
sub match ($;$) {
    no warnings qw(numeric);
    my ( $this, $str ) = @_;
    return 1
        if !$main::search{ $this->{'id'} }{'f'}
        && !$main::search{ $this->{'id'} }{'t'};
    return 0 if $$str && $$str =~ /disabled$/s;
    my $is_matched = 0;
    $is_matched++
        if !$main::search{ $this->{'id'} }{'f'}
        || $main::search{ $this->{'id'} }{'f'} <= $$str;
    $is_matched++
        if $main::search{ $this->{'id'} }{'t'}
        && $main::search{ $this->{'id'} }{'t'} >= $$str;
    if ((   (     !$main::search{ $this->{'id'} }{'f'}
                || $main::search{ $this->{'id'} }{'f'}
                <= $main::search{ $this->{'id'} }{'t'}
            )
            && $is_matched == 2
        )
        || ($main::search{ $this->{'id'} }{'f'}
            && (  !$main::search{ $this->{'id'} }{'t'}
                || $main::search{ $this->{'id'} }{'f'}
                > $main::search{ $this->{'id'} }{'t'} )
            && $is_matched
        )
        )
    {
        return 1;
    }
    else {
        return 0;
    }
}

######################################################################
#	(2) obj->input_enabled;
sub input_enabled ($) {
    my $this = shift;
    return ( defined $main::data{ $this->{'id'} }{'str'} ) ? 1 : 0;
}

#	(2) obj->form;
sub form {
    my ( $this, $status, $original, $path ) = @_;
    my $field_disabled = (
        $main::option{ $this->{'id'} }{'disabled'}
            || ( $main::data{ $this->{'id'} }{'status'}
            && $main::data{ $this->{'id'} }{'status'} eq 'disabled' )
            || ( !$main::data{ $this->{'id'} }{'status'}
            && $this->{'protected'} )
    ) ? 1 : 0;

    #フィールドネーム+ヘッダ
    my $form = $this->field_header;

    #グラフ表示
    if ( !$field_disabled ) {
        %{ $main::data{ $this->{'id'} } }
            = $this->elements(
            $this->read_file( $path . '/' . $this->{'id'} . '.dat', 1 ) )
            if $default::static;
        $form .= $this->get_bargraph( $main::data{ $this->{'id'} } );
    }
    elsif (-f $path . '/' . $this->{'id'} . '.ssi'
        && -s $path . '/' . $this->{'id'} . '.ssi' )
    {
        $this->write_file( $path . '/' . $this->{'id'} . '.js',  '', 1 );
        $this->write_file( $path . '/' . $this->{'id'} . '.ssi', '', 1 );
    }

    $form .= '<ol class="checkbox">';
    $form
        .= '<li><label><input type="checkbox" name="option:'
        . $this->{'id'}
        . ':disabled" value="1"'
        . (
        (   $field_disabled
                && ( $main::data{ $this->{'id'} }{'status'}
                || !$this->{'protected'} )
        ) ? ' checked="checked"' : ''
        ) . ' /> 使用停止</label></li>';
    $form
        .= '<li><label><input type="checkbox" name="option:'
        . $this->{'id'}
        . ':reset" value="1" /> リセット</label></li>'
        if ref $main::data{ $this->{'id'} }
        && $main::data{ $this->{'id'} }{'atime'};
    $form .= '</ol>';
    $form
        .= '<input type="hidden" name="option:'
        . $this->{'id'}
        . ':status" value="'
        . ( ($field_disabled) ? 'disabled' : 'enabled' ) . '" />';

    $form .= $this->field_footer;
    return $form;
}

######################################################################
#	(3) obj->is_valid_data(path);
sub is_valid_data ($;$) {
    my $this = shift;
    if ($default::static) {
        $main::data{ $this->{'id'} }{'status'}
            = ( $main::option{ $this->{'id'} }{'disabled'} )
            ? 'disabled'
            : 'enabled';
        $this->write_file(
            $this->get_file_directory . '/' . $this->{'id'} . '.dat',
            $this->get_bargraph_data(
                { 'status' => $main::data{ $this->{'id'} }{'status'} }
            ),
            1,
            ( ($env::ownerpower) ? 0600 : $env::file_mode )
        ) if $main::option{ $this->{'id'} }{'reset'};
    }
    else {
        if ( defined $main::n && $main::n ne '' ) {
            undef $main::data{ $this->{'id'} }{'str'};
            if ((      $main::option{ $this->{'id'} }{'disabled'}
                    && $main::option{ $this->{'id'} }{'status'}
                    && $main::option{ $this->{'id'} }{'status'} eq 'enabled'
                )
                || (  !$main::option{ $this->{'id'} }{'disabled'}
                    && $main::option{ $this->{'id'} }{'status'}
                    && $main::option{ $this->{'id'} }{'status'} eq
                    'disabled' )
                || $main::option{ $this->{'id'} }{'reset'}
                )
            {
                my (%db);
                tie( %db, $env::dbm_file,
                    $this->get_db_directory . '/' . $this->db,
                    O_RDWR, $env::dbm_mode );
                if ( ref tied %db ) {
                    my %data = $this->elements(
                        $this->decode_utf8(
                            $db{ $this->encode_utf8($main::n) }
                        )
                    );
                    my $status
                        = ( $data{'status'} ) ? $data{'status'}
                        : ( $this->{'protected'} ) ? 'disabled'
                        :                            'enabled';
                    %data = $this->elements
                        if $main::option{ $this->{'id'} }{'reset'};
                    if (   $main::option{ $this->{'id'} }{'disabled'}
                        && $status ne 'disabled' )
                    {
                        $data{'status'} = 'disabled';
                    }
                    elsif ( !$main::option{ $this->{'id'} }{'disabled'}
                        && $status eq 'disabled' )
                    {
                        $data{'status'} = 'enabled';
                    }
                    elsif ( $main::option{ $this->{'id'} }{'reset'} ) {
                        $data{'status'} = $status;
                    }
                    $db{ $this->encode_utf8($main::n) } = $this->encode_utf8(
                        $this->get_bargraph_data( \%data ) );
                }
                untie %db;
            }
        }
        else {
            $main::data{ $this->{'id'} }{'status'}
                = ( $main::option{ $this->{'id'} }{'disabled'} )
                ? 'disabled'
                : 'enabled';
            $main::data{ $this->{'id'} }{'str'} = $this->get_bargraph_data(
                { 'status' => $main::data{ $this->{'id'} }{'status'} } );
        }
    }
    if (  !$this->{'externalFileDisabled'}
        && $main::option{ $this->{'id'} }{'reset'} )
    {
        my $path = $this->get_file_directory;
        my $id   = $this->mk_user_generated_field_id( $main::c, $main::n );
        my $data = $this->get_bargraph( {}, $id )
            . $this->get_vote_form( {}, $id, $main::c, $main::n );
        $this->write_file( $path . '/' . $this->{'id'} . '.ssi', \$data, 1 );
        $this->mk_external_javascript( $path . '/' . $this->{'id'} . '.ssi',
            $path . '/' . $this->{'id'} . '.js', $data );
    }
    return 1;
}

######################################################################
#	(4) obj->usual_format(str,path,category,no);
#	str=表示するデータ/path=ファイル保存ディレクトリ
sub usual_format {
    my ( $this, $str, $path, $c, $n ) = @_;
    return $this->bargraph_format( $str, $path, $c, $n,
        ( ( $this->has_detail_view && $this->{'detailViewOnly'} ) ? 0 : 1 ) );
}

sub format_for_detail {
    my ( $this, $str, $path, $c, $n ) = @_;
    return $this->bargraph_format( $str, $path, $c, $n, 1 );
}

sub bargraph_format {
    my ( $this, $str, $path, $c, $n, $votable ) = @_;
    my %data
        = ( ref $str eq 'HASH' )
        ? ( defined $$str{'str'} )
            ? $this->elements( $$str{'str'} )
            : %$str
        : $this->elements($str);
    my $id = $this->mk_user_generated_field_id( $c, $n );
    if ( $this->{'externalFileDisabled'}
        || ( $data{'status'} && $data{'status'} eq 'disabled' ) )
    {
        if (  !-f $path . '/' . $this->{'id'} . '.ssi'
            || -s $path . '/' . $this->{'id'} . '.ssi' )
        {
            $this->set_dir($path);
            $this->write_file( $path . '/' . $this->{'id'} . '.js',  '', 1 );
            $this->write_file( $path . '/' . $this->{'id'} . '.ssi', '', 1 );
        }
    }
    return $this->field_tag(
        $this->data_tag_from_hash( 'status' => 'disabled' ) )
        if ( $data{'status'} && $data{'status'} eq 'disabled' )
        || ( !$data{'status'} && $this->{'protected'} );
    if (!$this->{'externalFileDisabled'}
        && (   $cgi::on_refreshing
            || !-f $path . '/' . $this->{'id'} . '.ssi'
            || !-s $path . '/' . $this->{'id'} . '.ssi' )
        )
    {
        if ($default::static    #静的書き出しで
            && ($cgi::on_refreshing #最新のテンプレートで書き出し中　か、
                || (  !$main::option{ $this->{'id'} }{'disabled'}
                    && $main::option{ $this->{'id'} }{'status'}
                    && $main::option{ $this->{'id'} }{'status'} eq
                    'disabled' )
            )                       #それまで使用停止だった場合
            )
        {
            %data = $this->elements(
                $this->read_file( $path . '/' . $this->{'id'} . '.dat', 1 ) );
        }
        my $data = $this->get_bargraph( \%data, $id )
            . $this->get_vote_form( \%data, $id, $c, $n );
        $this->write_file( $path . '/' . $this->{'id'} . '.ssi', \$data, 1 );
        $this->mk_external_javascript( $path . '/' . $this->{'id'} . '.ssi',
            $path . '/' . $this->{'id'} . '.js', $data );
    }
    return $this->field_tag(
        $this->data_tag_from_hash( 'status' => 'enabled' )
            . (
            (   $this->{'externalFileDisabled'}
                    || ( !$default::static && $this->{'update_is_failed'} )
            )
            ? $this->get_bargraph( \%data, $id, 1 )
                . (
                ($votable)
                ? $this->get_vote_form( \%data, $id, $c, $n, 1 )
                : ''
                )
            : $this->include_external_file(
                $path . '/' . $this->{'id'} . '.ssi', 1,
                $this->get_output_path,               1
            )
            )
    );
}

sub has_content {
    my ( $this, $str ) = @_;
    return 1 if !defined $str || $str eq '';
    my %data
        = ( ref $str eq 'HASH' )
        ? ( defined $$str{'str'} )
            ? $this->elements( $$str{'str'} )
            : %$str
        : $this->elements($str);
    return (   %data
            && defined $data{'status'}
            && $data{'status'} eq 'disabled' ) ? 0 : 1;
}

sub get_bargraph ($$;$$) {
    my ( $this, $data, $id, $external_file_disabled ) = @_;
    my $alt = $this->get_graph_info($data);
    return $cgi::BarGraph->bargraph(
        $this->get_bar_value($data),
        $this->get_bar_max_value,
        '', $id,
        $this->{'barColor'},
        $this->{'bgColor'},
        $this->{'barImage'},
        $this->{'bgImage'},
        (   (          $external_file_disabled
                    && $this->{'maxwidth'}
                    && $this->{'maxwidth'} < $this->{'barWidth'}
            ) ? $this->{'maxwidth'} : $this->{'barWidth'}
        ),
        $alt
        )
        . '<div'
        . ( ($id) ? ' id="' . $id . '"' : '' )
        . ' class="bar-data">'
        . $alt
        . '</div>';
}

#投票フォーム
sub get_vote_form ($$$;$$$) {
    my ( $this, $data, $id, $c, $n, $external_file_disabled ) = @_;
    return ''
        if $this->{'formdisabled'}
        || ( ( !$default::static || !$this->{'externalFileDisabled'} )
        && $this->{'generatableUser'}
        && !$this->is_as_secure_as( $this->{'generatableUser'} ) );
    my $form           = '';
    my $is_latest_user = 0;
    if ( $external_file_disabled && $this->{'rule'} ) {
        my $latest_ip
            = ( defined $data->{'latest_ip'} ) ? $data->{'latest_ip'} : '';
        $latest_ip =~ s/[0-9]+/[0-9]+/g
            if $latest_ip =~ /[0-9]/
            && $latest_ip =~ /[^\.0-9]/
            && $this->{'rule'}
            && $this->{'rule'} == 2;
        $is_latest_user = 1
            if $latest_ip ne ''
            && $this->client_ip_is_matched($latest_ip)
            && ( !$this->{'cancelLimit'}
            || !$data->{'atime'}
            || time - $data->{'atime'} < $this->{'cancelLimit'} );
    }
    if ( !$external_file_disabled || !$is_latest_user ) {
        $form .= $this->form_start(
            'key' => (
                ( $external_file_disabled && $setting::security_key )
                ? $setting::security_key
                : ''
            ),
            'id'       => $id . '-form',
            'name'     => $id . '-form',
            'method'   => 'post',
            'class'    => 'user-generated-bargraph-form',
            'onsubmit' => 'return cmonos.form.item(this).submit(\''
                . $id . '\');',
            'required' => $this->get_query_keys
        );
        $form .= $this->add_query_for_form( $c, $n );
        $form .= $this->add_query( 'post', { 'id' => $this->{'id'} } );
        $form .= $this->get_additional_vote_form( $data, $id );
        $form .= $cgi::Deco->submit_button(
            'vote', $this->{'button'},
            $this->{'voteButtonName'},
            { 'id' => $id . '-submit' },
            '', 'abs'
        );
        $form .= '</form>';
        $form .= $this->get_graph_javascript($id);
    }
    return $form;
}

sub get_graph_javascript ($$) {
    my ( $this, $id ) = @_;
    return ( $this->{'rule'} )
        ? $this->javascript(
        'cmonos.form.hideFromRepeater(\'' . $id . '\');' )
        : '';
}

sub get_graph_info ($$) {
    my ( $this, $data ) = @_;
    return '';
}

sub get_bar_value ($$) {
    my ( $this, $data ) = @_;
    return 0;
}

sub get_bar_max_value ($) {
    my $this = shift;
    return 150;
}

sub get_additional_vote_form ($$;$) {
    my ( $this, $data, $id ) = @_;
    return '';
}

#---------------------------------------------------------------------
#	(4)-2 obj->format_for_mail(str);
sub format_for_mail {
    my ( $this, $str, $path, $c, $n ) = @_;
    return '' if !defined $str || $str eq '';
    my %data
        = ( ref $str eq 'HASH' )
        ? ( defined $$str{'str'} )
            ? $this->elements( $$str{'str'} )
            : %$str
        : $this->elements($str);
    return ( $data{'status'} && $data{'status'} eq 'disabled' )
        ? ''
        : '['
        . $this->name . "]\x0A"
        . $this->get_graph_info( \%data )
        . "\x0A\x0A";
}

#---------------------------------------------------------------------
#	(4)-4 obj->format_for_text(str);
sub format_for_text {
    my ( $this, $str ) = @_;
    return '' if !defined $str || $str eq '';
    my %data
        = ( ref $str eq 'HASH' )
        ? ( defined $$str{'str'} )
            ? $this->elements( $$str{'str'} )
            : %$str
        : $this->elements($str);
    return ( $data{'status'} && $data{'status'} eq 'disabled' )
        ? ''
        : $this->get_graph_info( \%data );
}

#---------------------------------------------------------------------
#	(4)-5 obj->confirmation(str);
sub confirmation ($$) {
    my ( $this, $str ) = @_;
    return $this->optional_values if !defined $str || $str eq '';
    my %data = $this->elements($str);
    return $this->optional_values
        . ( ( $data{'status'} && $data{'status'} eq 'disabled' )
        ? '使用停止'
        : '使用' );
}

######################################################################
#	(5) obj->print_setting_form;
sub print_setting_form ($;$$) {
    my $this = shift;

    #名前
    my $name = 'data:' . $this->{'id'};

    $this->print_field_info_form($name);
    print '<fieldset>';
    print '<legend>投票処理</legend>';
    print '<table class="field-table">';
    print '<tbody>';
    print '<tr>';
    print '<td class="field-name"><label for="' . $name
        . '_rule">連続投票制限</label></td>';
    print '<td class="field">';
    print $this->mk_select_menu(
        $name . '_rule', '', '', $this->{'rule'},
        '0' => '制限なし',
        '1' => '同一IPからの連続投票を制限',
        '2' => '類似IPからの連続投票を制限'
    );
    print '</td>';
    print '</tr>';
    print '<tr>';
    print '<td class="field-name"><label for="' . $name
        . '_cancelLimit">制限期限</label></td>';
    print '<td class="field">';
    print $this->mk_select_menu(
        $name . '_cancelLimit', '', '', $this->{'cancelLimit'},
        '0'       => '無期限',
        '86400'   => '1日後',
        '259200'  => '3日後',
        '604800'  => '7日後',
        '1209600' => '14日後',
        '2592000' => '30日後',
        '5184000' => '60日後',
        '7776000' => '90日後'
    );
    print '</td>';
    print '</tr>';
    print '<tr>';
    print '<td class="field-name"><label for="' . $name
        . '_generatableUser">パスワード制限</label></td>';
    print '<td class="field">';
    print $this->mk_select_menu(
        $name . '_generatableUser', '', '', $this->{'generatableUser'},
        'master'  => 'マスター',
        'owner'   => '管理人',
        'owners'  => '共同オーナー',
        'staff'   => 'スタッフ',
        'member'  => '登録メンバー',
        'nocheck' => 'チェックなし'
    );
    print '</td>';
    print '</tr>';

    if ( !$default::static ) {
        print '<tr>';
        print
            '<td class="field-name"><span class="datatitle">後処理</span></td>';
        print '<td class="field"><ol class="checkbox">';
        print '<li><label><input type="checkbox" name="'
            . $name
            . '_externalFileDisabled" id="'
            . $name
            . '_externalFileDisabled" value="1"'
            . (
            (   defined $this->{'externalFileDisabled'}
                    && $this->{'externalFileDisabled'}
            ) ? ' checked="checked"' : ''
            )
            . ' /> JavaScript による埋め込みではなく、その都度描画する (外部 JavaScript ファイルを作成しない)</label></li>';
        print '<li><label><input type="checkbox" name="'
            . $name
            . '_mTime" id="'
            . $name
            . '_mTime" value="1"'
            . ( ( defined $this->{'mTime'} && $this->{'mTime'} )
            ? ' checked="checked"'
            : '' )
            . ' /> 投稿時に更新時データベースを更新する</label></li>';
        print '</ol>';
        print '</td>';
        print '</tr>';
    }
    print '</tbody></table>';
    print '</fieldset>';

    if ( $this->has_detail_view ) {
        print '<fieldset>';
        print '<legend>投票可能な画面</legend>';
        print '<label><input type="checkbox" name="'
            . $name
            . '_detailViewOnly" id="'
            . $name
            . '_detailViewOnly" value="1"'
            . ( ( $this->{'detailViewOnly'} ) ? ' checked="checked"' : '' )
            . ' /> 詳細表示時のみ投票可能にする (JavaScript 埋め込みによる表示では常に投票が可能です)</label>';
        print '</fieldset>';
    }

    $cgi::BarGraph->print_bargraph_setting_form( $this->{'id'}, '', '', 0,
        $this );
    $this->print_sub_setting_form($name);

    print '<fieldset>';
    print '<legend>ボタン設定</legend>';
    print '<fieldset>';
    print '<legend><label for="' . $name
        . '_voteButtonName">投票ボタンの名前</label></legend>';
    print '<input type="text" name="'
        . $name
        . '_voteButtonName" value="'
        . $this->escape( $this->{'voteButtonName'} )
        . '" size="50" /></fieldset>';
    print '<fieldset>';
    print '<legend>投票ボタン</legend>';
    print $cgi::Deco->button_menu( $name . '_button',
        'vote', 120, $this->{'button'} );
    print '</fieldset>';
    print '</fieldset>';

    $this->print_setting_save_button;
    return;
}

sub print_sub_setting_form($$) {
    my ( $this, $name ) = @_;
}

sub has_detail_view ($) {
    my $this = shift;
    return 0;
}

######################################################################
#	(6) obj->is_valid_setting;
sub is_valid_setting ($) {
    my $this     = shift;
    my $is_valid = 1;
    if (   defined $main::data{ $this->{'id'} . '_barWidth' }
        && $main::data{ $this->{'id'} . '_barWidth' } ne ''
        && $this->is_nan( $main::data{ $this->{'id'} . '_barWidth' } ) )
    {
        push(
            @{ $cgi::action->{'dialog'} },
            'グラフ幅を更新できませんでした。半角数字にしてください。'
        ) if ref $cgi::action;
        delete $main::data{ $this->{'id'} . '_barWidth' };
        $is_valid = 0;
    }
    if (   defined $main::data{ $this->{'id'} . '_barColor' }
        && $main::data{ $this->{'id'} . '_barColor' } ne ''
        && $this->is_invalid_color(
            $main::data{ $this->{'id'} . '_barColor' } ) )
    {
        push(
            @{ $cgi::action->{'dialog'} },
            '棒グラフ代替色を更新できませんでした。色設定を確認してください。'
        ) if ref $cgi::action;
        delete $main::data{ $this->{'id'} . '_barColor' };
        $is_valid = 0;
    }
    if (   defined $main::data{ $this->{'id'} . '_bgColor' }
        && $main::data{ $this->{'id'} . '_bgColor' } ne ''
        && $this->is_invalid_color(
            $main::data{ $this->{'id'} . '_bgColor' } ) )
    {
        push(
            @{ $cgi::action->{'dialog'} },
            '棒グラフ背景代替色を更新できませんでした。色設定を確認してください。'
        ) if ref $cgi::action;
        delete $main::data{ $this->{'id'} . '_bgColor' };
        $is_valid = 0;
    }
    $main::data{ $this->{'id'} . '_externalFileDisabled' } = ''
        if !defined $main::data{ $this->{'id'} . '_externalFileDisabled' }
        || !$main::data{ $this->{'id'} . '_externalFileDisabled' };
    $main::data{ $this->{'id'} . '_mTime' } = 0
        if !defined $main::data{ $this->{'id'} . '_mTime' }
        || !$main::data{ $this->{'id'} . '_mTime' };
    $main::data{ $this->{'id'} . '_detailViewOnly' } = 0
        if $this->has_detail_view
        && !$main::data{ $this->{'id'} . '_detailViewOnly' };
    $this->tag_fix( \$main::data{ $this->{'id'} . '_description' } )
        if defined $main::data{ $this->{'id'} . '_description' }
        && $main::data{ $this->{'id'} . '_description' };
    $this->tag_fix( \$main::data{ $this->{'id'} . '_note' } )
        if defined $main::data{ $this->{'id'} . '_note' }
        && $main::data{ $this->{'id'} . '_note' };
    $this->detag( \$main::data{ $this->{'id'} . '_voteButtonName' } )
        if defined $main::data{ $this->{'id'} . '_voteButtonName' }
        && $main::data{ $this->{'id'} . '_voteButtonName' };
    $is_valid = 0 if !$this->is_valid_bargraph_setting;
    return $is_valid;
}

sub is_valid_bargraph_setting ($) {
    my $this = shift;
    return 1;
}

######################################################################
#	(6) obj->search_form;
sub search_form ($) {
    my $this = shift;
    my $form
        = '<tr><td class="field-name"><span class="datatitle">'
        . $this->{'name'}
        . '</span></td><td class="field">';
    $form
        .= '<label>'
        . ( ($default::english) ? '<span class="unit">From</span> ' : '' )
        . $this->get_bargraph_form( 'search:' . $this->{'id'} . ':f',
        $main::search{ $this->{'id'} }{'f'}, 1 )
        . ( ($default::english) ? '' : ' <span class="unit">以上</span>' )
        . '</label> ';
    $form
        .= '<label>'
        . ( ($default::english) ? '<span class="unit">To</span> ' : '' )
        . $this->get_bargraph_form( 'search:' . $this->{'id'} . ':t',
        $main::search{ $this->{'id'} }{'t'}, 1 )
        . ( ($default::english) ? '' : ' <span class="unit">以下</span>' )
        . '</label>';
    $form .= '</td></tr>';
    return $form;
}

sub get_bargraph_form ($$$;$) {
    my ( $this, $name, $default, $search_flag ) = @_;
    return
          '<input type="text" name="'
        . $name
        . '" value="'
        . $this->escape($default)
        . '" size="6" />';
}

######################################################################
#	(8) obj->sort_enabled;
sub sort_enabled ($) {
    my $this = shift;
    return 1;
}

#	sample
sub sample ($$) {
    my ( $this, $str ) = @_;
    return ( defined $str ) ? $str : '';
}

######################################################################
#	(11) obj->update;
sub update ($;$$) {
    my ( $this, $is_ajax, $synced ) = @_;
    my ( $data_ref, $old_size, $new_size, $latest_ip );
    $data_ref = $this->get_field_data;
    if (!$synced
        && (   $this->{'formdisabled'}
            || !ref $data_ref
            || (   $data_ref->{'status'}
                && $data_ref->{'status'} eq 'disabled' )
            || ( !$data_ref->{'status'} && $this->{'protected'} )
            || ( $default::static
                && ( !%$data_ref || !$data_ref->{'status'} ) ) )
        )
    {
        push(
            @{ $cgi::action->{'dialog'} },
            (   ($default::english)
                ? 'Error!'
                : $this->name(1) . ' は現在利用できません。'
            )
        ) if ref $cgi::action;
        return ($is_ajax)
            ? {
            'status'           => 'error',
            'hide_form'        => 1,
            'message'          => $this->get_message_string,
            'authorized_level' => $this->get_authorized_level
            }
            : 0;
    }
    $data_ref = {
        $this->elements(
            $this->read_file(
                $this->get_file_directory . '/' . $this->{'id'} . '.dat', 1
            )
        )
        }
        if $default::static;
    $old_size = $cgi::BarGraph->get_bar_size( $this->get_bar_value($data_ref),
        $this->get_bar_max_value, $this->{'barWidth'} );
    $latest_ip
        = ( defined $data_ref->{'latest_ip'} )
        ? $data_ref->{'latest_ip'}
        : '';
    $latest_ip =~ s/[0-9]+/[0-9]+/g
        if $latest_ip =~ /[0-9]/
        && $latest_ip =~ /[^\.0-9]/
        && $this->{'rule'}
        && $this->{'rule'} == 2;
    if (   $synced
        || !$this->{'rule'}
        || $latest_ip eq ''
        || $this->client_ip_is_matched($latest_ip) == 0
        || (   $this->{'cancelLimit'}
            && $data_ref->{'atime'}
            && time - $data_ref->{'atime'} > $this->{'cancelLimit'} )
        )
    {
        my $path = $this->get_file_directory;
        my $data = $this->update_bargraph( $data_ref, $synced );
        $new_size
            = $cgi::BarGraph->get_bar_size( $this->get_bar_value($data_ref),
            $this->get_bar_max_value, $this->{'barWidth'} );
        if ($default::static) {
            $this->write_file( $path . '/' . $this->{'id'} . '.dat',
                \$data, 1, ( ($env::ownerpower) ? 0600 : $env::file_mode ) );
        }
        else {
            my (%db);
            tie(%db, $env::dbm_file,
                $this->get_db_directory . '/' . $this->db,
                O_RDWR | O_CREAT,
                $env::dbm_mode
            );
            if ( ref tied %db ) {
                $db{ $this->encode_utf8($main::n) }
                    = $this->encode_utf8($data);
            }
            untie %db;
        }
        if ( $this->{'externalFileDisabled'} ) {
            $this->write_file( $path . '/' . $this->{'id'} . '.js',  '', 1 );
            $this->write_file( $path . '/' . $this->{'id'} . '.ssi', '', 1 );
        }
        else {
            my $id = $this->mk_user_generated_field_id( $main::c, $main::n );
            my $data_html = $this->get_bargraph( $data_ref, $id )
                . $this->get_vote_form( $data_ref, $id, $main::c, $main::n );
            $this->write_file( $path . '/' . $this->{'id'} . '.ssi',
                \$data_html, 1 );
            $this->mk_external_javascript(
                $path . '/' . $this->{'id'} . '.ssi',
                $path . '/' . $this->{'id'} . '.js', $data_html );
        }
    }
    else {
        push(
            @{ $cgi::action->{'dialog'} },
            (   ($default::english)
                ? 'Do not vote twice.'
                : '連続投票はご遠慮ください。'
            )
        ) if ref $cgi::action;
        return ($is_ajax)
            ? {
            'status'           => 'error',
            'hide_form'        => 1,
            'voted'            => 1,
            'old_barwidth'     => $old_size,
            'message'          => $this->get_message_string,
            'authorized_level' => $this->get_authorized_level
            }
            : 0;
    }
    $this->post_update;
    return ($is_ajax)
        ? {
        'status'           => 'success',
        'hide_form'        => 1,
        'submitted'        => 1,
        'old_barwidth'     => $old_size,
        'new_barwidth'     => $new_size,
        'content'          => $this->get_graph_info($data_ref),
        'message'          => $this->get_message_string,
        'authorized_level' => $this->get_authorized_level
        }
        : 1;
}

sub editor_enabled ($) {
    my $this = shift;
    return 0;
}

sub is_secure_user_for_edit ($) {
    my $this = shift;
    return 0;
}

######################################################################
#sub import {
BEGIN {
    no warnings qw(once);
    $setting::deco_dir{'bargraph'}    = '棒グラフ画像';
    $setting::deco_dir{'bargraphbg'}  = '棒グラフ枠画像';
    $setting::deco_type{'bargraph'}   = 'image';
    $setting::deco_type{'bargraphbg'} = 'image';
    $setting::deco_dir{'vote'}        = '投票する ボタン';
    $setting::deco_type{'vote'}       = 'button';
}

1;
