package Xtime;
require CMONOS::CGI_Lib::Field;
@ISA = qw(Field);
use strict;
use utf8;
######################################################################
# フィールドモジュール（更新時表示）
# Xtime.pm 1.1.2
# Copyright (C) 1999-2018 CMONOS Co. Ltd.
#
# support@cmonos.jp
# http://cmonos.jp/
# 最終更新日：2014-01-09
######################################################################
#	(0)-1 初期設定
sub _set ($$) {
    my ( $this, $setting ) = @_;
    $this->{'datetype'}
        = ( ( $setting::general{'datetype'} )
        ? $setting::general{'datetype'}
        : '' )
        if !$this->{'datetype'};
}

# --------------------------------------------------------------------
#	(0)-3 フィールドDB
sub db ($) {
    my $this = shift;
    return ( defined $this->{'timetype'} && $this->{'timetype'} ne '' )
        ? $this->{'timetype'}
        : 'mtime';
}

######################################################################
#	(1) obj->match(str);
sub match_enabled ($) {
    my $this = shift;
    return 1
        if ( defined $main::search{ $this->{'id'} }{'time'}
        && $main::search{ $this->{'id'} }{'time'} ne '' )
        || ( defined $main::search{ $this->{'id'} }{'str'}
        && $main::search{ $this->{'id'} }{'str'} ne '' );
    return 0;
}

#	(1) obj->match(str);
sub match ($;$) {
    my ( $this, $str ) = @_;
    return 1
        unless ( defined $main::search{ $this->{'id'} }{'time'}
        && $main::search{ $this->{'id'} }{'time'} ne '' )
        || ( defined $main::search{ $this->{'id'} }{'str'}
        && $main::search{ $this->{'id'} }{'str'} ne '' );
    my $pat = '';

    #何日前
    if ( defined $main::search{ $this->{'id'} }{'time'}
        && $main::search{ $this->{'id'} }{'time'} )
    {
        if ( $main::search{ $this->{'id'} }{'time'} =~ /[^0-9]/ ) {
            $pat = $main::search{ $this->{'id'} }{'time'};
        }
        else {
            if ( $main::search{ $this->{'id'} }{'time'} * 86400
                > ( time - $$str ) )
            {
                return 1
                    if !defined $main::search{ $this->{'id'} }{'mode'}
                    || $main::search{ $this->{'id'} }{'mode'} ne 'and';
            }
            else {
                return 0
                    if defined $main::search{ $this->{'id'} }{'mode'}
                    && $main::search{ $this->{'id'} }{'mode'} eq 'and';
            }
        }
    }
    return 0 if !$pat && !$this->{'searchOption'};

    #期間
    $this->get_pattern($pat) if !ref $this->{'pattern'};
    foreach ( @{ $this->{'pattern'} } ) {
        next if $_ eq '';
        if ( $_ =~ /^([0-9]*)-([0-9]*)$/ ) {
            my ( $f, $t ) = ( $1, $2 );
            if ( ( $f eq '' || $f <= $$str ) && ( $t eq '' || $$str <= $t ) )
            {
                return 1
                    if !defined $main::search{ $this->{'id'} }{'mode'}
                    || $main::search{ $this->{'id'} }{'mode'} ne 'and';
            }
            elsif ( defined $main::search{ $this->{'id'} }{'mode'}
                && $main::search{ $this->{'id'} }{'mode'} eq 'and' )
            {
                return 0;
            }
        }
        elsif ( $_ == $$str ) {
            return 1
                if !defined $main::search{ $this->{'id'} }{'mode'}
                || $main::search{ $this->{'id'} }{'mode'} ne 'and';
        }
        elsif ( defined $main::search{ $this->{'id'} }{'mode'}
            && $main::search{ $this->{'id'} }{'mode'} eq 'and' )
        {
            return 0;
        }
    }
    if ( defined $main::search{ $this->{'id'} }{'mode'}
        && $main::search{ $this->{'id'} }{'mode'} eq 'and' )
    {
        return 1;
    }
    else {
        return 0;
    }

}

#詳細検索読み出し
sub get_pattern ($;$) {
    my ( $this, $str ) = @_;
    $str .= ( ($str) ? ' ' : '' )
        . $this->z_to_h( $main::search{ $this->{'id'} }{'str'} );

    my @localtime = localtime(time);
    use Time::Local;

    while ( $str =~ /([^\x09\x0A\x0C\x0D\x20]+)([\x09\x0A\x0C\x0D\x20]+|$)/g )
    {
        my $key = $1;
        my $time;
        if ( $key eq 'today' || $key eq '今日' ) {
            $time
                = timelocal( 0, 0, 0, $localtime[3], $localtime[4],
                $localtime[5] )
                . '-';
        }
        elsif ( $key eq 'yesterday' || $key eq '昨日' ) {
            my @t = localtime( time - 86400 );
            $time = timelocal( 0, 0, 0, $t[3], $t[4], $t[5] ) . '-'
                . timelocal( 59, 59, 23, $t[3], $t[4], $t[5] );
        }
        elsif ( $key eq 'thisweek' || $key eq '今週' ) {
            my @t = localtime( time - ( 86400 * $localtime[6] ) );
            $time = timelocal( 0, 0, 0, $t[3], $t[4], $t[5] ) . '-';
        }
        elsif ( $key eq 'lastweek' || $key eq '先週' ) {
            my @t = localtime( time - ( 86400 * ( $localtime[6] + 7 ) ) );
            $time = timelocal( 0, 0, 0, $t[3], $t[4], $t[5] );
            @t = localtime( time - ( 86400 * ( $localtime[6] + 1 ) ) );
            $time .= '-' . timelocal( 59, 59, 23, $t[3], $t[4], $t[5] );
        }
        elsif ( $key eq 'thismonth' || $key eq '今月' ) {
            my @t = localtime(time);
            $time = timelocal( 0, 0, 0, 1, $t[4], $t[5] ) . '-';
        }
        elsif ( $key eq 'lastmonth' || $key eq '先月' ) {
            my @t = localtime(time);
            $t[4]--;
            if ( $t[4] < 0 ) {
                $t[4] = 11;
                $t[5]--;
            }
            $time
                = timelocal( 0, 0, 0, 1, $t[4], $t[5] ) . '-'
                . timelocal( 59, 59, 23, $this->max_mday( $t[5], $t[4] + 1 ),
                $t[4], $t[5] );
        }
        else {
            my @pat = split( /\-|~|〜/, $key, -1 );
            foreach my $pat (@pat) {
                my ( @time1, @time2 );
                if ( $pat =~ s!^([0-9]{4})!! ) {
                    $time1[5] = $1;
                    $pat =~ s!^/!!;
                }
                if ( $pat =~ s!^([0-9]{1,2})/?!! ) {
                    $time1[4] = $1 - 1;
                    $time1[5] = $localtime[5]
                        if !defined $time1[5] || $time1[5] eq '';
                }
                if ( $pat =~ s/^([0-9]{1,2})(?!:)\/?// ) {
                    $time1[3] = $1 + 0;
                    $time1[5] = $localtime[5]
                        if !defined $time1[5] || $time1[5] eq '';
                    $time1[4] = $localtime[4]
                        if !defined $time1[4] || $time1[4] eq '';
                }
                if ( $pat =~ s!^([0-9]{1,2}):?!! ) {
                    $time1[2] = $1 + 0;
                    $time1[5] = $localtime[5]
                        if !defined $time1[5] || $time1[5] eq '';
                    $time1[4] = $localtime[4]
                        if !defined $time1[4] || $time1[4] eq '';
                    $time1[3] = $localtime[3]
                        if !defined $time1[3] || $time1[3] eq '';
                }
                if ( $pat =~ s!^([0-9]{1,2}):?!! ) {
                    $time1[1] = $1 + 0;
                    $time1[5] = $localtime[5]
                        if !defined $time1[5] || $time1[5] eq '';
                    $time1[4] = $localtime[4]
                        if !defined $time1[4] || $time1[4] eq '';
                    $time1[3] = $localtime[3]
                        if !defined $time1[3] || $time1[3] eq '';
                    $time1[2] = $localtime[2]
                        if !defined $time1[2] || $time1[2] eq '';
                }
                if ( $pat =~ s!^([0-9]{1,2})!! ) {
                    $time1[0] = $1 + 0;
                    $time1[5] = $localtime[5]
                        if !defined $time1[5] || $time1[5] eq '';
                    $time1[4] = $localtime[4]
                        if !defined $time1[4] || $time1[4] eq '';
                    $time1[3] = $localtime[3]
                        if !defined $time1[3] || $time1[3] eq '';
                    $time1[2] = $localtime[2]
                        if !defined $time1[2] || $time1[2] eq '';
                    $time1[1] = $localtime[1]
                        if !defined $time1[1] || $time1[1] eq '';
                }

                if ( !@time1 || grep( !defined $_ || $_ eq '', @time1 ) ) {
                    @time2 = @time1;
                    ( $time1[5], $time2[5] ) = ( 1970, $localtime[5] )
                        if !defined $time1[5] || $time1[5] eq '';
                    ( $time1[4], $time2[4] ) = ( 0, 11 )
                        if !defined $time1[4] || $time1[4] eq '';
                    ( $time1[3], $time2[3] ) = ( 1, 31 )
                        if !defined $time1[3] || $time1[3] eq '';
                    ( $time1[2], $time2[2] ) = ( 0, 23 )
                        if !defined $time1[2] || $time1[2] eq '';
                    ( $time1[1], $time2[1] ) = ( 0, 59 )
                        if !defined $time1[1] || $time1[1] eq '';
                    ( $time1[0], $time2[0] ) = ( 0, 59 )
                        if !defined $time1[0] || $time1[0] eq '';
                    if ($time2[3] > 30
                        && (   $time2[4] == 3
                            || $time2[4] == 5
                            || $time2[4] == 8
                            || $time2[4] == 10 )
                        )
                    {
                        $time2[3] = 30;
                    }
                    elsif ( $time2[3] > 28 && $time2[4] == 1 ) {
                        $time2[3]
                            = ( ( $time2[5] % 4 == 0 && $time2[5] % 100 != 0 )
                                || $time2[5] % 400 == 0 ) ? 29 : 28;
                    }
                }
                if ($time1[3] > 30
                    && (   $time1[4] == 3
                        || $time1[4] == 5
                        || $time1[4] == 8
                        || $time1[4] == 10 )
                    )
                {
                    $time1[3] = 30;
                }
                elsif ( $time1[3] > 28 && $time1[4] == 1 ) {
                    $time1[3]
                        = ( ( $time1[5] % 4 == 0 && $time1[5] % 100 != 0 )
                            || $time1[5] % 400 == 0 ) ? 29 : 28;
                }
                $time
                    .= ( ( defined $time && $time ne '' ) ? '-' : '' )
                    . timelocal(@time1)
                    . ( (@time2) ? '-' . timelocal(@time2) : '' );
            }
            $time =~ s/\-.*\-/\-/;
        }
        push( @{ $this->{'pattern'} }, $time ) if $time;
    }
}

######################################################################
#	(2) obj->input_enabled;
sub input_enabled ($) {
    my $this = shift;
    return 0;
}

sub form {
    my ( $this, $status, $original ) = @_;
    my ($form);
    $main::data{ $this->{'id'} }{'str'} = time
        if !$main::data{ $this->{'id'} }{'str'};
    $form = $this->field_header;
    $form .= $this->field_date( $main::data{ $this->{'id'} }{'str'}, 0 );
    $form
        .= '<input type="hidden" name="data:'
        . $this->{'id'}
        . ':str" value="'
        . $main::data{ $this->{'id'} }{'str'} . '" />'
        if $this->{'timetype'} eq 'ctime';
    $form .= $this->field_footer;
    return $form;
}

sub field_date ($$;$) {
    my ( $this, $time, $limit ) = @_;
    $limit = $this->{'datelimit'}
        if ( !defined $limit || $limit eq '' )
        && $this->{'field_tag_enabled'}
        && $this->{'field_tag_enabled'} eq 'no';
    return $this->date( $time, $limit, 'gmt' . $this->{'datetype'},
        $this->{'dateformat'} );
}

######################################################################
#	(3) obj->is_valid_data(path);
sub is_valid_data ($;$) {
    my $this = shift;

    $main::data{ $this->{'id'} }{'str'} = time
        if $this->{'timetype'} eq 'mtime' || $this->{'timetype'} eq '';
    return 1;
}

######################################################################
#	(4) obj->usual_format(str);
sub usual_format {
    my ( $this, $str ) = @_;
    $str = $$str{'str'} if ref $str eq 'HASH';
    return $this->field_tag('') if !defined $str || $str eq '';
    return $this->field_tag(
        $this->data_tag_from_hash( 'str', $str )
            . $this->style(
            $this->nobr_date( $this->field_date($str) ),
            $this->{'style'},     $this->{'fontsize'},
            $this->{'fontcolor'}, $this->{'fontface'}
            )
    );
}

#---------------------------------------------------------------------
#	(4) obj->format_for_mail(str);
sub format_for_mail {
    my ( $this, $str ) = @_;
    $str = $$str{'str'} if ref $str eq 'HASH';
    return '' if !defined $str || $str eq '';
    return
          '['
        . $this->name . "]\x0A"
        . $this->field_date( $str, 0 )
        . "\x0A\x0A";
}

#	(4)-3 obj->format_for_text(str);
sub format_for_text {
    my ( $this, $str ) = @_;
    $str = $$str{'str'} if ref $str eq 'HASH';
    return '' if !defined $str || $str eq '';
    return $this->field_date( $str, 0 );
}

######################################################################
#	(5) obj->print_setting_form;
sub print_setting_form ($$$) {
    my ( $this, $html_disabled ) = @_;
    my ($name);

    #名前
    $name = 'data:' . $this->{'id'};

    $this->print_field_info_form($name);

    print '<fieldset>';
    print '<legend>表示設定</legend>';
    print '<table class="field-table">';
    print '<tbody>';
    print '<tr class="tbody-end">';
    print '<td class="field-name"><label for="' . $name
        . '_timetype">タイプ</label></td>';
    print '<td class="field">';
    print $this->mk_select_menu(
        $name . '_timetype', '', '', $this->{'timetype'},
        'mtime' => '更新時',
        'ctime' => '作成時'
    );
    print '</td>';
    print '</tr>';
    print '</tbody>';

    print '<tbody>';
    print '<tr>';
    print '<td class="field-name"><label for="' . $name
        . '_datetype">表示形式</label></td>';
    print '<td class="field">';
    $this->print_date_type_menu( $name . '_',
        $this->{'datetype'}, '', '', 1, $this->{'dateformat'} );
    print '</td>';
    print '</tr>';

    if ( !defined $default::static || !$default::static ) {
        print '<tr>';
        print
            '<td class="field-name"><span class="datatitle">日時の表示</span></td>';
        print '<td class="field"><label><input type="number" name="'
            . $name
            . '_datelimit" id="'
            . $name
            . '_datelimit" size="3" maxlength="3" value="'
            . $this->escape( $this->{'datelimit'} )
            . '" /> 日以内なら相対日時で表現する（きょう/きのう/○日前）</label></td>';
        print '</tr>';
    }

    print '</tbody></table>';
    print '</fieldset>';

    if ( !defined $html_disabled || !$html_disabled ) {
        if ( !defined $default::static || !$default::static ) {
            print '<fieldset>';
            print '<legend>検索設定</legend>';
            print '<label><input type="checkbox" name="'
                . $name
                . '_searchOption" value="1"'
                . (
                (   defined $this->{'searchOption'} && $this->{'searchOption'}
                ) ? ' checked="checked"' : ''
                ) . ' /> より詳しい検索</label>';
            print '</fieldset>';
        }

        #文字設定
        $this->print_font_setting_form($name);
    }

    $this->print_setting_save_button;
    return;
}

######################################################################
#	(6) obj->is_valid_setting;
sub is_valid_setting ($) {
    my $this     = shift;
    my $is_valid = 1;
    $this->tag_fix( \$main::data{ $this->{'id'} . '_description' } )
        if defined $main::data{ $this->{'id'} . '_description' }
        && $main::data{ $this->{'id'} . '_description' };
    $this->tag_fix( \$main::data{ $this->{'id'} . '_note' } )
        if defined $main::data{ $this->{'id'} . '_note' }
        && $main::data{ $this->{'id'} . '_note' };
    $main::data{ $this->{'id'} . '_searchOption' } = 0
        if !defined $main::data{ $this->{'id'} . '_searchOption' }
        || $main::data{ $this->{'id'} . '_searchOption' } == 0;
    if (   defined $main::data{ $this->{'id'} . '_datelimit' }
        && $main::data{ $this->{'id'} . '_datelimit' } ne ''
        && $this->is_nan( $main::data{ $this->{'id'} . '_datelimit' } ) )
    {
        push(
            @{ $cgi::action->{'dialog'} },
            '相対日時設定を更新できませんでした。半角数字にしてください。'
        ) if ref $cgi::action;
        delete $main::data{ $this->{'id'} . '_datelimit' };
        $is_valid = 0;
    }
    $is_valid = 0 if !$this->is_valid_font_setting;
    return $is_valid;
}

######################################################################
#	(7) obj->search_form;
sub search_form ($) {
    my $this = shift;
    my ( $key, $form );
    $key = $this->escape( $main::search{ $this->{'id'} }{'str'} );
    $form
        = '<tr><td class="field-name"><label for="search:'
        . $this->{'id'}
        . ':time">'
        . $this->{'name'}
        . '</label></td><td class="field">';

    #英語表記
    if ( defined $default::english && $default::english ) {
        $form .= $this->mk_select_menu(
            'search:' . $this->{'id'} . ':time', '', '',
            $main::search{ $this->{'id'} }{'time'},
            ''          => '',
            'today'     => 'Today',
            'yesterday' => 'Yesterday',
            'thisweek'  => 'This week',
            'lastweek'  => 'Last week',
            'thismonth' => 'This month',
            'lastmonth' => 'Last month',
            ''          => '',
            '1'         => 'During the past 1 day',
            '2'         => 'During the past 2 days',
            '3'         => 'During the past 3 days',
            '7'         => 'During the past 1 week',
            '14'        => 'During the past 2 weeks',
            '31'        => 'During the past 1 month',
            '93'        => 'During the past 3 months',
            '183'       => 'During the past 6 months',
            '365'       => 'During the past 1 years'
        );

        if ( defined $this->{'searchOption'} && $this->{'searchOption'} ) {
            $form
                .= '<div class="sub-field"><input type="text" size="30" name="search:'
                . $this->{'id'}
                . ':str" value="'
                . $key . '" /> ';
            $form .= $this->mk_select_menu(
                'search:' . $this->{'id'} . ':mode', '', '',
                $main::search{ $this->{'id'} }{'mode'},
                'and' => 'Matches on all',
                'or'  => 'Matches on any'
            );
            $form .= '</div>';
            $form .= '<div class="note">year[4]/month/day/hour:min:sec</div>';
            $form
                .= '<div class="note">ex) 2001/1/1/0:00:00-2001/4/1/0:00:00</div>';
        }

        #日本語
    }
    else {
        $form .= $this->mk_select_menu(
            'search:' . $this->{'id'} . ':time', '', '',
            $main::search{ $this->{'id'} }{'time'},
            ''          => '',
            'today'     => '今日',
            'yesterday' => '昨日',
            'thisweek'  => '今週',
            'lastweek'  => '先週',
            'thismonth' => '今月',
            'lastmonth' => '先月',
            ''          => '',
            '1'         => '24時間以内',
            '2'         => '48時間以内',
            '3'         => '3日以内',
            '7'         => '1週間以内',
            '14'        => '2週間以内',
            '31'        => '1カ月以内',
            '93'        => '3カ月以内',
            '183'       => '半年以内',
            '365'       => '1年以内'
        );

        if ( defined $this->{'searchOption'} && $this->{'searchOption'} ) {
            $form
                .= '<div class="sub-field"><input type="text" size="30" name="search:'
                . $this->{'id'}
                . ':str" value="'
                . $key . '" /> ';
            $form .= $this->mk_select_menu(
                'search:' . $this->{'id'} . ':mode', '', '',
                $main::search{ $this->{'id'} }{'mode'},
                'and' => '全ての条件に一致',
                'or'  => 'いずれかの条件に一致'
            );
            $form .= '</div>';
            $form
                .= '<div class="note">年[4桁]/月/日/時:分:秒（複数の場合スペースで区切ります）</div>';
            $form
                .= '<div class="note">"-"で期間を指定できます（2000/1/1/0:00:00-2001/1/1/0:00:00）。</div>';
        }
    }
    $form .= '</td></tr>';
    return $form;
}

######################################################################
#	sample
sub sample ($$) {
    my ( $this, $str ) = @_;
    return ( defined $str ) ? $str : '';
}

######################################################################
#	(9) obj->cookie_enabled;
sub cookie_enabled ($) {
    my $this = shift;
    return 0;
}

######################################################################
#	(10) obj->required_enabled;
sub required_enabled ($) {
    my $this = shift;
    return 0;
}

######################################################################
#sub import {
BEGIN {
    Field::class_register( 'user_xtime', 'Xtime', '作成時/更新時' );
}

1;
