package JPrefecture;
use strict;
use utf8;
######################################################################
# 日本の都道府県
# JPrefecture.pm ver1.0
# Copyright (C) 1999-2018 CMONOS Co. Ltd.
#
# support@cmonos.jp
# http://cmonos.jp/
#
######################################################################
# オブジェクトを作る。
sub new ($) {
    my $pkg  = shift;
    my $this = {};
    bless $this;
    $this;
}

sub get_prefecture_name_by_id ($$) {
    my ( $this, $id ) = @_;
    my %pref_name_table = $this->get_prefecture_name_hash;
    return $pref_name_table{$id};
}

sub get_prefecture_name_hash ($) {
    my $this = shift;
    return (
        1 => '北海道',

        2 => '青森県',
        3 => '岩手県',
        4 => '宮城県',
        5 => '秋田県',
        6 => '山形県',
        7 => '福島県',

        8  => '茨城県',
        9  => '栃木県',
        10 => '群馬県',
        11 => '埼玉県',
        12 => '千葉県',
        13 => '東京都',
        14 => '神奈川県',

        15 => '新潟県',
        16 => '富山県',
        17 => '石川県',
        18 => '福井県',
        19 => '山梨県',
        20 => '長野県',
        21 => '岐阜県',
        22 => '静岡県',
        23 => '愛知県',

        24 => '三重県',
        25 => '滋賀県',
        26 => '京都府',
        27 => '大阪府',
        28 => '兵庫県',
        29 => '奈良県',
        30 => '和歌山県',

        31 => '鳥取県',
        32 => '島根県',
        33 => '岡山県',
        34 => '広島県',
        35 => '山口県',

        36 => '徳島県',
        37 => '香川県',
        38 => '愛媛県',
        39 => '高知県',

        40 => '福岡県',
        41 => '佐賀県',
        42 => '長崎県',
        43 => '熊本県',
        44 => '大分県',
        45 => '宮崎県',
        46 => '鹿児島県',
        47 => '沖縄県'
    );
}

sub get_prefecture_id_by_name ($$) {
    my ( $this, $name ) = @_;
    my %pref_id_table = $this->get_prefecture_id_hash;
    return $pref_id_table{$name};
}

sub get_prefecture_id_hash ($) {
    my $this = shift;
    return (
        '北海道' => 1,

        '青森県' => 2,
        '岩手県' => 3,
        '宮城県' => 4,
        '秋田県' => 5,
        '山形県' => 6,
        '福島県' => 7,

        '茨城県'    => 8,
        '栃木県'    => 9,
        '群馬県'    => 10,
        '埼玉県'    => 11,
        '千葉県'    => 12,
        '東京都'    => 13,
        '神奈川県' => 14,

        '新潟県' => 15,
        '富山県' => 16,
        '石川県' => 17,
        '福井県' => 18,
        '山梨県' => 19,
        '長野県' => 20,
        '岐阜県' => 21,
        '静岡県' => 22,
        '愛知県' => 23,

        '三重県'    => 24,
        '滋賀県'    => 25,
        '京都府'    => 26,
        '大阪府'    => 27,
        '兵庫県'    => 28,
        '奈良県'    => 29,
        '和歌山県' => 30,

        '鳥取県' => 31,
        '島根県' => 32,
        '岡山県' => 33,
        '広島県' => 34,
        '山口県' => 35,

        '徳島県' => 36,
        '香川県' => 37,
        '愛媛県' => 38,
        '高知県' => 39,

        '福岡県'    => 40,
        '佐賀県'    => 41,
        '長崎県'    => 42,
        '熊本県'    => 43,
        '大分県'    => 44,
        '宮崎県'    => 45,
        '鹿児島県' => 46,
        '沖縄県'    => 47
    );
}

sub get_region_name_by_id ($$) {
    my ( $this, $id ) = @_;
    my %region_name_table = $this->get_region_name_hash;
    return $region_name_table{$id};
}

sub get_region_name_hash ($) {
    my $this = shift;
    return (
        1 => '北海道地方',
        2 => '東北地方',
        3 => '関東地方',
        4 => '中部地方',
        5 => '関西地方',
        6 => '中国地方',
        7 => '四国地方',
        8 => '九州地方',
        9 => '沖縄地方'
    );
}

sub get_region_id_by_name ($$) {
    my ( $this, $name ) = @_;
    my %region_id_table = $this->get_region_id_hash;
    return $region_id_table{$name};
}

sub get_region_id_hash ($) {
    my $this = shift;
    return (
        '北海道地方' => 1,
        '東北地方'    => 2,
        '関東地方'    => 3,
        '中部地方'    => 4,
        '関西地方'    => 5,
        '中国地方'    => 6,
        '四国地方'    => 7,
        '九州地方'    => 8,
        '沖縄地方'    => 9
    );
}

sub get_prefecture_id_array_by_region_id ($$) {
    my ( $this, $rid ) = @_;
    if ( $rid == 1 ) {
        return (1);
    }
    elsif ( $rid == 2 ) {
        return ( 2 .. 7 );
    }
    elsif ( $rid == 3 ) {
        return ( 8 .. 14 );
    }
    elsif ( $rid == 4 ) {
        return ( 15 .. 23 );
    }
    elsif ( $rid == 5 ) {
        return ( 24 .. 30 );
    }
    elsif ( $rid == 6 ) {
        return ( 31 .. 35 );
    }
    elsif ( $rid == 7 ) {
        return ( 36 .. 39 );
    }
    elsif ( $rid == 8 ) {
        return ( 40 .. 46 );
    }
    elsif ( $rid == 9 ) {
        return (47);
    }
}

sub get_region_id_by_prefecture_id ($$) {
    my ( $this, $pid ) = @_;
    if ( $pid == 1 ) {
        return 1;
    }
    elsif ( $pid >= 2 && $pid <= 7 ) {
        return 2;
    }
    elsif ( $pid >= 8 && $pid <= 14 ) {
        return 3;
    }
    elsif ( $pid >= 15 && $pid <= 23 ) {
        return 4;
    }
    elsif ( $pid >= 24 && $pid <= 30 ) {
        return 5;
    }
    elsif ( $pid >= 31 && $pid <= 35 ) {
        return 6;
    }
    elsif ( $pid >= 36 && $pid <= 39 ) {
        return 7;
    }
    elsif ( $pid >= 40 && $pid <= 46 ) {
        return 8;
    }
    elsif ( $pid == 47 ) {
        return 9;
    }
}

1;
