package WeblogUpdatesPing;
use strict;
use utf8;
######################################################################
# WeblogUpdatesPing.pm
# CMONOS::CGI_Lib::Ping::WeblogUpdatesPing.pm ver1.0
# Copyright (C) 2007-2018 CMONOS Co. Ltd.
#
# support@cmonos.jp
# http://cmonos.jp/
#
######################################################################
# 使い方
# require CMONOS::CGI_Lib::Ping::WeblogUpdatesPing;
# $ping = WeblogUpdatesPing->new(
#	'ping_url'				=>	Ping URL,
#	'weblogname'			=>	ブログタイトル,
#	'weblogurl'				=>	ブログのURL,
#	'changesurl'			=>	変更をチェックするページの URL,
#	'rssurl'				=>	RSS、RDF、Atom フィードの URL,
#	'categoryname'			=>	サイトのコンテンツを分類する名前またはタグ。複数の値は "|" 文字で区切ります。,
#	'extendPing'			=>	1/0(Google は自動的に1),
# );
#
# RDF取得
# $ping->rdf;
#
######################################################################
# オブジェクトを作る。
sub new ($;@) {
    my $pkg  = shift;
    my $this = {@_};
    $this->{'changesurl'} = $this->{'weblogurl'}
        if !$this->{'changesurl'} && $this->{'weblogurl'};
    bless $this;
    return $this;
}

sub flerror ($) {
    my $this = shift;
    return ( $this->{'flerror'} ) ? $this->{'flerror'} : 0;
}

sub message ($) {
    my $this = shift;
    return ( $this->{'message'} ) ? $this->{'message'} : '';
}

sub ping ($) {
    my $this = shift;
    if ( !$this->{'ping_url'} ) {
        $this->{'message'} = 'Ping URL がみつかりませんでした。';
        return $this;
    }
    my $extend_flag
        = ( $this->{'extendPing'} || $this->{'ping_url'} =~ /\.google\./ )
        ? 1
        : 0;
    my $content = '<?xml version="1.0" encoding="UTF-8"?>' . "\x0A";
    $content .= '<methodCall>' . "\x0A";
    $content
        .= '  <methodName>weblogUpdates.'
        . ( ($extend_flag) ? 'extendedPing' : 'ping' )
        . '</methodName>' . "\x0A";
    $content .= '  <params>' . "\x0A";
    $content .= '    <param>' . "\x0A";
    $content
        .= '      <value>'
        . ( ( defined $this->{'weblogname'} ) ? $this->{'weblogname'} : '' )
        . '</value>' . "\x0A";
    $content .= '    </param>' . "\x0A";
    $content .= '    <param>' . "\x0A";
    $content
        .= '      <value>'
        . ( ( defined $this->{'weblogurl'} ) ? $this->{'weblogurl'} : '' )
        . '</value>' . "\x0A";
    $content .= '    </param>' . "\x0A";

    if ($extend_flag) {
        $content .= '    <param>' . "\x0A";
        $content
            .= '      <value>'
            . (
            ( defined $this->{'changesurl'} ) ? $this->{'changesurl'} : '' )
            . '</value>' . "\x0A";
        $content .= '    </param>' . "\x0A";
        $content .= '    <param>' . "\x0A";
        $content
            .= '      <value>'
            . ( ( defined $this->{'rssurl'} ) ? $this->{'rssurl'} : '' )
            . '</value>' . "\x0A";
        $content .= '    </param>' . "\x0A";
        if ( $this->{'categoryname'} ) {
            $content .= '    <param>' . "\x0A";
            $content
                .= '      <value>'
                . ( ( defined $this->{'categoryname'} )
                ? $this->{'categoryname'}
                : '' )
                . '</value>' . "\x0A";
            $content .= '    </param>' . "\x0A";
        }
    }
    $content .= '  </params>' . "\x0A";
    $content .= '</methodCall>' . "\x0A";
    require CMONOS::CGI_Lib::HTTP_Client;
    my $res = HTTP_Client->new->request(
        'POST' => $this->{'ping_url'},
        {   'Accept'       => '*/*',
            'Content-Type' => 'text/xml; charset=utf-8',
        },
        $content,
        'utf8'
    );
    if ( $res->is_success ) {
        my $hash = $res->hash('utf8');
        if (   ref $hash
            && ref $hash->{'methodResponse'}
            && defined $hash->{'methodResponse'}->{'params'}->{'param'}
            ->{'struct'}->{'member'}->[0]->{'flerror'} )
        {
            $this->{'flerror'}
                = $hash->{'methodResponse'}->{'params'}->{'param'}
                ->{'struct'}->{'member'}->[0]->{'flerror'};
            $this->{'message'}
                = $hash->{'methodResponse'}->{'params'}->{'param'}
                ->{'struct'}->{'member'}->[1]->{'message'}
                if defined $hash->{'methodResponse'}->{'params'}->{'param'}
                ->{'struct'}->{'member'}->[1]->{'message'};
            $this->{'ptime'} = time;
        }
        else {
            $this->{'error'}   = 1;
            $this->{'message'} = '';
        }
    }
    return $this;
}

1;
