package StyleSheetHelper;
require CMONOS::CGI_Lib::Common;
@ISA = qw(Common);
use strict;
use utf8;
######################################################################
# スタイルシート入力補助モジュール
# StyleSheetHelper.pm 1.0.2
# Copyright (C) 2007-2018 CMONOS Co. Ltd.
#
# support@cmonos.jp
# http://cmonos.jp/
# 最終更新日：2010-05-06
######################################################################
sub new ($;@) {
    my $pkg  = shift;
    my $this = {};
    bless $this;
    $this;
}

######################################################################
#ソケットを開いて接続する
sub print_menu ($$;$$) {
    my ( $this, $name, $option, $additional_menu ) = @_;
    print '<div class="toolbox">';
    print
        '<label class="auto-fit" title="高さを内容に合わせる"><input type="checkbox" onclick="cmonos.form.item(this.form).fieldname(\'',
        $name, '\').setAutoFit(this.checked);" />フィット</label> ';
    print
        '<select class="tool" onchange="cmonos.form.item(this.form).fieldname(\'',
        $name, '\').quotationByMenu(this)">';
    print '<option value="">▼挿入する</option>';
    print '<option value="[[REPLACE]]">[置換]</option>';
    if ($additional_menu) {
        print '<option value=""></option>';
        print $additional_menu;
    }
    if ( !$option ) {
        print '<option value=""></option>';
        print '<option value="'
            . $this->jsquot('\n  color: ;')
            . '">文字色 color: #rrggbb;</option>';
    }
    print '<option value=""></option>';
    print '<option value="'
        . $this->jsquot('\n  background-color: transparent|#rgb;')
        . '">背景色 background-color: #rrggbb;</option>';
    print '<option value="'
        . $this->jsquot('\n  background-image: url(&quot;&quot;);')
        . '">背景画像 background-image: url(&quot;&quot;);</option>';
    print '<option value="'
        . $this->jsquot(
        '\n  background-repeat: repeat|repeat-x|repeat-y|no-repeat;')
        . '">背景画像の並び方 background-repeat: ;</option>';
    print '<option value="'
        . $this->jsquot('\n  background-position: % %;')
        . '">背景画像位置 background-position: 横方向 縦方向;</option>';
    print '<option value="'
        . $this->jsquot('\n  background-attachment: scroll|fixed;')
        . '">背景画像スクロール background-attachment: scroll|fixed;</option>';
    print '<option value=""></option>';
    print '<option value="'
        . $this->jsquot(
        '\n  font-family: serif|sans-serif|cursive|fantasy|monospace|&quot;&quot;;'
        ) . '">フォント名 font-family: &quot;&quot;</option>';
    print '<option value="'
        . $this->jsquot(
        '\n  font-size: xx-small|x-small|small|medium|large|x-large|xx-large|%;'
        ) . '">フォントサイズ font-size: 120%;</option>';
    print '<option value="'
        . $this->jsquot('\n  font-weight: normal|bold;')
        . '">フォントの太さ font-weight: bold;</option>';
    print '<option value="'
        . $this->jsquot('\n  font-style: normal|italic|oblique;')
        . '">斜体 font-style: italic;</option>';
    print '<option value="'
        . $this->jsquot('\n  font-variant: normal|small-caps;')
        . '">小文字が小さめの大文字の書体 font-variant: small-caps;</option>';
    print '<option value=""></option>';
    print '<option value="'
        . $this->jsquot('\n  line-height: %|em;')
        . '">行の高さ line-height: 1.5;</option>';
    print '<option value="'
        . $this->jsquot('\n  text-align: left|right|center|justify;')
        . '">行揃え text-align: left|right|center|justify;</option>';
    print '<option value="'
        . $this->jsquot('\n  vertical-align: top|middle|bottom|baseline;')
        . '">縦方向の位置 vertical-align: top|middle|bottom;</option>';
    print '<option value=""></option>';
    print '<option value="'
        . $this->jsquot(
        '\n  text-decoration: none|underline|overline|line-through|blink;')
        . '">下線・上線・取消線・点滅 text-decoration: underline;</option>'
        unless $option;
    print '<option value="'
        . $this->jsquot('\n  letter-spacing: em;')
        . '">文字間隔 letter-spacing: 2em;</option>';
    print '<option value="'
        . $this->jsquot('\n  word-spacing: em;')
        . '">単語間隔 word-spacing: 0.2em;</option>';
    print '<option value="'
        . $this->jsquot(
        '\n  text-trancform: none|capitalize|lowercase|uppercase;')
        . '">単語頭大文字・小文字・大文字 text-trancform: capitalize;</option>';
    print '<option value="'
        . $this->jsquot('\n  text-indent: 1em;')
        . '">一行目のインデント text-indent: 1em;</option>';
    print '<option value="'
        . $this->jsquot('\n  white-space: normal|pre|nowrap;')
        . '">空白・タブ・改行の反映 white-space: pre;</option>';
    print '<option value="'
        . $this->jsquot('\n  text-shadow: #666666 2px 2px 1.3px;')
        . '">影付き文字 text-shadow: 影の色 右 下 ぼかし;</option>';
    print '<option value="'
        . $this->jsquot('\n  text-overflow: ellipsis;')
        . '">ボックスに収まらないとき &quot;...&quot; text-overflow: ellipsis;</option>';
    print '<option value=""></option>';
    print '<option value="'
        . $this->jsquot('\n  margin: px|em|%|auto;')
        . '">マージン margin: px|em|%|auto;</option>';
    print '<option value="'
        . $this->jsquot('\n  margin-top: px|em|%|auto;')
        . '">上マージン margin-top: px|em|%|auto;</option>';
    print '<option value="'
        . $this->jsquot('\n  margin-left: px|em|%|auto;')
        . '">左マージン margin-left: px|em|%|auto;</option>';
    print '<option value="'
        . $this->jsquot('\n  margin-right: px|em|%|auto;')
        . '">右マージン margin-right: px|em|%|auto;</option>';
    print '<option value="'
        . $this->jsquot('\n  margin-bottom: px|em|%|auto;')
        . '">下マージン margin-bottom: px|em|%|auto;</option>';
    print '<option value=""></option>';
    print '<option value="'
        . $this->jsquot('\n  padding: px|em|%;')
        . '">パディング padding: px|em|%;</option>';
    print '<option value="'
        . $this->jsquot('\n  padding-top: px|em|%;')
        . '">上パディング padding-top: px|em|%;</option>';
    print '<option value="'
        . $this->jsquot('\n  padding-left: px|em|%;')
        . '">左パディング padding-left: px|em|%;</option>';
    print '<option value="'
        . $this->jsquot('\n  padding-right: px|em|%;')
        . '">右パディング padding-right: px|em|%;</option>';
    print '<option value="'
        . $this->jsquot('\n  padding-bottom: px|em|%;')
        . '">下パディング padding-bottom: px|em|%;</option>';
    print '<option value=""></option>';
    print '<option value="'
        . $this->jsquot('\n  border-color: ;')
        . '">ボーダー色 border-color: #rrggbb;</option>';
    print '<option value="'
        . $this->jsquot('\n  border-top-color: ;')
        . '">上ボーダー色 border-top-color: #rrggbb;</option>';
    print '<option value="'
        . $this->jsquot('\n  border-left-color: ;')
        . '">左ボーダー色 border-left-color: #rrggbb;</option>';
    print '<option value="'
        . $this->jsquot('\n  border-right-color: ;')
        . '">右ボーダー色 border-right-color: #rrggbb;</option>';
    print '<option value="'
        . $this->jsquot('\n  border-bottom-color: ;')
        . '">下ボーダー色 border-bottom-color: #rrggbb;</option>';
    print '<option value=""></option>';
    print '<option value="'
        . $this->jsquot('\n  border-width: thin|medium|thick;')
        . '">ボーダー幅 border-width: thin|medium|thick;</option>';
    print '<option value="'
        . $this->jsquot('\n  border-top-width: thin|medium|thick;')
        . '">上ボーダー幅 border-top-width: thin|medium|thick;</option>';
    print '<option value="'
        . $this->jsquot('\n  border-left-width: thin|medium|thick;')
        . '">左ボーダー幅 border-left-width: thin|medium|thick;</option>';
    print '<option value="'
        . $this->jsquot('\n  border-right-width: thin|medium|thick;')
        . '">右ボーダー幅 border-right-width: thin|medium|thick;</option>';
    print '<option value="'
        . $this->jsquot('\n  border-bottom-width: thin|medium|thick;')
        . '">下ボーダー幅 border-bottom-width: thin|medium|thick;</option>';
    print '<option value=""></option>';
    print '<option value="'
        . $this->jsquot(
        '\n  border-style: none|hidden|solid|double|groove|ridge|inset|outset|dashed|dotted;'
        ) . '">ボーダー幅 border-style: solid;</option>';
    print '<option value="'
        . $this->jsquot(
        '\n  border-top-style: none|hidden|solid|double|groove|ridge|inset|outset|dashed|dotted;'
        ) . '">上ボーダー幅 border-top-style: solid;</option>';
    print '<option value="'
        . $this->jsquot(
        '\n  border-left-style: none|hidden|solid|double|groove|ridge|inset|outset|dashed|dotted;'
        ) . '">左ボーダー幅 border-left-style: solid;</option>';
    print '<option value="'
        . $this->jsquot(
        '\n  border-right-style: none|hidden|solid|double|groove|ridge|inset|outset|dashed|dotted;'
        ) . '">右ボーダー幅 border-right-style: solid;</option>';
    print '<option value="'
        . $this->jsquot(
        '\n  border-bottom-style: none|hidden|solid|double|groove|ridge|inset|outset|dashed|dotted;'
        ) . '">下ボーダー幅 border-bottom-style: solid;</option>';
    print '<option value=""></option>';
    print '<option value="'
        . $this->jsquot('\n  border-top: solid 1px #rrggbb;')
        . '">上ボーダー一括指定 border-top: solid 1px #rrggbb;</option>';
    print '<option value="'
        . $this->jsquot('\n  border-left: solid 1px #rrggbb;')
        . '">左ボーダー一括指定 border-left: solid 1px #rrggbb;</option>';
    print '<option value="'
        . $this->jsquot('\n  border-right: solid 1px #rrggbb;')
        . '">右ボーダー一括指定 border-right: solid 1px #rrggbb;</option>';
    print '<option value="'
        . $this->jsquot('\n  border-bottom: solid 1px #rrggbb;')
        . '">下ボーダー一括指定 border-bottom: solid 1px #rrggbb;</option>';
    print '<option value=""></option>';
    print '<option value="'
        . $this->jsquot('\n  float: left|right|none;')
        . '">回り込み float: left|right|none;</option>';
    print '<option value="'
        . $this->jsquot('\n  clear: left|right|both|none;')
        . '">回り込み解除 clear: left|right|both|none;</option>';
    print '<option value=""></option>';
    print '<option value="'
        . $this->jsquot(
        '\n  list-style-type: none|disc|circle|square|lower-roman|upper-roman|decimal|decimal-leading-zero|lower-latin|upper-latin;'
        )
        . '">リストのマーカー list-style-type: none|disc|decimal;</option>';
    print '<option value="'
        . $this->jsquot('\n  list-style-image: url(&quot;&quot;);')
        . '">リストのマーカー画像 list-style-image: url(&quot;&quot;);</option>';
    print '<option value="'
        . $this->jsquot('\n  list-style-position: outside|inside;')
        . '">リストのマーカー画像位置 list-style-position: outside|inside;</option>';
    print '<option value=""></option>';
    print '<option value="'
        . $this->jsquot(
        '\n  opacity: 0.;\n  -moz-opacity: 0.;\n  -webkit-opacity: 0.;\n  -o-opacity: 0.;\n  -ms-filter:"alpha(opacity=)";\n  filter:alpha(opacity=);'
        ) . '">透明度  opacity: 0.x;</option>';
    print '<option value=""></option>';
    print '<option value="'
        . $this->jsquot(
        '\n  border-radius: px|em|%;\n  -moz-border-radius: px|em|%;\n  -webkit-border-radius: px|em|%;\n  -o-border-radius: px|em|%;\n  -ms-border-radius: px|em|%;'
        ) . '">角丸半径  border-radius: px|em|%;</option>';
    print '<option value="'
        . $this->jsquot(
        '\n  border-radius-topleft: px|em|%;\n  -moz-border-radius-topleft: px|em|%;\n  -webkit-border-top-left-radius: px|em|%;\n  -o-border-top-left-radius: px|em|%;\n  -ms-border-top-left-radius: px|em|%;'
        ) . '">上左角丸半径  border-radius-topleft: px|em|%;</option>';
    print '<option value="'
        . $this->jsquot(
        '\n  border-radius-topright: px|em|%;\n  -moz-border-radius-topright: px|em|%;\n  -webkit-border-top-right-radius: px|em|%;\n  -o-border-top-right-radius: px|em|%;\n  -ms-border-top-right-radius: px|em|%;'
        ) . '">上右角丸半径  border-radius-topright: px|em|%;</option>';
    print '<option value="'
        . $this->jsquot(
        '\n  border-radius-bottomleft: px|em|%;\n  -moz-border-radius-bottomleft: px|em|%;\n  -webkit-border-bottom-left-radius: px|em|%;\n  -o-border-bottom-left-radius: px|em|%;\n  -ms-border-bottom-left-radius: px|em|%;'
        )
        . '">下左角丸半径  border-radius-bottomleft: px|em|%;</option>';
    print '<option value="'
        . $this->jsquot(
        '\n  border-radius-bottomright: px|em|%;\n  -moz-border-radius-bottomright: px|em|%;\n  -webkit-border-bottom-right-radius: px|em|%;\n  -o-border-bottom-right-radius: px|em|%;\n  -ms-border-bottom-right-radius: px|em|%;'
        )
        . '">下右角丸半径  border-radius-bottomright: px|em|%;</option>';
    print '<option value=""></option>';
    print '<option value="'
        . $this->jsquot(
        '\n  box-shadow: 10px 10px 5px #888;\n  -moz-box-shadow: 10px 10px 5px #888;\n  -webkit-box-shadow: 10px 10px 5px #888;\n  -o-box-shadow: 10px 10px 5px #888;\n  -ms-box-shadow: 10px 10px 5px #888;'
        )
        . '">影付きボックス  box-shadow: 10px 10px 5px #888;</option>';
    print '<option value=""></option>';
    print '<option value="'
        . $this->jsquot(
        '\n  transform: rotate(1deg) scale(1.0,1.0);\n  -moz-transform: rotate(1deg) scale(1.0,1.0);\n  -webkit-transform: rotate(1deg) scale(1.0,1.0);\n  -o-transform: rotate(1deg) scale(1.0,1.0);\n  -ms-transform: rotate(1deg) scale(1.0,1.0);'
        ) . '">変形  transform: rotate(1deg) scale(1.0,1.0);</option>';
    print '</select> ';
    print '<a href="JavaScript:cmonos.tool.colorPalette.open(\'', $name,
        '+\')" ondblclick="cmonos.tool.colorPalette.open(\'', $name,
        '+\',\'window\')"><img src="'
        . $env::image_dir
        . '/tool/palette.gif" alt="パレット" height="12" width="18" border="0" /></a>';
    print '</div> ';
}

1;
