package FieldEditor;
require CMONOS::CGI_Lib::SetUp;
@ISA = qw(SetUp);
use strict;
use utf8;
######################################################################
# フィールド編集モジュール
# FieldEditor.pm ver1.1.8
# Copyright (C) 1999-2018 CMONOS Co. Ltd.
#
# support@cmonos.jp
# http://cmonos.jp/
# 最終更新日：2015-07-07
######################################################################
# 実行
sub run ($) {
    my $this = shift;
    my ($new_field_id);

    #フィールドデータベースの位置などを取得
    $this->set_field;

    #フィールドモジュール読み込み
    $this->call_field($setting::field);

    if ( defined $main::next && $main::next ) {
        $main::data{'P'}++;
    }
    elsif ( defined $main::prev && $main::prev ) {
        $main::data{'P'}--;
    }

    #全体編集書き込み
    if ( defined $main::a && $main::a eq 'e' ) {
        no warnings qw(numeric);
        my ( %old, %redundancy_forbidden, $no );
        push( @main::delete, $main::delete )
            if defined $main::delete && $main::delete;
        @main::delete = grep( defined $_ && $_ ne '', @main::delete );
        %redundancy_forbidden = ();

        #不正なデータの除去
        push( @check::checkbox, 'required', 'cookie' );
        while ( my ( $k, $v ) = each %main::order ) {
            foreach (@check::checkbox) {
                $main::data{ $k . '_' . $_ } = ''
                    if !defined $main::data{ $k . '_' . $_ }
                    || $main::data{ $k . '_' . $_ } eq '';
            }
            $main::data{ $k . '_pkg' }
                = $Field::modules{ $main::data{ $k . '_class' } };
            $this->detag( \$main::data{ $k . '_name' } );
            $this->field_setting_check($k);
        }

        #表示順データ読み込み
        %old
            = $this->import_order(
            $default::field_pref_dir . '/' . $setting::field_db_name,
            \%main::order, \%redundancy_forbidden );

        #データ削除
        if (@main::delete) {

            #順序判定への影響を回避
            foreach (@main::delete) {
                delete $old{$_};
                delete $main::order{$_};
            }
            $this->delete_field(@main::delete);
        }

        #順序判定
        $no = 0;
        foreach my $id (
            sort {
                (          defined $main::order{$a}
                        && defined $main::order{$b}
                        && $main::order{$a} <=> $main::order{$b} )
                    || ( defined $old{$b}
                    && defined $old{$a}
                    && $old{$b} <=> $old{$a} )
                    || ( defined $main::order{$a}
                    && defined $main::order{$b}
                    && $main::order{$a} cmp $main::order{$b} )
                    || $a <=> $b
            } keys %old
            )
        {

            $no++;
            $main::data{ 'ORDER_' . $no } = $id;
            $main::data{ $id . '_ORDER' } = $no;
            if (@field::redundancy_forbidden) {
                if (defined
                    $redundancy_forbidden{ $main::data{ $id . '_class' } }
                    && $redundancy_forbidden{ $main::data{ $id . '_class' } }
                    )
                {
                    if ($redundancy_forbidden{ $main::data{ $id . '_class' } }
                        ne $id )
                    {
                        push(
                            @{ $this->{'dialog'} },
                            'ID:'
                                . $id
                                . 'のフィールドタイプを変更してください。「'
                                . $Field::fieldname{ $main::data{ $id
                                        . '_class' } }
                                . '」はすでに存在しています。'
                        );
                        delete $main::data{ $id . '_class' };
                    }
                }
                elsif (
                    grep( $_ eq $main::data{ $id . '_class' },
                        @field::redundancy_forbidden )
                    )
                {
                    $redundancy_forbidden{ $main::data{ $id . '_class' } }
                        = $id;
                }
            }
        }

        #新規作成
        if ( defined $main::copy && !@main::copy ) {
            @main::copy = ($main::copy);
            undef $main::copy;
        }
        if ( @main::copy
            || ( defined $main::new{'name'} && $main::new{'name'} ne '' ) )
        {
            my $n = 0;
            while (1) {
                $n++;
                last if !defined $old{$n} || $old{$n} eq '';
            }
            if (@main::copy) {
                my %old_data = ();
                $this->import_db(
                    $default::field_pref_dir . '/' . $setting::field_db_name,
                    \%old_data, 1, @main::copy );
                foreach my $i (@main::copy) {
                    next
                        if !$i
                        || $i =~ /[^0-9]/
                        || !ref $old_data{$i}
                        || !$old_data{$i}{'class'}
                        || ( @field::redundancy_forbidden
                        && $redundancy_forbidden{ $old_data{$i}{'class'} } );
                    $no++;
                    $main::data{ 'ORDER_' . $no } = $n;
                    $main::data{ $n . '_ORDER' } = $no;
                    while ( my ( $k, $v ) = each %{ $old_data{$i} } ) {
                        $main::data{ $n . '_' . $k }
                            = ( defined $main::data{ $i . '_' . $k } )
                            ? $main::data{ $i . '_' . $k }
                            : $v
                            if defined $v && $k ne 'ORDER';
                    }
                    $main::data{ $n . '_pkg' }
                        = $Field::modules{ $main::data{ $n . '_class' } };
                    $this->detag( \$main::data{ $n . '_name' } );
                    $main::data{ $n . '_name' }
                        =~ s/([0-9]*):/(($1) ? $1+1 : 2) . ':'/ges;
                    $this->field_setting_check($n);
                    @main::delete = grep( $_ ne $n, @main::delete );
                    $n++;
                }
            }
            if ( defined $main::new{'name'} && $main::new{'name'} ne '' ) {
                if (   @field::redundancy_forbidden
                    && $redundancy_forbidden{ $main::new{'class'} } )
                {
                    $main::id = '';
                    push(
                        @{ $this->{'dialog'} },
                        '新規フィールドのフィールドタイプを変更してください。「'
                            . $Field::fieldname{ $main::new{'class'} }
                            . '」はすでに存在しています。'
                    );
                }
                else {
                    $no++;
                    $new_field_id                 = $n;
                    $main::data{ 'ORDER_' . $no } = $n;
                    $main::data{ $n . '_ORDER' }  = $no;
                    while ( my ( $k, $v ) = each %main::new ) {
                        $main::data{ $n . '_' . $k } = $v;
                    }
                    $main::data{ $n . '_pkg' }
                        = $Field::modules{ $main::data{ $n . '_class' } };
                    $this->detag( \$main::data{ $n . '_name' } );
                    $this->field_setting_check($n);
                    $main::id = $n if $main::id && $main::id eq 'new';
                    @main::delete = grep( $_ ne $n, @main::delete );
                }
            }
        }
        elsif ( defined $main::id && $main::id eq 'new' ) {
            $main::id = '';
            push(
                @{ $this->{'dialog'} },
                '新規フィールド名が入力されていません。'
            );
        }

        undef %old;
        $this->field_general_setting_check;
        $this->write_db(
            $default::field_pref_dir . '/' . $setting::field_db_name,
            \%main::data, 'ORDER', \@main::delete, \%setting::field, 1 );

        #フィールド定義書き込み
    }
    elsif (defined $main::id
        && defined $main::a
        && $main::id ne ''
        && $main::a eq 'd' )
    {
        my $field = Field->new( $main::class, $main::id );
        $field->set();
        $field->is_valid_setting;
        $this->write_db(
            $default::field_pref_dir . '/' . $setting::field_db_name,
            \%main::data, '', '', \%setting::field, 1 );
        undef %$field;
        undef $field;
    }
    undef(%main::data);

    #フィールドオブジェクト作成
    $this->use_field(
        'field',
        $default::field_pref_dir . '/' . $setting::field_db_name,
        $setting::field,
        $setting::field_style_disabled,
        $setting::field_tag_enabled,
        $setting::field_tag_name,
        1
    );
    $this->mk_field($new_field_id) if defined $new_field_id && $new_field_id;

    #フィールド定義パネル
    if ( defined $main::id && $main::id ne '' && ref $field::obj{$main::id} )
    {

        #ページヘッダ
        $this->jump_menu( 'tools', 'field' );
        $this->print_page_header('tools');

        #前後フィールド
        print '<fieldset class="toolbox" id="toolnavi">';
        print $this->form_start(
            'key'      => 'tools',
            'name'     => 'fieldlist',
            'required' => \@setting::form
        );
        print '<input type="submit" value="一覧" />';
        print '</form>';

        my ( $prev, $next );
        print $this->form_start(
            'key'      => 'tools',
            'name'     => 'fieldselector',
            'required' => \@setting::form
        );
        print '<select name="id" onchange="submit()">';
        foreach my $i ( sort { $a <=> $b } keys %field::ORDER ) {
            next unless ref $field::obj{ $field::ORDER{$i} };
            $prev = $i if $i < $field::obj{$main::id}->{'ORDER'};
            $next = $i if !$next && $i > $field::obj{$main::id}->{'ORDER'};
            print '<option value="'
                . $field::ORDER{$i} . '"'
                . ( ( $main::id && $main::id == $field::ORDER{$i} )
                ? ' selected="selected"'
                : '' )
                . '>'
                . $this->jfold( $field::obj{ $field::ORDER{$i} }->name,
                32, 'I', 1 )
                . '</option>';
        }
        print '</select><input type="submit" value="選択" />';
        print '</form>';

        if ( $prev && $prev > 0 ) {
            print $this->form_start(
                'key'      => 'tools',
                'name'     => 'prevfield',
                'required' => \@setting::form
            );
            print '<input type="submit" name="id='
                . $field::ORDER{$prev}
                . '" value="前のフィールド" />';
            print '</form>';
        }
        if ( $next && $next > 1 ) {
            print $this->form_start(
                'key'      => 'tools',
                'name'     => 'nextfield',
                'required' => \@setting::form
            );
            print '<input type="submit" name="id='
                . $field::ORDER{$next}
                . '" value="次のフィールド" />';
            print '</form>';
        }
        print '</fieldset>';

        print '<h1>'
            . ( ( $setting::jump_menu{$main::k} )
            ? $setting::jump_menu{$main::k} . '／'
            : '' )
            . 'フィールド定義</h1>';

        print $this->form_start(
            'key'      => 'tools',
            'name'     => 'input',
            'method'   => 'post',
            'required' => \@setting::form
        );
        print '<input type="hidden" name="id" value="'
            . $this->escape($main::id) . '" />';
        print '<input type="hidden" name="class" value="'
            . $field::obj{$main::id}->{'class'} . '" />';
        print '<input type="hidden" name="a" value="d" />';
        $field::obj{$main::id}
            ->print_setting_form( $this->is_not_html, $this->tips );

        #フィールド編集パネル
    }
    else {

        #ページヘッダ
        $this->set_onload(
            'cmonos.element.tagClass(\'th\',\'foldable\',\'td\',\'foldable\').disappear(true);'
        ) if $this->{'foldable'} && $main::foldup;
        $this->jump_menu( 'tools', 'field' );
        $this->print_page_header('tools');

        print '<h1>'
            . ( ( $setting::jump_menu{$main::k} )
            ? $setting::jump_menu{$main::k} . '／'
            : '' )
            . 'フィールド編集</h1>';

        print $this->form_start(
            'key'      => 'tools',
            'name'     => 'input',
            'method'   => 'post',
            'required' => \@setting::form
        );
        print '<input type="hidden" name="a" value="e" />';
        print '<fieldset><legend>フィールド編集</legend>';

        #テーブル設定
        require CMONOS::CGI_Lib::Table;
        my $table = Table->new;
        $table->set(
            'tableclass' => 'tooltable',
            'trclass'    => 'odd,even',
            'class0'     => 'odd,even',
            'style0'     => 'white-space: nowrap;text-align: center;',
            'classF'     => 'caution foldable',
            'thenabled'  => 'true'
        );

        #ページ
        my ( @field_no, $lastpage, $prev, $next, $from, $to, $count );
        @field_no = sort {
            $this->sort_by( \$field::obj{$a}{'ORDER'},
                \$field::obj{$b}{'ORDER'} )
        } keys %field::obj;
        $lastpage
            = ( @field_no && $field::U )
            ? ( ( @field_no % $field::U )
            ? int( @field_no / $field::U ) + 1
            : @field_no / $field::U )
            : 1;
        if ( !$field::P || $field::P < 1 ) {
            $field::P = 1;
        }
        elsif ( $field::P > $lastpage ) {
            $field::P = $lastpage;
        }
        ( $from, $to )
            = ( ( $field::U * ( $field::P - 1 ) ), ( $field::U * $field::P ) )
            if $field::U;

        print '(' . $field::P . '/' . $lastpage . ' ページ)';
        my @foldable;
        if ( defined $this->{'foldable'} && $this->{'foldable'} ) {
            print
                ' <label><input type="checkbox" name="foldup" value="1" onclick="cmonos.element.tagClass(\'th\',\'foldable\',\'td\',\'foldable\').disappear(this.checked);"'
                . ( ($main::foldup) ? ' checked="checked"' : '' )
                . ' /> 折り畳む</label>';
        }
        print $table->table;

        #ヘッダ
        print $table->tr;
        print $table->td('削除');
        print $table->td( 'コピー', { 'class' => 'even foldable' } );
        print $table->td( '表示順', { 'class' => 'odd foldable' } );
        print $table->td('ID');
        print $table->td('フィールド名');
        print $table->td( '必須項目', { 'class' => 'even foldable' } );
        print $table->td( '記憶',       { 'class' => 'odd foldable' } );
        print $table->td( 'フィールドタイプ',
            { 'class' => 'even foldable' } );
        print $table->td( '詳細設定', { 'class' => 'odd foldable' } );
        $this->print_setting_item_name($table);
        print $table->_tr;

        #設定項目
        foreach my $id (@field_no) {
            next unless ref $field::obj{$id};
            my $order = $field::obj{$id}{'ORDER'};
            $count++;

            #ページ
            if ($field::U) {
                if ( $from >= $count ) {
                    $prev = 1;
                    next;
                }
                elsif ( $to < $count ) {
                    $next = 1;
                    last;
                }
            }

            print $table->tr;
            print $table->td(
                      '<input type="checkbox" name="delete" value="'
                    . $id
                    . '" onclick="cmonos.form.field(this).checkboxConfirm(\''
                    . $this->escape_except_html_entity(
                    $field::obj{$id}->{'name'}
                    )
                    . ' に関連する全てのデータが削除されます。本当に削除しますか？\')" title="'
                    . $this->escape_except_html_entity(
                    $field::obj{$id}->{'name'}
                    )
                    . ' に関連する全てのデータを削除する" />'
            );
            print $table->td(
                (   (   @field::redundancy_forbidden
                            && grep( $_ eq $field::obj{$id}->{'class'},
                            @field::redundancy_forbidden )
                    )
                    ? '&nbsp;'
                    : '<input type="checkbox" name="copy" value="'
                        . $id
                        . '" title="'
                        . $this->escape_except_html_entity(
                        $field::obj{$id}->{'name'}
                        )
                        . ' をコピーして新規フィールドを作成する" />'
                ),
                { 'class' => 'odd foldable' }
            );
            print $table->td(
                '<input type="number" name="order:'
                    . $id
                    . '" value="'
                    . $count
                    . '" size="2" maxlength="2" />',
                { 'class' => 'even foldable' }
            );
            print $table->td($id);
            if ( defined $this->{'long_name_enabled'}
                && $this->{'long_name_enabled'} )
            {
                print $table->td( '<textarea name="data:'
                        . $id
                        . '_name" rows="3" cols="30" title="[フィールドグループ名:]フィールド名">'
                        . $field::obj{$id}->{'name'}
                        . '</textarea>' );
            }
            else {
                print $table->td( '<input type="text" name="data:'
                        . $id
                        . '_name" value="'
                        . $field::obj{$id}->{'name'}
                        . '" size="20" title="[フィールドグループ名:]フィールド名" />'
                );
            }
            if ( $field::obj{$id}->required_enabled ) {
                print $table->td(
                    '<input type="checkbox" name="data:'
                        . $id
                        . '_required" value="1"'
                        . (
                        (   defined $field::obj{$id}->{'required'}
                                && $field::obj{$id}->{'required'}
                        ) ? ' checked="checked"' : ''
                        )
                        . ' title="'
                        . $this->escape_except_html_entity(
                        $field::obj{$id}->{'name'}
                        )
                        . ' を必須項目にする" />',
                    { 'class' => 'odd foldable' }
                );
            }
            else {
                print $table->td( '', { 'class' => 'odd foldable' } );
            }
            if ( $field::obj{$id}->cookie_enabled ) {
                print $table->td(
                    '<input type="checkbox" name="data:'
                        . $id
                        . '_cookie" value="1"'
                        . (
                        (   defined $field::obj{$id}->{'cookie'}
                                && $field::obj{$id}->{'cookie'}
                        ) ? ' checked="checked"' : ''
                        )
                        . ' title="'
                        . $this->escape_except_html_entity(
                        $field::obj{$id}->{'name'}
                        )
                        . ' を Cookie に記憶する" />',
                    { 'class' => 'even foldable' }
                );
            }
            else {
                print $table->td( '', { 'class' => 'even foldable' } );
            }
            print $table->td(
                $field::obj{$id}->menu( 'data:' . $id . '_class' ),
                { 'class' => 'odd foldable' } );
            print $table->td(
                '<input type="submit" name="id='
                    . $id
                    . '" value="詳細設定" title="現在の設定を保存して詳細設定を開きます。" />',
                { 'class' => 'even foldable' }
            );
            $this->print_setting_items( $table, $field::obj{$id},
                'data:' . $id . '_', $id );
            print $table->_tr;
        }

        #新規作成
        if ( !defined $next || !$next ) {
            my $field = Field->new( 'text', 'NEW' );
            $field->set();
            print $table->tr;
            print $table->td('&nbsp;');
            print $table->td( '&nbsp;', { 'class' => 'odd foldable' } );
            print $table->td( '&nbsp;', { 'class' => 'even foldable' } );
            print $table->td('新規');
            if ( defined $this->{'long_name_enabled'}
                && $this->{'long_name_enabled'} )
            {
                print $table->td(
                    '<textarea name="new:name" rows="3" cols="30"></textarea>'
                );
            }
            else {
                print $table->td(
                    '<input type="text" name="new:name" size="20" />');
            }
            print $table->td(
                '<input type="checkbox" name="new:required" value="1" title="このフィールド を必須項目にする" />',
                { 'class' => 'odd foldable' }
            );
            print $table->td(
                '<input type="checkbox" name="new:cookie" value="1" title="このフィールド を Cookie に記憶する" />',
                { 'class' => 'even foldable' }
            );
            print $table->td( $field->menu('new:class'),
                { 'class' => 'odd foldable' } );
            print $table->td(
                '<input type="submit" name="id=new" value="詳細設定" title="現在の設定を保存して詳細設定を開きます。" />',
                { 'class' => 'even foldable' }
            );

            $this->print_setting_items( $table, $field, 'new:', '' );

            undef %$field;
            undef $field;

            print $table->_tr;
        }

        print $table->_table;

        print $this->note;
        print
            '</fieldset><fieldset class="submit"><label>表示数 <input type="number" name="data:U" value="'
            . $this->escape($field::U)
            . '" size="3" maxlength="3" /></label>';
        print '<input type="submit" name="prev" value="前のページ" />'
            if defined $prev && $prev;
        print '<input type="submit" name="next" value="次のページ" />'
            if defined $next && $next;
        print '<input type="hidden" name="data:P" value="'
            . $field::P
            . '" /><input type="submit" value="保存" class="save" /></fieldset>';

        $this->print_sub_setting_items;

        undef %$table;
        undef $table;

    }
    print '</form>';

    #ページフッタ
    $this->print_page_footer('tools');
}

sub field_setting_check ($$) {
    my ( $this, $k ) = @_;
    return;
}

sub field_general_setting_check ($) {
    my $this = shift;
    return;
}

sub note ($) {
    my $this = shift;
    return;
}

sub import_order ($$$$) {
    no warnings "untie";
    my ( $this, $db, $order, $redundancy_forbidden ) = @_;
    my ( %db, @fields );
    use Fcntl qw(:DEFAULT);
    eval 'use ' . $env::dbm_file . ';';
    tie( %db, $env::dbm_file, $db, O_RDONLY, $env::dbm_mode );
    if ( ref tied %db ) {
        my ( $key, $value, %order );
        while ( ( $key, $value ) = each %db ) {
            utf8::decode($key)   if !utf8::is_utf8($key);
            utf8::decode($value) if !utf8::is_utf8($value);
            if ( $key =~ /^ORDER_(.*)$/ ) {
                $order{$value}  = $1;
                $$order{$value} = $1
                    unless defined $$order{$value} && $$order{$value} ne '';
            }
            elsif ( $key =~ /^([0-9]+)_class$/ ) {
                my $id = $1;
                push( @fields, $id );
                if (   @field::redundancy_forbidden
                    && grep( $_ eq $value, @field::redundancy_forbidden )
                    && !grep( $_ eq $id, @main::delete )
                    && ( !defined $main::data{ $id . '_class' }
                        || $main::data{ $id . '_class' } eq $value )
                    )
                {
                    $$redundancy_forbidden{$value} = $1;
                }
            }
        }
        untie %db;
        foreach my $id (@fields) {
            $order{$id} = 999 if !defined $order{$id};
        }
        return %order;
    }
    else {
        untie %db;
        my ($dbname);
        $dbname = '\n' . $1 if $db ne $env::register_db && $db =~ m!([^/]+)$!;
        push(
            @{ $this->{'dialog'} },
            'フィールド設定データベースの読み込みに失敗しました。このまま作業を続けると既に存在する設定が失われる可能性があります。'
        );
        return ();
    }
}

sub mk_field ($$) {
    my ( $this, $id ) = @_;
    return 1;
}

sub is_not_html ($) {
    my $this = shift;
    return 0;
}

sub set_field ($) {
    my $this = shift;
    push(
        @{ $this->{'dialog'} },
        'スクリプトエラー：フィールド編集モジュールに異常があります。'
    );
    $this->print_error_dialog('tools');
}

sub print_setting_item_name ($$) {
    my ( $this, $table ) = @_;
    return;
}

sub print_setting_items ($$$$$) {
    my ( $this, $table, $field, $name, $id ) = @_;
    return;
}

sub print_sub_setting_items ($) {
    my ($this) = @_;
    return;
}

sub delete_field ($@) {
    my ( $this, @delete ) = @_;
    return;
}

sub tips ($) {
    my $this = shift;
    return;
}

1;
