package TogglerLib;
require CMONOS::CGI_Lib::Tools::ButtonLib;
@ISA = qw(ButtonLib);
use strict;
use utf8;
######################################################################
# トグルボタンライブラリ編集モジュール
# TogglerLib.pm ver1.0
# Copyright (C) 1999-2018 CMONOS Co. Ltd.
#
# support@cmonos.jp
# http://cmonos.jp/
# 最終更新日：2011-09-19
######################################################################
sub erace_image_css ($) {
    my $this = shift;
    $this->replace_image_css( $main::dir . '-' . $main::id );
}

######################################################################
# メニュー
sub menu ($$;$$$$) {
    my ( $this, $name, $lib_dir, $id, $list ) = @_;
    return $this->{'deco_obj'}
        ->toggler_menu( $name, $main::dir, $id, 1, $list, $lib_dir );
}

######################################################################
# 素材ライブラリCSSチェック
sub image_css_is_ready ($$$$) {
    my ( $this, $image_lib, $dir, $setting ) = @_;
    my $image_css = $image_lib . '/' . $dir . '/image.css';
    if ( !-f $image_css ) {
        my $css = $this->make_image_css( $image_lib, $dir, 1 );
        $this->write_file( $image_css, \$css );
    }
    return 1;
}

sub make_image_css ($$$;$$) {
    my ( $this, $image_dir, $dir, $is_image_lib, $setting ) = @_;
    my @dirs = $this->get_image_dir_list( $image_dir, $dir );
    my $css = '';
    my $id;
    foreach $id (@dirs) {
        my %image_info = ();
        my $class_name = $dir . '-' . ( ($is_image_lib) ? 'lib-' : '' ) . $id;
        %image_info = $this->get_toggler_settings( $dir, $id, $is_image_lib );
        $css .= "\x0A\x0A"
            . $this->mk_image_css_for_toggler( $class_name, \%image_info,
            $dir, $id, $is_image_lib );
        $this->add_setting_hash( $setting, \%image_info, $dir, $id )
            if !$is_image_lib
            && ref $setting
            && defined $setting::deco_option{$dir}
            && $setting::deco_option{$dir} eq 'save_all'
            && %image_info;
    }
    return $css;
}

sub mk_image_css_for_toggler ($$$$$;$) {
    my ( $this, $class_name, $setting, $dir, $id, $is_image_lib ) = @_;
    return '' if !$setting->{'a'};
    my $image_dir = (
        ($is_image_lib) ? '.' : $this->base_change(
            $this->{'deco_obj'}->{'image_dir'} . '/' . $dir,
            $this->{'image_css'}
        )
        )
        . '/'
        . $id;
    my $css = '/* ' . $class_name . ' start */' . "\x0A";
    $css
        .= 'span.'
        . $class_name
        . '-a, span.'
        . $class_name
        . '-b, span.'
        . $class_name
        . '-c, span.'
        . $class_name
        . '-active, span.'
        . $class_name
        . '-a-active, span.'
        . $class_name
        . '-b-active, span.'
        . $class_name
        . '-c-active, ';
    $css
        .= 'input.'
        . $class_name
        . '-a, input.'
        . $class_name
        . '-b, input.'
        . $class_name
        . '-c, input.'
        . $class_name
        . '-active, input.'
        . $class_name
        . '-a-active, input.'
        . $class_name
        . '-b-active, input.'
        . $class_name
        . '-c-active';
    $css .= ' {' . "\x0A";
    $css .= '  border: none !important;' . "\x0A";
    $css .= '  width: ' . $setting->{'awidth'} . 'px;' . "\x0A";
    $css .= '  height: ' . $setting->{'aheight'} . 'px;' . "\x0A";
    $css
        .= '  background: transparent url("'
        . $image_dir . '/'
        . $setting->{'a'}
        . '") no-repeat center !important;' . "\x0A";
    $css .= '  vertical-align: middle;' . "\x0A";
    $css .= '  overflow: hidden;' . "\x0A";
    $css .= '  text-align: left;' . "\x0A";
    $css .= '  text-indent: -999px;' . "\x0A";
    $css .= '  font-size: 1px;' . "\x0A";
    $css .= '  line-height: 1px;' . "\x0A";
    $css .= '  /text-indent: 0;' . "\x0A";
    $css .= '  /font-size: 0;' . "\x0A";
    $css .= '  /line-height: 0;' . "\x0A";
    $css .= '  _text-indent: 0;' . "\x0A";
    $css .= '  _font-size: 0;' . "\x0A";
    $css .= '  _line-height: 0;' . "\x0A";
    $css .= '}' . "\x0A";
    $css
        .= 'span.'
        . $class_name
        . '-a, span.'
        . $class_name
        . '-b, span.'
        . $class_name
        . '-c, span.'
        . $class_name
        . '-active, span.'
        . $class_name
        . '-a-active, span.'
        . $class_name
        . '-b-active, span.'
        . $class_name
        . '-c-active';
    $css .= ' {' . "\x0A";
    $css .= '  display: -moz-inline-box;' . "\x0A";
    $css .= '  display: inline-block;' . "\x0A";
    $css .= '  /display: inline;' . "\x0A";
    $css .= '  /zoom: 1;' . "\x0A";
    $css .= '  _display: inline;' . "\x0A";
    $css .= '  _zoom: 1;' . "\x0A";
    $css .= '}' . "\x0A";
    $css
        .= 'input.'
        . $class_name
        . '-a, input.'
        . $class_name
        . '-b, input.'
        . $class_name
        . '-c, input.'
        . $class_name
        . '-active, input.'
        . $class_name
        . '-a-active, input.'
        . $class_name
        . '-b-active, input.'
        . $class_name
        . '-c-active';
    $css .= ' {' . "\x0A";
    $css .= '  cursor: pointer !important;' . "\x0A";
    $css .= '  /padding-left: 999px;' . "\x0A";
    $css .= '  _padding-left: 999px;' . "\x0A";
    $css .= '}' . "\x0A";

    if ( $setting->{'b'} ) {
        $css
            .= 'span.'
            . $class_name
            . '-b, input.'
            . $class_name . '-b {' . "\x0A";
        $css .= '  width: ' . $setting->{'bwidth'} . 'px;' . "\x0A";
        $css .= '  height: ' . $setting->{'bheight'} . 'px;' . "\x0A";
        $css
            .= '  background: transparent url("'
            . $image_dir . '/'
            . $setting->{'b'}
            . '") no-repeat center !important;' . "\x0A";
        $css .= '}' . "\x0A";
    }
    if ( $setting->{'c'} ) {
        $css
            .= 'span.'
            . $class_name
            . '-c, input.'
            . $class_name . '-c {' . "\x0A";
        $css .= '  width: ' . $setting->{'cwidth'} . 'px;' . "\x0A";
        $css .= '  height: ' . $setting->{'cheight'} . 'px;' . "\x0A";
        $css
            .= '  background: transparent url("'
            . $image_dir . '/'
            . $setting->{'c'}
            . '") no-repeat center !important;' . "\x0A";
        $css .= '}' . "\x0A";
    }
    if ( $setting->{'active'} ) {
        $css
            .= 'span.'
            . $class_name
            . '-active, input.'
            . $class_name
            . '-active, ';
        $css
            .= 'span.'
            . $class_name
            . '-a-active, input.'
            . $class_name
            . '-a-active, ';
        $css
            .= 'span.'
            . $class_name
            . '-b-active, input.'
            . $class_name
            . '-b-active, ';
        $css
            .= 'span.'
            . $class_name
            . '-c-active, input.'
            . $class_name
            . '-c-active';
        $css .= ' {' . "\x0A";
        $css .= '  width: ' . $setting->{'activewidth'} . 'px;' . "\x0A";
        $css .= '  height: ' . $setting->{'activeheight'} . 'px;' . "\x0A";
        $css
            .= '  background: transparent url("'
            . $image_dir . '/'
            . $setting->{'active'}
            . '") no-repeat center !important;' . "\x0A";
        $css .= '}' . "\x0A";
    }
    $css .= '/* ' . $class_name . ' end */' . "\x0A";
    return $css;
}

sub get_toggler_settings ($$$;$) {
    my ( $this, $dir, $id, $is_image_lib ) = @_;
    my %data;
    $dir
        = ( ($is_image_lib)
        ? $this->{'deco_obj'}->{'image_lib'}
        : $this->{'deco_obj'}->{'image_dir'} )
        . '/'
        . $dir . '/'
        . $id;
    if ( -f "$dir/a.gif" ) {
        $data{'a'} = 'a.gif';
    }
    elsif ( -f "$dir/a.jpg" ) {
        $data{'a'} = 'a.jpg';
    }
    elsif ( -f "$dir/a.png" ) {
        $data{'a'} = 'a.png';
    }
    else {
        return ();
    }
    ( $data{'awidth'}, $data{'aheight'} )
        = $cgi::Image->info("$dir/$data{'a'}")
        if $data{'a'};
    if ( -f "$dir/b.gif" ) {
        $data{'b'} = 'b.gif';
    }
    elsif ( -f "$dir/b.jpg" ) {
        $data{'b'} = 'b.jpg';
    }
    elsif ( -f "$dir/b.png" ) {
        $data{'b'} = 'b.png';
    }
    ( $data{'bwidth'}, $data{'bheight'} )
        = $cgi::Image->info("$dir/$data{'b'}")
        if $data{'b'};
    if ( -f "$dir/c.gif" ) {
        $data{'c'} = 'c.gif';
    }
    elsif ( -f "$dir/c.jpg" ) {
        $data{'c'} = 'c.jpg';
    }
    elsif ( -f "$dir/c.png" ) {
        $data{'c'} = 'c.png';
    }
    ( $data{'cwidth'}, $data{'cheight'} )
        = $cgi::Image->info("$dir/$data{'c'}")
        if $data{'c'};
    if ( -f "$dir/active.gif" ) {
        $data{'active'} = 'active.gif';
    }
    elsif ( -f "$dir/active.jpg" ) {
        $data{'active'} = 'active.jpg';
    }
    elsif ( -f "$dir/active.png" ) {
        $data{'active'} = 'active.png';
    }
    ( $data{'activewidth'}, $data{'activeheight'} )
        = $cgi::Image->info("$dir/$data{'active'}")
        if $data{'active'};
    return %data;
}

######################################################################
# 設定フォーム
sub print_setting_form ($) {
    my $this = shift;
}

######################################################################
# 画像設定登録
sub set_image ($) {
    my $this       = shift;
    my $class_name = $main::dir . '-' . $main::id;
    $this->replace_image_css(
        $class_name,
        $this->mk_image_css_for_toggler(
            $class_name,
            { $this->get_toggler_settings( $main::dir, $main::id ) },
            $main::dir, $main::id
        )
    );
}

######################################################################
# アップロードフォーム
sub print_upload_form ($$) {
    my ( $this, $save_button ) = @_;
    print
        '<fieldset id="toggler-uploader"><legend>オリジナルトグルボタン (画像A、画像B、画像C は必須です)</legend>';
    print '<table class="field-table"><tbody>';
    print
        '<tr><td class="field-name"><label for="image:a">画像A (初期画像)</label></td><td class="field"><input type="file" name="image:a" id="image:a" /></td></tr>';
    print
        '<tr><td class="field-name"><label for="image:b">画像B</label></td><td class="field"><input type="file" name="image:b" id="image:b" /></td></tr>';
    print
        '<tr><td class="field-name"><label for="image:c">画像C</label></td><td class="field"><input type="file" name="image:c" id="image:c" /></td></tr>';
    print
        '<tr><td class="field-name"><label for="image:active">処理中画像</label></td><td class="field"><input type="file" name="image:active" id="image:active" /></td></tr>';
    print '</tbody></table>';
    print '<div class="submit"><input type="submit" value="'
        . $save_button
        . '" /></div></fieldset>';
}

sub unlink_my_files ($) {
    my $this = shift;
    $this->unlink_image_files( $this->get_my_files );
}

sub is_invalid_images ($) {
    my $this = shift;
    if (   !$cgi::input->get_posted_file_size_from_param('image:a')
        || !$cgi::input->get_posted_file_size_from_param('image:b')
        || !$cgi::input->get_posted_file_size_from_param('image:c') )
    {
        push(
            @{ $cgi::action->{'dialog'} },
            '画像A(初期画像)、画像B、画像C は必須です。'
        ) if ref $cgi::action;
        return 1;
    }
    else {
        return 0;
    }
    return 0;
}

sub get_my_files ($) {
    my $this = shift;
    return ( 'a', 'b', 'c', 'active' );
}

######################################################################
# クラス登録
#sub import {
BEGIN {
    #クラス登録
    $ImageLib::modules{'toggler'} = 'TogglerLib';
}

1;
