package UserGeneratedFieldEditorBase;
require CMONOS::CGI_Lib::SetUp;
@ISA = qw(SetUp);
use strict;
use utf8;
######################################################################
# ユーザー作成フィールドエディタモジュール
# UserGeneratedFieldEditorBase.pm ver1.0.1
# Copyright (C) 1999-2018 CMONOS Co. Ltd.
#
# support@cmonos.jp
# http://cmonos.jp/
# 最終更新日：2008-08-21
######################################################################
# 実行
sub run ($) {
    my $this = shift;
    $this->error404
        if !defined $main::id
        || $main::id eq ''
        || !ref $field::obj{$main::id}
        || !$field::obj{$main::id}->editor_enabled;
    $this->unauthorized_alert
        if !$field::obj{$main::id}->is_secure_user_for_edit;
    $field::obj{$main::id}->user_generated_field_edit if $main::action;
    $field::obj{$main::id}->set_user_generated_field_editor_page_settings;
    $this->unauthorized_alert
        if !$field::obj{$main::id}->print_user_generated_field_editor;
}

######################################################################
sub unauthorized_alert ($) {
    my $this = shift;
    @setting::form = ( 'm', 'k', 'id', 'c', 'n', 'p', 'chap', 'sect' );
    $this->print_password_check_form($setting::key);
}

######################################################################
# モジュール読み込み
#sub import {
BEGIN {
    #クッキー
    $cookie::id_enabled = 1;    #ID情報クッキー読み込み

    $setting::security_key                               = 'ugfieldeditor';
    $setting::key                                        = 'ugfieldeditor';
    $setting::security{'ugfieldeditor'}{'passwordCheck'} = 'nocheck';
    $main::k                                             = 'ugfieldeditor';

    $setting::general  = 1;     #一般設定読み込み
    $setting::deco     = 1;     #テキスト装飾設定読み込み
    $setting::security = 1;     #アクセス権設定読み込み
    $setting::table    = 1;     #テーブル設定読み込み
    $setting::page     = 0;     #ページ設定読み込み

    #フィールド読み込み設定
    $setting::field_db_name = 'inputfield'
        if !$setting::field_db_name;    #フィールド設定DB
    $setting::field = 2
        ; #フィールド設定読み込み（2=オリジナルも読み込む）
    $setting::field_style_disabled = 0
        ; #2=フォント設定スタイル設定を無視/1=フォント設定のみ無視
    $setting::field_tag_enabled
        = 'no'; #tag=タグのみ/all=全ての設定/no=タグをつけない

#ツールページ設定
#	$setting::page{'ugfieldeditor'}{'title'} = '環境設定';
#	$setting::page{'ugfieldeditor'}{'text'} = '#000000';
#	$setting::page{'ugfieldeditor'}{'link'} = '#0000ff';
#	$setting::page{'ugfieldeditor'}{'alink'} = '#99ffff';
#	$setting::page{'ugfieldeditor'}{'vlink'} = '#000099';
#	$setting::page{'ugfieldeditor'}{'hover'} = '#00ffff';
#	$setting::page{'ugfieldeditor'}{'nodeco'} = 'no';
#	$setting::page{'ugfieldeditor'}{'bgcolor'} = '#ffffff';
#	$setting::page{'ugfieldeditor'}{'bodyId'} = 'ugfieldeditor';
#	$setting::page{'ugfieldeditor'}{'cssFileName'} = 'ugfieldeditor.css';
# 	$setting::page{'ugfieldeditor'}{'CSS'} = 'h1 { font-size: large; font-weight: bold; text-indent: 1em; font-family: "ヒラギノ角ゴ Pro W3",Osaka,"ＭＳ Ｐゴシック",sans-serif;}' . "\x0A";
# 	$setting::page{'ugfieldeditor'}{'CSS'} .= 'h2 { font-size: medium; font-weight: bold; font-family: "ヒラギノ角ゴ Pro W3",Osaka,"ＭＳ Ｐゴシック",sans-serif;}' . "\x0A";
# 	$setting::page{'ugfieldeditor'}{'CSS'} .= 'hr { border-width: 1 0 0 0; }';
# 	$setting::page{'ugfieldeditor'}{'background'} = '';
# 	$setting::page{'ugfieldeditor'}{'bgproperties'} = '';
# 	$setting::page{'ugfieldeditor'}{'topmargin'} = '';
# 	$setting::page{'ugfieldeditor'}{'leftmargin'} = '';
# 	$setting::page{'ugfieldeditor'}{'javascript'} = '';
# 	$setting::page{'ugfieldeditor'}{'header'} = '';
# 	$setting::page{'ugfieldeditor'}{'headerFileName'} = '';
# 	$setting::page{'ugfieldeditor'}{'titleImageAlign'} = '';
# 	$setting::page{'ugfieldeditor'}{'titleImage'} = '';
# 	$setting::page{'ugfieldeditor'}{'align'} = '';
# 	$setting::page{'ugfieldeditor'}{'width'} = '';
# 	$setting::page{'ugfieldeditor'}{'deco'} = '';
# 	$setting::page{'ugfieldeditor'}{'titleText'} = '';

}

1;
