package WayPointsKML;
require CMONOS::CGI_Lib::Common;
@ISA = qw(Common);
use strict;
use utf8;
use Fcntl qw(:flock);
######################################################################
# 簡易KMLツール
# CMONOS::CGI_Lib::WayPointsKML.pm ver1.0
# Copyright (C) 1999-2018 CMONOS Co. Ltd.
#
# support@cmonos.jp
# http://cmonos.jp/
# 最終更新日：2015-02-05
######################################################################
# オブジェクトを作る。
sub new ($$$$;$) {
    my ( $pkg, $path, $field_obj, $field_for, $parent_path ) = @_;
    my $this = {
        'kml'       => $path,
        'field_obj' => $field_obj,
        'field_for' => $field_for,
        'parent'    => $parent_path,
    };
    bless $this;
    $env::file_mode = 0644 if !$env::file_mode;
    return $this;
}

sub get_coordinates_from_data ($$) {
    my ( $this, $this_data ) = @_;
    if ( $this->{'field_for'}{'coordinates'}
        && ref $this->{'field_obj'}{ $this->{'field_for'}{'coordinates'} } )
    {
        if ( defined $this_data->{ $this->{'field_for'}{'coordinates'} }{'m'}
            && $this_data->{ $this->{'field_for'}{'coordinates'} }{'m'} ne ''
            && $this_data->{ $this->{'field_for'}{'coordinates'} }{'c'} )
        {
            return ( $this_data->{ $this->{'field_for'}{'coordinates'} }{'c'}
                    =~ /^(-?[0-9\.]+),(-?[0-9\.]+)$/ ) ? $2 . ',' . $1 : '';
        }
        elsif ($this_data->{ $this->{'field_for'}{'coordinates'} }{'kml'}
            && $this_data->{ $this->{'field_for'}{'coordinates'} }{'p'} )
        {
            return ( $this_data->{ $this->{'field_for'}{'coordinates'} }{'p'}
                    =~ /^(-?[0-9\.]+),(-?[0-9\.]+)$/ ) ? $2 . ',' . $1 : '';
        }
        elsif ( $this_data->{ $this->{'field_for'}{'coordinates'} }{'c'} ) {
            return ( $this_data->{ $this->{'field_for'}{'coordinates'} }{'c'}
                    =~ /^(-?[0-9\.]+),(-?[0-9\.]+)$/ ) ? $2 . ',' . $1 : '';
        }
        elsif ( $this_data->{ $this->{'field_for'}{'coordinates'} }{'str'} ) {
            my %data
                = $this->{'field_obj'}{ $this->{'field_for'}{'coordinates'} }
                ->elements(
                $this_data->{ $this->{'field_for'}{'coordinates'} }{'str'} );
            if ( defined $data{'m'} && $data{'m'} ne '' && $data{'c'} ) {
                return ( $data{'c'} =~ /^(-?[0-9\.]+),(-?[0-9\.]+)$/ )
                    ? $2 . ',' . $1
                    : '';
            }
            elsif ( $data{'kml'} && $data{'p'} ) {
                return ( $data{'p'} =~ /^(-?[0-9\.]+),(-?[0-9\.]+)$/ )
                    ? $2 . ',' . $1
                    : '';
            }
            elsif ( $data{'c'} ) {
                return ( $data{'c'} =~ /^(-?[0-9\.]+),(-?[0-9\.]+)$/ )
                    ? $2 . ',' . $1
                    : '';
            }
        }
    }
    if ( $this->{'field_for'}{'media'}
        && ref $this->{'field_obj'}{ $this->{'field_for'}{'media'} } )
    {
        if ( defined $this_data->{ $this->{'field_for'}{'media'} }{'latlng'}
            && $this_data->{ $this->{'field_for'}{'media'} }{'latlng'} ne '' )
        {
            return ( $this_data->{ $this->{'field_for'}{'media'} }{'latlng'}
                    =~ /^(-?[0-9\.]+),(-?[0-9\.]+)$/ ) ? $2 . ',' . $1 : '';
        }
        elsif ( $this_data->{ $this->{'field_for'}{'media'} }{'str'} ) {
            my %data
                = $this->{'field_obj'}{ $this->{'field_for'}{'media'} }
                ->elements(
                $this_data->{ $this->{'field_for'}{'media'} }{'str'} );
            if ( defined $data{'latlng'} && $data{'latlng'} ne '' ) {
                return ( $data{'latlng'} =~ /^(-?[0-9\.]+),(-?[0-9\.]+)$/ )
                    ? $2 . ',' . $1
                    : '';
            }
        }
    }
    if ( $this->{'field_for'}{'media2'}
        && ref $this->{'field_obj'}{ $this->{'field_for'}{'media2'} } )
    {
        if ( defined $this_data->{ $this->{'field_for'}{'media2'} }{'latlng'}
            && $this_data->{ $this->{'field_for'}{'media2'} }{'latlng'} ne
            '' )
        {
            return ( $this_data->{ $this->{'field_for'}{'media2'} }{'latlng'}
                    =~ /^(-?[0-9\.]+),(-?[0-9\.]+)$/ ) ? $2 . ',' . $1 : '';
        }
        elsif ( $this_data->{ $this->{'field_for'}{'media2'} }{'str'} ) {
            my %data
                = $this->{'field_obj'}{ $this->{'field_for'}{'media2'} }
                ->elements(
                $this_data->{ $this->{'field_for'}{'media2'} }{'str'} );
            if ( defined $data{'latlng'} && $data{'latlng'} ne '' ) {
                return ( $data{'latlng'} =~ /^(-?[0-9\.]+),(-?[0-9\.]+)$/ )
                    ? $2 . ',' . $1
                    : '';
            }
        }
    }
    if ( $this->{'field_for'}{'media3'}
        && ref $this->{'field_obj'}{ $this->{'field_for'}{'media3'} } )
    {
        if ( defined $this_data->{ $this->{'field_for'}{'media3'} }{'latlng'}
            && $this_data->{ $this->{'field_for'}{'media3'} }{'latlng'} ne
            '' )
        {
            return ( $this_data->{ $this->{'field_for'}{'media3'} }{'latlng'}
                    =~ /^(-?[0-9\.]+),(-?[0-9\.]+)$/ ) ? $2 . ',' . $1 : '';
        }
        elsif ( $this_data->{ $this->{'field_for'}{'media3'} }{'str'} ) {
            my %data
                = $this->{'field_obj'}{ $this->{'field_for'}{'media3'} }
                ->elements(
                $this_data->{ $this->{'field_for'}{'media3'} }{'str'} );
            if ( defined $data{'latlng'} && $data{'latlng'} ne '' ) {
                return ( $data{'latlng'} =~ /^(-?[0-9\.]+),(-?[0-9\.]+)$/ )
                    ? $2 . ',' . $1
                    : '';
            }
        }
    }
    return '';
}

sub get_icon_from_data ($$$) {
    my ( $this, $this_data, $file_dir ) = @_;
    my ( $w, $h, $pw, $ph, $href, $phref );
    if (   ref $this->{'field_obj'}
        && ref $this->{'field_for'}
        && $this->{'field_for'}{'media'}
        && ref $this->{'field_obj'}{ $this->{'field_for'}{'media'} } )
    {
        my $this_image
            = ( $this_data->{ $this->{'field_for'}{'media'} }{'type'} )
            ? $this_data->{ $this->{'field_for'}{'media'} }
            : ( $this_data->{ $this->{'field_for'}{'media'} }{'str'} ) ? {
            $this->{'field_obj'}{ $this->{'field_for'}{'media'} }->elements(
                $this_data->{ $this->{'field_for'}{'media'} }{'str'}
            )
            }
            : {};
        if (   $this_image->{'previewtype'}
            && $this_image->{'previewwidth'}
            && $this_image->{'previewheight'} )
        {
            ( $w, $h ) = $cgi::Image->image_fit(
                $this_image->{'previewwidth'},
                $this_image->{'previewheight'},
                48, 48
            );
            ( $pw, $ph ) = $cgi::Image->image_fit(
                $this_image->{'previewwidth'},
                $this_image->{'previewheight'},
                200, 200
            );
            $href = $phref
                = $file_dir . '/'
                . $this->{'field_for'}{'media'}
                . '.preview.'
                . $this_image->{'previewtype'};
        }
        elsif ( $this_image->{'type'}
            && grep( $this_image->{'type'} eq $_, 'gif', 'jpg', 'jpeg',
                'png' )
            && $this_image->{'width'}
            && $this_image->{'height'} )
        {
            ( $w, $h ) = $cgi::Image->image_fit(
                $this_image->{'width'},
                $this_image->{'height'},
                48, 48
            );
            ( $pw, $ph ) = $cgi::Image->image_fit(
                $this_image->{'width'},
                $this_image->{'height'},
                200, 200
            );
            $href
                = $phref
                = $file_dir . '/'
                . $this->{'field_for'}{'media'}
                . (
                (   defined $this_image->{'name'}
                        && $this_image->{'name'} ne ''
                ) ? '.' . $this_image->{'name'} : ''
                )
                . '.'
                . $this_image->{'type'};
        }
    }
    if (   !$href
        && ref $this->{'field_obj'}
        && ref $this->{'field_for'}
        && $this->{'field_for'}{'media2'}
        && ref $this->{'field_obj'}{ $this->{'field_for'}{'media2'} } )
    {
        my $this_image
            = ( $this_data->{ $this->{'field_for'}{'media2'} }{'type'} )
            ? $this_data->{ $this->{'field_for'}{'media2'} }
            : ( $this_data->{ $this->{'field_for'}{'media2'} }{'str'} ) ? {
            $this->{'field_obj'}{ $this->{'field_for'}{'media2'} }->elements(
                $this_data->{ $this->{'field_for'}{'media2'} }{'str'}
            )
            }
            : {};
        if (   $this_image->{'previewtype'}
            && $this_image->{'previewwidth'}
            && $this_image->{'previewheight'} )
        {
            ( $w, $h ) = $cgi::Image->image_fit(
                $this_image->{'previewwidth'},
                $this_image->{'previewheight'},
                48, 48
            );
            ( $pw, $ph ) = $cgi::Image->image_fit(
                $this_image->{'previewwidth'},
                $this_image->{'previewheight'},
                200, 200
            );
            $href = $phref
                = $file_dir . '/'
                . $this->{'field_for'}{'media2'}
                . '.preview.'
                . $this_image->{'previewtype'};
        }
        elsif ( $this_image->{'type'}
            && grep( $this_image->{'type'} eq $_, 'gif', 'jpg', 'jpeg',
                'png' )
            && $this_image->{'width'}
            && $this_image->{'height'} )
        {
            ( $w, $h ) = $cgi::Image->image_fit(
                $this_image->{'width'},
                $this_image->{'height'},
                48, 48
            );
            ( $pw, $ph ) = $cgi::Image->image_fit(
                $this_image->{'width'},
                $this_image->{'height'},
                200, 200
            );
            $href
                = $phref
                = $file_dir . '/'
                . $this->{'field_for'}{'media2'}
                . (
                (   defined $this_image->{'name'}
                        && $this_image->{'name'} ne ''
                ) ? '.' . $this_image->{'name'} : ''
                )
                . '.'
                . $this_image->{'type'};
        }
    }
    if (   !$href
        && ref $this->{'field_obj'}
        && ref $this->{'field_for'}
        && $this->{'field_for'}{'media3'}
        && ref $this->{'field_obj'}{ $this->{'field_for'}{'media3'} } )
    {
        my $this_image
            = ( $this_data->{ $this->{'field_for'}{'media3'} }{'type'} )
            ? $this_data->{ $this->{'field_for'}{'media3'} }
            : ( $this_data->{ $this->{'field_for'}{'media3'} }{'str'} ) ? {
            $this->{'field_obj'}{ $this->{'field_for'}{'media3'} }->elements(
                $this_data->{ $this->{'field_for'}{'media3'} }{'str'}
            )
            }
            : {};
        if (   $this_image->{'previewtype'}
            && $this_image->{'previewwidth'}
            && $this_image->{'previewheight'} )
        {
            ( $w, $h ) = $cgi::Image->image_fit(
                $this_image->{'previewwidth'},
                $this_image->{'previewheight'},
                48, 48
            );
            ( $pw, $ph ) = $cgi::Image->image_fit(
                $this_image->{'previewwidth'},
                $this_image->{'previewheight'},
                200, 200
            );
            $href = $phref
                = $file_dir . '/'
                . $this->{'field_for'}{'media3'}
                . '.preview.'
                . $this_image->{'previewtype'};
        }
        elsif ( $this_image->{'type'}
            && grep( $this_image->{'type'} eq $_, 'gif', 'jpg', 'jpeg',
                'png' )
            && $this_image->{'width'}
            && $this_image->{'height'} )
        {
            ( $w, $h ) = $cgi::Image->image_fit(
                $this_image->{'width'},
                $this_image->{'height'},
                48, 48
            );
            ( $pw, $ph ) = $cgi::Image->image_fit(
                $this_image->{'width'},
                $this_image->{'height'},
                200, 200
            );
            $href
                = $phref
                = $file_dir . '/'
                . $this->{'field_for'}{'media3'}
                . (
                (   defined $this_image->{'name'}
                        && $this_image->{'name'} ne ''
                ) ? '.' . $this_image->{'name'} : ''
                )
                . '.'
                . $this_image->{'type'};
        }
    }
    if (   ref $this->{'field_obj'}
        && ref $this->{'field_for'}
        && $this->{'field_for'}{'coordinates'}
        && ref $this->{'field_obj'}{ $this->{'field_for'}{'coordinates'} } )
    {
        my $gmap = $this->{'field_for'}{'coordinates'};
        if (   defined $this_data->{$gmap}{'mk'}
            && $this_data->{$gmap}{'mk'} ne ''
            && $this_data->{$gmap}{'width'}
            && $this_data->{$gmap}{'height'} )
        {
            $href = $this_data->{$gmap}{'mk'};
            $w    = $this_data->{$gmap}{'width'};
            $h    = $this_data->{$gmap}{'height'};
        }
        elsif (
            $this_data->{ $this->{'template'}->{'field_for'}{'coordinates'} }
            {'str'} )
        {
            my %data
                = $this->{'template'}->{'field_obj'}
                { $this->{'template'}->{'field_for'}{'coordinates'} }
                ->elements(
                $this_data->{ $this->{'template'}
                        ->{'field_for'}{'coordinates'} }{'str'} );
            if (   defined $data{'mk'}
                && $data{'mk'} ne ''
                && $data{'width'}
                && $data{'height'} )
            {
                $href = $data{'mk'};
                $w    = $data{'width'};
                $h    = $data{'height'};
            }
        }
    }
    if ($href) {
        return {
            'href'           => $href,
            'width'          => $w,
            'height'         => $h,
            'anchorx'        => int( $w / 2 ),
            'anchory'        => int( $h / 2 ),
            'thumnailhref'   => ( ($phref) ? $phref : $href ),
            'thumnailwidth'  => ( ($phref) ? $pw : $w ),
            'thumnailheight' => ( ($phref) ? $ph : $h ),
        };
    }
    return {};
}

sub update ($$$$) {
    my ( $this, $target, $data, $file_dir ) = @_;
    return 0
        if !$this->{'kml'}
        || !ref $this->{'field_obj'}
        || !ref $this->{'field_for'};
    my $is_updated      = 0;
    my $new_place       = '';
    my $new_place_title = '';
    my $kml             = '';
    my $gmap_field
        = (    ref $this->{'field_obj'}
            && ref $this->{'field_for'}
            && $this->{'field_for'}{'coordinates'}
            && ref $this->{'field_obj'}{ $this->{'field_for'}{'coordinates'} }
        )
        ? $this->{'field_obj'}{ $this->{'field_for'}{'coordinates'} }
        : undef;
    my $style_id
        = ( ref $gmap_field && $gmap_field->{'defaultMarker'} )
        ? 'defaultIcon'
        : 'temporaryIcon';

    if (   $this->{'field_for'}{'title'}
        && ref $this->{'field_obj'}{ $this->{'field_for'}{'title'} }
        && defined $data->{ $this->{'field_for'}{'title'} }{'str'}
        && $data->{ $this->{'field_for'}{'title'} }{'str'} ne '' )
    {
        $new_place_title = $this->detag_text(
            $this->{'field_obj'}{ $this->{'field_for'}{'title'} }
                ->usual_format(
                $data->{ $this->{'field_for'}{'title'} }{'str'}
                )
        );
        $new_place_title
            =~ s/\&(?!(?:#[0-9]{2,6}|#x[a-fA-F0-9]+|[a-zA-Z0-9]{2,10});)/\&amp;/g;
    }
    my $new_place_coordinate = $this->get_coordinates_from_data($data);

    local (*KML);
    if ( -f $this->{'kml'} ) {
        if ( open( KML, $this->{'kml'} ) ) {
            binmode KML, ":utf8";
            flock( KML, LOCK_SH );
            $kml = join( '', <KML> );
            close(KML);
        }
        else {
            return 0;
        }
    }
    if ( $new_place_title ne '' && $new_place_coordinate ) {
        my $icon = $this->get_icon_from_data( $data, $file_dir );
        $new_place .= '  <Placemark>' . "\x0A";
        $new_place .= '    <name>' . $new_place_title . "</name>\x0A";
        $new_place .= '    <description><![CDATA[';
        $new_place
            .= '<div><strong><a href="'
            . $this->escape($target)
            . '" target="_parent" style="font-size:14px;text-decoration:none;">'
            . $new_place_title
            . '</a></div>';
        if ( $icon->{'thumnailwidth'} ) {
            $new_place
                .= '<div style="text-align:center"><a href="'
                . $this->escape($target)
                . '" target="_parent"><img src="'
                . $icon->{'thumnailhref'}
                . '" width="'
                . $icon->{'thumnailwidth'}
                . '" height="'
                . $icon->{'thumnailheight'}
                . '" border="0" /></a></div>';
        }
        $new_place .= "]]></description>\x0A";
        $new_place .= '    <atom:link href="'
            . $this->escape($target) . '" />' . "\x0A";
        if ( $icon->{'href'} ) {
            $new_place .= '    <Style>' . "\x0A";
            $new_place .= '      <IconStyle>' . "\x0A";
            $new_place .= '        <Icon>' . "\x0A";
            $new_place
                .= '          <href>' . $icon->{'href'} . '</href>' . "\x0A";
            $new_place
                .= '          <width>'
                . $icon->{'width'}
                . '</width>' . "\x0A";
            $new_place
                .= '          <height>'
                . $icon->{'height'}
                . '</height>' . "\x0A";
            $new_place
                .= '          <anchorx>'
                . $icon->{'anchorx'}
                . '</anchorx>' . "\x0A";
            $new_place
                .= '          <anchory>'
                . $icon->{'anchory'}
                . '</anchory>' . "\x0A";
            $new_place .= '        </Icon>' . "\x0A";
            $new_place .= '      </IconStyle>' . "\x0A";
            $new_place .= '    </Style>' . "\x0A";
        }
        else {
            $new_place
                .= '    <styleUrl>#' . $style_id . '</styleUrl>' . "\x0A";
        }
        $new_place .= '    <Point>' . "\x0A";
        $new_place
            .= '      <coordinates>'
            . $new_place_coordinate
            . '</coordinates>' . "\x0A";
        $new_place .= '    </Point>' . "\x0A";
        $new_place .= '  </Placemark>' . "\x0A";
    }
    if ($kml) {
        my $new_kml = '';
        my $done    = 0;
        while (
            $kml =~ /([\t\x20]*<Placemark>.*?<\/Placemark>[\x0A\x0D]*)/sg )
        {
            my $place_mark = $1;
            my $tag        = $2;
            my $link
                = ( $place_mark
                    =~ /<atom:link(?![0-9a-zA-Z_])[^>]*[\x09\x0A\x0C\x0D\x20]+href="([^"]*?)"[^>]*\/>/
                ) ? $this->unescape($1) : 0;
            if ( $link eq $target ) {
                $new_kml .= $new_place if !$done++;
            }
            else {
                $new_kml .= $place_mark;
            }
        }
        $new_kml .= $new_place if !$done;
        $kml = $new_kml;
    }
    else {
        $kml = $new_place;
    }
    if ( open( KML, '>>' . $this->{'kml'} ) ) {
        binmode KML, ":utf8";
        flock( KML, LOCK_EX );
        truncate( KML, 0 );
        seek( KML, 0, 0 );
        print KML '<?xml version="1.0" encoding="UTF-8"?>', "\x0A";
        print KML
            '<kml xmlns="http://earth.google.com/kml/2.2" xmlns:atom="http://www.w3.org/2005/Atom">',
            "\x0A";
        print KML '<Document>', "\x0A";
        print KML '  <atom:link href="' . $this->{'parent'} . '" />', "\x0A"
            if $this->{'parent'};

        if ( $style_id eq 'defaultIcon' ) {
            print KML '  <Style id="defaultIcon">', "\x0A";
            print KML '    <IconStyle>',            "\x0A";
            print KML '      <Icon>',               "\x0A";
            print KML '        <href>'
                . $gmap_field->{'defaultMarker'}
                . '</href>', "\x0A";
            print KML '        <width>'
                . $gmap_field->{'defaultMarkerWidth'}
                . '</width>', "\x0A";
            print KML '        <height>'
                . $gmap_field->{'defaultMarkerHeight'}
                . '</height>', "\x0A";
            print KML '        <anchorx>'
                . $gmap_field->{'defaultMarkerAnchorX'}
                . '</anchorx>', "\x0A";
            print KML '        <anchory>'
                . $gmap_field->{'defaultMarkerAnchorY'}
                . '</anchory>', "\x0A";
            print KML '      </Icon>',    "\x0A";
            print KML '    </IconStyle>', "\x0A";
            print KML '  </Style>',       "\x0A";
        }
        else {
            print KML '  <Style id="temporaryIcon">', "\x0A";
            print KML '    <IconStyle>',              "\x0A";
            print KML '      <Icon>',                 "\x0A";
            print KML
                '        <href>http://maps.google.com/mapfiles/ms/micons/red-dot.png</href>',
                "\x0A";
            print KML '        <width>32</width>',     "\x0A";
            print KML '        <height>32</height>',   "\x0A";
            print KML '        <anchorx>16</anchorx>', "\x0A";
            print KML '        <anchory>32</anchory>', "\x0A";
            print KML
                '        <shadow>http://maps.google.com/mapfiles/ms/micons/msmarker.shadow.png</shadow>',
                "\x0A";
            print KML '        <swidth>59</swidth>',   "\x0A";
            print KML '        <sheight>32</sheight>', "\x0A";
            print KML '      </Icon>',                 "\x0A";
            print KML '    </IconStyle>',              "\x0A";
            print KML '  </Style>',                    "\x0A";
        }
        print KML $kml;
        print KML '</Document>', "\x0A";
        print KML '</kml>',      "\x0A";
        close(KML);
        return 1;
    }
    return 0;
}

1;
