package CalSearch;
require CMONOS::Calendar::CalCommon;
@ISA = qw(CalCommon);
use strict;
use utf8;
######################################################################
# カレンダーイベント検索フォーム表示モジュール
# CalSearch.pm ver1.0.6
# Copyright (C) 1999-2018 CMONOS Co. Ltd.
#
# support@cmonos.jp
# http://cmonos.jp/
# 最終更新日：2014-12-08
######################################################################
# オブジェクト作成
sub new ($) {
    my $pkg  = shift;
    my $this = {};
    bless $this, $pkg;
    return $this;
}

######################################################################
#イベントリスト
sub print_events ($) {
    my $this = shift;

    #検索フレーム
    if ( defined $setting::page{$setting::key}{'searchFrameTitle'}
        && $setting::page{$setting::key}{'searchFrameTitle'} )
    {
        print $this->frame_start(
            $setting::page{$setting::key}{'searchFrame'},
            $setting::page{$setting::key}{'searchFrameWidth'},
            'box',
            'calendar-search-frame',
            '<h2>イベント検索</h2>',
        );
    }
    else {
        print $this->frame_start(
            $setting::page{$setting::key}{'searchFrame'},
            $setting::page{$setting::key}{'searchFrameWidth'},
            'box',
            'calendar-search-frame',
        );
        print '<h2>イベント検索</h2>';
    }

    #フォーム
    print $this->form_start(
        'key'      => 'browse',
        'name'     => 'input',
        'required' => (
              ($default::subdivided)
            ? [ 'k', 'm', 'date', 'c' ]
            : [ 'k', 'm', 'date' ]
        )
    );

    print '<table class="field-table"><tbody>';
    print '<tr>';
    print
        '<td class="field-name"><label for="search:freq">繰り返し</label></td>';
    print '<td class="field">';
    print $this->mk_select_menu(
        'search:freq', '', '', $main::search{'freq'},
        ''   => '',
        '1'  => '繰り返す予定のみ',
        '-1' => '繰り返す予定を除外',
    );
    print '</td>';
    print '</tr>';

    my $title_field
        = ( $field::for{'title'} ) ? $field::for{'title'}
        : ( $field::for{'key'} )  ? $field::for{'key'}
        : ( $field::for{'name'} ) ? $field::for{'name'}
        :                           "";
    my $search_count = 0;
    foreach ( sort { $a <=> $b } keys %field::ORDER ) {
        if (ref $field::obj{ $field::ORDER{$_} }
            && (   $field::ORDER{$_} eq $title_field
                || $field::obj{ $field::ORDER{$_} }->{'class'} eq
                'xcal_category'
                || ( defined $setting::security{'detail'}{'passwordCheck'}
                    && $setting::security{'detail'}{'passwordCheck'} eq
                    'nocheck' )
                || $this->is_one_of_owners
            )
            && !$field::obj{ $field::ORDER{$_} }->{'Hidden'}
            && (   $field::obj{ $field::ORDER{$_} }->{'Open'}
                || $this->is_secure('secret') )
            && $field::obj{ $field::ORDER{$_} }->{'searchEnabled'}
            && $field::obj{ $field::ORDER{$_} }->search_form_enabled
            )
        {
            print $field::obj{ $field::ORDER{$_} }->search_form;
            $search_count++;
        }
    }

    print
        '</tbody><tbody><tr class="tbody-start"><td class="reset-box"><input type="button" value="リセット" onclick="cmonos.form.item(this.form).resetAll(\'search:\')" /></td><td class="submit-box">';
    if ( $search_count > 1 ) {
        if (   $setting::page{$setting::key}{'defaultSearchOparator'}
            && $setting::page{$setting::key}{'defaultSearchOparatorFixed'} )
        {
            print '<input type="hidden" name="and" value="'
                . (
                (   $setting::page{$setting::key}{'defaultSearchOparator'} eq
                        'OR'
                ) ? '0' : '1'
                ) . '" />';
        }
        else {
            print '<select name="and">';
            print '<option value="1">全ての条件に一致</option>';
            print '<option value="0"'
                . (
                (   (   !defined $main::and
                            && $setting::page{$setting::key}
                            {'defaultSearchOparator'}
                            && $setting::page{$setting::key}
                            {'defaultSearchOparator'} eq 'OR'
                    )
                        || (
                        (   defined $main::and
                            || !$setting::page{$setting::key}
                            {'defaultSearchOparator'}
                        )
                        && !$main::and
                        )
                ) ? ' selected="selected"' : ''
                ) . '>いずれかの条件に一致</option>';
            print '</select>';
        }
    }
    if ( !$setting::page{'viewer'}{'viewFixed'} ) {
        print $this->mk_select_menu(
            'v', '予定の表示方法', '', $main::v,
            'd' => '日表示',
            'w' => '週表示',
            'm' => '月表示'
        );
    }
    print '<input type="submit" value="'
        . ( ($default::english) ? 'Search' : '検索' ) . '" />';
    print '</td></tr></tbody></table>';
    print '</form>';

    #検索フレーム終了
    print $this->frame_end(
        $setting::page{$setting::key}{'searchFrame'},
        $setting::page{$setting::key}{'searchFrameWidth'},
        'box', 'calendar-search-frame', 1
    );

}

sub page_title ($$) {
    my ( $this, $date ) = @_;
    return '検索';
}

sub calendar_type ($) {
    my $this = shift;
    return 'search';
}

sub have_timetable ($) {
    my $this = shift;
    return 0;
}

1;
