package CalPreferenceShare;
require CMONOS::CGI_Lib::Tools::PreferenceShare;
@ISA = qw(PreferenceShare);
use strict;
use utf8;
######################################################################
# Calendar 設定の共有モジュール
# CalPreferenceShare.pm ver1.1
# Copyright (C) 1999-2018 CMONOS Co. Ltd.
#
# support@cmonos.jp
# http://cmonos.jp/
#
######################################################################
sub get_shareable_db_info ($$) {
    my ( $this, $shareable_db ) = @_;
    my $default_path
        = ( $env::user_default_dir || $env::default_dir ) . '/calendar';
    if ( $default::subdivided && ( !defined $main::c || $main::c eq '' ) ) {
        $default_path .= '/masterdefault';
        $this->set_dir($default_path);
        %$shareable_db = (
            'general' => {
                'pref_path' => $default::preference_dir . '/general',
                'bak_path'  => $default_path . '/general',
                'pref_type' => '一般設定',
                'pref_id'   => '0000'
            },
            'security' => {
                'pref_path' => $default::preference_dir . '/security',
                'bak_path'  => $default_path . '/security',
                'pref_type' => 'アクセス権設定',
                'pref_id'   => '0001'
            },
            'installmsg' => {
                'pref_path' => $default::preference_dir . '/installmsg',
                'bak_path'  => $default_path . '/installmsg',
                'pref_type' => 'カテゴリー増設通知設定',
                'pref_id'   => '00c1'
            },
            'page' => {
                'pref_path' => $default::preference_dir . '/page',
                'bak_path'  => $default_path . '/page',
                'pref_type' => 'ページレイアウト設定',
                'pref_id'   => 'c010'
            }
        );
    }
    else {
        $default_path .= '/default';
        $this->set_dir( $default_path . '/field' );
        $this->set_dir( $default_path . '/css' );
        %$shareable_db = (
            'general' => {
                'pref_path' => $default::preference_dir . '/general',
                'bak_path'  => $default_path . '/general',
                'pref_type' => '一般設定',
                'pref_id'   => '0000'
            },
            'security' => {
                'pref_path' => $default::preference_dir . '/security',
                'bak_path'  => $default_path . '/security',
                'pref_type' => 'アクセス権設定',
                'pref_id'   => '0001'
            },
            'event_category' => {
                'pref_path' => $default::preference_dir . '/event_category',
                'bak_path'  => $default_path . '/event_category',
                'pref_type' => 'イベントカテゴリー設定',
                'pref_id'   => 'c101'
            },
            'mail' => {
                'pref_path' => $default::preference_dir . '/mail',
                'bak_path'  => $default_path . '/mail',
                'pref_type' => '投稿通知設定',
                'pref_id'   => '00c1'
            },
            'inputfield' => {
                'pref_path' => $default::field_pref_dir . '/inputfield',
                'bak_path'  => $default_path . '/field/inputfield',
                'pref_type' => '入力フィールド設定',
                'pref_id'   => 'c100'
            },
            'page' => {
                'pref_path' => $default::preference_dir . '/page',
                'bak_path'  => $default_path . '/page',
                'pref_type' => 'ページレイアウト設定',
                'pref_id'   => 'c010'
            },
            'thanks' => {
                'pref_path' => $default::preference_dir . '/thanks',
                'bak_path'  => $default_path . '/thanks',
                'pref_type' => '入力お礼設定',
                'pref_id'   => 'c210'
            }
        );
    }
    return;
}

sub share_relational_files ($$$) {
    my ( $this, $target, $id ) = @_;
    if ( grep( $_ eq 'event_category', @$target ) ) {
        $this->file_copy(
            $default::file . '/event-category.css',
            ( $env::user_default_dir || $env::default_dir )
                . '/calendar/default/css/event-category.'
                . $id . '.css'
        );
    }
    return 1;
}

######################################################################
# クラス登録
#sub import {
BEGIN {
    if ($env::default_dir) {

        #クラス登録
        Common::class_register( 'xxbs', 'CalPreferenceShare' );

        #メニュー登録
        $setting::jump_menu{'xxbs'}              = '設定の共有';
        $setting::sub_jump_menu{'share'}{'xxbs'} = '設定の共有';
        $setting::selected_jump_menu{'xxbs'}     = 'xxbs';
    }
}

1;
