package CalendarSetting;
require CMONOS::CGI_Lib::Tools::Preference;
@ISA = qw(Preference);
use strict;
use utf8;
######################################################################
# カレンダー表示設定モジュール
# CalendarSetting.pm ver1.0.2
# Copyright (C) 1999-2018 CMONOS Co. Ltd.
#
# support@cmonos.jp
# http://cmonos.jp/
# 最終更新日：2008-01-07
######################################################################
# 設定チェック項目取得
sub get_setting_items ($) {
    my $this = shift;

    #チェックボックス
    push( @check::checkbox,
        'css',    'bold',        'headerbold',
        'thbold', 'specialwday', 'calcssunembedded' );

    #カラー書式チェック
    $check::color{'bordercolor'} = '枠線色'
        if !defined $check::color{'bordercolor'};
    $check::color{'bgcolor'} = '標準背景色'
        if !defined $check::color{'bgcolor'};
    $check::color{'fontcolor'} = '標準文字色'
        if !defined $check::color{'fontcolor'};
    $check::color{'headerfontcolor'} = '月名文字色'
        if !defined $check::color{'headerfontcolor'};
    $check::color{'thbgcolor'} = '曜日背景色'
        if !defined $check::color{'thbgcolor'};
    $check::color{'thfontcolor'} = '曜日文字色'
        if !defined $check::color{'thfontcolor'};
    $check::color{'saturdaybgcolor'} = '土曜日背景色'
        if !defined $check::color{'saturdaybgcolor'};
    $check::color{'sundaybgcolor'} = '日曜日背景色'
        if !defined $check::color{'sundaybgcolor'};
    $check::color{'holidaybgcolor'} = '休日背景色'
        if !defined $check::color{'holidaybgcolor'};
    $check::color{'specialdaybgcolor'} = '特別日背景色'
        if !defined $check::color{'specialdaybgcolor'};
    $check::color{'specialwdaybgcolor'} = '特別な曜日背景色'
        if !defined $check::color{'specialwdaybgcolor'};

    #数字チェック
    $check::num{'cellpadding'} = 'セル余白'
        if !defined $check::num{'cellpadding'};
    $check::num{'cellspacing'} = '罫線幅'
        if !defined $check::num{'cellspacing'};
    $check::num{'border'} = '枠線幅' if !defined $check::num{'border'};
    $check::num{'cellwidth'} = 'セル幅'
        if !defined $check::num{'cellwidth'};
    $check::num{'cellheight'} = 'セル高'
        if !defined $check::num{'cellheight'};
}

######################################################################
# 設定環境
sub set_preferences ($) {
    my $this = shift;
    $preference::db = 'page'
        if !defined $preference::db
        || $preference::db ne 'page';    # 記録用データベース名
    $preference::submenukey = 'page'
        if !defined $preference::submenukey
        || $preference::submenukey ne 'page';    # サブメニューキー
    $preference::id = 'calendar'
        if !defined $preference::id
        || $preference::id ne 'calendar';        # データキー
    $preference::name = 'カレンダー設定'
        if !defined $preference::name
        || $preference::name ne 'カレンダー設定';  # 設定パネル名
    $preference::title
        = 'カレンダーのレイアウトを設定します。'
        if !defined $preference::title
        || $preference::title ne
        'カレンダーのレイアウトを設定します。';
}

sub set_page_header ($) {
    my $this = shift;
    require CMONOS::CGI_Lib::Calendar;
    $this->{'calendar'} = Calendar->new;
    $this->{'calendar'}->set(
        'jcode' => 'utf8',                                # utf8/euc/jis/sjis
        'css'   => $main::data{'calendar_css'},           # 1=css
        'bg'    => $main::data{'calendar_bg'}
        ,    # 1=テーブルの背面を反映させる
        'cellpadding' => $main::data{'calendar_cellpadding'},  # cellpadding
        'cellspacing' => $main::data{'calendar_cellspacing'},  # cellspacing
        'border'      => $main::data{'calendar_border'},       # border
        'bordercolor' => $main::data{'calendar_bordercolor'},  # bordercolor
        'cellwidth'   => $main::data{'calendar_cellwidth'},    # セル幅
        'cellheight'  => $main::data{'calendar_cellheight'},   # セル高さ
        'cellalign'   => $main::data{'calendar_cellalign'},    # セルalign
        'cellvalign'  => $main::data{'calendar_cellvalign'},   # セルvalign
        'bgcolor'     => $main::data{'calendar_bgcolor'},      # 標準bgcolor
        'fontcolor' => $main::data{'calendar_fontcolor'},    # 標準文字色
        'fontsize'  => $main::data{'calendar_fontsize'}
        ,    # 標準文字サイズ
        'style' => $main::data{'calendar_style'},   # 標準文字スタイル
        'bold'  => $main::data{'calendar_bold'},    # 標準文字太字
        'headerfontcolor' => $main::data{'calendar_headerfontcolor'}
        ,                                           # 月名文字色
        'headerfontsize' => $main::data{'calendar_headerfontsize'}
        ,                                           # 月名文字サイズ
        'headerstyle' => $main::data{'calendar_headerstyle'}
        ,                                           # 月名文字スタイル
        'headerbold' => $main::data{'calendar_headerbold'}
        ,                                           # 月名文字太字
        'thbgcolor'   => $main::data{'calendar_thbgcolor'},    # 曜日bgcolor
        'thfontcolor' => $main::data{'calendar_thfontcolor'}
        ,    # 曜日文字色
        'thfontsize' => $main::data{'calendar_thfontsize'}
        ,    # 曜日文字サイズ
        'thstyle' => $main::data{'calendar_thstyle'}
        ,    # 曜日文字スタイル
        'thbold'    => $main::data{'calendar_thbold'},    # 曜日文字太字
        'linkstyle' => $main::data{'calendar_linkstyle'}
        ,    # リンク文字スタイル
        'linkbold' => $main::data{'calendar_linkbold'}
        ,    # リンク文字太字
        'weekformat' => $main::data{'calendar_weekformat'},    # 曜日
          #（j=日本語/e=英語/f=フル/u=ucfirst/U=大文字/l=小文字）
        'monthformat' => $main::data{'calendar_monthformat'},    # 月
          #（j=日本語/J=陰暦月名/e=英語/f=フル/u=ucfirst/U=大文字/l=小文字）
        'yearformat' => $main::data{'calendar_yearformat'},    # 年
             #（J=年号/w=西暦/j=西暦日本語表記/k=漢字表記）
        'saturdaybgcolor' => $main::data{'calendar_saturdaybgcolor'}
        ,    # 土曜日bgcolor
        'sundaybgcolor' => $main::data{'calendar_sundaybgcolor'}
        ,    # 日曜日bgcolor
        'holidaybgcolor' => $main::data{'calendar_holidaybgcolor'}
        ,    # 休日bgcolor
        'specialdaybgcolor' => $main::data{'calendar_specialdaybgcolor'}
        ,    # 特別な日bgcolor
        'specialwdaybgcolor' => $main::data{'calendar_specialwdaybgcolor'}
        ,    # 特別な曜日bgcolor
        'specialwday' => $main::data{'calendar_specialwday'}
        ,    # 特別な曜日
        'specialwdayexception' => $main::data{'calendar_specialwdayexception'}
        ,    # 特別な曜日例外
        'specialwdayextra' =>
            $main::data{'calendar_specialwdayextra'}   # 特別な曜日追加
    );
    $this->{'calendar_css'} = $this->{'calendar'}->mk_css;
    $this->set_css( $this->{'calendar_css'} );
    $this->set_onload(
        "cmonos.element.tagClass('fieldset','foldable').disappear(true);")
        if !defined $main::unfold || !$main::unfold;
}

######################################################################
# 設定パネル
sub print_preference_panel ($) {
    my $this = shift;
    $this->scalar_to_array( \$main::data{'calendar_specialwday'} );

    print '<input type="hidden" name="id" value="' . $preference::id . '" />';
    print
        '<fieldset class="toggle"><label><input type="checkbox" name="unfold" value="1" onclick="cmonos.element.tagClass(\'fieldset\',\'foldable\').disappear(!this.checked);"'
        . ( ( defined $main::unfold && $main::unfold )
        ? ' checked="checked"'
        : '' )
        . ' /> 詳しい設定を表示する</label></fieldset>';
    print '<fieldset class="sample"><legend>現在の設定</legend>';

    my ( %specialday, %cell, $year, $mon );
    if ( defined $main::data{'calendar_specialday'}
        && $main::data{'calendar_specialday'} )
    {
        while ( $main::data{'calendar_specialday'}
            =~ /^([0-9]{1,2})[\x20]*\/[\x20]*([0-9]{1,2})[\x20]*=[\x20]*(.*?)$/mg
            )
        {
            $specialday{ $1 + 0 }{ $2 + 0 } = $3;
        }
    }
    if ( defined $main::data{'calendar_addition'}
        && $main::data{'calendar_addition'} )
    {
        while ( $main::data{'calendar_addition'}
            =~ /^([0-9]{1,2})[\x20]*\/[\x20]*([0-9]{1,2})[\x20]*=[\x20]*(.*?)$/mg
            )
        {
            $cell{ $1 + 0 }{ $2 + 0 } = $3;
        }
    }
    ( $mon, $year ) = ( localtime(time) )[ 4, 5 ];
    print $this->{'calendar'}
        ->calendar( $year + 1900, $mon + 1, \%specialday, \%cell );
    print '</fieldset>';
    print '<fieldset class="foldable">';
    print '<legend>カレンダーテーブル</legend>';
    print '<table class="field-table">';
    print '<tbody>';
    print '<tr class="tbody-end">';
    print
        '<td class="field-name"><label for="data:calendar_bg">背面</label></td>';
    print '<td class="q-field">';
    print $this->mk_select_menu(
        'data:calendar_bg',
        'カレンダーの背面画像を透過させるか設定します。',
        '', $main::data{'calendar_bg'},
        '1' => '透過させる',
        ''  => '透過させない'
    );
    print '</td>';
    print
        '<td class="field-name"><span class="datatitle">表示方法</span></td>';
    print '<td class="q-field">';
    print '<ol class="checkbox">';
    print
        '<li><label><input type="checkbox" name="data:calendar_css" id="data:calendar_css"  value="1" title="CSSを利用して表示するかどうか設定します。"'
        . (
        (   defined $main::data{'calendar_css'} && $main::data{'calendar_css'}
        ) ? ' checked="checked"' : ''
        ) . ' /> CSS を利用して表示する</label></li>';
    print
        '<li><label><input type="checkbox" name="data:calendar_calcssunembedded" id="data:calendar_calcssunembedded"  value="1" title="CSSをページに埋め込むかどうか設定します。"'
        . (
        (   defined $main::data{'calendar_calcssunembedded'}
                && $main::data{'calendar_calcssunembedded'}
        ) ? ' checked="checked"' : ''
        )
        . ' onclick="cmonos.form.field(this).checkboxConfirm(\'ページに埋め込まない場合、手作業でカレンダー用 CSS を外部 CSS ファイル等にコピーする必要があります。\')" /> CSS をページに埋め込まない</label></li>';
    print '</ol>';
    print '</td>';
    print '</tr>';
    print '</tbody>';
    print '<tbody>';
    print '<tr>';
    print
        '<td class="field-name"><label for="data:calendar_cellpadding">セル間隔</label></td>';
    print
        '<td class="q-field"><input type="text" name="data:calendar_cellpadding" id="data:calendar_cellpadding" value="'
        . $this->escape( $main::data{'calendar_cellpadding'} )
        . '" size="3" maxlength="3" title="カレンダーのセル間隔を設定します。" /> <span class="unit">ピクセル</span></td>';
    print
        '<td class="field-name"><label for="data:calendar_cellspacing">罫線幅</label></td>';
    print
        '<td class="q-field"><input type="text" name="data:calendar_cellspacing" id="data:calendar_cellspacing" value="'
        . $this->escape( $main::data{'calendar_cellspacing'} )
        . '" size="3" maxlength="3" title="カレンダーの罫線幅を設定します。" /> <span class="unit">ピクセル</span></td>';
    print '</tr>';
    print '<tr class="tbody-end">';
    print
        '<td class="field-name"><label for="data:calendar_border">枠線幅</label></td>';
    print
        '<td class="q-field"><input type="text" name="data:calendar_border" id="data:calendar_border" value="'
        . $this->escape( $main::data{'calendar_border'} )
        . '" size="3" maxlength="3" title="カレンダーの枠線幅を設定します。" /> <span class="unit">ピクセル</span></td>';
    print
        '<td class="field-name"><label for="data:calendar_bordercolor">枠線色</label></td>';
    print
        '<td class="q-field"><input type="text" name="data:calendar_bordercolor" id="data:calendar_bordercolor" value="'
        . $this->escape( $main::data{'calendar_bordercolor'} )
        . '" size="7" maxlength="7" onclick="cmonos.tool.colorPalette.open(\'data:calendar_bordercolor\',\'dom\')" onchange="cmonos.validate.field(this).asColor()"'
        . ( ( $main::data{'calendar_bordercolor'} )
        ? ' style="background-color: '
            . $main::data{'calendar_bordercolor'} . '"'
        : '' )
        . ' />';
    print
        ' <a href="JavaScript:cmonos.tool.colorPalette.open(\'data:calendar_bordercolor\')" ondblclick="cmonos.tool.colorPalette.open(\'data:calendar_bordercolor\',\'window\')"><img src="'
        . $env::image_dir
        . '/tool/palette.gif" alt="パレット" height="12" width="18" border="0" /></a>';
    print
        ' <a href="JavaScript:cmonos.tool.colorSlider.open(\'data:calendar_bordercolor\')" ondblclick="cmonos.tool.colorSlider.open(\'data:calendar_bordercolor\',\'window\')"><img src="'
        . $env::image_dir
        . '/tool/picker.gif" alt="カラーピッカー" height="12" width="18" border="0" /></a>';
    print '</td>';
    print '</tr>';
    print '</tbody>';
    print '<tbody>';
    print '<tr>';
    print
        '<td class="field-name"><label for="data:calendar_cellwidth">セル幅</label></td>';
    print
        '<td class="q-field"><input type="text" name="data:calendar_cellwidth" id="data:calendar_cellwidth" value="'
        . $this->escape( $main::data{'calendar_cellwidth'} )
        . '" size="3" maxlength="3" title="カレンダーのセル幅を固定します。" /> <span class="unit">ピクセル</span></td>';
    print
        '<td class="field-name"><label for="data:calendar_cellheight">セル高</label></td>';
    print
        '<td class="q-field"><input type="text" name="data:calendar_cellheight" id="data:calendar_cellheight" value="'
        . $this->escape( $main::data{'calendar_cellheight'} )
        . '" size="3" maxlength="3" title="カレンダーのセル高を固定します。" /> <span class="unit">ピクセル</span></td>';
    print '</tr>';
    print '<tr>';
    print
        '<td class="field-name"><label for="data:calendar_cellalign">水平位置揃え</label></td>';
    print '<td class="q-field">';
    print $this->mk_select_menu(
        'data:calendar_cellalign',
        'セル内容の水平位置を設定します。', '',
        $main::data{'calendar_cellalign'},
        ''       => '',
        'left'   => '左',
        'center' => '中央',
        'right'  => '右'
    );
    print '</td>';
    print
        '<td class="field-name"><label for="data:calendar_cellvalign">垂直位置揃え</label></td>';
    print '<td class="q-field">';
    print $this->mk_select_menu(
        'data:calendar_cellvalign',
        'セル内容の垂直位置を設定します。', '',
        $main::data{'calendar_cellvalign'},
        ''       => '',
        'top'    => '上',
        'middle' => '中央',
        'bottom' => '下'
    );
    print '</td>';
    print '</tr>';
    print '</tbody>';
    print '</table>';
    print '</fieldset>';
    print '<fieldset class="foldable">';
    print '<legend>一般</legend>';
    print '<table class="field-table">';
    print '<tbody>';
    print '<tr>';
    print
        '<td class="field-name"><label for="data:calendar_bgcolor">標準背景色</label></td>';
    print
        '<td class="q-field"><input type="text" name="data:calendar_bgcolor" id="data:calendar_bgcolor" value="'
        . $this->escape( $main::data{'calendar_bgcolor'} )
        . '" size="7" maxlength="7" onclick="cmonos.tool.colorPalette.open(\'data:calendar_bgcolor\',\'dom\')" onchange="cmonos.validate.field(this).asColor()"'
        . ( ( $main::data{'calendar_bgcolor'} )
        ? ' style="background-color: '
            . $main::data{'calendar_bgcolor'} . '"'
        : '' )
        . ' title="カレンダーのセル背景色を設定します。" />';
    print
        ' <a href="JavaScript:cmonos.tool.colorPalette.open(\'data:calendar_bgcolor\')" ondblclick="cmonos.tool.colorPalette.open(\'data:calendar_bgcolor\',\'window\')"><img src="'
        . $env::image_dir
        . '/tool/palette.gif" alt="パレット" height="12" width="18" border="0" /></a>';
    print
        ' <a href="JavaScript:cmonos.tool.colorSlider.open(\'data:calendar_bgcolor\')" ondblclick="cmonos.tool.colorSlider.open(\'data:calendar_bgcolor\',\'window\')"><img src="'
        . $env::image_dir
        . '/tool/picker.gif" alt="カラーピッカー" height="12" width="18" border="0" /></a></td>';
    print
        '<td class="field-name"><label for="data:calendar_fontcolor">標準文字色</label></td>';
    print
        '<td class="q-field"><input type="text" name="data:calendar_fontcolor" id="data:calendar_fontcolor" value="'
        . $this->escape( $main::data{'calendar_fontcolor'} )
        . '" size="7" maxlength="7" onclick="cmonos.tool.colorPalette.open(\'data:calendar_fontcolor\',\'dom\')" onchange="cmonos.validate.field(this).asColor()"'
        . ( ( $main::data{'calendar_fontcolor'} )
        ? ' style="background-color: '
            . $main::data{'calendar_fontcolor'} . '"'
        : '' )
        . ' title="カレンダーの標準文字色を設定します。" />';
    print
        ' <a href="JavaScript:cmonos.tool.colorPalette.open(\'data:calendar_fontcolor\')" ondblclick="cmonos.tool.colorPalette.open(\'data:calendar_fontcolor\',\'window\')"><img src="'
        . $env::image_dir
        . '/tool/palette.gif" alt="パレット" height="12" width="18" border="0" /></a>';
    print
        ' <a href="JavaScript:cmonos.tool.colorSlider.open(\'data:calendar_fontcolor\')" ondblclick="cmonos.tool.colorSlider.open(\'data:calendar_fontcolor\',\'window\')"><img src="'
        . $env::image_dir
        . '/tool/picker.gif" alt="カラーピッカー" height="12" width="18" border="0" /></a></td>';
    print '</tr>';
    print '<tr>';
    print
        '<td class="field-name"><label for="data:calendar_fontsize">標準文字サイズ</label></td>';
    print '<td class="q-field">';
    print $this->mk_select_menu(
        'data:calendar_fontsize', '', '', $main::data{'calendar_fontsize'},
        ''  => '',
        '1' => '小さめ',
        '2' => 'やや小さめ',
        '3' => '標準',
        '4' => 'やや大きめ',
        '5' => '大きめ',
        '6' => 'やや大きい',
        '7' => '大きい'
    );
    print '</td>';
    print
        '<td class="field-name"><span class="datatitle">標準文字</span></td>';
    print
        '<td class="q-field"><label><input type="checkbox" name="data:calendar_bold" id="data:calendar_bold" value="1" title="BOLDにするかどうか設定します。"'
        . (
        (   defined $main::data{'calendar_bold'}
                && $main::data{'calendar_bold'}
        ) ? ' checked="checked"' : ''
        ) . ' /> 太字</label></td>';
    print '</tr>';
    print '<tr>';
    print
        '<td class="field-name"><label for="data:calendar_style">標準スタイル</label></td>';
    print
        '<td class="field" colspan="3"><input type="text" name="data:calendar_style" id="data:calendar_style" value="'
        . $this->escape( $main::data{'calendar_style'} )
        . '" size="50" title="標準のスタイルを設定します。「:」を含まない場合はクラス指定と解釈されます。"/></td>';
    print '</tr>';
    print '</tbody>';
    print '</table>';
    print '</fieldset>';
    print '<fieldset class="foldable">';
    print '<legend>年/月</legend>';
    print '<table class="field-table">';
    print '<tbody>';
    print '<tr>';
    print
        '<td class="field-name"><label for="data:calendar_headerfontcolor">月名文字色</label></td>';
    print
        '<td class="q-field"><input type="text" name="data:calendar_headerfontcolor" id="data:calendar_headerfontcolor" value="'
        . $this->escape( $main::data{'calendar_headerfontcolor'} )
        . '" size="7" maxlength="7" onclick="cmonos.tool.colorPalette.open(\'data:calendar_headerfontcolor\',\'dom\')" onchange="cmonos.validate.field(this).asColor()"'
        . ( ( $main::data{'calendar_headerfontcolor'} )
        ? ' style="background-color: '
            . $main::data{'calendar_headerfontcolor'} . '"'
        : '' )
        . ' title="カレンダーの月名文字色を設定します。" />';
    print
        ' <a href="JavaScript:cmonos.tool.colorPalette.open(\'data:calendar_headerfontcolor\')" ondblclick="cmonos.tool.colorPalette.open(\'data:calendar_headerfontcolor\',\'window\')"><img src="'
        . $env::image_dir
        . '/tool/palette.gif" alt="パレット" height="12" width="18" border="0" /></a>';
    print
        ' <a href="JavaScript:cmonos.tool.colorSlider.open(\'data:calendar_headerfontcolor\')" ondblclick="cmonos.tool.colorSlider.open(\'data:calendar_headerfontcolor\',\'window\')"><img src="'
        . $env::image_dir
        . '/tool/picker.gif" alt="カラーピッカー" height="12" width="18" border="0" /></a></td>';
    print
        '<td class="field-name"><label for="data:calendar_headerfontsize">月名文字サイズ</label></td>';
    print '<td class="q-field">';
    print $this->mk_select_menu(
        'data:calendar_headerfontsize', '', '',
        $main::data{'calendar_headerfontsize'},
        ''  => '',
        '1' => '小さめ',
        '2' => 'やや小さめ',
        '3' => '標準',
        '4' => 'やや大きめ',
        '5' => '大きめ',
        '6' => 'やや大きい',
        '7' => '大きい'
    );
    print '</td>';
    print '</tr>';
    print '<tr>';
    print
        '<td class="field-name"><span class="datatitle">月名文字</span></td>';
    print
        '<td class="field" colspan="3"><label><input type="checkbox" name="data:calendar_headerbold" id="data:calendar_headerbold" value="1" title="BOLDにするかどうか設定します。"'
        . (
        (   defined $main::data{'calendar_headerbold'}
                && $main::data{'calendar_headerbold'}
        ) ? ' checked="checked"' : ''
        ) . ' /> 太字</label></td>';
    print '</tr>';
    print '<tr>';
    print
        '<td class="field-name"><label for="data:calendar_headerstyle">月名スタイル</label></td>';
    print
        '<td class="field" colspan="3"><input type="text" name="data:calendar_headerstyle" id="data:calendar_headerstyle" value="'
        . $this->escape( $main::data{'calendar_headerstyle'} )
        . '" size="50" title="月名のスタイルを設定します。「:」を含まない場合はクラス指定と解釈されます。"/></td>';
    print '</tr>';
    print '</tbody>';
    print '</table>';
    print '</fieldset>';
    print '<fieldset class="foldable">';
    print '<legend>曜日</legend>';
    print '<table class="field-table">';
    print '<tbody>';
    print '<tr>';
    print
        '<td class="field-name"><label for="data:calendar_thbgcolor">曜日背景色</label></td>';
    print
        '<td class="q-field"><input type="text" name="data:calendar_thbgcolor" id="data:calendar_thbgcolor" value="'
        . $this->escape( $main::data{'calendar_thbgcolor'} )
        . '" size="7" maxlength="7" onclick="cmonos.tool.colorPalette.open(\'data:calendar_thbgcolor\',\'dom\')" onchange="cmonos.validate.field(this).asColor()"'
        . ( ( $main::data{'calendar_thbgcolor'} )
        ? ' style="background-color: '
            . $main::data{'calendar_thbgcolor'} . '"'
        : '' )
        . ' title="カレンダーのセル背景色を設定します。" />';
    print
        ' <a href="JavaScript:cmonos.tool.colorPalette.open(\'data:calendar_thbgcolor\')" ondblclick="cmonos.tool.colorPalette.open(\'data:calendar_thbgcolor\',\'window\')"><img src="'
        . $env::image_dir
        . '/tool/palette.gif" alt="パレット" height="12" width="18" border="0" /></a>';
    print
        ' <a href="JavaScript:cmonos.tool.colorSlider.open(\'data:calendar_thbgcolor\')" ondblclick="cmonos.tool.colorSlider.open(\'data:calendar_thbgcolor\',\'window\')"><img src="'
        . $env::image_dir
        . '/tool/picker.gif" alt="カラーピッカー" height="12" width="18" border="0" /></a></td>';
    print
        '<td class="field-name"><label for="data:calendar_thfontcolor">曜日文字色</label></td>';
    print
        '<td class="q-field"><input type="text" name="data:calendar_thfontcolor" id="data:calendar_thfontcolor" value="'
        . $this->escape( $main::data{'calendar_thfontcolor'} )
        . '" size="7" maxlength="7" onclick="cmonos.tool.colorPalette.open(\'data:calendar_thfontcolor\',\'dom\')" onchange="cmonos.validate.field(this).asColor()"'
        . ( ( $main::data{'calendar_thfontcolor'} )
        ? ' style="background-color: '
            . $main::data{'calendar_thfontcolor'} . '"'
        : '' )
        . ' title="カレンダーの曜日文字色を設定します。" />';
    print
        ' <a href="JavaScript:cmonos.tool.colorPalette.open(\'data:calendar_thfontcolor\')" ondblclick="cmonos.tool.colorPalette.open(\'data:calendar_thfontcolor\',\'window\')"><img src="'
        . $env::image_dir
        . '/tool/palette.gif" alt="パレット" height="12" width="18" border="0" /></a>';
    print
        ' <a href="JavaScript:cmonos.tool.colorSlider.open(\'data:calendar_thfontcolor\')" ondblclick="cmonos.tool.colorSlider.open(\'data:calendar_thfontcolor\',\'window\')"><img src="'
        . $env::image_dir
        . '/tool/picker.gif" alt="カラーピッカー" height="12" width="18" border="0" /></a></td>';
    print '</tr>';
    print '<tr>';
    print
        '<td class="field-name"><label for="data:calendar_thfontsize">曜日文字サイズ</label></td>';
    print '<td class="q-field">';
    print $this->mk_select_menu(
        'data:calendar_thfontsize', '', '',
        $main::data{'calendar_thfontsize'},
        ''  => '',
        '1' => '小さめ',
        '2' => 'やや小さめ',
        '3' => '標準',
        '4' => 'やや大きめ',
        '5' => '大きめ',
        '6' => 'やや大きい',
        '7' => '大きい'
    );
    print '</td>';
    print
        '<td class="field-name"><span class="datatitle">曜日文字</span></td>';
    print
        '<td class="q-field"><label><input type="checkbox" name="data:calendar_thbold" id="data:calendar_thbold" value="1" title="BOLDにするかどうか設定します。"'
        . (
        (   defined $main::data{'calendar_thbold'}
                && $main::data{'calendar_thbold'}
        ) ? ' checked="checked"' : ''
        ) . ' /> 太字</label></td>';
    print '</tr>';
    print '<tr>';
    print
        '<td class="field-name"><label for="data:calendar_thstyle">曜日スタイル</label></td>';
    print
        '<td class="field" colspan="3"><input type="text" name="data:calendar_thstyle" id="data:calendar_thstyle" value="'
        . $this->escape( $main::data{'calendar_thstyle'} )
        . '" size="50" title="このフィールドのスタイルを指定して下さい。「:」を含まない場合はクラス指定と解釈されます。"/>';
    print '</td>';
    print '</tr>';
    print '</tbody>';
    print '</table>';
    print '</fieldset>';
    print '<fieldset class="foldable">';
    print '<legend>書式</legend>';
    print '<table class="field-table">';
    print '<tbody>';
    print '<tr>';
    print
        '<td class="field-name"><label for="data:calendar_yearformat">年書式</label></td>';
    print '<td class="field">';
    print $this->mk_select_menu(
        'data:calendar_yearformat', '', '',
        $main::data{'calendar_yearformat'},
        'j'  => '日本語西暦表記',
        'jk' => '日本語西暦表記（漢数字）',
        'J'  => '日本語元号表記',
        'Jk' => '日本語元号表記（漢数字）',
        'w'  => '西暦表記（数字のみ）'
    );
    print '</td>';
    print '</tr>';
    print '<tr>';
    print
        '<td class="field-name"><label for="data:calendar_monthformat">月書式</label></td>';
    print '<td class="field">';
    print $this->mk_select_menu(
        'data:calendar_monthformat', '', '',
        $main::data{'calendar_monthformat'},
        'j'   => '日本語表記',
        'jk'  => '日本語表記（漢数字）',
        'J'   => '日本語陰暦月名表記',
        'ef'  => '英語表記',
        'efU' => '英語表記（大文字）',
        'efL' => '英語表記（小文字）',
        'e'   => '英語表記（略記）',
        'eU'  => '英語表記（大文字略記）',
        'eL'  => '英語表記（小文字略記）'
    );
    print '</td>';
    print '</tr>';
    print '<tr>';
    print
        '<td class="field-name"><label for="data:calendar_weekformat">曜日書式</label></td>';
    print '<td class="field">';
    print $this->mk_select_menu(
        'data:calendar_weekformat', '', '',
        $main::data{'calendar_weekformat'},
        'j'   => '日本語表記',
        'jk'  => '日本語表記（漢数字）',
        'J'   => '日本語陰暦月名表記',
        'ef'  => '英語表記',
        'efU' => '英語表記（大文字）',
        'efL' => '英語表記（小文字）',
        'e'   => '英語表記（略記）',
        'eU'  => '英語表記（大文字略記）',
        'eI'  => '英語表記（頭文字）',
        'eL'  => '英語表記（小文字略記）'
    );
    print '</td>';
    print '</tr>';
    print '</tbody>';
    print '</table>';
    print '</fieldset>';
    print '<fieldset class="foldable">';
    print '<legend>日種別背景色</legend>';
    print '<table class="field-table">';
    print '<tbody>';
    print '<tr class="tbody-end">';
    print
        '<td class="field-name"><label for="data:calendar_saturdaybgcolor">土曜日背景色</label></td>';
    print
        '<td class="q-field"><input type="text" name="data:calendar_saturdaybgcolor" id="data:calendar_saturdaybgcolor" value="'
        . $this->escape( $main::data{'calendar_saturdaybgcolor'} )
        . '" size="7" maxlength="7" onclick="cmonos.tool.colorPalette.open(\'data:calendar_saturdaybgcolor\',\'dom\')" onchange="cmonos.validate.field(this).asColor()"'
        . ( ( $main::data{'calendar_saturdaybgcolor'} )
        ? ' style="background-color: '
            . $main::data{'calendar_saturdaybgcolor'} . '"'
        : '' )
        . ' title="カレンダーのセル背景色を設定します。" />';
    print
        ' <a href="JavaScript:cmonos.tool.colorPalette.open(\'data:calendar_saturdaybgcolor\')" ondblclick="cmonos.tool.colorPalette.open(\'data:calendar_saturdaybgcolor\',\'window\')"><img src="'
        . $env::image_dir
        . '/tool/palette.gif" alt="パレット" height="12" width="18" border="0" /></a>';
    print
        ' <a href="JavaScript:cmonos.tool.colorSlider.open(\'data:calendar_saturdaybgcolor\')" ondblclick="cmonos.tool.colorSlider.open(\'data:calendar_saturdaybgcolor\',\'window\')"><img src="'
        . $env::image_dir
        . '/tool/picker.gif" alt="カラーピッカー" height="12" width="18" border="0" /></a></td>';
    print
        '<td class="field-name"><label for="data:calendar_sundaybgcolor">日曜日背景色</label></td>';
    print
        '<td class="q-field"><input type="text" name="data:calendar_sundaybgcolor" id="data:calendar_sundaybgcolor" value="'
        . $this->escape( $main::data{'calendar_sundaybgcolor'} )
        . '" size="7" maxlength="7" onclick="cmonos.tool.colorPalette.open(\'data:calendar_sundaybgcolor\',\'dom\')" onchange="cmonos.validate.field(this).asColor()"'
        . ( ( $main::data{'calendar_sundaybgcolor'} )
        ? ' style="background-color: '
            . $main::data{'calendar_sundaybgcolor'} . '"'
        : '' )
        . ' title="カレンダーの標準文字色を設定します。" />';
    print
        ' <a href="JavaScript:cmonos.tool.colorPalette.open(\'data:calendar_sundaybgcolor\')" ondblclick="cmonos.tool.colorPalette.open(\'data:calendar_sundaybgcolor\',\'window\')"><img src="'
        . $env::image_dir
        . '/tool/palette.gif" alt="パレット" height="12" width="18" border="0" /></a>';
    print
        ' <a href="JavaScript:cmonos.tool.colorSlider.open(\'data:calendar_sundaybgcolor\')" ondblclick="cmonos.tool.colorSlider.open(\'data:calendar_sundaybgcolor\',\'window\')"><img src="'
        . $env::image_dir
        . '/tool/picker.gif" alt="カラーピッカー" height="12" width="18" border="0" /></a></td>';
    print '</tr>';
    print '<tr>';
    print
        '<td class="field-name"><label for="data:calendar_holidaybgcolor">休日背景色</label></td>';
    print
        '<td class="q-field"><input type="text" name="data:calendar_holidaybgcolor" id="data:calendar_holidaybgcolor" value="'
        . $this->escape( $main::data{'calendar_holidaybgcolor'} )
        . '" size="7" maxlength="7" onclick="cmonos.tool.colorPalette.open(\'data:calendar_holidaybgcolor\',\'dom\')" onchange="cmonos.validate.field(this).asColor()"'
        . ( ( $main::data{'calendar_holidaybgcolor'} )
        ? ' style="background-color: '
            . $main::data{'calendar_holidaybgcolor'} . '"'
        : '' )
        . ' title="カレンダーのセル背景色を設定します。" />';
    print
        ' <a href="JavaScript:cmonos.tool.colorPalette.open(\'data:calendar_holidaybgcolor\')" ondblclick="cmonos.tool.colorPalette.open(\'data:calendar_holidaybgcolor\',\'window\')"><img src="'
        . $env::image_dir
        . '/tool/palette.gif" alt="パレット" height="12" width="18" border="0" /></a>';
    print
        ' <a href="JavaScript:cmonos.tool.colorSlider.open(\'data:calendar_holidaybgcolor\')" ondblclick="cmonos.tool.colorSlider.open(\'data:calendar_holidaybgcolor\',\'window\')"><img src="'
        . $env::image_dir
        . '/tool/picker.gif" alt="カラーピッカー" height="12" width="18" border="0" /></a></td>';
    print
        '<td class="field-name"><label for="data:calendar_specialdaybgcolor">特別日背景色</label></td>';
    print
        '<td class="q-field"><input type="text" name="data:calendar_specialdaybgcolor" id="data:calendar_specialdaybgcolor" value="'
        . $this->escape( $main::data{'calendar_specialdaybgcolor'} )
        . '" size="7" maxlength="7" onclick="cmonos.tool.colorPalette.open(\'data:calendar_specialdaybgcolor\',\'dom\')" onchange="cmonos.validate.field(this).asColor()"'
        . ( ( $main::data{'calendar_specialdaybgcolor'} )
        ? ' style="background-color: '
            . $main::data{'calendar_specialdaybgcolor'} . '"'
        : '' )
        . ' title="カレンダーの標準文字色を設定します。" />';
    print
        ' <a href="JavaScript:cmonos.tool.colorPalette.open(\'data:calendar_specialdaybgcolor\')" ondblclick="cmonos.tool.colorPalette.open(\'data:calendar_specialdaybgcolor\',\'window\')"><img src="'
        . $env::image_dir
        . '/tool/palette.gif" alt="パレット" height="12" width="18" border="0" /></a>';
    print
        ' <a href="JavaScript:cmonos.tool.colorSlider.open(\'data:calendar_specialdaybgcolor\')" ondblclick="cmonos.tool.colorSlider.open(\'data:calendar_specialdaybgcolor\',\'window\')"><img src="'
        . $env::image_dir
        . '/tool/picker.gif" alt="カラーピッカー" height="12" width="18" border="0" /></a></td>';
    print '</tr>';
    print '<tr>';
    print
        '<td class="field-name"><label for="data:calendar_specialwdaybgcolor">特別な曜日背景色</label></td>';
    print
        '<td class="field" colspan="3"><input type="text" name="data:calendar_specialwdaybgcolor" id="data:calendar_specialwdaybgcolor" value="'
        . $this->escape( $main::data{'calendar_specialwdaybgcolor'} )
        . '" size="7" maxlength="7" onclick="cmonos.tool.colorPalette.open(\'data:calendar_specialwdaybgcolor\',\'dom\')" onchange="cmonos.validate.field(this).asColor()"'
        . ( ( $main::data{'calendar_specialwdaybgcolor'} )
        ? ' style="background-color: '
            . $main::data{'calendar_specialwdaybgcolor'} . '"'
        : '' )
        . ' title="カレンダーの標準文字色を設定します。" />';
    print
        ' <a href="JavaScript:cmonos.tool.colorPalette.open(\'data:calendar_specialwdaybgcolor\')" ondblclick="cmonos.tool.colorPalette.open(\'data:calendar_specialwdaybgcolor\',\'window\')"><img src="'
        . $env::image_dir
        . '/tool/palette.gif" alt="パレット" height="12" width="18" border="0" /></a>';
    print
        ' <a href="JavaScript:cmonos.tool.colorSlider.open(\'data:calendar_specialwdaybgcolor\')" ondblclick="cmonos.tool.colorSlider.open(\'data:calendar_specialwdaybgcolor\',\'window\')"><img src="'
        . $env::image_dir
        . '/tool/picker.gif" alt="カラーピッカー" height="12" width="18" border="0" /></a></td>';
    print '</tr>';
    print '</tbody>';
    print '</table>';
    print '</fieldset>';
    print '<fieldset>';
    print
        '<legend><label for="data:calendar_specialday">特別な日</label></legend>';
    print
        '<textarea name="data:calendar_specialday" id="data:calendar_specialday" cols="60" rows="6" wrap="soft" title="特別な日を設定します。設定された日は背景色が特別日背景色になります。">'
        . $this->escape( $main::data{'calendar_specialday'} )
        . '</textarea>';
    print
        '<div class="note">月/日=コメント:背景色指定［改行］ 例）1/1=僕の誕生日です。</div>';
    print '</fieldset>';
    print '<fieldset>';
    print
        '<legend><label for="data:calendar_addition">セル内追加コメント</label></legend>';
    print
        '<textarea name="data:calendar_addition" id="data:calendar_addition" cols="60" rows="6" wrap="soft" title="カレンダーセル内にコメントを追加します。">'
        . $this->escape( $main::data{'calendar_addition'} )
        . '</textarea>';
    print
        '<div class="note">月/日=コメント［改行］ 例）1/1=誕生日</div>';
    print '</fieldset>';
    print '<fieldset>';
    print '<legend>特別な曜日</legend>';
    print '<table class="field-table">';
    print '<tbody>';
    print '<tr>';
    print
        '<td class="field-name"><label for="data:calendar_specialwday">特別な曜日</label></td>';
    print '<td class="field">';
    print $this->mk_select_menu(
        'data:calendar_specialwday', '', ' multiple="multiple" size="7"',
        $main::data{'calendar_specialwday'},
        '0' => '日曜日',
        '1' => '月曜日',
        '2' => '火曜日',
        '3' => '水曜日',
        '4' => '木曜日',
        '5' => '金曜日',
        '6' => '土曜日'
    );
    print '</td>';
    print
        '<td class="field-name"><label for="data:calendar_specialwdayextra">特別な曜日の追加</label></td>';
    print
        '<td class="field"><textarea name="data:calendar_specialwdayextra" id="data:calendar_specialwdayextra" cols="24" rows="4" wrap="soft" title="特別な曜日の追加を設定します。設定された日は背景色が特別な曜日背景色になります。">'
        . $this->escape( $main::data{'calendar_specialwdayextra'} )
        . '</textarea>';
    print
        '<div class="note">月/日,［改行］ 例）1/1,1/2,1/3</div></td>';
    print '</tr>';
    print '<tr>';
    print
        '<td class="field-name"><label for="data:calendar_specialwdayexception">特別な曜日の例外</label></td>';
    print
        '<td class="field"><textarea name="data:calendar_specialwdayexception" id="data:calendar_specialwdayexception" cols="24" rows="4" wrap="soft" title="特別な曜日から除外する日を設定します。設定された日は背景色が通常の背景色になります。">'
        . $this->escape( $main::data{'calendar_specialwdayexception'} )
        . '</textarea>';
    print
        '<div class="note">月/日,［改行］ 例）1/1,1/2,1/3</div></td>';
    print '</tr>';
    print '</tbody></table>';
    print '</fieldset>';

    my ($tool);
    require CMONOS::CGI_Lib::Template;
    my $this_template = Template->new;

    #入力支援ツール
    my $mkcal = $ENV{'SCRIPT_NAME'};
    $mkcal =~ s/start.cgi$/mkcal.cgi/;
    $tool
        = '<select class="tool" onchange="cmonos.form.item(this.form).fieldname(\'data:calendar_template\').quotationByMenu(this)" title="これらのタグは、書き出し時に適切な表示に変換されます。">';
    $tool .= '<option value="">▼特殊タグを挿入する</option>';
    $tool
        .= '<option value="&lt;!--daycounter id=&quot;&quot;--&gt;">日数カウンター</option>';
    $tool
        .= '<option value="&lt;!--daycountertitle id=&quot;&quot;--&gt;">日数カウンタータイトル</option>';
    $tool .= '<option value="&lt;!--calendar--&gt;">カレンダー</option>';
    $tool
        .= '<option value="&lt;img src=&quot;'
        . $mkcal . '?'
        . time
        . '&quot; width=&quot;1&quot; height=&quot;1&quot; /&gt;">SSI埋め込みファイル作成タグ</option>';
    $tool .= '</select>';
    $this_template->print_template_form(
        'data:calendar_template',
        '埋め込みカレンダー用テンプレート',
        \$main::data{'calendar_template'}, \$tool
    );

    print
        '<fieldset class="submit"><input type="submit" value="保存" class="save" /></fieldset>';

    print
        '</form><form name="sample-codes" id="sample-codes" action="#"><fieldset class="sample"><legend><label for="sample-ssi">埋め込みタグ(動的 JavaScript)</label></legend>';
    print
        '<textarea cols="70" rows="3">&lt;script type=&quot;text/javascript&quot; language=&quot;JavaScript&quot; src=&quot;'
        . $this->http_my_domain
        . $ENV{'SCRIPT_NAME'}
        . '?mode=js&quot;&gt;&lt;/script&gt;&lt;noscript&gt;&lt;a href=&quot;'
        . $this->http_my_domain
        . $ENV{'SCRIPT_NAME'}
        . '&quot;&gt;カレンダーを見る&lt;/a&gt;&lt;/noscript&gt;</textarea>';
    print '</fieldset>';

    if ( defined $setting::security{'dcount'}{'passwordCheck'}
        && $setting::security{'dcount'}{'passwordCheck'} eq 'nocheck' )
    {
        my $target_uri
            = $this->path_change( $default::file, $ENV{'SCRIPT_NAME'},
            'abs' );
        if ( defined $env::ssi && $env::ssi ) {
            print
                '<fieldset class="sample"><legend><label for="sample-ssi">埋め込みタグ(静的 SSI)</label></legend>';
            print
                '<textarea cols="70" rows="3">&lt;!--#include virtual=&quot;'
                . $target_uri
                . '&quot;--&gt;</textarea>';
            print '</fieldset>';
        }
        $target_uri =~ s/\.ssi$/.js/i;
        $target_uri = $this->http_my_domain . $target_uri;
        print
            '<fieldset class="sample"><legend><label for="sample-js">埋め込みタグ(静的 JavaScript)</label></legend>';
        print
            '<textarea cols="70" rows="3">&lt;script type=&quot;text/javascript&quot; language=&quot;JavaScript&quot; src=&quot;'
            . $target_uri
            . '&quot;&gt;&lt;/script&gt;&lt;noscript&gt;&lt;a href=&quot;'
            . $this->http_my_domain
            . $ENV{'SCRIPT_NAME'}
            . '&quot;&gt;カレンダーを見る&lt;/a&gt;&lt;/noscript&gt;</textarea>';
        print '<img src="'
            . $mkcal
            . '?refresh" width="1" height="1" alt="" />'
            if $main::id;
        print '</fieldset>';
    }
    if (   defined $this->{'calendar_css'}
        && $this->{'calendar_css'} ne ''
        && $main::data{ $preference::id . '_calcssunembedded' } )
    {
        print
            '<fieldset class="sample"><legend><label for="sample-ssi">カレンダー用 CSS</label></legend>';
        print '<textarea cols="70" rows="8">'
            . $this->escape( $this->{'calendar_css'} )
            . '</textarea>';
        print '</fieldset>';
    }
    return;
}

######################################################################
# クラス登録
#sub import {
BEGIN {
    no warnings qw(once);

    #クラス登録
    Common::class_register( 'd001', 'CalendarSetting' );

    #ツール登録
    $setting::jump_menu{'d001'} = 'カレンダー設定';
}

1;
