package DcPreferenceShare;
require CMONOS::CGI_Lib::Tools::PreferenceShare;
@ISA = qw(PreferenceShare);
use strict;
use utf8;
######################################################################
# DayCounter 設定の共有モジュール
# DcPreferenceShare.pm ver1.1
# Copyright (C) 1999-2018 CMONOS Co. Ltd.
#
# support@cmonos.jp
# http://cmonos.jp/
#
######################################################################
sub get_shareable_db_info ($$) {
    my ( $this, $shareable_db ) = @_;
    my $default_path
        = ( $env::user_default_dir || $env::default_dir ) . '/daycounter';
    $this->set_dir($default_path);
    %$shareable_db = (
        'general' => {
            'pref_path' => $default::preference_dir . '/general',
            'bak_path'  => $default_path . '/general',
            'pref_type' => '一般設定',
            'pref_id'   => '0000'
        },
        'security' => {
            'pref_path' => $default::preference_dir . '/security',
            'bak_path'  => $default_path . '/security',
            'pref_type' => 'アクセス権設定',
            'pref_id'   => '0001'
        },
        'page' => {
            'pref_path' => $default::preference_dir . '/page',
            'bak_path'  => $default_path . '/page',
            'pref_type' => 'ページレイアウト設定',
            'pref_id'   => 'd000'
        },
        'counter' => {
            'pref_path' => $default::preference_dir . '/counter',
            'bak_path'  => $default_path . '/counter',
            'pref_type' => '日数カウント設定',
            'pref_id'   => 'd100'
        }
    );
    return;
}

######################################################################
# クラス登録
#sub import {
BEGIN {
    if ($env::default_dir) {

        #クラス登録
        Common::class_register( 'xxbs', 'DcPreferenceShare' );

        #メニュー登録
        $setting::jump_menu{'xxbs'}              = '設定の共有';
        $setting::sub_jump_menu{'share'}{'xxbs'} = '設定の共有';
        $setting::selected_jump_menu{'xxbs'}     = 'xxbs';
    }
}

1;
