package GeneralSetting;
require CMONOS::CGI_Lib::Tools::General;
@ISA = qw(General);
use strict;
use utf8;
######################################################################
# 一般設定モジュール
# GeneralSetting.pm ver1.0
# Copyright (C) 1999-2018 CMONOS Co. Ltd.
#
# support@cmonos.jp
# http://cmonos.jp/
# 最終更新日：2009-02-07
######################################################################
# 設定項目取得
sub get_sub_setting_items ($) {
    no warnings qw(once);
    my $this = shift;

    #チェックボックス
    push( @check::checkbox, 'nofollow' );

    return;
}

######################################################################
# 追加設定
sub print_sub_preference_panel ($) {
    my $this = shift;
    print
        '<fieldset><legend><label for="data:feeds">RSS/Atom フィードリスト</label></legend>';
    print
        '<textarea name="data:feeds" id="data:feeds" cols="72" rows="12" wrap="off" class="content-editor-area">'
        . $this->escape( $main::data{'feeds'} )
        . '</textarea>';
    print
        '<div class="note">フィード URL ごとに改行で区切ります。</div>';
    print '</fieldset>';
    print '<fieldset><legend>巡回間隔</legend>';
    print '<label><input type="text" name="interval" size="6" value="'
        . $this->escape($default::interval)
        . '" /> 時間ごとにリストを更新する。</label>';
    print '</fieldset>';
    print '<fieldset><legend>フィルタ</legend>';
    print
        '<fieldset><legend><label for="data:requiredWords">必須キーワード</label></legend>';
    print
        '<textarea name="data:requiredWords" id="data:requiredWords" cols="72" rows="3" wrap="off" class="content-editor-area" title="空白で区切ったキーワードに一致する記事のみ表示します。">'
        . $this->escape( $main::data{'requiredWords'} )
        . '</textarea>';
    print '<div class="extra-field">';
    print $this->mk_select_menu(
        'data:requiredWordsMethod', '', '',
        $main::data{'requiredWordsMethod'},
        'or'  => 'いずれかに一致',
        'and' => '全てに一致',
    );
    print '</div></fieldset>';
    print
        '<fieldset><legend><label for="data:ignoreWords">除外キーワード</label></legend>';
    print
        '<textarea name="data:ignoreWords" id="data:ignoreWords" cols="72" rows="3" wrap="off" class="content-editor-area" title="空白で区切ったキーワードに一致する記事を無視します。">'
        . $this->escape( $main::data{'ignoreWords'} )
        . '</textarea>';
    print '<div class="extra-field">';
    print $this->mk_select_menu(
        'data:ignoreWordsMethod', '', '', $main::data{'ignoreWordsMethod'},
        'or'  => 'いずれかに一致',
        'and' => '全てに一致',
    );
    print '</div></fieldset>';
    print '</fieldset>';

    print
        '<fieldset><legend><label for="data:datetype">標準日付書式</label></legend>';
    $this->print_date_type_menu( 'data:', $main::data{'datetype'},
        '日付の標準書式を設定します。' );
    print '</fieldset>';
    print '<fieldset><legend>リンクオプション</legend>';
    print '<label><input type="checkbox" name="data:nofollow" value="1"'
        . ( ( $main::data{'nofollow'} ) ? ' checked="checked"' : '' )
        . ' /> リンク先を検索エンジンに無視させる</label>';
    print '</fieldset>';

    if ( $this->{'updated'} ) {
        my $mklist = $ENV{'SCRIPT_NAME'};
        $mklist =~ s/start.cgi$/mklist.cgi/;
        print '<img src="' . $mklist
            . '?refresh" width="1" height="1" alt="" />';
    }
}

######################################################################
# サブ設定チェック
sub _is_valid_setting ($) {
    my $this = shift;
    $main::interval = 1.5
        if !$main::interval
        || $this->is_nan($main::interval)
        || $main::interval < 0;
    unlink $default::preference_dir . '/cache.html';
    unlink $default::preference_dir . '/cache.js';
    unlink $default::preference_dir . '/ssi_cache.html';
    unlink $default::preference_dir . '/ssi_cache.js';
    return;
}

sub update_settings ($) {
    my $this = shift;
    return
        if defined $default::interval
        && $default::interval == $main::interval;
    my ( $data, $default_path );
    $default_path = './default.pl';
    $data = $this->read_file( $default_path, 1 );
    unless ( $data
        =~ s/^[\x20\x09]*\$interval[\x20\x09]*=[^;]*;/\$interval = $main::interval;/gm
        )
    {
        $data =~ s/1;/\$interval = $main::interval;\x0A\x0A1;/gm;
    }
    if ( $this->write_file( $default_path, \$data, 1, $env::cgi_file_mode ) )
    {
        $default::interval = $main::interval;
        undef $main::interval;
        $this->{'updated'} = 1;
    }
    else {
        push(
            @{ $this->{'dialog'} },
            '日付変更時刻繰り上げ設定の更新に失敗しました。設定ファイルを開けませんでした。'
        );
    }
    return;
}

######################################################################
# クラス登録
#sub import {
BEGIN {
    #クラス登録
    Common::class_register( '0000', 'GeneralSetting' );

    #ツール登録
    $setting::jump_menu{'0000'} = '一般設定';
}

1;
