package DSelector;
require CMONOS::CGI_Lib::SetUp;
@ISA = qw(SetUp);
use strict;
use utf8;
######################################################################
# ディレクトリ選択モジュール
# DSelector.pm ver1.0
# Copyright (C) 1999-2018 CMONOS Co. Ltd.
#
# support@cmonos.jp
# http://cmonos.jp/
#
######################################################################
# 実行
sub run ($) {
    no warnings qw(numeric);
    my $this = shift;
    my ( $current, $current_directory, $size, @list );

    #カレントディレクトリ
    $current = $this->current_directory;

    #ディレクトリリスト
    $current_directory = $this->path_conv( $current, 'path' );
    opendir( DIR, $current_directory );
    @list = grep( $_ !~ /^\./ && -d $current_directory . '/' . $_,
        readdir(DIR) );
    closedir(DIR);
    @list = sort { $a <=> $b || $a cmp $b } @list;
    $size = @list;
    if ( $size > 12 ) {
        $size = 12;
    }
    elsif ( $size <= 1 ) {
        $size = 4;
    }

    #ページヘッダ
    $this->jump_menu('tools');
    $this->print_page_header('tools');

    print
        '<h1 title="アクセス制限をかけるディレクトリを選択します。">ディレクトリ選択</h1>';

    #フォーム開始
    print $this->form_start(
        'key'      => 'tools',
        'name'     => 'input',
        'method'   => 'post',
        'required' => ['m']
    );

    #現在位置
    print '<input type="hidden" name="a" value="ds" />';
    print '<input type="hidden" name="parent" value="'
        . $this->escape($current) . '" />';

    #ディレクトリ階層移動
    print '<fieldset><legend><select name="current">';
    my ( $is_here, $dir_menu, $user_directory );
    $dir_menu       = '';
    $user_directory = $this->user_directory(1);
    $is_here        = 1;
    while ( $current =~ s/\/([^\/]+)$// ) {
        my $dir = $1;
        next
            if $default::target
            && !eval { $current =~ /^\Q$default::target\E/ };
        if ( $current =~ /^$user_directory/ ) {
            $dir_menu
                = '<option value="'
                . $current . '/'
                . $dir . '"'
                . ( ($is_here) ? ' selected="selected"' : '' ) . '>'
                . $dir
                . '</option>'
                . $dir_menu;
        }
        else {
            last;
        }
        $is_here = 0;
    }
    if ( defined $default::target && $default::target ) {
        print '<option value="'
            . $default::target . '">'
            . $default::target
            . '</option>';
    }
    else {
        print '<option value="' . $current
            . '">ホームディレクトリ</option>';
    }
    print $dir_menu;
    print '</select>';
    print
        ' <input type="submit" name="cd=1&amp;k=k200" value="移動" /></legend>';
    undef $dir_menu;
    undef $is_here;

    #ディレクトリ選択
    print '<table class="target-selector"><tbody><tr><td>';
    print '<select name="dir" size="' . $size . '">';
    foreach (@list) {
        print '<option value="' . $_ . '">' . $_ . '</option>';
    }
    print '</select>';

    #処理
    print '</td><td>';
    print '<input type="submit" name="k=k200" value="開く" />';
    print '<input type="submit" name="k=k201" value="選択" />';

    print '</td></tr></tbody></table></fieldset></form>';

    #ページフッタ
    $this->print_page_footer('tools');
}

sub current_directory ($) {
    my $this = shift;
    my ($current);
    $main::parent = '' if $main::parent && $main::parent eq '/';
    if ( $main::cd && -d $this->path_conv( $main::current, 'path' ) ) {
        $current = $main::current;
    }
    elsif ( $main::dir
        && -d $this->path_conv( $main::parent . '/' . $main::dir, 'path' ) )
    {
        $current = $main::parent . '/' . $main::dir;
    }
    elsif (defined $main::a
        && $main::a eq 'ds'
        && -d $this->path_conv( $main::parent, 'path' ) )
    {
        $current = $main::parent;
    }
    elsif ( $setting::general{'current'}
        && -d $this->path_conv( $setting::general{'current'}, 'path' ) )
    {
        $current = $setting::general{'current'};
    }
    elsif ( defined $default::target && $default::target ) {
        $current = $default::target;
    }
    else {
        $current = $this->user_directory(1);
    }
    if ( $default::target && $current !~ /^\Q$default::target\E/ ) {
        push(
            @{ $this->{'dialog'} },
            '指定されたディレクトリはアクセス権の設定ができません。'
                . $current
        );
        $current = $default::target;
    }
    return $current;
}

######################################################################
# クラス登録
#sub import {
BEGIN {
    no warnings qw(once);

    #クラス登録
    Common::class_register( 'k200', 'DSelector' );

#メニュー登録
#$setting::jump_menu{'k200'} = (defined $main::k && $main::k =~ /^k2/) ? 'ディレクトリ選択' : 'ディレクトリ選択→アクセス制限';
    $setting::jump_menu{'k200'}
        = 'ディレクトリ選択→アクセス制限';
    $setting::selected_jump_menu{'k200'}
        = 'k200';    #メインメニューのデフォルトキー

}

1;
