package GeneralSetting;
require CMONOS::CGI_Lib::Tools::General;
@ISA = qw(General);
use strict;
use utf8;
######################################################################
# 一般設定モジュール
# GeneralSetting.pm ver1.0
# Copyright (C) 1999-2018 CMONOS Co. Ltd.
#
# support@cmonos.jp
# http://cmonos.jp/
#
######################################################################
# 設定チェック項目取得
sub get_sub_setting_items ($) {
    my $this = shift;

    #チェックボックス
    push( @check::checkbox, 'uniqaddr' );

    #数字チェック
    $check::num{'lifetime'} = '自動発行パスワードの有効期限'
        if !defined $check::num{'lifetime'};
    return;
}

sub ogtype_disabled ($) {
    my $this = shift;
    return 1;
}

# サブ設定パネル
sub print_sub_preference_panel ($$) {
    my ( $this, $master ) = @_;

    if ( defined $master && $master ) {
        print '<fieldset>';
        print
            '<legend><label for="data:authmod">パスワード情報の保存形式</label></legend>';
        print $this->mk_select_menu(
            'data:authmod',
            'パスワード情報の保存形式を選択します。', '',
            $main::data{'authmod'},
            'text' =>
                'テキストファイルに保存する(100アカウント以内推奨)',
            'dbm' =>
                'DBM に保存する(Auth_DBM 対応サーバでのみ利用可能・10,000アカウント以内推奨)'
        );
        print ' <label><input type="checkbox" name="data:uniqaddr" value="1"'
            . ( ( $main::data{'uniqaddr'} ) ? ' checked="checked"' : '' )
            . ' /> メールアドレスの重複を禁止する</label>';
        print '</fieldset>';

        print '<fieldset>';
        print
            '<legend><label for="data:options">アカウントカテゴリー設定</label></legend>';
        print
            '<textarea name="data:options" id="data:options" cols="40" rows="4" wrap="soft" title="アカウント登録時コメント欄に表示されるアカウントカテゴリーメニューの項目を設定します。">'
            . $this->escape( $main::data{'options'} )
            . '</textarea>';
        print
            '<div class="hints">項目ごとに改行します。設定がない場合自由記述式のコメント欄になります。</div>';
        print '</fieldset>';

        print '<fieldset><legend>パスワードの有効期限</legend>';
        print
            '<table class="field-table"><tbody><tr><td class="field-name"><label for="data:datetype">日付書式</label></td>';
        print '<td class="field">';
        $this->print_date_type_menu( 'data:', $main::data{'datetype'},
            '日付の標準書式を設定します。', '>d' );
        print
            '</td></tr><tr><td class="field-name"><label for="data:lifetime">自動発行パスワードの有効期限</label></td>';
        print '<td class="field">';
        print $this->mk_select_menu(
            'data:lifetime',
            '自動発行パスワードの有効期限を選択します。',
            '', $main::data{'lifetime'},
            ''       => '無期限',
            86400    => '1日',
            604800   => '1週間',
            1209600  => '2週間',
            2678400  => '1ヶ月',
            5270400  => '2ヶ月',
            8208000  => '3ヶ月',
            10540800 => '4ヶ月',
            13219200 => '5ヶ月',
            15811200 => '6ヶ月',
            18489600 => '7ヶ月',
            21081600 => '8ヶ月',
            23760000 => '9ヶ月',
            26352000 => '10ヶ月',
            29030400 => '11ヶ月',
            31536000 => '1年',
            47347200 => '1年6ヶ月',
            63072000 => '2年',
            94608000 => '3年'
        );
        print '</td></tr></tbody></table>';
        print '</fieldset>';

        $this->print_mail_setting_field();
        $this->print_mail_setting_field( 'auto',    '自動発行' );
        $this->print_mail_setting_field( 'reissue', '自動再発行' );
    }
    else {

        print '<fieldset>';
        print '<legend>パスワード情報の保存形式</label></legend>';
        print( ( $main::data{'authmod'} && $main::data{'authmod'} eq 'dbm' )
            ? 'DBM に保存する(Auth_DBM 対応サーバでのみ利用可能・10,000アカウント以内推奨)'
            : 'テキストファイルに保存する(100アカウント以内推奨)'
        );
        print '[メールアドレスの重複を禁止する]'
            if $main::data{'uniqaddr'};
        print '</fieldset>';

        print '<fieldset>';
        print '<legend>登録者カテゴリー項目</legend>';
        my $options = $this->escape( $main::data{'options'} );
        $options =~ s/[\x0A\x0D]+/<br \/>/g;
        print $options;
        print '</fieldset>';

        print '<fieldset><legend>パスワードの有効期限</legend>';
        print
            '<table class="field-table"><tbody><tr><td class="field-name"><span class="datatitle">日付書式</span></td>';
        print '<td class="field">';
        print $this->date(
            time, 0,
            'gmt'
                . (
                ( defined $main::data{'datetype'} )
                ? $main::data{'datetype'}
                : ''
                )
        );
        print
            '</td></tr><tr><td class="field-name"><span class="datatitle">自動発行パスワードの有効期限</span></td>';
        print '<td class="field">';
        print(
              ( !$main::data{'lifetime'} )            ? '無期限'
            : ( $main::data{'lifetime'} == 86400 )    ? '1日'
            : ( $main::data{'lifetime'} == 604800 )   ? '1週間'
            : ( $main::data{'lifetime'} == 1209600 )  ? '2週間'
            : ( $main::data{'lifetime'} == 2678400 )  ? '1ヶ月'
            : ( $main::data{'lifetime'} == 5270400 )  ? '2ヶ月'
            : ( $main::data{'lifetime'} == 8208000 )  ? '3ヶ月'
            : ( $main::data{'lifetime'} == 10540800 ) ? '4ヶ月'
            : ( $main::data{'lifetime'} == 13219200 ) ? '5ヶ月'
            : ( $main::data{'lifetime'} == 15811200 ) ? '6ヶ月'
            : ( $main::data{'lifetime'} == 18489600 ) ? '7ヶ月'
            : ( $main::data{'lifetime'} == 21081600 ) ? '8ヶ月'
            : ( $main::data{'lifetime'} == 23760000 ) ? '9ヶ月'
            : ( $main::data{'lifetime'} == 26352000 ) ? '10ヶ月'
            : ( $main::data{'lifetime'} == 29030400 ) ? '11ヶ月'
            : ( $main::data{'lifetime'} == 31536000 ) ? '1年'
            : ( $main::data{'lifetime'} == 47347200 ) ? '1年6ヶ月'
            : ( $main::data{'lifetime'} == 63072000 ) ? '2年'
            : ( $main::data{'lifetime'} == 94608000 ) ? '3年'
            :                                           '?'
        );
        print '</td></tr></tbody></table>';
        print '</fieldset>';

        $this->print_mail_setting();
        $this->print_mail_setting( 'auto',    '自動発行' );
        $this->print_mail_setting( 'reissue', '自動再発行' );
    }
    return;
}

sub print_mail_setting_field ($$$) {
    my ( $this, $type, $name ) = @_;
    $type = '' if !defined $type;
    $name = '' if !defined $name;

    print '<fieldset><legend>' . $name
        . 'パスワード通知メール設定</legend>';
    print '<fieldset>';
    print '<legend><label for="data:'
        . $type
        . 'subject">'
        . $name
        . 'パスワード通知メールの表題</label></legend>';
    print '<input type="text" name="data:'
        . $type
        . 'subject" id="data:'
        . $type
        . 'subject" size="72" value="'
        . $this->escape( $main::data{ $type . 'subject' } )
        . '" title="パスワード通知メールの表題を設定します。" />';
    print '</fieldset>';
    print '<fieldset><legend><label for="data:' . $type . 'msg">' . $name
        . 'パスワード通知メールの本文</label></legend>';
    print '<textarea name="data:'
        . $type
        . 'msg" id="data:'
        . $type
        . 'msg" cols="72" rows="15" wrap="soft">'
        . $this->escape( $main::data{ $type . 'msg' } )
        . '</textarea>';
    print '<div class="toolbox">';
    print
        '<select class="tool" onchange="cmonos.form.item(this.form).fieldname(\'data:'
        . $type
        . 'msg\').quotationByMenu(this)" title="これらのタグはメール送信時に対応する値に変換されます。">';
    print '<option value="">▼挿入する</option>';
    print '<option value="&lt;name&gt;">&lt;name&gt;[登録名]</option>';
    print
        '<option value="&lt;account&gt;">&lt;account&gt;[発行したアカウント]</option>';
    print
        '<option value="&lt;password&gt;">&lt;password&gt;[発行したパスワード]</option>';
    print
        '<option value="&lt;url&gt;">&lt;url&gt;[アクセス制限対象ディレクトリの URL]</option>';
    print
        '<option value="&lt;expire&gt;">&lt;expire&gt;[パスワードの有効期限]</option>';
    print '</select>';
    print '</div>';
    print '</fieldset>';
    print '</fieldset>';

}

sub print_mail_setting ($$$) {
    my ( $this, $type, $name ) = @_;
    $type = '' if !defined $type;
    $name = '' if !defined $name;

    print '<fieldset><legend>' . $name
        . 'パスワード通知メール設定</legend>';
    print '<fieldset><legend>' . $name
        . 'パスワード通知メールの表題</legend>';
    my $subject = $this->escape( $main::data{ $type . 'subject' } );
    $subject =~ s/[\x0A\x0D]+/<br \/>/g;
    print $subject;
    print '</fieldset>';
    print '<fieldset><legend>' . $name
        . 'パスワード通知メールの本文</legend>';
    my $msg = $this->escape( $main::data{ $type . 'msg' } );
    $msg =~ s/[\x0A\x0D]+/<br \/>/g;
    print $msg;
    print '</fieldset>';
    print '</fieldset>';
}

######################################################################
# サブ設定チェック
sub _is_valid_setting ($) {
    my $this = shift;
    $main::data{'options'} =~ s/<.*?>//g;
    $main::data{'options'} =~ s/"/&quot;/g;
    return;
}

######################################################################
# クラス登録
#sub import {
BEGIN {
    #クラス登録
    Common::class_register( '0000', 'GeneralSetting' );

    #ツール登録
    $setting::jump_menu{'0000'} = '一般設定';
}

1;
