package HMUserGeneratedField;
use strict;
use utf8;
######################################################################
# フィールド定義モジュール（HomePageMaker ユーザー作成フィールド）
# HMUserGeneratedField.pm 1.0.1
# Copyright (C) 1999-2018 CMONOS Co. Ltd.
#
#　support@cmonos.jp
#　http://cmonos.jp/
#  最終更新日：2007-12-13
######################################################################
sub get_query_for_user_generated_field_editor ($;$$$) {
    my ( $this, $for_post, $c, $n ) = @_;
    $c
        = ( defined $c && $c ne '' ) ? $c
        : ( defined $main::c && $main::c ne '' ) ? $main::c
        :                                          '';
    $n = ( defined $n && $n ne '' ) ? $n : $main::n;
    if ($for_post) {
        return $this->add_query(
            'post',
            {   'm'  => 'UserGeneratedFieldEditor',
                'k'  => 'ugfieldeditor',
                'id' => $this->{'id'},
                ( ($default::subdivided) ? ( 'c' => $c ) : () ),
                'n' => $n,
                'p' => $main::p,
                (   ( $main::p ne 'i' )
                    ? ( 'chap' => $main::chap,
                        'sect' => $main::sect
                        )
                    : ()
                )
            }
        );
    }
    else {
        return
              '?m=UserGeneratedFieldEditor&k=ugfieldeditor&id='
            . $this->{'id'}
            . ( ($default::subdivided) ? '&c=' . $c : '' ) . '&n='
            . $n . '&p='
            . $main::p
            . ( ( $main::p ne 'i' )
            ? '&chap=' . $main::chap . '&sect=' . $main::sect
            : '' );
    }
}

sub _mk_user_generated_field_id ($;$$) {
    my ( $this, $c, $n ) = @_;
    my $id = ( ( defined $c && $c ne '' ) ? '-' . $c : '' )
        . ( ( defined $n && $n ne '' ) ? '-' . $n : '' );
    if ( $main::p && $main::p eq 'i' ) {
        $id .= '-info';
    }
    else {
        $id .= ($main::p) ? '-' . $main::p : '';
        $id
            .= ( ( defined $main::chap && $main::chap ne '' )
            ? '-' . $main::chap
            : '' );
        $id
            .= ( ( defined $main::sect && $main::sect ne '' )
            ? '-' . $main::sect
            : '' );
    }
    return $id . '-' . $this->{'id'};
}

sub get_query_keys ($) {
    my $this = shift;
    return ($default::subdivided) ? [ 'c', 'n', 'p' ] : [ 'n', 'p' ];
}

sub add_query_for_form ($;$$) {
    my ( $this, $c, $n ) = @_;
    return $this->add_query(
        'post',
        (     ( $main::p eq 'i' )
            ? { 'm' => 'UserGeneratedFieldUpdater' }
            : { 'm'    => 'UserGeneratedFieldUpdater',
                'chap' => $main::chap,
                'sect' => $main::sect
            }
        )
    );
}

sub get_output_path ($;$) {
    my ( $this, $no_pending ) = @_;
    return
          $this->get_article_dir($no_pending) . '/'
        . ( ( !$main::p || $main::p eq 'i' ) ? '1' : $main::p ) . '.'
        . ( ( $env::ssi && $env::ssi_ext ) ? $env::ssi_ext : 'html' );
}

sub get_article_dir ($;$) {
    my ( $this, $no_pending ) = @_;
    my $path
        = ( !$master::home || $master::home eq $default::home )
        ? $default::home
        . ( ( $default::subdivided && defined $main::c && $main::c ne '' )
        ? '/' . $main::c
        : '' )
        . '/'
        . $main::n
        : $default::home . '/' . $main::n;
    $path .= '.pending'
        if !$no_pending
        && ( !-d $path && ( $main::pending || -d $path . '.pending' ) );
    return $path;
}

sub is_short_parameters ($) {
    return (
        !$default::home
            || ( $default::subdivided
            && ( !defined $main::c || $main::c eq '' ) )
            || !defined $main::n
            || $main::n eq ''
            || !defined $main::p
            || $main::p eq ''
            || (
            $main::p ne 'i'
            && (   !defined $main::chap
                || $main::chap eq ''
                || !defined $main::sect
                || $main::sect eq '' )
            )
    ) ? 1 : 0;
}

sub get_field_data ($) {
    my $this = shift;
    return $this->get_field_hash_by_id($main::id);
}

sub get_field_hash_by_id ($$) {
    my ( $this, $id ) = @_;
    my ( $chap, $sect )
        = ( $main::p && $main::p eq 'i' )
        ? ( '', '' )
        : ( $main::chap, $main::sect );
    return ( ( ref $this->{'record_hash'}->{$chap}->{$sect}->{$id} )
        ? $this->{'record_hash'}->{$chap}->{$sect}->{$id}
        : {} )
        if ref $this->{'record_hash'}
        && ref $this->{'record_hash'}->{$chap}
        && ref $this->{'record_hash'}->{$chap}->{$sect};
    my ( $template, $article );
    $article = $this->read_file( $this->get_output_path, 1 );
    require CMONOS::CGI_Lib::Template;
    $template = Template->new( $this->{'field_obj'}, $this->{'field_for'} );
    if ( $main::p && $main::p eq 'i' ) {
        $template->set( 'field_tag_name' => 'info' );
    }
    else {
        $template->set(
            'field_tag_name' => 'field',
            'chapter'        => 'chapter',
            'section'        => 'section'
        );
    }
    $this->{'record_hash'}->{$chap}->{$sect} = {};
    $template->scan( \$article, \$main::chap, \$main::sect,
        $this->{'record_hash'}->{$chap}->{$sect} );
    return ( ( ref $this->{'record_hash'}->{$chap}->{$sect}->{$id} )
        ? $this->{'record_hash'}->{$chap}->{$sect}->{$id}
        : {} );
}

sub get_file_directory ($) {
    my $this = shift;
    return
          $this->get_article_dir . '/'
        . $main::p
        . (
        ( $main::p eq 'i' ) ? '' : '/' . $main::chap . '/' . $main::sect );
}

sub get_mail_field_data ($$) {
    my ( $this, $mailto ) = @_;
    return ''
        if !ref $this->{'field_obj'}->{$mailto}
        || $this->{'field_obj'}->{$mailto}->{'class'} !~ /email/;
    my $data = $this->get_field_hash_by_id($mailto);
    my ( $k, $v, @addr );
    while ( ( $k, $v ) = each %$data ) {
        push( @addr, $v );
    }
    return
          (wantarray)
        ? (@addr)
            ? $this->get_address(@addr)
            : ()
        : (@addr) ? join( ',', $this->get_address(@addr) )
        :           '';
}

sub get_title_field_data ($) {
    my $this = shift;
    return ''
        if !$this->{'field_for'}->{'title'}
        || !ref $this->{'field_obj'}->{ $this->{'field_for'}->{'title'} };
    my $data = $this->get_field_hash_by_id( $this->{'field_for'}->{'title'} );
    return ( $data->{'str'} )
        ? $data->{'str'}
        : ($default::date) ? $this->date( substr( $main::n, 0, 8 ),
        0, $setting::general{'datetype'} )
        : $main::n;
}

sub get_viewer_url ($;$$) {
    my $this = shift;
    return $this->full_path( $this->get_output_path(1) )
        . ( ( $main::p eq 'i' )
        ? ''
        : '#a'
            . sprintf( "%.2d", $main::p )
            . sprintf( "%.2d", $main::chap )
            . sprintf( "%.2d", $main::sect ) );
}

sub get_additional_recent_item_list ($$$) {
    my ( $this, $file_name, $setting_name ) = @_;
    my @info = ();
    if (   $default::subdivided
        && defined $main::c
        && $main::c ne ''
        && $default::master_preference_dir
        && $default::master_preference_dir ne $default::preference_dir )
    {
        push(
            @info,
            {   'path' => (
                      ($default::master_file_dir) ? $default::master_file_dir
                    : ($master::home)             ? $master::home
                    :                               $default::home
                    )
                    . '/'
                    . $file_name,
                'template' => $this->get_value_by_key(
                    $default::preference_dir . '/page',
                    $setting_name
                )
            }
        );
    }
    push(
        @info,
        {   'path' => (
                (          $default::subdivided
                        && defined $main::c
                        && $main::c ne ''
                        && ( !$master::home
                        || $master::home eq $default::home )
                ) ? $default::home . '/' . $main::c : $default::home
                )
                . '/'
                . $file_name,
            'template' => $this->get_value_by_key(
                $default::master_preference_dir . '/page',
                $setting_name
            )
        }
    );
    return @info;
}

sub is_secure_user_for_edit ($) {
    my $this      = shift;
    my $is_secure = $this->is_secure_user_for_update;
    $this->read_security_settings;
    if ( $this->is_short_parameters ) {
        push(
            @{ $cgi::action->{'dialog'} },
            (   ($default::english)
                ? 'Error! Prameters is short.'
                : '必要な設定を取得できませんでした。'
            )
        ) if ref $cgi::action;
        $is_secure = 0;
    }
    $is_secure = 0 if !$this->is_secure( 'edit', 1 );
    return $is_secure;
}

sub get_rss_path ($) {
    my $this = shift;
    my $home
        = ( !$master::home || $master::home eq $default::home )
        ? $default::home
        . ( ( $default::subdivided && defined $main::c && $main::c ne '' )
        ? '/' . $main::c
        : '' )
        : $default::home;
    my $master_home
        = ( $master::home && $master::home ne $default::home )
        ? $master::home
        : $default::home;
    return (
        $home,
        $this->full_path($home)
            . '/index.'
            . ( ( $env::ssi && $env::ssi_ext ) ? $env::ssi_ext : 'html' ),
        ( ($default::subdivided) ? $master_home : '' ),
        (   ($default::subdivided)
            ? $this->full_path($master_home)
                . '/index.'
                . ( ( $env::ssi && $env::ssi_ext ) ? $env::ssi_ext : 'html' )
            : ''
        )
    );
}

1;
