package HistoryIndexPage;
require CMONOS::HomePageMaker::Tools::HomePage;
@ISA = qw(HomePage);
use strict;
use utf8;
######################################################################
# 履歴ページ設定モジュール
# HistoryPage.pm ver1.0
# Copyright (C) 1999-2018 CMONOS Co. Ltd.
#
# support@cmonos.jp
# http://cmonos.jp/
#
######################################################################
# 設定環境
sub set_sub_preferences ($) {
    my $this = shift;
    $preference::id = 'historyindex';    # データキー
    $preference::name = '履歴インデックスページレイアウト'
        ;                                # 設定パネル名
    $preference::title
        = '履歴インデックスページのレイアウトについて設定します。';
    $preference::ssi         = 1;        #SSIを利用可能
    $preference::static_page = 1;        #HTMLファイル
}

######################################################################
# 設定環境
sub input_support ($) {
    my $this = shift;
    my ( $tool, $id );
    $id = 'data:historyindex_template';
    $tool
        .= '<select class="tool" onchange="cmonos.form.item(this.form).fieldname(\''
        . $id
        . '\').quotationByMenu(this)" title="これらのタグは、書き出し時に適切なタグに変換されます。">';
    $tool .= '<option value="">▼特殊タグを挿入する</option>';
    $tool
        .= '<option value="&lt;!--tool--&gt;&lt;!--/tool--&gt;">環境設定へのリンク</option>';
    $tool
        .= '<option value="&lt;!--indexpage title=&quot;インデックス&quot;--&gt;&lt;!--/indexpage--&gt;">インデックスページへのリンク</option>';

    $tool .= '<option value=""></option>';
    $tool
        .= '<option value="&lt;!--title--&gt;&lt;!--/title--&gt;">タイトル</option>';
    $tool
        .= '<option value="&lt;!--mastertitle--&gt;&lt;!--/mastertitle--&gt;">マスタータイトル</option>'
        if defined $default::subdivided && $default::subdivided;

    $tool .= '<option value=""></option>';
    $tool
        .= '<option value="&lt;!--historylist yearsort=&quot;descend&quot; monthsort=&quot;descend&quot;--&gt;&lt;!--/historylist--&gt;">履歴ページリスト</option>';

    $tool .= '<option value=""></option>';
    $tool
        .= '<option value="&lt;!--yhistory yearsort=&quot;descend&quot; monthsort=&quot;descend&quot;--&gt;&lt;!--head--&gt;&lt;!--/head--&gt;&lt;!--foot--&gt;&lt;!--/foot--&gt;&lt;!--/yhistory--&gt;">年間履歴カレンダー</option>';
    $tool
        .= '<option value="&lt;!--ytitle--&gt;&lt;!--head--&gt;&lt;!--/head--&gt;&lt;!--foot--&gt;&lt;!--/foot--&gt;&lt;!--/ytitle--&gt;">年タイトル</option>';
    $tool
        .= '<option value="&lt;!--ycal--&gt;&lt;!--head--&gt;&lt;!--/head--&gt;&lt;!--foot--&gt;&lt;!--/foot--&gt;&lt;!--/ycal--&gt;">カレンダー</option>';
    $tool
        .= '<option value="&lt;!--separator interval=&quot;4&quot;--&gt;&lt;!--/separator--&gt;">カレンダーセパレータ</option>';
    $tool .= '<option value="';
    $tool
        .= $this->jsquot(
        '&lt;!--yhistory yearsort=&quot;descend&quot; monthsort=&quot;descend&quot;--&gt;\n'
            . '&lt;div class="yhistory"&gt;\n'
            . '&lt;!--ytitle--&gt;&lt;!--head--&gt;&lt;h2 class="ytitle"&gt;&lt;!--/head--&gt;&lt;!--foot--&gt;&lt;/h2&gt;&lt;!--/foot--&gt;&lt;!--/ytitle--&gt;\n'
            . '&lt;div class="ycal"&gt;\n'
            . '&lt;!--ycal--&gt;&lt;!--head--&gt;&lt;!--/head--&gt;&lt;!--foot--&gt;&lt;!--/foot--&gt;&lt;!--/ycal--&gt;\n'
            . '&lt;!--separator interval=&quot;4&quot;--&gt;&lt;/div&gt;&lt;div class="ycal"&gt;&lt;!--/separator--&gt;\n'
            . '&lt;/div&gt;\n'
            . '&lt;/div&gt;\n'
            . '&lt;!--/yhistory--&gt;\n' );
    $tool .= '">年間履歴カレンダー例</option>';
    $tool .= $this->recent_item_support;
    $tool .= '</select>';
    $tool .= $this->image_support($id);
    return $tool;
}

######################################################################
# 設定パネル
sub _print_sub_preference_panel ($) {
    my ( $this, $id, $key ) = @_;
    return;
}

######################################################################
#sub import {
BEGIN {
    if ($default::date
        && ( !$default::subdivided
            || ( $default::subdivided && defined $main::c && $main::c ne '' )
        )
        )
    {

        #クラス登録
        Common::class_register( 'H003', 'HistoryIndexPage' );

        #ツール登録
        $setting::sub_jump_menu{'page'}{'H003'}
            = '履歴インデックスページ';
        $setting::selected_jump_menu{'H003'} = 'H010'
            ; #サブメニューがあるときメインメニューのデフォルトキー
        $preference::page{'H003'} = 'historyindex';
    }
}

1;
