package HmPreferenceShare;
require CMONOS::CGI_Lib::Tools::PreferenceShare;
@ISA = qw(PreferenceShare);
use strict;
use utf8;
######################################################################
# HomePageMaker 設定の共有モジュール
# HmPreferenceShare.pm ver1.1.1
# Copyright (C) 1999-2018 CMONOS Co. Ltd.
#
# support@cmonos.jp
# http://cmonos.jp/
#
######################################################################
sub get_shareable_db_info ($$) {
    my ( $this, $shareable_db ) = @_;
    my $default_path
        = ( $env::user_default_dir || $env::default_dir ) . '/homepagemaker';
    $default_path .= '_date' if defined $default::date && $default::date;
    if ( $default::subdivided && ( !defined $main::c || $main::c eq '' ) ) {
        $default_path .= '/masterdefault';
        $this->set_dir($default_path);
        %$shareable_db = (
            'general' => {
                'pref_path' => $default::preference_dir . '/general',
                'bak_path'  => $default_path . '/general',
                'pref_type' => '一般設定',
                'pref_id'   => '0000'
            },
            'security' => {
                'pref_path' => $default::preference_dir . '/security',
                'bak_path'  => $default_path . '/security',
                'pref_type' => 'アクセス権設定',
                'pref_id'   => '0001'
            },
            'installmsg' => {
                'pref_path' => $default::preference_dir . '/installmsg',
                'bak_path'  => $default_path . '/installmsg',
                'pref_type' => 'カテゴリー増設通知設定',
                'pref_id'   => '00H1'
            },
            'page' => {
                'pref_path' => $default::preference_dir . '/page',
                'bak_path'  => $default_path . '/page',
                'pref_type' => 'ページレイアウト設定',
                'pref_id'   => 'H010'
            }
        );
    }
    else {
        $default_path .= '/default';
        $this->set_dir( $default_path . '/field' );
        %$shareable_db = (
            'general' => {
                'pref_path' => $default::preference_dir . '/general',
                'bak_path'  => $default_path . '/general',
                'pref_type' => '一般設定',
                'pref_id'   => '0000'
            },
            'security' => {
                'pref_path' => $default::preference_dir . '/security',
                'bak_path'  => $default_path . '/security',
                'pref_type' => 'アクセス権設定',
                'pref_id'   => '0001'
            },
            'inputfield' => {
                'pref_path' => $default::field_pref_dir . '/inputfield',
                'bak_path'  => $default_path . '/field/inputfield',
                'pref_type' => '入力フィールド設定',
                'pref_id'   => 'H100'
            },
            'infofield' => {
                'pref_path' => $default::field_pref_dir . '/infofield',
                'bak_path'  => $default_path . '/field/infofield',
                'pref_type' => 'ページ情報フィールド設定',
                'pref_id'   => 'H101'
            },
            'page' => {
                'pref_path' => $default::preference_dir . '/page',
                'bak_path'  => $default_path . '/page',
                'pref_type' => 'ページレイアウト設定',
                'pref_id'   => 'H010'
            }
        );
    }
    return;
}

######################################################################
# クラス登録
#sub import {
BEGIN {
    if ($env::default_dir) {

        #クラス登録
        Common::class_register( 'xxbs', 'HmPreferenceShare' );

        #メニュー登録
        $setting::jump_menu{'xxbs'}              = '設定の共有';
        $setting::sub_jump_menu{'share'}{'xxbs'} = '設定の共有';
        $setting::selected_jump_menu{'xxbs'}     = 'xxbs';
    }
}

1;
