package MasterIndexPage;
require CMONOS::HomePageMaker::Tools::HomePage;
@ISA = qw(HomePage);
use strict;
use utf8;
######################################################################
# マスターインデックスページ設定モジュール
# MasterIndexPage.pm ver1.0
# Copyright (C) 1999-2018 CMONOS Co. Ltd.
#
# support@cmonos.jp
# http://cmonos.jp/
#
######################################################################
# 設定項目取得
sub get_sub_setting_items ($) {
    my $this = shift;

    #数字項目
    $check::num{'ChapterLimit'} = 'chapter数/1ページ'
        if !defined $check::num{'ChapterLimit'};
    $check::num{'SectionLimit'} = 'section数/1ページ'
        if !defined $check::num{'SectionLimit'};
    $check::num{'gmapWidth'}    = 'Googleマップ幅';
    $check::num{'gmapHeight'}   = 'Googleマップ高さ';
    $check::num{'gmapMaxWidth'} = '情報ウィンドウ最大幅';

    #チェックボックス
    push( @check::checkbox, 'gmapOverView', 'gmapStreetView', 'gmapSearch' );
    return;
}

######################################################################
# 設定環境
sub set_sub_preferences ($) {
    my $this = shift;
    $preference::id = 'masterindex'
        if !defined $preference::id;    # データキー
    $preference::name = '総合インデックスページレイアウト'
        if !defined $preference::name;    # 設定パネル名
    $preference::title
        = '総合インデックスページのレイアウトについて設定します。'
        if !defined $preference::title;
    $preference::ssi = 1 if !$preference::ssi;    #SSIを利用可能
    $preference::static_page = 1
        if !$preference::static_page;             #HTMLファイル
}

######################################################################
# 入力支援ツール取得
sub input_support ($) {
    my $this = shift;
    my ( $tool, $name );
    $name = 'data:' . $preference::id . '_template';
    $tool
        .= '<select class="tool" onchange="cmonos.form.item(this.form).fieldname(\''
        . $name
        . '\').quotationByMenu(this)" title="これらのタグは、書き出し時に適切なタグに変換されます。">';
    $tool .= '<option value="">▼特殊タグを挿入する</option>';
    $tool .= $this->index_support(1);
    $tool .= $this->recent_item_support;
    $tool .= '<option value=""></option>';
    $tool
        .= '<option value="&lt;!--tool--&gt;&lt;!--/tool--&gt;">環境設定へのリンク</option>';
    $tool .= '</select>';
    $tool .= $this->image_support($name);
    return $tool;
}

######################################################################
# 設定パネル
sub _print_sub_preference_panel ($$;$) {
    my ( $this, $id, $key ) = @_;
    $this->print_index_setting_form( $id, $key, 1 );
    print '<fieldset>';
    print '<legend>Googleマップ表示設定</legend>';
    print '<label>幅 <input type="number" size="4" name="data:'
        . $id
        . 'gmapWidth" id="data:'
        . $id
        . 'gmapWidth" value="'
        . $this->escape( $main::data{ $key . 'gmapWidth' } )
        . '" /> px</label> &times; ';
    print '<label>高さ <input type="number" size="4" name="data:'
        . $id
        . 'gmapHeight" id="data:'
        . $id
        . 'gmapHeight" value="'
        . $this->escape( $main::data{ $key . 'gmapHeight' } )
        . '" /> px</label>';
    print '<ol class="checkbox">';
    print '<li><label><input type="checkbox" name="data:'
        . $id
        . 'gmapOverView" id="data:'
        . $id
        . 'gmapOverView" value="1"'
        . (
        ( $main::data{ $key . 'gmapOverView' } ) ? ' checked="checked"' : '' )
        . ' /> 概観地図を表示する</label></li>';
    print '<li><label><input type="checkbox" name="data:'
        . $id
        . 'gmapStreetView" id="data:'
        . $id
        . 'gmapStreetView" value="1"'
        . ( ( $main::data{ $key . 'gmapStreetView' } )
        ? ' checked="checked"'
        : '' )
        . ' /> ストリートビューツールを表示する</label></li>';
    print '<li><label><input type="checkbox" name="data:'
        . $id
        . 'gmapSearch" id="data:'
        . $id
        . 'gmapSearch" value="1"'
        . (
        ( $main::data{ $key . 'gmapSearch' } ) ? ' checked="checked"' : '' )
        . ' /> 住所検索ツールを表示する</label></li>';
    print '</ol>';
    print '<label>情報ウィンドウ内リンクを';
    print $this->mk_select_menu(
        'data:' . $id . 'gmapLinkTarget', '', '',
        $main::data{ $key . 'gmapLinkTarget' },
        'p' => '同じウィンドウで開く',
        'b' => '新しいウィンドウで開く',
    );
    print '</label>';
    print ' (<label for="data:' . $id
        . 'gmapMaxWidth">情報ウィンドウ最大幅</label>';
    print '<input type="number" size="4" name="data:'
        . $id
        . 'gmapMaxWidth" id="data:'
        . $id
        . 'gmapMaxWidth" value="'
        . $this->escape( $main::data{ $key . 'gmapMaxWidth' } )
        . '" /> px)';
    print '</fieldset>';
}

######################################################################
#sub import {
BEGIN {
    if ( $default::subdivided && ( !defined $main::c || $main::c eq '' ) ) {

        #クラス登録
        Common::class_register( 'H000', 'MasterIndexPage' );

        #ツール登録
        $setting::jump_menu{'H000'} = 'ページレイアウト'
            if !defined $setting::jump_menu{'H000'}; #これがデフォルト
        $setting::sub_jump_menu{'page'}{'H000'}
            = '総合インデックスページ'
            if !defined $setting::sub_jump_menu{'page'}{'H000'};
        $setting::selected_jump_menu{'H000'} = 'H000'
            if !defined $setting::selected_jump_menu{'H000'}
            ; #サブメニューがあるときメインメニューのデフォルトキー
        $preference::page{'H000'} = 'masterindex'
            if !defined $preference::page{'H000'};
    }
}

1;
