package PageObj;
require CMONOS::CGI_Lib::Tools::Page;
@ISA = qw(Page);
use strict;
use utf8;
######################################################################
# 共通部品モジュール
# PageObj.pm ver1.0
# Copyright (C) 1999-2018 CMONOS Co. Ltd.
#
# support@cmonos.jp
# http://cmonos.jp/
#
######################################################################
# 設定環境
sub set_sub_preferences ($) {
    my $this = shift;
    $preference::id   = '';                   # データキー
    $preference::name = 'ボタン設定';    # 設定パネル名
    $preference::title = 'リンクボタンについて設定します。';
}

sub get_setting_items ($) {
    my $this = shift;
}

######################################################################
# 設定パネル
sub print_preference_panel ($) {
    my $this = shift;

    print '<fieldset>';
    print '<legend>ページ移動ボタン設定</legend>';
    print '<fieldset>';
    print '<legend>戻る ボタン</legend>';
    print $cgi::Deco->button_menu( 'data:returnButton', 'return', 120,
        $main::data{'returnButton'} );
    print '</fieldset>';
    print '<fieldset>';
    print '<legend>インデックス ボタン</legend>';
    print $cgi::Deco->button_menu( 'data:indexButton', 'index', 120,
        $main::data{'indexButton'} );
    print '</fieldset>';
    print '<fieldset>';
    print '<legend>トップページ ボタン</legend>';
    print $cgi::Deco->button_menu( 'data:topButton', 'index', 120,
        $main::data{'topButton'} );
    print '</fieldset>';
    print '</fieldset>';

    print '<fieldset>';
    print '<legend>ツールボタン設定</legend>';
    print '<fieldset>';
    print '<legend>編集 ボタン</legend>';
    print $cgi::Deco->button_menu( 'data:editButton', 'edit', 120,
        $main::data{'editButton'} );
    print '</fieldset>';
    print '<fieldset>';
    print '<legend>環境設定 ボタン</legend>';
    print $cgi::Deco->button_menu( 'data:toolButton', 'tools', 120,
        $main::data{'toolButton'} );
    print '</fieldset>';
    print '</fieldset>';

    $this->print_close_button_setting;
    $this->print_sc_button_setting;

    print
        '<fieldset class="submit"><input type="submit" value="保存" class="save" /></fieldset>';
}

######################################################################
# 登録
#sub import {
BEGIN {
    #クラス登録
    Common::class_register( 'h0zz', 'PageObj' );

    #ツール登録
    $setting::sub_jump_menu{'page'}{'h0zz'} = 'ボタン設定';
    $setting::selected_jump_menu{'h0zz'} = 'h010'
        ; #サブメニューがあるときメインメニューのデフォルトキー

    #画像
    $setting::deco_dir{'index'}   = 'インデックス ボタン';
    $setting::deco_type{'index'}  = 'button';
    $setting::deco_dir{'return'}  = '戻る ボタン';
    $setting::deco_type{'return'} = 'button';
    $setting::deco_dir{'edit'}    = '環境設定 ボタン';
    $setting::deco_type{'edit'}   = 'button';
    $setting::deco_dir{'tools'}   = '編集画面 ボタン';
    $setting::deco_type{'tools'}  = 'button';
    $setting::deco_dir{'close'}   = '閉じる ボタン';
    $setting::deco_type{'close'}  = 'button';
    if ( defined $env::checkout && $env::checkout ) {
        $setting::deco_dir{'check'}  = 'カートを見る ボタン';
        $setting::deco_type{'check'} = 'button';
    }
}

1;
