package IconEditor;
require CMONOS::CGI_Lib::Tools::ImageEditor;
@ISA = qw(ImageEditor);
use strict;
use utf8;
no warnings qw(once);
######################################################################
# ナビゲーション作成アイコンライブラリ編集モジュール
# IconEditor.pm ver1.0.1
# Copyright (C) 1999-2018 CMONOS Co. Ltd.
#
# support@cmonos.jp
# http://cmonos.jp/
# 最終更新日：2008-05-21
######################################################################
# 画像情報
sub get_image_info ($) {
    my $this = shift;
    undef %setting::deco_type;
    undef %setting::deco_dir;

    %setting::deco_type = (
        'bbs'       => 'button',
        'db'        => 'button',
        'page'      => 'button',
        'equipment' => 'button'
    );
    %setting::deco_option = (
        'bbs'       => 'save_all',
        'db'        => 'save_all',
        'page'      => 'save_all',
        'equipment' => 'save_all'
    );
    %setting::deco_dir = (
        'bbs'       => '001:BBS用アイコン',
        'db'        => '002:データベース用アイコン',
        'page'      => '003:HTMLコンテンツ用アイコン',
        'equipment' => '004:その他ツール用アイコン'
    );
    if ($env::inline_navi) {
        $setting::deco_type{'tab'}    = 'tab';
        $setting::deco_type{'tabbg'}  = 'tabbg';
        $setting::deco_type{'logo'}   = 'image';
        $setting::deco_type{'search'} = 'button';

        $setting::deco_option{'logo'} = 'noalt';

        $setting::deco_dir{'tab'}   = '101:タブ';
        $setting::deco_dir{'tabbg'} = '102:タブ背景';
        $setting::deco_dir{'logo'}  = '110:ロゴ';
        $setting::deco_dir{'search'}
            = '201:サイト検索欄表示ボタン';
    }

    my $icon_pref = $env::preference_dir . '/navi_icon';
    $this->import_db( $icon_pref, \%setting::icon, 1 );
    $main::dir = 'bbs' if !defined $main::dir || $main::dir eq '';
    $default::button_sync = ( $main::dir eq 'search' ) ? 0 : 1;
    return (
        $env::image_dir . '/navi',
        $env::image_lib . '/navi',
        \%setting::icon, $icon_pref, $env::css . '/' . $setting::image_css
    );
}

sub _success_dialog ($$) {
    my ( $this, $new ) = @_;
    push(
        @{ $this->{'dialog'} },
        '現在ナビゲーションに使用している画像を更新した場合は「ナビゲーション作成」で「ナビゲーション書き出し」を必ず実行してください。'
    ) if !$new;
}

######################################################################
# クラス登録
#sub import {
BEGIN {
    #クラス登録
    Common::class_register( '0102', 'IconEditor' );

    #メニュー登録
    $setting::jump_menu{'0102'} = 'アイコンライブラリ編集';
    $setting::master_check_option{'0102'} = 1;

    #イメージCSS
    $setting::image_css = 'navi-image.css';
}

1;
