package MkNavi;
require CMONOS::CGI_Lib::SetUp;
@ISA = qw(SetUp);
use strict;
use utf8;
######################################################################
# ナビゲーションフレーム作成モジュール
# MkNavi.pm ver1.1.4
# Copyright (C) 1999-2018 CMONOS Co. Ltd.
#
# support@cmonos.jp
# http://cmonos.jp/
# 最終更新日：2013-12-20
######################################################################
# 実行
sub run ($) {
    my $this    = shift;
    my $navi_db = $default::preference_dir . '/navi_db';
    my (%old);
    use Fcntl qw(:DEFAULT :flock);
    eval 'use ' . $env::dbm_file . ';';
    $this->use_icon( 'navi', 'navi_icon' );
    $env::home_dir_id = '' if !defined $env::home_dir_id;

    require CMONOS::CGI_Lib::NavUpdate;
    my $updater
        = NavUpdate->new( $navi_db, $default::id, $default::sitemap_path,
        $default::sitemap_ssi, $default::navi_path, $default::top_path,
        $default::frame_path );

    #全体編集書き込み
    if ( defined $main::a && $main::a ) {
        no warnings qw(numeric);
        my ( %old, @delete );
        %old = $updater->import_order( $navi_db, \%main::order );

        #不正なデータの除去
        while ( my ( $k, $v ) = each %main::order ) {
            $main::data{ $k . '_use' } = ''
                if !defined $main::data{ $k . '_use' }
                || !$main::data{ $k . '_use' };
            $main::data{ $k . '_icon' } = ''
                if !defined $main::data{ $k . '_icon' }
                || !$main::data{ $k . '_icon' };
            $main::data{ $k . '_default' } = ''
                if !defined $main::data{ $k . '_default' }
                || !$main::data{ $k . '_default' };
            $main::data{ $k . '_sitemap' } = ''
                if !defined $main::data{ $k . '_sitemap' }
                || !$main::data{ $k . '_sitemap' };
            $main::data{ $k . '_menu' } = ''
                if !defined $main::data{ $k . '_menu' }
                || !$main::data{ $k . '_menu' };
            if ( defined $env::inline_navi && $env::inline_navi ) {
                if ($main::data{ $k . '_tabcolor' } ne ''
                    && $this->is_invalid_color(
                        $main::data{ $k . '_tabcolor' }
                    )
                    )
                {
                    push(
                        @{ $this->{'dialog'} },
                        $k
                            . ' のタブ色を更新できませんでした。色指定を確認してください。'
                    );
                    delete $main::data{ $k . '_tabcolor' };
                }
                if ($main::data{ $k . '_tabfontcolor' } ne ''
                    && $this->is_invalid_color(
                        $main::data{ $k . '_tabfontcolor' }
                    )
                    )
                {
                    push(
                        @{ $this->{'dialog'} },
                        $k
                            . ' のタブ文字色を更新できませんでした。色指定を確認してください。'
                    );
                    delete $main::data{ $k . '_tabfontcolor' };
                }
            }
            else {
                delete $main::data{ $k . '_tabcolor' };
                delete $main::data{ $k . '_tabfontcolor' };
            }
            push( @delete, $k )
                if !$main::data{ $k . '_use' }
                && !$main::data{ $k . '_sitemap' }
                && $k =~ /^URI[0-9]+$/;
        }

        #CGIスキャン
        $updater->scan( \%old, \%main::order, \@delete, \%main::data )
            if $main::action && $main::action eq 'scan';

        #削除項目の順序判定への影響を回避
        foreach (@delete) {
            delete $old{$_};
            delete $main::order{$_};
        }

        #新規追加
        if ( $main::action && $main::action eq 'add' ) {
            my $error_flag = 0;
            $main::new{'uri'} = $this->z_to_h( $main::new{'uri'}, 'utf8' )
                if $main::new{'uri'} && $main::new{'uri'} =~ /[^\x20-\x7E]/;
            $main::new{'id'} = $this->z_to_h( $main::new{'id'}, 'utf8' )
                if $main::new{'id'} && $main::new{'id'} =~ /[^0-9a-zA-Z_]/;
            if ( defined $main::new{'id'}
                && $main::new{'id'} =~ /[^0-9a-zA-Z_]/ )
            {
                push(
                    @{ $this->{'dialog'} },
                    'URLを追加できませんでした。ID を半角英数字にしてください。'
                );
                $error_flag = 1;
            }
            if ( !defined $main::new{'title'} || $main::new{'title'} eq '' ) {
                push(
                    @{ $this->{'dialog'} },
                    'URLを追加できませんでした。タイトルを入力してください。'
                );
                $error_flag = 1;
            }
            if ( !defined $main::new{'uri'} || $main::new{'uri'} eq '' ) {
                push(
                    @{ $this->{'dialog'} },
                    'URLを追加できませんでした。URLを入力してください。'
                );
                $error_flag = 1;
            }

#if ($main::new{'uri'} !~ m!://! && $main::new{'uri'} !~ m!^/!) {
#	push(@{$this->{'dialog'}},'URLを追加できませんでした。フルパスまたは絶対パスでURLを入力してください。');
#	$error_flag = 1;
#}
            if (   defined $main::new{'uri'}
                && $main::new{'uri'} !~ m!://!
                && $main::new{'uri'} !~ m!^/! )
            {
                $main::new{'uri'} = $this->path_change(
                    $this->path_change(
                        $main::new{'uri'},
                        $this->path_change(
                            $default::frame_path, $ENV{'SCRIPT_NAME'},
                            'abs'
                        ),
                        'abs'
                    ),
                    $ENV{'SCRIPT_NAME'},
                    'rel'
                );
            }
            if ( !defined $main::new{'mode'} || $main::new{'mode'} eq '' ) {
                push(
                    @{ $this->{'dialog'} },
                    'URLを追加できませんでした。アイコンタイプを選択してください。'
                );
                $error_flag = 1;
            }
            if ( !$error_flag ) {
                my $n = 1;
                $n++ while defined $old{ 'URI' . $n };
                $main::data{ 'URI' . $n . '_title' } = $main::new{'title'};
                $main::data{ 'URI' . $n . '_id' }
                    = '__'
                    . ( ( defined $main::new{'id'} && $main::new{'id'} ne '' )
                    ? $main::new{'id'}
                    : $n );
                $main::data{ 'URI' . $n . '_uri' }
                    = $this->escape( $main::new{'uri'} );
                $main::data{ 'URI' . $n . '_mode' } = $main::new{'mode'};
                $main::data{ 'URI' . $n . '_openWindow' }
                    = $main::new{'openWindow'}
                    if $main::new{'openWindow'};
                $main::data{ 'URI' . $n . '_use' }     = 1;
                $main::data{ 'URI' . $n . '_sitemap' } = '';
                $old{ 'URI' . $n }                     = 9999;
                $main::order{ 'URI' . $n }             = 9999;
                undef %main::new;
                @delete = grep( $_ ne 'URI' . $n, @delete );
            }
        }

        #順序判定
        my $no = 0;
        no warnings qw(numeric);
        foreach my $num (
            sort {
                       $main::order{$a} <=> $main::order{$b}
                    || $old{$b} <=> $old{$a}
                    || $main::order{$a} cmp $main::order{$b}
                    || $a <=> $b
                    || $a cmp $b
            } keys %old
            )
        {
            $no++;
            $main::data{ 'ORDER_' . $no } = $num;
            $main::data{ $num . '_ORDER' } = $no;
        }
        undef %old;
        $this->write_db( $navi_db, \%main::data, 'ORDER', \@delete,
            \%navi::data, 1 );

        #チェックアウトのタイトル調整
        $navi::data{'order'}{'title'} = $navi::data{'order'}{'pagetitle'}
            if defined $navi::data{'order'}{'pagetitle'}
            && $navi::data{'order'}{'pagetitle'} ne '';

        #書き出し処理
        $this->import_db( $default::preference_dir . '/page',
            \%setting::page, 1, 'navi', 'sitemap' );
        if ( $main::action && $main::action eq 'write' ) {
            $updater->update(
                \%navi::data, \%setting::page,
                $cgi::icon,   \%setting::icon
            );
        }
        my $t          = time;
        my $javascript = <<JAVA;
cmonos.tool.refreshNavi = function () {
	if (parent.tool_navi) {
		parent.tool_navi.location.href = parent.tool_navi.location.href + '?mode=tool&amp;stamp=$t';
	}
}
JAVA
        $this->set_onload('cmonos.tool.refreshNavi()');
        $this->set_javascript($javascript);

    }
    else {
        $this->import_db( $default::preference_dir . '/page',
            \%setting::page, 1, 'navi', 'sitemap' );
        $this->import_db( $navi_db, \%navi::data, 1 );
        $navi::data{'order'}{'title'} = $navi::data{'order'}{'pagetitle'}
            if defined $navi::data{'order'}{'pagetitle'}
            && $navi::data{'order'}{'pagetitle'} ne '';

    }
    undef(%main::data);

    #折り畳む項目
    my $foldup_items = (
        (         !$setting::page{'navi'}{'type'}
                || $setting::page{'navi'}{'type'} ne 'icon'
        ) ? "'th','nav-icon','td','nav-icon'" : ''
        )
        . (
        (          $setting::page{'navi'}{'type'} ne 'tab'
                || !$setting::page{'navi'}{'tabtype'}
                || $setting::page{'navi'}{'tabtype'} ne 'color'
        )
        ? ( ( $setting::page{'navi'}{'type'} ne 'icon' ) ? ',' : '' )
            . "'th','tab-color','td','tab-color'"
        : ''
        );

    #ページヘッダ
    $this->jump_menu('tools');
    $this->print_page_header('tools');
    print '<h1>ナビゲーション作成</h1>';

    print $this->form_start(
        'key'      => 'tools',
        'name'     => 'input',
        'method'   => 'post',
        'onsubmit' => 'return cmonos.form.item(this).isNotSubmitted()',
        'required' => \@setting::form
    );
    print '<input type="hidden" name="a" value="e" />';
    print '<fieldset><legend>フォルダ一覧</legend>';
    print ' <label><input type="checkbox" name="foldup" value="1"'
        . ( ( !$main::a || $main::foldup ) ? ' checked="checked"' : '' )
        . ' onclick="cmonos.element.tagClass('
        . $foldup_items
        . ').disappear(this.checked);"'
        . ( ($main::foldup) ? ' checked="checked"' : '' )
        . ' /> ナビゲーション書き出し方式に関係のない項目を隠す</label>'
        if $foldup_items;

    #テーブル設定
    require CMONOS::CGI_Lib::Table;
    my $table = Table->new;
    $table->set(
        'tableclass' => 'tooltable',
        'trclass'    => 'odd,even',
        'class0'     => 'odd,even',
        'classF'     => 'name',
        'thenabled'  => 'true',
        'style0'     => 'text-align: center'
    );

    #表
    print $table->table;

    #ヘッダ
    print $table->tr;
    print $table->td('使用');
    print $table->td('トップ')
        if !defined $env::inline_navi || !$env::inline_navi;
    print $table->td('表示順');
    print $table->td('フォルダ名/(タイトル)/[ID]');
    print $table->td('デフォルト');
    print $table->td('サイトマップ');

    if ( defined $env::inline_navi && $env::inline_navi ) {
        print $table->td('メニュー');
        print $table->td( 'タブ色', { 'class' => 'odd tab-color' } );
        print $table->td( '文字色', { 'class' => 'even tab-color' } );
    }
    print $table->td( 'アイコン', { 'class' => 'odd nav-icon' } );
    print $table->_tr;

    #設定項目
    foreach ( sort { $a <=> $b } keys %{ $navi::data{'ORDER'} } ) {
        my ( $id, $icon );
        $id = $navi::data{'ORDER'}{$_};
        print $table->tr;
        if ( $id =~ /^URI[0-9]+$/ ) {
            print $table->td(
                      '<input type="checkbox" name="data:'
                    . $id
                    . '_use" id="data:'
                    . $id
                    . '_use" value="1"'
                    . (
                    ( $navi::data{$id}{'use'} ) ? ' checked="checked"' : ''
                    )
                    . ' onclick="if(!document.getElementById(\'data:'
                    . $id
                    . '_sitemap\').checked)cmonos.form.field(this).checkboxConfirm(\'追加URLの使用を中止すると追加URLが削除されます。本当に使用を中止しますか？\',false)" />'
            );
            print $table->td(
                      '<input type="radio" name="data:TOP" value="'
                    . $id . '"'
                    . (
                    (   defined $navi::data{'TOP'}
                            && $navi::data{'TOP'} eq $id
                    ) ? ' checked="checked"' : ''
                    )
                    . ' />'
            ) if !defined $env::inline_navi || !$env::inline_navi;
            print $table->td( '<input type="number" name="order:'
                    . $id
                    . '" value="'
                    . $_
                    . '" size="2" maxlength="2" />' );
            print $table->td(
                '追加URL<div class="folder-title" title="URL タイトル">(<a href="'
                    . $this->escape( $navi::data{$id}{'uri'} )
                    . '" target="_blank">'
                    . $this->escape( $navi::data{$id}{'title'} )
                    . '</a>)</div><div class="folder-id" title="BODY ID">[document'
                    . $this->escape( $navi::data{$id}{'id'} )
                    . ']</div>' );
            print $table->td( ( $navi::data{$id}{'openWindow'} )
                ? '新しいウィンドウで開く'
                : '' );
            print $table->td(
                      '<input type="checkbox" name="data:'
                    . $id
                    . '_sitemap" id="data:'
                    . $id
                    . '_sitemap" value="1"'
                    . (
                    ( $navi::data{$id}{'sitemap'} )
                    ? ' checked="checked"'
                    : ''
                    )
                    . ' onclick="if(!document.getElementById(\'data:'
                    . $id
                    . '_sitemap\').checked)cmonos.form.field(this).checkboxConfirm(\'追加URLの使用を中止すると追加URLが削除されます。本当に使用を中止しますか？\',false)" />'
            );
            if ( defined $env::inline_navi && $env::inline_navi ) {
                print $table->td('');
                print $table->td(
                    '<input type="text" name="data:'
                        . $id
                        . '_tabcolor" id="data:'
                        . $id
                        . '_tabcolor" value="'
                        . $this->escape( $navi::data{$id}{'tabcolor'} )
                        . '" size="7" maxlength="7" onclick="cmonos.tool.colorPalette.open(\'data:'
                        . $id
                        . '_tabcolor\',\'dom\')" onchange="cmonos.validate.field(this).asColor()"'
                        . (
                        ( $navi::data{$id}{'tabcolor'} )
                        ? ' style="background-color: '
                            . $navi::data{$id}{'tabcolor'} . '"'
                        : ''
                        )
                        . ' />'
                        . '<div class="toolbox"><a href="JavaScript:cmonos.tool.colorPalette.open(\'data:'
                        . $id
                        . '_tabcolor\')" ondblclick="cmonos.tool.colorPalette.open(\'data:'
                        . $id
                        . '_tabcolor\',\'window\')"><img src="'
                        . $env::image_dir
                        . '/tool/palette.gif" alt="パレット" height="12" width="18" border="0" /></a>'
                        . ' <a href="JavaScript:cmonos.tool.colorSlider.open(\'data:'
                        . $id
                        . '_tabcolor\')" ondblclick="cmonos.tool.colorSlider.open(\'data:'
                        . $id
                        . '_tabcolor\',\'window\')"><img src="'
                        . $env::image_dir
                        . '/tool/picker.gif" alt="カラーピッカー" height="12" width="18" border="0" /></a></div>',
                    { 'class' => 'odd tab-color' }
                );
                print $table->td(
                    '<input type="text" name="data:'
                        . $id
                        . '_tabfontcolor" id="data:'
                        . $id
                        . '_tabfontcolor" value="'
                        . $this->escape( $navi::data{$id}{'tabfontcolor'} )
                        . '" size="7" maxlength="7" onclick="cmonos.tool.colorPalette.open(\'data:'
                        . $id
                        . '_tabfontcolor\',\'dom\')" onchange="cmonos.validate.field(this).asColor()"'
                        . (
                        ( $navi::data{$id}{'tabfontcolor'} )
                        ? ' style="background-color: '
                            . $navi::data{$id}{'tabfontcolor'} . '"'
                        : ''
                        )
                        . ' />'
                        . '<div class="toolbox"><a href="JavaScript:cmonos.tool.colorPalette.open(\'data:'
                        . $id
                        . '_tabfontcolor\')" ondblclick="cmonos.tool.colorPalette.open(\'data:'
                        . $id
                        . '_tabfontcolor\',\'window\')"><img src="'
                        . $env::image_dir
                        . '/tool/palette.gif" alt="パレット" height="12" width="18" border="0" /></a>'
                        . ' <a href="JavaScript:cmonos.tool.colorSlider.open(\'data:'
                        . $id
                        . '_tabfontcolor\')" ondblclick="cmonos.tool.colorSlider.open(\'data:'
                        . $id
                        . '_tabfontcolor\',\'window\')"><img src="'
                        . $env::image_dir
                        . '/tool/picker.gif" alt="カラーピッカー" height="12" width="18" border="0" /></a></div>',
                    { 'class' => 'even tab-color' }
                );
            }
            print $table->td(
                $cgi::icon->button_menu(
                    'data:' . $id . '_icon', $navi::data{$id}{'mode'},
                    50,                      $navi::data{$id}{'icon'}
                ),
                { 'class' => 'odd nav-icon' }
            );
        }
        else {
            print $table->td(
                      '<input type="checkbox" name="data:'
                    . $id
                    . '_use" value="1"'
                    . (
                    ( $navi::data{$id}{'use'} ) ? ' checked="checked"' : ''
                    )
                    . ' />'
            );
            print $table->td(
                      '<input type="radio" name="data:TOP" value="'
                    . $id . '"'
                    . (
                    (   defined $navi::data{'TOP'}
                            && $navi::data{'TOP'} eq $id
                    ) ? ' checked="checked"' : ''
                    )
                    . ' />'
            ) if !defined $env::inline_navi || !$env::inline_navi;
            print $table->td( '<input type="number" name="order:'
                    . $id
                    . '" value="'
                    . $_
                    . '" size="2" maxlength="2" />' );
            print $table->td(
                (   ( $id && $id eq 'orderPaymentInfo' )
                    ? 'order/payment_info'
                    : ( $id && $id eq 'orderCartViewer' )  ? 'order/cart'
                    : ( $id && $id eq 'navimakerSiteMap' ) ? 'sitemap'
                    :                                        $id
                )
                . '<div class="folder-title" title="CGI タイトル">('
                    . $this->escape( $navi::data{$id}{'title'} )
                    . ')</div><div class="folder-id" title="BODY ID">[document'
                    . $this->escape( $navi::data{$id}{'id'} )
                    . ']</div>'
            );
            if (   $navi::data{$id}{'lib'}
                && $navi::data{$id}{'lib'} eq 'TableMaker' )
            {
                if ( $id ne 'order' && $id ne 'account' ) {
                    print $table->td(
                              '<select name="data:'
                            . $id
                            . '_default">'
                            . '<option value=""'
                            . (
                            (   !defined $navi::data{$id}{'default'}
                                    || $navi::data{$id}{'default'} eq ''
                            ) ? ' selected="selected"' : ''
                            )
                            . '>デフォルトの表示</option>'
                            . '<option value="search"'
                            . (
                            (   defined $navi::data{$id}{'default'}
                                    && $navi::data{$id}{'default'} eq 'search'
                            ) ? ' selected="selected"' : ''
                            )
                            . '>検索ページ</option>'
                            . '<option value="table"'
                            . (
                            (   defined $navi::data{$id}{'default'}
                                    && $navi::data{$id}{'default'} eq 'table'
                            ) ? ' selected="selected"' : ''
                            )
                            . '>テーブル表示</option>'
                            . '<option value="tile"'
                            . (
                            (   defined $navi::data{$id}{'default'}
                                    && $navi::data{$id}{'default'} eq 'tile'
                            ) ? ' selected="selected"' : ''
                            )
                            . '>タイル表示</option>'
                            . '<option value="gmap"'
                            . (
                            (   defined $navi::data{$id}{'default'}
                                    && $navi::data{$id}{'default'} eq 'gmap'
                            ) ? ' selected="selected"' : ''
                            )
                            . '>Googleマップ表示</option>'
                            . '<option value="dgate"'
                            . (
                            (   defined $navi::data{$id}{'default'}
                                    && $navi::data{$id}{'default'} eq 'dgate'
                            ) ? ' selected="selected"' : ''
                            )
                            . '>詳細表示選択</option>'
                            . '<option value="gate"'
                            . (
                            (   defined $navi::data{$id}{'default'}
                                    && $navi::data{$id}{'default'} eq 'gate'
                            ) ? ' selected="selected"' : ''
                            )
                            . '>修正レコード選択</option>'
                            . '<option value="input"'
                            . (
                            (   defined $navi::data{$id}{'default'}
                                    && $navi::data{$id}{'default'} eq 'input'
                            ) ? ' selected="selected"' : ''
                            )
                            . '>新規データ入力</option>'
                            . '</select>'
                    );
                }
                else {
                    print $table->td('');
                }
                $icon = 'db';
            }
            elsif ($navi::data{$id}{'lib'}
                && $navi::data{$id}{'lib'} eq 'HomePageMaker'
                && !$navi::data{$id}{'subdivided'} )
            {
                print $table->td(
                          '<select name="data:'
                        . $id
                        . '_default">'
                        . '<option value="index"'
                        . (
                        (   defined $navi::data{$id}{'default'}
                                && $navi::data{$id}{'default'} eq 'index'
                        ) ? ' selected="selected"' : ''
                        )
                        . '>インデックス</option>'
                        . '<option value="latest"'
                        . (
                        (   defined $navi::data{$id}{'default'}
                                && $navi::data{$id}{'default'} eq 'latest'
                        ) ? ' selected="selected"' : ''
                        )
                        . '>最新記事</option>'
                        . '<option value="first"'
                        . (
                        (   defined $navi::data{$id}{'default'}
                                && $navi::data{$id}{'default'} eq 'first'
                        ) ? ' selected="selected"' : ''
                        )
                        . '>最初の記事</option>'
                        . '</select>'
                );
                $icon = 'page';
            }
            elsif ($navi::data{$id}{'lib'} eq 'Baobab'
                && $navi::data{$id}{'subdivided'} )
            {
                print $table->td(
                          '<select name="data:'
                        . $id
                        . '_default">'
                        . '<option value=""'
                        . (
                        (   defined $navi::data{$id}{'default'}
                                && $navi::data{$id}{'default'} eq ''
                        ) ? ' selected="selected"' : ''
                        )
                        . '>デフォルトの順</option>'
                        . '<option value="newer"'
                        . (
                        (   defined $navi::data{$id}{'default'}
                                && $navi::data{$id}{'default'} eq 'newer'
                        ) ? ' selected="selected"' : ''
                        )
                        . '>更新時の新しい順</option>'
                        . '<option value="older"'
                        . (
                        (   defined $navi::data{$id}{'default'}
                                && $navi::data{$id}{'default'} eq 'older'
                        ) ? ' selected="selected"' : ''
                        )
                        . '>更新時の古い順</option>'
                        . '</select>'
                );
                $icon = 'bbs';
            }
            else {
                print $table->td('');
                if ( $navi::data{$id}{'lib'} eq 'Baobab' ) {
                    $icon = 'bbs';
                }
                elsif ($navi::data{$id}{'lib'} eq 'HomePageMakerLite'
                    || $navi::data{$id}{'lib'} eq 'HomePageMaker' )
                {
                    $icon = 'page';
                }
                else {
                    $icon = 'equipment';
                }
            }
            print $table->td(
                      '<input type="checkbox" name="data:'
                    . $id
                    . '_sitemap" value="1"'
                    . (
                    ( $navi::data{$id}{'sitemap'} )
                    ? ' checked="checked"'
                    : ''
                    )
                    . ' />'
            );
            if ( defined $env::inline_navi && $env::inline_navi ) {
                print $table->td(
                    ( $navi::data{$id}{'categories'} )
                    ? '<input type="checkbox" name="data:'
                        . $id
                        . '_menu" value="1"'
                        . (
                        ( $navi::data{$id}{'menu'} )
                        ? ' checked="checked"'
                        : ''
                        )
                        . ' />'
                    : ''
                );
                print $table->td(
                    '<input type="text" name="data:'
                        . $id
                        . '_tabcolor" id="data:'
                        . $id
                        . '_tabcolor" value="'
                        . $this->escape( $navi::data{$id}{'tabcolor'} )
                        . '" size="7" maxlength="7" onclick="cmonos.tool.colorPalette.open(\'data:'
                        . $id
                        . '_tabcolor\',\'dom\')" onchange="cmonos.validate.field(this).asColor()"'
                        . (
                        ( $navi::data{$id}{'tabcolor'} )
                        ? ' style="background-color: '
                            . $navi::data{$id}{'tabcolor'} . '"'
                        : ''
                        )
                        . ' />'
                        . '<div class="toolbox"><a href="JavaScript:cmonos.tool.colorPalette.open(\'data:'
                        . $id
                        . '_tabcolor\')" ondblclick="cmonos.tool.colorPalette.open(\'data:'
                        . $id
                        . '_tabcolor\',\'window\')"><img src="'
                        . $env::image_dir
                        . '/tool/palette.gif" alt="パレット" height="12" width="18" border="0" /></a>'
                        . ' <a href="JavaScript:cmonos.tool.colorSlider.open(\'data:'
                        . $id
                        . '_tabcolor\')" ondblclick="cmonos.tool.colorSlider.open(\'data:'
                        . $id
                        . '_tabcolor\',\'window\')"><img src="'
                        . $env::image_dir
                        . '/tool/picker.gif" alt="カラーピッカー" height="12" width="18" border="0" /></a></div>',
                    { 'class' => 'odd tab-color' }
                );
                print $table->td(
                    '<input type="text" name="data:'
                        . $id
                        . '_tabfontcolor" id="data:'
                        . $id
                        . '_tabfontcolor" value="'
                        . $this->escape( $navi::data{$id}{'tabfontcolor'} )
                        . '" size="7" maxlength="7" onclick="cmonos.tool.colorPalette.open(\'data:'
                        . $id
                        . '_tabfontcolor\',\'dom\')" onchange="cmonos.validate.field(this).asColor()"'
                        . (
                        ( $navi::data{$id}{'tabfontcolor'} )
                        ? ' style="background-color: '
                            . $navi::data{$id}{'tabfontcolor'} . '"'
                        : ''
                        )
                        . ' />'
                        . '<div class="toolbox"><a href="JavaScript:cmonos.tool.colorPalette.open(\'data:'
                        . $id
                        . '_tabfontcolor\')" ondblclick="cmonos.tool.colorPalette.open(\'data:'
                        . $id
                        . '_tabfontcolor\',\'window\')"><img src="'
                        . $env::image_dir
                        . '/tool/palette.gif" alt="パレット" height="12" width="18" border="0" /></a>'
                        . ' <a href="JavaScript:cmonos.tool.colorSlider.open(\'data:'
                        . $id
                        . '_tabfontcolor\')" ondblclick="cmonos.tool.colorSlider.open(\'data:'
                        . $id
                        . '_tabfontcolor\',\'window\')"><img src="'
                        . $env::image_dir
                        . '/tool/picker.gif" alt="カラーピッカー" height="12" width="18" border="0" /></a></div>',
                    { 'class' => 'even tab-color' }
                );
            }
            print $table->td(
                $cgi::icon->button_menu(
                    'data:' . $id . '_icon', $icon,
                    50,                      $navi::data{$id}{'icon'}
                ),
                { 'class' => 'odd nav-icon' }
            );
        }
        print $table->_tr;
    }

    print $table->_table;
    print $this->javascript(
        'cmonos.element.tagClass(' . $foldup_items . ').disappear(true);' )
        if $foldup_items && ( !$main::a || $main::foldup );
    print '</fieldset>';
    print
        '<fieldset class="submit"><input name="action=write" type="submit" value="ナビゲーション書き出し" /> ';
    print
        '<input name="action=scan" type="submit" value="サイトスキャン" class="group-end" /> ';
    print '<input type="submit" value="保存" class="save" />';
    print '</fieldset>';

    $table->reset_all->set(
        'tableclass' => 'tooltable',
        'trclass'    => 'odd,even',
        'class0'     => 'odd,even',
        'thenabled'  => 'true',
        'style0'     => 'text-align: center'
    );

    print '<fieldset><legend>URL 追加</legend>';
    print $table->table;
    print $table->tr;
    print $table->td('ID（半角英数字）');
    print $table->td('タイトル');
    print $table->td('URL（フルパス・絶対パス）');
    print $table->td('新しいウィンドウで開く');
    print $table->td('アイコンタイプ');
    print $table->td('新規追加');
    print $table->_tr;
    print $table->tr;
    print $table->td( '<input type="text" name="new:id" size="8" value="'
            . $this->escape( $main::new{'id'} )
            . '" title="半角英数字で入力してください。" />' );
    print $table->td( '<input type="text" name="new:title" size="16" value="'
            . $this->escape( $main::new{'title'} )
            . '" />' );
    print $table->td( '<input type="text" name="new:uri" size="40" value="'
            . $this->escape( $main::new{'uri'} )
            . '" />' );
    print $table->td(
              '<input type="checkbox" name="new:openWindow" value="1" '
            . ( ( $main::new{'openWindow'} ) ? ' checked="checked"' : '' )
            . ' />' );
    print $table->td(
              '<select name="new:mode">'
            . '<option value=""></option>'
            . '<option value="page"'
            . (
            ( defined $main::new{'mode'} && $main::new{'mode'} eq 'page' )
            ? ' selected="selected"'
            : ''
            )
            . '>HTMLコンテンツ用</option>'
            . '<option value="db"'
            . (
            ( defined $main::new{'mode'} && $main::new{'mode'} eq 'db' )
            ? ' selected="selected"'
            : ''
            )
            . '>データベース用</option>'
            . '<option value="bbs"'
            . (
            ( defined $main::new{'mode'} && $main::new{'mode'} eq 'bbs' )
            ? ' selected="selected"'
            : ''
            )
            . '>BBS用</option>'
            . '<option value="equipment"'
            . (
            (   defined $main::new{'mode'}
                    && $main::new{'mode'} eq 'equipment'
            ) ? ' selected="selected"' : ''
            )
            . '>ツール用</option>'
            . '</select>'
    );
    print $table->td(
        '<input type="submit" name="action=add" value="URL 追加" />');
    print $table->_tr;
    print $table->_table;

    $table->reset_all;
    undef %$table;
    undef $table;

    print '</fieldset>';
    print '</form>';

    #ページフッタ
    $this->print_page_footer('tools');
}

######################################################################
# クラス登録
#sub import {
BEGIN {
    no warnings qw(once);

    #クラス登録
    Common::class_register( 'n100', 'MkNavi' );

    #ツール登録
    $setting::jump_menu{'n100'} = 'ナビゲーション作成'
        if !defined $setting::jump_menu{'n100'};
}

1;
