package MailRules;
require CMONOS::CGI_Lib::Field;
@ISA = qw(Field);
use strict;
use utf8;
######################################################################
# フィールド定義モジュール（メール送信先振り分け）
# MailRules1.0
# Copyright (C) 1999-2018 CMONOS Co. Ltd.
#
# support@cmonos.jp
# http://cmonos.jp/
# 最終更新日：2014-01-18
######################################################################
sub _set ($$) {
    my ( $this, $setting ) = @_;
    $this->{'condition'} = {} if !ref $this->{'condition'};
    $this->scalar_to_array( \$this->{'order'} ) if !ref $this->{'order'};
    $this->{'selectortype'} = 'checkbox' if !defined $this->{'selectortype'};
    return;
}

######################################################################
#	(1) obj->match(str);
sub match_enabled ($) {
    my $this = shift;
    return (
        (   defined $main::search{ $this->{'id'} }{'str'}
                && $main::search{ $this->{'id'} }{'str'} ne ''
        )
            || ( ref $main::search{ $this->{'id'} }{'str'}
            && @{ $main::search{ $this->{'id'} }{'str'} } > 0 )
    ) ? 1 : 0;
}

sub match ($;$) {
    my ( $this, $str ) = @_;
    my ( $pat, @str );
    return 1
        unless ( defined $main::search{ $this->{'id'} }{'str'}
        && $main::search{ $this->{'id'} }{'str'} ne '' )
        || ( ref $main::search{ $this->{'id'} }{'str'}
        && @{ $main::search{ $this->{'id'} }{'str'} } > 0 );
    $this->scalar_to_array( \$main::search{ $this->{'id'} }{'str'} )
        if !ref $main::search{ $this->{'id'} }{'str'};
    @str = split( /,/, $$str );
    foreach $pat ( @{ $main::search{ $this->{'id'} }{'str'} } ) {
        next if $pat eq '';
        if ( grep( $_ eq $pat, @str ) > 0 ) {
            return 1
                if !defined $main::search{ $this->{'id'} }{'mode'}
                || $main::search{ $this->{'id'} }{'mode'} ne 'and';
        }
        elsif ( defined $main::search{ $this->{'id'} }{'mode'}
            && $main::search{ $this->{'id'} }{'mode'} eq 'and' )
        {
            return 0;
        }
    }
    if ( defined $main::search{ $this->{'id'} }{'mode'}
        && $main::search{ $this->{'id'} }{'mode'} eq 'and' )
    {
        return 1;
    }
    else {
        return 0;
    }
}

######################################################################
#	(2) obj->form;
sub form {
    my ( $this, $status ) = @_;
    my ($form);
    my $default_enabled = 0;
    if ( !ref $main::data{ $this->{'id'} }{'str'} ) {
        my @temp;
        if ( defined $main::data{ $this->{'id'} }{'str'}
            && $main::data{ $this->{'id'} }{'str'} =~ /,/ )
        {
            @temp = split( /,/, $main::data{ $this->{'id'} }{'str'} );
            delete $main::data{ $this->{'id'} }{'str'};
            @{ $main::data{ $this->{'id'} }{'str'} } = @temp;
        }
        elsif ( defined $main::data{ $this->{'id'} }{'str'}
            && $main::data{ $this->{'id'} }{'str'} ne '' )
        {
            @temp = ( $main::data{ $this->{'id'} }{'str'} );
            delete $main::data{ $this->{'id'} }{'str'};
            @{ $main::data{ $this->{'id'} }{'str'} } = @temp;
        }
        else {
            $default_enabled = 1
                if !defined $main::data{ $this->{'id'} }{'str'}
                || $this->{'required'};
            $main::data{ $this->{'id'} }{'str'} = [];
        }
    }
    $form = $this->field_header(
        50,
        (   (          $this->{'selectortype'} eq 'menu'
                    || $this->{'selectortype'} eq 'multiplemenu'
            ) ? 'data:' . $this->{'id'} . ':str' : ''
        )
    );
    $form .= $this->get_selector(
        'data', $main::data{ $this->{'id'} }{'str'},
        0,      $this->{'is_invalid_field'}{'str'}
    );
    $form .= $this->field_footer;
    return $form;
}

sub get_selector ($$;$$$) {
    my ( $this, $name, $default, $multiple_flag, $is_invalid ) = @_;
    my $form = '';
    $name .= ':' . $this->{'id'} . ':str';
    if (   $this->{'selectortype'} eq 'menu'
        || $this->{'selectortype'} eq 'multiplemenu' )
    {
        $form .= '<select name="' . $name . '" id="' . $name . '"';
        if ( $multiple_flag || $this->{'selectortype'} eq 'multiplemenu' ) {
            if ( !$this->{'row'} ) {
                my $row
                    = ( ref $this->{'condition'} )
                    ? keys %{ $this->{'condition'} }
                    : 1;
                $this->{'row'} = ( $row > 4 ) ? 4 : $row;
            }
            $form .= ' multiple="multiple" size="' . $this->{'row'} . '"';
        }
        if ($is_invalid) {
            $form .= ' class="invalid-field"';
            $form .= ' onchange="cmonos.validate.field(this).bailOut();"';
        }
        $form .= '>';
        $form .= '<option value=""></option>'
            unless $multiple_flag
            || $this->{'selectortype'} eq 'multiplemenu'
            || $this->{'required'};
        my $id;
        foreach $id ( @{ $this->{'order'} } ) {
            $form
                .= '<option value="'
                . $id . '"'
                . (
                (   (          ref $default
                            && @$default
                            && grep( $_ eq $id, @$default )
                    )
                        || ( ( !ref $default || !@$default )
                        && $this->{'condition'}{$id}{'selected'} )
                ) ? ' selected="selected"' : ''
                )
                . '>'
                . $this->detag( $this->{'condition'}{$id}{'name'} )
                . '</option>';
        }
        $form .= '</select>';
    }
    else {
        my $type
            = ( $multiple_flag || $this->{'selectortype'} eq 'checkbox' )
            ? 'checkbox'
            : 'radio';
        $form .= '<ol class="checkbox">';
        $form
            .= '<li><label'
            . ( ($is_invalid) ? ' class="invalid-field"' : '' )
            . '><input type="radio" name="'
            . $name
            . '" value=""'
            . ( ( !ref $default || !@$default ) ? ' checked="checked"' : '' )
            . ( ($is_invalid)
            ? ' onclick="cmonos.validate.field(this).bailOut();"'
            : '' )
            . '/></label></li>'
            unless $type eq 'checkbox' || $this->{'required'};
        my $id;
        foreach $id ( @{ $this->{'order'} } ) {
            $form
                .= '<li><label'
                . ( ($is_invalid) ? ' class="invalid-field"' : '' )
                . '><input type="'
                . $type
                . '" name="'
                . $name
                . '" value="'
                . $id . '"'
                . (
                (   (          ref $default
                            && @$default
                            && grep( $_ eq $id, @$default )
                    )
                        || ( ( !ref $default || !@$default )
                        && $this->{'condition'}{$id}{'selected'} )
                ) ? ' checked="checked"' : ''
                )
                . ( ($is_invalid)
                ? ' onclick="cmonos.validate.field(this).bailOut();"'
                : '' )
                . ' /> '
                . $this->{'condition'}{$id}{'name'}
                . '</label></li>';
        }
        $form .= '</ol>';
    }
    return $form;
}

sub detag ($$) {
    my ( $this, $str ) = @_;
    $str =~ s/<(.*?)>/(($1 =~ m! alt="(.*?)"!i) ? $1 : '')/egs;
    $str =~ s/"/&quot;/g;
    $str =~ s/</&lt;/g;
    $str =~ s/>/&gt;/g;
    $str =~ s/\x0D\x0A/ /gs;
    $str =~ s/\x0D/ /gs;
    return $str;
}

######################################################################
#	(3) obj->is_valid_data(path);
sub is_valid_data ($;$) {
    my $this = shift;
    delete $this->{'is_invalid_field'} if ref $this->{'is_invalid_field'};
    if ( !ref $main::data{ $this->{'id'} }{'str'} ) {
        if (   $main::data{ $this->{'id'} }{'str'}
            && $main::data{ $this->{'id'} }{'str'} =~ /,/ )
        {
            $main::data{ $this->{'id'} }{'str'} = [
                grep( $_ ne '',
                    split( /,/, $main::data{ $this->{'id'} }{'str'} ) )
            ];
        }
        else {
            $this->scalar_to_array( \$main::data{ $this->{'id'} }{'str'} );
        }
    }
    @{ $main::data{ $this->{'id'} }{'str'} }
        = grep( ref $this->{'condition'}->{$_},
        @{ $main::data{ $this->{'id'} }{'str'} } );
    $main::data{ $this->{'id'} }{'str'}
        = ( @{ $main::data{ $this->{'id'} }{'str'} } )
        ? ( $this->{'selectortype'} eq 'checkbox'
            || $this->{'selectortype'} eq 'multiplemenu' )
            ? join( ",", @{ $main::data{ $this->{'id'} }{'str'} } )
            : shift( @{ $main::data{ $this->{'id'} }{'str'} } )
        : '';
    $this->escape_data_tag('str');
    if ( $main::data{ $this->{'id'} }{'str'} ne '' ) {
        $cookie::data{ 'data:' . $this->{'id'} . ':str' }
            = $main::data{ $this->{'id'} }{'str'}
            if defined $this->{'cookie'}
            && $this->{'cookie'}
            && defined $main::set_cookie
            && $main::set_cookie;
    }
    elsif ( $this->{'required'} ) {
        push(
            @{ $cgi::action->{'dialog'} },
            (   ( defined $this->{'name'} && $this->{'name'} )
                ? $this->{'name'} . 'が'
                : ''
                )
                . '選択されていません。'
        ) if ref $cgi::action;
        $this->{'is_invalid_field'}{'str'} = 1;
        return 0;
    }
    if ( ref $cgi::action ) {
        my @selected
            = ( $main::data{ $this->{'id'} }{'str'} )
            ? split( /,/, $main::data{ $this->{'id'} }{'str'} )
            : ();
        $cgi::action->{'mail_to'} = [] if !ref $cgi::action->{'mail_to'};
        while ( my ($id) = each %{ $this->{'condition'} } ) {
            if ((      $this->{'condition'}{$id}{'status'} eq 'selected'
                    && @selected
                    && grep( $id eq $_, @selected )
                )
                || ( $this->{'condition'}{$id}{'status'} eq 'neglected'
                    && ( !@selected || !grep( $id eq $_, @selected ) ) )
                )
            {
                push(
                    @{ $cgi::action->{'mail_to'} },
                    $this->{'condition'}{$id}{'mailto'}
                );
            }
        }
    }
    return 1;
}

######################################################################
#	(4)-1 obj->usual_format(str);
sub usual_format {
    my ( $this, $str ) = @_;
    $str = $$str{'str'} if ref $str eq 'HASH';
    return '' if !defined $str || $str eq '';
    return $this->field_tag(
        $this->data_tag_from_hash( 'str', $str )
            . $this->style(
            $this->id_to_list( $str, $this->{'listtype'} ),
            $this->{'style'},     $this->{'fontsize'},
            $this->{'fontcolor'}, $this->{'fontface'}
            )
    );
}

sub id_to_list ($$;$$) {
    my ( $this, $str, $type, $html_disabled ) = @_;
    my $id;
    my $no   = 1;
    my $list = '';
    my @id   = ( ref $str ) ? @$str : split( /,/, $str );
    return '' if !@id;
    return ($html_disabled)
        ? $this->detag( $this->{'condition'}{ $id[0] }{'name'} )
        : $this->{'condition'}{ $id[0] }{'name'}
        if @id == 1;
    $list .= ( $type eq 'ul' ) ? '<ul>' : '<ol>'
        if !$html_disabled && $type && $type ne 'csv';

    foreach $id (@id) {
        next if !ref $this->{'condition'}->{$id};
        if ( !$type || $type eq 'csv' ) {
            $list
                .= ( ( $list ne '' ) ? ', ' : '' )
                . ( ($html_disabled)
                ? $this->detag( $this->{'condition'}{$id}{'name'} )
                : $this->{'condition'}{$id}{'name'} );
        }
        elsif ($html_disabled) {
            $list .= ( ( $type eq 'ul' ) ? '・' : $no++ . ') ' )
                . $this->detag( $this->{'condition'}{$id}{'name'} ) . "\x0A";
        }
        else {
            $list .= '<li>' . $this->{'condition'}{$id}{'name'} . '</li>';
        }
    }
    $list .= ( $type eq 'ul' ) ? '</ul>' : '</ol>'
        if !$html_disabled && $type && $type ne 'csv';
    return $list;
}

#---------------------------------------------------------------------
#	(4)-2 obj->format_for_mail(str);
sub format_for_mail {
    my ( $this, $str ) = @_;
    $str = $$str{'str'} if ref $str eq 'HASH';
    return '' if !defined $str || $str eq '';
    $str = $this->id_to_list( $str, $this->{'listtype'}, 1 );
    $str = '[' . $this->name . "]\x0A" . $str;
    $str =~ s/[\x0A]*\Z/\x0A\x0A/s;
    return $str;
}

#---------------------------------------------------------------------
#	(4)-4 obj->format_for_text(str);
sub format_for_text {
    my ( $this, $str ) = @_;
    $str = $$str{'str'} if ref $str eq 'HASH';
    return '' if !defined $str || $str eq '';
    return $this->id_to_list( $str, 'csv', 1 );
}

######################################################################
#	(5) obj->print_setting_form;
sub print_setting_form ($;$$) {
    my ( $this, $html_disabled ) = @_;

    #名前
    my $name = 'data:' . $this->{'id'};
    my $n    = 1;
    my $id   = 1;
    $this->print_field_info_form($name);
    print '<fieldset>';
    print '<legend>選択肢の表示</legend>';
    print '<ol class="checkbox">';
    print '<li><label><input type="radio" name="'
        . $name
        . '_selectortype" value="menu"'
        . ( ( $this->{'selectortype'} && $this->{'selectortype'} eq 'menu' )
        ? ' checked="checked"'
        : '' )
        . ' />メニュー</label></li>';
    print '<li><label><input type="radio" name="'
        . $name
        . '_selectortype" value="multiplemenu"'
        . (
        (          $this->{'selectortype'}
                && $this->{'selectortype'} eq 'multiplemenu'
        ) ? ' checked="checked"' : ''
        ) . ' />複数選択可能メニュー</label></li>';
    print '<li><label><input type="radio" name="'
        . $name
        . '_selectortype" value="checkbox"'
        . (
        (   !$this->{'selectortype'}
                || ( $this->{'selectortype'}
                && $this->{'selectortype'} eq 'checkbox' )
        ) ? ' checked="checked"' : ''
        ) . ' />チェックボックス</label></li>';
    print '<li><label><input type="radio" name="'
        . $name
        . '_selectortype" value="radio"'
        . ( ( $this->{'selectortype'} && $this->{'selectortype'} eq 'radio' )
        ? ' checked="checked"'
        : '' )
        . ' />ラジオボタン</label></li>';
    print '</ol>';
    print '</fieldset>';
    print '<fieldset>';
    print '<legend>選択肢設定</legend>';
    print '<table class="tooltable">';
    print '<thead>';
    print '<tr class="odd">';
    print '<th class="odd">削除</th>';
    print '<th class="even">表示順</th>';
    print '<th class="odd">選択済</th>';
    print '<th class="even">選択肢の内容</th>';
    print '<th class="odd">選択状態</th>';
    print '<th class="even">送信先メールアドレス</th>';
    print '</tr>';
    print '</thead>';
    print '<tbody>';

    if ( ref $this->{'condition'} ) {
        foreach $id ( @{ $this->{'order'} } ) {
            $this->print_condition_setting_form( $name, $id, $n++ );
        }
        $id = 1;
        $id++ while ref $this->{'condition'}{$id};
    }
    $this->print_condition_setting_form( $name, $id, $n, 1 );
    print '</tbody></table>';
    print '</fieldset>';
    print '<fieldset>';
    print '<legend>複数選択可能な場合の表示</legend>';
    print '<ol class="checkbox">';
    print '<li><label><input type="radio" name="'
        . $name
        . '_listtype" value="csv"'
        . (
        (   !$this->{'listtype'}
                || ( $this->{'listtype'} && $this->{'listtype'} eq 'csv' )
        ) ? ' checked="checked"' : ''
        ) . ' /> カンマ区切りテキスト</label></li>';
    print '<li><label><input type="radio" name="'
        . $name
        . '_listtype" value="ul"'
        . ( ( $this->{'listtype'} && $this->{'listtype'} eq 'ul' )
        ? ' checked="checked"'
        : '' )
        . ' /> リスト(&lt;ul&gt;)</label></li>';
    print '<li><label><input type="radio" name="'
        . $name
        . '_listtype" value="ol"'
        . ( ( $this->{'listtype'} && $this->{'listtype'} eq 'ol' )
        ? ' checked="checked"'
        : '' )
        . ' /> 番号付リスト(&lt;ol&gt;)</label></li>';
    print '</ol>';
    print '</fieldset>';
    $this->print_font_setting_form($name)
        if !defined $html_disabled || !$html_disabled;
    $this->print_setting_save_button;
    return;
}

sub print_condition_setting_form ($$$$;$) {
    my ( $this, $name, $id, $n, $new ) = @_;
    $name .= '_condition_' . $id . '_';
    print '<tr class="' . ( ( $n % 2 ) ? 'even' : 'odd' ) . '">';
    print '<td class="caution">'
        . ( ( !$new )
        ? '<input type="checkbox" name="delete:' . $id . '" value="1" />'
        : '新規' )
        . '</td>';
    print '<td class="even"><input type="hidden" name="oldorder:'
        . $id
        . '" value="'
        . $n
        . '" /><input type="number" name="order:'
        . $id
        . '" value="'
        . $n
        . '" size="3" /></td>';
    print '<td class="odd"><input type="checkbox" name="'
        . $name
        . 'selected" value="1"'
        . ( ( $id && $this->{'condition'}{$id}{'selected'} )
        ? ' checked="checked"'
        : '' )
        . ' /></td>';
    print '<td class="even"><textarea name="'
        . $name
        . 'name" cols="24" rows="3" title="選択肢の内容を入力します。">'
        . $this->escape( $this->{'condition'}{$id}{'name'} )
        . '</textarea></td>';
    print '<td class="odd">';
    print '<select name="' . $name . 'status">';
    print '<option value="selected"'
        . (
        (          $id
                && $this->{'condition'}{$id}{'status'}
                && $this->{'condition'}{$id}{'status'} eq 'selected'
        ) ? ' selected="selected"' : ''
        ) . '>選択されたとき</option>';
    print '<option value="neglected"'
        . (
        (          $id
                && $this->{'condition'}{$id}{'status'}
                && $this->{'condition'}{$id}{'status'} eq 'neglected'
        ) ? ' selected="selected"' : ''
        ) . '>選択されなかったとき</option>';
    print '</select>';
    print '</td>';
    print '<td class="even"><textarea name="'
        . $name
        . 'mailto" cols="24" rows="3" title="複数設定する場合はメールアドレスごとに改行します。">'
        . $this->escape( $this->{'condition'}{$id}{'mailto'} )
        . '</textarea></td>';
    print '</tr>';
}

######################################################################
#	(6) obj->is_valid_setting;
sub is_valid_setting ($) {
    no warnings qw(numeric);
    my $this       = shift;
    my $selected   = 0;
    my @conditions = ();
    my $id;
    while ( ($id) = each %main::order ) {
        if ( $main::delete{$id}
            || !
            defined $main::data{ $this->{'id'}
                    . '_condition_'
                    . $id
                    . '_name' }
            || $main::data{ $this->{'id'} . '_condition_' . $id . '_name' }
            eq '' )
        {
            $main::data{ $this->{'id'} . '_condition_' . $id . '_name' }
                = "\x7F";
            $main::data{ $this->{'id'} . '_condition_' . $id . '_selected' }
                = "\x7F";
            $main::data{ $this->{'id'} . '_condition_' . $id . '_status' }
                = "\x7F";
            $main::data{ $this->{'id'} . '_condition_' . $id . '_mailto' }
                = "\x7F";
        }
        else {
            push( @conditions, $id );
            $this->tag_fix(
                \$main::data{ $this->{'id'} . '_condition_' . $id . '_name' }
            );
            $main::data{ $this->{'id'} . '_condition_' . $id . '_selected' }
                = (
                (   $main::data{ $this->{'id'}
                            . '_condition_'
                            . $id
                            . '_selected' }
                        && ( $main::data{ $this->{'id'} . '_selectortype' } eq
                        'checkbox'
                        || $main::data{ $this->{'id'} . '_selectortype' } eq
                        'multiplemenu'
                        || !$selected )
                ) ? 1 : 0
                );
            $main::data{ $this->{'id'} . '_condition_' . $id . '_mailto' }
                = join(
                "\x0A",
                $this->get_address(
                    $main::data{ $this->{'id'}
                            . '_condition_'
                            . $id
                            . '_mailto' }
                )
                )
                if $main::data{ $this->{'id'}
                    . '_condition_'
                    . $id
                    . '_mailto' };
            $selected = 1
                if $main::data{ $this->{'id'}
                    . '_condition_'
                    . $id
                    . '_selected' };
        }
    }
    $main::data{ $this->{'id'} . '_order' } = [
        (   sort {
                       $main::order{$a} <=> $main::order{$b}
                    || $main::oldorder{$b} <=> $main::oldorder{$a}
                    || $main::order{$a} cmp $main::order{$b}
                    || $a <=> $b
            } @conditions
        )
    ];
    $this->tag_fix( \$main::data{ $this->{'id'} . '_description' } )
        if defined $main::data{ $this->{'id'} . '_description' }
        && $main::data{ $this->{'id'} . '_description' };
    $this->tag_fix( \$main::data{ $this->{'id'} . '_note' } )
        if defined $main::data{ $this->{'id'} . '_note' }
        && $main::data{ $this->{'id'} . '_note' };
    return $this->is_valid_font_setting;
}

######################################################################
#	(7) obj->search_form;
sub search_form ($) {
    my $this = shift;
    my ($form);
    $this->scalar_to_array( \$main::search{ $this->{'id'} }{'str'} );
    $form = '<tr><td class="field-name">'
        . (
        (          $this->{'selectortype'} eq 'menu'
                || $this->{'selectortype'} eq 'multiplemenu'
        )
        ? '<label for="search:'
            . $this->{'id'}
            . ':str">'
            . $this->{'name'}
            . '</label>'
        : '<span class="datatitle">' . $this->{'name'} . '</span>'
        ) . '</td><td class="field">';
    $form .= $this->get_selector( 'search',
        $main::search{ $this->{'id'} }{'str'}, 1 );
    if (   $this->{'selectortype'} eq 'checkbox'
        || $this->{'selectortype'} eq 'multiplemenu' )
    {
        $form .= $this->mk_select_menu(
            'search:' . $this->{'id'} . ':mode',
            '', '',
            $main::search{ $this->{'id'} }{'mode'},
            'and' => (
                ($default::english) ? 'Matches on all selection'
                : '全ての選択肢に一致'
            ),
            'or' => (
                ($default::english) ? 'Matches on any selection'
                : 'いずれかの選択肢に一致'
            )
        );
    }
    $form .= '</td></tr>';
    return $form;
}

######################################################################
#sub import {
BEGIN {
    Field::class_register( 'select_mailrules', 'MailRules',
        'メール送信先振り分け' );
}

1;
