package ThanksMsg;
require CMONOS::CGI_Lib::Tools::Preference;
@ISA = qw(Preference);
use strict;
use utf8;
######################################################################
# 入力お礼設定モジュール
# ThanksMsg.pm ver1.0.1
# Copyright (C) 1999-2018 CMONOS Co. Ltd.
#
# support@cmonos.jp
# http://cmonos.jp/
# 最終更新日：2015-04-17
######################################################################
# 設定環境
sub set_preferences ($) {
    my $this = shift;
    $preference::db   = 'thanks';             # 記録用データベース名
    $preference::name = '自動返信設定'; # 設定パネル名
    $preference::title
        = 'アンケート送信後に自動返信されるメールの設定をします。';
}

######################################################################
# 設定パネル
sub print_preference_panel ($) {
    my $this = shift;
    $this->use_field( 'field', $default::field_pref_dir . '/inquiryfield',
        2 );
    if (   $field::for{'from'}
        && ref $field::obj{ $field::for{'from'} }
        && $field::obj{ $field::for{'from'} }->{'e-mail'} )
    {
        print '<fieldset><legend>自動返信設定</legend>';
        print '<table class="field-table"><tbody>';
        print
            '<tr><td class="field-name"><label for="data:ressubject">自動返信メールの表題</label></td>';
        print
            '<td class="field"><input type="text" name="data:ressubject" id="data:ressubject" size="72" value="'
            . $this->escape( $main::data{'ressubject'} )
            . '" title="自動返信されるメールの表題を設定します。" />';
        print '</td></tr>';

        print
            '<tr><td class="field-name"><label for="data:resmsg">自動返信メールの本文</label></td>';
        print
            '<td class="field"><textarea name="data:resmsg" id="data:resmsg" cols="72" rows="15" wrap="soft">'
            . $this->escape( $main::data{'resmsg'} )
            . '</textarea>';
        print '<div class="toolbox">';
        print
            '<select class="tool" onchange="cmonos.form.item(this.form).fieldname(\'data:resmsg\').quotationByMenu(this)" title="これらのタグはお礼表示時に対応する値に変換されます。">';
        print '<option value="">▼挿入する</option>';
        print
            '<option value="&lt;name&gt;">&lt;name&gt;[差出人名フィールド'
            . (
            ( $field::for{'name'} && ref $field::obj{ $field::for{'name'} } )
            ? '（' . $field::obj{ $field::for{'name'} }->name . '）'
            : '' )
            . 'の値]</option>';
        print
            '<option value="&lt;data&gt;">&lt;data&gt;[入力されたデータの一覧]</option>';
        print
            '<option value="&lt;number&gt;">&lt;number&gt;[通し番号]</option>';
        print '</select>';
        print '</div>';
        print '</td></tr>';

        print
            '<tr><td class="field-name"><label for="data:defaultname">&lt;name&gt; のデフォルト</label></td>';
        print
            '<td class="field"><input type="text" name="data:defaultname" id="data:defaultname" size="20" value="'
            . $this->escape( $main::data{'defaultname'} )
            . '" title="&lt;name&gt; のデフォルトを設定します。" />';
        print '</td></tr>';
        print '</tbody></table>';

        print '</fieldset>';

        print
            '<fieldset class="submit"><input type="submit" value="保存" class="save" /></fieldset>';

    }
    else {
        print
            '<fieldset>差出人メールアドレスフィールドが存在しないので、自動返信機能は利用できません。<br />アンケートフィールド設定で差出人メールアドレスフィールドを指定してください。</fieldset>';
    }

}

######################################################################
# クラス登録
#sub import {
BEGIN {
    #クラス登録
    Common::class_register( 'q010', 'ThanksMsg' );

    #ツール登録
    $setting::jump_menu{'q010'} = '自動返信設定';
}

1;
