package Password;
require CMONOS::Register::RgCommon;
@ISA = qw(RgCommon);
use strict;
use utf8;
######################################################################
# パスワード登録モジュール
# Password.pm ver1.1.0
# Copyright (C) 1999-2018 CMONOS Co. Ltd.
#
# support@cmonos.jp
# http://cmonos.jp/
# 最終更新日：2015-01-18
######################################################################
# メイン
sub run ($) {
    my $this = shift;
    $this->print_register_dialog( 'pswd',
        '設定エラー！ : パスワード管理データベースディレクトリのパスが設定されていません。'
    ) if !$this->use_register;
    $this->jump($env::register_cgi)
        if $this->path_change( $env::register_cgi, $ENV{'SCRIPT_NAME'},
        'abs' ) ne $ENV{'SCRIPT_NAME'};
    $main::a = '' if !defined $main::a;

    #---------------------------------------------------------------------
    #セキュリティチェック
    my ( $is_secure, $is_registered, $claimed_id, $reregistry_enabled,
        $want_new_password_form );
    $main::referer_url = $ENV{'HTTP_REFERER'} || ''
        if !$main::referer_url || $main::referer_url !~ m!^https?://!;
    ( $is_secure, $is_registered, $claimed_id, $reregistry_enabled )
        = $this->id_info($main::addr);

    #---------------------------------------------------------------------
    #処理
    if ($main::transition) {
        if ( !$is_secure && !$reregistry_enabled ) {
            $this->print_register_dialog( 'pswd',
                'メールアドレス登録権限がありません。' );
        }
        if ( $claimed_id && $main::a eq 'o' ) {
            $main::a = 'c';
        }
        elsif ( $main::a && $main::a ne 'r' && $main::a ne 'o' ) {
            push(
                @{ $this->{'dialog'} },
                '登録メールアドレスの移行中です。'
            );
            $main::a = '';
        }
    }
    my $logout = 1
        if !$main::transition
        && !$main::login
        && !$main::a
        && $main::email
        && defined $main::pswd;
    if ( $main::a eq 'c' ) {
        if ($claimed_id) {
            $this->print_openid_login_panel_opener( $main::addr,
                $claimed_id );
        }
        elsif (
            $cgi::Register->is_registered(
                $main::password, $main::addr, 0, 1
            )
            )
        {
            if ( $env::session_enabled && $this->use_session ) {
                if (   !$session::is_changed
                    || !$main::email
                    || $main::email ne $main::addr )
                {
                    $session::id = $cgi::Session->set_user_info( $main::addr,
                        $main::password, $session::id );
                    $session::is_changed = 1;
                }
            }
            else {
                $main::set_cookie_id = 1;
            }
            $main::email = $main::addr;
            $main::pswd  = $main::password;
            push(
                @{ $this->{'dialog'} },
                'ログインに成功しました。'
            );
            $this->set_onload('cmonos.window.refreshOpener()')
                if !$env::register_in_same_window;
        }
        else {
            my @error_msg = $cgi::Register->error_dialog;
            push(
                @{ $this->{'dialog'} },
                (   (@error_msg)
                    ? @error_msg
                    : 'パスワードまたはメールアドレスに誤りがあります。'
                )
            );
        }
    }
    elsif ( $main::a eq 'cd' ) {
        $this->log_out;
        push( @{ $this->{'dialog'} }, 'ログアウトしました。' );
        $this->set_onload('cmonos.window.refreshOpener()')
            if !$env::register_in_same_window;
        $main::a = '';
    }
    elsif ( $main::a eq 'p' ) {
        if ( !$setting::general{'changeable'} ) {
            push(
                @{ $this->{'dialog'} },
                'パスワード変更は認められていません。'
            );
            undef $main::a;
        }
        elsif ($main::action) {
            $want_new_password_form = 1;
            if ( $main::password !~ /^[a-zA-Z0-9]{6,}$/ ) {
                push(
                    @{ $this->{'dialog'} },
                    'パスワード変更に失敗しました。新しいパスワードは6文字以上の半角英数字列にしてください。'
                );
            }
            elsif ( $main::password ne $main::password2 ) {
                push(
                    @{ $this->{'dialog'} },
                    'パスワード変更に失敗しました。新しいパスワードが確認用のパスワードと一致しません。'
                );
            }
            elsif (
                !$cgi::Register->is_registered( $main::pswd, $main::email ) )
            {
                push(
                    @{ $this->{'dialog'} },
                    '認証に失敗しました。'
                );
            }
            elsif (
                $cgi::Register->password_register(
                    $main::password, $main::email
                )
                )
            {
                $main::pswd = $main::password;
                if ( $env::session_enabled && $this->use_session ) {
                    $session::id = $cgi::Session->set_user_info( $main::email,
                        $main::pswd, $session::id );
                    $session::is_changed = 1;
                }
                else {
                    $main::set_cookie_id = 1;
                }
                push(
                    @{ $this->{'dialog'} },
                    'パスワード変更に成功しました。'
                );
                $want_new_password_form = 0;
                $main::a                = '';
            }
            else {
                push(
                    @{ $this->{'dialog'} },
                    'パスワード変更に失敗しました。'
                );
            }
        }
        else {
            my $change_enabled = 0;
            if ( $is_registered && !$claimed_id ) {
                if ($cgi::Register->is_registered(
                        $main::password, $main::addr
                    )
                    )
                {
                    if (   !$session::is_changed
                        || !$main::email
                        || $main::email ne $main::addr )
                    {
                        $session::id
                            = $cgi::Session->set_user_info( $main::addr,
                            $main::password, $session::id );
                        $session::is_changed = 1;
                    }
                    $main::email    = $main::addr;
                    $main::pswd     = $main::password;
                    $change_enabled = 1;
                }
            }
            elsif ($claimed_id) {
                if (   $main::email
                    && $main::addr
                    && $main::email eq $main::addr
                    && ref $main::pswd
                    && $cgi::Register->is_identified( $main::pswd,
                        $claimed_id ) )
                {
                    $change_enabled = 1;
                }
                elsif ( $cgi::Register->is_master( $main::password, 1 ) ) {
                    $session::id = $cgi::Session->set_user_info( $main::addr,
                        $main::password, $session::id );
                    $session::is_changed = 1;
                    $main::email         = $main::addr;
                    $main::pswd          = $main::password;
                    $change_enabled      = 1;
                }
            }
            if ($change_enabled) {
                $want_new_password_form = 1;
            }
            else {
                push(
                    @{ $this->{'dialog'} },
                    '認証に失敗しました。パスワードを変更する前に、このメールアドレスでログインしてください。'
                );
            }
        }
    }
    elsif ( $main::a eq 'o' ) {
        if ($env::openid_enabled) {
            my $openid_enabled = 0;
            my $login_failed   = 0;
            if ( $is_registered && !$claimed_id ) {
                if ($cgi::Register->is_registered(
                        $main::password, $main::addr
                    )
                    )
                {
                    if (   !$session::is_changed
                        || !$main::email
                        || $main::email ne $main::addr )
                    {
                        $session::id
                            = $cgi::Session->set_user_info( $main::addr,
                            $main::password, $session::id );
                        $session::is_changed = 1;
                    }
                    $main::email    = $main::addr;
                    $main::pswd     = $main::password;
                    $openid_enabled = 1;
                }
                else {
                    $login_failed = 1;
                }
            }
            elsif ($claimed_id) {
                if (   $main::email
                    && $main::addr
                    && $main::email eq $main::addr
                    && ref $main::pswd
                    && $cgi::Register->is_identified( $main::pswd,
                        $claimed_id ) )
                {
                    $openid_enabled = 1;
                }
                else {
                    $login_failed = 1;
                }
            }
            elsif ( !$is_registered ) {
                if ( !$is_secure ) {
                    push(
                        @{ $this->{'dialog'} },
                        'OpenID による登録に失敗しました。'
                    );
                }
                elsif ($setting::general{'firstRegistry'}
                    && $setting::general{'firstRegistry'} eq 'password' )
                {
                    push(
                        @{ $this->{'dialog'} },
                        '最初の登録についてはパスワードによる登録のみ許可されています。'
                    );
                }
                else {
                    $openid_enabled = 1;
                }
            }
            if ($openid_enabled) {
                $this->print_openid_login_panel_opener($main::addr);
            }
            elsif ($login_failed) {
                push(
                    @{ $this->{'dialog'} },
                    'OpenID を変更する前に、このメールアドレスでログインしてください。'
                );
            }
        }
        else {
            push(
                @{ $this->{'dialog'} },
                'OpenID の利用は認められていません。'
            );
        }
    }
    elsif ( $main::a eq 'r' ) {
        if ( !$is_secure && !$reregistry_enabled ) {
            push(
                @{ $this->{'dialog'} },
                'メールアドレスの登録に失敗しました。'
            );
        }
        elsif ($env::openid_enabled
            && $setting::general{'lifeLongOpenId'}
            && $claimed_id )
        {
            push(
                @{ $this->{'dialog'} },
                'メールアドレスの登録に失敗しました。OpenID を利用してログインしているユーザーに対してパスワードを自動発行することはできません。'
            );
        }
        elsif ($env::openid_enabled
            && !$is_registered
            && $setting::general{'firstRegistry'}
            && $setting::general{'firstRegistry'} eq 'openid' )
        {
            push(
                @{ $this->{'dialog'} },
                'メールアドレスの登録に失敗しました。最初の登録については OpenID による登録のみ許可されています。'
            );
        }
        elsif ( $cgi::Register->register($main::addr) ) {
            $cgi::Register->gc( $setting::general{'pswdExpired'}, 1 );
            push( @{ $this->{'dialog'} }, $cgi::Register->success_dialog );
        }
        else {
            push( @{ $this->{'dialog'} }, $cgi::Register->error_dialog );
        }
        $main::a = '';
    }
    elsif ( $main::a eq 'd' ) {
        my $self = 0;
        if ( $main::email && $main::addr && $main::email eq $main::addr ) {
            $main::password = $main::pswd;
            $self           = 1;
        }
        if ( !$is_secure ) {
            push( @{ $this->{'dialog'} }, '不正なアクセスです。' );
        }
        elsif ( $cgi::Register->remove( $main::password, $main::addr ) ) {
            if ($self) {
                $this->set_cookie_direct( -1, $this->login_cookie_name,
                    'null', $env::cgi_server, $env::cookie_path );
                if ( $env::session_enabled && $this->use_session ) {
                    push(
                        @{ $this->{'dialog'} },
                        'セッション情報の削除に失敗しました。'
                    ) unless $cgi::Session->erase($session::id);
                    undef $session::id;
                    undef $session::is_changed;
                    undef $main::pswd;
                }
            }
            $this->print_register_dialog( 'pswd',
                $cgi::Register->success_dialog )
                if !$this->is_master && !$self;
            push( @{ $this->{'dialog'} }, $cgi::Register->success_dialog );
            $this->set_onload('cmonos.window.refreshOpener()')
                if !$env::register_in_same_window;
        }
        else {
            push( @{ $this->{'dialog'} }, $cgi::Register->error_dialog );
        }
        $main::a = '';
    }

    #---------------------------------------------------------------------
    #書き出し
    #ページヘッダ
    if ( !$main::transition ) {
        $main::a = 'cd' if $logout;
        my $js = <<JS;
cmonos.tool.togglePasswordForm = function (this_action) {
	if (this_action == "cd" || this_action == "r" || this_action == "o") {
		document.getElementById("login-password").style.display = "none";
	} else {
		document.getElementById("login-password").style.display = "table-row";
	}
	if (this_action == "cd") {
		document.getElementById("addr").setAttribute("disabled","disabled");
	} else {
		document.getElementById("addr").removeAttribute("disabled");
	}
}
JS
        $this->set_javascript($js);
        $this->set_onload(
            'cmonos.tool.togglePasswordForm(\'' . $main::a . '\')' )
            if $main::a;
    }
    $this->print_page_header('pswd');

    print $this->form_start(
        'key'      => 'password',
        'name'     => 'gate',
        'method'   => 'post',
        'required' => \@setting::form
    );
    print '<input type="hidden" name="referer_url" value="'
        . $this->escape($main::referer_url) . '" />';

    if ( defined $want_new_password_form && $want_new_password_form ) {
        print
            '<input type="hidden" name="a" value="p" /><input type="hidden" name="action" value="change" />';
        if (   !$env::session_enabled
            && defined $main::pswd
            && !ref $main::pswd
            && $main::pswd ne ''
            && !$cookie::read{ $this->login_cookie_name } )
        {
            print '<input type="hidden" name="email" value="'
                . $this->escape($main::email) . '" />';
            print '<input type="hidden" name="pswd" value="'
                . $this->escape($main::pswd) . '" />';
        }
        print '<table class="field-table"><tbody>';
        print '<tr>';
        print
            '<td class="field-name"><span class="datatitle">メールアドレス</span></td>';
        print '<td class="field">' . $this->escape($main::email) . '</td>';
        print '</tr>';
        print '<tr>';
        print
            '<td class="field-name"><label for="password">新しいパスワード</label></td>';
        print
            '<td class="field"><input type="password" name="password" id="password" size="16" /><div class="note">(6文字以上の半角英数字列)</div></td>';
        print '</tr>';
        print '<tr>';
        print
            '<td class="field-name"><label for="password2">新しいパスワード(確認)</label></td>';
        print
            '<td class="field"><input type="password" name="password2" id="password2" size="16" /><div class="note">(6文字以上の半角英数字列)</div></td>';
        print '</tr>';
        print '<tr>';
        $this->print_close_cell;
        print
            '<input type="submit" value="変更→ログイン" /></td></tr></tbody></table></form>';
    }
    else {
        if (   !$env::session_enabled
            && defined $main::pswd
            && !ref $main::pswd
            && $main::pswd ne ''
            && !$cookie::read{ $this->login_cookie_name } )
        {
            print '<input type="hidden" name="email" value="'
                . $this->escape($main::email) . '" />';
            print '<input type="hidden" name="pswd" value="'
                . $this->escape($main::pswd) . '" />';
        }
        print '<table class="field-table"><tbody>';
        print '<tr>';
        print
            '<td class="field-name"><label for="addr">メールアドレス</label></td>';
        print
            '<td class="field"><input type="email" name="addr" id="addr" size="32" value="'
            . $this->escape( ( ($main::addr) ? $main::addr : $main::email ) )
            . '" /></td>';
        print '</tr>';
        if ( !$main::transition ) {
            print '<tr id="login-password">';
            print
                '<td class="field-name"><label for="password">パスワード</label></td>';
            print
                '<td class="field"><input type="password" name="password" id="password" size="16" value="'
                . $this->escape(
                (   ( $main::password && !ref $main::password )
                    ? $main::password
                    : ($env::session_enabled) ? ''
                    :                           $main::pswd
                )
                ) . '" />';
            print '</td>';
            print '</tr>';
        }
        print '<tr>';
        $this->print_close_cell;
        if ($main::transition) {
            if ( !$env::openid_enabled ) {
                print
                    '<input type="hidden" name="a" value="r" /><input type="submit" value="パスワードを取得する" />';
            }
            elsif (
                (     !$is_registered
                    && $setting::general{'firstRegistry'}
                    && $setting::general{'firstRegistry'} eq 'openid'
                )
                || ( $claimed_id && $setting::general{'lifeLongOpenId'} )
                )
            {
                print
                    '<input type="hidden" name="a" value="o" /><input type="submit" value="OpenID でログインする" />';
            }
            else {
                print '<select name="a">';
                print '<option value="r"'
                    . ( ( $main::a eq 'r' ) ? ' selected="selected"' : '' )
                    . '>パスワードを取得する</option>';
                print
                    '<option value="r">パスワードを忘れたのでリセットする</option>'
                    if $setting::general{'reregistry'};
                print '<option value="o"'
                    . ( ( $main::a eq 'o' || $main::a eq 'c' )
                    ? ' selected="selected"'
                    : '' )
                    . '>OpenID でログインする</option>';
                print '</select><input type="submit" value="実行" />';
            }
        }
        else {
            print
                '<select name="a" onchange="cmonos.tool.togglePasswordForm(this.options[this.selectedIndex].value)">';
            print '<option value="c"'
                . ( ( $main::a eq 'c' ) ? ' selected="selected"' : '' )
                . '>ログインする</option>';
            print '<option value="cd"'
                . ( ( $main::a eq 'cd' ) ? ' selected="selected"' : '' )
                . '>ログアウトする</option>'
                if defined $main::pswd;
            if ($setting::general{'changeable'}
                && (   !$env::openid_enabled
                    || !$claimed_id
                    || !$setting::general{'lifeLongOpenId'} )
                )
            {
                print '<option value="p"'
                    . ( ( $main::a eq 'p' ) ? ' selected="selected"' : '' )
                    . '>'
                    . ( ($claimed_id)
                    ? 'パスワード認証に変更する'
                    : 'パスワード変更画面を開く' )
                    . '</option>';
            }
            print '<option value="o"'
                . ( ( $main::a eq 'o' ) ? ' selected="selected"' : '' ) . '>'
                . ( ($claimed_id) ? 'OpenID 変更画面を開く'
                : ($is_registered) ? 'OpenID に変更する'
                :                    'OpenID で登録する' )
                . '</option>'
                if $env::openid_enabled && ( $is_secure || $is_registered );
            if ( $is_secure || $setting::general{'reregistry'} ) {
                print '<option value="r"'
                    . ( ( $main::a eq 'r' ) ? ' selected="selected"' : '' )
                    . '>パスワードを取得する</option>';
                print
                    '<option value="r">パスワードを忘れたのでリセットする</option>'
                    if $setting::general{'reregistry'};
                print '<option value="d"'
                    . ( ( $main::a eq 'd' ) ? ' selected="selected"' : '' )
                    . '>登録メールアドレスを削除する</option>'
                    if $is_secure;
            }
            print '</select><input type="submit" value="実行" />';
        }
        print '</td></tr>';
        print '</tbody></table></form>';
    }

    #ツールアイコン
    $this->print_tool_icon if $this->is_secure('tools');

    #ページフッタ
    $this->print_page_footer('pswd');
}

######################################################################
# クラス登録
#sub import {
BEGIN {
    no warnings qw(once);

    #設定DB読み込み設定
    $setting::general  = 1;    #一般設定読み込み
    $setting::deco     = 1;    #テキスト装飾設定読み込み
    $setting::security = 1;    #アクセス権設定読み込み
    $setting::page     = 1;    #ページ設定読み込み

    #設定種キー設定
    $setting::security_key = '';      #デフォルトセキュリティキー
    $setting::key          = 'pswd';  #ページ設定キー

    #クッキー
    $cookie::id_enabled = 1;          #ID情報クッキー読み込み

    #デフォルトキー
    $main::k = 'pswd' if !defined $main::k || !$main::k;

    #必須フォーム
    @setting::form = ( 'm', 'k', 'transition' );
    if ( $ENV{'QUERY_STRING'}
        || ( $ENV{'REQUEST_METHOD'} eq 'POST' && !$cgi::input->referer_is_me )
        )
    {
        undef $main::a;
    }

    #クラス登録
    Common::class_register( 'pswd', 'Password' );

}

1;
