package GeneralSetting;
require CMONOS::CGI_Lib::Tools::General;
@ISA = qw(General);
use strict;
use utf8;
######################################################################
# パスワード登録一般設定モジュール
# GeneralSetting.pm ver1.0.3
# Copyright (C) 1999-2018 CMONOS Co. Ltd.
#
# support@cmonos.jp
# http://cmonos.jp/
# 最終更新日：2009-04-04
######################################################################
# 設定チェック項目取得
sub get_sub_setting_items ($) {
    my $this = shift;

    #チェックボックス
    push( @check::checkbox, 'reregistry', 'changeable' );

    #数字チェック
    $check::num{'pswdExpired'} = '登録パスワード保存期間';

    if ($env::openid_enabled) {
        push( @check::checkbox, 'lifeLongOpenId', 'anyOp' );
    }
    return;
}

sub ogtype_disabled ($) {
    my $this = shift;
    return 1;
}

######################################################################
# サブ設定パネル
sub print_sub_preference_panel ($$) {
    my ( $this, $master ) = @_;
    print '<fieldset><legend>パスワード登録設定</legend>';
    print '<ol class="checkbox">';
    print
        '<li><label><input type="checkbox" name="data:reregistry" id="data:reregistry" value="1"'
        . ( ( $main::data{'reregistry'} ) ? ' checked="checked"' : '' )
        . ' /> 登録済みメールアドレスのパスワード再発行はどんな場合も受け付ける</label></li>';
    print
        '<li><label><input type="checkbox" name="data:changeable" id="data:changeable" value="1"'
        . ( ( $main::data{'changeable'} ) ? ' checked="checked"' : '' )
        . ' /> ユーザー本人によるパスワード変更を許可する</label></li>';
    print '</ol>';
    print '</fieldset>';

    print '<fieldset><legend>登録パスワード保存期間</legend>';
    print
        '<label>パスワード登録後、ログインがなくても<input type="number" size="3" name="data:pswdExpired" value="'
        . $this->escape( $main::data{'pswdExpired'} )
        . '" />日間パスワードを保持する</label>';
    print '</fieldset>';

    if ($env::openid_enabled) {
        print '<fieldset><legend>OpenID 設定</legend>';

        print '<fieldset><legend>初回登録制限</legend>';
        print '<ol class="checkbox">';
        print
            '<li><label><input type="radio" name="data:firstRegistry" value=""'
            . (
            ( !$main::data{'firstRegistry'} ) ? ' checked="checked"' : '' )
            . ' /> 初回登録からパスワードおよび OpenID の両方を受け付ける</label></li>';
        print
            '<li><label><input type="radio" name="data:firstRegistry" value="password"'
            . (
            (          $main::data{'firstRegistry'}
                    && $main::data{'firstRegistry'} eq 'password'
            ) ? ' checked="checked"' : ''
            )
            . ' /> 初回登録はパスワードのみ受け付ける<span class="note">(登録メールアドレスが本人のものであることを確認したいとき)</span></label></li>';
        print
            '<li><label><input type="radio" name="data:firstRegistry" value="openid"'
            . (
            (          $main::data{'firstRegistry'}
                    && $main::data{'firstRegistry'} eq 'openid'
            ) ? ' checked="checked"' : ''
            )
            . ' /> 初回登録は OpenID のみ受け付ける<span class="note">(登録を特定サービスユーザーに限定したいときなど)</span></label></li>';
        print '</ol>';
        print '</fieldset>';

        print '<fieldset><legend>パスワード再発行制限</legend>';
        print '<ol class="checkbox">';
        print
            '<li><label><input type="checkbox" name="data:lifeLongOpenId" id="data:lifeLongOpenId" value="1"'
            . (
            ( $main::data{'lifeLongOpenId'} ) ? ' checked="checked"' : '' )
            . ' /> 登録済みメールアドレスであっても OpenID で登録されている場合はパスワード再発行を拒絶する</label></li>';
        print '</ol>';
        print '</fieldset>';

        print '<fieldset><legend>OpenID プロバイダー</legend>';
        print
            '<div class="note">[OpenID プロバイダー名]=[エンドポイントURL];[Claimed ID(オプション)];[Identity(オプション)][改行]</div>';
        print
            '<textarea name="data:op" id="data:op" cols="90" rows="12" wrap="off" class="content-editor-area">'
            . $this->escape( $main::data{'op'} )
            . '</textarea>';
        print
            '<div class="tools"><select class="tool" onchange="cmonos.form.item(this.form).fieldname(\'data:op\').quotationByMenu(this)">';
        print '<option value="">▼挿入する</option>';
        print
            '<option value="mixi=mixi.jp/openid_server.pl\\n">mixi</option>';
        print
            '<option value="mixi=mixi.jp/openid_server.pl;https://id.mixi.jp/[mixi ID]/friends\\n">mixi([mixi ID]のマイミク限定)</option>';
        print
            '<option value="mixi=mixi.jp/openid_server.pl;https://id.mixi.jp/community/[コミュニティ ID]\\n">mixi([コミュニティ ID]のメンバー限定)</option>';
        print
            '<option value="Yahoo! Japan ID=open.login.yahooapis.jp/openid/op/auth\\n">Yahoo! Japan ID</option>';

#print '<option value="Google=www.google.com/accounts/o8/ud\\n">Google</option>';
        print
            '<option value="flickr=https://open.login.yahooapis.com/openid/op/auth;http://flickr.com/\\n">flickr</option>';
        print '</select></div>';
        print
            '<div class="extra-field"><label title="このウェブアプリケーションが利用できる OpenID プロバイダーはあまり存在しません。"><input type="checkbox" name="data:anyOp" id="data:anyOp" value="1"'
            . ( ( $main::data{'anyOp'} ) ? ' checked="checked"' : '' )
            . ' /> 任意の OpenID プロバイダーによる認証を許可する【非推奨】</label></div>';
        print '</fieldset>';

        print '</fieldset>';
    }
    return;
}

######################################################################
# クラス登録
#sub import {
BEGIN {
    #クラス登録
    Common::class_register( '0000', 'GeneralSetting' );

    #ツール登録
    $setting::jump_menu{'0000'} = '一般設定';
}

1;
