package Installer;
require CMONOS::SetupAssistant::Tools::SetupEnv;
@ISA = qw(SetupEnv);
use strict;
use utf8;
use Fcntl qw(:DEFAULT :flock);
######################################################################
# CMONOS.JP インストーラーモジュール
# Installer.pm ver1.0.2
# Copyright (C) 1999-2018 CMONOS Co. Ltd.
#
# support@cmonos.jp
# http://cmonos.jp/
# 最終更新日：2010-05-20
######################################################################
# 実行
sub run ($) {
    my $this = shift;
    $this->get_setup_env;

    Common->new('00s0')->run(1);

    $this->print_page_header('tools');

    print '<h1>インストール</h1>';

    print
        '<form action="#"><fieldset><textarea name="log" id="log" rows="5" cols="50"></textarea><div id="link"></div></form>';

    $this->print_page_footer('tools');

    print $this->javascript(
        'var install_log = document.getElementById(\'log\');');

    print $this->javascript(
        'document.getElementById(\'log\').value += \'管理情報設定...\';'
    );
    print $this->javascript(
        'document.getElementById(\'log\').value += \'完了\\n\';');

    print $this->javascript(
        'document.getElementById(\'log\').value += \'パーミッション最適化...\';'
    );
    Common->new('s300')->site_chmod;
    print $this->javascript(
        'document.getElementById(\'log\').value += \'完了\\n\';');

    print $this->javascript(
        'document.getElementById(\'log\').value += \'データベース・設定 の復元...\';'
    );
    my $restore = Common->new('xxbr');
    $restore->restore_dir( '', $backup::db_path{'allpref'},
        'bak', $backup::find{'allpref'} );
    print $this->javascript(
        'document.getElementById(\'log\').value += \'完了\\n\';');

    if ( ref $restore->{'dialog'} && @{ $restore->{'dialog'} } ) {
        my @dialog = @{ $restore->{'dialog'} };
        undef @{ $restore->{'dialog'} };
        print $this->javascript(
                  'document.getElementById(\'log\').value += \'  [!] '
                . join( '\\n  [!] ', @dialog )
                . '\\n\';' );
    }
    undef $restore;

    print $this->javascript(
        'document.getElementById(\'log\').value += \'JavaScript アップデート...\';'
    );
    Common->new('s303')->update;
    print $this->javascript(
        'document.getElementById(\'log\').value += \'完了\\n\';');

    print $this->javascript(
        'document.getElementById(\'log\').value += \'ナビゲーション調整...\';'
    );
    my $user_directory = $this->home_directory(1);
    foreach my $jcode ( '', 'sjis', 'euc' ) {
        my $description = $env::description;
        my $title       = $env::title;
        if ($jcode) {
            $this->jcode_convert( \$title,       $jcode, 'utf8' );
            $this->jcode_convert( \$description, $jcode, 'utf8' );
        }
        foreach my $ext ( 'ssi', 'js' ) {
            my $path
                = $env::externalfiles
                . '/site-navi'
                . ( ($jcode) ? '-' . $jcode : '' ) . '.'
                . $ext;
            my $data = $this->read_file( $path, 1 );
            $data =~ s/This is my web site !!/$description/g;
            $data =~ s/My Web Site/$title/g;
            $data
                =~ s/(['"](?!$user_directory))\/(?![0-9a-zA-Z_]+\))/$1$user_directory\//g
                if $user_directory;
            $this->write_file( $path, \$data, 1 ) if $data;
        }
    }
    print $this->javascript(
        'document.getElementById(\'log\').value += \'完了\\n\';');
    $this->optimize_htaccess('../../');
    unlink '../servercheck.cgi';
    unlink '../../installer.cgi';
    eval 'use ' . $env::dbm_file . ';';
    my %general;
    tie( %general, $env::dbm_file, $default::preference_dir . '/general',
        O_RDWR, $env::dbm_mode );

    if ( ref tied %general ) {
        $general{'ver'} = $this->encode_utf8($cgi::cmonos_ver);
    }
    untie %general;
    print $this->javascript(
        'document.getElementById(\'link\').innerHTML = \'<a href="../">メンテナンスステーションを開く</a>\';'
    );
    print $this->javascript(
        'if (confirm(\'メンテナンスステーションに移動しますか？\')) location.href="../";'
    );
}

######################################################################
# クラス登録
#sub import {
BEGIN {
    no warnings qw(once);

    #クラス登録
    Common::class_register( '0', 'Installer' );

}

1;
