package OptMod;
require CMONOS::CGI_Lib::SetUp;
@ISA = qw(SetUp);
use strict;
use utf8;
######################################################################
# パーミッション調整モジュール
# OptMod.pm ver1.0
# Copyright (C) 1999-2018 CMONOS Co. Ltd.
#
# support@cmonos.jp
# http://cmonos.jp/
# 最終更新日：2009-02-14
######################################################################
# 実行
sub run ($) {
    my $this = shift;

    #パーミッション調整
    if ( defined $main::a && $main::a ) {
        local ( $OptMod::fmod, $OptMod::dmod )
            = ( $main::a eq 'rw' )
            ? ( 0666, 0777 )
            : ( $env::file_mode, $env::dir_mode );
        local $OptMod::count = 0;

        use File::Find;
        find( \&opt_mod, $default::preferences );
        find( \&opt_mod, $default::data );
        find( \&opt_mod, $this->document_root );

        sub opt_mod {
            my $uid = ( stat($_) )[4];
            return if $uid ne $> && $uid ne $<;
            if ( -f $_ ) {
                $OptMod::count++ if chmod( $OptMod::fmod, $_ );
            }
            elsif ( -d $_ ) {
                $OptMod::count++ if chmod( $OptMod::dmod, $_ );
            }
        }

        push(
            @{ $this->{'dialog'} },
            $OptMod::count
                . ' のファイルまたはディレクトリのパーミッションを調整しました。'
        );
    }

    #ページヘッダ
    $this->jump_menu('tools');
    $this->print_page_header('tools');

    print
        '<h1 title="パーミッションを調整します。">パーミッション調整</h1>';

    #フォーム開始
    print $this->form_start(
        'key'      => 'tools',
        'name'     => 'input',
        'method'   => 'post',
        'required' => \@setting::form
    );

    #CGI所有ファイル/ディレクトリを変更可能にする
    print
        '<fieldset><input type="submit" name="a=rw" value="CGI 所有ファイル/ディレクトリを CGI 以外が変更可能にする" onclick="return confirm(\'この操作は取り消せません。本当に変更しますか？\') && cmonos.form.item(this).isNotSubmitted();" />';
    print
        '<div class="note">CGI が書き出したファイルやディレクトリをユーザーが変更できるようパーミッションを変更します。</div></fieldset>';

    #CGI所有ファイル/ディレクトリを変更不能にする
    print
        '<fieldset><input type="submit" name="a=r" value="CGI 所有ファイル/ディレクトリを CGI 以外は変更不能にする" onclick="return confirm(\'この操作は取り消せません。本当に変更しますか？\') && cmonos.form.item(this).isNotSubmitted();" />';
    print
        '<div class="note">CGI が書き出したファイルやディレクトリを CGI 以外が変更できないようパーミッションを変更します。</div></fieldset>';

    print '</form>';

    #ページフッタ
    $this->print_page_footer('tools');
}

######################################################################
# クラス登録
#sub import {
BEGIN {
    if ( !defined $env::ownerpower || !$env::ownerpower ) {
        no warnings qw(once);

        #クラス登録
        Common::class_register( 's301', 'OptMod' );

        #メニュー登録
        $setting::jump_menu{'s301'} = 'パーミッション調整';
    }
}

1;
