package SubDirUninstaller;
require CMONOS::SetupAssistant::Tools::SetupEnv;
@ISA = qw(SetupEnv);
use strict;
use utf8;
######################################################################
# サブディレクトリ削除モジュール
# SubDirUninstaller.pm ver1.0.1
# Copyright (C) 1999-2018 CMONOS Co. Ltd.
#
# support@cmonos.jp
# http://cmonos.jp/
# 最終更新日：2011-08-09
######################################################################
# 実行
sub run ($) {
    my $this = shift;
    $this->get_setup_env;
    if ( !@main::target && defined $main::target && $main::target ne '' ) {
        push( @main::target, $main::target );
        undef $main::target;
    }
    my @targetable_directories
        = $this->targetable_directories(
        $default::cgi_data_root . ( $default::home_dir || '' ),
        '', 1 );

    #アンインストール処理
    if ( @targetable_directories && @main::target ) {
        eval 'use File::Path';
        foreach my $dir (@main::target) {
            my $d = $dir;
            $d =~ s!^/!!;
            if (  !$dir
                || $dir !~ /^\//
                || $dir =~ /\/\.\.\//
                || !grep( $_ eq $dir, @targetable_directories ) )
            {
                push(
                    @{ $this->{'dialog'} },
                    'サブディレクトリ「'
                        . $d
                        . '」は削除できません。'
                );
            }
            elsif ( -d $default::cgi_data . $dir ) {
                rmtree( $default::cgi_data . $dir );
                rmtree( '../..' . $dir );
                push(
                    @{ $this->{'dialog'} },
                    '「' . $d . '」を削除しました。'
                );
            }
        }
        undef @main::target;
        @targetable_directories
            = $this->targetable_directories(
            $default::cgi_data_root . ( $default::home_dir || '' ),
            '', 1 );
    }

    #ページヘッダ
    $this->jump_menu('tools');
    $this->print_page_header('tools');

    print '<h1>サブディレクトリ削除</h1>';

    if (@targetable_directories) {
        print $this->form_start(
            'key'    => 'tools',
            'name'   => 'input',
            'method' => 'post',
            'onsubmit' =>
                'return confirm(\'この操作は取り消せません。本当に削除しますか？\') &amp;&amp; cmonos.form.item(this).isNotSubmitted();',
            'required' => \@setting::form
        );
        print
            '<fieldset><legend>削除するサブディレクトリを選択</legend>';
        print '<ol class="checkbox">';
        foreach my $dir (@targetable_directories) {
            my $d = $dir;
            $d =~ s!^/!!;
            print '<li><label><input type="checkbox" name="target" value="'
                . $dir . '"'
                . ( ( @main::target && grep( $_ eq $dir, @main::target ) )
                ? ' checked="checked"'
                : '' )
                . ' />'
                . $d
                . '</label> <a href="../..'
                . $dir
                . '/" target="sample">[確認]</a></li>';
        }
        print '</ol>';
        print '</fieldset>';
        print
            '<fieldset class="delete"><input type="submit" value="削除" /></fieldset></form>';
    }
    else {
        print
            '<fieldset><div class="hints">サブディレクトリが存在しません。</div></fieldset>';
    }

    #ページフッタ
    $this->print_page_footer('tools');
}

sub targetable_directories ($$$;$) {
    my ( $this, $dir, $home_dir, $is_here ) = @_;
    if ($is_here) {
        return () if $env::subdirectory_disabled;
    }
    else {
        my ( $multi_domain, $server_name, $ssl, $subdirectory_disabled,
            $user_site_template_dir, $user_default_dir )
            = $this->subdir_options( $dir . '/lib/env.pl' );
        return () if !$subdirectory_disabled;
    }
    my ( @directories, @sub_directories );
    @directories = @sub_directories = ();
    local (*DIR);
    return unless opendir( DIR, $dir );
    $home_dir = '' if !defined $home_dir;
    while ( my $entry = readdir(DIR) ) {
        next if $entry =~ /^\./;
        my $path = $dir . '/' . $entry;
        if (   -d $dir . '/' . $entry
            && -f $dir . '/' . $entry . '/lib/env.pl' )
        {
            push( @directories, $entry );
        }
    }
    closedir(DIR);
    foreach my $d (@directories) {
        push(
            @sub_directories,
            $home_dir . '/' . $d,
            $this->targetable_directories(
                $dir . '/' . $d,
                $home_dir . '/' . $d
            )
        );
    }
    return @sub_directories;
}

######################################################################
# クラス登録
#sub import {
BEGIN {
    no warnings qw(once);
    if ( !$env::subdirectory_disabled ) {

        #クラス登録
        Common::class_register( 's501', 'SubDirUninstaller' );

        #メニュー登録
        $setting::jump_menu{'s501'} = 'サブディレクトリ削除';
    }
}

1;
