package Checker;
require CMONOS::TableMaker::Field::TMUserGeneratedField;
require CMONOS::CGI_Lib::Field::UserGeneratedField;
@ISA = qw(TMUserGeneratedField UserGeneratedField);
use strict;
use utf8;
use Fcntl qw(:DEFAULT);
eval 'use ' . $env::dbm_file . ';';
######################################################################
# フィールド定義モジュール（作業状況チェック）
# Checker.pm 1.0.6
# Copyright (C) 1999-2018 CMONOS Co. Ltd.
#
# support@cmonos.jp
# http://cmonos.jp/
# 最終更新日：2015-04-11
######################################################################
sub __set ($$) {
    my $this = shift;
    if ( !ref $cgi::Deco ) {
        require CMONOS::CGI_Lib::Deco;
        $cgi::Deco = Deco->new;
    }
    if ( !ref $cgi::Image ) {
        require CMONOS::CGI_Lib::Image;
        $cgi::Image = Image->new;
    }
    @{ $this->{'authorities'} } = $this->get_address( $this->{'authority'} );
    $this->scalar_to_array( \$this->{'order'} );
    $this->{'phase'}{'1'} = { 'name' => '完了' }
        if !defined $this->{'phase'} || !ref $this->{'phase'};
    $this->{'authorityName'} = 'チェック責任者'
        if !defined $this->{'authorityName'}
        || $this->{'authorityName'} eq '';
    $this->{'lifetime'} = 604800 if !$this->{'lifetime'};
    $this->{'datetype'}
        = ( ( $setting::general{'datetype'} )
        ? $setting::general{'datetype'}
        : '' )
        if !$this->{'datetype'};
    $this->scalar_to_array( \$this->{'mailto'} );
    $this->{'field_for'}{'checker'} = $this->{'id'};
    return;
}

######################################################################
#	(1)-0 obj->match_enabled;
sub match_enabled ($) {
    my $this = shift;
    return 1
        if ( defined $main::search{ $this->{'id'} }{'str'}
        && $main::search{ $this->{'id'} }{'str'} ne '' )
        || ( ref $main::search{ $this->{'id'} }{'str'}
        && @{ $main::search{ $this->{'id'} }{'str'} } > 0 );
    return 0;
}

#	(1) obj->match(str);
sub match ($;$) {
    my ( $this, $str ) = @_;
    my ( $pat, $phase );
    return 1
        if ( !defined $main::search{ $this->{'id'} }{'str'}
        || $main::search{ $this->{'id'} }{'str'} eq '' )
        && ( !ref $main::search{ $this->{'id'} }{'str'}
        || !@{ $main::search{ $this->{'id'} }{'str'} } );
    if ( !ref $this->{'pattern'} ) {
        $this->scalar_to_array( \$main::search{ $this->{'id'} }{'str'} );
        @{ $this->{'pattern'} } = @{ $main::search{ $this->{'id'} }{'str'} };
    }
    $phase = $1 if $$str =~ /^.*?\x0A([0-9]+):/;
    foreach $pat ( @{ $this->{'pattern'} } ) {
        next if !defined $pat || $pat eq '';
        return (   $main::search{ $this->{'id'} }{'mode'}
                && $main::search{ $this->{'id'} }{'mode'} eq 'nor' ) ? 0 : 1
            if ( !$phase && !$pat ) || ( $phase && $phase == $pat );
    }
    return (   $main::search{ $this->{'id'} }{'mode'}
            && $main::search{ $this->{'id'} }{'mode'} eq 'nor' ) ? 1 : 0;
}

######################################################################
#	(2) obj->form;
sub form {
    my ( $this, $status, $original, $path ) = @_;
    my $form = '';
    if ( $main::data{ $this->{'id'} }{'str'} ) {
        $main::data{ $this->{'id'} }{'str'} =~ s/^.*?\x0A//;
        if ( $main::data{ $this->{'id'} }{'str'}
            =~ /^([0-9]+):([^:\x0A]*):[^:\x0A]*:(.*)$/m )
        {
            $form = $this->field_header;
            $form .= $this->get_oparation_phase( $1, $2, $3 );
            $form .= $this->get_oparation_phase_log(
                \$main::data{ $this->{'id'} }{'str'} );
            $form .= $this->field_footer;
        }
        elsif ( $this->{'initialphase'} ) {
            $form = $this->field_header;
            $form .= $this->{'initialphase'};
            $form .= $this->field_footer;
        }
    }
    elsif ( $this->{'initialphase'} ) {
        $form = $this->field_header;
        $form .= $this->{'initialphase'};
        $form .= $this->field_footer;
    }
    return $form;
}

sub get_oparation_phase ($$$;$$) {
    my ( $this, $phase, $authority, $comment, $short_ver ) = @_;
    return ( ( $this->{'initialphase'} ) ? $this->{'initialphase'} : '' )
        if !$phase
        || ( $phase != 999 && !defined $this->{'phase'}{$phase}{'name'} );
    if (   !$short_ver
        && defined $this->{'authorityInfo'}
        && $this->{'authorityInfo'} )
    {
        $this->set_authority_name;
        return
              $this->get_phase_name($phase) . ' ['
            . $this->{'authorityName'}
            . ':<a href="'
            . $this->address_protector( $authority,
            $this->{'addressProtector'} )
            . '">'
            . (
            (          defined $authority
                    && ref $this->{'authority_name'}
                    && defined $this->{'authority_name'}{$authority}
                    && $this->{'authority_name'}{$authority} ne ''
            ) ? $this->{'authority_name'}{$authority}
            : $this->address_camouflage(
                $authority, $this->{'addressProtector'}
            )
            )
            . '</a>]'
            . ( ( $this->{'comment'} && $comment ne '' )
            ? ' (' . $this->escape($comment) . ')'
            : '' );
    }
    else {
        return $this->get_phase_name($phase);
    }
}

sub get_oparation_phase_log ($$;$$$) {
    my ( $this, $str, $id, $class, $short_ver ) = @_;
    return ( $id || $class )
        ? '<div'
        . ( ($id)    ? ' id="' . $id . '"'       : '' )
        . ( ($class) ? ' class="' . $class . '"' : '' )
        . '>ログはありません。</div>'
        : ''
        if !defined $$str || $$str eq '';
    $this->set_authority_name
        if !$short_ver
        && defined $this->{'authorityInfo'}
        && $this->{'authorityInfo'};
    my ($log);
    $this->{'Table'}->set( 'thenabled' => 'true' );
    $log
        = '<div'
        . ( ($id)    ? ' id="' . $id . '"'       : '' )
        . ( ($class) ? ' class="' . $class . '"' : '' ) . '>'
        if $id || $class;
    $log .= $this->{'Table'}->table;
    $log .= $this->{'Table'}->tr;
    $log .= $this->{'Table'}->th( $this->name(1) );
    $log
        .= $this->{'Table'}
        ->th( ($default::english) ? 'Comment' : 'コメント' )
        if defined $this->{'comment'} && $this->{'comment'};
    $log .= $this->{'Table'}->th( $this->{'authorityName'} )
        if !$short_ver
        && defined $this->{'authorityInfo'}
        && $this->{'authorityInfo'};
    $log .= $this->{'Table'}->th( ($default::english) ? 'Date' : '日時' );
    $log .= $this->{'Table'}->_tr;

    while ( $$str =~ /^([^:\x0A]*):([^:\x0A]*):([^:\x0A]*):(.*)$/gm ) {
        my ( $phase, $authority, $time, $comment ) = ( $1, $2, $3, $4 );
        next if !defined $phase || $phase eq '';
        $log .= $this->{'Table'}->tr;
        if ( $phase == 0 ) {
            $log .= $this->{'Table'}
                ->td( ($default::english) ? 'Reset' : 'リセット' );
        }
        else {
            $log .= $this->{'Table'}->td(
                $this->phase_distiller( $this->get_phase_name($phase) ) );
        }
        $log .= $this->{'Table'}->td( $this->escape($comment) )
            if defined $this->{'comment'} && $this->{'comment'};
        $log .= $this->{'Table'}->td(
            '<a href="'
                . $this->address_protector( $authority,
                $this->{'addressProtector'} )
                . '">'
                . (
                (          defined $authority
                        && ref $this->{'authority_name'}
                        && defined $this->{'authority_name'}{$authority}
                        && $this->{'authority_name'}{$authority} ne ''
                )
                ? $this->{'authority_name'}{$authority}
                : $this->address_camouflage( $authority,
                    $this->{'addressProtector'} )
                    . '</a>'
                )
            )
            if !$short_ver
            && defined $this->{'authorityInfo'}
            && $this->{'authorityInfo'};
        $log .= $this->{'Table'}->td(
            $this->date(
                $time, $this->{'datelimit'}, 'gmt' . $this->{'datetype'}
            )
        );
        $log .= $this->{'Table'}->_tr;
    }
    $log .= $this->{'Table'}->_table;
    $log .= '</div>' if $id || $class;
    return $log;
}

######################################################################
#	(3) obj->is_valid_data;
sub is_valid_data ($;$) {
    my $this = shift;
    my ( $data, @addr, $user_addr );
    $data = '';
    if ( defined $main::n && $main::n ne '' ) {
        my %db;
        tie( %db, $env::dbm_file, "$default::db/$main::c/$this->{'id'}",
            O_RDONLY, $env::dbm_mode );
        if ( ref tied %db && defined $db{ $this->encode_utf8($main::n) } ) {
            $data = $this->decode_utf8( $db{ $this->encode_utf8($main::n) } );
        }
        untie %db;
    }
    foreach my $id ( @{ $this->{'field_for'}{'mail_address'} } ) {
        while ( my ( $k, $v ) = each %{ $main::data{$id} } ) {
            push( @addr, $this->get_address($v) );
        }
    }
    $user_addr = (@addr) ? join( ',', $this->get_address(@addr) ) : '';
    $data = $user_addr . "\x0A" . $data
        unless $data && $data =~ s/^.*?\x0A/$user_addr\x0A/;
    $main::data{ $this->{'id'} }{'str'} = $data;
    return 1;
}

######################################################################
#	obj->is_secure;
sub is_secure_user ($) {
    my $this = shift;

    #管理パスワードチェック
    if (   !defined $this->{'checkerLevel'}
        || $this->{'checkerLevel'} eq ''
        || $this->{'checkerLevel'} eq 'master' )
    {
        if ( $this->is_master ) {
            return 1;
        }
        else {
            return 0;
        }

        #オーナーパスワードチェック
    }
    elsif ( $this->{'checkerLevel'} eq 'owner' ) {
        if ( $this->is_owner ) {
            return 1;
        }
        else {
            push(
                @{ $cgi::action->{'dialog'} },
                $cgi::Register->error_dialog
            ) if ref $cgi::Register;
            return 0;
        }

        #共同オーナーパスワードチェック
    }
    elsif ( $this->{'checkerLevel'} eq 'owners' ) {
        if ( $this->is_one_of_owners ) {
            return 1;
        }
        else {
            push(
                @{ $cgi::action->{'dialog'} },
                $cgi::Register->error_dialog
            ) if ref $cgi::Register;
            return 0;
        }

        #スタッフパスワードチェック
    }
    elsif ( $this->{'checkerLevel'} eq 'staff' ) {
        if ( $this->is_staff ) {
            return 1;
        }
        else {
            push(
                @{ $cgi::action->{'dialog'} },
                $cgi::Register->error_dialog
            ) if ref $cgi::Register;
            return 0;
        }

        #登録パスワードチェック
    }
    elsif ( $this->{'checkerLevel'} eq 'member' ) {
        if ( $this->is_authorized( @{ $this->{'authorities'} } ) ) {
            return 1;
        }
        else {
            push(
                @{ $cgi::action->{'dialog'} },
                $cgi::Register->error_dialog
            ) if ref $cgi::Register;
            return 0;
        }

        #チェックなし
    }
    elsif ( ( !$default::type || $default::type ne 'order' )
        && $this->{'checkerLevel'} eq 'nocheck' )
    {
        return 1;
    }

    return 0;
}

######################################################################
#	(4) obj->usual_format(str,path,category,no);
#	str=表示するデータ/path=ファイル保存ディレクトリ
sub usual_format {
    my ( $this, $str, @data ) = @_;
    return $this->phase_format( 0, $str, @data );
}

sub has_content {
    my $this = shift;
    return 1;
}

sub phase_format {
    my ( $this, $show_log, $str, $path, $c, $n ) = @_;
    my ( $phase, $authority, $comment, @user_addr, $form, $id,
        $is_updated_record );
    $is_updated_record = $this->is_updated_record( $c, $n );
    $id = $this->mk_user_generated_field_id( $c, $n );
    $str = $$str{'str'} if ref $str eq 'HASH';
    @user_addr = ( $str && $str =~ s/^(.*?)\x0A//s ) ? split( /,/, $1 ) : ();
    ( $phase, $authority, $comment )
        = ( $str && $str =~ /^([0-9]+):([^:\x0A]*):[^:\x0A]*:(.*)$/m )
        ? ( $1, $2, $3 )
        : ( '', '', '' );
    if (   $this->is_secure_user
        && defined $n
        && $n ne ''
        && (   !$this->{'charge'}
            || !$phase
            || $authority eq $main::email
            || $this->is_secure('tools') )
        )
    {

        if (   $default::type
            && $default::type eq 'order'
            && $this->order_is_pending( $c, $n ) )
        {
            $form
                .= '<p class="warning">キャンセルが申請されています。確認後、<a href="javascript:window.location.reload()">再読み込み</a>してください。</p>';
        }
        else {
            $form .= $this->get_oparation_phase_menu_header( $c, $n, $id );
            $form
                .= $this->get_oparation_phase_menu( 'phase',
                ( ( defined $phase && $phase ne '' ) ? [$phase] : [] ),
                0, $this->user_included_in( \@user_addr ) );
            $form
                .= '<input type="text" name="comment" size="16" title="'
                . ( ($default::english) ? 'Comment' : 'コメント' ) . '"'
                . (
                (          $is_updated_record
                        && $this->{'is_invalid_field'}{'comment'}
                ) ? ' class="invalid-field"' : ''
                )
                . ' onchange="cmonos.validate.field(this).bailOut()"'
                . (
                ($is_updated_record) ? $this->escape($main::comment) : '' )
                . ' />'
                if defined $this->{'comment'} && $this->{'comment'};
            $form .= $cgi::Deco->submit_button(
                'submit', $this->{'button'},
                ( ($default::english) ? 'Submit' : '送信' ),
                { 'id' => $id . '-submit' }
            );
            $form .= '</form>';
        }
        $form
            .= '<p class="checker-log"><a href="javascript:void(0)" onclick="cmonos.element.item(\''
            . $id
            . '\').toggle()" class="toggle-link">['
            . ( ($default::english) ? 'LOG' : 'ログ' )
            . ']</a></p>';
        $form .= $this->get_oparation_phase_log(
            \$str, $id,
            ( ($show_log) ? '' : 'floating-box' ),
            ( ($show_log) ? 0  : 1 )
        );
        $form
            .= $this->javascript(
            'cmonos.element.item(\'' . $id . '\').disappear(true);' )
            if !$show_log;
        return $this->field_tag($form);
    }
    elsif (
           $this->{'cancelEnabled'}
        && defined $n
        && $n ne ''
        && (!$phase
            || (   $phase
                && $phase != 999
                && !$this->{'phase'}{$phase}{'aftercancel'} )
            && ( $this->{'cancelAlwaysEnabled'}
                || !$this->{'phase'}{$phase}{'suspend'} )
        )
        && $this->user_included_in( \@user_addr )
        )
    {
        $form .= $this->get_oparation_phase_menu_header( $c, $n, $id );
        $form
            .= '<input type="text" name="comment" size="16" title="'
            . ( ($default::english) ? 'Comment' : 'コメント' ) . '"'
            . (
            ( $is_updated_record && $this->{'is_invalid_field'}{'comment'} )
            ? ' class="invalid-field"'
            : '' )
            . ' onchange="cmonos.validate.field(this).bailOut()"'
            . ( ($is_updated_record) ? $this->escape($main::comment) : '' )
            . ' />'
            if defined $this->{'comment'} && $this->{'comment'};
        $form .= $cgi::Deco->submit_button(
            'cancel',
            $this->{'cancelButton'},
            $this->phase_distiller( $this->get_phase_name(999) ),
            { 'id'    => $id . '-submit' },
            { 'phase' => 999 }
        );
        $form .= '</form>';
        $form
            .= '<p class="checker-log"><a href="javascript:void(0)" onclick="cmonos.element.item(\''
            . $id
            . '\').toggle()" class="toggle-link">['
            . ( ($default::english) ? 'LOG' : 'ログ' )
            . ']</a></p>';
        $form .= $this->get_oparation_phase_log(
            \$str, $id,
            ( ($show_log) ? '' : 'floating-box' ),
            ( ($show_log) ? 0  : 1 )
        );
        $form
            .= $this->javascript(
            'cmonos.element.item(\'' . $id . '\').disappear(true);' )
            if !$show_log;
        return $this->field_tag($form);
    }
    else {
        return $this->field_tag(
            $this->style(
                $this->get_oparation_phase(
                    $phase, $authority, $comment, ( ($show_log) ? 0 : 1 )
                ),
                $this->{'style'},
                $this->{'fontsize'},
                $this->{'fontcolor'},
                $this->{'fontface'}
                )
                . '<a href="javascript:void(0)" onclick="cmonos.element.item(\''
                . $id
                . '\').toggle()" class="toggle-link">['
                . ( ($default::english) ? 'LOG' : 'ログ' ) . ']</a>'
                . $this->get_oparation_phase_log(
                \$str, $id,
                ( ($show_log) ? '' : 'floating-box' ),
                ( ($show_log) ? 0  : 1 )
                )
                . (
                ($show_log) ? '' : $this->javascript(
                    'cmonos.element.item(\'' . $id . '\').disappear(true);'
                )
                )
        );
    }
}

sub user_included_in ($$$) {
    my ( $this, $user_addr ) = @_;
    return (
               defined $main::email
            && $main::email
            && @$user_addr
            && grep( defined $_ && $_ eq $main::email, @$user_addr )
            && (
            $security::registered
            || (   $this->use_register
                && $cgi::Register->is_registered( $main::pswd, $main::email )
            )
            )
    ) ? 1 : 0;
}

sub get_oparation_phase_menu_header ($$$$) {
    my ( $this, $c, $n, $id ) = @_;
    my @required
        = grep( $_ ne 'n' && $_ ne 'c' && $_ ne 'id', @setting::form );
    push( @required, 'ct' ) if !grep( $_ eq 'ct', @required );
    @main::ct = @main::c if !@main::ct && @main::c;
    my $form = $this->form_start(
        'key'  => ( ($setting::security_key) ? $setting::security_key : '' ),
        'id'   => ( ($id)                    ? $id . '-form'          : '' ),
        'name' => ( ($id)                    ? $id . '-form'          : '' ),
        'method'   => 'post',
        'onsubmit' => 'return cmonos.form.item(this).submit(\''
            . $id . '\');',
        'required' => \@required
    );
    $form
        .= '<input type="hidden" name="id" value="' . $this->{'id'} . '" />';
    $form .= '<input type="hidden" name="n" value="' . $n . '" />';
    $form .= '<input type="hidden" name="c" value="' . $c . '" />';
    return $form;
}

sub set_authority_name ($) {
    my $this = shift;
    return if ref $this->{'authority_name'};
    $this->{'authority_name'}{ $setting::general{'master'} }
        = $setting::general{'mastername'};
    $this->set_authority_name_from_email_list( $setting::general{'owners'} );
    $this->set_authority_name_from_email_list( $setting::general{'staff'} );
    $this->set_authority_name_from_email_list( $this->{'authority'} );
}

sub set_authority_name_from_email_list ($$) {
    my ( $this, $list ) = @_;
    return if !defined $list || $list eq '';
    my ( @addr, $addr, %name );
    @addr = split( /,[\x09\x0A\x0C\x0D\x20]*|[\x0A\x0D]+/, $list );
    %{ $this->{'authority_name'} }
        = $cgi::Register->get_name_hash_from_emails(
        $this->get_address(@addr) );
    foreach $addr (@addr) {
        if ( $addr =~ /^([^<>]*)<([^<>]+)>[\x09\x0A\x0C\x0D\x20]*$/ ) {
            $this->{'authority_name'}{$2} = $1;
            $this->{'authority_name'}{$2} =~ s/[\x09\x0A\x0C\x0D\x20]+$//;
        }
        elsif ( $addr =~ s/\((.*)\)//g ) {
            my $name = $1;
            $addr =~ s/[\x09\x0A\x0C\x0D\x20]+//g;
            $this->{'authority_name'}{$addr} = $name
                if defined $name && $name ne '';
        }
    }
}

sub get_oparation_phase_menu ($$$;$$) {
    my ( $this, $name, $phase, $search_flag, $cancel_enabled ) = @_;
    my ( $form, $id );
    $form
        .= '<select name="'
        . $name . '"'
        . ( ($search_flag) ? ' multiple="multiple"' : '' ) . '>';
    if ($search_flag) {
        $form
            .= '<option value="0"'
            . ( ( grep( defined $_ && $_ eq '0', @$phase ) )
            ? ' selected="selected"'
            : '' )
            . '>'
            . ( ( $this->{'initialphase'} ) ? $this->{'initialphase'}
            : ($default::english) ? 'No check'
            :                       '未処理' )
            . '</option>';
    }
    elsif ( !ref $phase || !@$phase ) {
        $form
            .= '<option value="i">'
            . ( ( $this->{'initialphase'} ) ? $this->{'initialphase'}
            : ($default::english) ? 'No check'
            :                       '未処理' )
            . '</option>';
    }
    foreach $id ( @{ $this->{'order'} } ) {
        if (   $search_flag
            || ( !$phase->[0] && !$this->{'phase'}{$id}{'aftercancel'} )
            || ($phase->[0]
                && ((   (      $phase->[0] == 999
                            || $this->{'phase'}{ $phase->[0] }{'aftercancel'}
                        )
                        && $this->{'phase'}{$id}{'aftercancel'}
                    )
                    || (   $phase->[0] != 999
                        && !$this->{'phase'}{ $phase->[0] }{'aftercancel'}
                        && !$this->{'phase'}{$id}{'aftercancel'} )
                )
            )
            )
        {
            $form
                .= '<option value="'
                . $id . '"'
                . ( ( grep( defined $_ && $_ ne '' && $_ == $id, @$phase ) )
                ? ' selected="selected"'
                : '' )
                . '>'
                . $this->phase_distiller( $this->{'phase'}{$id}{'name'} )
                . '</option>';
        }
    }
    if ($search_flag) {
        $form
            .= '<option value="999"'
            . ( ( grep( defined $_ && $_ == 999, @$phase ) )
            ? ' selected="selected"'
            : '' )
            . '>'
            . (
            ( defined $this->{'cancelName'} && $this->{'cancelName'} ne '' )
            ? $this->{'cancelName'}
            : ( ($default::english) ? 'Canceled' : 'キャンセル済' ) )
            . '</option>'
            if $this->{'cancelEnabled'};
    }
    else {
        $form
            .= '<option value="'
            . ( ( $phase->[0] ) ? $phase->[0] : '' )
            . '"></option><option value="999">'
            . $this->phase_distiller( $this->get_phase_name(999) )
            . '</option>'
            if ( $this->{'masterCancelEnabled'} || $cancel_enabled )
            && (
            !$phase->[0]
            || (   $phase->[0] != 999
                && !$this->{'phase'}{ $phase->[0] }{'aftercancel'}
                && ( $this->{'cancelAlwaysEnabled'}
                    || !$this->{'phase'}{ $phase->[0] }{'suspend'} )
            )
            );
        $form
            .= '<option value="'
            . $phase->[0]
            . '"></option><option value="0">'
            . ( ($default::english) ? 'Reset' : 'リセット' )
            . '</option>'
            if $phase->[0];
    }
    $form .= '</select>';
    return $form;
}

sub phase_distiller ($$) {
    my ( $this, $str ) = @_;
    return '' if !defined $str || $str eq '';
    my $extract = '';
    while ( $str =~ /(<([^>]*)>|[^<]*)/g ) {
        if ( defined $2 && $2 ) {
            my $tag = $2;
            $extract .= ( ( $extract ne '' ) ? ' ' : '' ) . $2
                if $tag =~ / (title|alt)="(.*?)"/i;
        }
        else {
            $extract .= ( ( $extract ne '' ) ? ' ' : '' ) . $1;
        }
    }
    $extract =~ s/[\x09\x0A\x0C\x0D\x20]+$//;
    return $extract;
}

sub get_phase_name ($$) {
    my ( $this, $phase ) = @_;
    return ( !$phase )
        ? ( ( $this->{'initialphase'} ) ? $this->{'initialphase'} : '' )
        : ( $phase == 999 )
        ? ( defined $this->{'cancelName'} && $this->{'cancelName'} ne '' )
            ? $this->{'cancelName'}
            : ($default::english) ? 'Canceled'
        : 'キャンセル済'
        : ( defined $this->{'phase'}{$phase}{'name'} )
        ? $this->{'phase'}{$phase}{'name'}
        : '';
}

#---------------------------------------------------------------------
#	(4)-2 obj->format_for_mail(str);
sub format_for_mail {
    my ( $this, $str ) = @_;
    $str = $$str{'str'} if ref $str eq 'HASH';
    if ( defined $str ) {
        $str =~ s/^.*?\x0A//;
        if ( $str =~ /^([0-9]+):([^:\x0A]*):[^:\x0A]*:(.*)$/m ) {
            my ( $phase, $authority, $comment ) = (
                $this->phase_distiller( $this->get_phase_name($1) ),
                $2, $3
            );
            $phase =~ s/\&lt;/</g;
            $phase =~ s/\&gt;/</g;
            $this->set_authority_name;
            return
                  '['
                . $this->name . "]\x0A"
                . $phase
                . (
                ( $this->{'authorityInfo'} )
                ? '('
                    . $this->{'authorityName'}
                    . (
                    (   defined $this->{'authority_name'}{$authority}
                            && $this->{'authority_name'}{$authority} ne ''
                    ) ? ' ' . $this->{'authority_name'}{$authority} : ''
                    )
                    . ' <'
                    . $authority . '>)'
                : ''
                )
                . (
                ( $this->{'comment'} && $comment ) ? "\x0A" . $comment : '' )
                . "\x0A\x0A";
        }
    }
    return '';
}

#---------------------------------------------------------------------
#	(4)-3 obj->format_for_detail(str);
sub format_for_detail {
    my ( $this, $str, @data ) = @_;
    return $this->phase_format( $this->{'showLog'}, $str, @data );
}

#---------------------------------------------------------------------
#	(4)-4 obj->format_for_text(str);
sub format_for_text {
    my ( $this, $str ) = @_;
    $str = $$str{'str'} if ref $str eq 'HASH';
    if ( defined $str ) {
        $str =~ s/^.*?\x0A//;
        if ( $str =~ /^([0-9]+):([^:\x0A]*):[^:\x0A]*:(.*)$/m ) {
            my ( $phase, $authority, $comment ) = (
                $this->phase_distiller( $this->get_phase_name($1) ),
                $2, $3
            );
            $phase =~ s/\&lt;/</g;
            $phase =~ s/\&gt;/</g;
            $this->set_authority_name;
            return $phase
                . (
                ( $this->{'authorityInfo'} )
                ? ' ['
                    . $this->{'authorityName'}
                    . (
                    (   defined $this->{'authority_name'}{$authority}
                            && $this->{'authority_name'}{$authority} ne ''
                    ) ? ' ' . $this->{'authority_name'}{$authority} : ''
                    )
                    . ' <'
                    . $authority . '>]'
                : ''
                ) . ( ( $this->{'comment'} ) ? $comment : '' );
        }
    }
    return '';
}

#---------------------------------------------------------------------
#	(4)-5 obj->confirmation(str);
sub confirmation_enabled ($) {
    my $this = shift;
    return 1;
}

sub confirmation ($$) {
    my ( $this, $str ) = @_;
    my ( $phase, $authority, $comment );
    $str = $$str{'str'} if ref $str eq 'HASH';
    $str =~ s/^(.*?)\x0A//;
    ( $phase, $authority, $comment ) = ( $1, $2, $3 )
        if $str =~ /^([0-9]+):([^:\x0A]*):[^:\x0A]*:(.*)$/m;
    return $this->field_tag(
        $this->style(
            $this->get_oparation_phase( $phase, $authority, $comment ),
            $this->{'style'},     $this->{'fontsize'},
            $this->{'fontcolor'}, $this->{'fontface'}
        )
    );
}

######################################################################
#	(5) obj->print_setting_form;
sub print_setting_form ($;$$) {
    my $this = shift;
    my ( $name, $id, $n );

    #名前
    $name = 'data:' . $this->{'id'};

    $this->print_field_info_form($name);

    print '<fieldset>';
    print '<legend>作業状況チェック欄設定</legend>';

    print '<table class="tooltable" style="margin-bottom: 20px">';
    print '<thead>';
    print '<tr class="odd">';
    print '<th class="odd">削除</th>';
    print '<th class="even">表示順</th>';
    print '<th class="odd">名前</th>';
    print '<th class="even">通知メール(表題/内容)</th>';
    print '<th class="odd">削除予約</th>';
    print '<th class="even">変更禁止</th>';
    print '<th class="odd">キャンセル後有効</th>';
    print '<th class="even">決済承認</th>'
        if $default::type && $default::type eq 'order';
    print '</tr>';
    print '</thead>';
    print '<tbody>';
    $this->print_phase_setting_form( $name, 0,
        ( ( $this->{'cancelEnabled'} ) ? 1 : 0 ) );
    $this->print_phase_setting_form( $name, 999, 0 )
        if $this->{'cancelEnabled'};
    $n = 1;

    foreach $id ( @{ $this->{'order'} } ) {
        $this->print_phase_setting_form( $name, $id, $n++ );
    }
    $id = 1;
    $id++ while ref $this->{'phase'}{$id};
    $this->print_phase_setting_form( $name, $id, $n, 1 );
    print '</tbody></table>';

    print '<fieldset>';
    print '<legend><label for="' . $name
        . '_initialphase">初期状況の名前</label></legend>';
    print '<input type="text" name="'
        . $name
        . '_initialphase" id="'
        . $name
        . '_initialphase" value="'
        . $this->escape( $this->{'initialphase'} )
        . '" size="40" />';
    print '</fieldset>';
    print '<fieldset>';
    print '<legend>作業状況チェック時の処理</legend>';
    print '<ol class="checkbox">';
    print '<li><label><input type="checkbox" name="'
        . $name
        . '_comment" id="'
        . $name
        . '_comment" value="1"'
        . ( ( defined $this->{'comment'} && $this->{'comment'} )
        ? ' checked="checked"'
        : '' )
        . ' /> 一言コメント欄を使用可能にする。</label></li>';
    print '<li><label><input type="checkbox" name="'
        . $name
        . '_mTime" id="'
        . $name
        . '_mTime" value="1" '
        . ( ( defined $this->{'mTime'} && $this->{'mTime'} )
        ? ' checked="checked"'
        : '' )
        . ' /> 作業状況チェック時に更新時データベースを更新する。</label></li>';
    print '</ol>';
    print '</fieldset>';
    print '<fieldset>';
    print '<legend>キャンセル処理</legend>';
    print '<table class="field-table">';
    print '<tbody>';
    print '<tr>';
    print
        '<td class="field-name"><span class="datatitle">キャンセルボタン</span></td>';
    print '<td class="field"><ol class="checkbox">';
    print '<li><label><input type="checkbox" name="'
        . $name
        . '_cancelEnabled" id="'
        . $name
        . '_cancelEnabled" value="1" '
        . ( ( defined $this->{'cancelEnabled'} && $this->{'cancelEnabled'} )
        ? ' checked="checked"'
        : '' )
        . ' /> 使用可能にする。</label></li>';
    print '<li><label><input type="checkbox" name="'
        . $name
        . '_cancelAlwaysEnabled" id="'
        . $name
        . '_cancelAlwaysEnabled" value="1" '
        . (
        (   defined $this->{'cancelAlwaysEnabled'}
                && $this->{'cancelAlwaysEnabled'}
        ) ? ' checked="checked"' : ''
        )
        . ' /> レコードの変更が禁止されていても使用可能にする。</label></li>';
    print '</ol></td>';
    print '</tr>';
    print '<tr>';
    print
        '<td class="field-name"><span class="datatitle">「チェック責任者」によるキャンセル</span></td>';
    print '<td class="field"><ol class="checkbox">';
    print '<li><label><input type="checkbox" name="'
        . $name
        . '_masterCancelEnabled" id="'
        . $name
        . '_masterCancelEnabled" value="1" '
        . (
        (   defined $this->{'masterCancelEnabled'}
                && $this->{'masterCancelEnabled'}
        ) ? ' checked="checked"' : ''
        )
        . ' /> 「チェック責任者」によるキャンセルを可能にする。</label></li>';
    print '</ol></td>';
    print '</tr>';
    print '<tr>';
    print '<td class="field-name"><label for="' . $name
        . '_cancelName">キャンセル処理名</label></td>';
    print '<td class="field"><input type="text" name="'
        . $name
        . '_cancelName" id="'
        . $name
        . '_cancelName" size="30" value="'
        . $this->escape( $this->{'cancelName'} )
        . '" /></td>';
    print '</tr>';
    print '<tr>';
    print
        '<td class="field-name"><span class="datatitle">キャンセル処理内容</span></td>';
    print '<td class="field"><ol class="checkbox">';
    print '<li><label><input type="checkbox" name="'
        . $name
        . '_cancelExpire" id="'
        . $name
        . '_cancelExpire" value="1"'
        . ( ( defined $this->{'cancelExpire'} && $this->{'cancelExpire'} )
        ? ' checked="checked"'
        : '' )
        . ' /> レコードの削除を予約する。</label></li>';
    print '<li><label><input type="checkbox" name="'
        . $name
        . '_cancelSuspend" id="'
        . $name
        . '_cancelSuspend" value="1"'
        . ( ( defined $this->{'cancelSuspend'} && $this->{'cancelSuspend'} )
        ? ' checked="checked"'
        : '' )
        . ' /> レコードの変更を禁止する。</label></li>';
    print '<li><label><input type="checkbox" name="'
        . $name
        . '_cancelSC" id="'
        . $name
        . '_cancelSC" value="1" '
        . ( ( defined $this->{'cancelSC'} && $this->{'cancelSC'} )
        ? ' checked="checked"'
        : '' )
        . ' /> 商品を棚に戻す。</label></li>'
        if $default::type && $default::type eq 'order';
    print '</ol></td>';
    print '</tr>';
    print '</tbody></table>';
    print '</fieldset>';
    print '<fieldset>';
    print '<legend>予約された削除のタイミング</legend>';
    print $this->mk_select_menu(
        $name . '_lifetime', '', '',
        ( ( defined $this->{'lifetime'} ) ? $this->{'lifetime'} : 604800 ),
        1        => '直後',
        86400    => '1日後以降',
        604800   => '1週間後以降',
        1209600  => '2週間後以降',
        2678400  => '1ヶ月後以降',
        5270400  => '2ヶ月後以降',
        8208000  => '3ヶ月後以降',
        10540800 => '4ヶ月後以降',
        13219200 => '5ヶ月後以降',
        15811200 => '6ヶ月後以降',
        18489600 => '7ヶ月後以降',
        21081600 => '8ヶ月後以降',
        23760000 => '9ヶ月後以降',
        26352000 => '10ヶ月後以降',
        29030400 => '11ヶ月後以降',
        31536000 => '1年後以降',
        47347200 => '1年6ヶ月後以降',
        63072000 => '2年後以降',
        94608000 => '3年後以降'
    );
    print '</fieldset>';
    print '</fieldset>';

    print '<fieldset>';
    print '<legend>チェック責任者</legend>';
    print '<fieldset>';
    print '<legend><label for="' . $name
        . '_checkerLevel">チェック権限のあるユーザー</label></legend>';
    print $this->mk_select_menu(
        $name . '_checkerLevel',
        '', '',
        $this->{'checkerLevel'},
        'master' => 'マスター',
        'owner'  => '管理人',
        'owners' => '共同オーナー',
        'staff'  => 'スタッフ',
        'member' => '登録メンバー',
        (     ( $default::type && $default::type eq 'order' )
            ? ()
            : ( 'nocheck' => '全てのユーザー' )
        )
    );
    print '</fieldset>';
    print '<fieldset>';
    print '<legend><label for="' . $name
        . '_authority">「登録メンバー」メールアドレス</label></legend>';
    print '<textarea name="'
        . $name
        . '_authority" id="'
        . $name
        . '_authority" cols="56" rows="5" wrap="off">'
        . $this->escape( $this->{'authority'} )
        . '</textarea>';
    print
        '<div class="note">登録メンバーが複数の時はカンマ（+改行）で区切ります。</div>';
    print '</fieldset>';
    print '<fieldset>';
    print '<legend><label for="' . $name
        . '_authorityName">チェック責任者の名称</label></legend>';
    print '<input type="text" name="'
        . $name
        . '_authorityName" id="'
        . $name
        . '_authorityName" value="'
        . $this->escape( $this->{'authorityName'} )
        . '" size="20" /><span class="note">（「担当者」等）</span>';
    print '</fieldset>';
    print '<ol class="checkbox">';
    print '<li><label><input type="checkbox" name="'
        . $name
        . '_authorityInfo" id="'
        . $name
        . '_authorityInfo" value="1"'
        . ( ( defined $this->{'authorityInfo'} && $this->{'authorityInfo'} )
        ? ' checked="checked"'
        : '' )
        . ' /> チェック責任者を表示する。</label></li>';
    print '<li><label><input type="checkbox" name="'
        . $name
        . '_charge" id="'
        . $name
        . '_charge" value="1"'
        . ( ( defined $this->{'charge'} && $this->{'charge'} )
        ? ' checked="checked"'
        : '' )
        . ' /> チェック責任者を固定する。</label></li>';
    print '<li><label><input type="checkbox" name="'
        . $name
        . '_addressProtector" id="'
        . $name
        . '_addressProtector" value="1"'
        . (
        (   defined $this->{'addressProtector'} && $this->{'addressProtector'}
        ) ? ' checked="checked"' : ''
        )
        . ' /> メールアドレスを JavaScript + CSS + HTML エンティティで保護する。</label></li>';
    print '<li><label><input type="checkbox" name="'
        . $name
        . '_notice" id="'
        . $name
        . '_notice" value="1"'
        . ( ( defined $this->{'notice'} && $this->{'notice'} )
        ? ' checked="checked"'
        : '' )
        . ' /> 全てのチェック責任者に状況をメールで通知する。</label></li>';
    print '</ol>';
    print '</fieldset>';
    print '<fieldset>';
    print '<legend>作業状況チェックログ設定</legend>';
    print '<table class="field-table">';
    print '<tbody>';
    print '<tr>';
    print
        '<td class="field-name"><span class="datatitle">表示設定</span></td>';
    print '<td class="field"><label><input type="checkbox" name="'
        . $name
        . '_showLog" id="'
        . $name
        . '_showLog" value="1"'
        . ( ( defined $this->{'showLog'} && $this->{'showLog'} )
        ? ' checked="checked"'
        : '' )
        . ' /> ログを表示する。</label></td>';
    print '</tr>';
    print '<tr>';
    print
        '<td class="field-name"><span class="datatitle">チェック時の表示</span></td>';
    print
        '<td class="field"><label><input type="number" size="3" maxlength="3" name="'
        . $name
        . '_datelimit" id="'
        . $name
        . '_datelimit" value="'
        . $this->escape( $this->{'datelimit'} )
        . '" /> 日以内なら相対日時で表現する（きょう/きのう/○日前）</label></td>';
    print '</tr>';
    print '<tr>';
    print '<td class="field-name"><label for="' . $name
        . '_datetype">チェック時表示形式</label></td>';
    print '<td class="field">';
    $this->print_date_type_menu( $name . '_', $this->{'datetype'} );
    print '</td>';
    print '</tr>';
    print '</tbody></table>';
    print '</fieldset>';

    print '<fieldset>';
    print '<legend>ボタン設定</legend>';
    print '<fieldset>';
    print '<legend>送信ボタン</legend>';
    print $cgi::Deco->button_menu( $name . '_button',
        'submit', 120, $this->{'button'} );
    print '</fieldset>';
    print '<fieldset>';
    print '<legend>キャンセルボタン</legend>';
    print $cgi::Deco->button_menu( $name . '_cancelButton',
        'cancel', 120, $this->{'cancelButton'} );
    print '</fieldset>';
    print '</fieldset>';

    #テーブル設定
    $this->print_table_setting_form( $name, '(ログ表示)', 'none' );

    print '<fieldset>';
    print '<legend>作業状況チェック通知メール設定</legend>';
    print
        '<div class="hints">作業状況が変更されたときに送信されます。</div>';
    print '<table class="field-table">';
    print '<tbody>';
    print '<tr>';
    print '<td class="field-name"><label for="' . $name
        . '_mailto">通知メール送信先</label></td>';
    print '<td class="field">';
    my $mail_fields_menu = '';

    foreach my $id (
        sort {
            $this->{'field_obj'}->{$a}->{'ORDER'}
                <=> $this->{'field_obj'}->{$b}->{'ORDER'}
                || $a <=> $b
        } keys %{ $this->{'field_obj'} }
        )
    {
        if ( defined $this->{'field_obj'}{$id}->{'e-mail'}
            && $this->{'field_obj'}{$id}->{'e-mail'} )
        {
            $mail_fields_menu
                .= '<option value="'
                . $id . '"'
                . (
                (   ref $this->{'mailto'}
                        && grep( $_ eq $id, @{ $this->{'mailto'} } )
                ) ? ' selected="selected"' : ''
                )
                . '>'
                . $this->{'field_obj'}{$id}->name
                . '</option>';
        }
    }
    if ($mail_fields_menu) {
        print '<select name="'
            . $name
            . '_mailto" id="'
            . $name
            . '_mailto" multiple="multiple">';
        print $mail_fields_menu;
        print '</select>';
        print
            '<div class="note">無選択の場合、通知機能は動作しません。</div>';
    }
    else {
        print
            '<div class="note">メールアドレスフィールドが存在しません。</div>';
    }
    print '</td></tr>';
    print '</tbody></table>';
    print '</fieldset>';

    $this->print_font_setting_form($name);
    $this->print_setting_save_button;
    return;
}

sub print_phase_setting_form ($$$$;$) {
    my ( $this, $name, $id, $n, $new ) = @_;
    $name .= '_phase_' . $id . '_';
    print '<tr class="' . ( ( ( $n + 1 ) % 2 ) ? 'even' : 'odd' ) . '">';
    if ( !$id ) {
        print '<td class="caution"></td>';
        print
            '<td class="even"><input type="hidden" name="order:0" value="0" /></td>';
        print '<td class="odd">リセット</td>';
    }
    elsif ( $id == 999 ) {
        print '<td class="caution"></td>';
        print
            '<td class="even"><input type="hidden" name="order:999" value="0" /></td>';
        print '<td class="odd">'
            . ( $this->{'cancelName'} || 'キャンセル' ) . '</td>';
    }
    elsif ($id) {
        print '<td class="caution">'
            . ( ( !$new )
            ? '<input type="checkbox" name="delete:' . $id . '" value="1" />'
            : '新規' )
            . '</td>';
        print '<td class="even"><input type="hidden" name="oldorder:'
            . $id
            . '" value="'
            . $n
            . '" /><input type="number" name="order:'
            . $id
            . '" value="'
            . $n
            . '" size="2" /></td>';
        print '<td class="odd"><input type="text" name="'
            . $name
            . 'name" size="16" value="'
            . $this->escape( $this->{'phase'}{$id}{'name'} )
            . '" /></td>';
    }
    print '<td class="even" style="text-align: left">';
    print '<div class="email-subject"><input type="text" name="'
        . $name
        . 'subject" size="50" value="'
        . $this->escape( $this->{'phase'}{$id}{'subject'} )
        . '" /></div>';
    print '<div class="email-msg"><textarea name="'
        . $name
        . 'msg" cols="50" rows="5">'
        . $this->escape( $this->{'phase'}{$id}{'msg'} )
        . '</textarea>';
    print '<div class="toolbox">';
    print
        '<select class="tool" onchange="cmonos.form.item(this.form).fieldname(\''
        . $name
        . 'msg\').quotationByMenu(this)" title="これらのタグはメール送信時に対応する値に変換されます。">';
    print '<option value="">▼挿入する</option>';
    print
        '<option value="&lt;phase&gt;">&lt;phase&gt;[現在の作業状況]</option>';
    print
        '<option value="&lt;checker&gt;">&lt;checker&gt;[チェック責任者のメールアドレス]</option>';
    print
        '<option value="&lt;comment&gt;">&lt;comment&gt;[チェックコメント]</option>';
    print '<option value="&lt;name&gt;">&lt;name&gt;[名前フィールド'
        . (
        (   $this->{'field_for'}{'name'}
                && ref $this->{'field_obj'}{ $this->{'field_for'}{'name'} }
        )
        ? '（'
            . $this->{'field_obj'}{ $this->{'field_for'}{'name'} }->name
            . '）'
        : ''
        ) . 'の値]</option>';
    print '<option value="&lt;key&gt;">&lt;key&gt;[キーフィールド'
        . (
        (   $this->{'field_for'}{'key'}
                && ref $this->{'field_obj'}{ $this->{'field_for'}{'key'} }
        )
        ? '（'
            . $this->{'field_obj'}{ $this->{'field_for'}{'key'} }->name
            . '）'
        : ''
        ) . 'の値]</option>';
    print
        '<option value="&lt;title&gt;">&lt;title&gt;[タイトルフィールド'
        . (
        (   $this->{'field_for'}{'title'}
                && ref $this->{'field_obj'}{ $this->{'field_for'}{'title'} }
        )
        ? '（'
            . $this->{'field_obj'}{ $this->{'field_for'}{'title'} }->name
            . '）'
        : ''
        ) . 'の値]</option>';
    print
        '<option value="&lt;url&gt;">&lt;url&gt;[詳細ページのURL]</option>';
    print
        '<option value="&lt;input&gt;">&lt;input&gt;[修正ページのURL]</option>';
    print
        '<option value="&lt;register&gt;">&lt;register&gt;[アドレス登録のURL]</option>';
    print
        '<option value="&lt;data&gt;">&lt;data&gt;[データの一覧]</option>';
    print '</select>';
    print ' <label id="'
        . $id
        . '-fit" class="auto-fit" title="高さを内容に合わせる"><input type="checkbox" onclick="cmonos.form.item(this.form).fieldname(\''
        . $name
        . 'msg\').setAutoFit(this.checked);" />フィット</label>';
    print '</div></div>';
    print '</td>';

    if ( $id && $id != 999 ) {
        print
            '<td class="odd" style="text-align: center; vertical-align: middle;"><input type="checkbox" name="'
            . $name
            . 'expire" value="1"'
            . (
            ( $this->{'phase'}{$id}{'expire'} ) ? ' checked="checked"' : '' )
            . ' /></td>';
        print
            '<td class="even" style="text-align: center; vertical-align: middle;"><input type="checkbox" name="'
            . $name
            . 'suspend" value="1"'
            . (
            ( $this->{'phase'}{$id}{'suspend'} ) ? ' checked="checked"' : '' )
            . ' /></td>';
        print
            '<td class="odd" style="text-align: center; vertical-align: middle;"><input type="checkbox" name="'
            . $name
            . 'aftercancel" value="1"'
            . ( ( $this->{'phase'}{$id}{'aftercancel'} )
            ? ' checked="checked"'
            : '' )
            . ' /></td>';
        print
            '<td class="even" style="text-align: center; vertical-align: middle;"><input type="checkbox" name="'
            . $name
            . 'paid" value="1"'
            . (
            ( $this->{'phase'}{$id}{'paid'} ) ? ' checked="checked"' : '' )
            . ' /></td>'
            if $default::type && $default::type eq 'order';
    }
    else {
        print '<td class="odd"></td>';
        print '<td class="even"></td>';
        print '<td class="odd"></td>';
        print '<td class="even"></td>'
            if $default::type && $default::type eq 'order';
    }
    print '</tr>';
}

######################################################################
#	(6) obj->is_valid_setting;
sub is_valid_setting ($) {
    my $this     = shift;
    my $is_valid = $this->is_valid_font_setting;
    my @phases   = ();
    my $id;
    while ( ($id) = each %main::order ) {
        if ( !$id || $id == 999 ) {
            $id = '0' if !$id;
            $main::data{ $this->{'id'} . '_phase_' . $id . '_subject' }
                =~ s/[\x0A\x0D]+//g
                if defined $main::data{ $this->{'id'}
                    . '_phase_'
                    . $id
                    . '_subject' };
            delete $main::data{ $this->{'id'} . '_phase_' . $id . '_name' };
            delete $main::data{ $this->{'id'} . '_phase_' . $id . '_expire' };
            delete $main::data{ $this->{'id'}
                    . '_phase_'
                    . $id
                    . '_suspend' };
            delete $main::data{ $this->{'id'}
                    . '_phase_'
                    . $id
                    . '_aftercancel' };
            delete $main::data{ $this->{'id'} . '_phase_' . $id . '_paid' }
                if $default::type && $default::type eq 'order';
        }
        elsif ( $main::delete{$id}
            || !
            defined $main::data{ $this->{'id'} . '_phase_' . $id . '_name' }
            || $main::data{ $this->{'id'} . '_phase_' . $id . '_name' } eq
            '' )
        {
            $main::data{ $this->{'id'} . '_phase_' . $id . '_name' } = "\x7F";
            $main::data{ $this->{'id'} . '_phase_' . $id . '_subject' }
                = "\x7F";
            $main::data{ $this->{'id'} . '_phase_' . $id . '_msg' } = "\x7F";
            $main::data{ $this->{'id'} . '_phase_' . $id . '_expire' }
                = "\x7F";
            $main::data{ $this->{'id'} . '_phase_' . $id . '_suspend' }
                = "\x7F";
            $main::data{ $this->{'id'} . '_phase_' . $id . '_aftercancel' }
                = "\x7F";
            $main::data{ $this->{'id'} . '_phase_' . $id . '_paid' } = "\x7F"
                if $default::type && $default::type eq 'order';
        }
        else {
            push( @phases, $id );
            $this->tag_fix(
                \$main::data{ $this->{'id'} . '_phase_' . $id . '_name' } );
            $main::data{ $this->{'id'} . '_phase_' . $id . '_expire' } = 0
                if !$main::data{ $this->{'id'}
                    . '_phase_'
                    . $id
                    . '_expire' };
            $main::data{ $this->{'id'} . '_phase_' . $id . '_suspend' } = 0
                if !$main::data{ $this->{'id'}
                    . '_phase_'
                    . $id
                    . '_suspend' };
            $main::data{ $this->{'id'} . '_phase_' . $id . '_aftercancel' }
                = 0
                if !$main::data{ $this->{'id'}
                    . '_phase_'
                    . $id
                    . '_aftercancel' };
            $main::data{ $this->{'id'} . '_phase_' . $id . '_paid' } = 0
                if $default::type
                && $default::type eq 'order'
                && !$main::data{ $this->{'id'} . '_phase_' . $id . '_paid' };
            $main::data{ $this->{'id'} . '_phase_' . $id . '_subject' }
                =~ s/[\x0A\x0D]+//g
                if defined $main::data{ $this->{'id'}
                    . '_phase_'
                    . $id
                    . '_subject' };
        }
    }
    $main::data{ $this->{'id'} . '_order' } = [
        (   sort {
                       $main::order{$a} <=> $main::order{$b}
                    || $main::oldorder{$b} <=> $main::oldorder{$a}
                    || $main::order{$a} cmp $main::order{$b}
                    || $a <=> $b
            } @phases
        )
    ];

    #タグの調整
    $this->tag_fix( \$main::data{ $this->{'id'} . '_initialphase' } )
        if defined $main::data{ $this->{'id'} . '_initialphase' }
        && $main::data{ $this->{'id'} . '_initialphase' };
    $this->tag_fix( \$main::data{ $this->{'id'} . '_description' } )
        if defined $main::data{ $this->{'id'} . '_description' }
        && $main::data{ $this->{'id'} . '_description' };
    $this->tag_fix( \$main::data{ $this->{'id'} . '_note' } )
        if defined $main::data{ $this->{'id'} . '_note' }
        && $main::data{ $this->{'id'} . '_note' };
    $this->detag( \$main::data{ $this->{'id'} . '_authorityName' } )
        if defined $main::data{ $this->{'id'} . '_authorityName' }
        && $main::data{ $this->{'id'} . '_authorityName' };
    $this->tag_fix( \$main::data{ $this->{'id'} . '_cancelName' } );

    #半角変換
    $main::data{ $this->{'id'} . '_authority' }
        = $this->z_to_h( $main::data{ $this->{'id'} . '_authority' }, 'utf8' )
        if defined $main::data{ $this->{'id'} . '_authority' }
        && $main::data{ $this->{'id'} . '_authority' };

    #チェックボックス
    $main::data{ $this->{'id'} . '_cancelEnabled' } = 0
        if !defined $main::data{ $this->{'id'} . '_cancelEnabled' }
        || !$main::data{ $this->{'id'} . '_cancelEnabled' };
    $main::data{ $this->{'id'} . '_cancelAlwaysEnabled' } = 0
        if !defined $main::data{ $this->{'id'} . '_cancelAlwaysEnabled' }
        || !$main::data{ $this->{'id'} . '_cancelAlwaysEnabled' };
    $main::data{ $this->{'id'} . '_masterCancelEnabled' } = 0
        if !defined $main::data{ $this->{'id'} . '_masterCancelEnabled' }
        || !$main::data{ $this->{'id'} . '_masterCancelEnabled' };
    $main::data{ $this->{'id'} . '_cancelExpire' } = 0
        if !defined $main::data{ $this->{'id'} . '_cancelExpire' }
        || !$main::data{ $this->{'id'} . '_cancelExpire' };
    $main::data{ $this->{'id'} . '_cancelSuspend' } = 0
        if !defined $main::data{ $this->{'id'} . '_cancelSuspend' }
        || !$main::data{ $this->{'id'} . '_cancelSuspend' };
    $main::data{ $this->{'id'} . '_cancelSC' } = 0
        if $default::type
        && $default::type eq 'order'
        && !$main::data{ $this->{'id'} . '_cancelSC' };
    $main::data{ $this->{'id'} . '_mTime' } = 0
        if !defined $main::data{ $this->{'id'} . '_mTime' }
        || !$main::data{ $this->{'id'} . '_mTime' };
    $main::data{ $this->{'id'} . '_charge' } = 0
        if !defined $main::data{ $this->{'id'} . '_charge' }
        || !$main::data{ $this->{'id'} . '_charge' };
    $main::data{ $this->{'id'} . '_authorityInfo' } = 0
        if !defined $main::data{ $this->{'id'} . '_authorityInfo' }
        || !$main::data{ $this->{'id'} . '_authorityInfo' };
    $main::data{ $this->{'id'} . '_showLog' } = 0
        if !defined $main::data{ $this->{'id'} . '_showLog' }
        || !$main::data{ $this->{'id'} . '_showLog' };
    $main::data{ $this->{'id'} . '_comment' } = 0
        if !defined $main::data{ $this->{'id'} . '_comment' }
        || !$main::data{ $this->{'id'} . '_comment' };
    $main::data{ $this->{'id'} . '_addressProtector' } = 0
        if !defined $main::data{ $this->{'id'} . '_addressProtector' }
        || !$main::data{ $this->{'id'} . '_addressProtector' };
    $main::data{ $this->{'id'} . '_notice' } = 0
        if !defined $main::data{ $this->{'id'} . '_notice' }
        || !$main::data{ $this->{'id'} . '_notice' };
    $main::data{ $this->{'id'} . '_mailto' } = ''
        if !defined $main::data{ $this->{'id'} . '_mailto' };

    #数字チェック
    if (   defined $main::data{ $this->{'id'} . '_datelimit' }
        && $main::data{ $this->{'id'} . '_datelimit' } ne ''
        && $this->is_nan( $main::data{ $this->{'id'} . '_datelimit' } ) )
    {
        push(
            @{ $cgi::action->{'dialog'} },
            '相対日時設定を更新できませんでした。半角数字にしてください。'
        ) if ref $cgi::action;
        delete $main::data{ $this->{'id'} . '_datelimit' };
        $is_valid = 0;
    }
    if (   defined $main::data{ $this->{'id'} . '_lifetime' }
        && $main::data{ $this->{'id'} . '_lifetime' } ne ''
        && $this->is_nan( $main::data{ $this->{'id'} . '_lifetime' } ) )
    {
        push(
            @{ $cgi::action->{'dialog'} },
            '削除のタイミングを更新できませんでした。半角数字にしてください。'
        ) if ref $cgi::action;
        delete $main::data{ $this->{'id'} . '_lifetime' };
        $is_valid = 0;
    }
    return $is_valid;
}

######################################################################
#	(6) obj->search_form;
sub search_form ($) {
    my $this = shift;
    my ($form);
    $this->scalar_to_array( \$main::search{ $this->{'id'} }{'str'} );
    $form
        = '<tr><td class="field-name"><label for="search:'
        . $this->{'id'}
        . ':str">'
        . $this->{'name'}
        . '</label></td><td class="field">';
    $form
        .= $this->get_oparation_phase_menu(
        'search:' . $this->{'id'} . ':str',
        $main::search{ $this->{'id'} }{'str'}, 1 );
    $form .= $this->mk_select_menu(
        'search:' . $this->{'id'} . ':mode',
        '', '',
        $main::search{ $this->{'id'} }{'mode'},
        'or' => (
            ($default::english) ? 'Matches on any selection'
            : 'いずれかに一致'
        ),
        'nor' => (
            ($default::english) ? 'Unmatches on any selection'
            : 'いずれにも一致しない'
        )
    );
    $form .= '</td></tr>';
    return $form;
}

######################################################################
#	(8) obj->sort_enabled;
sub sort_enabled ($) {
    my $this = shift;
    return 0;
}

######################################################################
#	(9) obj->cookie_enabled;
sub cookie_enabled ($) {
    my $this = shift;
    return 0;
}

######################################################################
#	(10) obj->required_enabled;
sub required_enabled ($) {
    my $this = shift;
    return 0;
}

######################################################################
#	(11) obj->update;
sub update_enabled ($) {
    my $this = shift;
    return 1;
}

sub is_secure_user_for_edit ($) {
    my $this = shift;
    return 0;
}

sub _update_error ($$) {
    my ( $this, $is_ajax ) = @_;
    return ($is_ajax)
        ? {
        'status'           => 'error',
        'message'          => $this->get_message_string,
        'authorized_level' => $this->get_authorized_level
        }
        : 0;
}

sub update ($;$) {
    no warnings qw(untie);
    my ( $this, $is_ajax ) = @_;
    my ( $db, $n, $c, %db, $addr, @user_addr, $data, $latest_phase,
        $latest_authority, $content, $url, $record );
    $this->save_update_target;
    delete $this->{'is_invalid_field'} if ref $this->{'is_invalid_field'};
    if ( !$this->is_secure_user && $main::phase != 999 ) {
        push(
            @{ $cgi::action->{'dialog'} },
            ( ( $this->{'name'} ne '' ) ? $this->{'name'} : '作業状況' )
                . 'を更新できませんでした。チェック権限がありません。'
        );
        return $this->_update_error($is_ajax);
    }
    if ( $main::phase && $main::phase eq 'i' ) {
        push(
            @{ $cgi::action->{'dialog'} },
            ( ( $this->{'name'} ne '' ) ? $this->{'name'} : '作業状況' )
                . 'を更新できませんでした。初期状況から変更されていません。'
        );
        return $this->_update_error($is_ajax);
    }
    if (   !defined $main::n
        || $main::n eq ''
        || !defined $main::c
        || $main::c eq ''
        || $this->is_nan($main::phase)
        || (   $main::phase
            && $main::phase != 999
            && !ref $this->{'phase'}{$main::phase} )
        )
    {
        push(
            @{ $cgi::action->{'dialog'} },
            ( ( $this->{'name'} ne '' ) ? $this->{'name'} : '作業状況' )
                . 'を更新できませんでした。送信内容に問題があります。'
        );
        return $this->_update_error($is_ajax);
    }
    $main::phase   = 0  if !$main::phase;
    $main::comment = '' if !defined $main::comment;
    $db            = $default::db . '/' . $main::c;
    $n             = $main::n;
    $c             = $main::c;
    tie(%db, $env::dbm_file,
        $db . '/' . $this->{'id'},
        O_RDWR | O_CREAT,
        $env::dbm_mode
    );
    if ( !ref tied %db ) {
        push(
            @{ $cgi::action->{'dialog'} },
            ( ( $this->{'name'} ne '' ) ? $this->{'name'} : '作業状況' )
                . 'を更新できませんでした。データベースに接続できませんでした。'
        );
        return $this->_update_error($is_ajax);
    }
    $data = $this->decode_utf8( $db{ $this->encode_utf8($n) } );
    untie %db;
    if ( $data =~ s/^(.*?)\x0A// ) {
        $addr = $1;
        @user_addr = split( /,/, $addr );
    }
    ( $latest_phase, $latest_authority ) = ( $1, $2 )
        if $data =~ /^([0-9]+):([^:\x0A]*):/;
    $latest_phase = 0 if !$latest_phase;
    if (   $this->{'charge'}
        && $latest_phase
        && $latest_authority ne $main::email
        && !$this->is_secure('tools') )
    {
        push(
            @{ $cgi::action->{'dialog'} },
            ( ( $this->{'name'} ne '' ) ? $this->{'name'} : '作業状況' )
                . 'を更新できませんでした。チェック権限がありません。'
        );
        return $this->_update_error($is_ajax);
    }
    if ((      $latest_phase
            && $main::phase
            && ((   (      $latest_phase == 999
                        || $this->{'phase'}{$latest_phase}{'aftercancel'}
                    )
                    && !$this->{'phase'}{$main::phase}{'aftercancel'}
                )
                || (   $latest_phase != 999
                    && !$this->{'phase'}{$latest_phase}{'aftercancel'}
                    && $this->{'phase'}{$main::phase}{'aftercancel'} )
            )
        )
        )
    {
        push(
            @{ $cgi::action->{'dialog'} },
            ( ( $this->{'name'} ne '' ) ? $this->{'name'} : '作業状況' )
                . 'を更新できませんでした。送信内容に問題があります。'
        );
        return $this->_update_error($is_ajax);
    }
    if ( $main::phase && $main::phase == 999 ) {
        if ((      !$this->{'cancelEnabled'}
                || !$this->user_included_in( \@user_addr )
            )
            && ( !$this->{'masterCancelEnabled'} || !$this->is_secure_user )
            )
        {
            push(
                @{ $cgi::action->{'dialog'} },
                (   ( $this->{'name'} ne '' )
                    ? $this->{'name'}
                    : '作業状況'
                    )
                    . 'を更新できませんでした。'
                    . ( $this->{'cancelName'} || 'キャンセル' )
                    . '権限がありません。'
            );
            return $this->_update_error($is_ajax);
        }
        elsif ($latest_phase
            && !$this->{'cancelAlwaysEnabled'}
            && $this->{'phase'}{$latest_phase}{'suspend'} )
        {
            push(
                @{ $cgi::action->{'dialog'} },
                (   ( $this->{'name'} ne '' )
                    ? $this->{'name'}
                    : '作業状況'
                    )
                    . 'を更新できませんでした。変更が禁止されています。'
            );
            return $this->_update_error($is_ajax);
        }
    }
    if ( $this->{'comment'} && $this->str_length($main::comment) > 200 ) {
        push(
            @{ $cgi::action->{'dialog'} },
            ( ( $this->{'name'} ne '' ) ? $this->{'name'} : '作業状況' )
                . 'を更新できませんでした。コメントが長すぎます。100字以内にしてください。'
        );
        $this->{'is_invalid_field'}{'comment'} = 1;
        return ($is_ajax)
            ? {
            'status'           => 'error',
            'error_fields'     => 'comment',
            'message'          => $this->get_message_string,
            'authorized_level' => $this->get_authorized_level
            }
            : 0;
    }
    $main::comment =~ s/[\x09\x0A\x0C\x0D\x20]+/ /sg;

    #ショッピングカートの処理
    if ( $default::type && $default::type eq 'order' ) {
        my ( %order, $order_info, @info );
        tie( %order, $env::dbm_file, $db . '/order',
            O_RDONLY, $env::dbm_mode );
        $order_info = $this->decode_utf8( $order{ $this->encode_utf8($n) } )
            if ref tied %order
            && defined $order{ $this->encode_utf8($n) }
            && $order{ $this->encode_utf8($n) };
        untie(%order);
        if ( $order_info && $order_info =~ /^(.*?)\x0A/s ) {

#($total,$tax,$fee,$carriage,$carriage_total,$download_key,$ptime,$transaction_id,$status,$dc_only,$expense,$dc_included,$discount)
            my @info = split( /\x09/, $1 );

            if ( $this->order_is_pending( $c, $n, $order_info ) ) {
                push(
                    @{ $cgi::action->{'dialog'} },
                    (   ( $this->{'name'} ne '' )
                        ? $this->{'name'}
                        : '作業状況'
                        )
                        . 'を更新できませんでした。キャンセルが申請されています。確認後再読み込みしてください。'
                );
                return $this->_update_error($is_ajax);
            }

            #支払い完了を記録
            if ( $this->{'phase'}{$main::phase}{'paid'} ) {
                if ( !$info[6] ) {
                    if ( $info[7] ) {
                        my $paypal = $this->use_paypal($is_ajax);
                        my ( $transaction_id, $ptime )
                            = $paypal->do_capture( $info[7], $info[0],
                            'Complete' );
                        if ( !$ptime ) {
                            push(
                                @{ $cgi::action->{'dialog'} },
                                $paypal->errors('all')
                            );
                            return $this->_update_error($is_ajax);
                        }
                        push(
                            @{ $cgi::action->{'dialog'} },
                            'PayPal による支払いを完了しました。'
                        );
                        $info[7] = $transaction_id;
                        $info[8] = 'Completed';
                        $main::comment
                            .= ( ($main::comment) ? '・' : '' )
                            . 'お支払い完了(PayPal)'
                            if $this->{'comment'}
                            && $this->str_length($main::comment) < 170;
                    }
                    $info[6] = time;
                    my $info = join( "\x09",
                        map( ( ( defined $_ ) ? $_ : '' ), @info ) );
                    $order_info =~ s/^(.*?)\x0A/$info\x0A/s;
                    tie( %order, $env::dbm_file, $db . '/order',
                        O_RDWR, $env::dbm_mode );
                    $order{ $this->encode_utf8($n) }
                        = $this->encode_utf8($order_info)
                        if ref tied %order;
                    untie(%order);
                }

                #カートの中身を戻す
            }
            elsif ( $main::phase == 999 && $this->{'cancelSC'} ) {
                if ( $info[6] ) {
                    push(
                        @{ $cgi::action->{'dialog'} },
                        (   ( $this->{'name'} ne '' )
                            ? $this->{'name'}
                            : '作業状況'
                            )
                            . 'を更新できませんでした。既に支払いが完了しているのでキャンセルできません。'
                    );
                    return $this->_update_error($is_ajax);
                }
                else {
                    if ( $info[7] && ( !$info[8] || $info[8] ne 'Canceled' ) )
                    {
                        my $paypal = $this->use_paypal($is_ajax);
                        if ( !$paypal->do_void( $info[7] ) ) {
                            push(
                                @{ $cgi::action->{'dialog'} },
                                $paypal->errors('all')
                            );
                            return $this->_update_error($is_ajax);
                        }
                        push(
                            @{ $cgi::action->{'dialog'} },
                            'PayPal による支払いをキャンセルしました。'
                        );
                        $info[8] = 'Canceled';
                        my $info = join( "\x09",
                            map( ( ( defined $_ ) ? $_ : '' ), @info ) );
                        $order_info =~ s/^(.*?)\x0A/$info\x0A/s;
                        tie( %order, $env::dbm_file, $db . '/order',
                            O_RDWR, $env::dbm_mode );
                        $order{ $this->encode_utf8($n) } = $order_info
                            if ref tied %order;
                        untie(%order);
                        $main::comment
                            .= ( ($main::comment) ? '・' : '' )
                            . 'お支払いキャンセル(PayPal)'
                            if $this->{'comment'}
                            && $this->str_length($main::comment) < 170;
                    }
                    if ( !ref $cgi::CartController ) {
                        require CMONOS::CGI_Lib::CartController;
                        $cgi::CartController = CartController->new;
                    }
                    $cgi::CartController->restore( $order_info,
                        $default::file . '/download' );
                }
            }
        }
    }

    #作業状況更新
    if ( $latest_phase == $main::phase ) {
        push(
            @{ $cgi::action->{'dialog'} },
            ( ( $this->{'name'} ne '' ) ? $this->{'name'} : '作業状況' )
                . 'を更新できませんでした。既に更新されています。'
        );
        return $this->_update_error($is_ajax);
    }
    else {
        tie(%db, $env::dbm_file,
            $db . '/' . $this->{'id'},
            O_RDWR | O_CREAT,
            $env::dbm_mode
        );
        if ( !ref tied %db ) {
            push(
                @{ $cgi::action->{'dialog'} },
                (   ( $this->{'name'} ne '' )
                    ? $this->{'name'}
                    : '作業状況'
                    )
                    . 'を更新できませんでした。データベースに接続できませんでした。'
            );
            return $this->_update_error($is_ajax);
        }
        $db{ $this->encode_utf8($n) } = $this->encode_utf8(
                  $addr . "\x0A"
                . $main::phase . ':'
                . ( ($main::email) ? $main::email : $env::master_email ) . ':'
                . time . ':'
                . (
                  ( $this->{'comment'} )
                ? ( defined $main::comment )
                        ? $main::comment
                        : ''
                : ''
                )
                . "\x0A"
                . $data
        );
        $content = $this->decode_utf8( $db{ $this->encode_utf8($n) } )
            if $is_ajax;
        untie %db;
    }

    #削除予約/解除
    if ( $this->{'phase'}{$main::phase}{'expire'}
        || ( $main::phase == 999 && $this->{'cancelExpire'} ) )
    {
        tie(%db, $env::dbm_file,
            $db . '/expire',
            O_RDWR | O_CREAT,
            $env::dbm_mode
        );
        if ( ref tied %db ) {
            $db{ $this->encode_utf8($n) }
                = $this->encode_utf8( time + $this->{'lifetime'} );
        }
        untie %db;
    }
    else {
        tie( %db, $env::dbm_file, $db . '/expire', O_RDWR, $env::dbm_mode );
        if ( ref tied %db ) {
            delete $db{ $this->encode_utf8($n) };
        }
        untie %db;
    }

    ( $url, $record ) = $this->permalink_of_detailview( $c, $n );

    #通知メール
    if (   ref $this->{'mailto'}
        && @{ $this->{'mailto'} }
        && $main::phase != 999
        && $this->{'phase'}{$main::phase}{'msg'} )
    {
        my (@mailto);
        foreach my $id ( @{ $this->{'mailto'} } ) {
            if ( ref $this->{'field_obj'}{$id}
                && $this->{'field_obj'}{$id}->{'e-mail'} )
            {
                my (%mail);
                tie( %mail, $env::dbm_file,
                    $db . '/' . $this->{'field_obj'}{$id}->db,
                    O_RDONLY, $env::dbm_mode );
                push(
                    @mailto,
                    $this->get_address(
                        $this->decode_utf8( $mail{ $this->encode_utf8($n) } )
                    )
                    )
                    if ref tied %mail
                    && defined $mail{ $this->encode_utf8($n) }
                    && $mail{ $this->encode_utf8($n) };
                untie(%mail);
            }
        }
        if (@mailto) {
            unless ( ref $cgi::SendMail ) {
                require CMONOS::CGI_Lib::SendMail;
                $cgi::SendMail
                    = SendMail->new( $env::sendmail, $env::master_email, '',
                    $cgi::input, 1 );
            }
            my ( $subject, $msg, $name, $authority_email )
                = $this->phase_message( $db, $c, $n, $main::email,
                $main::phase, $main::comment, $url, $record );
            my ($bcc);
            foreach my $m (@mailto) {
                $bcc .= ',' if defined $bcc && $bcc ne '';
                $bcc
                    .= ( $name && $name ne 'you' && $name ne 'あなた' )
                    ? $name . ' <' . $m . '>'
                    : $m;
            }
            $cgi::SendMail->send_mail(
                'Bcc'     => $bcc,
                'From'    => $authority_email,
                'Subject' => $subject,
                'message' => $msg . "\x0A\x0A",
                'info'    => 0
            );
        }
    }
    if ( $this->{'notice'} || $main::phase == 999 ) {
        my (@addr);
        push( @addr, $env::master_email );
        push( @addr, $setting::general{'master'} )
            if $setting::general{'master'}
            && $this->{'checkerLevel'}
            && ( $this->{'checkerLevel'} eq 'owner'
            || $this->{'checkerLevel'} eq 'owners'
            || $this->{'checkerLevel'} eq 'staff'
            || $this->{'checkerLevel'} eq 'member' );
        push( @addr, $setting::general{'owners'} )
            if $setting::general{'owners'}
            && $this->{'checkerLevel'}
            && ( $this->{'checkerLevel'} eq 'owners'
            || $this->{'checkerLevel'} eq 'staff'
            || $this->{'checkerLevel'} eq 'member' );
        push( @addr, $setting::general{'staff'} )
            if $setting::general{'staff'}
            && $this->{'checkerLevel'}
            && ( $this->{'checkerLevel'} eq 'staff'
            || $this->{'checkerLevel'} eq 'member' );
        push( @addr, $this->{'authority'} )
            if $this->{'authority'}
            && $this->{'checkerLevel'}
            && $this->{'checkerLevel'} eq 'member';
        @addr = $this->get_address(@addr);
        if (@addr) {

            unless ( ref $cgi::SendMail ) {
                require CMONOS::CGI_Lib::SendMail;
                $cgi::SendMail
                    = SendMail->new( $env::sendmail, $env::master_email, '',
                    $cgi::input, 1 );
            }
            local $setting::fixed_data = 1;
            my ( $subject, $msg )
                = ( $main::phase == 999 && $this->{'phase'}{'999'}{'msg'} )
                ? $this->phase_message( $db, $c, $n, $main::email,
                $main::phase, $main::comment, $url, $record )
                : (
                '【'
                    . $this->name . '】'
                    . $this->phase_distiller(
                    $this->get_phase_name($main::phase)
                    ),
                $url
                    . "\x0A\x0A"
                    . (
                    ($main::comment)
                    ? '[コメント]' . "\x0A" . $main::comment . "\x0A\x0A"
                    : ''
                    )
                );
            $cgi::SendMail->send_mail(
                'Bcc'  => join( ',', @addr ),
                'From' => (
                    (          $this->{'authorityInfo'}
                            && ref $cgi::Register
                            && $main::email
                    )
                    ? $cgi::Register->name_and_email( $main::pswd,
                        $main::email )
                    : ( $setting::general{'master'} )
                    ? ( $setting::general{'mastername'} )
                            ? $setting::general{'mastername'} . ' <'
                            . $setting::general{'master'} . '>'
                            : $setting::general{'master'}
                    : $env::master_email
                    ),
                    'Subject' => $subject,
                    'message' => $msg . "\x0A\x0A",
                    'info'    => 1
            );
        }
    }
    $this->post_update;
    if ( $main::phase == 999 && $default::type && $default::type eq 'order' )
    {
        my %order;
        tie( %order, $env::dbm_file, $db . '/order', O_RDWR, $env::dbm_mode );
        $order{ $this->encode_utf8($n) } = "0\x090\x090\x090\x090\x0A"
            if ref tied %order;
        untie(%order);
    }
    if ($is_ajax) {
        return {
            'status'           => 'success',
            'content'          => $this->get_oparation_phase_log( \$content ),
            'message'          => $this->get_message_string,
            'authorized_level' => $this->get_authorized_level,
            'hide_form' => ( ( $main::phase && $main::phase == 999 ) ? 1 : 0 )
        };
    }
    else {
        return 1;
    }
}

sub order_is_pending ($$$;$) {
    my ( $this, $c, $n, $order_info ) = @_;
    if ( !$order_info ) {
        my (%order);
        tie( %order, $env::dbm_file, $default::db . '/' . $c . '/order',
            O_RDONLY, $env::dbm_mode );
        $order_info = $this->decode_utf8( $order{ $this->encode_utf8($n) } )
            if ref tied %order
            && defined $order{ $this->encode_utf8($n) }
            && $order{ $this->encode_utf8($n) };
        untie(%order);
    }
    return 0 if !$order_info;
    my $count = 0;
    while ( $order_info =~ /^(.*)$/mg ) {
        next if !$1 || !$count++;
        my %item_data = ();
        $cgi::Session->read_data( \%item_data, $1 );
        return 1
            if defined $item_data{'newquantity'}
            && $item_data{'quantity'}
            && $item_data{'newquantity'} =~ /^[0-9]+$/
            && $item_data{'newquantity'} < $item_data{'quantity'};
    }
    return 0;
}

sub phase_message ($$$$$$$$$) {
    my ( $this, $db, $c, $n, $email, $phase, $comment, $url, $record ) = @_;
    my ( $subject, $msg, $name, $authority_email, $script_name, $input,
        $register_url );
    $subject
        = ( $this->{'phase'}{$phase}{'subject'} )
        ? $this->{'phase'}{$phase}{'subject'}
        : '【' . $this->name . '】<phase> のお知らせ';
    $msg = $this->{'phase'}{$phase}{'msg'} || '';
    $subject =~ s/<record>/$record/igs;
    $msg =~ s/<record>/$record/igs;
    $phase = $this->phase_distiller( $this->get_phase_name($phase) );
    $subject =~ s/<phase>/$phase/igs;
    $msg =~ s/<phase>/$phase/igs;
    $subject =~ s/<comment>/$comment/igs;
    $msg =~ s/<comment>/$comment/igs;

    if ( $subject =~ /<name>/i || $msg =~ /<name>/i ) {
        $name = ($default::english) ? 'you' : 'あなた';
        if ( defined $this->{'field_for'}{'name'}
            && $this->{'field_for'}{'name'} )
        {
            my (%name);
            tie(%name,
                $env::dbm_file,
                $db . '/'
                    . $this->{'field_obj'}{ $this->{'field_for'}{'name'} }
                    ->db,
                O_RDONLY,
                $env::dbm_mode
            );
            $name = $this->decode_utf8( $name{ $this->encode_utf8($n) } )
                if defined $name{ $this->encode_utf8($n) }
                && $name{ $this->encode_utf8($n) } ne '';
            untie(%name);
        }
        $subject =~ s/<name>/$name/igs;
        $msg =~ s/<name>/$name/igs;
    }
    if ( $subject =~ /<key>/i || $msg =~ /<key>/i ) {
        my $key = ($default::english) ? 'this' : 'これ';
        if ( defined $this->{'field_for'}{'key'}
            && $this->{'field_for'}{'key'} )
        {
            my (%key);
            tie(%key,
                $env::dbm_file,
                $db . '/'
                    . $this->{'field_obj'}{ $this->{'field_for'}{'key'} }->db,
                O_RDONLY,
                $env::dbm_mode
            );
            $key = $this->decode_utf8( $key{ $this->encode_utf8($n) } )
                if defined $key{ $this->encode_utf8($n) }
                && $key{ $this->encode_utf8($n) } ne '';
            untie(%key);
        }
        $subject =~ s/<key>/$key/igs;
        $msg =~ s/<key>/$key/igs;
    }
    if ( $subject =~ /<title>/i || $msg =~ /<title>/i ) {
        my $title = ($default::english) ? 'this' : 'これ';
        if ( defined $this->{'field_for'}{'title'}
            && $this->{'field_for'}{'title'} )
        {
            my (%title);
            tie(%title,
                $env::dbm_file,
                $db . '/'
                    . $this->{'field_obj'}{ $this->{'field_for'}{'title'} }
                    ->db,
                O_RDONLY,
                $env::dbm_mode
            );
            $title = $this->decode_utf8( $title{ $this->encode_utf8($n) } )
                if defined $title{ $this->encode_utf8($n) }
                && $title{ $this->encode_utf8($n) } ne '';
            untie(%title);
        }
        $subject =~ s/<title>/$title/igs;
        $msg =~ s/<title>/$title/igs;
    }
    if ( $msg =~ /<data>/i ) {
        my ( $list, $file_dir );
        $file_dir = "$default::file/$c/$n";
        foreach my $id (
            sort {
                $this->{'field_obj'}->{$a}->{'ORDER'}
                    <=> $this->{'field_obj'}->{$b}->{'ORDER'}
                    || $a <=> $b
            } keys %{ $this->{'field_obj'} }
            )
        {
            next if !$this->{'field_obj'}{$id}->format_for_mail_enabled;
            my (%data);
            tie( %data, $env::dbm_file,
                $db . '/' . $this->{'field_obj'}{$id}->db,
                O_RDONLY, $env::dbm_mode );
            $list
                .= $this->{'field_obj'}{$id}->format_for_mail(
                $this->decode_utf8( $data{ $this->encode_utf8($n) } ),
                $file_dir, $c, $n );
            untie(%data);
        }
        $msg =~ s/<data>/$list/igs;
    }
    $this->set_authority_name;
    $authority_email
        = ( $this->{'authorityInfo'} && $email )
        ? ( defined $this->{'authority_name'}{$email}
            && $this->{'authority_name'}{$email} ne '' )
            ? $this->{'authority_name'}{$email} . ' <' . $email . '>'
            : $email
        : ( $setting::general{'master'} )
        ? ( $setting::general{'mastername'} )
            ? $setting::general{'mastername'} . ' <'
            . $setting::general{'master'} . '>'
            : $setting::general{'master'}
        : $env::master_email;
    $subject =~ s/<checker>/$authority_email/igs;
    $msg =~ s/<checker>/$authority_email/igs;

    $script_name = $this->my_url;
    $msg =~ s/<url>/$url/igs;
    $input
        = ( $this->{'phase'}{$phase}{'suspend'} )
        ? $url
        : $script_name . '?m=Input&k=input&c=' . $c . '&n=' . $n;
    $msg =~ s/<input>/$input/igs;
    $register_url
        = $this->http_my_domain
        . $this->path_change( $env::register_cgi, $ENV{'SCRIPT_NAME'},
        'abs' );
    $msg =~ s/<register>/$register_url/igs;
    return ( $subject, $msg, $name, $authority_email );
}

sub editor_enabled ($) {
    my $this = shift;
    return 0;
}

sub use_paypal ($;$) {
    my ( $this, $is_ajax ) = @_;
    $this->import_db( $default::preference_dir . '/terms',
        \%setting::payment, 1 )
        if !%setting::payment;
    require CMONOS::TableMaker::CheckOutAPI::PayPal;
    return PayPal->new(
        $setting::payment{'paypal'}{'username'},
        $setting::payment{'paypal'}{'password'},
        $setting::payment{'paypal'}{'signature'},
        'JPY',
        $setting::payment{'paypal'}{'sandbox'},
        $is_ajax,
    );
}

######################################################################
#sub import {
BEGIN {
    if ( !$setting::field_for_mail ) {
        Field::class_register( 'xtm_checker', 'Checker',
            '作業状況チェック' );
        $setting::deco_dir{'submit'}  = '送信 ボタン';
        $setting::deco_type{'submit'} = 'button';
        $setting::deco_dir{'cancel'}  = 'キャンセル ボタン';
        $setting::deco_type{'cancel'} = 'button';
        push( @field::redundancy_forbidden, 'xtm_checker' );
    }
}

1;
