package DetailAccessCounter;
require CMONOS::CGI_Lib::Field::Num;
@ISA = qw(Num);
use strict;
use utf8;
######################################################################
# フィールドモジュール（詳細表示アクセス数）
# AccessCounter.pm 1.0
# Copyright (C) 1999-2018 CMONOS Co. Ltd.
#
# support@cmonos.jp
# http://cmonos.jp/
# 最終更新日：2012-09-18
######################################################################
sub _set ($$) {
    my ( $this, $setting ) = @_;
    $this->{'unit'} = '人' if !$this->{'unit'};
    $this->{'int'}  = 1;
    $this->{'cols'} = 8;
    return;
}

######################################################################
#	(0)-3 フィールドDB
sub db ($) {
    my $this = shift;
    return
        ( defined $this->{'counterType'}
            && $this->{'counterType'} eq 'daily' ) ? 'access_daily'
        : ( defined $this->{'counterType'}
            && $this->{'counterType'} eq 'weekly' ) ? 'access_weekly'
        : ( defined $this->{'counterType'}
            && $this->{'counterType'} eq 'monthly' ) ? 'access_monthly'
        : 'access_total';
}

######################################################################
#	(2) obj->input_enabled;
sub input_enabled ($) {
    my $this = shift;
    return 0;
}

sub form {
    my ( $this, $status, $original ) = @_;
    return '' if !$main::data{ $this->{'id'} }{'str'};
    my $form    = $this->field_header;
    my $counter = $main::data{ $this->{'id'} }{'str'};
    $counter
        =~ s/([0-9]{4,}(?=([^0-9]|$)))/{my $d = $1;1 while $d =~ s\/([0-9])([0-9]{3}(?=([^0-9]|$)))\/$1,$2\/g;$d}/ge
        if $this->{'comma'};
    $form .= $counter . '<span class="unit">' . $this->{'unit'} . '</span>'
        if defined $this->{'unit'} && $this->{'unit'};
    $form .= $this->field_footer;
    return $form;
}

######################################################################
#	(3) obj->is_valid_data(path);
sub is_valid_data ($;$) {
    my $this = shift;
    delete $main::data{ $this->{'id'} };
    return 1;
}

######################################################################
#	(5) obj->print_setting_form;
sub print_setting_form ($$$) {
    my ( $this, $html_disabled ) = @_;
    my ($name);

    #名前
    $name = 'data:' . $this->{'id'};

    $this->print_field_info_form($name);

    print '<fieldset>';
    print '<legend>表示設定</legend>';
    print '<table class="field-table">';
    print '<tbody>';
    print '<tr class="tbody-end">';
    print '<td class="field-name"><label for="' . $name
        . '_counterType">タイプ</label></td>';
    print '<td class="field" colspan="3">';
    print $this->mk_select_menu(
        $name . '_counterType', '', '', $this->{'counterType'},
        'total'   => 'アクセス総数',
        'monthly' => '今月のアクセス数',
        'weekly'  => '今週のアクセス数',
        'daily'   => '今日のアクセス数',
    );
    print
        ' <label><input type="checkbox" name="reset_accesscounter" id="reset_accesscounter" value="1" /> カウンターをリセットする</label>';
    print '</td>';
    print '</tr>';
    print '<tr>';
    print '<td class="field-name"><label for="' . $name
        . '_unit">単位</label></td>';
    print '<td class="q-field"><input type="text" name="'
        . $name
        . '_unit" id="'
        . $name
        . '_unit" value="'
        . $this->escape( $this->{'unit'} )
        . '" size="8" title="単位を設定します。" /></td>';
    print '<td class="field-name"><label for="' . $name
        . '_numtype">表示形式</label></td>';
    print '<td class="q-field">';
    print '<select name="' . $name
        . '_numtype" onchange="document.getElementById(\'comma\').style.display = (this.selectedIndex == 0) ? \'\' : \'none\';">';
    print '<option value=""'
        . ( ( !$this->{'numtype'} ) ? ' selected="selected"' : '' )
        . '>数字(123)</option>';
    print '<option value="k"'
        . ( ( defined $this->{'numtype'} && $this->{'numtype'} eq 'k' )
        ? ' selected="selected"'
        : '' )
        . '>漢数字(一二三)</option>';
    print '<option value="kJ"'
        . ( ( defined $this->{'numtype'} && $this->{'numtype'} eq 'kJ' )
        ? ' selected="selected"'
        : '' )
        . '>漢数詞(百二十三)</option>';
    print '<option value="K"'
        . ( ( defined $this->{'numtype'} && $this->{'numtype'} eq 'K' )
        ? ' selected="selected"'
        : '' )
        . '>大字(百弐拾参)</option>';
    print '</select>';
    print ' <label id="comma"><input type="checkbox" name="'
        . $name
        . '_comma" id="'
        . $name
        . '_comma" value="1"'
        . ( ( defined $this->{'comma'} && $this->{'comma'} )
        ? ' checked="checked"'
        : '' )
        . ' />三桁ごとに位取りする</label>';
    print $this->javascript(
        'document.getElementById(\'comma\').style.display = \'none\';')
        if $this->{'numtype'};
    print '</td>';
    print '</tr>';
    print '</tbody></table>';
    print '</fieldset>';

    #検索オプション
    $this->print_search_option_settings($name);

    #文字設定
    $this->print_font_setting_form($name);

    $this->print_setting_save_button;
    return;
}

######################################################################
#	(6) obj->is_valid_setting;
sub is_valid_setting ($) {
    my $this = shift;
    $this->tag_fix( \$main::data{ $this->{'id'} . '_unit' }, 2 )
        if defined $main::data{ $this->{'id'} . '_unit' }
        && $main::data{ $this->{'id'} . '_unit' };
    $this->tag_fix( \$main::data{ $this->{'id'} . '_description' } )
        if defined $main::data{ $this->{'id'} . '_description' }
        && $main::data{ $this->{'id'} . '_description' };
    $this->tag_fix( \$main::data{ $this->{'id'} . '_note' } )
        if defined $main::data{ $this->{'id'} . '_note' }
        && $main::data{ $this->{'id'} . '_note' };
    $main::data{ $this->{'id'} . '_searchOption' } = 0
        if !$main::data{ $this->{'id'} . '_searchOption' };
    $main::data{ $this->{'id'} . '_comma' } = 0
        if !$main::data{ $this->{'id'} . '_comma' };
    if ( $main::data{ $this->{'id'} . '_searchMenu' } ) {
        $main::data{ $this->{'id'} . '_searchMenu' } = join(
            "\x0A",
            sort { $a <=> $b } grep( !$this->is_nan($_) && $_ ne '',
                split(
                    /[\r\n]+/, $main::data{ $this->{'id'} . '_searchMenu' }
                ) )
        );
    }
    if ($main::reset_accesscounter) {
        use Fcntl qw(:DEFAULT);
        eval 'use ' . $env::dbm_file . ';';
        my ($reset_total, $reset_monthly, $reset_weekly,
            $reset_daily, $reset_date,    $type
        );
        $type = $main::data{ $this->{'id'} . '_counterType' } || 'total';
        $reset_total = ( $type eq 'total' ) ? 1 : 0;
        $reset_monthly = ( $type eq 'total' || $type eq 'monthly' ) ? 1 : 0;
        $reset_weekly
            = ( $type eq 'total' || $type eq 'monthly' || $type eq 'weekly' )
            ? 1
            : 0;
        $reset_daily
            = (    $type eq 'total'
                || $type eq 'monthly'
                || $type eq 'weekly'
                || $type eq 'daily' ) ? 1 : 0;
        my ( $sec, $min, $hour, $mday, $mon, $year, $wday ) = localtime(time);
        $year += 1900;
        $mon++;
        $reset_date
            = $year . sprintf( "%.2d", $mon ) . sprintf( "%.2d", $mday );
        local (*CATEGORY);
        opendir( CATEGORY, $default::db );

        foreach my $c ( readdir(CATEGORY) ) {
            next if $c =~ /^\./ || !-d "$default::db/$c";
            my ( %mtime, %total, %monthly, %weekly, %daily );
            tie( %mtime, $env::dbm_file, "$default::db/$c/mtime", O_RDONLY,
                $env::dbm_mode );
            tie(%total, $env::dbm_file,
                "$default::db/$c/access_total",
                O_RDWR | O_CREAT,
                $env::dbm_mode
            ) if $reset_total;
            tie(%monthly, $env::dbm_file,
                "$default::db/$c/access_monthly",
                O_RDWR | O_CREAT,
                $env::dbm_mode
            ) if $reset_monthly;
            tie(%weekly, $env::dbm_file,
                "$default::db/$c/access_weekly",
                O_RDWR | O_CREAT,
                $env::dbm_mode
            ) if $reset_weekly;
            tie(%daily, $env::dbm_file,
                "$default::db/$c/access_daily",
                O_RDWR | O_CREAT,
                $env::dbm_mode
            ) if $reset_daily;
            while ( my ($n) = each %mtime ) {
                $total{$n}   = '0' if $reset_total   && ref tied %total;
                $monthly{$n} = '0' if $reset_monthly && ref tied %monthly;
                $weekly{$n}  = '0' if $reset_weekly  && ref tied %weekly;
                $daily{$n}   = '0' if $reset_daily   && ref tied %daily;
            }
            untie %daily   if $reset_daily;
            untie %weekly  if $reset_weekly;
            untie %monthly if $reset_monthly;
            untie %total   if $reset_total;
            untie %mtime;
            if ($reset_total) {
                my (%ip);
                tie( %ip, $env::dbm_file, "$default::db/$c/access_ip",
                    O_RDWR | O_CREAT,
                    $env::dbm_mode );
                if ( ref tied %ip ) {
                    %ip = ();
                }
                untie %ip;
            }
        }
        closedir(CATEGORY);
        my (%general);
        tie(%general, $env::dbm_file,
            $default::preference_dir . '/general',
            O_RDWR | O_CREAT,
            $env::dbm_mode
        );
        if ( ref tied %general ) {
            $general{'counterReset'} = $this->encode_utf8($reset_date);
        }
        untie %general;
        $setting::general{'counterReset'} = $reset_date;
    }
    return $this->is_valid_font_setting;
}

######################################################################
#	(9) obj->cookie_enabled;
sub cookie_enabled ($) {
    my $this = shift;
    return 0;
}

######################################################################
#	(10) obj->required_enabled;
sub required_enabled ($) {
    my $this = shift;
    return 0;
}

######################################################################
#sub import {
BEGIN {
    if ( !$setting::field_for_mail ) {
        Field::class_register( 'xtm_counter', 'DetailAccessCounter',
            '詳細表示アクセス数' );
    }
}

1;
