package SCOrderInfo;
require CMONOS::TableMaker::Field::TMUserGeneratedField;
require CMONOS::CGI_Lib::Field;
@ISA = qw(TMUserGeneratedField Field);
use strict;
use utf8;
use Fcntl qw(:DEFAULT);
eval 'use ' . $env::dbm_file . ';';
######################################################################
# 注文内容モジュール
# SCOrderInfo.pm 1.0.9
# Copyright (C) 1999-2018 CMONOS Co. Ltd.
#
# support@cmonos.jp
# http://cmonos.jp/
# 最終更新日：2018-02-21
######################################################################
#	(0)-3 フィールドDB
sub db ($) {
    my $this = shift;
    return 'order';
}

# --------------------------------------------------------------------
sub __set ($$) {
    my $this = shift;
    unless ( ref $cgi::Deco ) {
        require CMONOS::CGI_Lib::Deco;
        $cgi::Deco = Deco->new;
    }
    @{ $this->{'authorities'} } = $this->get_address( $this->{'authority'} );
    $this->import_db( $default::preference_dir . '/terms',
        \%setting::payment, 1 )
        if !%setting::payment;
    $this->scalar_to_array( \$this->{'mailto'} );
    $this->{'field_for'}{'order_info'} = $this->{'id'};
    $this->{'mTime'}                   = 1;
    $setting::general{'itemname'}      = '商品'
        if !$setting::general{'itemname'};
    return;
}

sub mk_table_object ($$) {
    my ( $this, $id ) = @_;
    my $table;
    if ($id) {
        if ( ref $table::obj{$id} ) {
            $table = $table::obj{$id};
        }
        elsif ( ref $setting::table{$id} ) {
            $this->use_table;
            $table = $table::obj{$id};
        }
    }
    if ( !ref $table ) {
        $table = Table->new;
        $table->set(
            'tableclass' => 'datatable',
            'trclass'    => 'odd,even',
            'class0'     => 'odd,even',
            'style0'     => 'text-align: left'
        );
    }
    return $table;
}

######################################################################
#	(1) obj->match(str);
sub match ($;$) {
    my ( $this, $str ) = @_;
    return 1
        if !defined $main::search{ $this->{'id'} }{'str'}
        || $main::search{ $this->{'id'} }{'str'} eq '';
    @{ $this->{'pattern'} } = $this->make_patterns(
        \$main::search{ $this->{'id'} }{'str'},
        (   ( $this->{'ignoreCase'} || $main::search{ $this->{'id'} }{'i'} )
            ? 1
            : 0
        ),
        $main::search{ $this->{'id'} }{'mode'}
    ) if !ref $this->{'pattern'};
    my $data = $$str;
    utf8::encode($data) if utf8::is_utf8($data);
    $data =~ s/%([A-Fa-f0-9][A-Fa-f0-9])/pack("C",hex($1))/ge;
    utf8::decode($data) if !utf8::is_utf8($data);
    return $this->pattern_matched(
        \$data,
        $this->{'pattern'},
        (   ( $this->{'ignoreCase'} || $main::search{ $this->{'id'} }{'i'} )
            ? 1
            : 0
        ),
        $main::search{ $this->{'id'} }{'mode'}
    );
}

######################################################################
#	(2) obj->form;
sub form {
    my ( $this, $status, $original, $path ) = @_;
    return '' if !$main::data{ $this->{'id'} }{'str'};
    my ($form);
    $form = $this->field_header(60);
    $form
        .= $this->order_info( $main::c, $main::n,
        $main::data{ $this->{'id'} }{'str'},
        'normal', 1 );
    $form .= $this->field_footer;
    return $form;
}

######################################################################
#	(3) obj->is_valid_data;
sub input_enabled ($) {
    my $this = shift;
    return 0;
}

sub is_valid_data ($;$) {
    my $this = shift;
    return 1;
}

######################################################################
#	obj->is_secure;
sub is_secure_user ($) {
    my $this = shift;

    #管理パスワードチェック
    if (   !defined $this->{'checkerLevel'}
        || $this->{'checkerLevel'} eq ''
        || $this->{'checkerLevel'} eq 'master' )
    {
        if ( $this->is_master ) {
            return 1;
        }
        else {
            return 0;
        }

        #オーナーパスワードチェック
    }
    elsif ( $this->{'checkerLevel'} eq 'owner' ) {
        if ( $this->is_owner ) {
            return 1;
        }
        else {
            push(
                @{ $cgi::action->{'dialog'} },
                $cgi::Register->error_dialog
            ) if ref $cgi::Register;
            return 0;
        }

        #共同オーナーパスワードチェック
    }
    elsif ( $this->{'checkerLevel'} eq 'owners' ) {
        if ( $this->is_one_of_owners ) {
            return 1;
        }
        else {
            push(
                @{ $cgi::action->{'dialog'} },
                $cgi::Register->error_dialog
            ) if ref $cgi::Register;
            return 0;
        }

        #スタッフパスワードチェック
    }
    elsif ( $this->{'checkerLevel'} eq 'staff' ) {
        if ( $this->is_staff ) {
            return 1;
        }
        else {
            push(
                @{ $cgi::action->{'dialog'} },
                $cgi::Register->error_dialog
            ) if ref $cgi::Register;
            return 0;
        }

        #登録パスワードチェック
    }
    elsif ( $this->{'checkerLevel'} eq 'member' ) {
        if ( $this->is_authorized( @{ $this->{'authorities'} } ) ) {
            return 1;
        }
        else {
            push(
                @{ $cgi::action->{'dialog'} },
                $cgi::Register->error_dialog
            ) if ref $cgi::Register;
            return 0;
        }
    }

    return 0;
}

######################################################################
#	(4) obj->usual_format(str,path,category,no);
#	str=表示するデータ/path=ファイル保存ディレクトリ
sub usual_format {
    my ( $this, $str, $path, $c, $n ) = @_;
    $str = $$str{'str'} if ref $str eq 'HASH';
    return ($str) ? $this->order_info( $c, $n, $str, 'normal', 1 ) : '';
}

sub format_for_detail {
    my ( $this, $str, $path, $c, $n ) = @_;
    $str = $$str{'str'} if ref $str eq 'HASH';
    return ($str)
        ? $this->order_info(
        $c, $n, $str, 'detail', 0,
        ( (%main::newquantity) ? \%main::newquantity : '' ),
        ( (%main::cancel)      ? \%main::cancel      : '' )
        )
        : '';
}

#---------------------------------------------------------------------
#	(4)-2 obj->format_for_mail(str);
sub format_for_mail {
    my ( $this, $str, $path, $c, $n ) = @_;
    return ( !defined $str || $str eq '' )
        ? ''
        : '['
        . $this->name . "]\x0A"
        . $this->format_for_text( $str, $path, $c, $n ) . "\x0A";
}

#---------------------------------------------------------------------
#	(4)-4 obj->format_for_text(str);
sub format_for_text {
    my ( $this, $str, $path, $c, $n ) = @_;
    return '' if !defined $str || $str eq '';
    $str = $$str{'str'} if ref $str eq 'HASH';
    return $this->order_info( $c, $n, $str, 'text' );
}

#---------------------------------------------------------------------
sub order_info ($$$$;$$$$$) {
    my ( $this, $c, $n, $data, $type, $compact, $newquantity, $cancel_info,
        $ajax )
        = @_;
    return '' if !$data;
    $type    = '' if !$type;
    $compact = 1  if $this->{'compact'};
    my ($old_total,    $total,           $tax,
        $fee,          $carriage,        $carriage_total,
        $download_key, $ptime,           $transaction_id,
        $status,       $noshipping_only, $expense,
        $dc_included,  $discount,        $info,
        $dl_url,       $amount_paid,     $refunded,
        $bank,         $office,          $deposit,
        $number,       $name,            $kana,
        $comment,      $for_text
    );
    $for_text = ( $type eq 'text' ) ? 1 : 0;
    (   $total,           $tax,            $fee,
        $carriage,        $carriage_total, $download_key,
        $ptime,           $transaction_id, $status,
        $noshipping_only, $expense,        $dc_included,
        $discount
        )
        = split( /\x09/, $1 )
        if $data =~ s/^(.*?)\x0A//;
    $dl_url = $this->full_path($cgi::path) . '?m=DL&key=' . $download_key
        if $download_key && $ptime && ( !$status || $status ne 'Canceled' );

    if ($for_text) {
        $info
            .= '============================================================'
            . "\x0A";
    }
    elsif ($compact) {
        $info .= '<table id="sc-table-compact">';
        $info .= '<tbody id="sc-item-tbody">';
    }
    else {
        $info .= '<table id="sc-table">';
        $info .= '<thead>';
        $info .= '<tr class="odd">';
        $info .= '<th class="sc-item-name">'
            . $setting::general{'itemname'} . '</th>';
        $info .= '<th class="sc-item-option">オプション</th>';
        $info .= '<th class="sc-item-unit-price">単価</th>';
        $info .= '<th class="sc-item-quantity">数量</th>';
        $info .= '<th class="sc-item-price">価格</th>';
        $info .= '<th class="sc-item-tool">処理</th>';
        $info .= '</tr>';
        $info .= '</thead>';
        $info .= '<tbody id="sc-item-tbody">';
    }
    my $quantity_changed    = 0;
    my %item_data           = ();
    my $dc_only             = 1;
    my $noshipping_included = 0;
    my $weight_lacked       = 0;
    my $papersize_lacked    = 0;
    my $item_id             = 0;
    my $count               = 0;
    my $item_count          = 0;
    my $temp_total          = 0;
    my $discountable_total  = 0;
    my $limited_total       = 0;
    my $all_clear           = 1;
    my $recalculatable
        = ( !$setting::fixed_data && ( $type eq 'detail' || $for_text ) )
        ? 1
        : 0;
    my $discount_ratio;
    my $changable = 0;
    $noshipping_only = 1 if $recalculatable;

    while ( $data =~ /^(.*)$/mg ) {
        my $i = $1;
        next if !$i;
        $item_id++;
        if ( $i =~ /^cancel\x09(.*)\s*$/ ) {
            (   $amount_paid, $refunded, $bank,
                $office,      $deposit,  $number,
                $name,        $kana,     $comment
            ) = split( /\x09/, $1 );
            next;
        }
        my %item = ();
        $cgi::Session->read_data( \%item, $i );
        if ( $recalculatable && $this->item_is_cancelable( \%item, $ptime ) )
        {
            if (%main::newquantity) {
                if (   defined $main::newquantity{$item_id}
                    && $main::newquantity{$item_id} =~ /^[0-9]+$/
                    && $main::newquantity{$item_id} < $item{'quantity'} )
                {
                    $item{'oldquantity'} = $item{'quantity'};
                    $item{'quantity'}    = $main::newquantity{$item_id};
                    $item{'cancel'}
                        = $item{'oldquantity'} - $item{'quantity'};
                    $quantity_changed = 1;
                }
            }
            elsif ( defined $item{'newquantity'}
                && $item{'newquantity'} < $item{'quantity'} )
            {
                $item{'oldquantity'} = $item{'quantity'};
                $item{'quantity'}    = $item{'newquantity'};
                $item{'cancel'} = $item{'oldquantity'} - $item{'quantity'};
                $quantity_changed = 1;
            }
            if ( $item{'quantity'} ) {
                my $price
                    = ( ( $item{'optionprice'} )
                    ? ( $item{'price'} + $item{'optionprice'} )
                    : $item{'price'} )
                    * ( $item{'quantity'} || 0 );
                $discountable_total += $price
                    if !$setting::payment{'discountlimited'}
                    || $item{'discountable'};
                $limited_total += $price
                    if !$setting::payment{'limitlimited'} || $item{'limited'};
                if ( $item{'digitalcontent'} ) {
                    $noshipping_included = 1;
                }
                else {
                    $dc_only = 0;
                }
                if ( $item{'digitalcontent'} || $item{'noshipping'} ) {
                    $noshipping_included = 1;
                }
                else {
                    $noshipping_only = 0;
                }
                $weight_lacked = 1
                    if (!defined $item{'weight'} || $item{'weight'} eq '')
                    && !$item{'digitalcontent'}
                    && !$item{'noshipping'};
                $papersize_lacked = 1
                    if ( !$item{'papersize'}
                    || $item{'papersize'} !~ /^(?:A[4-6]|B[5-6]|ACCESSORY)$/
                    || !$item{'thickness'}
                    || $item{'thickness'}
                    > ( 20 - ( $setting::payment{'packagethickness'} || 0 ) )
                    )
                    && !$item{'digitalcontent'};
                $all_clear = 0;
            }
        }
        $item_data{$item_id} = \%item;
        $count++;
    }
    undef $data;
    $amount_paid = $total if !$amount_paid;
    if (   $quantity_changed
        && ref $setting::payment{'discount'}
        && %{ $setting::payment{'discount'} } )
    {
        $discount = 0;
        foreach my $n ( sort { $b <=> $a || $b cmp $a }
            keys %{ $setting::payment{'discount'} } )
        {
            if (   $n <= $discountable_total
                && $setting::payment{'discount'}{$n} )
            {
                $discount
                    = (    $setting::payment{'discount'}{$n} > 0
                        && $setting::payment{'discount'}{$n} < 100 )
                    ? $setting::payment{'discount'}{$n}
                    : 0;
                last;
            }
        }
        $discount_ratio = 1 - ( $discount / 100 );
    }
    foreach my $id ( sort { $a <=> $b || $a cmp $b } keys %item_data ) {
        my $item = $item_data{$id};
        my $price
            = ( ( $item->{'optionprice'} )
            ? ( $item->{'price'} + $item->{'optionprice'} )
            : $item->{'price'} );
        if (defined $discount_ratio
            && (  !$setting::payment{'discountlimited'}
                || $item->{'discountable'} )
            )
        {
            $item->{'amount'} = int( ( $price || 0 ) * $discount_ratio );
        }
        if ($for_text) {
            $info .= $this->jfold(
                ( $item->{'name'} || '' )
                . ( (          $item->{'key'}
                            && $item->{'key'} ne ( $item->{'name'} || '' )
                    ) ? ' [' . $item->{'key'} . ']' : ''
                    )
                    . (
                    ( $item->{'digitalcontent'} )
                    ? ' (' . $item->{'digitalcontent'} . ')'
                    : ''
                    )
                    . "\x0A",
                56, 'r', '', "\x0A", '    '
            );
            $info .= ( ( $info =~ /\x0A$/ ) ? '' : "\x0A" )
                . $this->jfold( $item->{'option'} . "\x0A",
                56, 'r', '', "\x0A", '    ' )
                if $item->{'option'};
        }
        elsif ($compact) {
            $info
                .= '<tr class="'
                . ( ( $id % 2 ) ? 'odd' : 'even' )
                . '" id="sc-item-'
                . $id . '">';
            $info .= '<td>';
            $info
                .= '<div class="sc-item-name"><a href="'
                . $this->escape( $item->{'path'}
                    . ( ( $item->{'anchor'} ) ? $item->{'anchor'} : '' ) )
                . '" target="_blank">'
                . $this->escape( $item->{'name'} )
                . ( ( $item->{'key'} && $item->{'key'} ne $item->{'name'} )
                ? ' [' . $this->detag_text( $item->{'key'} ) . ']'
                : '' )
                . '</a>'
                . ( ( $item->{'digitalcontent'} )
                ? ' (' . $this->escape( $item->{'digitalcontent'} ) . ')'
                : '' )
                . ( ( $item->{'digitalcontent'} ) ? ' [DL]'
                : ( $item->{'noshipping'} ) ? ' [配送不要]'
                : ( $item->{'shipped'} )    ? ' [配送済]'
                :                             '' )
                . '</div>';
            $info
                .= '<div class="sc-item-option">'
                . $this->escape( $item->{'option'} )
                . '</div>'
                if $item->{'option'};
            $info .= '<div class="sc-item-info">';
            $info
                .= '<span class="sc-item-unit-price" id="sc-item-'
                . $id
                . '-unit-price">';
        }
        else {
            $info
                .= '<tr class="'
                . ( ( $id % 2 ) ? 'odd' : 'even' )
                . '" id="sc-item-'
                . $id . '">';
            $info
                .= '<td class="sc-item-name"><a href="'
                . $this->escape( $item->{'path'}
                    . ( ( $item->{'anchor'} ) ? $item->{'anchor'} : '' ) )
                . '" target="_blank">'
                . $this->escape( $item->{'name'} )
                . ( ( $item->{'key'} && $item->{'key'} ne $item->{'name'} )
                ? ' [' . $this->detag_text( $item->{'key'} ) . ']'
                : '' )
                . '</a>'
                . ( ( $item->{'digitalcontent'} )
                ? ' (' . $this->escape( $item->{'digitalcontent'} ) . ')'
                : '' )
                . '</td>';
            $info .= '<td class="sc-item-option">'
                . $this->escape( $item->{'option'} ) . '</td>';
            $info
                .= '<td class="sc-item-unit-price" id="sc-item-'
                . $id
                . '-unit-price">';
        }
        if (   $discount
            && $item->{'amount'}
            && $item->{'amount'} ne ''
            && $item->{'amount'} != $price )
        {
            if ($for_text) {
                $info
                    .= ( ( $info =~ /\x0A$/ ) ? '' : "\x0A" )
                    . '                              ￥'
                    . $this->digit($price)
                    . ' (割引前)';
                $price = $item->{'amount'};
                $info
                    .= ( ( $info =~ /\x0A$/ ) ? '' : "\x0A" )
                    . '                              ￥'
                    . $this->digit($price) . ' (-'
                    . $this->round_down( $discount,
                    $setting::payment{'discountrounddown'}, 'floor' )
                    . '%)';
            }
            else {
                $info
                    .= '<del>&yen;'
                    . $this->digit($price)
                    . '</del><ins>(-'
                    . $this->round_down( $discount,
                    $setting::payment{'discountrounddown'}, 'floor' )
                    . '%)</ins> ';
                $price = $item->{'amount'};
                $info .= '&yen;' . $this->digit($price);
            }
        }
        elsif ($for_text) {
            $info
                .= ( ( $info =~ /\x0A$/ ) ? '' : "\x0A" )
                . '                              ￥'
                . $this->digit($price);
        }
        else {
            $info .= '&yen;' . $this->digit($price);
        }
        if ($for_text) {
            $info .= ' × ';
        }
        elsif ($compact) {
            $info .= '</span>';
            $info .= '<span class="sc-item-quantity">&times;';
        }
        else {
            $info .= '</td>';
            $info .= '<td class="sc-item-quantity">';
        }
        if (  !$for_text
            && $recalculatable
            && $this->item_is_cancelable( $item, $ptime ) )
        {
            $info
                .= '<select id="sc-item-quantity" id="newquantity:'
                . $id
                . '" name="newquantity:'
                . $id
                . '" title="0=削除">';
            for (
                my $q = ( $item->{'oldquantity'} || $item->{'quantity'} );
                $q >= 0;
                $q--
                )
            {
                $info
                    .= '<option value="'
                    . $q . '"'
                    . (
                    (   defined $item->{'quantity'}
                            && $item->{'quantity'} eq $q
                    ) ? ' selected="selected"' : ''
                    )
                    . '>'
                    . $q
                    . '</option>';
            }
            $info .= '</select>';
            $changable = 1;
        }
        else {
            delete $newquantity->{$id} if ref $newquantity;
            delete $item->{'newquantity'};
            $info
                .= ( ( defined $item->{'quantity'} )
                ? $this->digit( $item->{'quantity'} )
                : '0' );
        }
        if ( !$for_text ) {
            if ($compact) {
                $info .= '</span>';
            }
            else {
                $info .= '</td>';
            }
        }
        $price
            = ( ( $price && $item->{'quantity'} )
            ? $price * $item->{'quantity'}
            : 0 );
        if ($for_text) {
            $info .= ' = ￥' . $this->digit($price) . "\x0A";
            $info
                .= '------------------------------------------------------------'
                . "\x0A";
        }
        elsif ($compact) {
            $info
                .= '=<span class="sc-item-price" id="sc-item-'
                . $id
                . '-price">&yen;'
                . $this->digit($price)
                . '</span>';
            $info .= '</div>';
            $info .= '</td>';
            $info .= '</tr>';
        }
        else {
            $info
                .= '<td class="sc-item-price" id="sc-item-'
                . $id
                . '-price">&yen;'
                . $this->digit($price) . '</td>';
            $info
                .= '<td class="sc-item-tool" id="sc-item-'
                . $id
                . '-tool">'
                . ( ( $item->{'digitalcontent'} ) ? 'DL'
                : ( $item->{'noshipping'} ) ? '配送不要'
                : ( $item->{'shipped'} )    ? '配送済'
                :                             '' )
                . '</td>';
            $info .= '</tr>';
        }
        $temp_total += $price;
        $item_count++ if $item->{'quantity'};
    }
    if ($quantity_changed) {
        $total = $temp_total;
        if ($noshipping_only) {
            $noshipping_only = 1;
            $noshipping_only = 2 if $dc_only;
        }
        $carriage_total = $this->add_tax($total);
        if (   $noshipping_only
            || !$field::for{'payment_method'}
            || (   $setting::payment{'carriage'}
                && $setting::payment{'carriage'} eq 'disabled' )
            )
        {
            $carriage = 0;
        }
        else {
            $carriage = $this->order_carriage(
                $carriage_total, \%item_data,
                $weight_lacked,  $papersize_lacked
            );
            $total += $carriage;
        }
        if ($total) {
            if ($setting::payment{'codenabled'}
                && ($noshipping_only
                    || (   $setting::payment{'cod'}{'dcUnavailable'}
                        && $noshipping_included )
                )
                && $this->get_field_data_from_db(
                    'payment', $main::c, $main::n
                ) eq 'cod'
                )
            {
                $fee = 0;
            }
            else {
                $fee = $this->order_fee($total);
                if ( $fee && $fee =~ /[^0-9]/ ) {
                    $fee = 0;
                }
                else {
                    $total += $fee;
                }
            }
        }
        if ($env::tax_rate) {
            $tax = $this->get_tax($total);
            $total += $tax;
        }
        $expense = $this->paypal_fee( $total, $noshipping_only ) if $expense;
    }
    if ( !$for_text ) {
        if ($compact) {
            $info .= '</tbody>';
            $info .= '<tbody id="sc-total-tbody">';
            $info .= '<tr>';
            $info .= '<td>';
        }
        else {
            $info .= '</tbody>';
            $info .= '<tbody id="sc-total-tbody">';
        }
    }
    if ( $quantity_changed || $temp_total != $total ) {
        if ($for_text) {
            $info
                .= '                                    小計:  ￥'
                . $this->digit($temp_total) . "\x0A"
                if $temp_total != $total;
        }
        elsif ($compact) {
            $info
                .= '<div id="sc-sub-total">小計:<span id="sc-sub-total-value">&yen;'
                . $this->digit($temp_total)
                . '</span></div>';
        }
        else {
            $info .= '<tr id="sc-sub-total" class="sc-total-start">';
            $info .= '<td class="sc-name" colspan="4">小計</td>';
            $info .= '<td class="sc-value" id="sc-sub-total-value">&yen;'
                . $this->digit($temp_total) . '</td>';
            $info .= '<td class="sc-tool empty"></td>';
            $info .= '</tr>';
        }
        if ($carriage) {
            if ($for_text) {
                $info
                    .= '                                  配送料:  ￥'
                    . $this->digit($carriage) . "\x0A"
                    if $carriage;
            }
            elsif ($compact) {
                $info .= '<div id="sc-carriage">';
                $info
                    .= '<a href="'
                    . $default::file
                    . '/payment_info.'
                    . (
                    ( $env::ssi && $env::ssi_ext ) ? $env::ssi_ext : 'html' )
                    . '#carriage-info-header" target="_blank">配送料</a>:';
                $info
                    .= '<span id="sc-carriage-value">&yen;'
                    . $this->digit($carriage)
                    . '</span>';
                $info .= '</div>';
            }
            else {
                $info .= '<tr id="sc-carriage">';
                $info
                    .= '<td class="sc-name" colspan="4"><a href="'
                    . $default::file
                    . '/payment_info.'
                    . (
                    ( $env::ssi && $env::ssi_ext ) ? $env::ssi_ext : 'html' )
                    . '#carriage-info-header" target="_blank">配送料</a></td>';
                $info .= '<td class="sc-value" id="sc-carriage-value">&yen;'
                    . $this->digit($carriage) . '</td>';
                $info .= '<td class="sc-tool empty"></td>';
                $info .= '</tr>';
            }
        }
        if ($fee) {
            if ($for_text) {
                $info
                    .= '                                  手数料:  ￥'
                    . $this->digit($fee) . "\x0A"
                    if $fee;
            }
            elsif ($compact) {
                $info .= '<div id="sc-fee">';
                $info
                    .= '<a href="'
                    . $default::file
                    . '/payment_info.'
                    . (
                    ( $env::ssi && $env::ssi_ext ) ? $env::ssi_ext : 'html' )
                    . '#payment-info-header" target="_blank">手数料</a>:';
                $info
                    .= '<span id="sc-fee-value">&yen;'
                    . $this->digit($fee)
                    . '</span>';
                $info .= '</div>';
            }
            else {
                $info .= '<tr id="sc-fee">';
                $info
                    .= '<td class="sc-name" colspan="4"><a href="'
                    . $default::file
                    . '/payment_info.'
                    . (
                    ( $env::ssi && $env::ssi_ext ) ? $env::ssi_ext : 'html' )
                    . '#payment-info-header" target="_blank">手数料</a></td>';
                $info .= '<td class="sc-value" id="sc-fee-value">&yen;'
                    . $this->digit($fee) . '</td>';
                $info .= '<td class="sc-tool empty"></td>';
                $info .= '</tr>';
            }
        }
        if ($tax) {
            if ($for_text) {
                $info
                    .= '                                  消費税:  ￥'
                    . $this->digit($tax) . "\x0A"
                    if $tax;
            }
            elsif ($compact) {
                $info .= '<div id="sc-tax">';
                $info .= '消費税:';
                $info
                    .= '<span id="sc-tax-value">&yen;'
                    . $this->digit($tax)
                    . '</span>';
                $info .= '</div>';
            }
            else {
                $info .= '<tr id="sc-tax">';
                $info .= '<td class="sc-name" colspan="4">消費税</td>';
                $info .= '<td class="sc-value" id="sc-tax-value">&yen;'
                    . $this->digit($tax) . '</td>';
                $info .= '<td class="sc-tool empty"></td>';
                $info .= '</tr>';
            }
        }
        $info .= '<tr id="sc-total">' if !$for_text && !$compact;
    }
    elsif ( !$for_text && !$compact ) {
        $info .= '<tr id="sc-total" class="sc-total-start">';
    }
    if ($for_text) {
        $info .= '                                    合計:  ￥'
            . $this->digit($total) . "\x0A";
        $info
            .= '============================================================'
            . "\x0A";
    }
    elsif ($compact) {
        $info
            .= '<div id="sc-total">合計'
            . ( ($ptime) ? '(支払済)' : '' )
            . ':<span id="sc-total-value">&yen;'
            . $this->digit($total)
            . '</span></div>';
    }
    else {
        $info .= '<td class="sc-name" colspan="4">合計</td>';
        $info .= '<td class="sc-value" id="sc-total-value">&yen;'
            . $this->digit($total) . '</td>';
        $info
            .= ($ptime)
            ? '<td class="sc-tool">支払済</td>'
            : '<td class="sc-tool empty"></td>';
        $info .= '</tr>';
    }
    if ( !$for_text ) {
        if ($expense
            && (   $this->is_secure_user
                || $setting::payment{'paypal'}{'sandbox'} )
            )
        {
            if ($compact) {
                $info
                    .= '<div id="sc-paypal">PayPal 手数料:<span id="sc-paypal-fee">-&yen;'
                    . $this->digit($expense)
                    . '</span></div>';
                $info
                    .= '<div id="sc-net">正味金額:<span id="sc-net-value">&yen;'
                    . $this->digit( $total - $expense )
                    . '</span></div>';
                $info .= '</tr>';
            }
            else {
                $info .= '<tr id="sc-paypal">';
                $info
                    .= '<td class="sc-name" colspan="4">PayPal 手数料</td>';
                $info .= '<td class="sc-value" id="sc-paypal-fee">-&yen;'
                    . $this->digit($expense) . '</td>';
                $info .= '<td class="sc-tool empty"></td>';
                $info .= '</tr>';
                $info .= '<tr id="sc-net">';
                $info .= '<td class="sc-name" colspan="4">正味金額</td>';
                $info .= '<td class="sc-value" id="sc-net-value">&yen;'
                    . $this->digit( $total - $expense ) . '</td>';
                $info .= '<td class="sc-tool empty"></td>';
                $info .= '</tr>';
            }
        }
        if ($changable) {
            if ($compact) {
                $info
                    .= '<div id="sc-cancel"><input type="submit" value="数量を変更する" /></div>';
                $info .= '</tr>';
            }
            else {
                $info .= '<tr id="sc-cancel">';
                $info
                    .= '<td class="sc-name" colspan="4"><input type="submit" value="数量を変更する" /></td>';
                $info .= '<td class="sc-tool empty" colspan="2"></td>';
                $info .= '</tr>';
            }
        }
        if ($compact) {
            $info .= '</td>';
            $info .= '</tr>';
            $info .= '</tbody>';
            $info .= '</table>';
        }
        else {
            $info .= '</tbody>';
            $info .= '</table>';
        }
        if ($dl_url) {
            $info
                .= '<p id="digital-content-download"><a href="'
                . $this->escape($dl_url)
                . '" target="_blank">&raquo; ダウンロード</a></p>';
        }
    }
    elsif ($dl_url) {
        $info .= "\x0A" . '【ダウンロード】' . "\x0A";
        $info .= $dl_url . "\x0A";
    }
    if ( !$count ) {
        $info
            = ( !$for_text )
            ? '<p class="warning">この注文はキャンセルされました。</p>'
            : '============================================================'
            . "\x0A"
            . '※この注文はキャンセルされました。' . "\x0A"
            . '============================================================'
            . "\x0A";
    }
    elsif ( !$item_count && $for_text ) {
        $info
            = '============================================================'
            . "\x0A"
            . '※この注文はキャンセルされ'
            . ( ($setting::quantity_changed) ? 'ました。' : 'ます。' )
            . "\x0A"
            . '============================================================'
            . "\x0A";
    }
    if ($for_text) {
        if ($quantity_changed) {
            $info
                .= "\x0A"
                . '[キャンセル'
                . (
                ($setting::quantity_changed) ? 'された' : '申請中の' )
                . $setting::general{'itemname'} . ']' . "\x0A";
            $info
                .= '============================================================'
                . "\x0A";
            foreach my $i ( sort { $a <=> $b } keys %item_data ) {
                my $item = $item_data{$i};
                if ( $item->{'cancel'} ) {
                    $info .= $this->jfold(
                        ( $item->{'name'} || '' )
                        . ( (          $item->{'key'}
                                    && $item->{'key'} ne
                                    ( $item->{'name'} || '' )
                            ) ? ' [' . $item->{'key'} . ']' : ''
                            )
                            . (
                            ( $item->{'digitalcontent'} )
                            ? ' (' . $item->{'digitalcontent'} . ')'
                            : ''
                            )
                            . "\x0A",
                        56, 'r', '', "\x0A", '    '
                    );
                    $info .= ( ( $info =~ /\x0A$/ ) ? '' : "\x0A" )
                        . $this->jfold( $item->{'option'} . "\x0A",
                        56, 'r', '', "\x0A", '    ' )
                        if $item->{'option'};
                    $info
                        .= ( ( $info =~ /\x0A$/ ) ? '' : "\x0A" )
                        . '                               × '
                        . $this->digit( $item->{'cancel'} );
                    $info .= '(削除)' if !$item->{'quantity'};
                    $info
                        .= ( ( $info =~ /\x0A$/ ) ? '' : "\x0A" )
                        . '------------------------------------------------------------'
                        . "\x0A";
                }
            }
            $info =~ s/-+\x0A$//s;
            $info
                .= '============================================================'
                . "\x0A";
            $info
                .= '※すべての注文をキャンセル'
                . ( ($setting::quantity_changed)
                ? 'しました。'
                : 'します。' )
                . "\x0A"
                if !$item_count;
        }
    }
    elsif ( $type eq 'detail' ) {
        my $id = $this->mk_user_generated_field_id( $c, $n );
        $info = $this->form_start(
            'id'   => ( ($id) ? $id . '-form' : '' ),
            'name' => ( ($id) ? $id . '-form' : '' ),
            'method'   => 'post',
            'onsubmit' => 'return cmonos.form.item(this).submit(\''
                . $id . '\');',
            'required' => \@setting::form
            )
            . '<input type="hidden" name="id" value="'
            . $this->{'id'} . '" />'
            . ( ( !grep( $_ eq 'c', @setting::form ) )
            ? '<input type="hidden" name="c" value="' . $c . '" />'
            : '' )
            . ( ( !grep( $_ eq 'n', @setting::form ) )
            ? '<input type="hidden" name="n" value="' . $n . '" />'
            : '' )
            . $info
            . '</form>'
            if $changable;
        if ($quantity_changed) {
            my $table = $this->mk_table_object( $this->{'table'} );
            $info
                .= '<dl class="sc-cancel-info"><dt>キャンセル</dt><dd>';
            $info .= $table->table;
            $info .= $table->tr;
            $info .= $table->th( $setting::general{'itemname'} );
            $info .= $table->th('オプション');
            $info .= $table->th('キャンセル数');
            $info .= $table->_tr;

            foreach my $i ( sort { $a <=> $b } keys %item_data ) {
                if ( $item_data{$i}{'cancel'} ) {
                    $info .= $table->tr;
                    $info .= $table->td(
                        '<a href="'
                            . $this->escape(
                            $item_data{$i}{'path'}
                                . (
                                ( $item_data{$i}{'anchor'} )
                                ? $item_data{$i}{'anchor'}
                                : ''
                                )
                            )
                            . '" target="_blank">'
                            . $this->escape( $item_data{$i}{'name'} )
                            . (
                            (          $item_data{$i}{'key'}
                                    && $item_data{$i}{'key'} ne
                                    $item_data{$i}{'name'}
                            )
                            ? ' ['
                                . $this->escape( $item_data{$i}{'key'} ) . ']'
                            : ''
                            )
                            . '</a>'
                            . (
                            ( $item_data{$i}{'digitalcontent'} ) ? ' ('
                                . $this->escape(
                                $item_data{$i}{'digitalcontent'}
                                )
                                . ')' : ''
                            )
                    );
                    $info .= $table->td(
                        $this->escape( $item_data{$i}{'option'} ) );
                    $info .= $table->td(
                        $this->escape( $item_data{$i}{'cancel'} )
                            . (
                            ( !$item_data{$i}{'quantity'} ) ? '(削除)' : ''
                            )
                    );
                    $info .= $table->_tr;
                }
            }
            $info .= $table->_table . '</dd>';
            $amount_paid = $old_total if !$amount_paid;
            my $refund_fee = (
                       $ptime
                    && $setting::payment{'refundfee'}
                    && ( !$transaction_id
                    || $transaction_id =~ /^expired:/
                    || $setting::payment{'paypalrefundfee'} )
            ) ? $setting::payment{'refundfee'} : 0;
            my $refund_amount
                = $amount_paid - $total
                - ( $refunded   || 0 )
                - ( $refund_fee || 0 );
            $refund_amount = 0 if $refund_amount < 0;
            my $info_required = (
                ( $transaction_id && $transaction_id !~ /^expired:/ )
                    || ( $this->is_secure_user
                    && ref $newquantity
                    && %$newquantity )
            ) ? 0 : 1;
            $info
                .= '<dd class="sc-refund-info">&yen;'
                . $this->digit($amount_paid)
                . ( ($ptime) ? '(支払済)' : '' )
                . ' - &yen;'
                . $this->digit($total)
                . '(数量変更後総額)'
                . ( ($refunded)
                ? ' - &yen;' . $this->digit($refunded) . '(払戻済)'
                : '' )
                . ( ($refund_fee)
                ? ' - &yen;'
                    . $this->digit($refund_fee)
                    . '(払戻手数料)'
                : '' )
                . ' = <strong>&yen;'
                . $this->digit($refund_amount)
                . '</strong>('
                . ( ($ptime) ? '払戻額' : '差額' ) . ')';
            $info
                .= '<p class="warning">すべての注文をキャンセルします。</p>'
                if !$item_count;
            $info .= '</dd>';
            $info
                .= '<dt class="sc-refund">'
                . ( ($ptime) ? '払い戻し先' : '数量変更の申請' )
                . '</dt>'
                if $info_required;
            $info .= '<dd class="sc-refund-confirmation">';
            $info .= $this->form_start(
                'id'   => ( ($id) ? $id . '-form' : '' ),
                'name' => ( ($id) ? $id . '-form' : '' ),
                'method'   => 'post',
                'onsubmit' => 'return cmonos.form.item(this).submit(\''
                    . $id . '\');',
                'required' => [ @setting::form, 'newquantity' ]
                )
                . '<input type="hidden" name="id" value="'
                . $this->{'id'} . '" />'
                . ( ( !grep( $_ eq 'c', @setting::form ) )
                ? '<input type="hidden" name="c" value="' . $c . '" />'
                : '' )
                . ( ( !grep( $_ eq 'n', @setting::form ) )
                ? '<input type="hidden" name="n" value="' . $n . '" />'
                : '' );

            if ( !$info_required ) {
                $info
                    .= '<p><input type="submit" name="cancel:cancel=1" value="数量変更を取り消す" onclick="this.name=\'cancel:cancel=2\'" /> <input type="submit" name="cancel:ok=1" value="数量変更を'
                    . ( ( $expense || $this->is_secure_user )
                    ? '実行'
                    : '申請' )
                    . 'する" onclick="this.name=\'cancel:ok=2\'" /></p>';
            }
            else {
                if ( ( ref $newquantity && %$newquantity )
                    || ( $ptime
                        && ( !$bank || !$office || !$name || !$kana ) ) )
                {
                    $info .= $table->table;
                    if ($ptime) {
                        $info .= $table->tr;
                        $info .= $table->th(
                            '<label for="cancel:bank">銀行名</label>');
                        $info .= $table->td(
                            '<input type="text" size="36" id="cancel:bank" name="cancel:bank" value="'
                                . $this->escape(
                                (   ref $cancel_info
                                        && defined $cancel_info->{'bank'}
                                ) ? $cancel_info->{'bank'} : $bank
                                )
                                . '" title="払戻先銀行名" placeholder="払戻先銀行名"'
                                . (
                                ( $this->{'is_invalid_field'}{'bank'} )
                                ? $this->set_invalid_class
                                : ''
                                )
                                . ' onkeypress="return (event.keyCode == 13) ? false : true" />'
                        );
                        $info .= $table->_tr;
                        $info .= $table->tr;
                        $info .= $table->th(
                            '<label for="cancel:office">支店名</label>');
                        $info .= $table->td(
                            '<input type="text" size="36" id="cancel:office" name="cancel:office" value="'
                                . $this->escape(
                                (   ref $cancel_info
                                        && defined $cancel_info->{'office'}
                                ) ? $cancel_info->{'office'} : $office
                                )
                                . '" title="払戻先支店名" placeholder="払戻先支店名"'
                                . (
                                ( $this->{'is_invalid_field'}{'office'} )
                                ? $this->set_invalid_class
                                : ''
                                )
                                . ' onkeypress="return (event.keyCode == 13) ? false : true" />'
                        );
                        $info .= $table->_tr;
                        $info .= $table->tr;
                        $info
                            .= $table->th(
                            '<label for="cancel:number">口座番号</label>'
                            );
                        $info .= $table->td(
                            $this->mk_select_menu(
                                'cancel:deposit',
                                '', '',
                                (   (   ref $cancel_info
                                            && defined $cancel_info->{
                                            'deposit'}
                                    ) ? $cancel_info->{'deposit'} : '普通'
                                ),
                                '普通' => '普通',
                                '当座' => '当座',
                                )
                                . '<input type="text" size="24" id="cancel:number" name="cancel:number" value="'
                                . $this->escape(
                                (   ref $cancel_info
                                        && defined $cancel_info->{'number'}
                                ) ? $cancel_info->{'number'} : $number
                                )
                                . '" title="払戻先口座番号" placeholder="払戻先口座番号"'
                                . (
                                ( $this->{'is_invalid_field'}{'number'} )
                                ? $this->set_invalid_class
                                : ''
                                )
                                . ' onkeypress="return (event.keyCode == 13) ? false : true" />'
                        );
                        $info .= $table->_tr;
                        $info .= $table->tr;
                        $info .= $table->th(
                            '<label for="cancel:name">名義</label>');
                        $info .= $table->td(
                            '<input type="text" size="36" id="cancel:name" name="cancel:name" value="'
                                . $this->escape(
                                (   ref $cancel_info
                                        && defined $cancel_info->{'name'}
                                ) ? $cancel_info->{'name'} : $name
                                )
                                . '"'
                                . (
                                ( $this->{'is_invalid_field'}{'name'} )
                                ? $this->set_invalid_class
                                : ''
                                )
                                . ' onkeypress="return (event.keyCode == 13) ? false : true" />'
                        );
                        $info .= $table->_tr;
                        $info .= $table->tr;
                        $info
                            .= $table->th(
                            '<label for="cancel:kana">名義(カタカナ)</label>'
                            );
                        $info .= $table->td(
                            '<input type="text" size="36" id="cancel:kana" name="cancel:kana" value="'
                                . $this->escape(
                                (   ref $cancel_info
                                        && defined $cancel_info->{'kana'}
                                ) ? $cancel_info->{'kana'} : $kana
                                )
                                . '"'
                                . (
                                ( $this->{'is_invalid_field'}{'kana'} )
                                ? $this->set_invalid_class
                                : ''
                                )
                                . ' onkeypress="return (event.keyCode == 13) ? false : true" />'
                        );
                        $info .= $table->_tr;
                        $info .= $table->tr;
                    }
                    $info .= $table->th(
                        '<label for="cancel:comment">コメント</label>');
                    $info .= $table->td(
                        '<input type="text" size="36" id="cancel:comment" name="cancel:comment" value="'
                            . $this->escape(
                            (   ref $cancel_info
                                    && defined $cancel_info->{'comment'}
                            ) ? $cancel_info->{'comment'} : $comment
                            )
                            . '" onkeypress="return (event.keyCode == 13) ? false : true" />'
                    );
                    $info .= $table->_tr;
                    $info .= $table->_table;
                    $info
                        .= '<p><input type="submit" name="cancel:cancel=1" value="数量変更を取り消す" onclick="this.name=\'cancel:cancel=2\'" /> <input type="submit" name="cancel:ok=1" value="数量変更を申請する" onclick="this.name=\'cancel:ok=2\'" /></p>';
                }
                else {
                    if ( $ptime || $comment || $this->is_secure_user ) {
                        $info .= $table->table;
                        if ($ptime) {
                            $info .= $table->tr;
                            $info .= $table->th('銀行名');
                            $info .= $table->td( $this->escape($bank) );
                            $info .= $table->_tr;
                            $info .= $table->tr;
                            $info .= $table->th('支店名');
                            $info .= $table->td( $this->escape($office) );
                            $info .= $table->_tr;
                            $info .= $table->tr;
                            $info .= $table->th('口座番号');
                            $info .= $table->td( $this->escape($number) );
                            $info .= $table->_tr;
                            $info .= $table->tr;
                            $info .= $table->th('名義');
                            $info .= $table->td( $this->escape($name) );
                            $info .= $table->_tr;
                            $info .= $table->tr;
                            $info .= $table->th('名義(カタカナ)');
                            $info .= $table->td( $this->escape($kana) );
                            $info .= $table->_tr;
                        }
                        if ($comment) {
                            $info .= $table->tr;
                            $info .= $table->th('コメント');
                            $info .= $table->td( $this->escape($comment) );
                            $info .= $table->_tr;
                        }
                        if ( $this->is_secure_user ) {
                            $info .= $table->tr;
                            $info
                                .= $table->th(
                                '<label for="comment">払い戻しコメント</label>'
                                );
                            $info
                                .= $table->td(
                                '<input type="text" size="36" id="comment" name="comment" value="'
                                    . $this->escape($main::comment)
                                    . '" />' );
                            $info .= $table->_tr;
                        }
                        $info .= $table->_table;
                    }
                    $info
                        .= '<p><input type="submit" name="cancel:cancel=1" value="数量変更を取り消す" onclick="this.name=\'cancel:cancel=2\'" />';
                    $info
                        .= ' <input type="submit" name="cancel:ok=1" value="数量変更を実行する" onclick="this.name=\'cancel:ok=2\'" />'
                        if $this->is_secure_user;
                    $info .= '</p>';
                }
            }
            $info .= '</form></dd></dl>';
        }
        $info = '<div id="' . $id . '">' . $info . '</div>' if !$ajax;
    }
    return $info;
}

sub item_is_cancelable ($$$) {
    my ( $this, $item_data, $ptime ) = @_;
    if ( $item_data->{'digitalcontent'} && !$this->is_secure_user ) {
        return 0;
    }
    elsif (
          !$ptime
        || $this->is_secure_user
        || (  !$item_data->{'noshipping'}
            && $item_data->{'canceldeadline'}
            && $item_data->{'canceldeadline'} eq 'shipping'
            && !$item_data->{'shipped'} )
        )
    {
        return 1;
    }
    elsif ($item_data->{'canceltimelimit'}
        && $item_data->{'canceltimelimitunit'}
        && $item_data->{'db'} )
    {
        my $dt = $this->get_field_data_from_db( 'dt', $item_data->{'db'},
            $item_data->{'n'} );
        use Time::Local;
        if (   $dt
            && $dt
            =~ /^([0-9]{0,4})([0-9]{0,2})([0-9]{0,2})T?([0-9]{0,2})([0-9]{0,2})([0-9]{0,2})/
            )
        {
            my $start = ($1)
                ? timelocal(
                ( $6 || 0 ),
                ( $5 || 0 ),
                ( $4 || 0 ),
                ( $3 || 1 ),
                ( ($2) ? $2 - 1 : 0 ), $1
                )
                : 0;
            return 1
                if time < $start
                - (   $item_data->{'canceltimelimit'}
                    * $item_data->{'canceltimelimitunit'} );
        }
    }
    return 0;
}

sub get_field_data_from_db ($$$$) {
    my ( $this, $db, $c, $n ) = @_;
    my $path = ( $c =~ m!/! ) ? $c : $default::db . '/' . $c;
    my $data = '';
    if ( ref $cgi::action && ref $cgi::action->{'DB'} ) {
        if ( !ref tied %{ $cgi::action->{'DB'}{$c}{$db} } ) {
            tie( %{ $cgi::action->{'DB'}{$c}{$db} },
                $env::dbm_file, "$path/$db", O_RDONLY, $env::dbm_mode );
        }
        $data = $this->decode_utf8(
            $cgi::action->{'DB'}{$c}{$db}{ $this->encode_utf8($n) } );
    }
    else {
        my %db;
        tie( %db, $env::dbm_file, $path . '/' . $db,
            O_RDONLY, $env::dbm_mode );
        if ( ref tied %db ) {
            $data = $this->decode_utf8( $db{ $this->encode_utf8($n) } );
        }
        untie %db;
    }
    return $data;
}

sub get_tax ($$) {
    my ( $this, $amount ) = @_;
    if ( $env::tax_rate && $amount ) {
        return ( $env::tax_frac && $env::tax_frac eq 'ceil' )
            ? int( ( $amount * $env::tax_rate ) + 0.99999 )
            : ( $env::tax_frac && $env::tax_frac eq 'round' )
            ? int( ( $amount * $env::tax_rate ) + 0.5 )
            : int( $amount * $env::tax_rate );
    }
    else {
        return 0;
    }
}

sub add_tax ($$) {
    my ( $this, $amount ) = @_;
    return ($amount) ? $amount + $this->get_tax($amount) : 0;
}

sub order_carriage ($$$$$) {
    my ( $this, $total, $item_data, $weight_lacked, $papersize_lacked ) = @_;
    my $shipping
        = $this->get_field_data_from_db( 'shipping', $main::c, $main::n );
    $shipping = $1 if $shipping =~ /^(.*?)\x09/s;
    if ((   (      $setting::payment{'carriage'}
                && $setting::payment{'carriage'} eq 'weight'
            )
            || (   $setting::payment{'yuumail'}
                && $shipping
                && $shipping =~ /ゆうメール/ )
        )
        && !$weight_lacked
        )
    {
        return $this->carriage_by_weight($item_data);
    }
    elsif (
        (   (      $setting::payment{'carriage'}
                && $setting::payment{'carriage'} eq 'papersize'
            )
            || (   $setting::payment{'mailbin'}
                && $shipping
                && $shipping =~ /メール便/ )
        )
        && !$papersize_lacked
        )
    {
        return $this->carriage_by_papersize( $shipping, $item_data );
    }
    elsif ($setting::payment{'specialcarriage'}{'requirements'}
        && $total >= $setting::payment{'specialcarriage'}{'requirements'} )
    {
        return ( $setting::payment{'specialcarriage'}{'cost'} )
            ? $setting::payment{'specialcarriage'}{'cost'}
            : 0;
    }
    elsif ($setting::payment{'carriage'}
        && $setting::payment{'carriage'} eq 'nation' )
    {
        return ( $setting::payment{'nation'} )
            ? $setting::payment{'nation'}
            : 0;
    }
    else {
        require CMONOS::CGI_Lib::JPrefecture;
        $cgi::JPrefecture = JPrefecture->new;
        my $pref
            = $this->get_field_data_from_db(
            $field::obj{ $field::for{'shippingaddress'} }->db,
            $main::c, $main::n );
        $pref = $1 if $pref =~ /^(.*)$/m;
        return 0 if !$pref;
        my $pref_id = $cgi::JPrefecture->get_prefecture_id_by_name($pref);
        return 0 if !$pref_id;
        if (   $setting::payment{'carriage'}
            && $setting::payment{'carriage'} eq 'region' )
        {
            my $reg_id
                = $cgi::JPrefecture->get_region_id_by_prefecture_id($pref_id);
            return ( $setting::payment{'region'}{$reg_id} )
                ? $setting::payment{'region'}{$reg_id}
                : 0;
        }
        elsif ($setting::payment{'carriage'}
            && $setting::payment{'carriage'} eq 'prefecture' )
        {
            return ( $setting::payment{'pref'}{$pref_id} )
                ? $setting::payment{'pref'}{$pref_id}
                : 0;
        }
    }
    return 0;
}

sub carriage_by_weight ($$) {
    my ( $this, $item_data ) = @_;
    my ( $total_weight, $total_carriage, @weight_id, $last );
    $total_weight = $total_carriage = 0;
    @weight_id = sort { $a <=> $b } keys %{ $setting::payment{'weight'} };
    $last = $weight_id[$#weight_id];
    while ( my ( $id, $item ) = each %$item_data ) {
        $total_weight += $item->{'weight'} * $item->{'quantity'}
            if $item->{'weight'} && $item->{'quantity'};
    }
    $total_weight += $setting::payment{'packageweight'}
        if $setting::payment{'packageweight'};
    if (   $setting::payment{'weight'}{$last}{'weight'}
        && $total_weight > $setting::payment{'weight'}{$last}{'weight'} )
    {
        $total_carriage
            = $setting::payment{'weight'}{$last}{'carriage'} *
            int(
            $total_weight / $setting::payment{'weight'}{$last}{'weight'} );
        $total_weight
            = $total_weight % $setting::payment{'weight'}{$last}{'weight'};
    }
    return $total_carriage if !$total_weight;
    foreach my $id (@weight_id) {
        return $total_carriage
            + ( ( $setting::payment{'weight'}{$id}{'carriage'} )
            ? $setting::payment{'weight'}{$id}{'carriage'}
            : 0 )
            if $total_weight < $setting::payment{'weight'}{$id}{'weight'};
    }
    return $total_carriage;
}

sub carriage_by_papersize ($$$) {
    my ( $this, $service, $item_data ) = @_;
    my ( $total_carriage, $total_thickness, @a4, $max_thickness,
        $accessory_count, $is_express );
    $max_thickness = 20 - ( $setting::payment{'packagethickness'} || 0 );
    $total_thickness = $total_carriage = $accessory_count = 0;
    $is_express
        = (    $setting::payment{'papersize'}{'expressdelivery'}
            && $service
            && $service =~ /速達/ ) ? 1 : 0;
    while ( my ( $id, $item ) = each %$item_data ) {
        if ( $item->{'papersize'} ) {
            if ( $item->{'papersize'} eq 'ACCESSORY' ) {
                $accessory_count += $item->{'quantity'}
                    if $item->{'quantity'};
            }
            elsif ( $item->{'papersize'} =~ /^(?:A[4-6]|B[5-6])$/ ) {
                if (   $item->{'thickness'}
                    && $item->{'thickness'} > 0
                    && $item->{'thickness'} <= $max_thickness
                    && $item->{'quantity'} )
                {
                    for ( my $i = 0; $i < $item->{'quantity'}; $i++ ) {
                        push( @a4, $item->{'thickness'} );
                        $total_thickness += $item->{'thickness'};
                    }
                }
            }
        }
    }
    if ($total_thickness) {
        if ( $total_thickness <= $max_thickness ) {
            if ( $total_thickness <= $max_thickness - 10 ) {
                $total_carriage = $setting::payment{'papersize'}{'1A4'};
            }
            else {
                $total_carriage = $setting::payment{'papersize'}{'2A4'};
            }
            $total_carriage
                += $setting::payment{'papersize'}{'expressdelivery'}
                if $is_express;
        }
        else {
            $total_thickness = 0;
            @a4 = (@a4) ? sort { $b <=> $a } @a4 : ();
            while ( @a4 > 0 ) {
                my @temp = ();
                @temp = ();
                foreach my $t (@a4) {
                    if ( $total_thickness + $t <= $max_thickness ) {
                        $total_thickness += $t;
                    }
                    else {
                        push( @temp, $t );
                    }
                }
                @a4 = @temp;
                $total_carriage
                    += ( $total_thickness <= $max_thickness - 10 )
                    ? $setting::payment{'papersize'}{'1A4'}
                    : $setting::payment{'papersize'}{'2A4'};
                $total_carriage
                    += $setting::payment{'papersize'}{'expressdelivery'}
                    if $is_express;
                $total_thickness = 0;
            }
        }
    }
    if ($accessory_count) {
        if (   $setting::payment{'papersize'}{'accessory2'}
            && $setting::payment{'papersize'}{'accessory2'}
            < $accessory_count )
        {
            my $c = int( $accessory_count
                    / $setting::payment{'papersize'}{'accessory2'} );
            $total_carriage += (
                $setting::payment{'papersize'}{'2A4'} + (
                    ($is_express)
                    ? $setting::payment{'papersize'}{'expressdelivery'}
                    : 0
                )
                )
                * $c;
            $accessory_count
                -= $setting::payment{'papersize'}{'accessory2'} * $c;
        }
        if (   $setting::payment{'papersize'}{'accessory1'}
            && $setting::payment{'papersize'}{'accessory2'}
            && $accessory_count > $setting::payment{'papersize'}{'accessory1'}
            && $accessory_count
            <= $setting::payment{'papersize'}{'accessory2'} )
        {
            $total_carriage
                += $setting::payment{'papersize'}{'2A4'}
                + ( ($is_express)
                ? $setting::payment{'papersize'}{'expressdelivery'}
                : 0 );
        }
        else {
            if (   $setting::payment{'papersize'}{'accessory1'}
                && $setting::payment{'papersize'}{'accessory1'}
                < $accessory_count )
            {
                my $c = int( $accessory_count
                        / $setting::payment{'papersize'}{'accessory1'} );
                $total_carriage += (
                    $setting::payment{'papersize'}{'1A4'} + (
                        ($is_express)
                        ? $setting::payment{'papersize'}{'expressdelivery'}
                        : 0
                    )
                    )
                    * $c;
                $accessory_count
                    -= $setting::payment{'papersize'}{'accessory1'} * $c;
            }
            if ($accessory_count) {
                $total_carriage
                    += $setting::payment{'papersize'}{'1A4'}
                    + ( ($is_express)
                    ? $setting::payment{'papersize'}{'expressdelivery'}
                    : 0 );
            }
        }
    }
    return $total_carriage;
}

sub order_fee ($$$) {
    my ( $this, $type, $price ) = @_;
    my ($id);
    return 0 if !$type;
    $price = 0 if !$price;
    ( $type, $id ) = ( $type =~ /^(.*?):(.*)$/ ) ? ( $1, $2 ) : ( $type, '' );
    if ( $type eq 'cod' && $setting::payment{'codenabled'} ) {
        $price = $this->add_tax($price);
        return ( $price < 10000 )
            ? $setting::payment{'cod'}{'fee1'}
            : ( $price < 30000 )
            ? ( ( $setting::payment{'cod'}{'fee2'} ne '' )
            ? $setting::payment{'cod'}{'fee2'}
            : '1万円' )
            : ( $price < 100000 )
            ? ( ( $setting::payment{'cod'}{'fee3'} ne '' )
            ? $setting::payment{'cod'}{'fee3'}
            : '3万円' )
            : ( $price < 300000 )
            ? ( ( $setting::payment{'cod'}{'fee4'} ne '' )
            ? $setting::payment{'cod'}{'fee4'}
            : '10万円' )
            : '30万円';
    }
    elsif ( $type eq 'paypal' && $setting::payment{'paypalenabled'} ) {
        return 0;
    }
    elsif ($type eq 'other'
        && $setting::payment{'otherenabled'}
        && $id
        && defined $setting::payment{'other'}{$id}{'name'}
        && defined $setting::payment{'other'}{$id}{'name'} ne '' )
    {
        my $formula = $setting::payment{'other'}{$id}{'formula'};
        return 0 if !$formula;
        $formula =~ s/x/$price/g;
        my $frac = $setting::payment{'other'}{$id}{'frac'};
        my $fee  = eval $formula;
        return
              ( !$fee ) ? 0
            : ( $frac && $frac eq 'floor' ) ? int( $fee + 0.999 )
            : ( $frac && $frac eq 'round' ) ? int( $fee + 0.5 )
            :                                 int($fee);
    }
    return 0;
}

sub paypal_fee ($$;$) {
    my ( $this, $price, $noshipping_only ) = @_;
    my $ratio
        = ( $setting::payment{'paypal'}{'ratio'} )
        ? $setting::payment{'paypal'}{'ratio'} / 100
        : 0;
    my $fee
        = ( $setting::payment{'paypal'}{'fee'} )
        ? $setting::payment{'paypal'}{'fee'}
        : 0;
    my $order_fee = int( ( $price * $ratio + $fee ) + 0.5 );

#if ($setting::payment{'paypal'}{'incontext'} && ($noshipping_only || ($setting::payment{'paypal'}{'paymentaction'} && $setting::payment{'paypal'}{'paymentaction'} eq 'Sale'))) {
    if (   $setting::payment{'paypal'}{'incontext'}
        && $noshipping_only
        && $noshipping_only eq '2' )
    {
        my $mratio
            = ( $setting::payment{'paypal'}{'mratio'} )
            ? $setting::payment{'paypal'}{'mratio'} / 100
            : 0;
        my $mfee
            = ( $setting::payment{'paypal'}{'mfee'} )
            ? $setting::payment{'paypal'}{'mfee'}
            : 0;
        my $m_order_fee = int( ( $price * $mratio + $mfee ) + 0.5 );
        $order_fee = $m_order_fee if $m_order_fee < $order_fee;
    }
    return $order_fee;
}

######################################################################
#	(5) obj->print_setting_form;
sub print_setting_form ($;$$) {
    my $this = shift;
    my $name = 'data:' . $this->{'id'};
    $this->print_field_info_form($name);
    print '<fieldset><legend>注文内容の表示</legend>';
    print '<label><input type="checkbox" name="'
        . $name
        . '_compact" value="1"'
        . ( ( $this->{'compact'} ) ? 'checked="checked"' : '' )
        . ' /> コンパクトに表示する</label>';
    print '</fieldset>';

    print '<fieldset>';
    print '<legend>数量変更</legend>';
    print '<fieldset>';
    print '<legend><label for="' . $name
        . '_checkerLevel">常に数量変更権限のあるユーザー</label></legend>';
    print $this->mk_select_menu(
        $name . '_checkerLevel', '', '', $this->{'checkerLevel'},
        'master' => 'マスター',
        'owner'  => '管理人',
        'owners' => '共同オーナー',
        'staff'  => 'スタッフ',
        'member' => '登録メンバー'
    );
    print '</fieldset>';
    print '<fieldset>';
    print '<legend><label for="' . $name
        . '_authority">「登録メンバー」メールアドレス</label></legend>';
    print '<textarea name="'
        . $name
        . '_authority" id="'
        . $name
        . '_authority" cols="56" rows="5" wrap="off">'
        . $this->escape( $this->{'authority'} )
        . '</textarea>';
    print
        '<div class="note">登録メンバーが複数の時はカンマ（+改行）で区切ります。</div>';
    print '</fieldset>';

    print '<fieldset>';
    print '<legend>通知メール</legend>';
    print '<fieldset>';
    print '<legend><label for="' . $name
        . '_mailto">通知メール送信先</label></legend>';
    print '<select name="'
        . $name
        . '_mailto" id="'
        . $name
        . '_mailto" multiple="multiple">';
    print '<option value="staff"'
        . (
        (   ref $this->{'mailto'}
                && grep( $_ eq 'staff', @{ $this->{'mailto'} } )
        ) ? ' selected="selected"' : ''
        ) . '>数量変更権限のあるユーザー</option>';

    foreach my $id (
        sort {
            $this->{'field_obj'}->{$a}->{'ORDER'}
                <=> $this->{'field_obj'}->{$b}->{'ORDER'}
                || $a <=> $b
        } keys %{ $this->{'field_obj'} }
        )
    {
        if ( defined $this->{'field_obj'}{$id}->{'e-mail'}
            && $this->{'field_obj'}{$id}->{'e-mail'} )
        {
            print '<option value="'
                . $id . '"'
                . (
                (   ref $this->{'mailto'}
                        && grep( $_ eq $id, @{ $this->{'mailto'} } )
                ) ? ' selected="selected"' : ''
                )
                . '>'
                . $this->{'field_obj'}{$id}->name
                . '</option>';
        }
    }
    print '</select>';
    print
        '<div class="note">無選択の場合、通知機能は動作しません。</div></fieldset>';
    print '<fieldset>';
    print '<legend>数量変更通知メール</legend>';
    print '<fieldset>';
    print '<legend><label for="' . $name
        . '_subject">表題</label></legend>';
    print '<td class="field"><input type="text" name="'
        . $name
        . '_subject" id="'
        . $name
        . '_subject" size="70" value="'
        . $this->escape( $this->{'subject'} )
        . '" /></td>';
    print '</fieldset>';
    print '<fieldset>';
    print '<legend><label for="' . $name . '_msg">内容</label></legend>';
    print '<td class="field"><textarea name="'
        . $name
        . '_msg" id="'
        . $name
        . '_msg" cols="70" rows="10">'
        . $this->escape( $this->{'msg'} )
        . '</textarea>';
    print '<div class="toolbox">';
    print
        '<select class="tool" onchange="cmonos.form.item(this.form).fieldname(\''
        . $name
        . '_msg\').quotationByMenu(this)" title="これらのタグはメール送信時に対応する値に変換されます。">';
    print '<option value="">▼挿入する</option>';
    print '<option value="&lt;name&gt;">&lt;name&gt;[名前フィールド'
        . (
        (   $this->{'field_for'}{'name'}
                && ref $this->{'field_obj'}{ $this->{'field_for'}{'name'} }
        )
        ? '（'
            . $this->{'field_obj'}{ $this->{'field_for'}{'name'} }->name
            . '）'
        : ''
        ) . 'の値]</option>';
    print '<option value="&lt;key&gt;">&lt;key&gt;[キーフィールド'
        . (
        (   $this->{'field_for'}{'key'}
                && ref $this->{'field_obj'}{ $this->{'field_for'}{'key'} }
        )
        ? '（'
            . $this->{'field_obj'}{ $this->{'field_for'}{'key'} }->name
            . '）'
        : ''
        ) . 'の値]</option>';
    print
        '<option value="&lt;title&gt;">&lt;title&gt;[タイトルフィールド'
        . (
        (   $this->{'field_for'}{'title'}
                && ref $this->{'field_obj'}{ $this->{'field_for'}{'title'} }
        )
        ? '（'
            . $this->{'field_obj'}{ $this->{'field_for'}{'title'} }->name
            . '）'
        : ''
        ) . 'の値]</option>';
    print
        '<option value="&lt;info&gt;">&lt;info&gt;[キャンセル情報]</option>';
    print
        '<option value="&lt;data&gt;">&lt;data&gt;[データの一覧]</option>';
    print
        '<option value="&lt;url&gt;">&lt;url&gt;[データ一覧のURL]</option>';
    print
        '<option value="&lt;input&gt;">&lt;input&gt;[データ編集のURL]</option>';
    print
        '<option value="&lt;register&gt;">&lt;register&gt;[アドレス登録のURL]</option>';
    print '</select>';
    print '</div></fieldset>';
    print '</fieldset>';
    print '<fieldset>';
    print '<legend>数量変更取り消し通知メール</legend>';
    print '<fieldset>';
    print '<legend><label for="' . $name
        . '_cancelsubject">表題</label></legend>';
    print '<td class="field"><input type="text" name="'
        . $name
        . '_cancelsubject" id="'
        . $name
        . '_cancelsubject" size="70" value="'
        . $this->escape( $this->{'cancelsubject'} )
        . '" /></td>';
    print '</fieldset>';
    print '<fieldset>';
    print '<legend><label for="' . $name
        . '_cancelmsg">内容</label></legend>';
    print '<td class="field"><textarea name="'
        . $name
        . '_cancelmsg" id="'
        . $name
        . '_cancelmsg" cols="70" rows="10">'
        . $this->escape( $this->{'cancelmsg'} )
        . '</textarea>';
    print '<div class="toolbox">';
    print
        '<select class="tool" onchange="cmonos.form.item(this.form).fieldname(\''
        . $name
        . '_cancelmsg\').quotationByMenu(this)" title="これらのタグはメール送信時に対応する値に変換されます。">';
    print '<option value="">▼挿入する</option>';
    print '<option value="&lt;name&gt;">&lt;name&gt;[名前フィールド'
        . (
        (   $this->{'field_for'}{'name'}
                && ref $this->{'field_obj'}{ $this->{'field_for'}{'name'} }
        )
        ? '（'
            . $this->{'field_obj'}{ $this->{'field_for'}{'name'} }->name
            . '）'
        : ''
        ) . 'の値]</option>';
    print '<option value="&lt;key&gt;">&lt;key&gt;[キーフィールド'
        . (
        (   $this->{'field_for'}{'key'}
                && ref $this->{'field_obj'}{ $this->{'field_for'}{'key'} }
        )
        ? '（'
            . $this->{'field_obj'}{ $this->{'field_for'}{'key'} }->name
            . '）'
        : ''
        ) . 'の値]</option>';
    print
        '<option value="&lt;title&gt;">&lt;title&gt;[タイトルフィールド'
        . (
        (   $this->{'field_for'}{'title'}
                && ref $this->{'field_obj'}{ $this->{'field_for'}{'title'} }
        )
        ? '（'
            . $this->{'field_obj'}{ $this->{'field_for'}{'title'} }->name
            . '）'
        : ''
        ) . 'の値]</option>';
    print
        '<option value="&lt;comment&gt;">&lt;comment&gt;[コメント]</option>';
    print
        '<option value="&lt;data&gt;">&lt;data&gt;[データの一覧]</option>';
    print
        '<option value="&lt;url&gt;">&lt;url&gt;[データ一覧のURL]</option>';
    print
        '<option value="&lt;input&gt;">&lt;input&gt;[データ編集のURL]</option>';
    print
        '<option value="&lt;register&gt;">&lt;register&gt;[アドレス登録のURL]</option>';
    print '</select>';
    print '</div></fieldset>';
    print '</fieldset>';
    print '</fieldset>';

    $this->print_table_setting_form( $name, '', 'none' );
    $this->print_setting_save_button;
    return;
}

######################################################################
#	(6) obj->is_valid_setting;
sub is_valid_setting ($) {
    my $this = shift;
    $this->tag_fix( \$main::data{ $this->{'id'} . '_description' } )
        if defined $main::data{ $this->{'id'} . '_description' }
        && $main::data{ $this->{'id'} . '_description' };
    $this->tag_fix( \$main::data{ $this->{'id'} . '_note' } )
        if defined $main::data{ $this->{'id'} . '_note' }
        && $main::data{ $this->{'id'} . '_note' };
    $main::data{ $this->{'id'} . '_compact' } = 0
        if !$main::data{ $this->{'id'} . '_compact' };
    $main::data{ $this->{'id'} . '_authority' }
        = $this->z_to_h( $main::data{ $this->{'id'} . '_authority' }, 'utf8' )
        if defined $main::data{ $this->{'id'} . '_authority' }
        && $main::data{ $this->{'id'} . '_authority' };
    return 1;
}

######################################################################
#	(7) obj->search_form;
sub search_form ($) {
    my $this = shift;
    my ($form);
    $form
        = '<tr><td class="field-name"><label for="search:'
        . $this->{'id'}
        . ':str">'
        . $this->{'name'}
        . '</label></td><td class="field">';
    $form
        .= '<input type="text" size="30" name="search:'
        . $this->{'id'}
        . ':str" value="'
        . $this->escape( $main::search{ $this->{'id'} }{'str'} ) . '" /> ';

    #英語表記
    if ( defined $default::english && $default::english ) {
        $form .= $this->mk_select_menu(
            'search:' . $this->{'id'} . ':mode', '', '',
            $main::search{ $this->{'id'} }{'mode'},
            'and' => 'Matches on all words',
            'or'  => 'Matches on any word',
        );
        $form
            .= '<div class="extra-field"><label><input type="checkbox" name="search:'
            . $this->{'id'}
            . ':i" value="1"'
            . (
            (   defined $main::search{ $this->{'id'} }{'i'}
                    && $main::search{ $this->{'id'} }{'i'}
            ) ? ' checked="checked"' : ''
            ) . ' /> Do case-insensitive pattern matching.</label></div>';

        #日本語
    }
    else {
        $form .= $this->mk_select_menu(
            'search:' . $this->{'id'} . ':mode', '', '',
            $main::search{ $this->{'id'} }{'mode'},
            'and' => '全ての文字列を含む',
            'or'  => 'いずれかの文字列を含む',
        );
        $form
            .= '<div class="extra-field"><label><input type="checkbox" name="search:'
            . $this->{'id'}
            . ':i" value="1"'
            . (
            (   defined $main::search{ $this->{'id'} }{'i'}
                    && $main::search{ $this->{'id'} }{'i'}
            ) ? ' checked="checked"' : ''
            ) . ' /> 大文字と小文字を区別しない</label></div>';
    }
    $form .= '</td></tr>';
    return $form;
}

######################################################################
#	(8) obj->sort_enabled;
sub sample ($$) {
    my ( $this, $str ) = @_;
    return ( defined $str && $str =~ /^([0-9]+)/ ) ? $1 : '';
}

######################################################################
#	(9) obj->cookie_enabled;
sub cookie_enabled ($) {
    my $this = shift;
    return 0;
}

######################################################################
#	(10) obj->required_enabled;
sub required_enabled ($) {
    my $this = shift;
    return 0;
}

######################################################################
#	(11) obj->update;
sub update_enabled ($) {
    my $this = shift;
    return 1;
}

sub is_secure_user_for_update ($) {
    my $this = shift;
    return 1;
}

sub is_secure_user_for_edit ($) {
    my $this = shift;
    return 0;
}

sub _update_error ($$) {
    my ( $this, $is_ajax ) = @_;
    return ($is_ajax)
        ? {
        'status'           => 'error',
        'message'          => $this->get_message_string,
        'authorized_level' => $this->get_authorized_level
        }
        : 0;
}

sub update ($;$) {
    my ( $this, $is_ajax ) = @_;
    if ( @main::c && !defined $main::c ) {
        $main::c = $main::c[0];
    }
    undef @main::c;
    my $c = $main::c;
    my $n = $main::n;
    $this->save_update_target;
    delete $this->{'is_invalid_field'} if ref $this->{'is_invalid_field'};
    if (!$this->is_secure_user
        && !$this->user_included_in(
            [ $this->get_all_mail_field_data( $c, $n ) ]
        )
        )
    {
        push(
            @{ $cgi::action->{'dialog'} },
            $setting::general{'itemname'}
                . 'の数量を更新できませんでした。更新権限がありません。'
        );
        return $this->_update_error($is_ajax);
    }
    if ( $main::cancel{'cancel'} && $main::cancel{'ok'} ) {
        if ( $main::cancel{'cancel'} < $main::cancel{'ok'} ) {
            delete $main::cancel{'cancel'};
        }
        else {
            delete $main::cancel{'ok'};
        }
    }
    my (%db,   $data,   $amount_paid, $refunded,
        $bank, $office, $deposit,     $number,
        $name, $kana,   $comment
    );
    my $db         = $default::db . '/' . $main::c;
    my $refundable = 0;
    tie( %db, $env::dbm_file, $db . '/order', O_RDONLY, $env::dbm_mode );
    if ( ref tied %db ) {
        $data = $this->decode_utf8( $db{ $this->encode_utf8($n) } );
    }
    untie %db;
    my ($total,           $tax,            $fee,
        $carriage,        $carriage_total, $download_key,
        $ptime,           $transaction_id, $status,
        $noshipping_only, $expense,        $dc_included,
        $discount,        @general
    ) = ( $data =~ /^(.*?)\x0A/s ) ? split( /\x09/, $1 ) : ();
    if ( $this->is_secure_user || ( $expense && !$ptime ) || $transaction_id )
    {
        $refundable = 1;
    }
    elsif (%main::cancel
        && $ptime
        && defined $main::cancel{'bank'}
        && !$main::cancel{'cancel'} )
    {
        my $invalid = 0;
        if ( !$main::cancel{'bank'} ) {
            $invalid = $this->{'is_invalid_field'}{'bank'} = 1;
            push(
                @{ $cgi::action->{'dialog'} },
                '銀行名を入力してください。'
            ) if ref $cgi::action;
        }
        else {
            $main::cancel{'bank'} =~ s/[\x09\x0A\x0D]+/ /sg;
        }
        if ( !$main::cancel{'office'} ) {
            $invalid = $this->{'is_invalid_field'}{'office'} = 1;
            push(
                @{ $cgi::action->{'dialog'} },
                '支店名を入力してください。'
            ) if ref $cgi::action;
        }
        else {
            $main::cancel{'office'} =~ s/[\x09\x0A\x0D]+/ /sg;
        }
        if ( !$main::cancel{'name'} ) {
            $invalid = $this->{'is_invalid_field'}{'name'} = 1;
            push(
                @{ $cgi::action->{'dialog'} },
                '名義を入力してください。'
            ) if ref $cgi::action;
        }
        if (  !$main::cancel{'kana'}
            || $this->is_not_katakana( $main::cancel{'kana'}, 'utf8' ) )
        {
            $invalid = $this->{'is_invalid_field'}{'kana'} = 1;
            push(
                @{ $cgi::action->{'dialog'} },
                '名義(カタカナ)を入力してください。'
            ) if ref $cgi::action;
        }
        else {
            $main::cancel{'kana'} =~ s/[\x09\x0A\x0D]+/ /sg;
        }
        $main::cancel{'deposit'} = '普通'
            if !$main::cancel{'deposit'}
            || $main::cancel{'deposit'} ne '当座';
        if ( !$main::cancel{'number'} ) {
            $invalid = $this->{'is_invalid_field'}{'number'} = 1;
            push(
                @{ $cgi::action->{'dialog'} },
                '口座番号を入力してください。'
            ) if ref $cgi::action;
        }
        else {
            $main::cancel{'number'}
                = $this->z_to_h( $main::cancel{'number'}, 'utf8' );
            if (   $main::cancel{'number'}
                && $main::cancel{'number'} =~ /[^0-9\-]/ )
            {
                $invalid = $this->{'is_invalid_field'}{'number'} = 1;
                push(
                    @{ $cgi::action->{'dialog'} },
                    '口座番号を半角数字にしてください。'
                ) if ref $cgi::action;
            }
        }
        return $this->_update_error($is_ajax) if $invalid;
        $main::cancel{'comment'} =~ s/[\x09\x0A\x0D]+/ /gs;
        $main::cancel{'comment'} =~ s/[\x09\x0A\x0C\x0D\x20]+\Z//s;
    }
    my %item_data           = ();
    my $dc_only             = 1;
    my $noshipping_included = 0;
    my $weight_lacked       = 0;
    my $papersize_lacked    = 0;
    my $count               = -1;
    my $temp_total          = 0;
    my $discountable_total  = 0;
    my $limited_total       = 0;
    my $quantity_changed    = 0;
    my $all_clear           = 1;
    $noshipping_only = 1;

    while ( $data =~ /^(.*)$/mg ) {
        my $i = $1;
        next if !$i || $count++ < 0;
        if ( $i =~ /^cancel\x09(.*)\s*$/ ) {
            (   $amount_paid, $refunded, $bank,
                $office,      $deposit,  $number,
                $name,        $kana,     $comment
            ) = split( /\x09/, $1 );
            next;
        }
        my %item = ();
        $cgi::Session->read_data( \%item, $i );
        if ( $this->item_is_cancelable( \%item, $ptime ) ) {
            if (%main::newquantity) {
                if (   defined $main::newquantity{$count}
                    && $main::newquantity{$count} =~ /^[0-9]+$/
                    && $main::newquantity{$count} < $item{'quantity'} )
                {
                    $item{'oldquantity'} = $item{'quantity'};
                    $item{'quantity'}    = $main::newquantity{$count};
                    $item{'cancel'}
                        = $item{'oldquantity'} - $item{'quantity'};
                    $quantity_changed = 1;
                }
            }
            elsif ( defined $item{'newquantity'}
                && $item{'newquantity'} < $item{'quantity'} )
            {
                $item{'oldquantity'} = $item{'quantity'};
                $item{'quantity'}    = $item{'newquantity'};
                $item{'cancel'} = $item{'oldquantity'} - $item{'quantity'};
                $quantity_changed = 1;
            }
        }
        if ( $item{'quantity'} ) {
            my $price
                = ( ( $item{'optionprice'} )
                ? ( $item{'price'} + $item{'optionprice'} )
                : $item{'price'} )
                * ( $item{'quantity'} || 0 );
            $temp_total += $price;
            $discountable_total += $price
                if !$setting::payment{'discountlimited'}
                || $item{'discountable'};
            $limited_total += $price
                if !$setting::payment{'limitlimited'} || $item{'limited'};
            if ( $item{'digitalcontent'} ) {
                $noshipping_included = 1;
            }
            else {
                $dc_only = 0;
            }
            if ( $item{'digitalcontent'} || $item{'noshipping'} ) {
                $noshipping_included = 1;
            }
            else {
                $noshipping_only = 0;
            }
            $weight_lacked = 1
                if (!defined $item{'weight'} || $item{'weight'} eq '')
                && !$item{'digitalcontent'}
                && !$item{'noshipping'};
            $papersize_lacked = 1
                if ( !$item{'papersize'}
                || $item{'papersize'} !~ /^(?:A[4-6]|B[5-6]|ACCESSORY)$/
                || !$item{'thickness'}
                || $item{'thickness'}
                > ( 20 - ( $setting::payment{'packagethickness'} || 0 ) ) )
                && !$item{'digitalcontent'};
            $all_clear = 0;
        }
        $item_data{$count} = \%item;
    }
    $amount_paid = $total if !$amount_paid;
    if ( !$quantity_changed ) {
        push(
            @{ $cgi::action->{'dialog'} },
            $setting::general{'itemname'}
                . 'の数量が変更されていません。'
        );
        if ($is_ajax) {
            return {
                'status'  => 'success',
                'content' => $this->order_info(
                    $c, $n, $data, 'detail', 0, '', '', 1
                ),
                'message'          => $this->get_message_string,
                'authorized_level' => $this->get_authorized_level
            };
        }
        else {
            return 1;
        }
        return $this->_update_error($is_ajax);
    }
    if (   ( !$all_clear && !$setting::payment{'cancelnolimit'} )
        && ( $limited_total || !$setting::payment{'pricerequired'} )
        && ((      defined $setting::payment{'minimumamount'}
                && $setting::payment{'minimumamount'} ne ''
                && $setting::payment{'minimumamount'} > $limited_total
            )
            || (   defined $setting::payment{'maximumamount'}
                && $setting::payment{'maximumamount'} ne ''
                && $setting::payment{'maximumamount'} < $limited_total )
        )
        )
    {
        push(
            @{ $cgi::action->{'dialog'} },
            (   ( $setting::payment{'limiterrormsg'} )
                ? $this->escape_except_html_entity(
                    $setting::payment{'limiterrormsg'}
                    )
                : ( ( $setting::payment{'pricerequired'} )
                    ? '購入総額制限対象に指定された'
                        . $setting::general{'itemname'}
                        . 'の総額が'
                    : '購入総額が' )
                    . (
                    (   defined $setting::payment{'minimumamount'}
                            && $setting::payment{'minimumamount'} ne ''
                    ) ? $setting::payment{'minimumamount'} . '円以上' : ''
                    )
                    . (
                    (   defined $setting::payment{'maximumamount'}
                            && $setting::payment{'maximumamount'} ne ''
                    ) ? $setting::payment{'maximumamount'} . '円以下' : ''
                    )
                    . 'となるよう数量を変更してください。'
            )
        );
        return $this->_update_error($is_ajax);
    }
    if ( ref $setting::payment{'discount'}
        && %{ $setting::payment{'discount'} } )
    {
        $discount = 0;
        foreach my $n ( sort { $b <=> $a || $b cmp $a }
            keys %{ $setting::payment{'discount'} } )
        {
            if (   $n <= $discountable_total
                && $setting::payment{'discount'}{$n} )
            {
                $discount
                    = (    $setting::payment{'discount'}{$n} > 0
                        && $setting::payment{'discount'}{$n} < 100 )
                    ? $setting::payment{'discount'}{$n}
                    : 0;
                last;
            }
        }
        my $discount_ratio = 1 - ( $discount / 100 );
        $temp_total = 0;
        while ( my ( $id, $item ) = each %item_data ) {
            my $price
                = ( $item->{'optionprice'} )
                ? ( $item->{'price'} + $item->{'optionprice'} )
                : $item->{'price'};
            $price = int( ( $price || 0 ) * $discount_ratio )
                if $discount
                && ( !$setting::payment{'discountlimited'}
                || $item->{'discountable'} );
            $item->{'amount'} = $price;
            $temp_total += $price * ( $item->{'quantity'} || 0 );
        }
    }
    $total = $temp_total;
    if ($noshipping_only) {
        $noshipping_only = 1;
        $noshipping_only = 2 if $dc_only;
    }
    $carriage_total = $this->add_tax($total);
    if (   $noshipping_only
        || !$field::for{'payment_method'}
        || (   $setting::payment{'carriage'}
            && $setting::payment{'carriage'} eq 'disabled' )
        )
    {
        $carriage = 0;
    }
    else {
        $carriage = $this->order_carriage(
            $carriage_total, \%item_data,
            $weight_lacked,  $papersize_lacked
        );
        $total += $carriage;
    }
    if ($total) {
        if ($setting::payment{'codenabled'}
            && ($noshipping_only
                || (   $setting::payment{'cod'}{'dcUnavailable'}
                    && $noshipping_included )
            )
            && $this->get_field_data_from_db( 'payment', $main::c, $main::n )
            eq 'cod'
            )
        {
            $fee = 0;
        }
        else {
            $fee = $this->order_fee($total);
            if ( $fee && $fee =~ /[^0-9]/ ) {
                $fee = 0;
            }
            else {
                $total += $fee;
            }
        }
    }
    if ($env::tax_rate) {
        $tax = $this->get_tax($total);
        $total += $tax;
    }
    $expense = $this->paypal_fee( $total, $noshipping_only ) if $expense;
    if ( $ptime && $amount_paid < $total ) {
        push(
            @{ $cgi::action->{'dialog'} },
            '数量変更後の方が総額が高くなるため、数量変更できません。'
        );
        $main::cancel{'cancel'} = 1;
        delete $main::cancel{'ok'};
    }
    if (%main::newquantity) {
        if ( $main::cancel{'ok'} ) {
            if ( !$refundable ) {
                my $new_data = '';
                my $count    = -1;
                while ( $data =~ /^(.*)$/mg ) {
                    my $i = $1;
                    next if !$i;
                    $i =~ s/\x0A*$/\x0A/;
                    if ( $count++ < 0 ) {
                        $new_data .= $i;
                    }
                    else {
                        if ( $i =~ /^cancel\x09/ ) {
                            next;
                        }
                        else {
                            my %item = ();
                            $cgi::Session->read_data( \%item, $i );
                            delete $item{'newquantity'};
                            $item{'newquantity'} = $main::newquantity{$count}
                                if defined $main::newquantity{$count}
                                && $main::newquantity{$count} =~ /^[0-9]+$/
                                && $main::newquantity{$count}
                                < $item{'quantity'};
                            $new_data
                                .= $cgi::Session->data( '', '', \%item, 1 );
                        }
                    }
                }
                $new_data .= join( "\x09",
                    'cancel',
                    $amount_paid,
                    ( $refunded                || 0 ),
                    ( $main::cancel{'bank'}    || '' ),
                    ( $main::cancel{'office'}  || '' ),
                    ( $main::cancel{'deposit'} || '' ),
                    ( $main::cancel{'number'}  || '' ),
                    ( $main::cancel{'name'}    || '' ),
                    ( $main::cancel{'kana'}    || '' ),
                    ( $main::cancel{'comment'} || '' ) )
                    . "\x0A";
                tie(%db, $env::dbm_file,
                    $db . '/order',
                    O_RDWR | O_CREAT,
                    $env::dbm_mode
                );
                if ( ref tied %db ) {
                    $db{ $this->encode_utf8($n) }
                        = $this->encode_utf8($new_data);
                }
                untie(%db);
                my @addr = $this->get_manager_addr;
                if (@addr) {
                    unless ( ref $cgi::SendMail ) {
                        require CMONOS::CGI_Lib::SendMail;
                        $cgi::SendMail = SendMail->new( $env::sendmail,
                            $env::master_email, '', $cgi::input, 1 );
                    }
                    my $info = '';
                    $info .= '銀行:' . $main::cancel{'bank'} . "\x0A"
                        if $main::cancel{'bank'};
                    $info .= '支店:' . $main::cancel{'office'} . "\x0A"
                        if $main::cancel{'office'};
                    $info
                        .= '番号:' . '('
                        . $main::cancel{'deposit'} . ')'
                        . $main::cancel{'number'} . "\x0A"
                        if $main::cancel{'number'};
                    $info .= '名義:' . $main::cancel{'name'} . "\x0A"
                        if $main::cancel{'name'};
                    $info .= 'カナ:' . $main::cancel{'kana'} . "\x0A"
                        if $main::cancel{'kana'};
                    $info .= '備考:' . $main::cancel{'comment'} . "\x0A"
                        if $main::cancel{'comment'};
                    $cgi::SendMail->send_mail(
                        'Bcc'  => join( ',', @addr ),
                        'From' => (
                            ( ref $cgi::Register && $main::email )
                            ? $cgi::Register->name_and_email($main::email)
                            : ($main::email) ? $main::email
                            : ( ( $setting::general{'master'} )
                                ? ( ( $setting::general{'mastername'} )
                                    ? $setting::general{'mastername'} . ' <'
                                        . $setting::general{'master'} . '>'
                                    : $setting::general{'master'} )
                                : $env::master_email
                            )
                        ),
                        'Subject' =>
                            '数量変更が申請されました。',
                        'message' =>
                            '下記注文の数量変更が申請されました。'
                            . "\x0A"
                            . $this->permalink_of_detailview( $c, $n )
                            . "\x0A\x0A"
                            . $info
                            . "\x0A\x0A",
                        'info' => 1
                    );
                }
                if ($is_ajax) {
                    return {
                        'status'  => 'success',
                        'content' => $this->order_info(
                            $c, $n, $new_data, 'detail', 0, '', '', 1
                        ),
                        'message'          => $this->get_message_string,
                        'authorized_level' => $this->get_authorized_level
                    };
                }
                else {
                    return 1;
                }
            }
        }
        else {
            if ( $main::cancel{'cancel'} ) {
                undef %main::newquantity;
                undef %main::cancel;
            }
            if ($is_ajax) {
                return {
                    'status'  => 'success',
                    'content' => $this->order_info(
                        $c,
                        $n,
                        $data,
                        'detail',
                        0,
                        ( (%main::newquantity) ? \%main::newquantity : '' ),
                        ( (%main::cancel)      ? \%main::cancel      : '' ),
                        1
                    ),
                    'message'          => $this->get_message_string,
                    'authorized_level' => $this->get_authorized_level
                };
            }
            else {
                return 1;
            }
        }
    }
    my $refund_fee = (
               $ptime
            && $setting::payment{'refundfee'}
            && ( !$transaction_id
            || $transaction_id =~ /^expired:/
            || $setting::payment{'paypalrefundfee'} )
    ) ? $setting::payment{'refundfee'} : 0;
    my $refund_total = $amount_paid - $total;
    my $refund_amount
        = $refund_total - ( $refunded || 0 ) - ( $refund_fee || 0 );
    $refund_amount = 0 if $refund_amount < 0;
    my $refund_info = '';
    $refund_info .= '銀行:' . $bank . "\x0A"   if $bank;
    $refund_info .= '支店:' . $office . "\x0A" if $office;
    $refund_info .= '番号:' . '(' . $deposit . ')' . $number . "\x0A"
        if $number;
    $refund_info .= '名義:' . $name . "\x0A"    if $name;
    $refund_info .= 'カナ:' . $kana . "\x0A"    if $kana;
    $refund_info .= '備考:' . $comment . "\x0A" if $comment;
    $refund_info
        = ( ($ptime) ? '[払い戻し先]' : '[キャンセル]' ) . "\x0A"
        . $refund_info . "\x0A"
        if $refund_info;
    $refund_info
        .= ( ($ptime) ? '[払い戻し額]' : '[差額]' ) . "\x0A" . '￥'
        . $this->digit($amount_paid)
        . ( ($ptime) ? '(支払済)' : '' )
        . ' - ￥'
        . $this->digit($total)
        . '(数量変更後総額)'
        . ( ($refunded) ? ' - ￥' . $this->digit($refunded) . '(払戻済)'
        : '' )
        . ( ($refund_fee)
        ? ' - ￥' . $this->digit($refund_fee) . '(払戻手数料)'
        : '' )
        . ' = ￥'
        . $this->digit($refund_amount) . '('
        . ( ($ptime) ? '払戻額' : '差額' ) . ')' . "\x0A";

    if (   $ptime
        && $transaction_id
        && $refund_amount
        && $transaction_id !~ /^expired:/
        && $status ne 'Canceled' )
    {
        my $paypal = $this->use_paypal($is_ajax);
        my ( $ramount, $rtime )
            = $paypal->refund_transaction_request( $transaction_id,
            $refund_amount );
        if ($ramount) {
            push(
                @{ $cgi::action->{'dialog'} },
                'PayPal アカウントに、'
                    . $ramount
                    . '円払い戻しました。'
            );
            $refund_info
                .= '※PayPal アカウントに、'
                . $ramount
                . '円払い戻しました。' . "\x0A";
        }
        else {
            push( @{ $cgi::action->{'dialog'} }, $paypal->errors('all') );
            $main::cancel{'cancel'} = 1;
            delete $main::cancel{'ok'};
            if ( $data =~ /^(.*?)\x0A/s ) {
                my @info = split( /\x09/, $1 );
                $info[7] = 'expired:' . $info[7];
                my $info = join( "\x09", @info );
                $data =~ s/^.*?\x0A/$info\x0A/s;
                $refund_info
                    .= '※払い戻しに失敗しました。PayPal取引が期限切れとなっています。'
                    . "\x0A";
            }
        }
    }
    $refund_info .= "\x0A" . $main::comment . "\x0A" if $main::comment;

    if ( $main::cancel{'cancel'} ) {
        my $cancel_writed = 0;
        my $new_data      = '';
        my $count         = -1;
        while ( $data =~ /^(.*)$/mg ) {
            my $i = $1;
            next if !$i;
            $i =~ s/\x0A*$/\x0A/;
            if ( $count++ < 0 ) {
                $new_data .= $i;
            }
            else {
                if ( $i =~ /^cancel\x09/ ) {
                    next;
                }
                else {
                    my %item = ();
                    $cgi::Session->read_data( \%item, $i );
                    delete $item{'newquantity'};
                    $new_data .= $cgi::Session->data( '', '', \%item, 1 );
                }
            }
        }
        $new_data
            .= join( "\x09", 'cancel', $amount_paid, ( $refunded || 0 ) )
            . "\x0A"
            if $ptime;
        tie(%db, $env::dbm_file,
            $db . '/order',
            O_RDWR | O_CREAT,
            $env::dbm_mode
        );
        if ( ref tied %db ) {
            $db{ $this->encode_utf8($n) } = $this->encode_utf8($new_data);
        }
        untie(%db);
        if ( $this->is_secure_user ) {
            $this->send_info_mail(
                $c, $n,
                (   $this->{'cancelsubject'}
                        || '数量変更がキャンセルされました。'
                ),
                (   $this->{'cancelmsg'}
                        || '数量変更がキャンセルされました。'
                        . "\x0A" . '<url>'
                        . "\x0A\x0A"
                        . '<comment>'
                ),
                $refund_info
            );
        }
        else {
            my @addr = $this->get_manager_addr;
            if (@addr) {
                unless ( ref $cgi::SendMail ) {
                    require CMONOS::CGI_Lib::SendMail;
                    $cgi::SendMail
                        = SendMail->new( $env::sendmail, $env::master_email,
                        '', $cgi::input, 1 );
                }
                $cgi::SendMail->send_mail(
                    'Bcc'  => join( ',', @addr ),
                    'From' => (
                        ( ref $cgi::Register && $main::email )
                        ? $cgi::Register->name_and_email($main::email)
                        : ($main::email) ? $main::email
                        : ( ( $setting::general{'master'} )
                            ? ( ( $setting::general{'mastername'} )
                                ? $setting::general{'mastername'} . ' <'
                                    . $setting::general{'master'} . '>'
                                : $setting::general{'master'} )
                            : $env::master_email
                        )
                    ),
                    'Subject' =>
                        '数量変更がキャンセルされました。',
                    'message' =>
                        '下記注文の数量変更がキャンセルされました。'
                        . "\x0A"
                        . $this->permalink_of_detailview( $c, $n )
                        . "\x0A\x0A"
                        . $refund_info
                        . "\x0A\x0A",
                    'info' => 1
                );
            }
        }
        if ($is_ajax) {
            return {
                'status'  => 'success',
                'content' => $this->order_info(
                    $c, $n, $new_data, 'detail', 0, '', '', 1
                ),
                'message'          => $this->get_message_string,
                'authorized_level' => $this->get_authorized_level
            };
        }
        else {
            return 1;
        }
    }

    my $list = $this->list_for_mail( $c, $n, 1 );
    $refunded = ( $refunded || 0 ) + $refund_total;
    my $new_data = join( "\x09",
        $total,           $tax,            $fee,
        $carriage,        $carriage_total, $download_key,
        $ptime,           $transaction_id, $status,
        $noshipping_only, $expense,        $dc_included,
        $discount, ( @general || () ) )
        . "\x0A";
    foreach my $id ( sort { $a <=> $b || $a cmp $b } keys %item_data ) {
        my $old_quantity = $item_data{$id}{'oldquantity'};
        delete $item_data{$id}{'newquantity'};
        delete $item_data{$id}{'oldquantity'};
        delete $item_data{$id}{'cancel'};
        $new_data .= $cgi::Session->data( '', '', $item_data{$id}, 1 )
            if $item_data{$id}{'quantity'};
        if (   $old_quantity
            && $old_quantity > $item_data{$id}{'quantity'}
            && $item_data{$id}{'db'} )
        {
            my $gap = $old_quantity - $item_data{$id}{'quantity'};
            my (%db);
            my $no = $this->encode_utf8( $item_data{$id}{'n'} );
            tie( %db, $env::dbm_file, $item_data{$id}{'db'} . '/showcase',
                O_RDWR, $env::dbm_mode );
            if ( ref tied %db && $db{$no} ) {
                my $data = $this->decode_utf8( $db{$no} );
                $data =~ s/^stock\:([0-9]+)$/'stock:' . ($1 + $gap)/me;
                $db{$no} = $this->encode_utf8($data);
            }
            untie(%db);
            tie( %db, $env::dbm_file, $item_data{$id}{'db'} . '/sales',
                O_RDWR, $env::dbm_mode );
            if ( ref tied %db && $db{$no} ) {
                $db{$no} = $this->set_sales_data( $db{$no}, ( 0 - $gap ) );
            }
            untie(%db);
        }
    }
    $new_data
        .= join( "\x09", 'cancel', $amount_paid, ( $refunded || 0 ) ) . "\x0A"
        if $ptime;
    tie(%db, $env::dbm_file,
        $db . '/order',
        O_RDWR | O_CREAT,
        $env::dbm_mode
    );
    if ( ref tied %db ) {
        $db{ $this->encode_utf8($n) } = $this->encode_utf8($new_data);
    }
    untie(%db);
    tie(%db, $env::dbm_file,
        $db . '/price',
        O_RDWR | O_CREAT,
        $env::dbm_mode
    );
    if ( ref tied %db ) {
        $db{ $this->encode_utf8($n) } = $this->encode_utf8($total);
    }
    untie(%db);

    undef %main::newquantity;
    undef %main::cancel;

    #通知メール
    if ( !$this->is_secure_user ) {
        my @addr = $this->get_manager_addr;
        if (@addr) {
            unless ( ref $cgi::SendMail ) {
                require CMONOS::CGI_Lib::SendMail;
                $cgi::SendMail
                    = SendMail->new( $env::sendmail, $env::master_email, '',
                    $cgi::input, 1 );
            }
            $cgi::SendMail->send_mail(
                'Bcc'  => join( ',', @addr ),
                'From' => (
                    ( ref $cgi::Register && $main::email )
                    ? $cgi::Register->name_and_email($main::email)
                    : ($main::email) ? $main::email
                    : ( ( $setting::general{'master'} )
                        ? ( ( $setting::general{'mastername'} )
                            ? $setting::general{'mastername'} . ' <'
                                . $setting::general{'master'} . '>'
                            : $setting::general{'master'} )
                        : $env::master_email
                    )
                ),
                'Subject' => (
                    ($all_clear)
                    ? '注文がキャンセルされました。'
                    : '数量を変更しました。'
                ),
                'message' =>
                    '下記注文の数量が変更されました。'
                    . "\x0A"
                    . $this->permalink_of_detailview( $c, $n )
                    . "\x0A\x0A"
                    . $refund_info
                    . "\x0A\x0A",
                'info' => 1
            );
        }
    }
    $this->send_info_mail(
        $c, $n,
        ( $this->{'subject'} || '数量を変更しました。' )
            . (
            ($all_clear)
            ? '(全' . $setting::general{'itemname'} . 'キャンセル)'
            : ''
            ),
        (   $this->{'msg'}
                || '数量を変更しました。' . "\x0A" . '<url>'
                . "\x0A\x0A"
                . '<info>'
        ),
        $refund_info,
        $list
    );

    $this->post_update;
    if ($is_ajax) {
        return {
            'status'  => 'success',
            'content' => $this->order_info(
                $c, $n, $new_data, 'detail', 0, '', '', 1
            ),
            'message'          => $this->get_message_string,
            'authorized_level' => $this->get_authorized_level
        };
    }
    else {
        return 0;
    }
}

sub get_all_mail_field_data ($$$) {
    my ( $this, $c, $n ) = @_;
    my @addr;
    while ( my ( $id, $field ) = each %{ $this->{'field_obj'} } ) {
        if ( ref $field && $field->{'class'} =~ /email/ ) {
            my (%mail);
            tie( %mail, $env::dbm_file,
                $default::db . '/' . $c . '/' . $field->db,
                O_RDONLY, $env::dbm_mode );
            if ( ref tied %mail ) {
                push( @addr,
                    $this->decode_utf8( $mail{ $this->encode_utf8($n) } ) )
                    if $mail{ $this->encode_utf8($n) };
            }
            untie %mail;
        }
    }
    return $this->get_address(@addr);
}

sub set_sales_data ($$$) {
    my ( $this, $data, $quantity ) = @_;
    return $data if !$quantity;
    my ( $point, $daily, $total, $ctime, $recommend );
    ( $point, $daily, $total, $ctime ) = split( /\t/, $data, 4 );
    $point = 0 if !$point;
    $daily = 0 if !$daily;
    $daily = $total = 0 if !$total;
    $ctime = time if !$ctime;
    $recommend = ( $point == 999999 ) ? 1 : 0;
    $total += $quantity;
    $daily
        = ($total)
        ? int(
        ( ( $total / int( ( ( time - $ctime ) / 86400 ) + 1 ) ) * 1000000 )
        + 0.5 ) / 1000000
        : 0;
    return
          ( ($recommend) ? 999999 : $daily ) . "\x09"
        . $daily . "\x09"
        . $total . "\x09"
        . $ctime;
}

sub get_manager_addr ($) {
    my $this = shift;
    my (@addr);
    push( @addr, $env::master_email );
    push( @addr, $setting::general{'master'} )
        if $setting::general{'master'}
        && $this->{'checkerLevel'}
        && ( $this->{'checkerLevel'} eq 'owner'
        || $this->{'checkerLevel'} eq 'owners'
        || $this->{'checkerLevel'} eq 'staff'
        || $this->{'checkerLevel'} eq 'member' );
    push( @addr, $setting::general{'owners'} )
        if $setting::general{'owners'}
        && $this->{'checkerLevel'}
        && ( $this->{'checkerLevel'} eq 'owners'
        || $this->{'checkerLevel'} eq 'staff'
        || $this->{'checkerLevel'} eq 'member' );
    push( @addr, $setting::general{'staff'} )
        if $setting::general{'staff'}
        && $this->{'checkerLevel'}
        && ( $this->{'checkerLevel'} eq 'staff'
        || $this->{'checkerLevel'} eq 'member' );
    push( @addr, $this->{'authority'} )
        if $this->{'authority'}
        && $this->{'checkerLevel'}
        && $this->{'checkerLevel'} eq 'member';
    return $this->get_address(@addr);
}

sub send_info_mail ($$$$$;$$) {
    my ( $this, $c, $n, $subject, $msg, $info, $list ) = @_;
    if ( ref $this->{'mailto'} && @{ $this->{'mailto'} } ) {
        my (@mailto);
        foreach my $m ( @{ $this->{'mailto'} } ) {
            if ( $m eq 'staff' ) {
                push( @mailto, $this->get_manager_addr );
            }
            else {
                my (%mail);
                tie( %mail, $env::dbm_file,
                    $default::db . '/' . $c . '/' . $m,
                    O_RDONLY, $env::dbm_mode );
                push( @mailto,
                    $this->get_address( $mail{ $this->encode_utf8($n) } ) )
                    if defined $mail{ $this->encode_utf8($n) }
                    && $mail{ $this->encode_utf8($n) };
                untie(%mail);
            }
        }
        if (@mailto) {
            my ( $name, $bcc, $register_url, $script_name, $url, $input,
                $date );
            $info = '' if !defined $info;
            $subject =~ s/<info>//igs;
            $msg =~ s/<info>/$info/igs;
            $subject =~ s/<comment>/$info/igs;
            $msg =~ s/<comment>/$info/igs;
            $date = $this->date( time, 0,
                ( $setting::general{'datetype'} || '' ) . 'gmt>d' );
            $msg =~ s/<date>/$date/igs;

            if ( $subject =~ /<name>/i || $msg =~ /<name>/i ) {
                $name = ($default::english) ? 'you' : 'あなた';
                if ( defined $this->{'field_for'}{'name'}
                    && $this->{'field_for'}{'name'} )
                {
                    my (%name);
                    tie(%name,
                        $env::dbm_file,
                        $default::db . '/'
                            . $c . '/'
                            . $this->{'field_obj'}
                            { $this->{'field_for'}{'name'} }->db,
                        O_RDONLY,
                        $env::dbm_mode
                    );
                    $name
                        = $this->decode_utf8(
                        $name{ $this->encode_utf8($n) } )
                        if defined $name{ $this->encode_utf8($n) }
                        && $name{ $this->encode_utf8($n) } ne '';
                    untie(%name);
                }
                $subject =~ s/<name>/$name/igs;
                $msg =~ s/<name>/$name/igs;
            }
            if ( $subject =~ /<key>/i || $msg =~ /<key>/i ) {
                my $key = ($default::english) ? 'this' : 'これ';
                if ( defined $this->{'field_for'}{'key'}
                    && $this->{'field_for'}{'key'} )
                {
                    my (%key);
                    tie(%key,
                        $env::dbm_file,
                        $default::db . '/'
                            . $c . '/'
                            . $this->{'field_obj'}
                            { $this->{'field_for'}{'key'} }->db,
                        O_RDONLY,
                        $env::dbm_mode
                    );
                    $key
                        = $this->decode_utf8( $key{ $this->encode_utf8($n) } )
                        if defined $key{ $this->encode_utf8($n) }
                        && $key{ $this->encode_utf8($n) } ne '';
                    untie(%key);
                }
                $subject =~ s/<key>/$key/igs;
                $msg =~ s/<key>/$key/igs;
            }
            if ( $subject =~ /<title>/i || $msg =~ /<title>/i ) {
                my $title = ($default::english) ? 'this' : 'これ';
                if ( defined $this->{'field_for'}{'title'}
                    && $this->{'field_for'}{'title'} )
                {
                    my (%title);
                    tie(%title,
                        $env::dbm_file,
                        $default::db . '/'
                            . $c . '/'
                            . $this->{'field_obj'}
                            { $this->{'field_for'}{'title'} }->db,
                        O_RDONLY,
                        $env::dbm_mode
                    );
                    $title
                        = $this->decode_utf8(
                        $title{ $this->encode_utf8($n) } )
                        if defined $title{ $this->encode_utf8($n) }
                        && $title{ $this->encode_utf8($n) } ne '';
                    untie(%title);
                }
                $subject =~ s/<title>/$title/igs;
                $msg =~ s/<title>/$title/igs;
            }
            if ( $msg =~ /<data>/i ) {
                $list = $this->list_for_mail( $c, $n ) if !defined $list;
                $msg =~ s/<data>/$list/igs;
            }
            $script_name = $this->my_url;
            $url = $this->permalink_of_detailview( $c, $n );
            $msg =~ s/<url>/$url/igs;
            $input = $script_name . '?m=Input&c=' . $c . '&n=' . $n;
            $msg =~ s/<input>/$input/igs;
            $register_url = $this->http_my_domain
                . $this->path_change( $env::register_cgi,
                $ENV{'SCRIPT_NAME'}, 'abs' );
            $msg =~ s/<register>/$register_url/igs;

            unless ( ref $cgi::SendMail ) {
                require CMONOS::CGI_Lib::SendMail;
                $cgi::SendMail
                    = SendMail->new( $env::sendmail, $env::master_email, '',
                    $cgi::input, 1 );
            }
            foreach (@mailto) {
                $bcc .= ',' if defined $bcc && $bcc ne '';
                $bcc
                    .= ( $name && $name ne 'you' && $name ne 'あなた' )
                    ? $name . ' <' . $_ . '>'
                    : $_;
            }
            $cgi::SendMail->send_mail(
                'Bcc'  => $bcc,
                'From' => (
                    ( $setting::general{'master'} )
                    ? ( ( $setting::general{'mastername'} )
                        ? $setting::general{'mastername'} . ' <'
                            . $setting::general{'master'} . '>'
                        : $setting::general{'master'} )
                    : $env::master_email
                ),
                'Subject' => $subject,
                'message' => $msg . "\x0A\x0A",
                'info'    => 0
            );
        }
    }
}

sub list_for_mail ($$$) {
    my ( $this, $c, $n, $changed ) = @_;
    my $file_dir = "$default::file/$c/$n";
    my $list     = '';
    local $setting::quantity_changed = ($changed) ? 1 : 0;
    foreach my $id (
        sort {
            $this->{'field_obj'}->{$a}->{'ORDER'}
                <=> $this->{'field_obj'}->{$b}->{'ORDER'}
                || $a <=> $b
        } keys %{ $this->{'field_obj'} }
        )
    {
        next if !$this->{'field_obj'}{$id}->format_for_mail_enabled;
        my (%data);
        tie( %data, $env::dbm_file,
            $default::db . '/' . $c . '/' . $this->{'field_obj'}{$id}->db,
            O_RDONLY, $env::dbm_mode );
        $list
            .= $this->{'field_obj'}{$id}->format_for_mail(
            $this->decode_utf8( $data{ $this->encode_utf8($n) } ),
            $file_dir, $c, $n );
        untie(%data);
    }
    return $list;
}

sub editor_enabled ($) {
    my $this = shift;
    return 0;
}

sub use_paypal ($;$) {
    my ( $this, $is_ajax ) = @_;
    $this->import_db( $default::preference_dir . '/terms',
        \%setting::payment, 1 )
        if !%setting::payment;
    require CMONOS::TableMaker::CheckOutAPI::PayPal;
    return PayPal->new(
        $setting::payment{'paypal'}{'username'},
        $setting::payment{'paypal'}{'password'},
        $setting::payment{'paypal'}{'signature'},
        'JPY',
        $setting::payment{'paypal'}{'sandbox'},
        $is_ajax,
    );
}

sub user_included_in ($$$) {
    my ( $this, $user_addr ) = @_;
    return (
               defined $main::email
            && $main::email
            && @$user_addr
            && grep( defined $_ && $_ eq $main::email, @$user_addr )
            && (
            $security::registered
            || (   $this->use_register
                && $cgi::Register->is_registered( $main::pswd, $main::email )
            )
            )
    ) ? 1 : 0;
}

######################################################################
#	CMONOS::CGI_Lib::UserGeneratedField からのコピー
sub get_invalid_field_list ($$) {
    my ( $this, $prefix ) = @_;
    return ''
        if !defined $this->{'is_invalid_field'}
        || !ref $this->{'is_invalid_field'};
    my @invalid_fields
        = map { $prefix . ':' . $_ } keys %{ $this->{'is_invalid_field'} };
    delete $this->{'is_invalid_field'};
    return (@invalid_fields) ? join( ';', @invalid_fields ) : '';
}

sub get_message_string ($) {
    my $this = shift;
    if ( ref $cgi::action ) {
        my @message = $cgi::action->dialog;
        if (@message) {
            map {
                $_ =~ s/\\n//g;
                $_ =~ s/;//g;
            } @message;
            return join( ';', @message );
        }
    }
    return '';
}

sub get_authorized_level ($) {
    my $this = shift;
    if ( $this->is_master ) {
        return 5;
    }
    elsif ( $this->is_owner ) {
        return 4;
    }
    elsif ( $this->is_one_of_owners ) {
        return 3;
    }
    elsif ( $this->is_staff ) {
        return 2;
    }
    elsif ( $this->is_registered_user ) {
        return 1;
    }
    else {
        return 0;
    }
}

######################################################################
#sub import {
BEGIN {
    no warnings qw(once);
    if (   defined $default::type
        && $default::type eq 'order'
        && defined $env::checkout
        && $env::checkout
        && !$setting::field_for_mail )
    {
        Field::class_register( 'yorder_info', 'SCOrderInfo', '注文内容' );
        push( @field::redundancy_forbidden, 'yorder_info' );
    }
}

1;
