package VCardExporter;
require CMONOS::CGI_Lib::Field;
@ISA = qw(Field);
use strict;
use utf8;
######################################################################
# フィールド定義モジュール（vCardダウンロード）
# VCardExporter.pm 1.0.2
# Copyright (C) 1999-2018 CMONOS Co. Ltd.
#
# support@cmonos.jp
# http://cmonos.jp/
# 最終更新日：2010-06-14
######################################################################
sub _set ($$) {
    my $this = shift;
    return;
}

######################################################################
#	(0)-3 フィールドDB
sub db ($) {
    my $this = shift;
    return 'mtime';
}

######################################################################
#	(2) obj->input_enabled;
sub input_enabled ($) {
    my $this = shift;
    return 0;
}

sub form {
    my $this = shift;
    return '';
}

######################################################################
#	(1)-0 obj->match_enabled;
sub match_enabled ($) {
    my $this = shift;
    return 0;
}

#	(1) obj->match(str);
sub match ($;$) {
    my $this = shift;
    return 1;
}

######################################################################
#	(3) obj->is_valid_data(path);
sub is_valid_data ($;$) {
    my $this = shift;
    delete $main::data{ $this->{'id'} }{'str'};
    return 1;
}

######################################################################
#	(4) obj->usual_format(str,path,category,no);
#	str=表示するデータ/path=ファイル保存ディレクトリ
sub usual_format {
    my ( $this, $str, $path, $c, $n ) = @_;
    return $this->field_tag( $this->vcard_download_form( $c, $n ) );
}

sub has_content {
    my $this = shift;
    return 1;
}

sub vcard_download_form ($$$) {
    my ( $this, $c, $n ) = @_;
    my $form
        = ( ( defined $this->{'description'} ) ? $this->{'description'} : '' )
        . $this->form_start(
        'key' => (
            ( defined $setting::security_key ) ? $setting::security_key : ''
        ),
        'name' => 'vcard-' . $c . '-' . $n,
        'path' => '/vcard-' . $c . '-' . $n . '.vcf',
        );
    my $title
        = ( defined $default::english && $default::english )
        ? ''
        : ' title="ダウンロード後、適切な名前(list.vcf 等)をつけて保存してください。"';
    my $ver2_flag = 0;
    if (( defined $this->{'ver'} && $this->{'ver'} eq '2.1' )
        || ((      !defined $this->{'ver'}
                || $this->{'ver'} eq 'auto'
                || $this->{'ver'} eq ''
            )
            && defined $ENV{'HTTP_USER_AGENT'}
            && $ENV{'HTTP_USER_AGENT'} =~ /win/i
        )
        )
    {
        $form .= '<input type="hidden" name="m" value="VCard2Viewer" />';
        $form .= '<input type="hidden" name="k" value="vcard2" />';
        $ver2_flag = 1;
    }
    else {
        $form .= '<input type="hidden" name="m" value="VCardViewer" />';
        $form .= '<input type="hidden" name="k" value="vcard" />';
    }
    $form .= '<input type="hidden" name="c" value="' . $c . '" />';
    $form .= '<input type="hidden" name="n" value="' . $n . '" />';
    $form
        .= '<input type="hidden" name="id" value="' . $this->{'id'} . '" />';
    if ( defined $this->{'icon'} && $this->{'icon'} ) {
        if ($ver2_flag) {
            $form
                .= '<input type="image" src="'
                . $env::icon_dir
                . '/vcf2.png"'
                . $title
                . ' alt="vCard2.1" />';
        }
        else {
            $form
                .= '<input type="image" src="'
                . $env::icon_dir
                . '/vcf.png"'
                . $title
                . ' alt="vCard" />';
        }
    }
    else {
        $form .= '<input type="submit" value="vCard"' . $title . ' />';
    }
    $form .= '</form>';
    $form .= $this->{'note'} if defined $this->{'note'};
    return $form;
}

#---------------------------------------------------------------------
#	(4) obj->format_for_mail(str);
sub format_for_mail_enabled ($) {
    my $this = shift;
    return 0;
}

sub format_for_mail {
    my $this = shift;
    return '';
}

#---------------------------------------------------------------------
#	(4)-3 obj->format_for_detail(str);
sub format_for_detail {
    my ( $this, $str, $path, $c, $n ) = @_;
    return $this->field_tag( $this->vcard_download_form( $c, $n ) );
}

#---------------------------------------------------------------------
#	(4)-4 obj->format_for_text(str);
sub format_for_text_enabled ($) {
    my $this = shift;
    return 0;
}

sub format_for_text {
    my ( $this, $str, $path, $n, $db ) = @_;
    return '';
}

#---------------------------------------------------------------------
#	(4)-5 obj->confirmation(str);
sub confirmation_enabled ($) {
    my $this = shift;
    return 1;
}

sub confirmation ($$) {
    my ( $this, $str ) = @_;
    return '';
}

######################################################################
#	(5) obj->print_setting_form;
sub print_setting_form ($;$$) {
    my $this = shift;

    #名前
    my $name = 'data:' . $this->{'id'};

    $this->print_field_info_form( $name, 1 );
    print '<fieldset>';
    print '<legend>表示設定</legend>';
    print '<ol class="checkbox">';
    print '<li><label><input type="checkbox" name="'
        . $name
        . '_icon" value="1"'
        . ( ( defined $this->{'icon'} && $this->{'icon'} )
        ? ' checked="checked"'
        : '' )
        . ' /> ダウンロードボタンに vcf アイコンを使う</label></li>';
    print '</ol>';
    print '<ol class="checkbox">';
    print '<li><label><input type="radio" name="'
        . $name
        . '_ver" value="3.0"'
        . ( ( defined $this->{'ver'} && $this->{'ver'} eq '3.0' )
        ? ' checked="checked"'
        : '' )
        . ' /> 常にバージョン 3.0 形式で書き出す</label></li>';
    print '<li><label><input type="radio" name="'
        . $name
        . '_ver" value="2.1"'
        . ( ( defined $this->{'ver'} && $this->{'ver'} eq '2.1' )
        ? ' checked="checked"'
        : '' )
        . ' /> 常にバージョン 2.1 形式(Shift JIS/CR+LF)で書き出す</label></li>';
    print '<li><label><input type="radio" name="'
        . $name
        . '_ver" value="auto"'
        . (
        (          !defined $this->{'ver'}
                || $this->{'ver'} eq 'auto'
                || $this->{'ver'} eq ''
        ) ? ' checked="checked"' : ''
        )
        . ' /> Windows にのみバージョン 2.1 形式で書き出す</label></li>';
    print '</ol>';
    print '</fieldset>';
    $this->print_setting_save_button;
    return;
}

######################################################################
#	(6) obj->is_valid_setting;
sub is_valid_setting ($) {
    my $this = shift;
    $main::data{ $this->{'id'} . '_icon' } = 0
        if !defined $main::data{ $this->{'id'} . '_icon' }
        || !$main::data{ $this->{'id'} . '_icon' };
    $main::data{ $this->{'id'} . '_ver' } = ''
        if !defined $main::data{ $this->{'id'} . '_ver' }
        || !$main::data{ $this->{'id'} . '_ver' };
    $this->tag_fix( \$main::data{ $this->{'id'} . '_description' } )
        if defined $main::data{ $this->{'id'} . '_description' }
        && $main::data{ $this->{'id'} . '_description' };
    $this->tag_fix( \$main::data{ $this->{'id'} . '_note' } )
        if defined $main::data{ $this->{'id'} . '_note' }
        && $main::data{ $this->{'id'} . '_note' };
    if ( !-f $env::icon_dir . '/vcf.png' ) {
        push(
            @{ $cgi::action->{'dialog'} },
            'vcf アイコンがみつかりません。'
        ) if ref $cgi::action;
        $main::data{ $this->{'id'} . '_icon' } = 0;
    }
    if ( !-f $env::icon_dir . '/vcf2.png' ) {
        push(
            @{ $cgi::action->{'dialog'} },
            'vcf アイコンがみつかりません。'
        ) if ref $cgi::action;
        $main::data{ $this->{'id'} . '_icon' } = 0;
    }
    return 1;
}

######################################################################
#	(7) obj->search_form;
sub search_form_enabled ($) {
    my $this = shift;
    return 0;
}

sub search_form ($) {
    my $this = shift;
    return '';
}

######################################################################
#	(8) obj->sort_enabled;
sub sort_enabled ($) {
    my $this = shift;
    return 0;
}

######################################################################
#	(9) obj->cookie_enabled;
sub cookie_enabled ($) {
    my $this = shift;
    return 0;
}

######################################################################
#	(10) obj->required_enabled;
sub required_enabled ($) {
    my $this = shift;
    return 0;
}

######################################################################
#	(11) obj->update;
sub update_enabled ($) {
    my $this = shift;
    return 1;
}

sub is_secure_user_for_update ($) {
    my $this = shift;
    return 1;
}

sub update ($;$) {
    my $this = shift;
    foreach my $id (
        sort {
            $this->{'field_obj'}->{$a}->{'ORDER'}
                <=> $this->{'field_obj'}->{$b}->{'ORDER'}
                || $a <=> $b
        } keys %{ $this->{'field_obj'} }
        )
    {
        next
            unless ref $this->{'field_obj'}{$id}
            && !$this->{'field_obj'}{$id}->{'Hidden'}
            && ( $this->{'field_obj'}{$id}->{'Open'}
            || $this->is_secure('secret') );
        next if grep( $_ eq $id, @{ $cgi::action->{'required_fields'} } );
        push( @{ $cgi::action->{'required_fields'} }, $id );
    }
    $cgi::action->print_viewer_header;
    $cgi::action->print_contents_header;
    $cgi::action->print_record( $main::c, $main::n );

    #DBM接続解除
    my ( $db_c, $db_id );
    while ( ($db_c) = each %{ $cgi::action->{'DB'} } ) {
        while ( ($db_id) = each %{ $cgi::action->{'DB'}{$db_c} } ) {
            untie( %{ $cgi::action->{'DB'}{$db_c}{$db_id} } );
        }
    }
    exit;
}

######################################################################
#sub import {
BEGIN {
    if ( !$setting::field_for_mail ) {
        Field::class_register( 'xtm_vcard', 'VCardExporter',
            'vCard ダウンロード' );
    }
}

1;
