package Input;
require CMONOS::TableMaker::InputBase;
@ISA = qw(InputBase);
use strict;
use utf8;
######################################################################
# データ入力モジュール
# Input.pm ver1.3.4
# Copyright (C) 1999-2018 CMONOS Co. Ltd.
#
# support@cmonos.jp
# http://cmonos.jp/
# 最終更新日：2014-04-10
######################################################################
sub update ($) {
    my $this = shift;
    my ( $input_is_valid, $input_only_user );
    use Fcntl qw(:DEFAULT);
    eval 'use ' . $env::dbm_file . ';';

    #レコード番号確認
    if ( defined $main::n && $main::n =~ /^[0-9]+$/ ) {
        my (%mtime);
        tie( %mtime, $env::dbm_file, "$default::db/$main::c/mtime", O_RDONLY,
            $env::dbm_mode );
        $main::n = ''
            unless ref tied %mtime && $mtime{ $this->encode_utf8($main::n) };
        untie(%mtime);
    }
    else {
        $main::n = '';
    }

    #データ入力パスワードチェック
    if ( $setting::security_key eq 'revise' && $main::n eq '' ) {
        $setting::security_key = 'input';
        $this->unauthorized_alert
            if !$this->is_secure( $setting::security_key, 1 );
    }

    #リンク元
    $this->query_optimize;
    $this->{'referer_url'} = $this->referer_url;

    #カテゴリー移動
    if (   defined $main::n
        && $main::n ne ''
        && ( !$default::type || $default::type ne 'order' )
        && $this->is_secure('input')
        && ($main::copy
            || (   defined $main::moveto
                && $main::moveto ne ''
                && $main::c ne $main::moveto
                && ref $setting::category{$main::moveto} )
        )
        )
    {
        $main::moveto = $main::c
            if !defined $main::moveto
            || $main::moveto eq ''
            || !ref $setting::category{$main::moveto};
        ( $main::c, $main::n )
            = $this->record_move_to( $main::moveto, $main::c, $main::n,
            $main::copy );
    }

    #読み込み
    $main::a = '' if $main::delete || !%main::data;
    $this->dbm if !$main::a && $main::n ne '';
    if (   $field::NAMECHECK
        && $field::for{'name'}
        && !defined $main::data{ $field::for{'name'} }{'str'}
        && $this->use_register )
    {
        $main::data{ $field::for{'name'} }{'str'}
            = $cgi::Register->email_to_name( $main::pswd, $main::email,
            $security::registered );
    }

#既にメールアドレスに対応するレコードがあるかチェック
    if (   $setting::general{'oneEmailToOneRecord'}
        && $field::for{'mail'}
        && !$this->is_invalid_email_address(
            $main::data{ $field::for{'mail'} }{'str'}
        )
        )
    {
        my ( %email_to_id, $email_data, $record_id, $old_record_id );
        tie( %email_to_id, $env::dbm_file, $default::db . '/email_to_id',
            O_RDONLY, $env::dbm_mode );
        $record_id
            = ( !defined $main::n || $main::n eq '' )
            ? ''
            : $this->permanent_id( $main::c, $main::n );
        $email_data
            = $this->encode_utf8( $main::data{ $field::for{'mail'} }{'str'} );
        if ( ref tied %email_to_id ) {
            if ( defined $email_to_id{$email_data}
                && $email_to_id{$email_data} ne $record_id )
            {
                $old_record_id = $email_to_id{$email_data};
            }
        }
        untie %email_to_id;
        if ($old_record_id) {
            my ( %email, $old_email, $old_c, $old_n );
            ( $old_c, $old_n )
                = $this->get_category_and_number_from_permanent_id(
                $old_record_id);
            tie(%email,
                $env::dbm_file,
                $default::db . '/'
                    . $old_c . '/'
                    . $field::obj{ $field::for{'mail'} }->db,
                O_RDONLY,
                $env::dbm_mode
            );
            if (   !ref tied %email
                || !$email{ $this->encode_utf8($old_n) }
                || $email{ $this->encode_utf8($old_n) } ne $email_data )
            {
                undef $old_record_id;
            }
            untie(%email);
            if ( !$old_record_id ) {
                tie( %email_to_id, $env::dbm_file,
                    $default::db . '/email_to_id',
                    O_RDWR, $env::dbm_mode );
                delete $email_to_id{$email_data} if ref tied %email_to_id;
                untie %email_to_id;
            }
        }
        if ($old_record_id) {
            if ($this->use_register
                && $cgi::Register->exist(
                    $main::data{ $field::for{'mail'} }{'str'}
                )
                )
            {
                ( $main::c, $main::n )
                    = $this->get_category_and_number_from_permanent_id(
                    $old_record_id);
                $this->print_page_header('input');
                print $this->form_start(
                    'key'      => $setting::key,
                    'name'     => 'input',
                    'method'   => 'post',
                    'required' => \@setting::form
                );
                print
                    '<p>このメールアドレスは既に登録されています。 <input type="submit" value="OK" class="save" /></p>';
                print '</form>';
                $this->print_contents_footer;
                $this->print_page_footer('input');
                exit;
            }
            else {
                $this->delete_record(
                    $this->get_category_and_number_from_permanent_id(
                        $old_record_id),
                    1
                );
            }
        }
    }

    #データ修正パスワードチェック
    $input_only_user = $this->is_input_only_user;

    #データ削除
    if (   $main::delete
        && $main::n ne ''
        && !$input_only_user
        && $this->is_secure( 'delete', 0, 'revise' )
        && (  !$default::type
            || $default::type ne 'order'
            || $this->is_secure('tools') )
        )
    {
        $this->delete_record( $main::c, $main::n, 1 );
        my %general;
        my $time = time;
        tie(%general, $env::dbm_file,
            $default::preference_dir . '/general',
            O_RDWR | O_CREAT,
            $env::dbm_mode
        );
        if ( ref tied %general ) {
            $general{'mtime'}  = $this->encode_utf8($time);
        }
        untie %general;
        $setting::general{'mtime'} = $time;
        if ($main::ajax) {
            $this->print_response( { 'status' => 'success' } );
            exit;
        }

        #ページヘッダ
        $this->set_onload( 'cmonos.window.refreshOpener(\''
                . $this->escape( $this->{'referer_url'} )
                . '\',false)' )
            if !$setting::page{'sameWindowNewDataButton'};
        $this->print_page_header('input');
        print '<p>削除しました。</p>';
        $this->print_contents_footer;
        $this->print_page_footer('input');
        exit;

    }
    elsif ( defined $main::delete && $main::delete ) {
        if (   $input_only_user
            || !$this->is_secure( 'delete', 0, 'revise' )
            || (   $default::type
                && $default::type eq 'order'
                && !$this->is_secure('tools') )
            )
        {
            push(
                @{ $this->{'dialog'} },
                '削除に失敗しました。削除権限がありません。'
            );
        }
        elsif ( !$input_only_user ) {
            push(
                @{ $this->{'dialog'} },
                '削除に失敗しました。対象レコードが指定されていません。'
            );
        }
        if ($main::ajax) {
            $this->print_response(
                {   'status'  => 'error',
                    'message' => join( '', @{ $this->{'dialog'} } )
                }
            );
            exit;
        }

        #入力のチェック
    }
    elsif ( $main::a eq 'w' ) {
        if ( $field::for{'mail'} ) {
            $field::obj{ $field::for{'mail'} }->{'required'} = 1
                if $setting::general{'oneEmailToOneRecord'};
            $field::obj{ $field::for{'mail'} }->{'single'} = 1
                if $setting::general{'oneEmailToOneRecord'}
                || $setting::general{'autoRegister'}
                || $setting::general{'syncRegister'};
        }

        $input_is_valid = $this->input_is_valid;

        #EMAILチェック
        if (( !defined $main::n || $main::n eq '' )
            && ( !defined $setting::security{'revise'}{'passwordCheck'}
                || $setting::security{'revise'}{'passwordCheck'} ne
                'nocheck' )
            && $this->is_secure('revise')
            && $this->is_registered_email
            && !$this->is_secure_email
            && $this->email_field_enabled
            )
        {
            push(
                @{ $this->{'dialog'} },
                '登録メールアドレスがみつかりません。'
            );
            if ( $field::for{'mail'}
                && ref $field::obj{ $field::for{'mail'} } )
            {
                $main::data{ $field::for{'mail'} }{'str'} = $main::email;
                $field::obj{ $field::for{'mail'} }
                    ->{'is_invalid_field'}{'str'} = 1;
            }
            $input_is_valid = 0;
        }

        #登録の移行
        if ( $this->use_register
            && (   $main::shift_flag
                || $setting::general{'oneEmailToOneRecord'} )
            && $this->{'old_pswd'}
            && $this->{'old_email'} )
        {
            if ($input_is_valid) {
                if (   $setting::general{'oneEmailToOneRecord'}
                    && $field::for{'mail'}
                    && $main::data{ $field::for{'mail'} }{'str'} )
                {
                    my (%email_to_id);
                    tie(%email_to_id, $env::dbm_file,
                        $default::db . '/email_to_id',
                        O_RDWR | O_CREAT,
                        $env::dbm_mode
                    );
                    if ( ref tied %email_to_id ) {
                        delete $email_to_id{ $this->encode_utf8(
                                $this->{'old_email'} ) }
                            if $cgi::Register->is_registered(
                            $this->{'old_pswd'}, $this->{'old_email'} );
                        $email_to_id{
                            $this->encode_utf8(
                                $main::data{ $field::for{'mail'} }{'str'}
                            )
                        } = $this->permanent_id( $main::c, $main::n );
                    }
                    untie %email_to_id;
                }
                if (   $field::for{'mail'}
                    && $main::data{ $field::for{'mail'} }{'str'} )
                {
                    if ($cgi::Register->move(
                            ( $this->{'old_pswd'}, $this->{'old_email'} ) => (
                                $main::pswd,
                                $main::data{ $field::for{'mail'} }{'str'}
                            ),
                            $this->{'move_enabled'}
                        )
                        )
                    {
                        $cgi::Register->success_dialog;
                        push(
                            @{ $this->{'dialog'} },
                            'これまで登録されていたメールアドレス（'
                                . $this->{'old_email'}
                                . '）を抹消しました。'
                        );
                    }
                    else {
                        push(
                            @{ $this->{'dialog'} },
                            $cgi::Register->error_dialog
                        );
                        push(
                            @{ $this->{'dialog'} },
                            'これまで登録されていたメールアドレス（'
                                . $this->{'old_email'}
                                . '）の抹消に失敗しました。'
                        );
                    }
                }
                elsif (
                    $cgi::Register->remove(
                        $this->{'old_pswd'}, $this->{'old_email'}
                    )
                    )
                {
                    push(
                        @{ $this->{'dialog'} },
                        'これまで登録されていたメールアドレス（'
                            . $this->{'old_email'}
                            . '）を抹消しました。'
                    );
                    $cgi::Register->success_dialog;
                }
            }
            else {
                push( @setting::form, 'shift_flag', 'old_pswd', 'old_email' );
            }
        }

        #名前チェック
        if (   $field::NAMECHECK
            && $field::for{'name'}
            && defined $main::data{ $field::for{'name'} }{'str'}
            && $main::data{ $field::for{'name'} }{'str'} ne '' )
        {
            if ($input_is_valid) {
                my ( $name, $fontcolor );
                $name = $main::data{ $field::for{'name'} }{'str'};
                $fontcolor = $1 if $name =~ s/<>([#0-9a-zA-z]{3,10})\Z//s;
                if (   defined $name
                    && $name ne ''
                    && !$this->is_same_name_and_email( $main::n, $name ) )
                {
                    if ((      !defined $main::n
                            || $main::n eq ''
                            || $this->is_secure_email
                        )
                        && $cgi::Register->is_available_name(
                            $main::pswd, $main::email,
                            $name,       $security::registered
                        )
                        )
                    {
                        push(
                            @{ $this->{'dialog'} },
                            $cgi::Register->success_dialog
                        );
                    }
                    else {
                        my @msg = $cgi::Register->error_dialog;
                        push(
                            @{ $this->{'dialog'} },
                            (   (@msg)
                                ? @msg
                                : '認証に必要なメールアドレスが変更されました。'
                            )
                        );
                        $main::data{ $field::for{'name'} }{'str'}
                            = $name
                            . ( ( defined $fontcolor && $fontcolor ne '' )
                            ? '<>' . $fontcolor
                            : '' );
                        if ( !$this->{'old_email'} ) {
                            push(
                                @{ $this->{'dialog'} },
                                'この入力は確定していません。'
                            );
                            $input_is_valid = 0;
                        }
                    }
                }
            }
        }

        #入力エラー or キャンセル
        if ( !$input_is_valid || $main::cancel ) {

            #確認画面
        }
        elsif ( $main::n eq '' ) {
            if (  !$setting::general{'skipConfirmation'}
                && $input_only_user
                && !$cgi::confirmation_disabled
                && !$cgi::ssl_required
                && !$main::ok )
            {
                $this->print_page_header('input');
                print '<p id="form-confirmation">'
                    . ( ($default::english)
                    ? 'Confirmation.'
                    : '下記内容に問題がなければ「保存」ボタンを押してください。'
                    ) . '</p>';
                $this->print_confirmation_table(1);
                $this->print_contents_footer;
                $this->print_page_footer('input');
                exit;

                #新規登録
            }
            else {

                #メールアドレス自動登録
                if (   $setting::general{'autoRegister'}
                    && $field::for{'mail'}
                    && $main::data{ $field::for{'mail'} }{'str'}
                    && $this->use_register
                    && !$cgi::Register->exist(
                        $main::data{ $field::for{'mail'} }{'str'}
                    )
                    )
                {
                    if ($cgi::Register->register(
                            $main::data{ $field::for{'mail'} }{'str'}
                        )
                        )
                    {
                        push(
                            @{ $this->{'dialog'} },
                            $cgi::Register->success_dialog
                        );
                    }
                    else {
                        push(
                            @{ $this->{'dialog'} },
                            $cgi::Register->error_dialog
                        );
                        $input_is_valid = 0;
                    }
                }

                if ($input_is_valid) {
                    $main::n = $this->new_record_number(1);
                    $this->{'new_data'} = 1;
                }
            }
        }

        #カウント
    }
    elsif ( $main::n eq '' ) {
        $this->new_record_number;

    }

    #書き込み/新規入力の告知
    if ( $input_is_valid && ( !$input_only_user || $this->{'new_data'} ) ) {
        $this->dbm;
        if (   $setting::general{'oneEmailToOneRecord'}
            && $field::for{'mail'}
            && $main::data{ $field::for{'mail'} }{'str'} )
        {
            my (%email_to_id);
            tie(%email_to_id, $env::dbm_file,
                $default::db . '/email_to_id',
                O_RDWR | O_CREAT,
                $env::dbm_mode
            );
            if ( ref tied %email_to_id ) {
                $email_to_id{
                    $this->encode_utf8(
                        $main::data{ $field::for{'mail'} }{'str'}
                    )
                } = $this->permanent_id( $main::c, $main::n );
            }
            untie %email_to_id;
        }
        $this->notice_mail_for_master(
            'データが入力されました。',
            'データが入力されました。',
            \%field::obj,
            ( ( $setting::general{'data'} ) ? \%main::data : '' )
        ) if $this->{'new_record'};
        $this->write_category_list;
        $this->{'is_written'} = 1;
    }
    elsif ( !$input_only_user ) {
        $this->dbm(1);
    }

    #データ修正パスワードチェック
    if ( $main::n ne '' && $input_only_user ) {

        #新規入力
        if ( defined $this->{'new_data'} && $this->{'new_data'} ) {
            $this->set_onload( 'cmonos.window.refreshOpener(\''
                    . $this->escape( $this->{'referer_url'} )
                    . '\',false)' )
                if !$setting::page{'sameWindowNewDataButton'};
            $this->thanks;

            #特殊なケース
        }
        elsif ( $input_only_user ne '1' ) {
            $this->print_dialog( $setting::key, $input_only_user );

            #パスワードチェック
        }
        elsif ( $main::a && $main::a eq 'w' ) {
            $this->print_password_check_form(
                'input',
                (   ( $this->{'user_address'} ) ? $this->{'user_address'}
                    : 'none'
                ),
                (   ( $this->{'need_new_pswd'} ) ? $this->{'need_new_pswd'}
                    : 0
                ),
                '',
                $setting::general{'oneEmailToOneRecord'}
            );
            return;
        }
        else {
            $this->print_password_check_form('input');
            return;
        }
    }

    #ページヘッダ
    $this->import_db( $default::preference_dir . '/category',
        \%setting::category, 1 )
        if !%setting::category;
    $this->push_window_title( $setting::category{$main::c}{'name'} )
        if keys %{ $setting::category{'ORDER'} } > 1
        && defined $setting::category{$main::c}{'name'}
        && $setting::category{$main::c}{'name'} ne '';
    $this->set_onload( 'cmonos.window.refreshOpener(\''
            . $this->escape( $this->{'referer_url'} )
            . '\',false)' )
        if !$setting::page{'sameWindowNewDataButton'}
        && $input_is_valid
        && !$main::cancel;
}

sub has_opener ($) {
    my $this = shift;
    return ( $setting::page{'sameWindowNewDataButton'} ) ? 0 : 1;
}

sub push_optional_title ($$) {
    my ( $this, $title_path ) = @_;
    $this->import_db( $default::preference_dir . '/category',
        \%setting::category, 1 )
        if !%setting::category;
    if (   ref $setting::category{'ORDER'}
        && keys %{ $setting::category{'ORDER'} } > 1
        && ref $setting::category{$main::c}
        && defined $setting::category{$main::c}{'name'}
        && $setting::category{$main::c}{'name'} ne '' )
    {
        push( @$title_path, $setting::category{$main::c}{'name'} );
    }
    return 1;
}

sub push_optional_topicpath ($$) {
    my ( $this, $topicpath_pair ) = @_;
    $this->import_db( $default::preference_dir . '/category',
        \%setting::category, 1 )
        if !%setting::category;
    if (   ref $setting::category{'ORDER'}
        && keys %{ $setting::category{'ORDER'} } > 1
        && ref $setting::category{$main::c}
        && defined $setting::category{$main::c}{'name'}
        && $setting::category{$main::c}{'name'} ne '' )
    {
        push( @$topicpath_pair,
                  './start.cgi?'
                . ( ($main::mod) ? 'm=' . $main::mod . '&' : '' ) . 'c='
                . $main::c => $setting::category{$main::c}{'name'} );
    }
    return 1;
}

sub print_contents_header ($) {
    my $this = shift;
    my ($header_neighbor_link);
    if (  !$main::delete
        && $main::n ne ''
        && (   $setting::page{$setting::key}{'headerNeighborLink'}
            || $setting::page{$setting::key}{'footerNeighborLink'} )
        )
    {
        my ( $prev_record, $next_record ) = $this->get_neighbor_record;
        if ( $prev_record || $next_record ) {
            $header_neighbor_link
                = $this->get_neighbor_link( $prev_record, $next_record )
                if defined $setting::page{$setting::key}{'headerNeighborLink'}
                && $setting::page{$setting::key}{'headerNeighborLink'};
            $this->{'footer_neighbor_link'}
                = $this->get_neighbor_link( $prev_record, $next_record,
                $this->{'referer_url'} )
                if defined $setting::page{$setting::key}{'footerNeighborLink'}
                && $setting::page{$setting::key}{'footerNeighborLink'};
        }
    }
    $this->print_page_header($setting::key);
    print $header_neighbor_link if $header_neighbor_link;
}

sub print_submit_button_in_table ($) {
    my $this       = shift;
    my $div_opened = 0;
    print '<tbody><tr class="tbody-start">';
    print '<td class="submit-box" colspan="2">';
    if ( defined $main::n && $main::n ne '' ) {
        print '<div id="submit-button">';
        print
            '<label title="このレコードを別のレコードとして保存します。"><input type="checkbox" name="copy" value="1" />コピー</label> '
            if ( !$default::type || $default::type ne 'order' )
            && $this->is_secure('input')
            && !$setting::general{'oneEmailToOneRecord'};
        $div_opened = 1;
    }
    print
        '<label title="同じ内容を入力することが多いいくつかの項目を記憶します。"><input type="checkbox" name="set_cookie" value="1"'
        . ( ( $cookie::read{$cookie::name} || $main::set_cookie )
        ? ' checked="checked"'
        : '' )
        . ' />情報を記憶する</label> '
        if defined $this->{'cookie_enabled'} && $this->{'cookie_enabled'};
    print
        '<input type="submit" name="submit_button" value="保存" class="save" />';
    print '</div>' if $div_opened;
    print
        '<div id="delete-button"><input type="submit" name="delete=1" value="削除" onclick="return confirm(\'この操作は取り消せません。本当に削除しますか？\')" /></div>'
        if defined $main::n
        && $main::n ne ''
        && $this->is_secure( 'delete', 0, 'revise' )
        && ( !$default::type
        || $default::type ne 'order'
        || $this->is_secure('tools') );
    print '</td></tr></tbody>';
}

sub print_submit_button ($) {
    my $this = shift;
    if (   defined $main::n
        && $main::n ne ''
        && ( !$default::type || $default::type ne 'order' )
        && $this->is_secure('input')
        && keys %{ $setting::category{'ORDER'} } > 1 )
    {
        my $menu = '';
        foreach
            my $o ( sort { $a <=> $b } keys %{ $setting::category{'ORDER'} } )
        {
            my $c = $setting::category{'ORDER'}{$o};
            if (   $c ne $main::c
                && ref $setting::category{$c}
                && (  !$setting::category{$c}{'total'}
                    || $setting::category{$c}{'total'}
                    < $setting::category{'LIMIT'} )
                )
            {
                $menu
                    .= '<option value="'
                    . $c . '">'
                    . $setting::category{$c}{'name'} . ' ('
                    . ( $setting::category{$c}{'count'} || 0 )
                    . ')</option>';
            }
        }
        if ($menu) {
            print
                '<fieldset id="renamer" class="risky">このレコードを';
            print '<select name="moveto" id="moveto">';
            print '<option value=""></option>';
            print $menu;
            print '</select>に<input type="submit" value="移動する" />';
            print '</fieldset>';
        }
    }
    my $archives_dir = "$default::file/$main::c/$main::n/archives.pending";
    if ( !$setting::general{'rewindable'} ) {
        if ( -d $archives_dir ) {
            use File::Path;
            rmtree $archives_dir;
        }
    }
    elsif ( $this->is_secure('rewind') ) {
        if ( opendir( DIR, $archives_dir ) ) {
            my @dir
                = sort { $this->sort_by( \$a, \$b, 'descend' ) }
                grep( $_ !~ /[^0-9]/ && -d $archives_dir . '/' . $_,
                readdir(DIR) );
            shift @dir;
            if (@dir) {
                print '</form>';
                print $this->form_start(
                    'key'      => $setting::key,
                    'id'       => 'rewind-form',
                    'name'     => 'rewind-form',
                    'method'   => 'post',
                    'onsubmit' => 'return cmonos.tool.isRewindable()',
                    'required' => \@setting::form
                );
                print '<fieldset class="risky">';
                print
                    '<select name="rewind" id="rewind" onchange="cmonos.tool.openPreviewWindow()">';
                print '<option value="">▼以前のデータ'
                    . ( ( $main::email || $this->is_secure('tools') )
                    ? ' [編集者]'
                    : '' )
                    . '</option>';
                foreach my $d (@dir) {
                    my $user = '';
                    if ( $main::email || $this->is_secure('tools') ) {
                        my ( $ip, $ua, $email, $name ) = split(
                            /\x0A/,
                            $this->read_file(
                                $archives_dir . '/' . $d . '/data/author', 1
                            )
                        );
                        if ($email
                            && ( ( $main::email && $email eq $main::email )
                                || $this->is_secure('tools') )
                            )
                        {
                            $user
                                = $cgi::Register->get_name_from_email($email);
                            $user .= ($user) ? '<' . $email . '>' : $email;
                        }
                    }
                    print '<option value="'
                        . $d . '">'
                        . $this->date( $d, 3, 'c24' )
                        . ( ($user) ? ' [' . $this->escape($user) . ']' : '' )
                        . '</option>';
                }
                print '</select>';
                print 'に<input type="submit" value="戻す" />';
                print
                    ' <label><input type="checkbox" id="preview-enabled" onclick="cmonos.tool.openPreviewWindow()" />プレビュー</label>';
                print '</fieldset>';
                my ( $window_width, $window_height ) = ( 640, 480 );
                my $same_window;
                foreach my $o ( sort { $a <=> $b } keys %field::ORDER ) {
                    my $id = $field::ORDER{$o};
                    if ( ref $field::obj{$id}
                        && $field::obj{$id}{'class'} eq 'xtm_detail' )
                    {
                        $window_width = $field::obj{$id}{'windowWidth'}
                            if $field::obj{$id}{'windowWidth'};
                        $window_height = $field::obj{$id}{'windowHeight'}
                            if $field::obj{$id}{'windowHeight'};
                        $same_window = $field::obj{$id}{'sameWindow'}
                            if $field::obj{$id}{'sameWindow'};
                        last;
                    }
                }
                my $url
                    = $this->full_path($cgi::path)
                    . '?m=DetailViewer&c='
                    . $main::c . '&n='
                    . $main::n . '&ver=';
                my $open_window
                    = ($same_window)
                    ? "window.open('$url'+d,null,'location=no')"
                    : "cmonos.window.open('previewViewer',$window_width,$window_height,'$url'+d)";
                my $js = <<JAVASCRIPT;
cmonos.tool.openPreviewWindow = function () {
	var preview_enabled = document.getElementById('preview-enabled');
	if (preview_enabled && preview_enabled.checked) {
		var d = cmonos.form.field('rewind').getValue();
		if (d != '') $open_window;
	}
};
cmonos.tool.isRewindable = function () {
	if (cmonos.form.field('rewind').getValue() != "") {
		return confirm('この操作は取り消せません。本当に以前の状態に戻しますか？') && cmonos.form.item(this).isNotSubmitted();
	} else {
		alert('以前のデータを選択してください。');
		return false;
	}
};
JAVASCRIPT
                print $this->javascript($js);
            }
        }
    }
}

sub print_contents_footer ($;$) {
    my ( $this, $closebutton_only ) = @_;
    if ( $this->{'footer_neighbor_link'} ) {
        print $this->{'footer_neighbor_link'};
    }
    else {
        print '<div id="close-button">';
        if ( $setting::page{'sameWindowNewDataButton'} ) {
            print $cgi::Deco->button(
                'return',
                $setting::page{'backButton'},
                $this->{'referer_url'},
                ( ($default::english) ? 'Return.' : '戻る' ),
                '',
                (   ( $this->{'referer_url'} )
                    ? ''
                    : { 'onclick' => 'history.back();return false;' }
                )
            );
        }
        else {
            print $this->close_button(
                $this->{'referer_url'},       $setting::page{'closeButton'},
                $setting::page{'backButton'}, $closebutton_only
            );
        }
        print '</div>';
    }
}

sub is_same_name_and_email ($$$) {
    my ( $this, $n, $name ) = @_;
    return 0 if !defined $n || $n eq '' || !$this->{'is_admin'};
    my ( @check_fields, %db, $is_not_same );
    @check_fields = @{ $field::for{'mail_address'} }
        if ref $field::for{'mail_address'};
    return 1 if !@check_fields;
    push( @check_fields, $field::for{'name'} );
    foreach my $id (@check_fields) {
        if ( ref $field::obj{$id} ) {
            tie( %db, $env::dbm_file,
                $default::db . '/' . $main::c . '/' . $field::obj{$id}->db,
                O_RDONLY, $env::dbm_mode );
            $is_not_same = 1
                if !ref tied %db
                || ( defined $db{ $this->encode_utf8($n) }
                && $this->decode_utf8( $db{ $this->encode_utf8($n) } ) ne
                $main::data{$id}{'str'} );
            untie(%db);
            return 0 if $is_not_same;
        }
    }
    $this->{'keep_original_user_info'} = 1;
    return 1;
}

sub get_order_info ($) {
    my $this = shift;
    if (   defined $main::c
        && $main::c ne ''
        && defined $main::n
        && $main::n ne ''
        && !$this->{'order_received'} )
    {
        my ( %order, $info );
        $this->{'order'} = {};
        tie( %order, $env::dbm_file, $default::db . '/' . $main::c . '/order',
            O_RDONLY, $env::dbm_mode );
        if (   ref tied %order
            && $order{ $this->encode_utf8($main::n) }
            && $this->decode_utf8( $order{ $this->encode_utf8($main::n) } )
            =~ /^(.*?)$/m )
        {
            $info = $1;
        }
        untie %order;
        if ($info) {
            chomp $info;
            my ($total,           $tax,            $fee,
                $carriage,        $carriage_total, $download_key,
                $ptime,           $transaction_id, $status,
                $noshipping_only, $expense,        $noshipping_included,
                $discount
            ) = split( /\x09/, $info );
            $this->{'order_carriage_total'} = $carriage_total;
            $this->{'order_paid'}           = $ptime;
            $this->{'order_status'}         = $status;
            $this->{'order_received'}       = 1;
            $this->{'estimated_sum'}        = $total;
            $this->{'noshipping_only'}      = $noshipping_only;
            $this->{'noshipping_included'}  = $noshipping_included;
        }
    }
}

sub is_skip_field ($$) {
    my ( $this, $field ) = @_;
    return (   $default::type
            && $default::type eq 'order'
            && $this->{'noshipping_only'}
            && $this->is_skippable_field($field) ) ? 1 : 0;
}

sub is_reserved_field ($$) {
    my ( $this, $field ) = @_;
    if ( $this->{'order_received'} ) {
        if ( $field->{'class'} =~ /^addr_/ ) {
            $this->import_db( $default::preference_dir . '/terms',
                \%setting::payment, 1 )
                if !%setting::payment;
            if (  !$setting::payment{'carriage'}
                || $setting::payment{'carriage'} eq 'nation'
                || $setting::payment{'carriage'} eq 'weight' )
            {
                return 0;
            }
            elsif ( $setting::payment{'specialcarriage'}{'requirements'} ) {
                if (   $this->{'order_carriage_total'}
                    && $this->{'order_carriage_total'}
                    >= $setting::payment{'specialcarriage'}{'requirements'} )
                {
                    return 0;
                }
                else {
                    return 1;
                }
            }
            else {
                return 1;
            }
        }
        elsif ( $field->{'class'} eq 'yorder_shipping' ) {
            $this->import_db( $default::preference_dir . '/terms',
                \%setting::payment, 1 )
                if !%setting::payment;
            return (   $setting::payment{'yuumail'}
                    || $setting::payment{'mailbin'} ) ? 1 : 0;
        }
        elsif ( $field->{'class'} eq 'yorder_payment' ) {
            $this->import_db( $default::preference_dir . '/terms',
                \%setting::payment, 1 )
                if !%setting::payment;
            if (   $setting::payment{'paypalenabled'}
                || $setting::payment{'codenabled'}
                || $setting::payment{'otherenabled'} )
            {
                return 1;
            }
            elsif ( $this->{'order_paid'} || $this->{'order_status'} ) {
                return 1;
            }
            else {
                return 0;
            }
        }
    }
    return 0;
}

######################################################################
# カテゴリーメニュー
sub allocate_category ($$) {
    my ( $this, $option ) = @_;
    my (%c);

    #ページヘッダ
    $this->print_page_header('input');

    #フォーム
    print $this->form_start(
        'key'  => 'input',
        'name' => 'category',
        'required' =>
            [ grep( $_ ne 'c' && $_ ne 'n' && $_ ne 'ct', @setting::form ) ]
    );

    if ( @main::c || ( defined $main::c && $main::c =~ /,/ ) ) {
        push( @main::c, $main::c )
            if !@main::c && defined $main::c && $main::c ne '';
        foreach (@main::c) {
            print '<input type="hidden" name="ct" value="'
                . $this->escape($_) . '" />'
                if !@main::ct;
            $c{$_}++ foreach ( split( /,/, $_ ) );
        }
    }
    if ( @main::ct || ( defined $main::ct && $main::ct =~ /,/ ) ) {
        push( @main::ct, $main::ct ) if defined $main::ct;
        foreach (@main::ct) {
            print '<input type="hidden" name="ct" value="'
                . $this->escape($_) . '" />';
        }
    }

    print '<select name="c">';
    my @categories = sort {
        $setting::category{$a}{'ORDER'} <=> $setting::category{$b}{'ORDER'}
            || $a <=> $b
    } grep( defined $_ && $_ !~ /[^0-9]/, keys %setting::category );
    if (%c) {
        my $c;
        foreach $c (@categories) {
            next
                if !$c{$c}
                || ( $setting::category{$c}{'total'}
                && $setting::category{$c}{'total'}
                > $setting::category{'LIMIT'} );
            print '<option value="'
                . $c . '">'
                . $setting::category{$c}{'name'}
                . ( ( $setting::category{$c}{'count'} )
                ? ' (' . $setting::category{$c}{'count'} . ')'
                : '' )
                . '</option>';
        }
    }
    else {
        print $this->mk_category_selector( \%setting::category,
            \@categories );
    }
    print '</select>';
    print '<input type="submit" value="選択" />';
    print '</form>';
    print '<div id="close-button">'
        . $this->close_button(
        $this->{'referer_url'},
        $setting::page{'closeButton'},
        $setting::page{'backButton'}
        ) . '</div>';

    #ページフッタ
    $this->print_page_footer('input');
    exit;
}

######################################################################
# 新規入力のみのユーザーかどうか
sub is_input_only_user ($) {
    my $this = shift;
    if ( !defined $main::n || $main::n eq '' ) {
        return (
            (   !defined $setting::security{'revise'}{'passwordCheck'}
                    || $setting::security{'revise'}{'passwordCheck'} ne
                    'nocheck'
            )
                && ( !$this->is_secure('revise')
                || ( !$this->is_one_of_owners && !$this->email_field_enabled )
                )
        ) ? 1 : 0;
    }
    else {
        my ($suspend_flag);
        if ( $field::for{'checker'}
            && ref $field::obj{ $field::for{'checker'} } )
        {
            my $field = $field::obj{ $field::for{'checker'} };
            my ( $level, %db );
            $level = 0;
            tie( %db, $env::dbm_file,
                $default::db . '/' . $main::c . '/' . $field->db,
                O_RDONLY, $env::dbm_mode );
            if ( ref tied %db ) {
                $level = $1
                    if $this->decode_utf8(
                    $db{ $this->encode_utf8($main::n) } )
                    =~ /^.*?\x0A([0-9]+):/s;
            }
            untie(%db);
            $suspend_flag = 1
                if $level
                && (
                ( $level == 999 && $field->{'cancelSuspend'} )
                || ( ref $field->{'phase'}{$level}
                    && $field->{'phase'}{$level}{'suspend'} )
                );
        }
        if ( defined $setting::security{'revise'}{'passwordCheck'}
            && $setting::security{'revise'}{'passwordCheck'} eq 'nocheck' )
        {
            $this->{'is_admin'} = 1
                if $this->is_secure('revise') && $this->is_one_of_owners;
            $this->is_authorized_email if !$suspend_flag;
        }
        else {
            $this->{'is_admin'} = 1
                if !$this->is_authorized_email
                && $this->is_secure('revise')
                && $this->is_one_of_owners;
        }
        if ($suspend_flag) {
            if ( $this->is_secure('revise') && $this->is_secure('tools') ) {
                return 0;
            }
            else {
                return 'このレコードは修正できません。';
            }
        }
        return (
            (   !defined $setting::security{'revise'}{'passwordCheck'}
                    || $setting::security{'revise'}{'passwordCheck'} ne
                    'nocheck'
            )
                && ( !$this->is_secure_email || !$this->is_secure('revise') )
        ) ? 1 : 0;

#return ((!defined $setting::security{'revise'}{'passwordCheck'} || $setting::security{'revise'}{'passwordCheck'} ne 'nocheck') && (!$this->is_secure_email || !$this->is_secure('revise'))) ? (($this->{'email_field_enabled'}) ? 1 : 'メールアドレスフィールドが存在しません。') : 0;
    }
}

sub is_secure_email ($) {
    my $this = shift;
    if ( defined $this->{'is_secure_email'} ) {
        return $this->{'is_secure_email'};
    }
    elsif ($this->is_master
        || $this->is_owner
        || $this->is_one_of_owners
        || $this->is_staff )
    {
        $main::set_cookie_id = 1
            if !$env::session_enabled
            && $cookie::read{ $this->login_cookie_name };
        $this->{'is_secure_email'} = 1;
    }
    elsif ( $this->is_authorized_email ) {
        $this->{'is_secure_email'} = 1;
    }
    else {
        $this->{'is_secure_email'} = 0;
    }
    return $this->{'is_secure_email'};
}

sub email_field_enabled ($) {
    my $this = shift;
    $this->is_authorized_email if !defined $this->{'email_field_enabled'};
    return $this->{'email_field_enabled'};
}

sub is_authorized_email ($) {
    my $this = shift;
    if ( defined $this->{'is_authorized_email'} ) {
        return $this->{'is_authorized_email'};

    }
    elsif ( $setting::general{'oneEmailToOneRecord'} && $field::for{'mail'} )
    {
        $this->{'is_authorized_email'} = 0;
        $this->{'email_field_enabled'} = 1;
        $this->{'user_address'}        = '';
        my $user_address = '';
        my $new_user_address
            = ( $main::data{ $field::for{'mail'} }{'str'}
                && !ref $main::data{ $field::for{'mail'} }{'str'} )
            ? $main::data{ $field::for{'mail'} }{'str'}
            : '';
        if ( defined $main::n && $main::n ne '' ) {
            if ( ref $field::obj{ $field::for{'mail'} } ) {
                my (%db);
                tie(%db,
                    $env::dbm_file,
                    $default::db . '/'
                        . $main::c . '/'
                        . $field::obj{ $field::for{'mail'} }->db,
                    O_RDONLY,
                    $env::dbm_mode
                );
                if ( ref tied %db ) {
                    $user_address
                        = $this->decode_utf8(
                        $db{ $this->encode_utf8($main::n) } )
                        if $db{ $this->encode_utf8($main::n) };
                }
                untie(%db);
            }
        }
        elsif ( $main::data{ $field::for{'mail'} }{'str'} ) {
            $user_address = $main::data{ $field::for{'mail'} }{'str'};
        }

        if ( $user_address && $new_user_address ) {
            my $user_address_is_registered
                = ( $main::email && $user_address eq $main::email ) ? 1 : 0;
            my $new_user_address_is_registered
                = ( $main::email && $new_user_address eq $main::email )
                ? 1
                : 0;

#データベースにも新しいデータにも登録されたE-Mailがある
            if (   $main::email
                && $user_address_is_registered
                && $new_user_address_is_registered
                && ($security::registered
                    || ($this->use_register
                        && $cgi::Register->is_registered(
                            $main::pswd, $main::email
                        )
                    )
                )
                )
            {
                $security::registered = 1;
                $main::set_cookie_id  = 1
                    if !$env::session_enabled
                    && $cookie::read{ $this->login_cookie_name };
                $this->{'is_authorized_email'} = 1;
                $this->{'user_address'}        = $main::email;

#データベースには登録されたE-Mailがあるが新しいデータにない
            }
            elsif ($user_address_is_registered
                && !$new_user_address_is_registered
                && $this->use_register
                && $cgi::Register->is_registered( $main::pswd, $main::email )
                )
            {
                if (   $setting::general{'autoRegister'}
                    && $new_user_address
                    && !$cgi::Register->exist($new_user_address) )
                {
                    if ( $cgi::Register->register($new_user_address) ) {
                        push(
                            @{ $this->{'dialog'} },
                            $cgi::Register->success_dialog
                        );
                        $this->{'is_authorized_email'} = 1;
                        $this->{'old_email'}           = $main::email;
                        $this->{'old_pswd'}            = $main::pswd;
                        $this->{'user_address'}        = $new_user_address;
                        $this->{'move_enabled'}        = 1;
                    }
                    else {
                        push(
                            @{ $this->{'dialog'} },
                            $cgi::Register->error_dialog
                        );
                        $this->{'user_address'}
                            = $new_user_address || $user_address;
                    }
                }
                else {
                    $this->{'need_new_pswd'} = 1;
                    if (   $main::new_email
                        && $main::new_pswd
                        && $new_user_address eq $main::new_email
                        && $cgi::Register->is_registered(
                            $main::new_pswd, $main::new_email
                        )
                        )
                    {
                        $this->{'is_authorized_email'} = 1;
                        $this->{'old_email'}           = $main::email;
                        $this->{'old_pswd'}            = $main::pswd;
                        $this->{'user_address'}        = $main::email
                            = $main::new_email;
                        $main::pswd = $main::new_pswd;
                        undef $main::new_email;
                        undef $main::new_pswd;
                        if ($env::session_enabled) {

                            if ( $this->use_session ) {
                                $session::id = $cgi::Session->set_user_info(
                                    $main::email, $main::pswd, $session::id );
                                $session::is_changed = 1;
                            }
                        }
                        elsif ( $cookie::read{ $this->login_cookie_name } ) {
                            $main::set_cookie_id = 1;
                        }
                    }
                    else {
                        if (   $main::new_email
                            && $new_user_address ne $main::new_email )
                        {
                            push(
                                @{ $this->{'dialog'} },
                                '入力された項目に新しいメールアドレスがみつかりません。'
                            );
                        }
                        elsif ($main::new_pswd) {
                            push(
                                @{ $this->{'dialog'} },
                                '新しいパスワードを確認してください。'
                            );
                        }
                        elsif (
                            $setting::security{'revise'}{'passwordCheck'} eq
                            'nocheck' )
                        {
                            $this->{'is_authorized_email'} = 1;
                        }
                        $this->{'user_address'}
                            = $new_user_address || $user_address;
                    }
                }

                #その他
            }
            else {
                if ( $setting::security{'revise'}{'passwordCheck'} eq
                    'nocheck' )
                {
                    $this->{'is_authorized_email'} = 1;
                }
                $this->{'user_address'} = $new_user_address || $user_address;
            }
        }
        elsif ( $setting::security{'revise'}{'passwordCheck'} eq 'nocheck' ) {
            $this->{'is_authorized_email'} = 1;
        }

    }
    else {
        $this->{'is_authorized_email'} = 0;
        $this->{'email_field_enabled'} = 0;
        $this->{'user_address'}        = '';
        if ( ref $field::for{'mail_address'}
            && @{ $field::for{'mail_address'} } )
        {
            my ( @user_address, @new_user_address );
            $this->{'email_field_enabled'} = 1;
            foreach my $id ( @{ $field::for{'mail_address'} } ) {
                push( @new_user_address, $main::data{$id}{'str'} )
                    if $main::data{$id}{'str'};
                if ( defined $main::n && $main::n ne '' ) {
                    if ( ref $field::obj{$id} ) {
                        my (%db);
                        tie(%db,
                            $env::dbm_file,
                            $default::db . '/'
                                . $main::c . '/'
                                . $field::obj{$id}->db,
                            O_RDONLY,
                            $env::dbm_mode
                        );
                        if ( ref tied %db ) {
                            push(
                                @user_address,
                                $this->decode_utf8(
                                    $db{ $this->encode_utf8($main::n) }
                                )
                            ) if $db{ $this->encode_utf8($main::n) };
                        }
                        untie(%db);
                    }
                }
                elsif ( $main::data{$id}{'str'} ) {
                    push( @user_address, $main::data{$id}{'str'} );
                }
            }
            @user_address     = $this->get_address(@user_address);
            @new_user_address = $this->get_address(@new_user_address);
            if ( @user_address && @new_user_address ) {
                my $user_address_count
                    = grep( defined $_
                        && defined $main::email
                        && $_ eq $main::email,
                    @user_address );
                my $new_user_address_count
                    = grep( defined $_
                        && defined $main::email
                        && $_ eq $main::email,
                    @new_user_address );

#データベースにも新しいデータにも登録されたE-Mailがある
                if (   $main::email
                    && $user_address_count
                    && $new_user_address_count
                    && ($security::registered
                        || ($this->use_register
                            && $cgi::Register->is_registered(
                                $main::pswd, $main::email
                            )
                        )
                    )
                    )
                {
                    $security::registered = 1;
                    $main::set_cookie_id  = 1
                        if !$env::session_enabled
                        && $cookie::read{ $this->login_cookie_name };
                    $this->{'is_authorized_email'} = 1;
                    $this->{'user_address'}        = $main::email;

#データベースには登録されたE-Mailがあるが新しいデータにない
                }
                elsif (
                       $user_address_count
                    && !$new_user_address_count
                    && $this->use_register
                    && $cgi::Register->is_registered(
                        $main::pswd, $main::email
                    )
                    )
                {
                    $this->{'need_new_pswd'} = 1;
                    if (   $main::new_email
                        && $main::new_pswd
                        && grep( defined $_ && $_ eq $main::new_email,
                            @new_user_address )
                        && $cgi::Register->is_registered(
                            $main::new_pswd, $main::new_email
                        )
                        )
                    {
                        $this->{'is_authorized_email'} = 1;
                        $this->{'old_email'}           = $main::email;
                        $this->{'old_pswd'}            = $main::pswd;
                        $this->{'user_address'}        = $main::email
                            = $main::new_email;
                        $main::pswd = $main::new_pswd;
                        undef $main::new_email;
                        undef $main::new_pswd;
                        if ($env::session_enabled) {

                            if ( $this->use_session ) {
                                $session::id = $cgi::Session->set_user_info(
                                    $main::email, $main::pswd, $session::id );
                                $session::is_changed = 1;
                            }
                        }
                        elsif ( $cookie::read{ $this->login_cookie_name } ) {
                            $main::set_cookie_id = 1;
                        }
                    }
                    else {
                        if ($main::new_email
                            && !grep( defined $_ && $_ eq $main::new_email,
                                @new_user_address )
                            )
                        {
                            push(
                                @{ $this->{'dialog'} },
                                '入力された項目に新しいメールアドレスがみつかりません。'
                            );
                        }
                        elsif ($main::new_pswd) {
                            push(
                                @{ $this->{'dialog'} },
                                '新しいパスワードを確認してください。'
                            );
                        }
                        elsif (
                            $setting::security{'revise'}{'passwordCheck'} eq
                            'nocheck' )
                        {
                            $this->{'is_authorized_email'} = 1;
                        }
                        $this->{'user_address'}
                            = (@new_user_address)
                            ? $new_user_address[0]
                            : $user_address[0];
                    }

                    #その他
                }
                else {
                    if ( $setting::security{'revise'}{'passwordCheck'} eq
                        'nocheck' )
                    {
                        $this->{'is_authorized_email'} = 1;
                    }
                    $this->{'user_address'}
                        = (@new_user_address)
                        ? $new_user_address[0]
                        : $user_address[0];
                }
            }
            elsif (
                $setting::security{'revise'}{'passwordCheck'} eq 'nocheck' )
            {
                $this->{'is_authorized_email'} = 1;
            }
        }
        elsif ( $setting::security{'revise'}{'passwordCheck'} eq 'nocheck' ) {
            $this->{'is_authorized_email'} = 1;
        }
    }
    return $this->{'is_authorized_email'};
}

######################################################################
# カテゴリー移動
sub record_move_to ($$$$;$) {
    my ( $this, $moveto, $c, $n, $copy ) = @_;
    return ( $c, $n ) if $moveto eq $c && !$copy;
    $copy = 0 if $setting::general{'oneEmailToOneRecord'};

    #移動先レコード数チェック
    my $count = 0;
    my (%mtime);
    tie( %mtime, $env::dbm_file, "$default::db/$moveto/mtime", O_RDONLY,
        $env::dbm_mode );
    if ( ref tied %mtime ) {
        while ( my ($k) = each %mtime ) {
            $count++;
        }
    }
    untie %mtime;
    if ( $count >= $setting::category{'LIMIT'} ) {
        push(
            @{ $this->{'dialog'} },
            '移動先のカテゴリー「'
                . $setting::category{$moveto}{'name'}
                . '」には書き込めません。レコード数が '
                . $setting::category{'LIMIT'}
                . ' 件以内に制限されています。'
        );
        return ( $c, $n );
    }

    #移動先
    my $has_permanent_id = $this->has_permanent_id( $c, $n );
    my $num = ( !$copy && $has_permanent_id ) ? $n : $this->new_record_id(1);

    #データコピー
    local (*DIR);
    if ( opendir( DIR, "$default::db/$c" ) ) {
        my @files = readdir(DIR);
        closedir(DIR);
        my ( %database, %category, $nocount );
        foreach my $db (@files) {
            next
                if $db =~ /^\./
                || $db =~ /\.s?html?$/i
                || !-f "$default::db/$c/$db";
            $db =~ s/\.[^\/\.]+$//;
            $database{$db} = 1;
        }
        eval 'use ' . $env::dbm_file . ';';
        while ( my ($db) = each %database ) {
            my ( $original, $new );
            tie( %{$original}, $env::dbm_file, "$default::db/$c/$db", O_RDWR,
                $env::dbm_mode );
            if ( ref tied %{$original} ) {
                if ( $moveto ne $c ) {
                    tie( %{$new}, $env::dbm_file, "$default::db/$moveto/$db",
                        O_RDWR | O_CREAT,
                        $env::dbm_mode );
                }
                else {
                    $new = $original;
                }
                $nocount = 1
                    if $db eq 'pending'
                    && $original->{ $this->encode_utf8($n) }
                    && $this->decode_utf8(
                    $original->{ $this->encode_utf8($n) } ) =~ /^1/;
                $new->{$num} = $original->{$n} if ref tied %{$new};
                delete $original->{$n} if !$copy;
                untie %{$new} if $moveto ne $c;
            }
            untie %{$original};
        }
        tie(%category, $env::dbm_file,
            $default::preference_dir . '/category',
            O_RDWR | O_CREAT,
            $env::dbm_mode
        );
        if ( ref tied %category ) {
            if ( !$copy ) {
                $category{ $this->encode_utf8( $c . '_count' ) }
                    = $setting::category{$c}{'count'}
                    = $category{ $this->encode_utf8( $c . '_count' ) } - 1
                    if !$nocount
                    && $category{ $this->encode_utf8( $c . '_count' ) };
                $category{ $this->encode_utf8( $c . '_total' ) }
                    = $setting::category{$c}{'total'}
                    = $category{ $this->encode_utf8( $c . '_total' ) } - 1
                    if $category{ $this->encode_utf8( $c . '_total' ) };
            }
            $category{ $this->encode_utf8( $moveto . '_count' ) }
                = $setting::category{$moveto}{'count'}
                = ( $category{ $this->encode_utf8( $moveto . '_count' ) }
                    || 0 ) + 1
                if !$nocount;
            $category{ $this->encode_utf8( $moveto . '_total' ) }
                = $setting::category{$moveto}{'total'}
                = ( $category{ $this->encode_utf8( $moveto . '_total' ) }
                    || 0 )
                + 1;
        }
        untie %category;
        $this->directory_copy( "$default::file/$c/$n",
            "$default::file/$moveto/$num", 1, ['\\.(?:js|ssi)$'] );
        $this->save_record_id( $moveto, $num );
        if ( !$copy ) {
            use File::Path;
            rmtree "$default::file/$c/$n";
            $this->index_sweeper( $c, $n );
            if (   $setting::general{'oneEmailToOneRecord'}
                && $field::for{'mail'}
                && $main::data{ $field::for{'mail'} }{'str'}
                && !$has_permanent_id )
            {
                my (%email_to_id);
                tie(%email_to_id, $env::dbm_file,
                    $default::db . '/email_to_id',
                    O_RDWR | O_CREAT,
                    $env::dbm_mode
                );
                if ( ref tied %email_to_id ) {
                    $email_to_id{
                        $this->encode_utf8(
                            $main::data{ $field::for{'mail'} }{'str'}
                        )
                    } = $num;
                }
                untie %email_to_id;
            }
        }
    }
    return ( $moveto, $num );
}

######################################################################
sub set_rss_link ($;$) {
    my ( $this, $output ) = @_;
    $this->import_db( $default::preference_dir . '/category',
        \%setting::category, 1 )
        if !%setting::category;
    $this->_set_rss_link(
        $default::file . '/' . $main::c,
        (   (          ref $setting::category{$main::c}
                    && defined $setting::category{$main::c}{'name'}
                    && $setting::category{$main::c}{'name'} ne ''
            ) ? $setting::category{$main::c}{'name'} : ''
        )
    ) if defined $main::c && $main::c ne '';
    $this->_set_rss_link(
        $default::file,
        (   (   defined $setting::general{'cginame'}
                    && $setting::general{'cginame'} ne ''
            ) ? $setting::general{'cginame'} : ''
        ),
        $output
    );
}

sub print_response ($$) {
    my ( $this, $data ) = @_;
    binmode STDOUT, ":utf8";
    $this->print_http_header(
        'application/x-www-form-urlencoded; charset=utf-8');
    print(( !defined $data ) ? ''
        : ( !ref $data )          ? $data
        : ( ref $data eq 'HASH' ) ? $this->url_encoded_query($data)
        :                           $$data );
}

######################################################################
# クラス登録
#sub import {
BEGIN {
    no warnings qw(once);

    #設定種キー設定
    $setting::security_key
        = ( defined $main::n && $main::n ne '' )
        ? 'revise'
        : 'input';    #デフォルトセキュリティキー
    $setting::key = 'input';    #ページ設定キー

    #デフォルトキー
    $main::k = 'input' if !defined $main::k || !$main::k;

    #必須フォーム
    @setting::form = (
        'm', 'c',   'n',      's',   'w',   'f', 'u', 'fv',
        'q', 'and', 'search', 'mod', 'uni', 'ct'
    );

    #クラス登録
    Common::class_register( 'input', 'Input' );

    $setting::page{'input'}{'title'} = 'データ入力';

}

1;
