package CheckOutPage;
require CMONOS::TableMaker::SCTools::CartViewerPage;
@ISA = qw(CartViewerPage);
use strict;
use utf8;
######################################################################
# チェックアウトページ設定モジュール
# CheckOutPage.pm ver1.0.1
# Copyright (C) 1999-2018 CMONOS Co. Ltd.
#
# support@cmonos.jp
# http://cmonos.jp/
# 最終更新日：2008-12-03
######################################################################
# 設定項目取得
sub get_sub_setting_items ($) {
    my $this = shift;
    push( @check::checkbox,
        'estimatedCarriageForbidden', 'estimatedFeeForbidden',
        'closeButtonDisabled' );    #チェックボックス
    push( @check::tagfix, 'checkoutDescription', 'confirmationDescription' );
    push( @check::notag,
        'backButtonTitle', 'checkoutTitle', 'confirmationTitle' );
    return;
}

######################################################################
# 設定環境
sub set_sub_preferences ($) {
    my $this = shift;
    $preference::id = 'checkout';    # データキー
    $preference::name = 'チェックアウト ページレイアウト'
        ;                            # 設定パネル名
    $preference::title
        = 'チェックアウト ページのレイアウトについて設定します。';
    $setting::image_css = 'order-image.css';
}

sub print_sub_preference_panel ($$$) {
    my ( $this, $id, $key ) = @_;
    print '<fieldset>';
    print '<legend>レジ 画面追加設定</legend>';
    print '<fieldset>';
    print '<legend><label for="data:' . $id
        . 'checkoutTitle">追加ページタイトル</label></legend>';
    print '<input type="text" name="data:'
        . $id
        . 'checkoutTitle" id="data:'
        . $id
        . 'checkoutTitle" size="56" value="'
        . $this->escape( $main::data{ $key . 'checkoutTitle' } ) . '" />';
    print '</fieldset>';
    print '<fieldset>';
    print '<legend><label for="data:' . $id
        . 'checkoutDescription">追加ページヘッダ</label></legend>';
    print '<textarea name="data:'
        . $id
        . 'checkoutDescription" id="data:'
        . $id
        . 'checkoutDescription" cols="72" rows="8" wrap="off" class="content-editor-area">'
        . $this->escape( $main::data{ $key . 'checkoutDescription' } )
        . '</textarea>';
    print '<div class="toolbox">';
    $this->print_header_tool( $id, 'checkoutDescription' );
    print '</div>';
    print '</fieldset>';
    print '<fieldset>';
    print
        '<legend>配送料・手数料の表示</legend><ol class="checkbox">';
    print '<li><label><input type="checkbox" name="data:'
        . $id
        . 'estimatedCarriageForbidden" id="data:'
        . $id
        . 'estimatedCarriageForbidden" value="1"'
        . ( ( $main::data{ $key . 'estimatedCarriageForbidden' } )
        ? ' checked="checked"'
        : '' )
        . ' /> 計算可能な場合でも未確定な配送料を表示しない</label></li>';
    print '<li><label><input type="checkbox" name="data:'
        . $id
        . 'estimatedFeeForbidden" id="data:'
        . $id
        . 'estimatedFeeForbidden" value="1"'
        . ( ( $main::data{ $key . 'estimatedFeeForbidden' } )
        ? ' checked="checked"'
        : '' )
        . ' /> 計算可能な場合でも未確定な手数料を表示しない</label></li>';
    print '</ol></fieldset>';
    print '</fieldset>';

    print '<fieldset>';
    print '<legend>注文の確認 画面追加設定</legend>';
    print '<fieldset>';
    print '<legend><label for="data:' . $id
        . 'confirmationTitle">追加ページタイトル</label></legend>';
    print '<input type="text" name="data:'
        . $id
        . 'confirmationTitle" id="data:'
        . $id
        . 'confirmationTitle" size="56" value="'
        . $this->escape( $main::data{ $key . 'confirmationTitle' } ) . '" />';
    print '</fieldset>';
    print '<fieldset>';
    print '<legend><label for="data:' . $id
        . 'confirmationDescription">追加ページヘッダ</label></legend>';
    print '<textarea name="data:'
        . $id
        . 'confirmationDescription" id="data:'
        . $id
        . 'confirmationDescription" cols="72" rows="8" wrap="off" class="content-editor-area">'
        . $this->escape( $main::data{ $key . 'confirmationDescription' } )
        . '</textarea>';
    print '<div class="toolbox">';
    $this->print_header_tool( $id, 'confirmationDescription' );
    print '</div>';
    print '</fieldset>';
    print '</fieldset>';

    print '<fieldset>';
    print '<legend>注文のお礼 画面追加設定</legend>';
    print '<fieldset>';
    print '<legend><label for="data:' . $id
        . 'thanksTitle">追加ページタイトル</label></legend>';
    print '<input type="text" name="data:'
        . $id
        . 'thanksTitle" id="data:'
        . $id
        . 'thanksTitle" size="56" value="'
        . $this->escape( $main::data{ $key . 'thanksTitle' } ) . '" />';
    print '</fieldset>';
    print '<fieldset>';
    print '<legend><label for="data:' . $id
        . 'thanksDescription">追加ページヘッダ</label></legend>';
    print '<textarea name="data:'
        . $id
        . 'thanksDescription" id="data:'
        . $id
        . 'thanksDescription" cols="72" rows="8" wrap="off" class="content-editor-area">'
        . $this->escape( $main::data{ $key . 'thanksDescription' } )
        . '</textarea>';
    print '<div class="toolbox">';
    $this->print_header_tool( $id, 'thanksDescription' );
    print '</div>';
    print '</fieldset>';
    print '</fieldset>';

    print '<fieldset>';
    print '<legend>入力内容確認テーブル設定</legend>';
    print '<table class="field-table">';
    print '<tbody>';
    print '<tr>';
    print '<td class="field-name"><label for="data:' . $id
        . 'table">テーブルタイプ設定</label></td>';
    print '<td class="field">';
    print $this->table_menu( 'data:' . $id . 'table',
        $main::data{ $key . 'table' } );
    print '</td></tr>';
    print '<tr><td class="field-name"><label for="data:' . $id
        . 'tableSetting">オリジナル設定</label></td>';
    print '<td class="field">';
    print '<textarea name="data:'
        . $id
        . 'tableSetting" id="data:'
        . $id
        . 'tableSetting" cols="56" rows="5" wrap="off">'
        . $this->escape( $main::data{ $key . 'tableSetting' } )
        . '</textarea>';
    print
        '<div class="note">独自の設定をする場合はここで設定します。</div>';
    print '</td></tr>';
    print '</tbody></table>';
    print '</fieldset>';

    my $icon_obj = $this->use_checkout_icon;
    print '<fieldset><legend>ボタン設定</legend>';
    $this->print_button_menu( $cgi::Deco, '(カートに)戻る ボタン',
        $id, 'backButton', 'return', 1 );
    $this->print_button_menu( $icon_obj, '注文を確認 ボタン',
        $id, 'confirmationButton', 'confirmation', 1 );
    $this->print_button_menu( $icon_obj, '注文を確定する ボタン',
        $id, 'orderButton', 'order', 1 );
    $this->print_button_menu( $icon_obj,
        '見積もりを印刷する ボタン',
        $id, 'estimateButton', 'estimate', 1, 1 );
    print '<fieldset>';
    print
        '<legend>閉じる/(お買い物ページに)戻る ボタン</legend>';
    print '<label><input type="checkbox" name="data:'
        . $id
        . 'closeButtonDisabled" id="data:'
        . $id
        . 'closeButtonDisabled"  value="1"'
        . ( ( $main::data{ $key . 'closeButtonDisabled' } )
        ? ' checked="checked"'
        : '' )
        . ' /> 表示しない</label>';
    print '</fieldset>';
    print '</fieldset>';
}

######################################################################
#sub import {
BEGIN {
    #クラス登録
    Common::class_register( 'c002', 'CheckOutPage' );

    #ツール登録
    $setting::sub_jump_menu{'page'}{'c002'}
        = 'チェックアウト ページ';
    $setting::selected_jump_menu{'c002'} = 't000'
        ; #サブメニューがあるときメインメニューのデフォルトキー

    $preference::page{'c002'} = 'checkout';
}

1;
