package DLPage;
require CMONOS::CGI_Lib::Tools::Page;
@ISA = qw(Page);
use strict;
use utf8;
######################################################################
# ダウンロードページ設定モジュール
# DLPage.pm ver1.0
# Copyright (C) 1999-2018 CMONOS Co. Ltd.
#
# support@cmonos.jp
# http://cmonos.jp/
# 最終更新日：2008-11-14
######################################################################
# 設定項目取得
sub get_sub_setting_items ($) {
    my $this = shift;
    push( @check::checkbox, '' );    #チェックボックス
    return;
}

######################################################################
# 設定環境
sub set_sub_preferences ($) {
    my $this = shift;
    $preference::id = 'dl';          # データキー
    $preference::name
        = 'ダウンロード ページレイアウト';  # 設定パネル名
    $preference::title
        = 'ダウンロード ページのレイアウトについて設定します。';
}

######################################################################
# 設定パネル
sub print_sub_preference_panel ($$$) {
    my ( $this, $id, $key ) = @_;
    require CMONOS::CGI_Lib::HTMLHelper;
    my $helper = HTMLHelper->new;
    print '<fieldset>';
    print '<legend><label for="data:' . $id
        . 'downloadMsg">ダウンロードメッセージ</label></legend>';
    print '<textarea name="data:'
        . $id
        . 'downloadMsg" id="data:'
        . $id
        . 'downloadMsg" cols="72" rows="10" wrap="off" class="content-editor-area">'
        . $this->escape( $main::data{ $key . 'downloadMsg' } )
        . '</textarea>';
    print '<div class="toolbox">';
    print
        '<label class="auto-fit" title="高さを内容に合わせる"><input type="checkbox" onclick="cmonos.form.item(this.form).fieldname(\'data:'
        . $id
        . 'downloadMsg\').setAutoFit(this.checked);" />フィット</label> ';
    print
        '<select class="tool" onchange="cmonos.form.item(this.form).fieldname(\'data:'
        . $id
        . 'downloadMsg\').quotationByMenu(this)" title="これらのタグは、書き出し時に対応するトラックバックデータに変換されます。">';
    print
        '<option value="">▼ダウンロードリストタグを挿入する</option>';
    print
        '<option value="&lt;lifetime&gt;">残り日数 &lt;lifetime&gt;</option>';
    print
        '<option value="&lt;list&gt;">ダウンロードリスト &lt;list&gt; (&lt;ul id=&quot;download-list&quot;&gt;)</option>';
    print '</select>';
    print $helper->html_helper_menu( 'data:' . $id . 'downloadMsg' );
    print '</div>';
    print '</fieldset>';
    print '<fieldset>';
    print '<legend><label for="data:' . $id
        . 'errorMsg">エラーメッセージ</label></legend>';
    print '<textarea name="data:'
        . $id
        . 'errorMsg" id="data:'
        . $id
        . 'errorMsg" cols="72" rows="10" wrap="off" class="content-editor-area">'
        . $this->escape( $main::data{ $key . 'errorMsg' } )
        . '</textarea>';
    print '</fieldset>';
}

######################################################################
#sub import {
BEGIN {
    #クラス登録
    Common::class_register( 'c003', 'DLPage' );

    #ツール登録
    $setting::sub_jump_menu{'page'}{'c003'} = 'ダウンロード ページ';
    $setting::selected_jump_menu{'c003'} = 't000'
        ; #サブメニューがあるときメインメニューのデフォルトキー

    $preference::page{'c003'} = 'dl';
}

1;
