package EstimatePage;
require CMONOS::CGI_Lib::Tools::Page;
@ISA = qw(Page);
use strict;
use utf8;
######################################################################
# 見積もり印刷設定モジュール
# EstimatePage.pm ver1.0.4
# Copyright (C) 1999-2018 CMONOS Co. Ltd.
#
# support@cmonos.jp
# http://cmonos.jp/
# 最終更新日：2009-10-10
######################################################################
# 設定項目取得
sub get_sub_setting_items ($) {
    my $this = shift;
    return;
}

######################################################################
# 設定環境
sub set_sub_preferences ($) {
    my $this = shift;
    $preference::id = 'estimate'
        if !defined $preference::id;    # データキー
    $preference::name = '見積もり印刷 レイアウト'
        if !defined $preference::name;    # 設定パネル名
    $preference::title
        = '見積もり印刷のレイアウトについて設定します。'
        if !defined $preference::title;
    $setting::image_css = 'order-image.css';
}

sub set_page_header ($) {
    my $this = shift;
    if ( !$main::data{'estimate_template'} ) {
        $main::data{'estimate_cssFileName'} = 'estimate.css'
            if !$main::data{'estimate_cssFileName'};
        $main::data{'estimate_title'} = 'お見積もりの印刷'
            if !$main::data{'estimate_title'};
        $main::data{'estimate_template'} = <<HTML;
<div id="main">
<h1>お見積もり</h1>
<dl id="date">
<dt>見積書発行日</dt><dd><!--date--><!--/date--></dd>
<dt>見積書有効期間</dt><dd>一ヶ月</dd>
</dl>
<div id="requestor">
<!--requestor_address--><!--head--><div class="address"><!--/head--><!--foot--></div><!--/foot--><!--/requestor_address-->
<!--requestor_email--><!--head--><div class="email"><!--/head--><!--foot--></div><!--/foot--><!--/requestor_email-->
<div class="name"><span class="name"><!--requestor--><!--/requestor--></span><span class="suffix">様</span></div>
</div>
<div id="estimator">
<!--estimator_company--><!--head--><div class="company"><!--/head--><!--foot--></div><!--/foot--><!--/estimator_company-->
<!--estimator--><!--head--><div class="name"><!--/head--><!--foot--></div><!--/foot--><!--/estimator-->
<!--estimator_email--><!--head--><div class="email"><!--/head--><!--foot--></div><!--/foot--><!--/estimator_email-->
<div class="address">



</div>
<!--estimator_sitename--><!--head--><div class="sitename"><!--/head--><!--foot--></div><!--/foot--><!--/estimator_sitename-->
<!--estimator_url--><!--head--><div class="url"><!--/head--><!--foot--></div><!--/foot--><!--/estimator_url-->
</div>
<!--estimate--><!--head--><div id="estimate"><!--/head--><!--foot--></div><!--/foot--><!--/estimate-->
<div id="note"><p>※このお見積もりは概算です。実際にご注文いただいた時点で、条件により多少変動する場合がございます。</p></div>
</div>
HTML
    }

    return;
}

######################################################################
# 設定パネル
sub print_sub_preference_panel ($$;$) {
    my ( $this, $id, $key ) = @_;
    $this->use_field( 'field', $default::field_pref_dir . '/inputfield', 2 );
    require CMONOS::CGI_Lib::Template;
    my $this_template = Template->new;

    #入力支援ツール
    my $tool
        = '<select class="tool" onchange="cmonos.form.item(this.form).fieldname(\''
        . $id
        . '\').quotationByMenu(this)" title="これらのタグは、対応するデータに変換されます。">';
    $tool .= '<option value="">▼特殊タグを挿入する</option>';
    $tool
        .= '<option value="&lt;!--estimate--&gt;&lt;!--/estimate--&gt;">見積もり &lt;!--estimate--&gt;</option>';
    $tool
        .= '<option value="&lt;!--date--&gt;&lt;!--/date--&gt;">日付 &lt;!--date--&gt;</option>';
    $tool .= '<option value=""></option>';
    $tool
        .= '<option value="&lt;!--requestor--&gt;&lt;!--/requestor--&gt;">名前 &lt;!--requestor--&gt;</option>';
    $tool
        .= '<option value="&lt;!--requestor_email--&gt;&lt;!--/requestor_email--&gt;">代表メールアドレス &lt;!--requestor_email--&gt;</option>';
    $tool
        .= '<option value="&lt;!--requestor_address--&gt;&lt;!--/requestor_address--&gt;">配送先住所 &lt;!--requestor_address--&gt;</option>';
    $tool .= '<option value=""></option>';
    $tool
        .= '<option value="&lt;!--estimator--&gt;&lt;!--/estimator--&gt;">見積り担当者の名前(管理人名) &lt;!--estimator--&gt;</option>';
    $tool
        .= '<option value="&lt;!--estimator_email--&gt;&lt;!--/estimator_email--&gt;">見積り担当者のメールアドレス(管理人アドレス) &lt;!--estimator_email--&gt;</option>';
    $tool
        .= '<option value="&lt;!--estimator_sitename--&gt;&lt;!--/estimator_sitename--&gt;">このサイトの名前 &lt;!--estimator_sitename--&gt;</option>';
    $tool
        .= '<option value="&lt;!--estimator_url--&gt;&lt;!--/estimator_url--&gt;">このサイトのURL &lt;!--estimator_url--&gt;</option>';
    $tool
        .= '<option value="&lt;!--estimator_company--&gt;&lt;!--/estimator_company--&gt;">このサイトの著作権者 &lt;!--estimator_company--&gt;</option>';
    $tool .= '</select>';

    $this_template->print_template_form(
        'data:' . $id . 'template',
        'ページテンプレート',
        \$main::data{ $key . 'template' },
        \$tool,
        'ページテンプレート中に &lt;html&gt; タグおよび &lt;body&gt; タグがある場合、各ページレイアウト設定よりページテンプレートが優先されます。'
    );
}

######################################################################
#sub import {
BEGIN {
    #クラス登録
    Common::class_register( 'c004', 'EstimatePage' );

    #ツール登録
    $setting::sub_jump_menu{'page'}{'c004'} = '見積もり印刷 ページ';
    $setting::selected_jump_menu{'c004'} = 't000'
        ; #サブメニューがあるときメインメニューのデフォルトキー

    $preference::page{'c004'} = 'estimate'
        if !defined $preference::page{'c004'};
}

1;
