package InfoPage;
require CMONOS::CGI_Lib::Tools::Page;
@ISA = qw(Page);
use strict;
use utf8;
######################################################################
# お支払い関連説明ページ設定モジュール
# InfoPage.pm ver1.0.2
# Copyright (C) 1999-2018 CMONOS Co. Ltd.
#
# support@cmonos.jp
# http://cmonos.jp/
# 最終更新日：2012-03-15
######################################################################
# 設定環境
sub set_sub_preferences ($) {
    my $this = shift;
    $preference::id = 'info';    # データキー
    $preference::name = 'お支払い関連説明ページレイアウト'
        ;                        # 設定パネル名
    $preference::title
        = 'お支払い関連説明ページのレイアウトについて設定します。';
    $preference::ssi         = 1;
    $preference::static_page = 1
        if !$preference::static_page;    #HTMLファイル
}

######################################################################
# 設定チェック
sub is_valid_setting ($) {
    my $this = shift;

    #ナビメーカーに CGI の名前を登録する
    my $navi_db = $default::preference_dir;
    if ( $navi_db =~ s![0-9a-zA-Z_]+$!navimaker/navi_db! ) {
        my ( %navi, $update );
        use Fcntl qw(:DEFAULT);
        eval 'use ' . $env::dbm_file . ';';
        tie( %navi, $env::dbm_file, $navi_db, O_RDWR, $env::dbm_mode );
        if ( ref tied %navi ) {
            my $k = 'orderPaymentInfo_title';
            utf8::encode($k) if utf8::is_utf8($k);
            if ( defined $navi{$k} ) {
                my $title
                    = $main::data{'info_title'}
                    || $setting::general{'cginame'}
                    || 'お支払い方法および送料について';
                if ( $this->decode_utf8( $navi{$k} ) ne $title ) {
                    $navi{$k} = $this->encode_utf8($title);
                    $update = 1;
                }
            }
        }
        untie %navi;
        if ($update) {
            require CMONOS::CGI_Lib::NavUpdate;
            NavUpdate->new->update;
        }
    }

}

######################################################################
# 設定パネル
sub print_sub_preference_panel ($$$) {
    my ( $this, $id, $key ) = @_;
    print
        '<fieldset><legend><label for="data:info_table">お支払い方法テーブルタイプ</label></legend>';
    print $this->table_menu( 'data:info_table', $main::data{'info_table'} );
    print '</fieldset>';
    print
        '<fieldset><legend><label for="data:info_carriagetable">送料テーブルタイプ</label></legend>';
    print $this->table_menu( 'data:info_carriagetable',
        $main::data{'info_carriagetable'} );
    print '</fieldset>';
    return;
}

######################################################################
#sub import {
BEGIN {
    #クラス登録
    Common::class_register( 'c010', 'InfoPage' );

    #ツール登録
    $setting::sub_jump_menu{'page'}{'c010'}
        = 'お支払い関連説明ページ';
    $setting::selected_jump_menu{'c010'} = 't000'
        ; #サブメニューがあるときメインメニューのデフォルトキー

    $preference::page{'c010'} = 'info';
}

1;
