package TableViewer;
require CMONOS::TableMaker::Viewer;
@ISA = qw(Viewer);
use strict;
use utf8;
######################################################################
# テーブルビューワモジュール
# TableViewer.pm ver1.1.7
# Copyright (C) 1999-2018 CMONOS Co. Ltd.
#
# support@cmonos.jp
# http://cmonos.jp/
# 最終更新日：2013-09-23
######################################################################
sub set_delete_this_js ($) {
    my $this = shift;
    my $js   = <<'JAVASCRIPT';
cmonos.form.deleteRecord = function (c,n) {
	this_form = this.currentForm;
	this_field = this.currentField;
	this_field.className = this_field.className.replace(/-(visited|active)$/,'') + '-active';
	record_id = 'n' + c + '-' + n;
	var hash = new Array();
	for (var i=0; i < this_form.elements.length; i++) {
		if (typeof this_form.elements[i].name != "undefined" && this_form.elements[i].name != "" && (typeof this_form.elements[i].value == "string" || typeof this_form.elements[i].value == "number") && typeof this_form.elements[i].type != "undefined" && this_form.elements[i].type != null && this_form.elements[i].type == 'hidden') {
			hash[this_form.elements[i].name] = this.setHashValue(hash[this_form.elements[i].name],this_form.elements[i].value);
		}
	}
	cmonos.form.item(this_form).enabled(false);
	hash["delete"] = "1";
	hash["ajax"] = "1";
	cmonos.xml.request(
		this_form.action, 
		{
			method: 'post',
			parameters: cmonos.value.urlEncode(hash), 
			onFailure: function(){
				alert("error!");
				cmonos.form.item(this_form).enabled(true);
				this_field.className = this_field.className.replace(/-active$/,"");
			},
			onSuccess: function(transport){
				var response_hash = cmonos.value.urlDecode(transport.responseText);
				cmonos.form.item(this_form).enabled(true);
				this_field.className = this_field.className.replace(/-active$/,"");
				if (response_hash["status"] == "success") {
					cmonos.element.item(record_id).addClassName('deleted');
				} else if (response_hash["status"] == "error") {
					alert((response_hash["message"] != null) ? response_hash["message"] : 'error!');
				}
			}
		}
	);
	return false;
}
JAVASCRIPT
    $this->set_javascript($js);
}

######################################################################
# コンテンツヘッダ
sub print_contents_header ($) {
    my $this = shift;
    use Fcntl qw(:DEFAULT);
    eval 'use ' . $env::dbm_file . ';';

    #ツールボックス
    $this->print_toolbox_top;

    #前後ページへのジャンプ
    $this->print_page_jump_form;

    $this->{'Table'} = Table->new;
    if ( defined $setting::page{$setting::key}{'table'} ) {
        if ( ref $table::obj{ $setting::page{$setting::key}{'table'} } ) {
            %{ $this->{'Table'} }
                = %{ $table::obj{ $setting::page{$setting::key}{'table'} } };
        }
        elsif (
            defined $setting::table{ $setting::page{$setting::key}{'table'} }
            {'setting'}
            && $setting::table{ $setting::page{$setting::key}{'table'} }
            {'setting'} )
        {
            $this->{'Table'}->set(
                $setting::table{ $setting::page{$setting::key}{'table'} }
                    {'setting'} );
            $this->{'Table'}->{'name'}
                = $setting::table{ $setting::page{$setting::key}{'table'} }
                {'name'};
        }
    }

    #修正ボタン
    if ( defined $this->{'revForm'} && $this->{'revForm'} ) {
        $this->{'cellWidth'}  .= ',' if defined $this->{'cellWidth'};
        $this->{'cellWidth'}  .= '100';
        $this->{'cellAlign'}  .= ',' if defined $this->{'cellAlign'};
        $this->{'cellAlign'}  .= 'center';
        $this->{'cellValign'} .= ',' if defined $this->{'cellValign'};
        $this->{'cellValign'} .= 'middle';
    }

    $this->{'Table'}->set(
        'width'   => $this->{'cellWidth'},
        'align0'  => $this->{'cellAlign'},
        'alignH'  => 'center',
        'valign0' => $this->{'cellValign'},
        'valignH' => 'middle',
        'tableid' => 'table-viewer'
    );
    $this->{'cellspace'} = 0;
    $this->{'cellspace'} += $this->{'Table'}->{'cellpadding'} * 2
        if defined $this->{'Table'}->{'cellpadding'}
        && $this->{'Table'}->{'cellpadding'} !~ /[^0-9]/
        && $this->{'Table'}->{'cellpadding'} > 0;
    $this->{'cellspace'} += $this->{'Table'}->{'cellspacing'} * 2
        if defined $this->{'Table'}->{'cellspacing'}
        && $this->{'Table'}->{'cellspacing'} !~ /[^0-9]/
        && $this->{'Table'}->{'cellspacing'} > 0;
    $this->{'cellspace'} += $this->{'Table'}->{'border'}
        if defined $this->{'Table'}->{'border'}
        && $this->{'Table'}->{'border'} !~ /[^0-9]/
        && $this->{'Table'}->{'border'} > 0;

    #テーブル開始
    my $handle = $this->{'filehandle'};
    print $handle ('<div id="table-viewer-box">');
    print $handle ( $this->{'Table'}->table );

    #フィールド名行
    print $handle ( $this->{'Table'}->tr );
    my $url = $cgi::path
        . $this->set_query( 'url',
        [ grep( $_ ne 'w' && $_ ne 's', @setting::form ) ] );
    foreach my $id ( @{ $this->{'required_fields'} } ) {
        next
            if !defined $id
            || !ref $field::obj{$id}
            || !$field::obj{$id}->usual_format_enabled;
        my $name = $field::obj{$id}->name;
        if (   !$field::obj{$id}->{'Hidden'}
            && ( $field::obj{$id}->{'Open'} || $this->is_secure('secret') )
            && $field::obj{$id}->sort_enabled
            && $field::obj{$id}->{'sortEnabled'} )
        {
            $name = '<a href="'
                . $this->escape(
                $url
                    . $this->add_query(
                    'url',
                    {   's' => $id,
                        'w' => (
                              ( $main::s eq $id )
                            ? ( $main::w eq 'descend' )
                                    ? 'ascend'
                                    : 'descend'
                            : $main::w
                        )
                    }
                    )
                )
                . '" title="'
                . (
                ($default::english)
                ? 'sort this column in '
                    . (
                      ( $main::s eq $id )
                    ? ( $main::w eq 'descend' )
                            ? 'ascending'
                            : 'descending'
                    : ( $main::w eq 'descend' ) ? 'descending'
                    :                             'ascending'
                    )
                    . ' order.'
                : 'この項目で'
                    . ( ( $main::s eq $id )
                    ? ( $main::w eq 'descend' )
                            ? '昇順▲'
                            : '降順▼'
                    : ( $main::w eq 'descend' ) ? '降順▼'
                    :                             '昇順▲' )
                    . 'にソートする'
                )
                . '">'
                . $name . '</a>'
                . ( ($default::english)
                ? ( $main::s eq $id )
                        ? ( $main::w eq 'descend' )
                            ? ' <span class="sort-mark">&uarr;</span>'
                            : ' <span class="sort-mark">&darr;</span>'
                        : ''
                : ( $main::s eq $id ) ? ( $main::w eq 'descend' )
                        ? ' <span class="sort-mark">▼</span>'
                        : ' <span class="sort-mark">▲</span>'
                    : '' );
            print $handle (
                $this->{'Table'}->th(
                    $name,
                    ( ( $main::s eq $id ) ? { 'class' => 'sorted' } : {} )
                )
            );
        }
        else {
            print $handle ( $this->{'Table'}->th($name) );
        }
    }

    #修正ボタン
    print $handle ( $this->{'Table'}->td('修正') ) if $this->{'revForm'};

    print $handle ( $this->{'Table'}->_tr );

    if ( $setting::page{'newIconLimit'} || $setting::page{'upIconLimit'} ) {
        $this->{'key_field'} = (
            $field::for{'key'} && grep( $_ eq $field::for{'key'},
                @{ $this->{'required_fields'} } )
            )
            ? $field::for{'key'}
            : (
            $field::for{'title'}
                && grep( $_ eq $field::for{'title'},
                @{ $this->{'required_fields'} } )
            ) ? $field::for{'title'}
            : '';
    }

}

######################################################################
# コンテンツフッタ
sub print_contents_footer ($) {
    my $this = shift;

    #テーブル終了
    my $handle = $this->{'filehandle'};
    print $handle ( $this->{'Table'}->_table );
    print $handle ('</div>');

    #前後ページへのジャンプ
    $this->print_page_jump_form;

    $this->print_toolbox_bottom;
    $this->print_download_form;
    $this->print_page_return_form;

}

######################################################################
# レコード
sub print_record ($$$) {
    my ( $this, $c, $n ) = @_;
    $this->set_title_link( $c, $n );
    my $path   = "$default::file/$c/$n";
    my $handle = $this->{'filehandle'};
    print $handle ( $this->{'Table'}->tr( { 'id' => 'n' . $c . '-' . $n } ) );
    foreach my $id ( @{ $this->{'required_fields'} } ) {
        if (   defined $id
            && ref $field::obj{$id}
            && $field::obj{$id}->usual_format_enabled )
        {
            my $db = $field::obj{$id}->db;
            unless ( !$db || ref tied %{ $this->{'DB'}{$c}{$db} } ) {
                tie( %{ $this->{'DB'}{$c}{$db} },
                    $env::dbm_file, "$default::db/$c/$db", O_RDONLY,
                    $env::dbm_mode );
            }
            $field::obj{$id}->{'maxwidth'} = $field::obj{$id}->{'cellWidth'}
                - ( $this->{'cellspace'} * 2 );
            print $handle (
                $this->{'Table'}->td(
                    $field::obj{$id}->usual_format(
                        (   ($db) ? $this->decode_utf8(
                                $this->{'DB'}{$c}{$db}
                                    { $this->encode_utf8($n) }
                            ) : ''
                        ),
                        $path, $c, $n
                        )
                        . (
                        (          $this->{'key_field'}
                                && $id eq $this->{'key_field'}
                        ) ? $this->new_item_icon( $c, $n ) : ''
                        )
                )
            );
        }
    }

    #修正ボタン
    print $handle ( $this->{'Table'}
            ->td( $this->get_rev_buttons( $c, $n, 'tmedit', 'tmdelete' ) ) )
        if $this->{'revForm'};

    print $handle ( $this->{'Table'}->_tr );
    $this->clear_title_link;
}

######################################################################
# フィールド設定
sub set_field_setting ($$) {
    my ( $this, $id ) = @_;
    $this->{'cellWidth'} .= ',' if defined $this->{'cellWidth'};
    $this->{'cellWidth'}  .= $field::obj{$id}->{'cellWidth'};
    $this->{'cellAlign'}  .= ',' if defined $this->{'cellAlign'};
    $this->{'cellAlign'}  .= $field::obj{$id}->{'cellAlign'};
    $this->{'cellValign'} .= ',' if defined $this->{'cellValign'};
    $this->{'cellValign'} .= $field::obj{$id}->{'cellValign'};
}

######################################################################
# クラス登録
#sub import {
BEGIN {

    $setting::field_style_disabled = 2
        ; #2=フォント設定スタイル設定を無視/1=フォント設定のみ無視
    $setting::field_tag_enabled
        = 'no'; #tag=タグのみ/all=全ての設定/no=タグをつけない

    #設定種キー設定
    $setting::key = 'viewer'
        if !defined $setting::key || !$setting::key;    #ページ設定キー

    #デフォルトキー
    $main::k = 'viewer' if !defined $main::k || !$main::k;

    #クラス登録
    Common::class_register( 'viewer', 'TableViewer' );
}

1;
