package GatePage;
require CMONOS::CGI_Lib::Tools::Page;
@ISA = qw(Page);
use strict;
use utf8;
######################################################################
# データ修正レコード選択ページ設定モジュール
# GatePage.pm ver1.0.1
# Copyright (C) 1999-2018 CMONOS Co. Ltd.
#
# support@cmonos.jp
# http://cmonos.jp/
# 最終更新日：2012-03-15
######################################################################
# 設定項目取得
sub get_sub_setting_items ($) {
    no warnings qw(once);
    my $this = shift;

    #タグ除去
    push( @check::notag, 'reviseButton', 'newDataButton' );

    #数字チェック
    $check::num{'u'} = '1ページ表示数';

    return;
}

######################################################################
# 設定環境
sub set_sub_preferences ($) {
    no warnings qw(once);
    my $this = shift;
    $preference::id = 'gate';    # データキー
    $preference::name = '修正レコード選択ページレイアウト'
        ;                        # 設定パネル名
    $preference::title
        = '修正レコード選択ページのレイアウトについて設定します。';
}

######################################################################
# 設定パネル
sub print_sub_preference_panel ($$$) {
    my ( $this, $id, $key ) = @_;
    $this->use_field( 'field', $default::field_pref_dir . '/inputfield', 2 );

    print '<fieldset>';
    print '<legend>一覧表示設定</legend>';

    print '<table class="field-table">';
    print '<tbody>';
    print '<tr>';
    print '<td class="field-name"><label for="data:' . $id
        . 'table">テーブルタイプ</label></td>';
    print '<td class="field" colspan="3">';
    print $this->table_menu( 'data:' . $id . 'table',
        $main::data{ $key . 'table' } );
    print '</td>';
    print '</tr>';

    print '<tr>';
    print '<td class="field-name"><label for="data:' . $id
        . 's">ソート項目のデフォルト</label></td>';
    print '<td class="q-field"><select name="data:'
        . $id
        . 's" id="data:'
        . $id . 's">';
    print '<option value=""></option>';

    foreach ( sort { $a <=> $b } keys %field::ORDER ) {
        next
            unless ref $field::obj{ $field::ORDER{$_} }
            && $field::obj{ $field::ORDER{$_} }->sort_enabled
            && $field::obj{ $field::ORDER{$_} }->{'sortEnabled'};
        print '<option value="'
            . $field::ORDER{$_} . '"'
            . (
            (   defined $main::data{ $key . 's' }
                    && $main::data{ $key . 's' } eq $field::ORDER{$_}
            ) ? ' selected="selected"' : ''
            )
            . '>'
            . $this->jfold( $field::obj{ $field::ORDER{$_} }->name, 24, 'I',
            1 )
            . '</option>';
    }
    print '</select>';
    print '</td>';
    print '<td class="field-name"><label for="data:' . $id
        . 'w">ソート方法のデフォルト</label></td>';
    print '<td class="q-field">';
    print $this->mk_select_menu(
        'data:' . $id . 'w', '', '', $main::data{ $key . 'w' },
        'ascend'  => '昇順',
        'descend' => '降順'
    );
    print '</td>';
    print '</tr>';

    print '<tr>';
    print '<td class="field-name"><label for="data:' . $id
        . 'selectedField">一覧表示項目</label></td>';
    print '<td class="q-field"><select name="data:'
        . $id
        . 'selectedField" id="data:'
        . $id
        . 'selectedField" multiple="multiple" title="無選択の場合「テーブル表示デフォルト」項目が表示されます。">';

    $this->scalar_to_array( \$main::data{ $key . 'selectedField' } );
    foreach ( sort { $a <=> $b } keys %field::ORDER ) {
        my $id = $field::ORDER{$_};
        next
            unless ref $field::obj{$id}
            && !$field::obj{$id}->{'Hidden'}
            && $field::obj{$id}->usual_format_enabled;
        print '<option value="'
            . $id . '"'
            . (
            (   ref $main::data{ $key . 'selectedField' } && grep( $_ eq $id,
                    @{ $main::data{ $key . 'selectedField' } } )
            ) ? ' selected="selected"' : ''
            )
            . '>'
            . $this->jfold( $field::obj{$id}->name, 24, 'I', 1 )
            . '</option>';
    }

    print '</select></td>';
    print '<td class="field-name"><label for="data:' . $id
        . 'u">1ページ表示数</label></td>';
    print '<td class="q-field"><input type="text" name="data:'
        . $id
        . 'u" id="data:'
        . $id
        . 'u" value="'
        . $this->escape( $main::data{ $key . 'u' } )
        . '" size="3" />';
    print '</td>';
    print '</tr>';
    print '</tbody></table></fieldset>';

}

######################################################################
#sub import {
BEGIN {
    no warnings qw(once);

    #クラス登録
    Common::class_register( 't021', 'GatePage' );

    #ツール登録
    $setting::sub_jump_menu{'page'}{'t021'}
        = '修正レコード選択ページ';
    $setting::selected_jump_menu{'t021'} = 't000'
        ; #サブメニューがあるときメインメニューのデフォルトキー

    $preference::page{'t021'} = 'gate';
}

1;
