package ThanksMsg;
require CMONOS::CGI_Lib::Tools::Preference;
@ISA = qw(Preference);
use strict;
use utf8;
######################################################################
# 入力お礼設定モジュール
# ThanksMsg.pm ver1.1.1
# Copyright (C) 1999-2018 CMONOS Co. Ltd.
#
# support@cmonos.jp
# http://cmonos.jp/
# 最終更新日：2009-11-14
######################################################################
# 設定チェック項目
sub get_setting_items ($) {
    my $this = shift;
    no warnings qw(once);
    push( @check::checkbox, 'shortpaymentinfo' )
        if $default::type && $default::type eq 'order';
}

# 設定環境
sub set_preferences ($) {
    no warnings qw(once);
    my $this = shift;
    $preference::db = 'thanks';    # 記録用データベース名
    $preference::name
        = $ThanksMsg::name . 'お礼設定';    # 設定パネル名
    $preference::title
        = ( $default::type && $default::type eq 'order' )
        ? '新しい注文があったときに表示する注文お礼を設定します。'
        : 'データ修正権限のないユーザーがデータ入力をしたときに表示する入力お礼を設定します。';
}

######################################################################
# 設定パネル
sub print_preference_panel ($) {
    my $this = shift;

    #フィールド設定読み込み
    $this->use_field( 'field', $default::field_pref_dir . '/inputfield', 2 );
    my $mail_field_flag
        = (    $field::for{'mail'}
            && ref $field::obj{ $field::for{'mail'} }
            && $field::obj{ $field::for{'mail'} }->{'e-mail'} ) ? 1 : 0;
    my $keyfield_name
        = ( $field::for{'key'} && ref $field::obj{ $field::for{'key'} } )
        ? '（' . $field::obj{ $field::for{'key'} }->name . '）'
        : '';
    my $titlefield_name
        = ( $field::for{'title'} && ref $field::obj{ $field::for{'title'} } )
        ? '（' . $field::obj{ $field::for{'title'} }->name . '）'
        : '';
    my $namefield_name
        = ( $field::for{'name'} && ref $field::obj{ $field::for{'name'} } )
        ? '（' . $field::obj{ $field::for{'name'} }->name . '）'
        : '';
    print '<fieldset><legend>'
        . $ThanksMsg::name
        . 'お礼設定 <span class="note">('
        . ( ( $default::type && $default::type eq 'order' )
        ? '新しい注文があったとき'
        : 'データ修正権限のないユーザーがデータ入力をしたときにのみ'
        ) . '表示されます)</span></legend>';
    print '<table class="field-table"><tbody>';
    print '<tr>';
    print '<td class="field-name"><label for="data:thankstitle">'
        . $ThanksMsg::name
        . 'お礼タイトル</label></td>';
    print
        '<td class="field"><input type="text" name="data:thankstitle" id="data:thankstitle" size="72" value="'
        . $this->escape( $main::data{'thankstitle'} )
        . '" /></td>';
    print '</tr>';
    print '<tr>';
    print '<td class="field-name"><label for="data:thanks">'
        . $ThanksMsg::name
        . 'お礼</label></td>';
    print '<td class="field">';
    print
        '<textarea name="data:thanks" id="data:thanks" cols="72" rows="15" wrap="soft" class="content-editor-area">'
        . $this->escape( $main::data{'thanks'} )
        . '</textarea>';
    print '<div class="toolbox">';
    print
        '<select class="tool" onchange="cmonos.form.item(this.form).fieldname(\'data:thanks\').quotationByMenu(this)" title="これらのタグはお礼表示時に対応する値に変換されます。">';
    print '<option value="">▼挿入する</option>';
    print '<option value="&lt;name&gt;">&lt;name&gt;[名前フィールド'
        . $namefield_name
        . 'の値]</option>';
    print '<option value="&lt;key&gt;">&lt;key&gt;[キーフィールド'
        . $keyfield_name
        . 'の値]</option>';
    print
        '<option value="&lt;title&gt;">&lt;title&gt;[タイトルフィールド'
        . $titlefield_name
        . 'の値]</option>';
    print '</select>';
    print '</div>';
    print '</td>';
    print '</tr>';
    print '</tbody></table>';
    print '</fieldset>';

    if ( !defined $mail_field_flag || !$mail_field_flag ) {
        print '<fieldset><legend>自動返信設定 <span class="note">('
            . ( ( $default::type && $default::type eq 'order' )
            ? '新しい注文があったとき、'
            : 'データ修正権限のないユーザーがデータ入力をしたときにのみ、'
            )
            . '代表メールフィールドに入力されたアドレスへ送信されます)</span></legend>代表メールフィールドが存在しないので、自動返信機能は利用できません。<br />入力フィールド設定で代表メールフィールドを指定してください。';

    }
    else {
        print '<fieldset><legend>自動返信設定 <span class="note">('
            . ( ( $default::type && $default::type eq 'order' )
            ? '新しい注文があったとき、'
            : 'データ修正権限のないユーザーがデータ入力をしたときにのみ、'
            )
            . $field::obj{ $field::for{'mail'} }->name
            . 'へ送信されます)</span></legend>';
        print '<table class="field-table"><tbody>';
        print '<tr>';
        print
            '<td class="field-name"><label for="data:ressubject">自動返信メールの表題</label></td>';
        print
            '<td class="field"><input type="text" name="data:ressubject" id="data:ressubject" size="72" value="'
            . $this->escape( $main::data{'ressubject'} )
            . '" /></td>';
        print '</tr>';
        print '<tr>';
        print
            '<td class="field-name"><label for="data:resmsg">自動返信メールの本文</label></td>';
        print '<td class="field">';
        print
            '<textarea name="data:resmsg" id="data:resmsg" cols="72" rows="15" wrap="soft">'
            . $this->escape( $main::data{'resmsg'} )
            . '</textarea>';
        print '<div class="toolbox">';
        print
            '<select class="tool" onchange="cmonos.form.item(this.form).fieldname(\'data:resmsg\').quotationByMenu(this)" title="これらのタグはメール送信時に対応する値に変換されます。">';
        print '<option value="">▼挿入する</option>';
        print
            '<option value="&lt;name&gt;">&lt;name&gt;[名前フィールド'
            . $namefield_name
            . 'の値]</option>';
        print '<option value="&lt;key&gt;">&lt;key&gt;[キーフィールド'
            . $keyfield_name
            . 'の値]</option>';
        print
            '<option value="&lt;title&gt;">&lt;title&gt;[タイトルフィールド'
            . $titlefield_name
            . 'の値]</option>';
        print
            '<option value="&lt;record&gt;">&lt;record&gt;[レコード番号]</option>';
        print
            '<option value="&lt;url&gt;">&lt;url&gt;[詳細ページのURL]</option>';
        print
            '<option value="&lt;input&gt;">&lt;input&gt;[修正ページのURL]</option>';
        print
            '<option value="&lt;register&gt;">&lt;register&gt;[アドレス登録のURL]</option>';
        print
            '<option value="&lt;data&gt;">&lt;data&gt;[データの一覧]</option>';
        print '</select>';
        print '</div>';
        print '</td>';
        print '</tr>';

        if ( $default::type && $default::type eq 'order' ) {
            print '<tr>';
            print
                '<td class="field-name"><label for="data:ressubject">支払い方法省略</label></td>';
            print
                '<td class="field"><label><input type="checkbox" name="data:shortpaymentinfo" id="data:shortpaymentinfo" value="1"'
                . ( ( $main::data{'shortpaymentinfo'} )
                ? 'checked="checked"'
                : '' )
                . ' /> 「支払い方法」フィールドタイプを「公開範囲」のみ書き出す。</label></td>';
            print '</tr>';
        }
        print '</tbody></table>';
    }
    print '</fieldset>';

    print
        '<fieldset class="submit"><input type="submit" value="保存" class="save" /></fieldset>';

}

######################################################################
# クラス登録
#sub import {
BEGIN {
    no warnings qw(once);
    $ThanksMsg::name
        = ( $default::type && $default::type eq 'order' )
        ? '注文'
        : '入力';

    #クラス登録
    Common::class_register( 't200', 'ThanksMsg' );

    #ツール登録
    $setting::jump_menu{'t200'} = $ThanksMsg::name . 'お礼設定';
}

1;
