package GeneralSetting;
require CMONOS::CGI_Lib::Tools::General;
@ISA = qw(General);
use strict;
use utf8;
######################################################################
# Yahoo検索一般設定モジュール
# GeneralSetting.pm ver1.0.1
# Copyright (C) 1999-2018 CMONOS Co. Ltd.
#
# support@cmonos.jp
# http://cmonos.jp/
# 最終更新日：2010-05-07
######################################################################
# 設定チェック項目取得
sub get_sub_setting_items ($) {
    my $this = shift;

    #チェックボックス
    push( @check::checkbox, 'vicunaCompatible' );

    #カラー書式チェック
    $check::color{'cloudFontColor'} = 'クラウド文字色';
    $check::color{'cloudBgColor'}   = 'クラウド背景色';
    $check::color{'cloudBgColor'}   = 'クラウド枠線色';

    #数字チェック
    $check::num{'rank'}      = 'ランク';
    $check::num{'limit'}     = '表示数';
    $check::num{'necessary'} = '最高ランクの最小値';
    $check::num{'maxsize'}   = '一番小さな文字の大きさ';
    $check::num{'minsize'}   = '一番大きな文字の大きさ';
    $check::num{'border'}    = 'クラウド枠線幅';
    $check::num{'radius'}    = 'クラウド枠線角丸半径';
    $check::num{'pickup'}    = '新着ワードクラウドのワード数';
    $check::num{'results'}   = '1ページあたりの検索結果表示数';
    $check::num{'datelimit'} = '最終更新日時の表示';

    return;
}

######################################################################
# サブ設定パネル
sub print_sub_preference_panel ($$) {
    my ( $this, $master ) = @_;

    print
        '<fieldset><legend><label for="data:appid">Yahoo! API <a href="http://developer.yahoo.co.jp/faq/#appid" target="_blank">アプリケーションID</a></label></legend>';
    print
        '<input type="text" size="32" name="data:appid" id="data:appid" value="'
        . $this->escape( $main::data{'appid'} ) . '" />';
    print '<div class="warning">';
    print
        'Yahoo!検索 によるサイト検索については、各ユーザーがそれぞれ個別に <a href="http://developer.yahoo.co.jp/search/" target="_blank">Yahoo!検索 Web サービス</a> を利用するものとみなします。';
    print
        '<a href="http://developer.yahoo.co.jp/search/" target="_blank">Yahoo!検索 Web サービス</a> は、<a href="http://www.yahoo.co.jp">Yahoo! JAPAN</a> が<strong>無保証</strong>で提供しているウェブ API サービスです。';
    print
        'Yahoo! JAPAN の判断でサービスが停止されたり、サービスの利用を拒否されることがあります。';
    print
        'この CGI は実験的に無償で追加されたものであり、あらゆるサポートの対象外です。将来のバージョンで削除されることがあります。</div>';
    print '</fieldset>';

    print '<fieldset><legend>検索ワードクラウド設定</legend>';
    print
        '<label><input type="checkbox" name="data:vicunaCompatible" value="1"'
        . ( ( $main::data{'vicunaCompatible'} ) ? ' checked="checked"' : '' )
        . ' onclick="cmonos.element.item(\'cloud-settings\').disappear(this.checked)" /> Vicuna CMS 互換検索ワードクラウドを書き出す</label>';
    print '<table class="field-table" id="cloud-settings"><tbody>';

    print '<tr>';
    print
        '<td class="field-name"><label for="data:rank">ランク</label></td>';
    print
        '<td class="field"><input type="number" size="3" maxlength="3" name="data:rank" id="data:rank" value="'
        . $this->escape( $main::data{'rank'} )
        . '" /> 段階</td>';
    print '</tr>';

    print '<tr>';
    print
        '<td class="field-name"><label for="data:limit">表示数</label></td>';
    print
        '<td class="field"><input type="number" size="3" maxlength="3" name="data:limit" id="data:limit" value="'
        . $this->escape( $main::data{'limit'} )
        . '" /> ワード</td>';
    print '</tr>';

    print '<tr class="tbody-end">';
    print
        '<td class="field-name"><label for="data:necessary">最高ランクの最小値</label></td>';
    print
        '<td class="field"><input type="number" size="3" maxlength="3" name="data:necessary" id="data:necessary" value="'
        . $this->escape( $main::data{'necessary'} )
        . '" /> 回</td>';
    print '</tr>';

    print '</tbody><tbody>';

    print '<tr>';
    print
        '<td class="field-name"><label for="data:maxsize">一番大きな文字の大きさ</label></td>';
    print
        '<td class="field">標準文字サイズの <input type="number" size="6" step="0.01" name="data:maxsize" id="data:maxsize" value="'
        . $this->escape( $main::data{'maxsize'} )
        . '" /> 倍</td>';
    print '</tr>';

    print '<tr class="tbody-end">';
    print
        '<td class="field-name"><label for="data:minsize">一番小さな文字の大きさ</label></td>';
    print
        '<td class="field">標準文字サイズの <input type="number" size="6" step="0.01" name="data:minsize" id="data:minsize" value="'
        . $this->escape( $main::data{'minsize'} )
        . '" /> 倍</td>';
    print '</tr>';

    print '</tbody><tbody>';

    print '<tr>';
    print
        '<td class="field-name"><label for="data:cloudFontColor">クラウド文字色</label></td>';
    print
        '<td class="field"><input type="text" name="data:cloudFontColor" id="data:cloudFontColor" size="7" maxlength="7" onclick="cmonos.tool.colorPalette.open(\'data:cloudFontColor\',\'dom\')" onchange="cmonos.validate.field(this).asColor()" value="'
        . $this->escape( $main::data{'cloudFontColor'} ) . '"'
        . ( ( $main::data{'cloudFontColor'} )
        ? ' style="background-color: ' . $main::data{'cloudFontColor'} . '"'
        : '' )
        . ' />';
    print
        ' <a href="JavaScript:cmonos.tool.colorPalette.open(\'data:cloudFontColor\')" ondblclick="cmonos.tool.colorPalette.open(\'data:cloudFontColor\',\'window\')"><img src="'
        . $env::image_dir
        . '/tool/palette.gif" alt="パレット" height="12" width="18" border="0" /></a>';
    print
        ' <a href="JavaScript:cmonos.tool.colorSlider.open(\'data:cloudFontColor\')" ondblclick="cmonos.tool.colorSlider.open(\'data:cloudFontColor\',\'window\')"><img src="'
        . $env::image_dir
        . '/tool/picker.gif" alt="カラーピッカー" height="12" width="18" border="0" /></a></td>';
    print '</tr>';

    print '<tr>';
    print
        '<td class="field-name"><label for="data:cloudBgColor">クラウド背景色</label></td>';
    print
        '<td class="field"><input type="text" name="data:cloudBgColor" id="data:cloudBgColor" size="7" maxlength="7" onclick="cmonos.tool.colorPalette.open(\'data:cloudBgColor\',\'dom\')" onchange="cmonos.validate.field(this).asColor()" value="'
        . $this->escape( $main::data{'cloudBgColor'} ) . '"'
        . ( ( $main::data{'cloudBgColor'} )
        ? ' style="background-color: ' . $main::data{'cloudBgColor'} . '"'
        : '' )
        . ' />';
    print
        ' <a href="JavaScript:cmonos.tool.colorPalette.open(\'data:cloudBgColor\')" ondblclick="cmonos.tool.colorPalette.open(\'data:cloudBgColor\',\'window\')"><img src="'
        . $env::image_dir
        . '/tool/palette.gif" alt="パレット" height="12" width="18" border="0" /></a>';
    print
        ' <a href="JavaScript:cmonos.tool.colorSlider.open(\'data:cloudBgColor\')" ondblclick="cmonos.tool.colorSlider.open(\'data:cloudBgColor\',\'window\')"><img src="'
        . $env::image_dir
        . '/tool/picker.gif" alt="カラーピッカー" height="12" width="18" border="0" /></a></td>';
    print '</tr>';

    print '<tr>';
    print
        '<td class="field-name"><label for="data:borderColor">クラウド枠線色</label></td>';
    print
        '<td class="field"><input type="text" name="data:borderColor" id="data:borderColor" size="7" maxlength="7" onclick="cmonos.tool.colorPalette.open(\'data:borderColor\',\'dom\')" onchange="cmonos.validate.field(this).asColor()" value="'
        . $this->escape( $main::data{'borderColor'} ) . '"'
        . ( ( $main::data{'borderColor'} )
        ? ' style="background-color: ' . $main::data{'borderColor'} . '"'
        : '' )
        . ' />';
    print
        ' <a href="JavaScript:cmonos.tool.colorPalette.open(\'data:borderColor\')" ondblclick="cmonos.tool.colorPalette.open(\'data:borderColor\',\'window\')"><img src="'
        . $env::image_dir
        . '/tool/palette.gif" alt="パレット" height="12" width="18" border="0" /></a>';
    print
        ' <a href="JavaScript:cmonos.tool.colorSlider.open(\'data:borderColor\')" ondblclick="cmonos.tool.colorSlider.open(\'data:borderColor\',\'window\')"><img src="'
        . $env::image_dir
        . '/tool/picker.gif" alt="カラーピッカー" height="12" width="18" border="0" /></a></td>';
    print '</tr>';

    print '<tr>';
    print
        '<td class="field-name"><label for="data:border">クラウド枠線幅</label></td>';
    print
        '<td class="field"><input type="number" size="3" maxlength="3" name="data:border" id="data:border" value="'
        . $this->escape( $main::data{'border'} )
        . '" /> px</td>';
    print '</tr>';

    print '<tr>';
    print
        '<td class="field-name"><label for="data:radius">クラウド枠線角丸半径</label></td>';
    print
        '<td class="field"><input type="number" size="3" maxlength="3" name="data:radius" id="data:radius" value="'
        . $this->escape( $main::data{'radius'} )
        . '" /> px</td>';
    print '</tr>';

    print '<tr>';
    print
        '<td class="field-name"><label for="data:radius">クラウド枠線スタイル</label></td>';
    print '<td class="field">';
    print $this->mk_select_menu(
        'data:borderStyle', '', '', $main::data{'borderStyle'},
        'solid'  => '線',
        'dashed' => '破線',
        'dotted' => '点線',
        'double' => '二重線',
        'groobe' => '立体的な線(凹)',
        'ridge'  => '立体的な線(凸)',
        'inset'  => '陥没',
        'outset' => '隆起',
    );
    print '</td>';
    print '</tr>';

    print '</tbody></table>';
    print '</fieldset>';

    print
        '<fieldset><legend><label for="data:pickup">新着ワードクラウドのワード数</label></legend>';
    print
        '<input type="number" size="3" maxlength="3" name="data:pickup" id="pickup" value="'
        . $this->escape( $main::data{'pickup'} )
        . '" /> ワード';
    print '</fieldset>';

    print '<fieldset><legend>検索結果表示設定</legend>';
    print '<table class="field-table"><tbody>';

    print '<tr>';
    print
        '<td class="field-name"><label for="data:results">1ページ当たりの検索結果表示数</label></td>';
    print
        '<td class="field"><input type="number" size="3" maxlength="3" name="data:results" id="data:results" value="'
        . $this->escape( $main::data{'results'} )
        . '" /> (&lt;50)</td>';
    print '</tr>';

    print '</tbody><tbody>';

    print '<tr>';
    print
        '<td class="field-name"><span class="datatitle">最終更新日の表示</span></td>';
    print
        '<td class="field"><label><input type="number" name="data:datelimit" id="data:datelimit" size="3" maxlength="3" value="'
        . $this->escape( $main::data{'datelimit'} )
        . '" /> 日以内なら相対日時で表現する（きょう/きのう/○日前）</label></td>';
    print '</tr>';

    print '<tr>';
    print
        '<td class="field-name"><label for="data:datetype">最終更新日の書式</label></td>';
    print '<td class="field">';
    $this->print_date_type_menu( 'data:', $main::data{'datetype'},
        '最終更新日の書式を設定します。', '>d' );
    print '</td>';
    print '</tr>';

    print '</tbody></table>';
    print '</fieldset>';

    print $this->javascript(
        "cmonos.element.item('cloud-settings').disappear(true);")
        if $main::data{'vicunaCompatible'};
}

######################################################################
# サブ設定チェック
sub _is_valid_setting ($) {
    my $this = shift;
    $main::data{'results'} = 50
        if $main::data{'results'} && $main::data{'results'} > 50;
    $main::data{'maxsize'} = 3   if !$main::data{'maxsize'};
    $main::data{'minsize'} = 0.7 if !$main::data{'minsize'};
    if ( $main::data{'maxsize'} < $main::data{'minsize'} ) {
        my $temp = $main::data{'maxsize'};
        $main::data{'maxsize'} = $main::data{'minsize'};
        $main::data{'minsize'} = $temp;
    }
    return;
}

sub update_settings ($) {
    my $this = shift;
    $this->write_file( "$env::css/ysearch-cloud.css", $this->word_cloud_css,
        1 );
    return;
}

######################################################################
# クラウドCSS
sub word_cloud_css ($) {
    my $this = shift;
    my $css  = '';
    my @rank = ( 'a' .. 'z' );
    $main::data{'rank'} = 4
        if !$main::data{'rank'} || $main::data{'rank'} > 26;
    $main::data{'maxsize'} = 3   if !$main::data{'maxsize'};
    $main::data{'minsize'} = 0.7 if !$main::data{'minsize'};
    $css = "ul#searchword-cloud {\x0A";
    $css .= "  list-style: none;\x0A";
    $css .= "  margin: 1em auto;\x0A";

    if ( $main::data{'radius'} ) {
        $css .= '  padding: ' . $main::data{'radius'} . "px;\x0A";
        $css .= '  border-radius: ' . $main::data{'radius'} . "px;\x0A";
        $css .= '  -moz-border-radius: ' . $main::data{'radius'} . "px;\x0A";
        $css
            .= '  -webkit-border-radius: '
            . $main::data{'radius'}
            . "px;\x0A";
        $css .= '  -o-border-radius: ' . $main::data{'radius'} . "px;\x0A";
        $css .= '  -ms-border-radius: ' . $main::data{'radius'} . "px;\x0A";
    }
    elsif ( $main::data{'border'} ) {
        $css .= "  padding: 1em;\x0A";
    }
    else {
        $css .= "  padding: 0;\x0A";
    }
    $css .= '  color: ' . $main::data{'cloudFontColor'} . ";\x0A"
        if $main::data{'cloudFontColor'};
    $css .= '  background-color: ' . $main::data{'cloudBgColor'} . ";\x0A"
        if $main::data{'cloudBgColor'};
    if ( $main::data{'border'} ) {
        $css
            .= '  border: '
            . $main::data{'border'} . 'px'
            . (
            ( $main::data{'borderColor'} ) ? ' ' . $main::data{'borderColor'}
            : '' )
            . (
            ( $main::data{'borderStyle'} ) ? ' ' . $main::data{'borderStyle'}
            : '' )
            . ";\x0A";
    }
    $css .= "}\x0A";
    $css .= "ul#searchword-cloud li {\x0A";
    $css .= "  margin: 0 3px;\x0A";
    $css .= "  padding: 0;\x0A";
    $css .= "  display: inline;\x0A";
    $css .= '  font-size: ' . $main::data{'minsize'} . "em;\x0A";
    $css .= "}\x0A";
    $css .= "ul#searchword-cloud li a {\x0A";
    $css .= "  white-space: nowrap;\x0A";
    $css .= "  text-decoration: none;\x0A";
    $css .= '  color: ' . $main::data{'cloudFontColor'} . ";\x0A"
        if $main::data{'cloudFontColor'};
    $css .= "}\x0A";

    for ( my $r = $main::data{'rank'} - 1; $r >= 0; $r-- ) {
        $css
            .= 'ul#searchword-cloud li.searchword-rank-'
            . $rank[ ( $main::data{'rank'} - $r - 1 ) ]
            . " {\x0A";
        $css .= '  font-size: '
            . (
            (   ($r)
                ? int(
                    ( $main::data{'maxsize'} - $main::data{'minsize'} )
                    * $r * 100
                        / ( $main::data{'rank'} - 1 ) + 0.5
                    ) / 100
                : 0
            ) + $main::data{'minsize'}
            ) . "em;\x0A";
        $css .= "}\x0A";
    }
    return $css;
}

######################################################################
# クラス登録
#sub import {
BEGIN {
    #クラス登録
    Common::class_register( '0000', 'GeneralSetting' );

    #ツール登録
    $setting::jump_menu{'0000'} = '一般設定';
}

1;
