package TagSample;
require CMONOS::CGI_Lib::SetUp;
@ISA = qw(SetUp);
use strict;
use utf8;
######################################################################
# 関連ファイル一覧・タグ見本モジュール
# TagSample.pm ver1.0.2
# Copyright (C) 1999-2018 CMONOS Co. Ltd.
#
# support@cmonos.jp
# http://cmonos.jp/
# 最終更新日：2008-08-24
######################################################################
# 実行
sub run ($) {
    my $this = shift;

    #ページヘッダ
    $this->jump_menu('tools');
    $this->print_page_header('tools');

    print '<h1>タグ見本</h1>';

    print '<form action="#">';

    print '<fieldset><legend>検索フォームの例</legend>';
    print '<textarea rows="8" cols="80" onfocus="this.select()">';
    my $ysearch_tip_js
        = $this->path_change( $env::externalfiles . '/ysearch-tip.js',
        $ENV{'SCRIPT_NAME'}, 'abs' );
    my $form = <<FORM;
<form action="$cgi::path" id="ysearch-form">
<input type="hidden" name="_" value="＿" />
<input type="text" size="16" name="query" />
<script type="text/javascript" language="JavaScript" src="$ysearch_tip_js"></script>
<input type="submit" value="検索" />
</form>
FORM
    print $this->escape($form);
    print '</textarea>';
    print '</fieldset>';

    if ( defined $setting::general{'rank'} ) {
        print '<fieldset><legend>CSS サンプル</legend>';
        print '<textarea rows="8" cols="80" onfocus="this.select()">';
        print $this->escape(
            $this->read_file( "$env::css/ysearch-cloud.css", 1 ) );
        print '</textarea>';
        print '</fieldset>';
    }

    #取り込みタグサンプル
    print '<fieldset><legend>検索ワードクラウド</legend>';
    print
        '<fieldset class="sample"><legend>埋め込みタグ(JavaScript)</legend>';
    print
        '<textarea cols="80" rows="3">&lt;script type=&quot;text/javascript&quot; language=&quot;JavaScript&quot; src=&quot;'
        . $this->full_path( $env::externalfiles . '/ysearch-cloud.js' )
        . '&quot;&gt;&lt;/script&gt;</textarea>';
    print '</fieldset>';
    if ( defined $env::ssi && $env::ssi ) {
        print
            '<fieldset class="sample"><legend>埋め込みタグ(SSI)</legend>';
        print '<textarea cols="80" rows="3">&lt;!--#include virtual=&quot;'
            . $this->path_change( $env::externalfiles . '/ysearch-cloud.ssi',
            $ENV{'SCRIPT_NAME'}, 'abs' )
            . '&quot;--&gt;</textarea>';
        print '</fieldset>';
    }
    print '</fieldset>';

    print '<fieldset><legend>新着検索ワードクラウド</legend>';
    print
        '<fieldset class="sample"><legend>埋め込みタグ(JavaScript)</legend>';
    print
        '<textarea cols="80" rows="3">&lt;script type=&quot;text/javascript&quot; language=&quot;JavaScript&quot; src=&quot;'
        . $this->full_path( $env::externalfiles . '/ysearch-tip.js' )
        . '&quot;&gt;&lt;/script&gt;</textarea>';
    print '</fieldset>';
    if ( defined $env::ssi && $env::ssi ) {
        print
            '<fieldset class="sample"><legend>埋め込みタグ(SSI)</legend>';
        print '<textarea cols="80" rows="3">&lt;!--#include virtual=&quot;'
            . $this->path_change( $env::externalfiles . '/ysearch-tip.ssi',
            $ENV{'SCRIPT_NAME'}, 'abs' )
            . '&quot;--&gt;</textarea>';
        print '</fieldset>';
    }
    print '</fieldset>';
    print '</form>';

    #ページフッタ
    $this->print_page_footer('tools');
}

######################################################################
# クラス登録
#sub import {
BEGIN {
    no warnings qw(once);

    #クラス登録
    Common::class_register( 's210', 'TagSample' );

    #メニュー登録
    $setting::jump_menu{'s210'} = 'タグ見本';

}

1;
